/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../config ../lib/oop ../keyboard/hash_handler ./occur_commands".split(" "),function(d,e){function f(a){this.$iSearch=a}var i=d("../config"),g=d("../lib/oop"),h=d("../keyboard/hash_handler").HashHandler,j=d("./occur_commands").occurStartCommand;e.iSearchStartCommands=[{name:"iSearch",bindKey:{win:"Ctrl-F",mac:"Command-F"},exec:function(a,b){i.loadModule(["core","ace/incremental_search"],function(c){c=c.iSearch=c.iSearch||new c.IncrementalSearch;c.activate(a,b.backwards);
b.jumpToFirstMatch&&c.next(b)})},readOnly:!0},{name:"iSearchBackwards",exec:function(a){a.execCommand("iSearch",{backwards:!0})},readOnly:!0},{name:"iSearchAndGo",bindKey:{win:"Ctrl-K",mac:"Command-G"},exec:function(a){a.execCommand("iSearch",{jumpToFirstMatch:!0,useCurrentOrPrevSearch:!0})},readOnly:!0},{name:"iSearchBackwardsAndGo",bindKey:{win:"Ctrl-Shift-K",mac:"Command-Shift-G"},exec:function(a){a.execCommand("iSearch",{jumpToFirstMatch:!0,backwards:!0,useCurrentOrPrevSearch:!0})},readOnly:!0}];
e.iSearchCommands=[{name:"restartSearch",bindKey:{win:"Ctrl-F",mac:"Command-F"},exec:function(a){a.cancelSearch(!0)},readOnly:!0,isIncrementalSearchCommand:!0},{name:"searchForward",bindKey:{win:"Ctrl-S|Ctrl-K",mac:"Ctrl-S|Command-G"},exec:function(a,b){b.useCurrentOrPrevSearch=!0;a.next(b)},readOnly:!0,isIncrementalSearchCommand:!0},{name:"searchBackward",bindKey:{win:"Ctrl-R|Ctrl-Shift-K",mac:"Ctrl-R|Command-Shift-G"},exec:function(a,b){b.useCurrentOrPrevSearch=!0;b.backwards=!0;a.next(b)},readOnly:!0,
isIncrementalSearchCommand:!0},{name:"extendSearchTerm",exec:function(a,b){a.addString(b)},readOnly:!0,isIncrementalSearchCommand:!0},{name:"extendSearchTermSpace",bindKey:"space",exec:function(a){a.addString(" ")},readOnly:!0,isIncrementalSearchCommand:!0},{name:"shrinkSearchTerm",bindKey:"backspace",exec:function(a){a.removeChar()},readOnly:!0,isIncrementalSearchCommand:!0},{name:"confirmSearch",bindKey:"return",exec:function(a){a.deactivate()},readOnly:!0,isIncrementalSearchCommand:!0},{name:"cancelSearch",
bindKey:"esc|Ctrl-G",exec:function(a){a.deactivate(!0)},readOnly:!0,isIncrementalSearchCommand:!0},{name:"occurisearch",bindKey:"Ctrl-O",exec:function(a){var b=g.mixin({},a.$options);a.deactivate();j.exec(a.$editor,b)},readOnly:!0,isIncrementalSearchCommand:!0},{name:"yankNextWord",bindKey:"Ctrl-w",exec:function(a){var b=a.$editor,c=b.selection.getRangeOfMovements(function(a){a.moveCursorWordRight()}),b=b.session.getTextRange(c);a.addString(b)},readOnly:!0,isIncrementalSearchCommand:!0},{name:"yankNextChar",
bindKey:"Ctrl-Alt-y",exec:function(a){var b=a.$editor,c=b.selection.getRangeOfMovements(function(a){a.moveCursorRight()}),b=b.session.getTextRange(c);a.addString(b)},readOnly:!0,isIncrementalSearchCommand:!0},{name:"recenterTopBottom",bindKey:"Ctrl-l",exec:function(a){a.$editor.execCommand("recenterTopBottom")},readOnly:!0,isIncrementalSearchCommand:!0},{name:"selectAllMatches",bindKey:"Ctrl-space",exec:function(a){var b=a.$editor,c=b.session.$isearchHighlight,c=c&&c.cache?c.cache.reduce(function(a,
b){return a.concat(b?b:[])},[]):[];a.deactivate(!1);c.forEach(b.selection.addRange.bind(b.selection))},readOnly:!0,isIncrementalSearchCommand:!0},{name:"searchAsRegExp",bindKey:"Alt-r",exec:function(a){a.convertNeedleToRegExp()},readOnly:!0,isIncrementalSearchCommand:!0}];g.inherits(f,h);(function(){this.attach=function(a){var c=this.$iSearch;h.call(this,e.iSearchCommands,a.commands.platform);this.$commandExecHandler=a.commands.addEventListener("exec",function(a){if(a.command.isIncrementalSearchCommand)return a.stopPropagation(),
a.preventDefault(),a.command.exec(c,a.args||{})})};this.detach=function(a){this.$commandExecHandler&&(a.commands.removeEventListener("exec",this.$commandExecHandler),delete this.$commandExecHandler)};var a=this.handleKeyboard;this.handleKeyboard=function(b,c,d,e){if((1===c||8===c)&&"v"===d||1===c&&"y"===d)return null;b=a.call(this,b,c,d,e);return b.command?b:-1==c&&(b=this.commands.extendSearchTerm)?{command:b,args:d}:{command:"null",passEvent:0==c||4==c}}}).call(f.prototype);e.IncrementalSearchKeyboardHandler=
f});