/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./lib/oop ./lib/event_emitter ./range ./anchor".split(" "),function(g,i){var j=g("./lib/oop"),k=g("./lib/event_emitter").EventEmitter,e=g("./range").Range,l=g("./anchor").Anchor,h=function(a){this.$lines=[];0===a.length?this.$lines=[""]:Array.isArray(a)?this._insertLines(0,a):this.insert({row:0,column:0},a)};(function(){j.implement(this,k);this.setValue=function(a){var b=this.getLength();this.remove(new e(0,0,b,this.getLine(b-1).length));this.insert({row:0,column:0},
a)};this.getValue=function(){return this.getAllLines().join(this.getNewLineCharacter())};this.createAnchor=function(a,b){return new l(this,a,b)};this.$split=0==="aaa".split(/a/).length?function(a){return a.replace(/\r\n|\r/g,"\n").split("\n")}:function(a){return a.split(/\r\n|\r|\n/)};this.$detectNewLine=function(a){this.$autoNewLine=(a=a.match(/^.*?(\r\n|\r|\n)/m))?a[1]:"\n";this._signal("changeNewLineMode")};this.getNewLineCharacter=function(){switch(this.$newLineMode){case "windows":return"\r\n";
case "unix":return"\n";default:return this.$autoNewLine||"\n"}};this.$autoNewLine="";this.$newLineMode="auto";this.setNewLineMode=function(a){this.$newLineMode!==a&&(this.$newLineMode=a,this._signal("changeNewLineMode"))};this.getNewLineMode=function(){return this.$newLineMode};this.isNewLine=function(a){return"\r\n"==a||"\r"==a||"\n"==a};this.getLine=function(a){return this.$lines[a]||""};this.getLines=function(a,b){return this.$lines.slice(a,b+1)};this.getAllLines=function(){return this.getLines(0,
this.getLength())};this.getLength=function(){return this.$lines.length};this.getTextRange=function(a){if(a.start.row==a.end.row)return this.getLine(a.start.row).substring(a.start.column,a.end.column);var b=this.getLines(a.start.row,a.end.row);b[0]=(b[0]||"").substring(a.start.column);var c=b.length-1;a.end.row-a.start.row==c&&(b[c]=b[c].substring(0,a.end.column));return b.join(this.getNewLineCharacter())};this.$clipPosition=function(a){var b=this.getLength();a.row>=b?(a.row=Math.max(0,b-1),a.column=
this.getLine(b-1).length):0>a.row&&(a.row=0);return a};this.insert=function(a,b){if(!b||0===b.length)return a;a=this.$clipPosition(a);1>=this.getLength()&&this.$detectNewLine(b);var c=this.$split(b),d=c.splice(0,1)[0],f=0==c.length?null:c.splice(c.length-1,1)[0],a=this.insertInLine(a,d);null!==f&&(a=this.insertNewLine(a),a=this._insertLines(a.row,c),a=this.insertInLine(a,f||""));return a};this.insertLines=function(a,b){return a>=this.getLength()?this.insert({row:a,column:0},"\n"+b.join("\n")):this._insertLines(Math.max(a,
0),b)};this._insertLines=function(a,b){if(0==b.length)return{row:a,column:0};for(;61440<b.length;)var c=this._insertLines(a,b.slice(0,61440)),b=b.slice(61440),a=c.row;c=[a,0];c.push.apply(c,b);this.$lines.splice.apply(this.$lines,c);c=new e(a,0,a+b.length,0);this._signal("change",{data:{action:"insertLines",range:c,lines:b}});return c.end};this.insertNewLine=function(a){var a=this.$clipPosition(a),b=this.$lines[a.row]||"";this.$lines[a.row]=b.substring(0,a.column);this.$lines.splice(a.row+1,0,b.substring(a.column,
b.length));b={row:a.row+1,column:0};a={action:"insertText",range:e.fromPoints(a,b),text:this.getNewLineCharacter()};this._signal("change",{data:a});return b};this.insertInLine=function(a,b){if(0==b.length)return a;var c=this.$lines[a.row]||"";this.$lines[a.row]=c.substring(0,a.column)+b+c.substring(a.column);var c={row:a.row,column:a.column+b.length},d={action:"insertText",range:e.fromPoints(a,c),text:b};this._signal("change",{data:d});return c};this.remove=function(a){a instanceof e||(a=e.fromPoints(a.start,
a.end));a.start=this.$clipPosition(a.start);a.end=this.$clipPosition(a.end);if(a.isEmpty())return a.start;var b=a.start.row,c=a.end.row;if(a.isMultiLine()){var d=0==a.start.column?b:b+1,f=c-1;0<a.end.column&&this.removeInLine(c,0,a.end.column);f>=d&&this._removeLines(d,f);d!=b&&(this.removeInLine(b,a.start.column,this.getLine(b).length),this.removeNewLine(a.start.row))}else this.removeInLine(b,a.start.column,a.end.column);return a.start};this.removeInLine=function(a,b,c){if(b!=c){var d=new e(a,b,
a,c),f=this.getLine(a),m=f.substring(b,c),b=f.substring(0,b)+f.substring(c,f.length);this.$lines.splice(a,1,b);this._signal("change",{data:{action:"removeText",range:d,text:m}});return d.start}};this.removeLines=function(a,b){return 0>a||b>=this.getLength()?this.remove(new e(a,0,b+1,0)):this._removeLines(a,b)};this._removeLines=function(a,b){var c=new e(a,0,b+1,0),d=this.$lines.splice(a,b-a+1),c={action:"removeLines",range:c,nl:this.getNewLineCharacter(),lines:d};this._signal("change",{data:c});return d};
this.removeNewLine=function(a){var b=this.getLine(a),c=this.getLine(a+1),d=new e(a,b.length,a+1,0);this.$lines.splice(a,2,b+c);a={action:"removeText",range:d,text:this.getNewLineCharacter()};this._signal("change",{data:a})};this.replace=function(a,b){a instanceof e||(a=e.fromPoints(a.start,a.end));if(0==b.length&&a.isEmpty())return a.start;if(b==this.getTextRange(a))return a.end;this.remove(a);return b?this.insert(a.start,b):a.start};this.applyDeltas=function(a){for(var b=0;b<a.length;b++){var c=
a[b],d=e.fromPoints(c.range.start,c.range.end);"insertLines"==c.action?this.insertLines(d.start.row,c.lines):"insertText"==c.action?this.insert(d.start,c.text):"removeLines"==c.action?this._removeLines(d.start.row,d.end.row-1):"removeText"==c.action&&this.remove(d)}};this.revertDeltas=function(a){for(var b=a.length-1;0<=b;b--){var c=a[b],d=e.fromPoints(c.range.start,c.range.end);"insertLines"==c.action?this._removeLines(d.start.row,d.end.row-1):"insertText"==c.action?this.remove(d):"removeLines"==
c.action?this._insertLines(d.start.row,c.lines):"removeText"==c.action&&this.insert(d.start,c.text)}};this.indexToPosition=function(a,b){for(var c=this.$lines||this.getAllLines(),d=this.getNewLineCharacter().length,f=b||0,e=c.length;f<e;f++)if(a-=c[f].length+d,0>a)return{row:f,column:a+c[f].length+d};return{row:e-1,column:c[e-1].length}};this.positionToIndex=function(a,b){for(var c=this.$lines||this.getAllLines(),d=this.getNewLineCharacter().length,f=0,e=Math.min(a.row,c.length),g=b||0;g<e;++g)f+=
c[g].length+d;return f+a.column}}).call(h.prototype);i.Document=h});