/**
 * Copyright (c) 2009-2013 Jeremy Ashkenas
 * 
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 * 
 */

define(["require","exports","module","./rewriter","./helpers"],function(E,t){var F,u,G,v,w,q,H,I,J,K,L,M,x,y,N,O,P,Q,z,r,R,S,T,U,V,W,A,X,Y,Z,B,$,s,aa,ba,ca,n,da,C,D,ea,fa,k,ga,ha,l,i=[].indexOf||function(a){for(var b=0,c=this.length;b<c;b++)if(b in this&&this[b]===a)return b;return-1};l=E("./rewriter");aa=l.Rewriter;P=l.INVERSES;l=E("./helpers");ea=l.count;k=l.last;ga=l.repeat;fa=l.invertLiterate;ha=l.throwSyntaxError;var e=function(){};e.prototype.tokenize=function(a,b){var c,d,h,f;null==b&&(b={});
this.literate=b.literate;this.outdebt=this.indebt=this.baseIndent=this.indent=0;this.indents=[];this.ends=[];this.tokens=[];this.chunkLine=b.line||0;this.chunkColumn=b.column||0;a=this.clean(a);for(d=0;this.chunk=a.slice(d);)c=this.identifierToken()||this.commentToken()||this.whitespaceToken()||this.lineToken()||this.heredocToken()||this.stringToken()||this.numberToken()||this.regexToken()||this.jsToken()||this.literalToken(),f=this.getLineAndColumnFromChunk(c),this.chunkLine=f[0],this.chunkColumn=
f[1],d+=c;this.closeIndentation();(h=this.ends.pop())&&this.error("missing "+h);return!1===b.rewrite?this.tokens:(new aa).rewrite(this.tokens)};e.prototype.clean=function(a){a.charCodeAt(0)===F&&(a=a.slice(1));a=a.replace(/\r/g,"").replace(da,"");D.test(a)&&(a="\n"+a,this.chunkLine--);this.literate&&(a=fa(a));return a};e.prototype.identifierToken=function(){var a,b,c,d,h,f,e,g,o,j;if(!(a=N.exec(this.chunk)))return 0;f=a[0];d=a[1];a=a[2];h=d.length;b=void 0;if("own"===d&&"FOR"===this.tag())return this.token("OWN",
d),d.length;c=a||(e=k(this.tokens))&&("."===(o=e[0])||("?."===o||"::"===o||"?::"===o)||!e.spaced&&"@"===e[0]);g="IDENTIFIER";if(!c&&(0<=i.call(r,d)||0<=i.call(q,d)))g=d.toUpperCase(),"WHEN"===g&&(j=this.tag(),0<=i.call(R,j))?g="LEADING_WHEN":"FOR"===g?this.seenFor=!0:"UNLESS"===g?g="IF":0<=i.call(C,g)?g="UNARY":0<=i.call($,g)&&("INSTANCEOF"!==g&&this.seenFor?(g="FOR"+g,this.seenFor=!1):(g="RELATION","!"===this.value()&&(b=this.tokens.pop(),d="!"+d)));0<=i.call(z,d)&&(c?(g="IDENTIFIER",d=new String(d),
d.reserved=!0):0<=i.call(s,d)&&this.error('reserved word "'+d+'"'));c||(0<=i.call(v,d)&&(d=w[d]),g=function(){switch(d){case "!":return"UNARY";case "==":case "!=":return"COMPARE";case "&&":case "||":return"LOGIC";case "true":case "false":return"BOOL";case "break":case "continue":return"STATEMENT";default:return g}}());e=this.token(g,d,0,h);b&&(b=[b[2].first_line,b[2].first_column],e[2].first_line=b[0],e[2].first_column=b[1]);a&&(b=f.lastIndexOf(":"),this.token(":",":",b,a.length));return f.length};
e.prototype.numberToken=function(){var a,b,c;if(!(b=Y.exec(this.chunk)))return 0;c=b[0];/^0[BOX]/.test(c)?this.error("radix prefix '"+c+"' must be lowercase"):/E/.test(c)&&!/^0x/.test(c)?this.error("exponential notation '"+c+"' must be indicated with a lowercase 'e'"):/^0\d*[89]/.test(c)?this.error("decimal literal '"+c+"' must not be prefixed with '0'"):/^0\d+/.test(c)&&this.error("octal literal '"+c+"' must be prefixed with '0o'");b=c.length;if(a=/^0o([0-7]+)/.exec(c))c="0x"+parseInt(a[1],8).toString(16);
if(a=/^0b([01]+)/.exec(c))c="0x"+parseInt(a[1],2).toString(16);this.token("NUMBER",c,0,b);return b};e.prototype.stringToken=function(){var a,b,c;switch(a=this.chunk.charAt(0)){case "'":b=ca.exec(this.chunk)[0];break;case '"':b=this.balancedString(this.chunk,'"')}if(!b)return 0;c=this.removeNewlines(b.slice(1,-1));'"'===a&&0<b.indexOf("#{",1)?this.interpolateString(c,{strOffset:1,lexedLength:b.length}):this.token("STRING",a+this.escapeLines(c)+a,0,b.length);/^(?:\\.|[^\\])*\\(?:0[0-7]|[1-7])/.test(b)&&
this.error("octal escape sequences "+b+" are not allowed");return b.length};e.prototype.heredocToken=function(){var a,b,c;if(!(a=K.exec(this.chunk)))return 0;b=a[0];c=b.charAt(0);a=this.sanitizeHeredoc(a[2],{quote:c,indent:null});'"'===c&&0<=a.indexOf("#{")?this.interpolateString(a,{heredoc:!0,strOffset:3,lexedLength:b.length}):this.token("STRING",this.makeString(a,c,!0),0,b.length);return b.length};e.prototype.commentToken=function(){var a,b;if(!(b=this.chunk.match(H)))return 0;a=b[0];(b=b[1])&&
this.token("HERECOMMENT",this.sanitizeHeredoc(b,{herecomment:!0,indent:ga(" ",this.indent)}),0,a.length);return a.length};e.prototype.jsToken=function(){var a,b;if(!("`"===this.chunk.charAt(0)&&(a=Q.exec(this.chunk))))return 0;this.token("JS",(b=a[0]).slice(1,-1),0,b.length);return b.length};e.prototype.regexToken=function(){var a,b,c;if("/"!==this.chunk.charAt(0))return 0;if(b=x.exec(this.chunk))return b=this.heregexToken(b);if((c=k(this.tokens))&&(a=c[0],0<=i.call(c.spaced?A:X,a))||!(b=B.exec(this.chunk)))return 0;
a=b;b=a[0];c=a[1];a=a[2];"/*"===c.slice(0,2)&&this.error("regular expressions cannot begin with `*`");"//"===c&&(c="/(?:)/");this.token("REGEX",""+c+a,0,b.length);return b.length};e.prototype.heregexToken=function(a){var b,c,d,h,f,e,g,o,j,i;d=a[0];b=a[1];a=a[2];if(0>b.indexOf("#{"))return c=this.escapeLines(b.replace(y,"$1$2").replace(/\//g,"\\/"),!0),c.match(/^\*/)&&this.error("regular expressions cannot begin with `*`"),this.token("REGEX","/"+(c||"(?:)")+"/"+a,0,d.length),d.length;this.token("IDENTIFIER",
"RegExp",0,0);this.token("CALL_START","(",0,0);e=[];j=this.interpolateString(b,{regex:!0});b=0;for(o=j.length;b<o;b++){f=j[b];h=f[0];g=f[1];if("TOKENS"===h)e.push.apply(e,g);else if("NEOSTRING"===h){if(!(g=g.replace(y,"$1$2")))continue;g=g.replace(/\\/g,"\\\\");f[0]="STRING";f[1]=this.makeString(g,'"',!0);e.push(f)}else this.error("Unexpected "+h);f=k(this.tokens);h=["+","+"];h[2]=f[2];e.push(h)}e.pop();if("STRING"!==(null!=(c=e[0])?c[0]:void 0))this.token("STRING",'""',0,0),this.token("+","+",0,
0);(i=this.tokens).push.apply(i,e);a&&(c=d.lastIndexOf(a),this.token(",",",",c,0),this.token("STRING",'"'+a+'"',c,a.length));this.token(")",")",d.length-1,0);return d.length};e.prototype.lineToken=function(){var a,b,c;if(!(b=W.exec(this.chunk)))return 0;b=b[0];this.seenFor=!1;c=b.length-1-b.lastIndexOf("\n");a=this.unfinished();if(c-this.indebt===this.indent)return a?this.suppressNewlines():this.newlineToken(0),b.length;if(c>this.indent){if(a)return this.indebt=c-this.indent,this.suppressNewlines(),
b.length;if(!this.tokens.length)return this.baseIndent=this.indent=c,b.length;a=c-this.indent+this.outdebt;this.token("INDENT",a,b.length-c,c);this.indents.push(a);this.ends.push("OUTDENT");this.outdebt=this.indebt=0}else c<this.baseIndent?this.error("missing indentation",b.length):(this.indebt=0,this.outdentToken(this.indent-c,a,b.length));this.indent=c;return b.length};e.prototype.outdentToken=function(a,b,c){for(var d,h;0<a;)h=this.indents.length-1,void 0===this.indents[h]?a=0:this.indents[h]===
this.outdebt?(a-=this.outdebt,this.outdebt=0):this.indents[h]<this.outdebt?(this.outdebt-=this.indents[h],a-=this.indents[h]):(d=this.indents.pop()+this.outdebt,a-=d,this.outdebt=0,this.pair("OUTDENT"),this.token("OUTDENT",d,0,c));d&&(this.outdebt-=a);for(;";"===this.value();)this.tokens.pop();"TERMINATOR"===this.tag()||b||this.token("TERMINATOR","\n",c,0);return this};e.prototype.whitespaceToken=function(){var a,b;if(!((a=D.exec(this.chunk))||"\n"===this.chunk.charAt(0)))return 0;(b=k(this.tokens))&&
(b[a?"spaced":"newLine"]=!0);return a?a[0].length:0};e.prototype.newlineToken=function(a){for(;";"===this.value();)this.tokens.pop();"TERMINATOR"!==this.tag()&&this.token("TERMINATOR","\n",a,0);return this};e.prototype.suppressNewlines=function(){"\\"===this.value()&&this.tokens.pop();return this};e.prototype.literalToken=function(){var a,b,c,d,h,f,e;(a=Z.exec(this.chunk))?(c=a[0],G.test(c)&&this.tagParameters()):c=this.chunk.charAt(0);b=c;a=k(this.tokens);if("="===c&&a&&(!a[1].reserved&&(d=a[1],
0<=i.call(z,d))&&this.error('reserved word "'+this.value()+"\" can't be assigned"),"||"===(h=a[1])||"&&"===h))return a[0]="COMPOUND_ASSIGN",a[1]+="=",c.length;if(";"===c)this.seenFor=!1,b="TERMINATOR";else if(0<=i.call(U,c))b="MATH";else if(0<=i.call(I,c))b="COMPARE";else if(0<=i.call(J,c))b="COMPOUND_ASSIGN";else if(0<=i.call(C,c))b="UNARY";else if(0<=i.call(ba,c))b="SHIFT";else if(0<=i.call(T,c)||"?"===c&&null!=a&&a.spaced)b="LOGIC";else if(a&&!a.spaced)if("("===c&&(f=a[0],0<=i.call(u,f)))"?"===
a[0]&&(a[0]="FUNC_EXIST"),b="CALL_START";else if("["===c&&(e=a[0],0<=i.call(O,e)))switch(b="INDEX_START",a[0]){case "?":a[0]="INDEX_SOAK"}switch(c){case "(":case "{":case "[":this.ends.push(P[c]);break;case ")":case "}":case "]":this.pair(c)}this.token(b,c);return c.length};e.prototype.sanitizeHeredoc=function(a,b){var c,d,h,f;h=b.indent;if(d=b.herecomment){if(L.test(a)&&this.error('block comment cannot contain "*/", starting'),0>a.indexOf("\n"))return a}else for(;c=M.exec(a);)if(c=c[1],null===h||
0<(f=c.length)&&f<h.length)h=c;h&&(a=a.replace(RegExp("\\n"+h,"g"),"\n"));d||(a=a.replace(/^\n/,""));return a};e.prototype.tagParameters=function(){var a,b,c,d;if(")"!==this.tag())return this;b=[];d=this.tokens;a=d.length;for(d[--a][0]="PARAM_END";c=d[--a];)switch(c[0]){case ")":b.push(c);break;case "(":case "CALL_START":if(b.length)b.pop();else return"("===c[0]&&(c[0]="PARAM_START"),this}return this};e.prototype.closeIndentation=function(){return this.outdentToken(this.indent)};e.prototype.balancedString=
function(a,b){var c,d,h,f,e,g,i,j;c=0;g=[b];d=i=1;for(j=a.length;1<=j?i<j:i>j;d=1<=j?++i:--i)if(c)--c;else{switch(h=a.charAt(d)){case "\\":++c;continue;case b:g.pop();if(!g.length)return a.slice(0,+d+1||9E9);b=g[g.length-1];continue}"}"===b&&('"'===h||"'"===h)?g.push(b=h):"}"===b&&"/"===h&&(f=x.exec(a.slice(d))||B.exec(a.slice(d)))?c+=f[0].length-1:"}"===b&&"{"===h?g.push(b="}"):'"'===b&&("#"===e&&"{"===h)&&g.push(b="}");e=h}return this.error("missing "+g.pop()+", starting")};e.prototype.interpolateString=
function(a,b){var c,d,h,f,i,g,o,j,l,k,m,p,n,q;null==b&&(b={});h=b.heredoc;k=b.regex;j=b.offsetInChunk;m=b.strOffset;o=b.lexedLength;j=j||0;m=m||0;o=o||a.length;p=[];g=0;for(f=-1;i=a.charAt(f+=1);)if("\\"===i)f+=1;else if("#"===i&&"{"===a.charAt(f+1)&&(d=this.balancedString(a.slice(f+1),"}"))){g<f&&p.push(this.makeToken("NEOSTRING",a.slice(g,f),m+g));i=d.slice(1,-1);if(i.length&&(c=this.getLineAndColumnFromChunk(m+f+1),g=c[0],c=c[1],c=(new e).tokenize(i,{line:g,column:c,rewrite:!1}),c.pop(),"TERMINATOR"===
(null!=(n=c[0])?n[0]:void 0)&&c.shift(),g=c.length))1<g&&(c.unshift(this.makeToken("(","(",m+f+1,0)),c.push(this.makeToken(")",")",m+f+1+i.length,0))),p.push(["TOKENS",c]);f+=d.length;g=f+1}f>g&&g<a.length&&p.push(this.makeToken("NEOSTRING",a.slice(g),m+g));if(k)return p;if(!p.length)return this.token("STRING",'""',j,o);"NEOSTRING"!==p[0][0]&&p.unshift(this.makeToken("NEOSTRING","",j));(d=1<p.length)&&this.token("(","(",j,0);f=i=0;for(g=p.length;i<g;f=++i)m=p[f],k=m[0],n=m[1],f&&(f&&(l=this.token("+",
"+")),f="TOKENS"===k?n[0]:m,l[2]={first_line:f[2].first_line,first_column:f[2].first_column,last_line:f[2].first_line,last_column:f[2].first_column}),"TOKENS"===k?(q=this.tokens).push.apply(q,n):"NEOSTRING"===k?(m[0]="STRING",m[1]=this.makeString(n,'"',h),this.tokens.push(m)):this.error("Unexpected "+k);d&&(h=this.makeToken(")",")",j+o,0),h.stringEnd=!0,this.tokens.push(h));return p};e.prototype.pair=function(a){var b;return a!==(b=k(this.ends))?("OUTDENT"!==b&&this.error("unmatched "+a),this.indent-=
b=k(this.indents),this.outdentToken(b,!0),this.pair(a)):this.ends.pop()};e.prototype.getLineAndColumnFromChunk=function(a){var b,c;if(0===a)return[this.chunkLine,this.chunkColumn];c=a>=this.chunk.length?this.chunk:this.chunk.slice(0,+(a-1)+1||9E9);a=ea(c,"\n");b=this.chunkColumn;0<a?(b=c.split("\n"),b=k(b).length):b+=c.length;return[this.chunkLine+a,b]};e.prototype.makeToken=function(a,b,c,d){var e,f;null==c&&(c=0);null==d&&(d=b.length);e={};f=this.getLineAndColumnFromChunk(c);e.first_line=f[0];e.first_column=
f[1];d=Math.max(0,d-1);c=this.getLineAndColumnFromChunk(c+d);e.last_line=c[0];e.last_column=c[1];return[a,b,e]};e.prototype.token=function(a,b,c,d){a=this.makeToken(a,b,c,d);this.tokens.push(a);return a};e.prototype.tag=function(a,b){var c;return(c=k(this.tokens,a))&&(b?c[0]=b:c[0])};e.prototype.value=function(a,b){var c;return(c=k(this.tokens,a))&&(b?c[1]=b:c[1])};e.prototype.unfinished=function(){var a;return S.test(this.chunk)||"\\"===(a=this.tag())||"."===a||"?."===a||"?::"===a||"UNARY"===a||
"MATH"===a||"+"===a||"-"===a||"SHIFT"===a||"RELATION"===a||"COMPARE"===a||"LOGIC"===a||"THROW"===a||"EXTENDS"===a};e.prototype.removeNewlines=function(a){return a.replace(/^\s*\n\s*/,"").replace(/([^\\]|\\\\)\s*\n\s*$/,"$1")};e.prototype.escapeLines=function(a,b){a=a.replace(/\\[^\S\n]*(\n|\\)\s*/g,function(a,b){return"\n"===b?"":a});return b?a.replace(V,"\\n"):a.replace(/\s*\n\s*/g," ")};e.prototype.makeString=function(a,b,c){if(!a)return b+b;a=a.replace(RegExp("\\\\("+b+"|\\\\)","g"),function(a,
c){return c===b?c:a});a=a.replace(RegExp(""+b,"g"),"\\$&");return b+this.escapeLines(a,c)+b};e.prototype.error=function(a,b){var c;null==b&&(b=0);c=this.getLineAndColumnFromChunk(b);return ha(a,{first_line:c[0],first_column:c[1]})};t.Lexer=e;r="true false null this new delete typeof in instanceof return throw break continue debugger if else switch for while do try catch finally class extends super".split(" ");q="undefined then unless until loop of by when".split(" ");w={and:"&&",or:"||",is:"==",isnt:"!=",
not:"!",yes:"true",no:"false",on:"true",off:"false"};l=[];for(n in w)l.push(n);v=l;q=q.concat(v);s="case default function var void with const let enum export import native __hasProp __extends __slice __bind __indexOf implements interface package private protected public static yield".split(" ");n=["arguments","eval"];z=r.concat(s).concat(n);t.RESERVED=s.concat(r).concat(q).concat(n);t.STRICT_PROSCRIBED=n;F=65279;N=/^([$A-Za-z_\x7f-\uffff][$\w\x7f-\uffff]*)([^\n\S]*:(?!:))?/;Y=/^0b[01]+|^0o[0-7]+|^0x[\da-f]+|^\d*\.?\d+(?:e[+-]?\d+)?/i;
K=/^("""|''')((?:\\[\s\S]|[^\\])*?)(?:\n[^\n\S]*)?\1/;Z=/^(?:[-=]>|[-+*\/%<>&|^!?=]=|>>>=?|([-+:])\1|([&|<>])\2=?|\?(\.|::)|\.{2,3})/;D=/^[^\n\S]+/;H=/^###([^#][\s\S]*?)(?:###[^\n\S]*|###$)|^(?:\s*#(?!##[^#]).*)+/;G=/^[-=]>/;W=/^(?:\n[^\n\S]*)+/;ca=/^'[^\\']*(?:\\[\s\S][^\\']*)*'/;Q=/^`[^\\`]*(?:\\.[^\\`]*)*`/;B=/^(\/(?![\s=])[^[\/\n\\]*(?:(?:\\[\s\S]|\[[^\]\n\\]*(?:\\[\s\S][^\]\n\\]*)*])[^[\/\n\\]*)*\/)([imgy]{0,4})(?!\w)/;x=/^\/{3}((?:\\?[\s\S])+?)\/{3}([imgy]{0,4})(?!\w)/;y=/((?:\\\\)+)|\\(\s|\/)|\s+(?:#.*)?/g;
V=/\n/g;M=/\n+([^\n\S]*)/g;L=/\*\//;S=/^\s*(?:,|\??\.(?![.\d])|::)/;da=/\s+$/;J="-= += /= *= %= ||= &&= ?= <<= >>= >>>= &= ^= |=".split(" ");C="! ~ NEW TYPEOF DELETE DO".split(" ");T=["&&","||","&","|","^"];ba=["<<",">>",">>>"];I="== != < > <= >=".split(" ");U=["*","/","%"];$=["IN","OF","INSTANCEOF"];A="NUMBER REGEX BOOL NULL UNDEFINED ++ --".split(" ");X=A.concat(")","}","THIS","IDENTIFIER","STRING","]");u="IDENTIFIER STRING REGEX ) ] } ? :: @ THIS SUPER".split(" ");O=u.concat("NUMBER","BOOL","NULL",
"UNDEFINED");R=["INDENT","OUTDENT","TERMINATOR"]});