/**
 * Copyright (c) 2009-2013 Jeremy Ashkenas
 * 
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 * 
 */

define(["require","exports","module"],function(M,G){var g,C,t,x,y,H,I,D,J,z,B,K,A,u,E,l,v,L,h=[].indexOf||function(b){for(var c=0,a=this.length;c<a;c++)if(c in this&&this[c]===b)return c;return-1},F=[].slice;u=function(b,c){var a;a=[b,c];a.generated=!0;return a};g=function(){};g.prototype.rewrite=function(b){this.tokens=b;this.removeLeadingNewlines();this.closeOpenCalls();this.closeOpenIndexes();this.normalizeLines();this.tagPostfixConditionals();this.addImplicitBracesAndParens();this.addLocationDataToGeneratedTokens();
return this.tokens};g.prototype.scanTokens=function(b){var c,a,d;d=this.tokens;for(c=0;a=d[c];)c+=b.call(this,a,c,d);return!0};g.prototype.detectEnd=function(b,c,a){var d,f,k,e,i;k=this.tokens;for(d=0;f=k[b];){if(0===d&&c.call(this,f,b))return a.call(this,f,b);if(!f||0>d)return a.call(this,f,b-1);if(e=f[0],0<=h.call(y,e))d+=1;else if(i=f[0],0<=h.call(x,i))d-=1;b+=1}return b-1};g.prototype.removeLeadingNewlines=function(){var b,c,a,d,f;f=this.tokens;b=a=0;for(d=f.length;a<d&&!(c=f[b][0],"TERMINATOR"!==
c);b=++a);if(b)return this.tokens.splice(0,b)};g.prototype.closeOpenCalls=function(){var b,c;c=function(a,b){var c;return")"===(c=a[0])||"CALL_END"===c||"OUTDENT"===a[0]&&")"===this.tag(b-1)};b=function(a,b){return this.tokens["OUTDENT"===a[0]?b-1:b][0]="CALL_END"};return this.scanTokens(function(a,d){"CALL_START"===a[0]&&this.detectEnd(d+1,c,b);return 1})};g.prototype.closeOpenIndexes=function(){var b,c;c=function(a){var b;return"]"===(b=a[0])||"INDEX_END"===b};b=function(a){return a[0]="INDEX_END"};
return this.scanTokens(function(a,d){"INDEX_START"===a[0]&&this.detectEnd(d+1,c,b);return 1})};g.prototype.matchTags=function(){var b,c,a,d,f,k,e;c=arguments[0];d=2<=arguments.length?F.call(arguments,1):[];a=f=b=0;for(k=d.length;0<=k?f<k:f>k;a=0<=k?++f:--f){for(;"HERECOMMENT"===this.tag(c+a+b);)b+=2;if(null!=d[a]&&("string"===typeof d[a]&&(d[a]=[d[a]]),e=this.tag(c+a+b),0>h.call(d[a],e)))return!1}return!0};g.prototype.looksObjectish=function(b){return this.matchTags(b,"@",null,":")||this.matchTags(b,
null,":")};g.prototype.findTagsBackwards=function(b,c){var a,d,f,k,e,i,g;for(a=[];0<=b&&(a.length||(k=this.tag(b),0>h.call(c,k))&&((e=this.tag(b),0>h.call(y,e))||this.tokens[b].generated)&&(i=this.tag(b),0>h.call(B,i)));)(d=this.tag(b),0<=h.call(x,d))&&a.push(this.tag(b)),(f=this.tag(b),0<=h.call(y,f))&&a.length&&a.pop(),b-=1;return g=this.tag(b),0<=h.call(c,g)};g.prototype.addImplicitBracesAndParens=function(){var b;b=[];return this.scanTokens(function(c,a,d){var f,k,e,i,g,o,n,p,w,m,l,s,q,r,v,t,
j,z,A;j=c[0];m=(l=0<a?d[a-1]:[])[0];w=(a<d.length-1?d[a+1]:[])[0];r=function(){return b[b.length-1]};v=a;i=function(b){return a-v+b};g=function(){var a,b;return null!=(a=r())?null!=(b=a[2])?b.ours:void 0:void 0};o=function(){var a;return g()&&"("===(null!=(a=r())?a[0]:void 0)};p=function(){var a;return g()&&"{"===(null!=(a=r())?a[0]:void 0)};n=function(){var a;return g&&"CONTROL"===(null!=(a=r())?a[0]:void 0)};t=function(c){var e;e=null!=c?c:a;b.push(["(",e,{ours:!0}]);d.splice(e,0,u("CALL_START",
"("));if(null==c)return a+=1};k=function(){b.pop();d.splice(a,0,u("CALL_END",")"));return a+=1};f=function(){for(;o();)k()};s=function(c,e){var f;null==e&&(e=!0);f=null!=c?c:a;b.push(["{",f,{sameLine:!0,startsLine:e,ours:!0}]);d.splice(f,0,u("{",u(new String("{"))));if(null==c)return a+=1};e=function(c){c=null!=c?c:a;b.pop();d.splice(c,0,u("}","}"));return a+=1};if(o()&&("IF"===j||"TRY"===j||"FINALLY"===j||"CATCH"===j||"CLASS"===j||"SWITCH"===j))return b.push(["CONTROL",a,{ours:!0}]),i(1);if("INDENT"===
j&&g()){if("=>"!==m&&"->"!==m&&"["!==m&&"("!==m&&","!==m&&"{"!==m&&"TRY"!==m&&"ELSE"!==m&&"="!==m)for(;o();)k();n()&&b.pop();b.push([j,a]);return i(1)}if(0<=h.call(y,j))return b.push([j,a]),i(1);if(0<=h.call(x,j)){for(;g();)o()?k():p()?e():b.pop();b.pop()}if((0<=h.call(D,j)&&c.spaced&&!c.stringEnd||"?"===j&&0<a&&!d[a-1].spaced)&&(0<=h.call(H,w)||0<=h.call(J,w)&&!(null!=(z=d[a+1])&&z.spaced)&&!(null!=(A=d[a+1])&&A.newLine)))return"?"===j&&(j=c[0]="FUNC_EXIST"),t(a+1),i(2);if(0<=h.call(D,j)&&this.matchTags(a+
1,"INDENT",null,":")&&!this.findTagsBackwards(a,"CLASS EXTENDS IF CATCH SWITCH LEADING_WHEN FOR WHILE UNTIL".split(" ")))return t(a+1),b.push(["INDENT",a+2]),i(3);if(":"===j){for(e="@"===this.tag(a-2)?a-2:a-1;"HERECOMMENT"===this.tag(e-2);)e-=2;c=0===e||(q=this.tag(e-1),0<=h.call(B,q))||d[e-1].newLine;if(r()&&(p=r(),q=p[0],f=p[1],("{"===q||"INDENT"===q&&"{"===this.tag(f-1))&&(c||","===this.tag(e-1)||"{"===this.tag(e-1))))return i(1);s(e,!!c);return i(2)}if(o()&&0<=h.call(C,j)){if("OUTDENT"===m)return k(),
i(1);if(l.newLine)return f(),i(1)}p()&&0<=h.call(B,j)&&(r()[2].sameLine=!1);if(0<=h.call(I,j))for(;g();)if(s=r(),q=s[0],f=s[1],q=s[2],s=q.sameLine,c=q.startsLine,o()&&","!==m)k();else if(p()&&s&&!c)e();else if(p()&&"TERMINATOR"===j&&","!==m&&(!c||!this.looksObjectish(a+1)))e();else break;if(","===j&&!this.looksObjectish(a+1)&&p()&&("TERMINATOR"!==w||!this.looksObjectish(a+2)))for(w="OUTDENT"===w?1:0;p();)e(a+w);return i(1)})};g.prototype.addLocationDataToGeneratedTokens=function(){return this.scanTokens(function(b,
c,a){var d,f,k;if(b[2]||!b.generated&&!b.explicit)return 1;"{"===b[0]&&(d=null!=(k=a[c+1])?k[2]:void 0)?(f=d.first_line,d=d.first_column):(d=null!=(f=a[c-1])?f[2]:void 0)?(f=d.last_line,d=d.last_column):f=d=0;b[2]={first_line:f,first_column:d,last_line:f,last_column:d};return 1})};g.prototype.normalizeLines=function(){var b,c,a,d,f;f=a=d=null;c=function(a,b){var c,d,g,n;return";"!==a[1]&&(c=a[0],0<=h.call(K,c))&&!("TERMINATOR"===a[0]&&(d=this.tag(b+1),0<=h.call(t,d)))&&!("ELSE"===a[0]&&"THEN"!==f)&&
!(("CATCH"===(g=a[0])||"FINALLY"===g)&&("->"===f||"=>"===f))||(n=a[0],0<=h.call(C,n))&&this.tokens[b-1].newLine};b=function(a,b){return this.tokens.splice(","===this.tag(b-1)?b-1:b,0,d)};return this.scanTokens(function(g,e,i){var l,o,n,g=g[0];if("TERMINATOR"===g){if("ELSE"===this.tag(e+1)&&"OUTDENT"!==this.tag(e-1))return i.splice.apply(i,[e,1].concat(F.call(this.indentation()))),1;if(l=this.tag(e+1),0<=h.call(t,l))return i.splice(e,1),0}if("CATCH"===g)for(l=o=1;2>=o;l=++o)if("OUTDENT"===(n=this.tag(e+
l))||"TERMINATOR"===n||"FINALLY"===n)return i.splice.apply(i,[e+l,0].concat(F.call(this.indentation()))),2+l;0<=h.call(A,g)&&("INDENT"!==this.tag(e+1)&&!("ELSE"===g&&"IF"===this.tag(e+1)))&&(f=g,n=this.indentation(!0),a=n[0],d=n[1],"THEN"===f&&(a.fromThen=!0),i.splice(e+1,0,a),this.detectEnd(e+2,c,b),"THEN"===g&&i.splice(e,1));return 1})};g.prototype.tagPostfixConditionals=function(){var b,c,a;a=null;c=function(a,b){var c,e;e=a[0];c=this.tokens[b-1][0];return"TERMINATOR"===e||"INDENT"===e&&0>h.call(A,
c)};b=function(b){if("INDENT"!==b[0]||b.generated&&!b.fromThen)return a[0]="POST_"+a[0]};return this.scanTokens(function(d,f){if("IF"!==d[0])return 1;a=d;this.detectEnd(f+1,c,b);return 1})};g.prototype.indentation=function(b){var c,a;null==b&&(b=!1);c=["INDENT",2];a=["OUTDENT",2];b&&(c.generated=a.generated=!0);b||(c.explicit=a.explicit=!0);return[c,a]};g.prototype.generate=u;g.prototype.tag=function(b){var c;return null!=(c=this.tokens[b])?c[0]:void 0};G.Rewriter=g;g=[["(",")"],["[","]"],["{","}"],
["INDENT","OUTDENT"],["CALL_START","CALL_END"],["PARAM_START","PARAM_END"],["INDEX_START","INDEX_END"]];G.INVERSES=z={};y=[];x=[];v=0;for(L=g.length;v<L;v++)l=g[v],E=l[0],l=l[1],y.push(z[l]=E),x.push(z[E]=l);t=["CATCH","THEN","ELSE","FINALLY"].concat(x);D="IDENTIFIER SUPER ) CALL_END ] INDEX_END @ THIS".split(" ");H="IDENTIFIER NUMBER STRING JS REGEX NEW PARAM_START CLASS IF TRY SWITCH THIS BOOL NULL UNDEFINED UNARY SUPER THROW @ -> => [ ( { -- ++".split(" ");J=["+","-"];I="POST_IF FOR WHILE UNTIL WHEN BY LOOP TERMINATOR".split(" ");
A="ELSE -> => TRY FINALLY THEN".split(" ");K="TERMINATOR CATCH FINALLY ELSE OUTDENT LEADING_WHEN".split(" ");B=["TERMINATOR","INDENT","OUTDENT"];C=[".","?.","::","?::"]});