/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","../token_iterator"],function(i,j){function d(b,a){return-1<b.type.lastIndexOf(a+".xml")}var k=i("../token_iterator").TokenIterator,l="accesskey class contenteditable contextmenu dir draggable dropzone hidden id inert itemid itemprop itemref itemscope itemtype lang spellcheck style tabindex title translate".split(" ").concat("onabort onblur oncancel oncanplay oncanplaythrough onchange onclick onclose oncontextmenu oncuechange ondblclick ondrag ondragend ondragenter ondragleave ondragover ondragstart ondrop ondurationchange onemptied onended onerror onfocus oninput oninvalid onkeydown onkeypress onkeyup onload onloadeddata onloadedmetadata onloadstart onmousedown onmousemove onmouseout onmouseover onmouseup onmousewheel onpause onplay onplaying onprogress onratechange onreset onscroll onseeked onseeking onselect onshow onstalled onsubmit onsuspend ontimeupdate onvolumechange onwaiting".split(" ")),
f={html:["manifest"],head:[],title:[],base:["href","target"],link:"href hreflang rel media type sizes".split(" "),meta:["http-equiv","name","content","charset"],style:["type","media","scoped"],script:["charset","type","src","defer","async"],noscript:["href"],body:"onafterprint onbeforeprint onbeforeunload onhashchange onmessage onoffline onpopstate onredo onresize onstorage onundo onunload".split(" "),section:[],nav:[],article:["pubdate"],aside:[],h1:[],h2:[],h3:[],h4:[],h5:[],h6:[],header:[],footer:[],
address:[],main:[],p:[],hr:[],pre:[],blockquote:["cite"],ol:["start","reversed"],ul:[],li:["value"],dl:[],dt:[],dd:[],figure:[],figcaption:[],div:[],a:"href target ping rel media hreflang type".split(" "),em:[],strong:[],small:[],s:[],cite:[],q:["cite"],dfn:[],abbr:[],data:[],time:["datetime"],code:[],"var":[],samp:[],kbd:[],sub:[],sup:[],i:[],b:[],u:[],mark:[],ruby:[],rt:[],rp:[],bdi:[],bdo:[],span:[],br:[],wbr:[],ins:["cite","datetime"],del:["cite","datetime"],img:"alt src height width usemap ismap".split(" "),
iframe:"name src height width sandbox seamless".split(" "),embed:["src","height","width","type"],object:"param data type height width usemap name form classid".split(" "),param:["name","value"],video:"src autobuffer autoplay loop controls width height poster".split(" "),audio:["src","autobuffer","autoplay","loop","controls"],source:["src","type","media"],track:["kind","src","srclang","label","default"],canvas:["width","height"],map:["name"],area:"shape coords href hreflang alt target media rel ping type".split(" "),
svg:[],math:[],table:["summary"],caption:[],colgroup:["span"],col:["span"],tbody:[],thead:[],tfoot:[],tr:[],td:["headers","rowspan","colspan"],th:["headers","rowspan","colspan","scope"],form:"accept-charset action autocomplete enctype method name novalidate target".split(" "),fieldset:["disabled","form","name"],legend:[],label:["form","for"],input:"type accept alt autocomplete checked disabled form formaction formenctype formmethod formnovalidate formtarget height list max maxlength min multiple pattern placeholder readonly required size src step width files value".split(" "),
button:"autofocus disabled form formaction formenctype formmethod formnovalidate formtarget name value type".split(" "),select:"autofocus disabled form multiple name size".split(" "),datalist:[],optgroup:["disabled","label"],option:["disabled","selected","label","value"],textarea:"autofocus disabled form maxlength name placeholder readonly required rows cols wrap".split(" "),keygen:"autofocus challenge disabled form keytype name".split(" "),output:["for","form","name"],progress:["value","max"],meter:"value min max low high optimum".split(" "),
details:["open"],summary:[],command:"type label icon disabled checked radiogroup command".split(" "),menu:["type","label"],dialog:["open"]},m=Object.keys(f),g=function(){};(function(){this.getCompletions=function(b,a,c,h){var e=a.getTokenAt(c.row,c.column);return!e?[]:d(e,"tag-name")||d(e,"tag-open")||d(e,"end-tag-open")?this.getTagCompletions(b,a,c,h):d(e,"tag-whitespace")||d(e,"attribute-name")?this.getAttributeCompetions(b,a,c,h):[]};this.getTagCompletions=function(){return m.map(function(b){return{value:b,
meta:"tag",score:Number.MAX_VALUE}})};this.getAttributeCompetions=function(b,a,c){b=new k(a,c.row,c.column);for(a=b.getCurrentToken();a&&!d(a,"tag-name");)a=b.stepBackward();b=a?a.value:void 0;if(!b)return[];a=l;b in f&&(a=a.concat(f[b]));return a.map(function(a){return{caption:a,snippet:a+'="$0"',meta:"attribute",score:Number.MAX_VALUE}})}}).call(g.prototype);j.HtmlCompletions=g});