/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../worker/worker_client ../lib/oop ./text ./text_highlight_rules ./xquery/jsoniq_lexer ../range ./behaviour/xquery ./folding/cstyle ../anchor".split(" "),function(d,j){var k=d("../worker/worker_client").WorkerClient,l=d("../lib/oop"),m=d("./text").Mode,n=d("./text_highlight_rules").TextHighlightRules,o=d("./xquery/jsoniq_lexer").JSONiqLexer,i=d("../range").Range,p=d("./behaviour/xquery").XQueryBehaviour,q=d("./folding/cstyle").FoldMode,r=d("../anchor").Anchor,h=function(){this.$tokenizer=
new o;this.$behaviour=new p;this.foldingRules=new q;this.$highlightRules=new n};l.inherits(h,m);(function(){this.completer={getCompletions:function(b,a,c,e,d){if(!a.$worker)return d();a.$worker.emit("complete",{data:{pos:c,prefix:e}});a.$worker.on("complete",function(a){d(null,a.data)})}};this.getNextLineIndent=function(b,a,c){b=this.$getIndent(a);a.match(/\s*(?:then|else|return|[{\(]|<\w+>)\s*$/)&&(b+=c);return b};this.checkOutdent=function(b,a,c){return!/^\s+$/.test(a)?!1:/^\s*[\}\)]/.test(c)};
this.autoOutdent=function(b,a,c){b=a.getLine(c).match(/^(\s*[\}\)])/);if(!b)return 0;var b=b[1].length,e=a.findMatchingBracket({row:c,column:b});if(!e||e.row==c)return 0;e=this.$getIndent(a.getLine(e.row));a.replace(new i(c,0,c,b-1),e)};this.toggleCommentLines=function(b,a,c,e){for(var d=!0,g=/^\s*\(:(.*):\)/,b=c;b<=e;b++)if(!g.test(a.getLine(b))){d=!1;break}for(var f=new i(0,0,0,0),b=c;b<=e;b++)c=a.getLine(b),f.start.row=b,f.end.row=b,f.end.column=c.length,a.replace(f,d?c.match(g)[1]:"(:"+c+":)")};
this.createWorker=function(b){var a=new k(["ace"],"ace/mode/xquery_worker","XQueryWorker"),c=this;a.attachToDocument(b.getDocument());a.on("ok",function(){b.clearAnnotations()});a.on("markers",function(a){b.clearAnnotations();c.addMarkers(a.data,b)});return a};this.removeMarkers=function(b){var a=b.getMarkers(!1),c;for(c in a)0===a[c].clazz.indexOf("language_highlight_")&&b.removeMarker(c);for(a=0;a<b.markerAnchors.length;a++)b.markerAnchors[a].detach();b.markerAnchors=[]};this.addMarkers=function(b,
a){a.markerAnchors||(a.markerAnchors=[]);this.removeMarkers(a);a.languageAnnos=[];b.forEach(function(c){function b(e){g&&a.removeMarker(g);f.row=d.row;if(void 0!==c.pos.sc&&void 0!==c.pos.ec){var h=new i(c.pos.sl,c.pos.sc,c.pos.el,c.pos.ec);g=a.addMarker(h,"language_highlight_"+(c.type?c.type:"default"))}e&&a.setAnnotations(a.languageAnnos)}var d=new r(a.getDocument(),c.pos.sl,c.pos.sc||0);a.markerAnchors.push(d);var g,f={guttertext:c.message,type:c.level||"warning",text:c.message};b();d.on("change",
function(){b(!0)});c.message&&a.languageAnnos.push(f)});a.setAnnotations(a.languageAnnos)};this.$id="ace/mode/jsoniq"}).call(h.prototype);j.Mode=h});