/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2014, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ../lib/lang ./text_highlight_rules ./javascript_highlight_rules ./css_highlight_rules ./markdown_highlight_rules ./html_highlight_rules".split(" "),function(d,p){function j(){function e(a,b,e){h(q,"js-"+a+"-",b,"block"===a?["start"]:["start","no_regex"],e)}function h(a,e,h,c,d){var f="pop",c=c||["start"];0===c.length&&(c=null);/block|multiline/.test(e)&&(f=e+"end",k.$rules[f]=[b("empty","","start")]);k.embedRules(a,e,[b(d||g,h,f)],c,null==c?!0:!1)}this.$rules=
{start:[b("comment","\\/\\/.*$"),b("comment","\\/\\*",[b("comment",".*?\\*\\/","start"),b("comment",".+")]),a.string("'''"),a.string('"""'),a.string('"'),a.string("'"),a.syntax(/(markdown|md)\b/,"md-multiline","multiline"),a.syntax(/html\b/,"html-multiline","multiline"),a.syntax(/(slot|event)\b/,"js-block","block"),a.syntax(/style\b/,"css-block","block"),a.syntax(/var\b/,"js-statement","attr"),a.tag(),b(c,"[[({>]"),b(g,"[\\])};]","start"),{caseInsensitive:!0}]};var k=this;e("interpolation",/\]/,g+
"."+i);e("statement",/\)|}|;/);e("block",/\}/);h(r,"css-block-",/\}/);h(s,"md-multiline-",/("""|''')/,[]);h(t,"html-multiline-",/("""|''')/);this.normalizeRules()}function b(a,b,c){var d,f,g;4===arguments.length?(d=c,f=arguments[3]):"string"===typeof c?f=c:d=c;"function"===typeof a&&(g=a,a="empty");return{token:a,regex:b,push:d,next:f,onMatch:g}}p.MaskHighlightRules=j;var u=d("../lib/oop"),f=d("../lib/lang"),v=d("./text_highlight_rules").TextHighlightRules,q=d("./javascript_highlight_rules").JavaScriptHighlightRules,
r=d("./css_highlight_rules").CssHighlightRules,s=d("./markdown_highlight_rules").MarkdownHighlightRules,t=d("./html_highlight_rules").HtmlHighlightRules,i="markup.italic",c="paren.lparen",g="paren.rparen",l,m,n,o;l=f.arrayToMap(["log"]);n=f.arrayToMap(":dualbind :bind :import slot event style html markdown md".split(" "));m=f.arrayToMap("debugger define var if each for of else switch case with visible +if +each +for +switch +with +visible include import".split(" "));o=f.arrayToMap("a abbr acronym address applet area article aside audio b base basefont bdo big blockquote body br button canvas caption center cite code col colgroup command datalist dd del details dfn dir div dl dt em embed fieldset figcaption figure font footer form frame frameset h1 h2 h3 h4 h5 h6 head header hgroup hr html i iframe img input ins keygen kbd label legend li link map mark menu meta meter nav noframes noscript object ol optgroup option output p param pre progress q rp rt ruby s samp script section select small source span strike strong style sub summary sup table tbody td textarea tfoot th thead time title tr tt u ul var video wbr xmp".split(" "));
u.inherits(j,v);var a={string:function(e,d){var f=b("string.start",e,[b(c+"."+i,/~\[/,a.interpolation()),b("string.end",e,"pop"),{defaultToken:"string"}],d);if(1===e.length){var g=b("string.escape","\\\\"+e);f.push.unshift(g)}return f},interpolation:function(){return[b("keyword.control.markup.italic",/\s*\w*\s*:/),"js-interpolation-start"]},tagHead:function(e){return b("support.variable.class",e,[b("support.variable.class",/[\w\-_]+/),b(c+"."+i,/~\[/,a.interpolation()),a.goUp()])},tag:function(){return{token:"tag",
onMatch:function(a){return void 0!==m[a]?"keyword":void 0!==n[a]?"constant.language":void 0!==l[a]?"support.function":void 0!==o[a.toLowerCase()]?"keyword.support.constant.language":"support.function.markup.bold"},regex:/([@\w\-_:+]+)|((^|\s)(?=\s*(\.|#)))/,push:[a.tagHead(/\./),a.tagHead(/\#/),a.expression(),a.attribute(),b(c,/[;>{]/,"pop")]}},syntax:function(e,d,f){return{token:"constant.language",regex:e,push:{attr:[d+"-start",b("keyword.operator",/;/,"start")],multiline:[a.tagHead(/\./),a.tagHead(/\#/),
a.attribute(),a.expression(),b(c,/[>\{]/),b("keyword.operator",/;/,"start"),b(c,/'''|"""/,[d+"-start"])],block:[a.tagHead(/\./),a.tagHead(/\#/),a.attribute(),a.expression(),b(c,/\{/,[d+"-start"])]}[f]}},attribute:function(){return b(function(a){return/^x\-/.test(a)?"support.variable.class.markup.bold":"support.variable.class"},/[\w_-]+/,[b("keyword.operator",/\s*=\s*/,[a.string('"'),a.string("'"),a.word(),a.goUp()]),a.goUp()])},expression:function(){return b(c,/\(/,["js-statement-start"])},word:function(){return b("string",
/[\w-_]+/)},goUp:function(){return b("text","","pop")},goStart:function(){return b("text","","start")}}});