/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/event ../lib/useragent ./default_handlers ./default_gutter_handler ./mouse_event ./dragdrop_handler ../config".split(" "),function(f,k){var c=f("../lib/event"),i=f("../lib/useragent"),l=f("./default_handlers").DefaultHandlers,m=f("./default_gutter_handler").GutterHandler,j=f("./mouse_event").MouseEvent,n=f("./dragdrop_handler").DragdropHandler,o=f("../config"),h=function(a){var d=this;this.editor=a;new l(this);new m(this);new n(this);var e=function(){(!document.hasFocus||
!document.hasFocus())&&window.focus();a.focus()},b=a.renderer.getMouseEventTarget();c.addListener(b,"click",this.onMouseEvent.bind(this,"click"));c.addListener(b,"mousemove",this.onMouseMove.bind(this,"mousemove"));c.addMultiMouseDownListener(b,[400,300,250],this,"onMouseEvent");a.renderer.scrollBarV&&(c.addMultiMouseDownListener(a.renderer.scrollBarV.inner,[400,300,250],this,"onMouseEvent"),c.addMultiMouseDownListener(a.renderer.scrollBarH.inner,[400,300,250],this,"onMouseEvent"),i.isIE&&(c.addListener(a.renderer.scrollBarV.element,
"mousedown",e),c.addListener(a.renderer.scrollBarH.element,"mousedown",e)));c.addMouseWheelListener(a.container,this.onMouseWheel.bind(this,"mousewheel"));var g=a.renderer.$gutter;c.addListener(g,"mousedown",this.onMouseEvent.bind(this,"guttermousedown"));c.addListener(g,"click",this.onMouseEvent.bind(this,"gutterclick"));c.addListener(g,"dblclick",this.onMouseEvent.bind(this,"gutterdblclick"));c.addListener(g,"mousemove",this.onMouseEvent.bind(this,"guttermousemove"));c.addListener(b,"mousedown",
e);c.addListener(g,"mousedown",function(b){a.focus();return c.preventDefault(b)});a.on("mousemove",function(b){if(!d.state&&!d.$dragDelay&&d.$dragEnabled){var b=a.renderer.screenToTextCoordinates(b.x,b.y),c=a.session.selection.getRange(),e=a.renderer;!c.isEmpty()&&c.insideStart(b.row,b.column)?e.setCursorStyle("default"):e.setCursorStyle("")}})};(function(){this.onMouseEvent=function(a,d){this.editor._emit(a,new j(d,this.editor))};this.onMouseMove=function(a,d){var c=this.editor._eventRegistry&&this.editor._eventRegistry.mousemove;
c&&c.length&&this.editor._emit(a,new j(d,this.editor))};this.onMouseWheel=function(a,c){var e=new j(c,this.editor);e.speed=2*this.$scrollSpeed;e.wheelX=c.wheelX;e.wheelY=c.wheelY;this.editor._emit(a,e)};this.setState=function(a){this.state=a};this.captureMouse=function(a,d){this.x=a.x;this.y=a.y;this.isMousePressed=!0;var e=this.editor.renderer;e.$keepTextAreaAtCursor&&(e.$keepTextAreaAtCursor=null);var b=this,g=function(a){if(a){if(i.isWebKit&&!a.which&&b.releaseMouse)return b.releaseMouse();b.x=
a.clientX;b.y=a.clientY;d&&d(a);b.mouseEvent=new j(a,b.editor);b.$mouseMoved=!0}},f=function(a){clearInterval(k);h();b[b.state+"End"]&&b[b.state+"End"](a);b.state="";null==e.$keepTextAreaAtCursor&&(e.$keepTextAreaAtCursor=!0,e.$moveTextAreaToCursor());b.isMousePressed=!1;b.$onCaptureMouseMove=b.releaseMouse=null;a&&b.onMouseEvent("mouseup",a)},h=function(){b[b.state]&&b[b.state]();b.$mouseMoved=!1};if(i.isOldIE&&"dblclick"==a.domEvent.type)return setTimeout(function(){f(a)});b.$onCaptureMouseMove=
g;b.releaseMouse=c.capture(this.editor.container,g,f);var k=setInterval(h,20)};this.releaseMouse=null;this.cancelContextMenu=function(){var a=function(d){if(!d||!(d.domEvent&&"contextmenu"!=d.domEvent.type))this.editor.off("nativecontextmenu",a),d&&d.domEvent&&c.stopEvent(d.domEvent)}.bind(this);setTimeout(a,10);this.editor.on("nativecontextmenu",a)}}).call(h.prototype);o.defineOptions(h.prototype,"mouseHandler",{scrollSpeed:{initialValue:2},dragDelay:{initialValue:i.isMac?150:0},dragEnabled:{initialValue:!0},
focusTimout:{initialValue:0},tooltipFollowsMouse:{initialValue:!0}});k.MouseHandler=h});