/**
 * @author DOGO
 * @module WebViewer3D
 * @copyright   2014 Esko Stonecube Ltd. All rights reserved.
 */

define("underscore backbone WV3Dlib/three WV3Dmod/Utils WV3Dmod/Timers WV3Dmod/LogMessage".split(" "),function(I,H,f,F,J,y){return H.Model.extend({initialize:function(c){y.Log("Creating ThreeDObjectHandler Object");this.set("_geometrycounter",0);this.set("_build_mesh_execution_queue",c)},DotNormals:function(c,n,e,g){var d=3*c[0],j=3*c[1],c=3*c[2],d=new f.Vector3(e[d],e[d+1],e[d+2]),j=new f.Vector3(e[j],e[j+1],e[j+2]),e=new f.Vector3(e[c],e[c+1],e[c+2]),e=d.add(j).add(e).normalize(),d=3*n[0],j=3*n[1],
c=3*n[2],n=new f.Vector3(g[d],g[d+1],g[d+2]),j=new f.Vector3(g[j],g[j+1],g[j+2]),g=new f.Vector3(g[c],g[c+1],g[c+2]),j=j.sub(n).normalize(),g=g.sub(n).normalize();return j.cross(g).dot(e)},GetColor:function(c,f,e){var g=e.indices,c=parseInt(f[e.source][g[c%g.length]],16);return{r:(c&16711680)>>16,g:(c&65280)>>8,b:c&255}},DotNormalsInterleaved:function(c,n,e,g){var d=3*c[1],j=3*c[1+g],a=3*c[1+2*g],d=new f.Vector3(n[d],n[d+1],n[d+2]),j=new f.Vector3(n[j],n[j+1],n[j+2]),n=new f.Vector3(n[a],n[a+1],n[a+
2]),n=d.add(j).add(n).normalize(),d=3*c[0],a=3*c[g],g=3*c[2*g],c=new f.Vector3(e[d],e[d+1],e[d+2]),a=new f.Vector3(e[a],e[a+1],e[a+2]),e=new f.Vector3(e[g],e[g+1],e[g+2]),g=a.sub(c).normalize(),e=e.sub(c).normalize();return g.cross(e).dot(n)},CreateCuboidFaces:function(c,n){return function(){if(n.hasOwnProperty("colors")&&null!==n.colors)for(var e=0;e<c.faces.length;e++){var g;switch(Math.floor(e/2)){case 0:g=0;break;case 1:g=3;break;case 2:g=1;break;case 3:g=4;break;case 4:g=2;break;case 5:g=5}c.faces[e].color.setHex(n.colors[g%
n.colors.length])}c.computeFaceNormals();n.hasOwnProperty("smoothnormals")&&n.smoothnormals&&(c.faces[0].vertexNormals[0]=new f.Vector3(1,1,1),c.faces[0].vertexNormals[1]=new f.Vector3(1,-1,1),c.faces[0].vertexNormals[2]=new f.Vector3(1,1,-1),c.faces[1].vertexNormals[0]=new f.Vector3(1,-1,1),c.faces[1].vertexNormals[1]=new f.Vector3(1,-1,-1),c.faces[1].vertexNormals[2]=new f.Vector3(1,1,-1),c.faces[2].vertexNormals[0]=new f.Vector3(-1,1,-1),c.faces[2].vertexNormals[1]=new f.Vector3(-1,-1,-1),c.faces[2].vertexNormals[2]=
new f.Vector3(-1,1,1),c.faces[3].vertexNormals[0]=new f.Vector3(-1,-1,-1),c.faces[3].vertexNormals[1]=new f.Vector3(-1,-1,1),c.faces[3].vertexNormals[2]=new f.Vector3(-1,1,1),c.faces[4].vertexNormals[0]=new f.Vector3(-1,1,-1),c.faces[4].vertexNormals[1]=new f.Vector3(-1,1,1),c.faces[4].vertexNormals[2]=new f.Vector3(1,1,-1),c.faces[5].vertexNormals[0]=new f.Vector3(-1,1,1),c.faces[5].vertexNormals[1]=new f.Vector3(1,1,1),c.faces[5].vertexNormals[2]=new f.Vector3(1,1,-1),c.faces[6].vertexNormals[0]=
new f.Vector3(-1,-1,1),c.faces[6].vertexNormals[1]=new f.Vector3(-1,-1,-1),c.faces[6].vertexNormals[2]=new f.Vector3(1,-1,1),c.faces[7].vertexNormals[0]=new f.Vector3(-1,-1,-1),c.faces[7].vertexNormals[1]=new f.Vector3(1,-1,-1),c.faces[7].vertexNormals[2]=new f.Vector3(1,-1,1),c.faces[8].vertexNormals[0]=new f.Vector3(-1,1,1),c.faces[8].vertexNormals[1]=new f.Vector3(-1,-1,1),c.faces[8].vertexNormals[2]=new f.Vector3(1,1,1),c.faces[9].vertexNormals[0]=new f.Vector3(-1,-1,1),c.faces[9].vertexNormals[1]=
new f.Vector3(1,-1,1),c.faces[9].vertexNormals[2]=new f.Vector3(1,1,1),c.faces[10].vertexNormals[0]=new f.Vector3(1,1,-1),c.faces[10].vertexNormals[1]=new f.Vector3(1,-1,-1),c.faces[10].vertexNormals[2]=new f.Vector3(-1,1,-1),c.faces[11].vertexNormals[0]=new f.Vector3(1,-1,-1),c.faces[11].vertexNormals[1]=new f.Vector3(-1,-1,-1),c.faces[11].vertexNormals[2]=new f.Vector3(-1,1,-1));g=[];g.push([new f.Vector2(0.5,1),new f.Vector2(0,1),new f.Vector2(0,0.666),new f.Vector2(0.5,0.666)],[new f.Vector2(0.5,
0.666),new f.Vector2(1,0.666),new f.Vector2(1,1),new f.Vector2(0.5,1)],[new f.Vector2(0.5,0.333),new f.Vector2(0.5,0.666),new f.Vector2(0,0.666),new f.Vector2(0,0.333)],[new f.Vector2(0.5,0.666),new f.Vector2(0.5,0.333),new f.Vector2(1,0.333),new f.Vector2(1,0.666)],[new f.Vector2(0.5,0.333),new f.Vector2(0,0.333),new f.Vector2(0,0),new f.Vector2(0.5,0)],[new f.Vector2(1,0.333),new f.Vector2(0.5,0.333),new f.Vector2(0.5,0),new f.Vector2(1,0)]);for(e=0;6>e;++e)c.faceVertexUvs[0][2*e]=[g[e][0],g[e][1],
g[e][3]],c.faceVertexUvs[0][2*e+1]=[g[e][1],g[e][2],g[e][3]]}},CreateCuboidHardEdges:function(c,n){return function(){var e=0.001*Math.max(n.length,n.height),g=-n.length/2-e,d=-n.width/2-e,j=-n.height/2-e,a=n.length/2+e,o=n.width/2+e,k=n.height/2+e,e=new f.Vector3(g,d,j),l=new f.Vector3(a,d,j),r=new f.Vector3(g,d,k),d=new f.Vector3(a,d,k),m=new f.Vector3(g,o,j),j=new f.Vector3(a,o,j),g=new f.Vector3(g,o,k),a=new f.Vector3(a,o,k);c.adjacentfacesedgeslines.vertices.push(e);c.adjacentfacesedgeslines.vertices.push(r);
c.adjacentfacesedgeslines.vertices.push(r);c.adjacentfacesedgeslines.vertices.push(d);c.adjacentfacesedgeslines.vertices.push(d);c.adjacentfacesedgeslines.vertices.push(l);c.adjacentfacesedgeslines.vertices.push(r);c.adjacentfacesedgeslines.vertices.push(g);c.adjacentfacesedgeslines.vertices.push(g);c.adjacentfacesedgeslines.vertices.push(a);c.adjacentfacesedgeslines.vertices.push(a);c.adjacentfacesedgeslines.vertices.push(d);c.adjacentfacesedgeslines.vertices.push(g);c.adjacentfacesedgeslines.vertices.push(m);
c.adjacentfacesedgeslines.vertices.push(m);c.adjacentfacesedgeslines.vertices.push(j);c.adjacentfacesedgeslines.vertices.push(j);c.adjacentfacesedgeslines.vertices.push(a);c.adjacentfacesedgeslines.vertices.push(m);c.adjacentfacesedgeslines.vertices.push(e);c.adjacentfacesedgeslines.vertices.push(e);c.adjacentfacesedgeslines.vertices.push(l);c.adjacentfacesedgeslines.vertices.push(l);c.adjacentfacesedgeslines.vertices.push(j)}},CreateMeshFaces:function(c,n,e){return function(){var g=e.input.position,
d=e.input.interleaved,j=e.input.color,a=e.input.normal,o=e.input.texcoord,k=a&&a.hasOwnProperty("smooth")&&F.get("toBool")(a.smooth);if(d){var l=n[d.sources[0]],a=d.indices,r=n[d.sources[1]],g=null,m=[],o=[],v=[],p=[],t=[],i,h;switch(d.format){default:y.Log("ThreeDObjectHandler Warning: Unrecognized interleaved format, switching to default PNT");case "PNT":g=n[d.sources[2]];i=9;h=3;break;case "PN":i=6,h=2}switch(e.topology){default:y.Log("ThreeDObjectHandler Warning: Unrecognized topology type. Switching to default triangle soup");
case "TRIANGLE_SOUP":d=this.DotNormalsInterleaved(a,r,l,h);0==d&&y.Log("ThreeDObjectHandler Warning: Problem in normal computation for winding");(0>d&&"CCW"==e.winding||0<d&&"CW"==e.winding)&&y.Log("ThreeDObjectHandler Warning: Surface winding is not coherent with input normals, please check input file (Winding will be flipped automatically anyway).");for(var q={},b=0;b<e.count;++b){0>d&&(a[b*i+h]=[a[b*i+2*h],a[b*i+2*h]=a[b*i+h]][0],a[b*i+h+1]=[a[b*i+2*h+1],a[b*i+2*h+1]=a[b*i+h+1]][0],3<=h&&(a[b*
i+h+2]=[a[b*i+2*h+2],a[b*i+2*h+2]=a[b*i+h+2]][0]));var s,w,A,z,C,D,x,E,G;s=l[3*a[i*b]];w=l[3*a[i*b]+1];A=l[3*a[i*b]+2];z=l[3*a[i*b+h]];C=l[3*a[i*b+h]+1];D=l[3*a[i*b+h]+2];x=l[3*a[i*b+2*h]];E=l[3*a[i*b+2*h]+1];G=l[3*a[i*b+2*h]+2];var u=[s,w,A,z,C,D,x,E,G];m.push.apply(m,u);k?(u=function(a,b,c){q.hasOwnProperty(a)?q[a].add(c):q[a]=c},s=new f.Vector3(s,w,A),z=new f.Vector3(z,C,D),x=new f.Vector3(x,E,G),E=z.clone().sub(s),x=x.clone().sub(s),x=E.cross(x),u(a[i*b],q,x),u(a[i*b+h],q,x),u(a[i*b+2*h],q,x)):
(u=[r[3*a[i*b+1]],r[3*a[i*b+1]+1],r[3*a[i*b+1]+2],r[3*a[i*b+h+1]],r[3*a[i*b+h+1]+1],r[3*a[i*b+h+1]+2],r[3*a[i*b+2*h+1]],r[3*a[i*b+2*h+1]+1],r[3*a[i*b+2*h+1]+2]],o.push.apply(o,u));u=g?[g[2*a[i*b+2]],g[2*a[i*b+2]+1],g[2*a[i*b+h+2]],g[2*a[i*b+h+2]+1],g[2*a[i*b+2*h+2]],g[2*a[i*b+2*h+2]+1]]:[0,0,0,0,0,0];v.push.apply(v,u);p.push.apply(p,u);j&&(u=this.GetColor(b,n,j),t.push.apply(t,[u.r/255,u.g/255,u.b/255]),t.push.apply(t,[u.r/255,u.g/255,u.b/255]),t.push.apply(t,[u.r/255,u.g/255,u.b/255]))}if(k){for(var B in q)q[B]instanceof
f.Vector3&&q[B].normalize();for(b=0;b<e.count;++b)u=[q[a[i*b]].x,q[a[i*b]].y,q[a[i*b]].z,q[a[i*b+h]].x,q[a[i*b+h]].y,q[a[i*b+h]].z,q[a[i*b+2*h]].x,q[a[i*b+2*h]].y,q[a[i*b+2*h]].z],o.push.apply(o,u)}}c.addAttribute("position",new f.BufferAttribute(new Float32Array(m),3));c.addAttribute("normal",new f.BufferAttribute(new Float32Array(o),3));j&&c.addAttribute("color",new f.BufferAttribute(new Float32Array(t),3));c.addAttribute("uv",new f.BufferAttribute(new Float32Array(v),2));c.addAttribute("uv2",new f.BufferAttribute(new Float32Array(p),
2));c.uvsNeedUpdate=!0}else{d=1;if(a&&g&&a.hasOwnProperty("indices")&&a.indices&&3<=a.indices.length&&n[a.source]&&g.hasOwnProperty("indices")&&g.indices&&3<=g.indices.length&&n[g.source])d=n[g.source],r=n[a.source],d=this.DotNormals(a.indices,g.indices,r,d),0==d&&y.Log("ThreeDObjectHandler Warning: Problem in normal computation for winding"),(0>d&&"CCW"==e.winding||0<d&&"CW"==e.winding)&&y.Log("ThreeDObjectHandler Warning: Surface winding is not coherent with input normals, please check input file (Winding will be flipped automatically anyway).");
else switch(e.winding){default:case "CCW":d=1;break;case "CW":d=-1}if(g){l=n[g.source];a=g.indices;m=[];t=[];switch(e.topology){default:y.Log("ThreeDObjectHandler Warning: Unrecognized topology type. Switching to default triangle soup");case "TRIANGLE_SOUP":for(b=0;b<e.count;++b)0>d&&(a[3*b+2]=[a[3*b+1],a[3*b+1]=a[3*b+2]][0]),u=[l[3*parseInt(a[3*b])],l[3*parseInt(a[3*b])+1],l[3*parseInt(a[3*b])+2],l[3*parseInt(a[3*b+1])],l[3*parseInt(a[3*b+1])+1],l[3*parseInt(a[3*b+1])+2],l[3*parseInt(a[3*b+2])],
l[3*parseInt(a[3*b+2])+1],l[3*parseInt(a[3*b+2])+2]],void 0===u[0]||void 0===u[1]||void 0===u[2]||void 0===u[3]||void 0===u[4]||void 0===u[5]||void 0===u[6]||void 0===u[7]||void 0===u[8]?y.Log("ThreeDObjectHandler Warning: index out of vertices array bounds"):m.push.apply(m,u),j&&(u=this.GetColor(b,n,j),t.push.apply(t,[u.r/255,u.g/255,u.b/255]),t.push.apply(t,[u.r/255,u.g/255,u.b/255]),t.push.apply(t,[u.r/255,u.g/255,u.b/255]))}c.addAttribute("position",new f.BufferAttribute(new Float32Array(m),3));
j&&c.addAttribute("color",new f.BufferAttribute(new Float32Array(t),3))}if(a=e.input.normal)if(a.hasOwnProperty("smooth")&&F.get("toBool")(a.smooth)){l=n[g.source];a=g.indices;j=[];q={};g=new f.Vector3;m=new f.Vector3;v=new f.Vector3;p=new f.Vector3;t=new f.Vector3;for(b=0;b<e.count;++b)r=3*a[3*b],k=3*a[3*b+1],B=3*a[3*b+2],g.fromArray(l,r),m.fromArray(l,k),v.fromArray(l,B),p.subVectors(v,m),t.subVectors(g,m),p.cross(t),i=function(a,b){q.hasOwnProperty(a)?q[a].add(b):q[a]=b.clone()},i(r,p),i(k,p),
i(B,p);b=0;l=Object.keys(q);for(r=l.length;b<r;++b)q[l[b]].normalize();for(b=0;b<e.count;++b)r=3*a[3*b],k=3*a[3*b+1],B=3*a[3*b+2],l=[q[r].x,q[r].y,q[r].z,q[k].x,q[k].y,q[k].z,q[B].x,q[B].y,q[B].z],j.push.apply(j,l);c.addAttribute("normal",new f.BufferAttribute(new Float32Array(j),3))}else if(a.hasOwnProperty("indices")&&a.indices&&a.indices.length&&n[a.source]){r=n[a.source];a=a.indices;j=[];for(b=0;b<e.count;++b)0>d&&(a[3*b+2]=[a[3*b+1],a[3*b+1]=a[3*b+2]][0]),l=[r[3*a[3*b]],r[3*a[3*b]+1],r[3*a[3*
b]+2],r[3*a[3*b+1]],r[3*a[3*b+1]+1],r[3*a[3*b+1]+2],r[3*a[3*b+2]],r[3*a[3*b+2]+1],r[3*a[3*b+2]+2]],j.push.apply(j,l);c.addAttribute("normal",new f.BufferAttribute(new Float32Array(j),3))}else y.Log("Problem parsing json: no normal computation can be infered");else c.computeVertexNormals();v=[];p=[];if(o&&o.indices&&o.indices.length&&n[o.source]){g=n[o.source];a=o.indices;for(b=0;b<e.count;b++)0>d&&(a[3*b+2]=[a[3*b+1],a[3*b+1]=a[3*b+2]][0]),u=[g[2*a[3*b]],g[2*a[3*b]+1],g[2*a[3*b+1]],g[2*a[3*b+1]+1],
g[2*a[3*b+2]],g[2*a[3*b+2]+1]],v.push.apply(v,u),p.push.apply(p,u);c.uvsNeedUpdate=!0}else for(b=0;b<3*e.count;b++)v.push.apply(v,[0,0]),p.push.apply(p,[0,0]);c.addAttribute("uv",new f.BufferAttribute(new Float32Array(v),2));c.addAttribute("uv2",new f.BufferAttribute(new Float32Array(p),2))}}},CreateMeshHardEdges:function(c,n,e,g){return function(){var d=e.input.position,j=e.input.interleaved,a=e.input.normal,o={};if(!a||!a.hasOwnProperty("smooth")||!F.get("toBool")(a.smooth))for(var k={},l=0;l<e.count;++l){var r=
l,m,v,p;if(d)p=d.indices,m=parseInt(p[3*r]),v=parseInt(p[3*r+1]),p=parseInt(p[3*r+2]);else if(j){var t,i;switch(j.format){default:y.Log("ThreeDObjectHandler Warning: Unrecognized interleaved format, switching to default PNT");case "PNT":t=9;i=3;break;case "PN":t=6,i=2}p=j.indices;m=parseInt(p[r*t]);v=parseInt(p[r*t+i]);p=parseInt(p[r*t+2*i])}var h={"0":m,1:v,face1:r,face2:null,opedge:null,edgeIDF1:0,edgeIDF2:null},q=h["0"]+"/"+h["1"],b=h["1"]+"/"+h["0"];k.hasOwnProperty(b)?(k[q]=h,k[q].face2=k[b].face1,
k[q].opedge=k[b],k[b].face2&&y.Log("ThreeDObjectHandler Warning: Edge shared with more than two faces"),k[b].face2=r,k[b].opedge=h,k[b].edgeIDF2=0):k.hasOwnProperty(q)?y.Log("ThreeDObjectHandler Warning: Edge already existing : not treated"):(k[q]=h,o[q]=h);h={"0":v,1:p,face1:r,face2:null,opedge:null,edgeIDF1:1,edgeIDF2:null};q=h["0"]+"/"+h["1"];b=h["1"]+"/"+h["0"];k.hasOwnProperty(b)?(k[q]=h,k[q].face2=k[b].face1,k[q].opedge=k[b],k[b].face2&&y.Log("ThreeDObjectHandler Warning: Edge shared with more than two faces"),
k[b].face2=r,k[b].opedge=h,k[b].edgeIDF2=1):k.hasOwnProperty(q)?y.Log("Warning: Edge already existing : not treated"):(k[q]=h,o[q]=h);h={"0":p,1:m,face1:r,face2:null,opedge:null,edgeIDF1:2,edgeIDF2:null};q=h["0"]+"/"+h["1"];b=h["1"]+"/"+h["0"];k.hasOwnProperty(b)?(k[q]=h,k[q].face2=k[b].face1,k[q].opedge=k[b],k[b].face2&&y.Log("ThreeDObjectHandler Warning: Edge shared with more than two faces"),k[b].face2=r,k[b].opedge=h,k[b].edgeIDF2=2):k.hasOwnProperty(q)?y.Log("ThreeDObjectHandler Warning: Edge already existing : not treated"):
(k[q]=h,o[q]=h)}l=0;k=Object.keys(o);for(r=k.length;l<r;++l)if(m=o[k[l]],m.face2){v=new f.Vector3;if(a||j){var s,w,A,z;if(d&&a)h=n[a.source],p=a.indices,q=3*m.face1+m.edgeIDF1,b=3*m.face1+(m.edgeIDF1+1)%3,A=3*m.face2+m.edgeIDF2,z=3*m.face2+(m.edgeIDF2+1)%3;else{switch(j.format){default:y.Log("ThreeDObjectHandler Warning: Unrecognized interleaved format, switching to default PNT");case "PNT":t=9;i=3;break;case "PN":t=6,i=2}h=n[j.sources[1]];p=j.indices;q=m.face1*t+1+i*m.edgeIDF1;b=m.face1*t+1+i*((m.edgeIDF1+
1)%3);A=m.face2*t+1+i*m.edgeIDF2;z=m.face2*t+1+i*((m.edgeIDF2+1)%3)}t=new f.Vector3;i=new f.Vector3;s=new f.Vector3;w=new f.Vector3;t.fromArray(h,3*p[q]);i.fromArray(h,3*p[b]);s.fromArray(h,3*p[A]);w.fromArray(h,3*p[z]);t.normalize();i.normalize();s.normalize();w.normalize();p=Math.abs(Math.min(t.dot(w),i.dot(s)))>1-g;v.addVectors(t,i);v.add(s).add(w).divideScalar(4)}else{if(d){x=n[d.source];p=d.indices;z=3*m.face1+m.edgeIDF1;var C=3*m.face1+(m.edgeIDF1+1)%3,D=3*m.face1+(m.edgeIDF1+2)%3,h=3*m.face2+
m.edgeIDF2,q=3*m.face2+(m.edgeIDF2+1)%3,b=3*m.face2+(m.edgeIDF2+2)%3;A=new f.Vector3;t=new f.Vector3;i=new f.Vector3;s=new f.Vector3;w=new f.Vector3;A.fromArray(x,3*p[z]);t.fromArray(x,3*p[C]);i.fromArray(x,3*p[D]);s.subVectors(i,t);w.subVectors(A,t);s.cross(w);s.normalize();z=s.clone();A.fromArray(x,3*p[h]);t.fromArray(x,3*p[q]);i.fromArray(x,3*p[b]);s.subVectors(i,t);w.subVectors(A,t);s.cross(w);s.normalize();h=s.clone()}else{y.Log("Missing vertex data");break}p=Math.abs(z.dot(h))>1-g;v.addVectors(z,
h);v.divideScalar(4)}p||(p=m["0"],h=m["1"],d?x=n[d.source]:j&&(x=n[j.sources[0]]),m=new f.Vector3,v=new f.Vector3,m.fromArray(x,3*p),v.fromArray(x,3*h),c.adjacentfacesedgeslines.vertices.push(m),c.adjacentfacesedgeslines.vertices.push(v))}else{p=m["0"];var h=m["1"],x;d?x=n[d.source]:j&&(x=n[j.sources[0]]);m=new f.Vector3;v=new f.Vector3;m.fromArray(x,3*p);v.fromArray(x,3*h);c.adjacentfacesedgeslines.vertices.push(m);c.adjacentfacesedgeslines.vertices.push(v)}c.computeBoundingBox()}},AddAssetToNode:function(c,
n,e,g,d,j,a,o,k,l,r){var m,v,p;if(j.hasOwnProperty(n))switch(c){case "Cuboid":m=j[n];break;case "Mesh":p=j[n];break;default:y.Log("ThreeDObjectHandler Warning: Unrecognized type of geometry - Accepted: Cuboid, Mesh")}else switch(c){case "Cuboid":m=new f.BoxGeometry(d.length,d.width,d.height);this.set("_geometrycounter",this.get("_geometrycounter")+1);this.get("_build_mesh_execution_queue").run(this.CreateCuboidFaces(m,d),this,!1,null,null,!0);m.adjacentfacesedgeslines=new f.Geometry;this.get("_build_mesh_execution_queue").run(this.CreateCuboidHardEdges(m,
d),this,!1,null,null,!0);j[n]=m;break;case "Mesh":j.hasOwnProperty(n)||(j[n]=[]);var t={},i;for(i in d.sources)if("string"==typeof i){p=[];var h=d.sources[i].stride,q=d.sources[i].count,b=d.sources[i].values;switch(d.sources[i].format){case "ST":case "UV":for(var s=0;s<q;++s)p.push.apply(p,[parseFloat(b[s*h]),parseFloat(b[s*h+1])]);break;case "XYZ":case "RGB":for(s=0;s<q;++s)p.push.apply(p,[parseFloat(b[s*h]),parseFloat(b[s*h+1]),parseFloat(b[s*h+2])]);break;case "XYZW":for(s=0;s<q;++s)p.push.apply(p,
[parseFloat(b[s*h]),parseFloat(b[s*h+1]),parseFloat(b[s*h+2]),parseFloat(b[s*h+3])]);break;default:y.Log("ThreeDObjectHandler Warning: Unhandled format string: default single buffer selected");case "C":p=b}t[i]=p}p=[];h=0;q=Object.keys(d.triangles);for(b=q.length;h<b;++h)i=q[h],m=new f.BufferGeometry,this.set("_geometrycounter",this.get("_geometrycounter")+1),s=d.triangles[i],m.coincidentmeshID=n,m.coincidentgroup=s.hasOwnProperty("coincident-group")?parseFloat(s["coincident-group"]):0,m.coincidentpriority=
s.hasOwnProperty("coincident-priority")?parseFloat(s["coincident-priority"]):0,m.coincidentgrouptag=s.hasOwnProperty("coincident-group-tag")?s["coincident-group-tag"]:"tris-same",this.get("_build_mesh_execution_queue").run(this.CreateMeshFaces(m,t,s),this,!1,null,null,!0),m.adjacentfacesedgeslines=new f.Geometry,this.get("_build_mesh_execution_queue").run(this.CreateMeshHardEdges(m,t,s,k),this,!1,null,null,!0),p[i]=m;j[n]=p;break;default:y.Log("ThreeDObjectHandler Warning: Unrecognized type of geometry - Accepted: Cuboid, Mesh")}i=
!0;switch(e){case "highlightnode":switch(c){case "Cuboid":g.add(new f.LineSegments(m.adjacentfacesedgeslines,a.highlight));break;case "Mesh":l=0;d=Object.keys(p);for(c=d.length;l<c;++l)i=d[l],g.add(new f.LineSegments(p[i].adjacentfacesedgeslines,a.highlight));break;default:y.Log("ThreeDObjectHandler Warning: Unrecognized type of geometry - Accepted: Cuboid, Mesh")}i=!0;break;default:switch(c){case "Cuboid":var w;if(d.hasOwnProperty("surfaceID")&&o.hasOwnProperty(d.surfaceID)){i=d.surfaceID;d=o[i].front;
j=1>d.opacity||d.transp_texture;r.SetNonEmptyScene(j);if(d.mat.untextured_mat[e]){d.boundmeshlist||(d.boundmeshlist={});d.boundmeshlist.hasOwnProperty(e)||(d.boundmeshlist[e]={});d.boundmeshlist[e].hasOwnProperty("front_mat")||(d.boundmeshlist[e].front_mat={});j=d.mat.untextured_mat[e];k=0;p=Object.keys(j);for(t=p.length;k<t;k++)h=p[k],w=j[p[h]],d.mat.textured_mat.hasOwnProperty(e)||(d.mat.textured_mat[e]={}),d.mat.textured_mat[e].hasOwnProperty(h)||(d.mat.textured_mat[e][h]={}),d.mat.textured_mat[e][h].hasOwnProperty(i)||
(d.mat.textured_mat[e][h][i]=w),d.boundmeshlist[e].front_mat.hasOwnProperty(h)||(d.boundmeshlist[e].front_mat[h]={}),d.boundmeshlist[e].front_mat[h].hasOwnProperty(i)||(d.boundmeshlist[e].front_mat[h][i]=[]),w=new f.Mesh(m,w),d.boundmeshlist[e].front_mat[h][i].push(w),g.add(w)}i=!0}else w=new f.Mesh(m,a.default_material),g.add(w),r.SetNonEmptyScene(!1),i=!1;break;case "Mesh":m=!1;n=this.OrderRenderList(p,l,o,r);l=0;d=Object.keys(n);for(c=d.length;l<c;++l)if(i=n[l].surfaceID,q=n[l].geometry,b=n[l].material,
o.hasOwnProperty(i))if(s=b.side==f.BackSide?"back_mat":"front_mat",d=b.side==f.BackSide?o[i].back:o[i].front){if(j=1>d.opacity||d.transp_texture,(!b.transparencylayer||j)&&d.mat.untextured_mat[e]){j=d.mat.untextured_mat[e];k=0;p=Object.keys(j);for(t=p.length;k<t;k++)h=p[k],w=j[h],b.side==f.BackSide&&o[i].sharedmaterial&&w.side==f.FrontSide||(v=new f.ShaderMaterial,v.copy(w),v.side=b.side,d.mat.textured_mat.hasOwnProperty(e)||(d.mat.textured_mat[e]={}),d.mat.textured_mat[e].hasOwnProperty(h)||(d.mat.textured_mat[e][h]=
{}),d.mat.textured_mat[e][h].hasOwnProperty(i)||(d.mat.textured_mat[e][h][i]=v),d.boundmeshlist||(d.boundmeshlist={}),d.boundmeshlist.hasOwnProperty(e)||(d.boundmeshlist[e]={}),d.boundmeshlist[e].hasOwnProperty(s)||(d.boundmeshlist[e][s]={}),d.boundmeshlist[e][s].hasOwnProperty(h)||(d.boundmeshlist[e][s][h]={}),d.boundmeshlist[e][s][h].hasOwnProperty(i)||(d.boundmeshlist[e][s][h][i]=[]),w=new f.Mesh(q,v),d.boundmeshlist[e][s][h][i].push(w),g.add(w))}}else y.Log("ThreeDObjectHandler Warning: No front material found for this surface");
else w=new f.Mesh(q,a.default_material),g.add(w),r.SetNonEmptyScene(!1),m=!0;i=!m;break;default:y.Log("ThreeDObjectHandler Warning: Unrecognized type of geometry - Only accepted: Cuboid, Mesh"),i=!0}}return i},OrderRenderList:function(c,f,e,g){for(var d=[],j=[],a=Object.keys(c),o=a.length-1;-1!==o;o--){j.push({surfaceID:a[o],geometry:c[a[o]]});var k=!1;if(e.hasOwnProperty(a[o]))var k=e[a[o]].front,l=e[a[o]].back,l=1>l.opacity||l.transp_texture,k=1>k.opacity||k.transp_texture||l;g.SetNonEmptyScene(k)}j.sort(this.CompareSurfacesInGlueGroup(!0));
c=this.splitSingleSurfaces(j);void 0===f&&(j=this.DuplicateSurfaceForFrontAndBack(c.singles),Array.prototype.push.apply(d,j.ungrouped),Array.prototype.push.apply(d,j.front),Array.prototype.push.apply(d,j.back));e=this.FilterRenderList(c.sorted,f,e,g);e=this.DuplicateSurfaceForFrontAndBack(e);e.front.sort(this.CompareSurfacesInGlueGroup(!0));e.back.sort(this.CompareSurfacesInGlueGroup(!1));void 0===f&&Array.prototype.push.apply(d,e.ungrouped);this.tagInnerSurfaces(e.front,!1);e.back.reverse();this.tagInnerSurfaces(e.back,
!0);e.back.reverse();Array.prototype.push.apply(d,e.back);Array.prototype.push.apply(d,e.front);return d},DuplicateSurfaceForFrontAndBack:function(c){for(var n=[],e=[],g=[],d=Object.keys(c),j=d.length-1;-1!==j;j--){var a=c[d[j]].geometry;if(a.hasOwnProperty(["coincidentgroup"])&&a.hasOwnProperty(["coincidentpriority"])&&a.hasOwnProperty(["coincidentgrouptag"])&&0<=a.coincidentgroup&&0!==a.coincidentpriority){var o=a.coincidentpriority,k={surfaceID:c[d[j]].surfaceID,geometry:a,material:{transparencylayer:!1,
coincidentsurface:!0,fromARD:!1,side:0<o?f.FrontSide:f.BackSide}},l={surfaceID:c[d[j]].surfaceID,geometry:a,material:{transparencylayer:!1,coincidentsurface:!0,fromARD:!1,side:0<o?f.BackSide:f.FrontSide}};switch(a.coincidentgrouptag){case "planar":0<o?n.unshift(k):e.unshift(l);break;default:case "tris-same":case "shape-same":n.unshift(k),e.unshift(l)}}else k={surfaceID:c[d[j]].surfaceID,geometry:a,material:{transparencylayer:!1,coincidentsurface:!1,fromARD:!1,side:f.FrontSide}},l={surfaceID:c[d[j]].surfaceID,
geometry:a,material:{transparencylayer:!1,coincidentsurface:!1,fromARD:!1,side:f.BackSide}},g.push(k),g.unshift(l)}return{front:n,back:e,ungrouped:g}},FilterRenderList:function(c,f,e,g){for(var d=[],j=Object.keys(c),a=j.length-1;-1!==a;a--){var o=c[j[a]].surfaceID;if(e.hasOwnProperty(o)){var k=e[o].front,o=e[o].back,o=1>o.opacity||o.transp_texture,k=1>k.opacity||k.transp_texture||o,o=!1,l=c[j[a]].geometry;if(l.hasOwnProperty(["coincidentgroup"])&&l.hasOwnProperty(["coincidentpriority"])&&l.hasOwnProperty(["coincidentgrouptag"])&&
0<=l.coincidentgroup&&0!==l.coincidentpriority)switch(l.coincidentgrouptag){case "planar":o=!0;break;default:case "tris-same":case "shape-same":o=!1}void 0===f?(o||k)&&l.hasOwnProperty("coincidentgroup")&&0<=l.coincidentgroup&&0!==l.coincidentpriority?g.CreateNewCoincidentGroupPass(l.coincidentgroup,k):d.push(c[a]):(o||k)&&(l.hasOwnProperty("coincidentgroup")&&0<=l.coincidentgroup&&0!==l.coincidentpriority&&f==l.coincidentgroup)&&d.push(c[a])}else y.Log("ThreeDObjectHandler Warning: Surface '"+o+
"' not found in material map"),d.push(c[a])}return d},CompareSurfacesInGlueGroup:function(c){return function(f,e){return parseFloat(f.geometry.coincidentgroup)!=parseFloat(e.geometry.coincidentgroup)?0>parseFloat(f.geometry.coincidentgroup)&&0>parseFloat(e.geometry.coincidentgroup)?!1:parseFloat(f.geometry.coincidentgroup)-parseFloat(e.geometry.coincidentgroup):c?Math.abs(f.geometry.coincidentpriority)-Math.abs(e.geometry.coincidentpriority):Math.abs(e.geometry.coincidentpriority)-Math.abs(f.geometry.coincidentpriority)}},
splitSingleSurfaces:function(c){var f=[],e=[],g=Object.keys(c);if(0!=g.length)if(1==g.length)f=c;else for(var d=0;d!==g.length;d++){var j=!c[g[d]].geometry.hasOwnProperty("coincidentgroup");if(!j){var a=c[g[d]].geometry.coincidentgroup;if(0==d){var o=c[g[d+1]].geometry.coincidentgroup;a!=o&&(j=!0)}else if(d==g.length-1){var k=c[g[d-1]].geometry.coincidentgroup;a!=k&&(j=!0)}else o=c[g[d+1]].geometry.coincidentgroup,k=c[g[d-1]].geometry.coincidentgroup,a!=k&&a!=o&&(j=!0)}j?f.push(c[g[d]]):e.push(c[g[d]])}return{singles:f,
sorted:e}},tagInnerSurfaces:function(c,f){var e,g,d,j,a,o,k,l;e=g="-1";if(f)for(a=0;a<c.length;){o=c[a];k=o.geometry.coincidentgroup;l=o.geometry.coincidentpriority;switch(o.geometry.coincidentgrouptag){case "planar":r=!0;break;default:case "tris-same":case "shape-same":r=!1}0>l?(k!=g?j=l:l<j&&(o.material.transparencylayer=!r),g=k):o.material.transparencylayer=!r;o.material.fromARD=r;a++}else for(a=c.length-1;0<=a;){o=c[a];k=o.geometry.coincidentgroup;l=o.geometry.coincidentpriority;var r;switch(o.geometry.coincidentgrouptag){case "planar":r=
!0;break;default:case "tris-same":case "shape-same":r=!1}0<l?(k!=e?d=l:l<d&&(o.material.transparencylayer=!r),e=k):o.material.transparencylayer=!r;o.material.fromARD=r;a--}}})});