/**
 * @author DOGO, PHST
 * @module WebViewer3D
 * @copyright   2014 Esko Stonecube Ltd. All rights reserved.
 */

define("backbone underscore WV3Dlib/three WV3Dmod/threeEXT WV3Dmod/Math WV3Dmod/SystemChecker WV3Dmod/HttpRequestHandler WV3Dmod/ThreeDObjectHandler WV3Dmod/TextSpriteMaker WV3Dmod/shaders/OutlineShader WV3Dmod/shaders/ShaderUtils WV3Dmod/shaders/D0Shader WV3Dmod/shaders/D1Shader WV3Dmod/shaders/D2Shader WV3Dmod/shaders/DepthOnlyShader WV3Dmod/shaders/BackdropShader WV3Dmod/shaders/ColorBlendShader WV3Dmod/shaders/TransparencyBlendShader WV3Dmod/shaders/CopyShader WV3Dmod/shaders/DesignerShader WV3Dmod/shaders/FilterShaderPM WV3Dmod/shaders/FilterShaderNPM WV3Dmod/shaders/ReflectanceShaderPM WV3Dmod/shaders/ReflectanceShaderNPM WV3Dmod/shaders/IrradianceShaderPM WV3Dmod/shaders/IrradianceShaderNPM WV3Dmod/shaders/DiffractionShaderPM WV3Dmod/Constants WV3Dmod/Utils WV3Dmod/FPSCounter WV3Dmod/Timers WV3Dmod/ExecutionQueue WV3Dmod/LogMessage".split(" "),
function(ca,G,d,da,z,C,ea,fa,ga,N,ia,H,O,P,Q,R,S,T,U,V,W,X,I,J,Y,Z,$,M,v,aa,ba,ha,o){return ca.Model.extend({initialize:function(a,b,c){o.Log("Creating WV3DViewerView Object");this.set("_context",a);this.set("_model",b);this.set("_clientUIAddElementCallback",c);a={alpha:!0,antialias:C.get("_glantialias"),preserveDrawingBuffer:!0};new da;this.set("_3JSrenderer",new d.WebGLRenderer(a));this.get("_3JSrenderer").sortObjects=!1;this.InitializeRenderTargets();this.set("_textSpriteMaker",new ga);this.set("_resourcePath",
"../Resources");this.set("_current_fps",0);this.set("_target_fps_min",25);this.set("_target_fps_max",60);this.set("_nb_max_peels",7);this.set("_nb_min_peels",2);this.set("_reflection_config","JSON");this.set("_enableInteractionOptimization",!1);this.set("_enableAnimations",!1);this.set("_lighting_contrast",0.5);this.set("_optimised_view",!1);this.set("_optimised_view_border",0);this.set("_obj_in_frustum_prev",!0);this.set("_obj_in_frustum",!0);this.set("_build_scene_exec_queue",new ha(!1,!1,G.bind(this.NotifySceneBuildProgress,
this)));a=new Image(2,2);a.src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAIAAAACCAIAAAD91JpzAAAACXBIWXMAAAsTAAALEwEAmpwYAAAAB3RJTUUH4AUMDiIqLjEjFgAAAAtJREFUCNdjYEAGAAAOAAEx6d0VAAAAAElFTkSuQmCC";var j=new d.Texture(a),e=new d.CubeTexture([a,a,a,a,a,a]);a.onload=function(){j.needsUpdate=!0;e.needsUpdate=!0;o.Log("Dummy texture loaded")};this.set("_DummyTexture",j);this.set("_DummyTextureCube",e);this.ResetScene();this.CameraUpdate(!1);this.listenTo(this.get("_model"),"scene_reset",this.ResetScene);
this.listenTo(this.get("_model"),"added_scene_resource",this.AddedResource);window.addEventListener("resize",G.bind(this.Resize,this),!1);this.Resize();this.SetBackgroundColor(0.37,0.37,0.37,1,!1);this.AppendRendererToDocument()},NotifySceneBuildProgress:function(a,b,c){"function"===typeof this.get("_model").get("_clientCallback")?(0==this.get("_model").get("_assetmanager").get("_textureCounter")&&(b=100),void 0===b&&(b=100*(this.get("_model").get("_assetmanager").get("_textureLoadedCounter")/this.get("_model").get("_assetmanager").get("_textureCounter"))),
void 0===c&&(c=0),this.get("_model").get("_clientCallback")(c,a,b,this.get("_model").get("_assetmanager").get("_assetloader").get("_httprequestmanager").get("_queriedassetnumber"),this.get("_model").get("_assetmanager").get("_resolvedassetnumber"))):o.Log("ViewerView Warning: Client callback not a function")},SetDefaultResourceRelativePath:function(a){this.set("_resourcePath",a)},ReleaseRenderTarget:function(a){a&&a.dispose()},ReleaseDummyTextures:function(){this.ReleaseRenderTarget(this.get("_DummyTexture"));
this.ReleaseRenderTarget(this.get("_DummyTextureCube"))},ReleaseAllRenderTargets:function(){this.ReleaseRenderTarget(this.get("_OpaqueDepthRT"));this.ReleaseRenderTarget(this.get("_D1RT"));this.ReleaseRenderTarget(this.get("_D2RT"));this.ReleaseRenderTarget(this.get("_ColorStackRT"));this.ReleaseRenderTarget(this.get("_PeelColorRT"));this.ReleaseRenderTarget(this.get("_TransparencyStackRT"));this.ReleaseRenderTarget(this.get("_OpaqueBackgroundMaskRT"));this.ReleaseRenderTarget(this.get("_MirrorOpaqueDepthRT"));
this.ReleaseRenderTarget(this.get("_MirrorColorStackRT"));this.ReleaseRenderTarget(this.get("_MirrorColorStackRT2"));this.ReleaseRenderTarget(this.get("_MirrorPeelColorRT"));this.ReleaseRenderTarget(this.get("_MirrorTransparencyStackRT"));this.ReleaseRenderTarget(this.get("_FadedMirrorTransparencyStackRT"));this.ReleaseRenderTarget(this.get("_MirrorOpaqueBackgroundMaskRT"))},InitializeRenderTargets:function(a,b){var c=a?a:this.get("_context").clientWidth,j=b?b:this.get("_context").clientHeight,e,
g;this.ReleaseAllRenderTargets();C.get("_fullSupportFloatingPointTextures")?(e={minFilter:d.LinearFilter,format:d.RGBAFormat,type:d.FloatType},g={minFilter:d.LinearFilter,format:d.RGBAFormat},this.set("_OpaqueDepthRT",new d.WebGLRenderTarget(c,j,e)),this.set("_D1RT",new d.WebGLRenderTarget(c,j,e)),this.set("_D2RT",new d.WebGLRenderTarget(c,j,e)),this.set("_ColorStackRT",new d.WebGLRenderTarget(c,j,g)),this.set("_PeelColorRT",new d.WebGLRenderTarget(c,j,g)),this.set("_TransparencyStackRT",new d.WebGLRenderTarget(c,
j,g)),this.set("_OpaqueBackgroundMaskRT",new d.WebGLRenderTarget(c,j,g)),this.set("_MirrorOpaqueDepthRT",new d.WebGLRenderTarget(c,j,e)),this.set("_MirrorColorStackRT",new d.WebGLRenderTarget(c,j,g)),this.set("_MirrorColorStackRT2",new d.WebGLRenderTarget(c,j,g)),this.set("_MirrorPeelColorRT",new d.WebGLRenderTarget(c,j,g)),this.set("_MirrorTransparencyStackRT",new d.WebGLRenderTarget(c,j,g)),this.set("_FadedMirrorTransparencyStackRT",new d.WebGLRenderTarget(c,j,g)),this.set("_MirrorOpaqueBackgroundMaskRT",
new d.WebGLRenderTarget(c,j,g))):C.get("_fullSupportHFloatingPointTextures")?(e={minFilter:d.LinearFilter,magFilter:d.NearestFilter,format:d.RGBAFormat,type:d.HalfFloatType},g={minFilter:d.LinearFilter,magFilter:d.NearestFilter,format:d.RGBAFormat},this.set("_OpaqueDepthRT",new d.WebGLRenderTarget(c,j,e)),this.set("_D1RT",new d.WebGLRenderTarget(c,j,e)),this.set("_D2RT",new d.WebGLRenderTarget(c,j,e)),this.set("_ColorStackRT",new d.WebGLRenderTarget(c,j,g)),this.set("_PeelColorRT",new d.WebGLRenderTarget(c,
j,g)),this.set("_TransparencyStackRT",new d.WebGLRenderTarget(c,j,g)),this.set("_OpaqueBackgroundMaskRT",new d.WebGLRenderTarget(c,j,g)),this.set("_MirrorOpaqueDepthRT",new d.WebGLRenderTarget(c,j,e)),this.set("_MirrorColorStackRT",new d.WebGLRenderTarget(c,j,g)),this.set("_MirrorColorStackRT2",new d.WebGLRenderTarget(c,j,g)),this.set("_MirrorPeelColorRT",new d.WebGLRenderTarget(c,j,g)),this.set("_MirrorTransparencyStackRT",new d.WebGLRenderTarget(c,j,g)),this.set("_FadedMirrorTransparencyStackRT",
new d.WebGLRenderTarget(c,j,g)),this.set("_MirrorOpaqueBackgroundMaskRT",new d.WebGLRenderTarget(c,j,g))):(g={minFilter:d.LinearFilter,magFilter:d.NearestFilter,format:d.RGBAFormat},this.set("_ColorStackRT",new d.WebGLRenderTarget(c,j,g)),this.set("_PeelColorRT",new d.WebGLRenderTarget(c,j,g)))},ResetOutlineShaders:function(){var a=this.get("_renderercache").materials.defaultcolor,b=d.UniformsUtils.clone(N.uniforms);b.color.value=new d.Vector3(a[0]/255,a[1]/255,a[2]/255);b.D0RT.value=this.get("_DummyTexture");
this.get("_renderercache").materials.outline||(a=this.get("_renderercache").materials.outlinethickness,b.offset.value=Math.max(0.001*this.get("_3JSsceneBBoxFocus").size().length(),0.001*this.get("_3JSsceneBBoxFocus").center().clone().sub(this.get("_3JScamera").position).length()*a),b=new d.ShaderMaterial({uniforms:b,vertexShader:N.vertexShader,fragmentShader:N.fragmentShader,side:d.BackSide,polygonOffset:!0,polygonOffsetFactor:1,polygonOffsetUnits:0.5,defines:!this.get("_emptyTransparentScene")?{USE_DEPTH_TEXTURE:""}:
{}}),this.get("_renderercache").materials.outline=b)},ResetShaders:function(){if(!this.get("_renderercache").materials.D0ShaderMaterial){var a=d.UniformsUtils.clone(H.uniforms),a=new d.ShaderMaterial({uniforms:a,vertexShader:H.vertexShader,fragmentShader:H.fragmentShader,side:d.DoubleSide,depthWrite:!0,transparent:!1,name:"D0ShaderMaterial"});this.get("_renderercache").materials.D0ShaderMaterial=a}this.get("_renderercache").materials.D1ShaderMaterial||(a=d.UniformsUtils.clone(O.uniforms),a.D0RT.value=
this.get("_DummyTexture"),a=new d.ShaderMaterial({uniforms:a,vertexShader:O.vertexShader,fragmentShader:O.fragmentShader,side:d.DoubleSide,depthWrite:!0,transparent:!1,name:"D1ShaderMaterial"}),this.get("_renderercache").materials.D1ShaderMaterial=a);this.get("_renderercache").materials.D2ShaderMaterial||(a=d.UniformsUtils.clone(P.uniforms),a.DX1RT.value=this.get("_DummyTexture"),a.DX2RT.value=this.get("_DummyTexture"),a=new d.ShaderMaterial({uniforms:a,vertexShader:P.vertexShader,fragmentShader:P.fragmentShader,
side:d.DoubleSide,depthWrite:!0,transparent:!1,name:"D2ShaderMaterial"}),this.get("_renderercache").materials.D2ShaderMaterial=a);this.get("_renderercache").materials.DepthOnlyShaderMaterial||(a=d.UniformsUtils.clone(Q.uniforms),a.DX1RT.value=this.get("_DummyTexture"),a.DX2RT.value=this.get("_DummyTexture"),a=new d.ShaderMaterial({uniforms:a,vertexShader:Q.vertexShader,fragmentShader:Q.fragmentShader,side:d.DoubleSide,depthWrite:!0,colorWrite:!1,transparent:!1,name:"DepthOnlyShaderMaterial"}),this.get("_renderercache").materials.DepthOnlyShaderMaterial=
a);this.get("_renderercache").materials.BackdropShaderMaterial||(a=d.UniformsUtils.clone(R.uniforms),a.backdrop.value=this.get("_DummyTexture"),a.reflection.value=this.get("_DummyTexture"),a=new d.ShaderMaterial({uniforms:a,vertexShader:R.vertexShader,fragmentShader:R.fragmentShader,side:d.FrontSide,depthWrite:!1,transparent:!1,name:"BackdropShaderMaterial"}),this.get("_renderercache").materials.BackdropShaderMaterial=a);this.get("_renderercache").materials.ColorBlendShaderMaterial||(a=d.UniformsUtils.clone(S.uniforms),
a.CX1RT.value=this.get("_DummyTexture"),a.TransparencyStack.value=this.get("_DummyTexture"),a.OpaqueRT.value=this.get("_DummyTexture"),a.ColorStackRT.value=this.get("_DummyTexture"),a=new d.ShaderMaterial({uniforms:a,vertexShader:S.vertexShader,fragmentShader:S.fragmentShader,side:d.FrontSide,depthWrite:!0,transparent:!0,blending:d.AdditiveBlending,name:"ColorBlendShaderMaterial"}),this.get("_renderercache").materials.ColorBlendShaderMaterial=a);this.get("_renderercache").materials.CopyShaderMaterial||
(a=d.UniformsUtils.clone(U.uniforms),a.CXRT.value=this.get("_DummyTexture"),a.OpaqueRT.value=this.get("_DummyTexture"),a=new d.ShaderMaterial({uniforms:a,vertexShader:U.vertexShader,fragmentShader:U.fragmentShader,side:d.FrontSide,depthWrite:!0,transparent:!1,blending:d.AdditiveBlending,name:"CopyShaderMaterial"}),this.get("_renderercache").materials.CopyShaderMaterial=a)},ApplyFctToMaterialStruct:function(a,b){for(var c=0,d=Object.keys(a.mat.untextured_mat),e=d.length;c<e;++c)for(var g=a.mat.untextured_mat[d[c]],
h=0,f=Object.keys(g),k=f.length;h<k;++h){var l=g[f[h]];b(l);l.needsUpdate=!0}c=0;d=Object.keys(a.mat.textured_mat);for(e=d.length;c<e;++c){g=a.mat.textured_mat[d[c]];h=0;f=Object.keys(g);for(k=f.length;h<k;++h)for(var n=g[f[h]],q=0,m=Object.keys(n),r=m.length;q<r;++q)l=n[m[q]],b(l),l.needsUpdate=!0}},ApplyFctToAllMaterials:function(a){a(this.get("_renderercache").materials.default_material);this.get("_renderercache").materials.default_material.needsUpdate=!0;for(var b=0,c=Object.keys(this.get("_renderercache").materials.materiallist),
d=c.length;b<d;++b){var e=this.get("_renderercache").materials.materiallist[c[b]];this.ApplyFctToMaterialStruct(e.front,a);this.ApplyFctToMaterialStruct(e.back,a)}},ReleaseMaterial:function(a,b){if(a&&(a.dispose(),a.uniforms))for(var c=0,j=Object.keys(a.uniforms),e=j.length;c<e;++c){var g=a.uniforms[j[c]];g.value&&"function"===typeof g.value.dispose&&(void 0===b||b||!(g.value instanceof d.Texture))&&g.value.dispose()}},ReleaseMaterialsAndTextures:function(a){if(a){var b=a.boundmeshlist;if(b){0==Object.keys(b).length&&
o.Log("ViewerView Warning: No meshes to update");for(var c=0,d=Object.keys(b),e=d.length;c<e;++c){var g=d[c];0==Object.keys(b[g]).length&&o.Log("ViewerView Warning: No render passes to update");for(var h=0,f=Object.keys(b[g]),k=f.length;h<k;++h){for(var l=f[h],n=0,q=Object.keys(b[g][l]),m=q.length;n<m;n++){var r=q[n];this.ReleaseMaterial(a.mat.untextured_mat[g][r]);0==Object.keys(b[g][l][r]).length&&o.Log("ViewerView Warning: No sided materials to update");for(var p=0,t=Object.keys(b[g][l][r]),x=
t.length;p<x;++p){var s=t[p];this.ReleaseMaterial(a.mat.textured_mat[g][r][s]);delete a.mat.textured_mat[g][r][s];delete b[g][l][r][s]}delete b[g][l][r]}delete b[g][l];delete b[g]}}delete a.boundmeshlist}else o.Log("ViewerView Warning: No meshes to update");a.diff_texture&&a.diff_texture.dispose();a.spec_texture&&a.spec_texture.dispose();a.int_spec_texture&&a.int_spec_texture.dispose();a.normal_chan0_texture&&a.normal_chan0_texture.dispose();a.normal_chan1_texture&&a.normal_chan1_texture.dispose();
a.diff_grating_texture&&a.diff_grating_texture.dispose();a.diff_grating_filter_texture&&a.diff_grating_filter_texture.dispose()}},ReleaseAllMaterialsAndTextures:function(){if(this.get("_renderercache")){this.ReleaseMaterial(this.get("_renderercache").materials.default_material);this.ReleaseMaterial(this.get("_renderercache").materials.highlight);this.ReleaseMaterial(this.get("_renderercache").materials.outline);this.ReleaseMaterial(this.get("_renderercache").materials.D0ShaderMaterial);this.ReleaseMaterial(this.get("_renderercache").materials.D1ShaderMaterial);
this.ReleaseMaterial(this.get("_renderercache").materials.D2ShaderMaterial);this.ReleaseMaterial(this.get("_renderercache").materials.BackdropShaderMaterial);this.ReleaseMaterial(this.get("_renderercache").materials.ColorBlendShaderMaterial);this.ReleaseMaterial(this.get("_renderercache").materials.CopyShaderMaterial);for(var a=0,b=Object.keys(this.get("_renderercache").materials.materiallist),c=b.length;a<c;++a){var d=this.get("_renderercache").materials.materiallist[b[a]];this.ReleaseMaterialsAndTextures(d.front);
this.ReleaseMaterialsAndTextures(d.back)}this.get("_renderercache").textures.Designer.irradiancemap.data&&this.get("_renderercache").textures.Designer.irradiancemap.data.dispose();this.get("_renderercache").textures.Designer.envmap.glossy.data&&this.get("_renderercache").textures.Designer.envmap.glossy.data.dispose();this.get("_renderercache").textures.Designer.envmap.matte.data&&this.get("_renderercache").textures.Designer.envmap.matte.data.dispose();this.get("_renderercache").textures.Visualizer.irradiancemap.data&&
this.get("_renderercache").textures.Visualizer.irradiancemap.data.dispose();if(this.get("_renderercache").textures.Visualizer.envmap.data)for(a=0;a<this.get("_renderercache").textures.Visualizer.envmap.data.length;a++)this.get("_renderercache").textures.Visualizer.envmap.data[a]&&this.get("_renderercache").textures.Visualizer.envmap.data[a].dispose();this.get("_renderercache").textures.Visualizer.spectrum.data&&this.get("_renderercache").textures.Visualizer.spectrum.data.dispose()}},ReleaseGeomMatTex:function(a){if(a){var b=
this;a.traverse(function(a){a instanceof d.Mesh&&a.geometry&&(a.geometry.dispose(),b.ReleaseMaterial(a.material))})}},ReleaseSGGeometriesAndMaterials:function(){this.ReleaseGeomMatTex(this.get("_3JSsceneOp"));this.ReleaseGeomMatTex(this.get("_3JSsceneOpDepth"));this.ReleaseGeomMatTex(this.get("_3JSsceneOpaqueDiffuse"));this.ReleaseGeomMatTex(this.get("_3JSsceneTransp"));this.ReleaseGeomMatTex(this.get("_3JSsceneTranspDepth"));this.ReleaseGeomMatTex(this.get("_3JSsceneTranspDiffuse"));this.ReleaseGeomMatTex(this.get("_3JSsceneHightlights"));
this.ReleaseGeomMatTex(this.get("_3JSsceneLabels"));this.ReleaseGeomMatTex(this.get("_3JSsceneDimensions"));this.ReleaseGeomMatTex(this.get("_3JSsceneAnnotations"));this.ReleaseGeomMatTex(this.get("_3JSlabelsBBox"));this.ReleaseGeomMatTex(this.get("_3JSdimensionsBBox"))},ReleaseThreejsnodesReferences:function(){if(this.get("_renderercache")&&this.get("_renderercache").hasOwnProperty("nodeviewproperties"))for(var a=this.get("_renderercache").nodeviewproperties,b=0,c=Object.keys(a),d=c.length;b<d;b++){for(var e=
a[c[b]].threejsnodes,g=0,h=Object.keys(e),f=h.length;g<f;g++){for(var k=0,l=e[h[g]],n=l.length;k<n;k++)delete e[h[g]][l[k]];delete e[h[g]]}delete a[c[b]].threejsnodes;delete a[c[b]]}},ReleaseScene:function(){this.ReleaseAllMaterialsAndTextures();this.ReleaseSGGeometriesAndMaterials();this.ReleaseThreejsnodesReferences();d.Cache.clear();this.set("_3JSsceneOp",null);this.set("_3JSsceneOpDepth",null);this.set("_3JSsceneOpaqueDiffuse",null);this.set("_3JSsceneTransp",null);this.set("_3JSsceneTranspDepth",
null);this.set("_3JSsceneTranspDiffuse",null);this.set("_3JSsceneHightlights",null);this.set("_3JSsceneLabels",null);this.set("_3JSsceneDimensions",null);this.set("_3JSsceneAnnotations",null);this.set("_3JSsceneBBox",null);this.set("_3JSsceneBBoxFocus",null);this.set("_3JSlabelsBBox",null);this.set("_3JSdimensionsBBox",null);this.set("_nodecounter",0);this.set("_geometrycounter",0);this.set("_renderercache",null);this.set("_emptyTransparentScene",!0);this.set("_emptyOpaqueScene",!0);this.set("_3JSsceneOpCoincidentGroupsIds",
{});this.set("_3JSsceneOpCoincidentGroupsPasses",[]);this.set("_3JSsceneNbOpCoincidentGroups",0);this.set("_3JSsceneTranspCoincidentGroupsIds",{});this.set("_3JSsceneTranspCoincidentGroupsPasses",[]);this.set("_3JSsceneNbTranspCoincidentGroups",0)},ResetScene:function(a){this.ReleaseScene();this.set("_3JSsceneOp",new d.Scene);this.set("_3JSsceneOpCoincidentGroups",{});this.set("_3JSsceneOpDepth",new d.Scene);this.set("_3JSsceneOpCoincidentGroupsDepth",[]);this.set("_3JSsceneOpaqueDiffuse",new d.Scene);
this.set("_3JSsceneOpCoincidentGroupsDiffuse",[]);this.set("_3JSsceneTransp",new d.Scene);this.set("_3JSsceneTranspCoincidentGroups",{});this.set("_3JSsceneTranspDepth",new d.Scene);this.set("_3JSsceneTranspCoincidentGroupsDepth",[]);this.set("_3JSsceneTranspDiffuse",new d.Scene);this.set("_3JSsceneTranspCoincidentGroupsDiffuse",[]);this.set("_3JSsceneHightlights",new d.Scene);this.set("_3JSsceneLabels",new d.Scene);this.set("_3JSsceneDimensions",new d.Scene);this.set("_3JSsceneAnnotations",new d.Scene);
this.get("_3JSsceneAnnotations").add(this.get("_3JSsceneLabels"),this.get("_3JSsceneDimensions"));this.set("_3JSsceneBBox",new d.Box3);this.set("_3JSsceneBBoxFocus",new d.Box3);this.set("_3JSlabelsBBox",new d.BoundingBoxHelper(this.get("_3JSsceneLabels"),16711680));this.set("_3JSdimensionsBBox",new d.BoundingBoxHelper(this.get("_3JSsceneDimensions"),65280));this.set("_renderercache",{nodeviewproperties:{},annotationsproperties:{labelsproperties:{visible:!0,parameters:{}},dimensionsproperties:{visible:!0,
parameters:{}}},coplanarityepsilon:void 0!==a?a:0.2,geometries:[],materials:{outlinethickness:1,enablehighlights:!1,enablehorizonhighlights:!0,enablehardedgehighlights:!0,enableirradiancemap:!0,enableenvmap:!0,defaultcolor:[30,30,30],default_material:{},materiallist:{},shaders:{}},textures:{Designer:{path:"lighting_environments/designer_quality/",irradiancemap:{files:"irr_map_right.PNG irr_map_left.PNG irr_map_top.PNG irr_map_bottom.PNG irr_map_front.PNG irr_map_back.PNG".split(" "),data:null,loaded:!1},
envmap:{glossy:{files:"env_map_glossy_right.PNG env_map_glossy_left.PNG env_map_glossy_top.PNG env_map_glossy_bottom.PNG env_map_glossy_front.PNG env_map_glossy_back.PNG".split(" "),data:null,loaded:!1},matte:{files:"env_map_mate_right.PNG env_map_mate_left.PNG env_map_mate_top.PNG env_map_mate_bottom.PNG env_map_mate_front.PNG env_map_mate_back.PNG".split(" "),data:null,loaded:!1}},backdrop:{loaded:!1,data:null,original_width:null,original_height:null}},Visualizer:{path:"lighting_environments/visualizer_quality/",
irradiancemap:{files:"cubic_irradiance_xpos.jpg cubic_irradiance_xneg.jpg cubic_irradiance_ypos.jpg cubic_irradiance_yneg.jpg cubic_irradiance_zpos.jpg cubic_irradiance_zneg.jpg".split(" "),data:null,loaded:!1},envmap:{files:"cubic_blur_00_xpos.jpg cubic_blur_00_xneg.jpg cubic_blur_00_ypos.jpg cubic_blur_00_yneg.jpg cubic_blur_00_zpos.jpg cubic_blur_00_zneg.jpg cubic_blur_02_xpos.jpg cubic_blur_02_xneg.jpg cubic_blur_02_ypos.jpg cubic_blur_02_yneg.jpg cubic_blur_02_zpos.jpg cubic_blur_02_zneg.jpg cubic_blur_04_xpos.jpg cubic_blur_04_xneg.jpg cubic_blur_04_ypos.jpg cubic_blur_04_yneg.jpg cubic_blur_04_zpos.jpg cubic_blur_04_zneg.jpg cubic_blur_06_xpos.jpg cubic_blur_06_xneg.jpg cubic_blur_06_ypos.jpg cubic_blur_06_yneg.jpg cubic_blur_06_zpos.jpg cubic_blur_06_zneg.jpg cubic_blur_08_xpos.jpg cubic_blur_08_xneg.jpg cubic_blur_08_ypos.jpg cubic_blur_08_yneg.jpg cubic_blur_08_zpos.jpg cubic_blur_08_zneg.jpg".split(" "),
data:null,loaded:!1},spectrum:{file:"spectrum_00.png",data:null,loaded:!1,queried:!1},backdrop:{loaded:!1,data:null,original_width:null,original_height:null}}},cameras:{defaultcamera:{cam_type:"PERSPECTIVE",azimuthAngle:0,elevationAngle:0,fieldOfView:30,scale:1,panOffset:{x:0,y:0}}},view_settings:{mode:1,model_xform:new d.Matrix4},camera_preset:{eye_position:null},environment_settings:{rotation:new d.Quaternion},lights:{},reflections:{enabled:!1,opacity:0.25,fade:!1,fade_size:1.2,fade_position:0.95},
hudelements:[],diagrams:[],viewports:[],animationkeyframes:[]});this.get("_renderercache").materials.default_material=new d.MeshPhongMaterial({color:16777215,specular:0,depthTest:!0,vertexColors:d.FaceColors,side:d.FrontSide});a=this.get("_renderercache").materials.defaultcolor;a=new d.LineBasicMaterial({color:(a[0]<<16)+(a[1]<<8)+a[2],linewidth:1,depthTest:!0});this.get("_renderercache").materials.highlight=a;this.AddDirectionalAndAmbientLightsToScene(this.get("_3JSsceneOp"),"cg_0");this.set("_InitialisedSceneSettings",
!1);this.set("_QueriedGlobalTextures",!1);this.set("_TextureSizeWarningMessageDisplayed",!1);this.set("_TextureSizeByPass",!1);this.set("_SceneLoaded",!1)},AddDirectionalAndAmbientLightsToScene:function(a,b){var c=new d.DirectionalLight(16777215,0.5);a.add(c);this.get("_renderercache").lights.dir_light||(this.get("_renderercache").lights.dir_light={});this.get("_renderercache").lights.dir_light[b]=c;c=new d.AmbientLight(7829367);a.add(c);this.get("_renderercache").lights.amb_light||(this.get("_renderercache").lights.amb_light=
{});this.get("_renderercache").lights.amb_light[b]=c},InitOpaqueCoincidentGroupScene:function(a){this.get("_3JSsceneOpCoincidentGroups").hasOwnProperty(a)||(this.get("_3JSsceneOpCoincidentGroups")[a]=new d.Scene,this.AddDirectionalAndAmbientLightsToScene(this.get("_3JSsceneOpCoincidentGroups")[a],a),this.get("_3JSsceneOpCoincidentGroupsDepth")[a]=new d.Scene,this.get("_3JSsceneOpCoincidentGroupsDiffuse")[a]=new d.Scene)},InitTransparentCoincidentGroupScene:function(a){this.get("_3JSsceneTranspCoincidentGroups").hasOwnProperty(a)||
(this.get("_3JSsceneTranspCoincidentGroups")[a]=new d.Scene,this.AddDirectionalAndAmbientLightsToScene(this.get("_3JSsceneTranspCoincidentGroups")[a],a),this.get("_3JSsceneTranspCoincidentGroupsDepth")[a]=new d.Scene,this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[a]=new d.Scene)},AddedResource:function(){this.ResetShaders();this.SetUpScene();var a=this;this.get("_build_scene_exec_queue").whenFinished(function(){a.ResetOutlineShaders();a.UpdateReflectionUniforms();0==a.get("_model").get("_assetmanager").get("_textureCounter")&&
a.get("_model").get("_assetmanager").get("_assetloader").get("_httprequestmanager").get("_queriedassetnumber")==a.get("_model").get("_assetmanager").get("_resolvedassetnumber")&&a.set("_SceneLoaded",!0);a.Render();a.NotifySceneBuildProgress(100,0,0)})},GetFileList:function(a,b){for(var c=[],d=0,e=Object.keys(b),g=e.length;d<g;++d)c.push(a+b[e[d]]);return c},CheckTextureSizeByPass:function(a){var b=!0;if(a.image.naturalHeight>M.textureSupport.MAX_NATURAL_HEIGHT||a.image.naturalWidth>M.textureSupport.MAX_NATURAL_WIDTH)this.get("_TextureSizeWarningMessageDisplayed")?
b=this.get("_TextureSizeByPass"):(b=window.confirm("WARNING ! Some textures have a size greater than "+M.textureSupport.MAX_NATURAL_WIDTH+"x"+M.textureSupport.MAX_NATURAL_HEIGHT+". This might not be supported by your system and you might experience browser or graphics card crashes."),this.set("_TextureSizeWarningMessageDisplayed",!0),this.set("_TextureSizeByPass",b));return b},StartAsyncTextureLoad:function(a,b,c,j,e,g,h,f,k){if(c.front.hasOwnProperty(j)&&c.front[j]&&b.hasOwnProperty(c.front[j])){var b=
b[c.front[j]],l=b.Properties.hasOwnProperty("remapped_alpha_channel")?v.get("toBool")(b.Properties.remapped_alpha_channel):!1,h=h+b.Properties.filepath,c=d.ImageUtils.loadTexture(h,{},function(b){a.get("_build_scene_exec_queue").whenFinished(function(){var c=a.CheckTextureSizeByPass(b);a.get("_model").get("_assetmanager").set("_textureLoadedCounter",a.get("_model").get("_assetmanager").get("_textureLoadedCounter")+1);var d=100*(a.get("_model").get("_assetmanager").get("_textureLoadedCounter")/a.get("_model").get("_assetmanager").get("_textureCounter"));
a.get("_model").get("_assetmanager").get("_assetloader").get("_httprequestmanager").get("_queriedassetnumber")==a.get("_model").get("_assetmanager").get("_resolvedassetnumber")&&100==d&&a.set("_SceneLoaded",!0);if(c&&g){var j,f;j=f=1;g.hasOwnProperty("originalTexWidth")&&(j=(g.originalTexWidth-1)/b.image.naturalWidth);g.hasOwnProperty("originalTexHeight")&&(f=(g.originalTexHeight-1)/b.image.naturalHeight);b.repeat.set(j,f);b.remappedAlphaChannel=l;g[e]=b;a.UpdateTexturedMaterial(g);a.Render()}a.NotifySceneBuildProgress(100,
d,c?0:1)})},function(){o.Log("ViewerView Warning: Problem loading texture")});c.name=h;c.format=f;c.unpackAlignment=k;c.anisotropy=16;a.get("_model").get("_assetmanager").set("_textureCounter",a.get("_model").get("_assetmanager").get("_textureCounter")+1);a.SelectTextureWrappingMode(c,b.Properties,g);return!0}return!1},StartAsyncGlobalTextureLoad:function(a,b,c){if(a.get("_renderercache").textures[a.get("_RenderingQuality")][b]){var j=function(b){a.get("_model").get("_assetmanager").set("_textureLoadedCounter",
a.get("_model").get("_assetmanager").get("_textureLoadedCounter")+1);var c=100*(a.get("_model").get("_assetmanager").get("_textureLoadedCounter")/a.get("_model").get("_assetmanager").get("_textureCounter"));a.get("_model").get("_assetmanager").get("_assetloader").get("_httprequestmanager").get("_queriedassetnumber")==a.get("_model").get("_assetmanager").get("_resolvedassetnumber")&&100==c&&a.set("_SceneLoaded",!0);a.Render();b=a.CheckTextureSizeByPass(b);a.NotifySceneBuildProgress(100,c,b?0:1)},e=
function(c){a.get("_build_scene_exec_queue").whenFinished(function(){a.get("_renderercache").textures[a.get("_RenderingQuality")][b].loaded=!0;a.UpdateMaterialsGlobalLighting();j(c)})},g=function(b){a.get("_build_scene_exec_queue").whenFinished(function(){a.get("_renderercache").textures[a.get("_RenderingQuality")].envmap.glossy.loaded=!0;a.UpdateMaterialsGlobalLighting();j(b)})},h=function(b){a.get("_build_scene_exec_queue").whenFinished(function(){a.get("_renderercache").textures[a.get("_RenderingQuality")].envmap.matte.loaded=
!0;a.UpdateMaterialsGlobalLighting();j(b)})},f=function(c){a.get("_build_scene_exec_queue").whenFinished(function(){a.get("_renderercache").textures[a.get("_RenderingQuality")][b].loaded=!0;j(c)})},k=function(){o.Log("ViewerView Warning: Problem loading texture")};switch(b){default:o.Log("ViewerView Warning: Unhandled global texture type: default to irradiancemap");case "irradiancemap":h=a.GetFileList(c,a.get("_renderercache").textures[a.get("_RenderingQuality")][b].files);h=d.ImageUtils.loadTextureCube(h,
{},e,k);h.format=d.RGBFormat;a.get("_renderercache").textures[a.get("_RenderingQuality")][b].data=h;a.get("_model").get("_assetmanager").set("_textureCounter",a.get("_model").get("_assetmanager").get("_textureCounter")+1);break;case "envmap":switch(a.get("_RenderingQuality")){case "Designer":e=a.GetFileList(c,a.get("_renderercache").textures[a.get("_RenderingQuality")][b].glossy.files);e=d.ImageUtils.loadTextureCube(e,{},g,k);e.format=d.RGBFormat;a.get("_renderercache").textures[a.get("_RenderingQuality")][b].glossy.data=
e;e=a.GetFileList(c,a.get("_renderercache").textures[a.get("_RenderingQuality")][b].matte.files);h=d.ImageUtils.loadTextureCube(e,{},h,k);h.format=d.RGBFormat;a.get("_renderercache").textures[a.get("_RenderingQuality")][b].matte.data=h;a.get("_model").get("_assetmanager").set("_textureCounter",a.get("_model").get("_assetmanager").get("_textureCounter")+2);break;case "Visualizer":a.get("_renderercache").textures[a.get("_RenderingQuality")][b].data={};a.get("_renderercache").textures[a.get("_RenderingQuality")][b].loaded=
{};h=function(a,e){var f=a.GetFileList(c,a.get("_renderercache").textures[a.get("_RenderingQuality")][b].files.slice(6*e,6*(e+1))),f=d.ImageUtils.loadTextureCube(f,{},function(c){a.get("_build_scene_exec_queue").whenFinished(function(){a.get("_renderercache").textures[a.get("_RenderingQuality")][b].loaded[e]=!0;a.UpdateMaterialsGlobalLighting();j(c)})},k);f.format=d.RGBFormat;a.get("_renderercache").textures[a.get("_RenderingQuality")][b].data[e]=f};for(e=0;5>e;++e)h(a,e);a.get("_model").get("_assetmanager").set("_textureCounter",
a.get("_model").get("_assetmanager").get("_textureCounter")+5)}break;case "spectrum":h=c+a.get("_renderercache").textures[a.get("_RenderingQuality")][b].file;h=d.ImageUtils.loadTexture(h,{},e,k);h.format=d.RGBFormat;a.get("_renderercache").textures[a.get("_RenderingQuality")][b].data=h;a.get("_model").get("_assetmanager").set("_textureCounter",a.get("_model").get("_assetmanager").get("_textureCounter")+1);break;case "backdrop":h=d.ImageUtils.loadTexture(c,{},f,k),h.format=d.RGBFormat,a.get("_renderercache").textures[a.get("_RenderingQuality")][b].data=
h,a.get("_model").get("_assetmanager").set("_textureCounter",a.get("_model").get("_assetmanager").get("_textureCounter")+1)}}},InitializeSceneSettings:function(a){if(!this.get("_InitialisedSceneSettings")){this.set("_RenderingQuality","Designer");this.set("_EnvironmentName","Office");if(a.Properties){if(a.Properties.hasOwnProperty("rendering_quality")&&(C.get("_fullSupportFloatingPointTextures")||C.get("_fullSupportHFloatingPointTextures")))this.set("_RenderingQuality",a.Properties.rendering_quality),
a.Properties.hasOwnProperty("environment_name")&&(this.set("_EnvironmentName",a.Properties.environment_name),this.get("_renderercache").textures.Visualizer.path=this.get("_renderercache").textures.Visualizer.path+a.Properties.environment_name+"/");a.Properties.hasOwnProperty("reflection_settings")&&(this.get("_renderercache").reflections.enabled=a.Properties.reflection_settings.hasOwnProperty("reflective_table_enabled")?v.get("toBool")(a.Properties.reflection_settings.reflective_table_enabled):!1,
this.get("_renderercache").reflections.enabled&&(this.get("_renderercache").reflections.opacity=a.Properties.reflection_settings.hasOwnProperty("reflection_opacity")?parseFloat(a.Properties.reflection_settings.reflection_opacity):0.25,a.Properties.reflection_settings.hasOwnProperty("reflection_fade_size")&&a.Properties.reflection_settings.hasOwnProperty("reflection_fade_position")&&(this.get("_renderercache").reflections.fade=!0,this.get("_renderercache").reflections.fade_size=parseFloat(a.Properties.reflection_settings.reflection_fade_size),
this.get("_renderercache").reflections.fade_position=parseFloat(a.Properties.reflection_settings.reflection_fade_position))))}this.LoadBackdrop(a);this.set("_InitialisedSceneSettings",!0)}},UpdateSceneSettings:function(){if(this.get("_renderercache").camera_preset.eye_position){this.CameraUpdate(!1);var a=this.get("_3JSsceneBBox").center(),b=this.get("_3JScamera").position,c=this.get("_renderercache").camera_preset.eye_position.clone(),a=a.clone().sub(b),d=a.clone().multiplyScalar(c.clone().sub(b).dot(a)),
e=this.get("_3JScamera").up,g=a.clone().normalize().cross(e),g=g.clone().multiplyScalar(c.clone().sub(b).dot(g)),b=e.clone().multiplyScalar(c.clone().sub(b).dot(e));this.SetCameraPanOffset({x:g.length(),y:b.length()},!1);b=a.length();a=a.clone().sub(d).length();this.SetCameraScale(a/b)}},LoadGlobalLightingTextures:function(){if(!this.get("_QueriedGlobalTextures")){d.ImageUtils.crossOrigin="";var a=this.get("_resourcePath")+"/"+this.get("_renderercache").textures[this.get("_RenderingQuality")].path;
this.get("_renderercache").materials.enableirradiancemap&&this.StartAsyncGlobalTextureLoad(this,"irradiancemap",a);this.get("_renderercache").materials.enableenvmap&&this.StartAsyncGlobalTextureLoad(this,"envmap",a);this.set("_QueriedGlobalTextures",!0)}},LoadBackdrop:function(a){if(a.Properties&&a.Properties.hasOwnProperty("backdrop"))if("COLOR"===a.Properties.backdrop.type)a=a.Properties.backdrop.color,this.SetBackgroundColor(a[0],a[1],a[2],1,!1);else if("IMAGE"===a.Properties.backdrop.type){d.ImageUtils.crossOrigin=
"";var a=a.Assets[a.Properties.backdrop.image_tex].Properties,b=this.get("_model").get("SceneId"),b=b.substring(0,b.lastIndexOf("/")+1)+"/"+a.filepath;this.StartAsyncGlobalTextureLoad(this,"backdrop",b);this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.original_height=a.original_height;this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.original_width=a.original_width;this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.enabled=
!0}else o.Log("ViewerView Warning: Backdrop type not supported (default to grey)."),this.SetBackgroundColor(0.37,0.37,0.37,1,!1);else this.SetBackgroundColor(0.37,0.37,0.37,1,!1)},SetUpScene:function(){ba.start("Scene Hierarchy Creation");this.CreateTHREEJSObjectHierarchy();ba.stop("Scene Hierarchy Creation");var a=this;this.get("_build_scene_exec_queue").whenFinished(function(){var b=new d.Box3;b.setFromObject(a.get("_3JSsceneOp"));for(var c=0;c<a.get("_3JSsceneOpCoincidentGroupsPasses").length;++c){var j=
new d.Box3,e=a.get("_3JSsceneOpCoincidentGroupsPasses")[c];j.setFromObject(a.get("_3JSsceneOpCoincidentGroups")[e]);b.union(j)}c=new d.Box3;c.setFromObject(a.get("_3JSsceneTransp"));b.union(c);for(c=0;c<a.get("_3JSsceneTranspCoincidentGroupsPasses").length;++c)j=new d.Box3,e=a.get("_3JSsceneTranspCoincidentGroupsPasses")[c],j.setFromObject(a.get("_3JSsceneTranspCoincidentGroups")[e]),b.union(j);a.set("_3JSsceneBBox",b);a.set("_3JSsceneBBoxFocus",b);a.SetupReflections();a.CameraUpdate(!1);a.set("_InitialDistanceToSceneCenter",
a.get("_3JSsceneBBox").center().clone().sub(a.get("_3JScamera").position).length())})},SetupReflections:function(){var a=new d.Matrix4;a.set(1,0,0,0,0,-1,0,0,0,0,1,0,0,0,0,1);this.set("_reflection_Y_scale",a);this.set("_mirror_offset",0.01);var a=2*this.get("_3JSsceneBBox").min.y-this.get("_mirror_offset"),b=new d.Matrix4;b.makeTranslation(0,a,0);this.set("_reflection_Y_translation",b);b=new d.Matrix4;b.makeTranslation(0,-a,0);this.set("_reflection_Y_opp_translation",b)},AddUIElement:function(a){"function"===
typeof this.get("_clientUIAddElementCallback")?this.get("_clientUIAddElementCallback").apply(null,arguments):o.Log("ViewerView Warning: Client callback not a function")},CreateTHREEJSObjectHierarchy:function(){this.get("_3DObjectHandler")||this.set("_3DObjectHandler",new fa(this.get("_build_scene_exec_queue")));this.get("_3DObjectHandler").set("_geometrycounter",0);this.get("_build_scene_exec_queue").run(function(){},this);this.get("_build_scene_exec_queue").run(function(){var a=this.get("_model").get("_assetmanager").get("_cache"),
b=this.get("_model").get("SceneId");this.InitializeSceneSettings(a.rootnodes[b])},this);this.get("_build_scene_exec_queue").run(function(){this.LoadGlobalLightingTextures()},this);this.get("_build_scene_exec_queue").run(function(){o.Log("Building Surfaces...")},this);this.get("_build_scene_exec_queue").whenFinished(function(){o.Log("Finished Building Surfaces.")},this);this.get("_build_scene_exec_queue").run(function(){var a=this.get("_model").get("_assetmanager").get("_cache"),b=this.get("_model").get("SceneId");
this.BuildOpaqueScenes(a.rootnodes[b],b)},this);this.get("_build_scene_exec_queue").run(function(){for(var a=this.get("_model").get("_assetmanager").get("_cache"),b=this.get("_model").get("SceneId"),a=a.rootnodes[b],c=0;c<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++c){var d=this.get("_3JSsceneOpCoincidentGroupsPasses")[c];this.BuildOpaqueScenes(a,b,d)}},this);this.get("_build_scene_exec_queue").run(function(){if(!this.get("_emptyTransparentScene")){var a=this.get("_model").get("_assetmanager").get("_cache"),
b=this.get("_model").get("SceneId"),a=a.rootnodes[b];this.BuildTransparentScenes(a,b);for(var c=0;c<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++c){var d=this.get("_3JSsceneTranspCoincidentGroupsPasses")[c];this.BuildTransparentScenes(a,b,d)}}},this);this.get("_build_scene_exec_queue").run(function(){this.UpdateLightingContrast()},this);this.get("_build_scene_exec_queue").run(function(){var a=this.get("_model").get("_assetmanager").get("_cache"),b=this.get("_model").get("SceneId"),a=
this.GetTHREEJSObjectHierarchy(a.rootnodes[b],"highlightnode",b,b);a.newlycreated&&this.get("_3JSsceneHightlights").add(a.node);this.set("_geometrycounter",this.get("_geometrycounter")+this.get("_3DObjectHandler").get("_geometrycounter"));o.Log(this.get("_nodecounter")+" nodes have been created for this scene");o.Log(this.get("_geometrycounter")+" geometries have been created for this scene")},this)},BuildOpaqueScenes:function(a,b,c){var d=this.GetTHREEJSObjectHierarchy(a,"opaque_pass",b,b,c),e=this.GetTHREEJSObjectHierarchy(a,
"depth_pass",b,b,c),a=this.GetTHREEJSObjectHierarchy(a,"opaque_diffuse_pass",b,b,c);void 0===c?(d.newlycreated&&(d.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOp").add(d.node)),e.newlycreated&&(e.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOpDepth").add(e.node)),a.newlycreated&&(a.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOpaqueDiffuse").add(a.node))):(this.InitOpaqueCoincidentGroupScene(c),
d.newlycreated&&(d.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOpCoincidentGroups")[c].add(d.node)),e.newlycreated&&(e.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOpCoincidentGroupsDepth")[c].add(e.node)),a.newlycreated&&(a.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOpCoincidentGroupsDiffuse")[c].add(a.node)))},BuildTransparentScenes:function(a,b,c){var d=this.GetTHREEJSObjectHierarchy(a,
"transparent_pass",b,b,c),e=this.GetTHREEJSObjectHierarchy(a,"transp_depth_pass",b,b,c),a=this.GetTHREEJSObjectHierarchy(a,"transp_diffuse_pass",b,b,c);void 0===c?(d.newlycreated&&this.get("_3JSsceneTransp").add(d.node),e.newlycreated&&this.get("_3JSsceneTranspDepth").add(e.node),a.newlycreated&&this.get("_3JSsceneTranspDiffuse").add(a.node)):(this.InitTransparentCoincidentGroupScene(c),d.newlycreated&&this.get("_3JSsceneTranspCoincidentGroups")[c].add(d.node),e.newlycreated&&this.get("_3JSsceneTranspCoincidentGroupsDepth")[c].add(e.node),
a.newlycreated&&this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[c].add(a.node))},SetNonEmptyScene:function(a){a?this.set("_emptyTransparentScene",!1):this.set("_emptyOpaqueScene",!1)},CreateNewCoincidentGroupPass:function(a,b){b?this.get("_3JSsceneTranspCoincidentGroupsIds").hasOwnProperty(a)||(this.get("_3JSsceneTranspCoincidentGroupsIds")[a]={},this.get("_3JSsceneTranspCoincidentGroupsPasses").push(a)):this.get("_3JSsceneOpCoincidentGroupsIds").hasOwnProperty(a)||(this.get("_3JSsceneOpCoincidentGroupsIds")[a]=
{},this.get("_3JSsceneOpCoincidentGroupsPasses").push(a))},AsynchronuousLightLoad:function(a){var b=this;b.get("_build_scene_exec_queue").whenFinished(function(){b.get("_renderercache").lights.holo_light=a;b.UpdateMaterialsGlobalLighting();var c=100*(b.get("_model").get("_assetmanager").get("_textureLoadedCounter")/b.get("_model").get("_assetmanager").get("_textureCounter"));b.get("_model").get("_assetmanager").set("_textureLoadedCounter",b.get("_model").get("_assetmanager").get("_textureLoadedCounter")+
1);b.get("_model").get("_assetmanager").get("_assetloader").get("_httprequestmanager").get("_queriedassetnumber")==b.get("_model").get("_assetmanager").get("_resolvedassetnumber")&&100==c&&b.set("_SceneLoaded",!0);b.Render();b.NotifySceneBuildProgress(100,c,0)})},SelectTextureWrappingMode:function(a,b,c){b.hasOwnProperty("original_width")&&(c.originalTexWidth=parseFloat(b.original_width));b.hasOwnProperty("original_height")&&(c.originalTexHeight=parseFloat(b.original_height));switch(b.swrap){default:case "GL_REPEAT":a.wrapS=
d.RepeatWrapping;break;case "GL_CLAMP":case "GL_CLAMP_TO_BORDER":case "GL_CLAMP_TO_EDGE":a.wrapS=d.ClampToEdgeWrapping}switch(b.twrap){default:case "GL_REPEAT":a.wrapT=d.RepeatWrapping;break;case "GL_CLAMP":case "GL_CLAMP_TO_BORDER":case "GL_CLAMP_TO_EDGE":a.wrapT=d.ClampToEdgeWrapping}},LoadMaterial:function(a,b,c,j,e){if("Material"==a.AssetType){if(a.hasOwnProperty("Properties")){var a=a.Properties,g=1,h=1,f=1,k=1,l=1,n=1,q=1,m=1,r=1;a.front.hasOwnProperty("diffuse")&&(g=a.front.diffuse[0],h=a.front.diffuse[1],
f=a.front.diffuse[2]);a.front.hasOwnProperty("specular")&&(k=a.front.specular[0],l=a.front.specular[1],n=a.front.specular[2]);a.front.hasOwnProperty("ambient")&&(q=a.front.ambient[0],m=a.front.ambient[1],r=a.front.ambient[2]);var g=new d.Color(g,h,f),k=new d.Color(k,l,n),r=new d.Color(q,m,r),l=a.front.hasOwnProperty("shininess")?z.clamp(parseFloat(a.front.shininess),0,1):0.5,n=a.hasOwnProperty("double_sided")?v.get("toBool")(a.double_sided):!1,h=a.hasOwnProperty("opacity")?z.clamp(parseFloat(a.opacity),
0,1):1,f=a.front.hasOwnProperty("double_grating")?v.get("toBool")(a.front.double_grating):!1,p=a.front.hasOwnProperty("grating_spacing_scale")?parseFloat(a.front.grating_spacing_scale):null,t=a.front.hasOwnProperty("default_diff_haze")?parseFloat(a.front.default_diff_haze):null,x=a.front.hasOwnProperty("default_diff_spacing")?parseFloat(a.front.default_diff_spacing):null,m=(q=a.front.hasOwnProperty("diff_grating_tex")||a.front.hasOwnProperty("diff_grating_filter_tex"))||a.front.hasOwnProperty("int_specular_tex")||
a.front.hasOwnProperty("normal_chan0_tex")||a.front.hasOwnProperty("normal_chan1_tex"),s=!1;a.front.hasOwnProperty("diffuse_tex")&&b[a.front.diffuse_tex].Properties.hasOwnProperty("transparent")&&(h=(s=v.get("toBool")(b[a.front.diffuse_tex].Properties.transparent))?0.5:h);j={mat:{untextured_mat:null,textured_mat:{}},boundmeshlist:null,reflectance_model:a.reflectance_model,diff_texture:null,spec_texture:null,int_spec_texture:null,normal_chan0_texture:null,normal_chan1_texture:null,diff_grating_texture:null,
diff_grating_filter_texture:null,diff_col:g,spec_col:k,amb_col:r,shininess:l,double_sided:n,opacity:h,transp_texture:s,double_grating:f,grating_spacing_scale:p,default_diff_haze:t,default_diff_spacing:x,holographic:q,printable:m,backTexture:j,flipNormals:e};e=this.get("_renderercache").materials.enablehighlights&&this.get("_renderercache").materials.enablehardedgehighlights;e=this.CreateMaterial(j,e);j.mat.untextured_mat=e;d.ImageUtils.crossOrigin="";c=this.get("_model").get("_assetmanager").get("_assetloader").get("_httprequestmanager").IsAbsoluteURL(c)?
c.substring(0,c.lastIndexOf("/")+1):this.get("_resourcePath")+"/";this.StartAsyncTextureLoad(this,b,a,"diffuse_tex","diff_texture",j,c,m?d.RGBAFormat:d.RGBFormat,4);this.StartAsyncTextureLoad(this,b,a,"specular_tex","spec_texture",j,c,d.RGBAFormat,4);this.StartAsyncTextureLoad(this,b,a,"int_specular_tex","int_spec_texture",j,c,d.RGBAFormat,4);this.StartAsyncTextureLoad(this,b,a,"normal_chan0_tex","normal_chan0_texture",j,c,d.RGBFormat,1);this.StartAsyncTextureLoad(this,b,a,"normal_chan1_tex","normal_chan1_texture",
j,c,d.RGBFormat,1);this.StartAsyncTextureLoad(this,b,a,"diff_grating_tex","diff_grating_texture",j,c,d.RGBAFormat,4)&&this.StartAsyncTextureLoad(this,b,a,"diff_grating_filter_tex","diff_grating_filter_texture",j,c,d.RGBAFormat,4);"Visualizer"==this.get("_RenderingQuality")&&(q&&!this.get("_renderercache").textures[this.get("_RenderingQuality")].spectrum.queried)&&(c=this.get("_resourcePath")+"/"+this.get("_renderercache").textures[this.get("_RenderingQuality")].path,this.get("_renderercache").textures[this.get("_RenderingQuality")].spectrum.queried=
!0,new ea(c+"PointLightSources.json",this,this.AsynchronuousLightLoad),this.get("_model").get("_assetmanager").set("_textureCounter",this.get("_model").get("_assetmanager").get("_textureCounter")+1),this.StartAsyncGlobalTextureLoad(this,"spectrum",c));return j}o.Log("ViewerView Warning: Material properties not defined")}else o.Log("ViewerView Warning: Queried asset is not a material")},CreateMaterial:function(a,b,c){var j=b=null,e,g;a.diff_texture?e=a.diff_texture:a.spec_texture&&(e=a.spec_texture);
void 0!==e?(g=e.offset,e=e.repeat,g=new d.Vector4(g.x,g.y,e.x,e.y)):g=new d.Vector4(0,0,1,1);e={};var h;switch(this.get("_RenderingQuality")){case "Designer":0.5<=a.shininess?this.get("_renderercache").textures.Designer.envmap.glossy.loaded&&(b=this.get("_renderercache").textures.Designer.envmap.glossy.data,this.get("_renderercache").textures.Designer.irradiancemap.loaded&&(j=this.get("_renderercache").textures.Designer.irradiancemap.data)):this.get("_renderercache").textures.Designer.envmap.matte.loaded&&
(b=this.get("_renderercache").textures.Designer.envmap.matte.data,this.get("_renderercache").textures.Designer.irradiancemap.loaded&&(j=this.get("_renderercache").textures.Designer.irradiancemap.data));h=!0;var f=d.UniformsUtils.clone(V.uniforms);f.diffuse.value=a.diff_col;f.specular.value=a.spec_col;f.ambient.value=a.amb_col;f.shininess.value=a.shininess;f.diff_texture.value=a.diff_texture;f.spec_texture.value=a.spec_texture;f.irr_tex.value=j;f.env_tex.value=b;f.combine.value=d.AddOperation;f.reflectivity.value=
0.5;f.offsetRepeat.value=g;e[1]={name:"designer",uniforms:f,vertexShader:V.vertexShader,fragmentShader:V.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,transparent:!1,defines:{},lights:!0};break;case "Visualizer":h={};for(var k=!0,f=0;5>f;++f)if(this.get("_renderercache").textures.Visualizer.envmap.loaded[f])h[f]=this.get("_renderercache").textures.Visualizer.envmap.data[f];else{k=!1;break}k&&this.get("_renderercache").textures.Visualizer.irradiancemap.loaded&&
(j=this.get("_renderercache").textures.Visualizer.irradiancemap.data,b=h);h=C.get("_fullSupportFloatingPointTextures")||C.get("_fullSupportHFloatingPointTextures");h=1<=a.opacity&&!a.transp_texture||!h;if(a.printable){if(f=d.UniformsUtils.clone(Y.uniforms),f.offsetRepeat.value=g,f.diffuseColor.value=a.diff_col,f.opacity.value=h?1:a.opacity,f.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),f.normalMap_chan_0.value=a.normal_chan0_texture?a.normal_chan0_texture:this.get("_DummyTexture"),
f.normalMap_chan_1.value=a.normal_chan1_texture?a.normal_chan1_texture:this.get("_DummyTexture"),f.DX1RT.value=this.get("_DummyTexture"),f.DX2RT.value=this.get("_DummyTexture"),f.irradianceCubeMap.value=j?j:this.get("_DummyTextureCube"),f.backTexture.value=a.backTexture?1:0,f.flipNormals.value=a.flipNormals?1:0,k={},a.normal_chan0_texture&&(k.USE_CHAN0_TEXTURE=""),a.normal_chan1_texture&&(k.USE_CHAN1_TEXTURE=""),e[1]={name:"irradiancepm",uniforms:f,vertexShader:Y.vertexShader,fragmentShader:Y.fragmentShader,
depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:k,lights:!0,blending:h?d.NormalBlending:d.CustomBlending,blendSrc:d.OneFactor,blendDst:d.DstAlphaFactor,transparent:!0,derivatives:!0},f=d.UniformsUtils.clone(W.uniforms),f.offsetRepeat.value=g,f.diffuseColor.value=a.diff_col,f.opacity.value=h?1:a.opacity,f.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),f.DX1RT.value=this.get("_DummyTexture"),f.DX2RT.value=this.get("_DummyTexture"),
f.backTexture.value=a.backTexture?1:0,f.flipNormals.value=a.flipNormals?1:0,e[3]={name:"filterpm",uniforms:f,vertexShader:W.vertexShader,fragmentShader:W.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:{},lights:!0,blending:d.CustomBlending,blendSrc:d.DstColorFactor,blendDst:d.ZeroFactor,transparent:!0},11<=C.get("_glmaxtextureimageunits")?(f=d.UniformsUtils.clone(I.EXTuniforms),f.haze1CubeMap.value=b?b[0]:this.get("_DummyTextureCube"),f.haze2CubeMap.value=
b?b[1]:this.get("_DummyTextureCube"),f.haze3CubeMap.value=b?b[2]:this.get("_DummyTextureCube"),f.haze4CubeMap.value=b?b[3]:this.get("_DummyTextureCube"),f.haze5CubeMap.value=b?b[4]:this.get("_DummyTextureCube")):(f=d.UniformsUtils.clone(I.uniforms),f.haze1CubeMap.value=b?b[0]:this.get("_DummyTextureCube"),f.haze2CubeMap.value=b?b[4]:this.get("_DummyTextureCube")),f.offsetRepeat.value=g,f.diffuseColor.value=a.diff_col,f.specularColor.value=a.spec_col,f.shininess.value=a.shininess,f.diffuseTexture.value=
a.diff_texture?a.diff_texture:this.get("_DummyTexture"),f.specularTexture.value=a.spec_texture?a.spec_texture:this.get("_DummyTexture"),f.internalSpecTex.value=a.int_spec_texture?a.int_spec_texture:this.get("_DummyTexture"),f.normalMap_chan_0.value=a.normal_chan0_texture?a.normal_chan0_texture:this.get("_DummyTexture"),f.normalMap_chan_1.value=a.normal_chan1_texture?a.normal_chan1_texture:this.get("_DummyTexture"),f.DX1RT.value=this.get("_DummyTexture"),f.DX2RT.value=this.get("_DummyTexture"),f.backTexture.value=
a.backTexture?1:0,f.flipNormals.value=a.flipNormals?1:0,k={},a.int_spec_texture&&(k.USE_INT_SPEC_TEXTURE=""),a.normal_chan0_texture&&(k.USE_CHAN0_TEXTURE=""),a.normal_chan1_texture&&(k.USE_CHAN1_TEXTURE=""),e[6]={name:"reflectancepm",uniforms:f,vertexShader:I.vertexShader,fragmentShader:11<=C.get("_glmaxtextureimageunits")?I.EXTfragmentShader:I.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:k,lights:!0,blending:d.CustomBlending,blendSrc:d.OneFactor,
blendDst:d.OneFactor,transparent:!0,derivatives:!0},a.holographic){k=d.UniformsUtils.clone($.uniforms);k.offsetRepeat.value=g;k.uvdhTexture.value=a.diff_grating_texture?a.diff_grating_texture:this.get("_DummyTexture");k.diffFilterTexture.value=a.diff_grating_filter_texture?a.diff_grating_filter_texture:this.get("_DummyTexture");k.normalMap_chan_0.value=a.normal_chan0_texture?a.normal_chan0_texture:this.get("_DummyTexture");k.normalMap_chan_1.value=a.normal_chan1_texture?a.normal_chan1_texture:this.get("_DummyTexture");
k.DX1RT.value=this.get("_DummyTexture");k.DX2RT.value=this.get("_DummyTexture");k.grating_spacing_scale.value=a.grating_spacing_scale;k.spectrumTexture.value=this.get("_renderercache").textures[this.get("_RenderingQuality")].spectrum.data;k.defaultDiffSpacing.value=a.default_diff_spacing;k.defaultDiffHaze.value=a.default_diff_haze;k.backTexture.value=a.backTexture?1:0;k.flipNormals.value=a.flipNormals?1:0;var l={};a.double_grating&&(l.DOUBLE_GRATING="");a.normal_chan0_texture&&(l.USE_CHAN0_TEXTURE=
"");a.normal_chan1_texture&&(l.USE_CHAN1_TEXTURE="");if(this.get("_renderercache").textures[this.get("_RenderingQuality")].spectrum.loaded&&this.get("_renderercache").lights.hasOwnProperty("holo_light")){l.USE_HOLOGRAPHICS="";k.lightPos.value=[];k.lightIntensity.value=[];k.lightRadius.value=[];k.lightHardness.value=[];for(f=0;f<this.get("_renderercache").lights.holo_light.Lights.length&&4>f;++f){var n=this.get("_renderercache").lights.holo_light.Lights[f];k.lightPos.value.push(new d.Vector3(n[0],
n[1],n[2]));k.lightIntensity.value.push(n[3]);k.lightRadius.value.push(n[4]);k.lightHardness.value.push(n[5])}}e[5]={name:"holographicspm",uniforms:k,vertexShader:$.vertexShader,fragmentShader:$.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:l,lights:!0,blending:d.CustomBlending,blendSrc:d.OneMinusDstColorFactor,blendDst:d.OneFactor,transparent:!0,derivatives:!0}}}else f=d.UniformsUtils.clone(Z.uniforms),f.offsetRepeat.value=g,f.diffuseColor.value=
a.diff_col,f.opacity.value=h?1:a.opacity,f.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),f.DX1RT.value=this.get("_DummyTexture"),f.DX2RT.value=this.get("_DummyTexture"),f.irradianceCubeMap.value=j?j:this.get("_DummyTextureCube"),f.backTexture.value=a.backTexture?1:0,f.flipNormals.value=a.flipNormals?1:0,e[2]={name:"irradiancenpm",uniforms:f,vertexShader:Z.vertexShader,fragmentShader:Z.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:
d.FrontSide,defines:{},lights:!0,blending:h?d.NormalBlending:d.CustomBlending,blendSrc:d.OneFactor,blendDst:d.DstAlphaFactor,transparent:!0},f=d.UniformsUtils.clone(X.uniforms),f.offsetRepeat.value=g,f.diffuseColor.value=a.diff_col,f.opacity.value=h?1:a.opacity,f.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),f.DX1RT.value=this.get("_DummyTexture"),f.DX2RT.value=this.get("_DummyTexture"),f.backTexture.value=a.backTexture?1:0,f.flipNormals.value=a.flipNormals?1:0,e[4]=
{name:"filternpm",uniforms:f,vertexShader:X.vertexShader,fragmentShader:X.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:{},lights:!0,blending:d.CustomBlending,blendSrc:d.DstColorFactor,blendDst:d.ZeroFactor,transparent:!0},11<=C.get("_glmaxtextureimageunits")?(f=d.UniformsUtils.clone(J.EXTuniforms),f.haze1CubeMap.value=b?b[0]:this.get("_DummyTextureCube"),f.haze2CubeMap.value=b?b[1]:this.get("_DummyTextureCube"),f.haze3CubeMap.value=b?b[2]:
this.get("_DummyTextureCube"),f.haze4CubeMap.value=b?b[3]:this.get("_DummyTextureCube"),f.haze5CubeMap.value=b?b[4]:this.get("_DummyTextureCube")):(f=d.UniformsUtils.clone(J.uniforms),f.haze1CubeMap.value=b?b[0]:this.get("_DummyTextureCube"),f.haze2CubeMap.value=b?b[4]:this.get("_DummyTextureCube")),f.DX1RT.value=this.get("_DummyTexture"),f.DX2RT.value=this.get("_DummyTexture"),f.offsetRepeat.value=g,f.specularCol.value=a.spec_col,f.shininess.value=a.shininess,f.backTexture.value=a.backTexture?1:
0,f.flipNormals.value=a.flipNormals?1:0,e[7]={name:"reflectancenpm",uniforms:f,vertexShader:J.vertexShader,fragmentShader:11<=C.get("_glmaxtextureimageunits")?J.EXTfragmentShader:J.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:{},lights:!0,blending:d.CustomBlending,blendSrc:d.OneFactor,blendDst:d.OneFactor,transparent:!0}}k={};if(!c||"depth_pass"==c||"opaque_diffuse_pass"==c||"transp_depth_pass"==c||"transp_diffuse_pass"==c){l=f=null;if(!c||
"depth_pass"==c||"transp_depth_pass"==c)f=d.UniformsUtils.clone(H.uniforms),f=new d.ShaderMaterial({uniforms:f,vertexShader:H.vertexShader,fragmentShader:H.fragmentShader,side:d.DoubleSide,depthWrite:!0,transparent:!1,name:"D0ShaderMaterial",lights:!1});if(!c||"opaque_diffuse_pass"==c||"transp_diffuse_pass"==c)l=d.UniformsUtils.clone(T.uniforms),l.diffuseColor.value=a.diff_col,l.opacity.value=a.opacity,l.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),l.offsetRepeat.value=
g,l.DX1RT.value=this.get("_DummyTexture"),l.DX2RT.value=this.get("_DummyTexture"),l.backTexture.value=a.backTexture?1:0,l.flipNormals.value=a.flipNormals?1:0,l=new d.ShaderMaterial({uniforms:l,vertexShader:T.vertexShader,fragmentShader:T.fragmentShader,side:a.double_sided?d.DoubleSide:d.FrontSide,depthWrite:!0,transparent:!0,blending:d.CustomBlending,blendSrc:d.DstColorFactor,blendDst:d.ZeroFactor,name:"TransBlendShader",lights:!1}),a.diff_texture&&(l.defines.USE_MAP=""),a.printable||(l.defines.IS_NPM=
""),a.diff_texture&&a.diff_texture.remappedAlphaChannel&&(l.defines.REMAPPED_DIFFUSE_ALPHA_CHANNEL=""),a.spec_texture&&a.spec_texture.remappedAlphaChannel&&(l.defines.REMAPPED_SPECULAR_ALPHA_CHANNEL=""),a.int_spec_texture&&a.int_spec_texture.remappedAlphaChannel&&(l.defines.REMAPPED_INT_SPECULAR_ALPHA_CHANNEL=""),a.diff_grating_texture&&a.diff_grating_texture.remappedAlphaChannel&&(l.defines.REMAPPED_DIFF_GRATING_ALPHA_CHANNEL="");h?(f&&(k.depth_pass=[f]),l&&(k.opaque_diffuse_pass=[l])):(f&&(k.transp_depth_pass=
[f]),l&&(k.transp_diffuse_pass=[l]))}k.hasOwnProperty("opaque_pass")||(k.opaque_pass=[]);k.hasOwnProperty("transparent_pass")||(k.transparent_pass=[]);f=0;g=Object.keys(e);for(l=g.length;f<l;++f)n=g[f],e[n]&&(a.double_sided&&(e[n].defines.DOUBLE_SIDED=""),a.diff_texture&&(e[n].defines.USE_MAP=""),a.spec_texture&&(e[n].defines.USE_SPECULARMAP=""),j&&(e[n].defines.USE_IRRMAP=""),b&&(e[n].defines.USE_ENVMAP=""),a.diff_texture&&a.diff_texture.remappedAlphaChannel&&(e[n].defines.REMAPPED_DIFFUSE_ALPHA_CHANNEL=
""),a.spec_texture&&a.spec_texture.remappedAlphaChannel&&(e[n].defines.REMAPPED_SPECULAR_ALPHA_CHANNEL=""),a.int_spec_texture&&a.int_spec_texture.remappedAlphaChannel&&(e[n].defines.REMAPPED_INT_SPECULAR_ALPHA_CHANNEL=""),a.diff_grating_texture&&a.diff_grating_texture.remappedAlphaChannel&&(e[n].defines.REMAPPED_DIFF_GRATING_ALPHA_CHANNEL=""),e[n].lights=!0,h&&(!c||"opaque_pass"==c)?k.opaque_pass.push(new d.ShaderMaterial(e[n])):!h&&(!c||"transparent_pass"==c)&&k.transparent_pass.push(new d.ShaderMaterial(e[n])));
return k},UpdateTexturedMaterial:function(a){if(a){var b=a.boundmeshlist;if(b){var c=this.get("_renderercache").materials.enablehighlights&&this.get("_renderercache").materials.enablehardedgehighlights;0==Object.keys(b).length&&o.Log("ViewerView Warning: No meshes to update");for(var d=0,e=Object.keys(b),g=e.length;d<g;++d){var h=e[d];0==Object.keys(b[h]).length&&o.Log("ViewerView Warning: No render passes to update");for(var f=0,k=Object.keys(b[h]),l=k.length;f<l;++f){var n=k[f];0==Object.keys(b[h][n]).length&&
o.Log("ViewerView Warning: No sided materials to update");for(var q=0,m=Object.keys(b[h][n]),r=m.length;q<r;++q){var p=m[q];0==Object.keys(b[h][n][p]).length&&o.Log("ViewerView Warning: No shading pass to update");for(var t=0,x=Object.keys(b[h][n][p]),s=x.length;t<s;++t){var u=x[t],E=this.CreateMaterial(a,c,h);E[h][p].side=a.mat.textured_mat[h][p][u].side;this.ReleaseMaterial(a.mat.textured_mat[h][p][u],!1);a.mat.textured_mat[h][p][u]=E[h][p];for(var A=0,v=Object.keys(b[h][n][p][u]),z=v.length;A<
z;++A){var B=b[h][n][p][u][v[A]];B.material=E[h][p];B.geometry.buffersNeedUpdate=!0;B.geometry.uvsNeedUpdate=!0}}}}}}else o.Log("ViewerView Warning: No meshes to update")}},UpdateMaterialsGlobalLighting:function(){for(var a=this.get("_renderercache").materials,b=0,c=Object.keys(a.materiallist),d=c.length;b<d;++b){var e=c[b],g=a.materiallist[e].back;this.UpdateTexturedMaterial(a.materiallist[e].front);this.UpdateTexturedMaterial(g)}},AssetRefParse:function(a,b){var c={},d=a.lastIndexOf("#");if(-1==
d)c.new_scene_id=a,c.refnode=b[c.new_scene_id];else{c.new_scene_id=a.substring(0,d);var e=b[c.new_scene_id];if(e){var d=a.substring(d+1),g;do g=d.indexOf("/"),-1==g?(g=d,d=""):g=d.substring(0,g),e=e[g],d=d.substring(Math.min(d.indexOf("/")+1,d.length));while(0<d.length&&void 0!==e);e||null==e}null===e?o.Log(c.new_scene_id+" is null"):void 0==e&&o.Log(c.new_scene_id+" not yet in cache or not existing");c.refnode=e}return c},RegisterObjectNode:function(a,b,c,j){var e=this.get("_renderercache").nodeviewproperties,
g=!1;e.hasOwnProperty(a)||(e[a]={threejsnodes:{}});e[a].threejsnodes.hasOwnProperty(b)||(e[a].threejsnodes[b]={});void 0===j?e[a].threejsnodes[b].hasOwnProperty("default_cg")||(this.set("_nodecounter",this.get("_nodecounter")+1),e[a].threejsnodes[b].default_cg=new d.Object3D,g=!0):e[a].threejsnodes[b].hasOwnProperty(j)||(this.set("_nodecounter",this.get("_nodecounter")+1),e[a].threejsnodes[b][j]=new d.Object3D,g=!0);"highlightnode"==b&&this.AddUIElement(a,c);return{node:void 0!==j?e[a].threejsnodes[b][j]:
e[a].threejsnodes[b].default_cg,newlycreated:g}},GetTHREEJSObjectHierarchyRec:function(a,b,c,j,e,g,h){var f=a.AssetReferenceProperties,k={};if(h)for(var l=0,n=Object.keys(h),q=n.length;l<q;++l){var m=n[l];k[m]=h[m]}if(f&&(h=f.materialmap)){l=0;n=Object.keys(h);for(q=n.length;l<q;++l){var m=n[l],r=this.get("_renderercache").materials.materiallist,p=this.get("_model").get("_assetmanager").get("_cache").rootnodes,t=h[m][0]+(h[m][1]?"/"+h[m][1]:""),p=p[c].Assets,x=null,s=null;if(r.hasOwnProperty(t))p=
r[t];else{var u=!1;p.hasOwnProperty(h[m][0])?x=this.LoadMaterial(p[h[m][0]],p,c,!1,!1):o.Log("ViewerView Warning: Front material "+h[m][0]+" not found");var E=!1;h[m][1]&&(p.hasOwnProperty(h[m][1])?(s=p[h[m][1]],s=this.LoadMaterial(s,p,c,!0,!0),E=!0):o.Log("ViewerView Warning: Back material "+h[m][1]+" not found. Trying to assign front material."));!E&&p.hasOwnProperty(h[m][0])&&(s=p[h[m][0]],s=this.LoadMaterial(s,p,c,!1,!0),u=!0);p={front:x,back:s,sharedmaterial:u};r[t]=p}k[m]=p}}a=this.GetTHREEJSObjectHierarchy(a,
b,c,j,e,g,k);if(a.newlycreated){b=new d.Matrix4;if(f)if(c=new d.Vector3(parseFloat(f.x),parseFloat(f.y),parseFloat(f.z)),new d.Vector3(0,0,0),f.hasOwnProperty("orientation_matrix"))b.set(f.orientation_matrix[0],f.orientation_matrix[1],f.orientation_matrix[2],c.x,f.orientation_matrix[3],f.orientation_matrix[4],f.orientation_matrix[5],c.y,f.orientation_matrix[6],f.orientation_matrix[7],f.orientation_matrix[8],c.z,0,0,0,1);else switch(f.orientation){case "2":b.set(0,-1,0,c.x,1,0,0,c.y,0,0,1,c.z,0,0,
0,1);break;case "3":b.set(-1,0,0,c.x,0,-1,0,c.y,0,0,1,c.z,0,0,0,1);break;case "4":b.set(0,1,0,c.x,-1,0,0,c.y,0,0,1,c.z,0,0,0,1);break;case "5":b.set(1,0,0,c.x,0,0,1,c.y,0,-1,0,c.z,0,0,0,1);break;case "6":b.set(0,0,-1,c.x,1,0,0,c.y,0,-1,0,c.z,0,0,0,1);break;case "7":b.set(-1,0,0,c.x,0,0,-1,c.y,0,-1,0,c.z,0,0,0,1);break;case "8":b.set(0,0,1,c.x,-1,0,0,c.y,0,-1,0,c.z,0,0,0,1);break;case "9":b.set(0,0,-1,c.x,0,1,0,c.y,1,0,0,c.z,0,0,0,1);break;case "10":b.set(0,-1,0,c.x,0,0,-1,c.y,1,0,0,c.z,0,0,0,1);break;
case "11":b.set(0,0,1,c.x,0,-1,0,c.y,1,0,0,c.z,0,0,0,1);break;case "12":b.set(0,1,0,c.x,0,0,1,c.y,1,0,0,c.z,0,0,0,1);break;case "13":b.set(-1,0,0,c.x,0,1,0,c.y,0,0,-1,c.z,0,0,0,1);break;case "14":b.set(0,-1,0,c.x,-1,0,0,c.y,0,0,-1,c.z,0,0,0,1);break;case "15":b.set(1,0,0,c.x,0,-1,0,c.y,0,0,-1,c.z,0,0,0,1);break;case "16":b.set(0,1,0,c.x,1,0,0,c.y,0,0,-1,c.z,0,0,0,1);break;case "17":b.set(-1,0,0,c.x,0,0,1,c.y,0,1,0,c.z,0,0,0,1);break;case "18":b.set(0,0,-1,c.x,-1,0,0,c.y,0,1,0,c.z,0,0,0,1);break;case "19":b.set(1,
0,0,c.x,0,0,-1,c.y,0,1,0,c.z,0,0,0,1);break;case "20":b.set(0,0,1,c.x,1,0,0,c.y,0,1,0,c.z,0,0,0,1);break;case "21":b.set(0,0,1,c.x,0,1,0,c.y,-1,0,0,c.z,0,0,0,1);break;case "22":b.set(0,-1,0,c.x,0,0,1,c.y,-1,0,0,c.z,0,0,0,1);break;case "23":b.set(0,0,-1,c.x,0,-1,0,c.y,-1,0,0,c.z,0,0,0,1);break;case "24":b.set(0,1,0,c.x,0,0,-1,c.y,-1,0,0,c.z,0,0,0,1);break;default:b.set(1,0,0,c.x,0,1,0,c.y,0,0,1,c.z,0,0,0,1)}else b.set(1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1);a.node.applyMatrix(b)}return a},GetTHREEJSObjectHierarchy:function(a,
b,c,d,e,g,h){var f=this.get("_model").get("_assetmanager").get("_cache").rootnodes;if(void 0==a)return o.Log("ViewerView Warning: Reference to __asset '"+d+"' not yet loaded in cache. This node should be updated when asynchronuous data is loaded."),f=this.RegisterObjectNode(d,b,!1,e);var k=!(a.hasOwnProperty("Children")&&a.Children||a.hasOwnProperty("AssetRef"));if(a.hasOwnProperty("Children")&&a.Children)for(var f=this.RegisterObjectNode(d,b,k,e),g=0,k=Object.keys(a.Children),l=k.length;g<l;++g){var n=
k[g],q=d+"/"+n,n=this.GetTHREEJSObjectHierarchyRec(a.Children[n],b,c,q,e,a.AssetRef,h);n.newlycreated&&f.node.add(n.node)}else a.hasOwnProperty("AssetRef")?(this.get("_model").get("_assetmanager").get("_assetloader").IsURL(a.AssetRef)?(c=this.AssetRefParse(a.AssetRef,f),f=c.refnode,c=c.new_scene_id,this.get("_model").get("_assetmanager").GetFileName(a.AssetRef),this.get("_model").get("_assetmanager").GetAssetName(a.AssetRef)):f=f[c].Assets[a.AssetRef],f=this.GetTHREEJSObjectHierarchy(f,b,c,d,e,a.AssetRef,
h)):(f=this.RegisterObjectNode(d,b,k,e),f.newlycreated&&(d=!0,a.hasOwnProperty("Properties")&&a.Properties&&(d=a.AssetType,a=a.Properties,k=this.get("_renderercache").geometries,l=this.get("_renderercache").materials,n=this.get("_renderercache").coplanarityepsilon,c+=g.substring(g.lastIndexOf("/")),this.get("_3DObjectHandler").AddAssetToNode(d,c,b,f.node,a,k,l,h,n,e,this),d=!1),d&&o.Log("ViewerView Warning: Empty node")));return f},ScaleNode:function(a,b){var c=("PERSPECTIVE"==this.get("_renderercache").cameras.defaultcamera.cam_type?
1.2*a.position.clone().sub(b).length():this.get("_3JSsceneBBox").center().clone().sub(b).length())/this.get("_InitialDistanceToSceneCenter")*this.get("_3JSsceneBBox").getBoundingSphere().radius/1E3,d=a.__initial_scale.clone();d.multiplyScalar(c);a.scale.copy(d);var d=a.__initial_att_position.clone(),e=a.__initial_position.clone().clone();e.sub(d);e.multiplyScalar(c);e.add(d);a.position.copy(e)},CameraUpdate:function(a,b,c){var j=this.get("_3JSsceneBBox").clone();this.SetCamera(this.get("_3JSsceneBBoxFocus"),
b,c);var e=this.get("_3JScamera").position.clone(),g=this.get("_3JScamera").up.clone().normalize(),e=j.center().clone().sub(e);e.normalize();for(var h=e.clone().cross(g),h=e.clone().sub(g.clone().multiplyScalar(0.5)).sub(h.clone().multiplyScalar(0.7)),e=0,f=Object.keys(this.get("_renderercache").lights.dir_light),g=f.length;e<g;++e){var k=this.get("_renderercache").lights.dir_light[f[e]];k&&(k.position.set(-h.x,-h.y,-h.z),k.needsUpdate=!0)}if(this.get("_3JScamera")){var l=this.get("_3JScamera").position.clone();
if(this.get("_InitialDistanceToSceneCenter")){this.get("_3JSlabelsBBox").box=new d.Box3;this.get("_3JSlabelsBBox").box.expandByPoint(this.get("_3JSsceneBBox").center());h=0;f=Object.keys(this.get("_3JSsceneLabels").children);for(g=f.length;h<g;++h)if(e=f[h],k=this.get("_3JSsceneLabels").children[e],"object"===typeof k)for(var n=this.get("_3JSsceneLabels").children[e].children,q=G.sortBy(n,function(a){return a.position.clone().sub(l).length()}),e=0;e<n.length;e++)q[e].visible=e==k._visible_rank&&k.user_visibility,
q[e].visible&&(this.ScaleNode(q[e],l),this.get("_3JSlabelsBBox").box.expandByPoint(q[e].position));this.get("_3JSdimensionsBBox").box=new d.Box3;this.get("_3JSdimensionsBBox").box.expandByPoint(this.get("_3JSsceneBBox").center());h=0;f=Object.keys(this.get("_3JSsceneDimensions").children);for(g=f.length;h<g;++h)if(e=f[h],k=this.get("_3JSsceneDimensions").children[e],"object"===typeof k){for(var n=this.get("_3JSsceneDimensions").children[e].children,m=[],q=[],r=[],e=0;4>e;e++)m=m.concat(n[3*e]),q=
q.concat(n[3*e+1]),r=r.concat(n[3*e+2]);n=G.sortBy(m,function(a){return a.position.clone().sub(l).length()});q=G.sortBy(q,function(a){return a.position.clone().sub(l).length()});r=G.sortBy(r,function(a){return a.position.clone().sub(l).length()});for(e=0;4>e;e++){var m=n[e],p=q[e],t=r[e];m.visible=e==k._visible_rank_w&&k.user_visibility_w;p.visible=e==k._visible_rank_h&&k.user_visibility_h;t.visible=e==k._visible_rank_d&&k.user_visibility_d;m.visible&&(this.ScaleNode(m,l),this.get("_3JSdimensionsBBox").box.expandByPoint(m.position));
p.visible&&(this.ScaleNode(p,l),this.get("_3JSdimensionsBBox").box.expandByPoint(p.position));t.visible&&(this.ScaleNode(t,l),this.get("_3JSdimensionsBBox").box.expandByPoint(t.position))}}}}j.union(this.get("_3JSlabelsBBox").box);j.union(this.get("_3JSdimensionsBBox").box);g=this.get("_3JSsceneBBox").min.clone();e=new d.Vector3(0,this.get("_3JSsceneBBox").size().y+this.get("_mirror_offset"),0);g.sub(e);j.expandByPoint(g);this.UpdateCamNearAndFar(j,b,c);b=!1;null===this.get("_3JScamera").parent&&
this.get("_3JScamera").updateMatrixWorld();c=new d.Matrix4;b=new d.Frustum;this.get("_3JScamera").matrixWorldInverse.getInverse(this.get("_3JScamera").matrixWorld);c.multiplyMatrices(this.get("_3JScamera").projectionMatrix,this.get("_3JScamera").matrixWorldInverse);b.setFromMatrix(c);c=new d.Geometry;c.vertices.push(this.get("_3JSsceneBBox").min,this.get("_3JSsceneBBox").max);c=new d.Mesh(c,null);this.set("_obj_in_frustum_prev",this.get("_obj_in_frustum"));b=b.intersectsObject(c);this.set("_obj_in_frustum",
b);(void 0===a||a)&&this.Render()},SetCameraAngles:function(a,b,c){var d=this.get("_renderercache").cameras.defaultcamera.azimuthAngle,e=this.get("_renderercache").cameras.defaultcamera.elevationAngle;this.get("_renderercache").cameras.defaultcamera.azimuthAngle=a;this.get("_renderercache").cameras.defaultcamera.elevationAngle=b;this.CameraUpdate(c);!this.get("_obj_in_frustum")&&this.get("_obj_in_frustum_prev")&&(this.get("_renderercache").cameras.defaultcamera.azimuthAngle=d,this.get("_renderercache").cameras.defaultcamera.elevationAngle=
e,this.CameraUpdate(c))},GetCameraAngles:function(){return{azimuth:this.get("_renderercache").cameras.defaultcamera.azimuthAngle,elevation:this.get("_renderercache").cameras.defaultcamera.elevationAngle}},SetCameraScale:function(a,b){var c=this.get("_renderercache").cameras.defaultcamera.scale;this.get("_renderercache").cameras.defaultcamera.scale=a;this.CameraUpdate(b);!this.get("_obj_in_frustum")&&this.get("_obj_in_frustum_prev")&&(this.get("_renderercache").cameras.defaultcamera.scale=c,this.CameraUpdate(b))},
GetCameraScale:function(){return this.get("_renderercache").cameras.defaultcamera.scale},SetCameraPanOffset:function(a,b){var c=this.get("_renderercache").cameras.defaultcamera.panOffset;this.get("_renderercache").cameras.defaultcamera.panOffset=a;this.CameraUpdate(b);!this.get("_obj_in_frustum")&&this.get("_obj_in_frustum_prev")&&(this.get("_renderercache").cameras.defaultcamera.panOffset=c,this.CameraUpdate(b))},GetCameraPanOffset:function(){var a=this.get("_renderercache").cameras.defaultcamera.panOffset;
return{x:a.x,y:a.y}},SetPerspectiveCamera:function(a,b){this.get("_renderercache").cameras.defaultcamera.cam_type="PERSPECTIVE";this.get("_renderercache").cameras.defaultcamera.fieldOfView=a;this.CameraUpdate(b)},SetOrthographicCamera:function(a){this.get("_renderercache").cameras.defaultcamera.cam_type="ORTHOGRAPHIC";this.CameraUpdate(a)},UpdateCamNearAndFar:function(a,b,c){var j=this.get("_3JScamera"),e=this.get("_renderercache").cameras.defaultcamera.fieldOfView,g=a.max,h=a.min,a=new d.Vector3(g.x-
h.x,g.y-h.y,g.z-h.z),g=new d.Vector3((h.x+g.x)/2,(h.y+g.y)/2,(h.z+g.z)/2),b=b?b:this.get("_context").clientWidth,c=c?c:this.get("_context").clientHeight,c=b/c;Math.min(e,c*e);e=Math.sqrt(a.x*a.x+a.y*a.y+a.z*a.z);a=this.get("_3JScamera").position.clone();b=this.get("_renderercache").cameras.defaultcamera;a.addScaledVector(this.get("_cameraleftdirvec"),b.panOffset.x);a.addScaledVector(this.get("_3JScamera").up,-b.panOffset.y);g=g.sub(a).length();j.near=Math.max(g-e/2,0.1);j.far=Math.max(g+e/2,0.2);
j.aspect=c;j.updateProjectionMatrix()},GetOptimisedScaleForCurrentView:function(a,b,c){var j=this.get("_renderercache").cameras.defaultcamera,b=b?b:this.get("_context").clientWidth,e=c?c:this.get("_context").clientHeight,g=this.get("_3JSsceneBBoxFocus").max,h=this.get("_3JSsceneBBoxFocus").min,f=j.fieldOfView,k=b/e,l=new d.Vector3(Math.abs(g.x-h.x),Math.abs(g.y-h.y),Math.abs(g.z-h.z)),c=Math.sqrt(l.x*l.x+l.y*l.y+l.z*l.z),n=h.x-(h.x+g.x)/2,l=h.y-(h.y+g.y)/2,q=h.z-(h.z+g.z)/2,m=g.x-(h.x+g.x)/2,r=g.y-
(h.y+g.y)/2,g=g.z-(h.z+g.z)/2,p=z.radians(j.azimuthAngle),t=z.radians(-j.elevationAngle),h=new d.Matrix3;h.set(Math.cos(t)*Math.cos(p),-Math.sin(t),Math.cos(t)*-Math.sin(p),Math.sin(t)*Math.cos(p),Math.cos(t),Math.sin(t)*-Math.sin(p),Math.sin(p),0,Math.cos(p));var p=new d.Vector3(n,l,q),t=new d.Vector3(n,l,g),o=new d.Vector3(n,r,q),s=new d.Vector3(n,r,g),u=new d.Vector3(m,l,q),E=new d.Vector3(m,l,g),A=new d.Vector3(m,r,q),g=new d.Vector3(m,r,g);p.applyMatrix3(h);t.applyMatrix3(h);o.applyMatrix3(h);
s.applyMatrix3(h);u.applyMatrix3(h);E.applyMatrix3(h);A.applyMatrix3(h);g.applyMatrix3(h);n=Math.min(p.x,Math.min(t.x,Math.min(o.x,Math.min(s.x,Math.min(u.x,Math.min(E.x,Math.min(A.x,g.x)))))));l=Math.min(p.y,Math.min(t.y,Math.min(o.y,Math.min(s.y,Math.min(u.y,Math.min(E.y,Math.min(A.y,g.y)))))));q=Math.min(p.z,Math.min(t.z,Math.min(o.z,Math.min(s.z,Math.min(u.z,Math.min(E.z,Math.min(A.z,g.z)))))));m=Math.max(p.x,Math.max(t.x,Math.max(o.x,Math.max(s.x,Math.max(u.x,Math.max(E.x,Math.max(A.x,g.x)))))));
r=Math.max(p.y,Math.max(t.y,Math.max(o.y,Math.max(s.y,Math.max(u.y,Math.max(E.y,Math.max(A.y,g.y)))))));g=Math.max(p.z,Math.max(t.z,Math.max(o.z,Math.max(s.z,Math.max(u.z,Math.max(E.z,Math.max(A.z,g.z)))))));if("PERSPECTIVE"==j.cam_type)return b=k*f,l=new d.Vector3(Math.abs(m-n),Math.abs(r-l),Math.abs(g-q)),e=Math.abs(l.y/(2*Math.tan(z.radians(f)/2))),b=Math.abs(l.z/(2*Math.tan(z.radians(b)/2))),b=Math.max(b,e),b=0.5*Math.abs(m-n)+b,e=Math.min(f,k*f),Math.abs(c/(2*Math.tan(z.radians(e)/2)))/(b-0.5*
c)-a;f=Math.abs(g-q)/b;k=Math.abs(r-l)/e;k=Math.max(f,k);f=k*b;k*=e;c=Math.max(c/b,c/e);return Math.max(c*b/f-a,c*e/k-a)},SetOptimisedViewRendering:function(a,b,c){this.set("_optimised_view",b);this.set("_optimised_view_border",a);this.CameraUpdate(c)},SetCamera:function(a,b,c){var j=this.get("_renderercache").cameras.defaultcamera,e=b?b:this.get("_context").clientWidth,g=c?c:this.get("_context").clientHeight,h=a.max,f=a.min,a=new d.Vector3((f.x+h.x)/2,(f.y+h.y)/2,(f.z+h.z)/2),k=0.1,k=j.fieldOfView,
l,n=e/g,q=j.scale,h=new d.Vector3(Math.abs(h.x-f.x),Math.abs(h.y-f.y),Math.abs(h.z-f.z)),h=Math.sqrt(h.x*h.x+h.y*h.y+h.z*h.z),k=Math.min(k,n*k),k=Math.abs(h/(2*Math.tan(z.radians(k)/2)));this.get("_optimised_view")&&(q=this.GetOptimisedScaleForCurrentView(this.get("_optimised_view_border"),b,c));f=Math.max(0.5*h+k/q,0.5*h);b=new d.Vector3(a.x,a.y,a.z);b.x+=f*Math.sin(Math.PI/2-z.radians(j.elevationAngle))*Math.cos(z.radians(j.azimuthAngle));b.z-=f*Math.sin(Math.PI/2-z.radians(j.elevationAngle))*Math.sin(z.radians(j.azimuthAngle));
b.y+=f*Math.cos(Math.PI/2-z.radians(j.elevationAngle));k=new d.Vector3(a.x,a.y,a.z);k.sub(b);90<=j.elevationAngle?j.elevationAngle=89.9:l=j.elevationAngle;c=new d.Vector3(0,0,0);c.x+=f*Math.sin(Math.PI/2-z.radians(l))*Math.cos(z.radians(j.azimuthAngle)-Math.PI/2);c.z-=f*Math.sin(Math.PI/2-z.radians(l))*Math.sin(z.radians(j.azimuthAngle)-Math.PI/2);c.normalize();l=k.cross(c).normalize();var k=f-h/2,f=f+h/2,h=Math.max(h/e,h/g),e=h*e/q,g=h*g/q,m;"PERSPECTIVE"==j.cam_type?m=new d.PerspectiveCamera(j.fieldOfView,
n,k,f):"ORTHOGRAPHIC"==j.cam_type&&(m=new d.OrthographicCamera(e/-2,e/2,g/2,g/-2,k,f));m.up=l;m.position.set(b.x,b.y,b.z);m.lookAt(a);b.addScaledVector(c,-j.panOffset.x);b.addScaledVector(l,j.panOffset.y);this.set("_cameraleftdirvec",c);m.position.set(b.x,b.y,b.z);this.set("_3JScamera",m)},SetCameraFocus:function(a,b){for(var c=0,j=Object.keys(this.get("_renderercache").nodeviewproperties[a].threejsnodes),e=j.length;c<e;++c){for(var g=j[c],g=this.get("_renderercache").nodeviewproperties[a].threejsnodes[g],
h=new d.Box3,f=0,k=Object.keys(g),l=k.length;f<l;f++){var n=new d.Box3;n.setFromObject(g[k[f]]);n.empty()||h.union(n)}if(!h.empty()){this.set("_3JSsceneBBoxFocus",h);this.CameraUpdate(b);break}}this.UpdateShadersUniforms()},SetEnvironmentRotation:function(a,b){this.get("_renderercache").environment_settings.rotation=a.clone();this.ApplyFctToAllMaterials(this.UpdateMaterialEnvironmentRotation(this.get("_renderercache").environment_settings.rotation));(void 0===b||b)&&this.Render()},GetEnvironmentRotation:function(){return this.get("_renderercache").environment_settings.rotation.clone()},
UpdateShadersUniforms:function(){if(this.get("_renderercache").materials.outline){var a=this.get("_renderercache").materials.outlinethickness;this.get("_renderercache").materials.outline.uniforms.offset.value=Math.max(0.001*this.get("_3JSsceneBBoxFocus").size().length(),0.001*this.get("_3JSsceneBBoxFocus").center().clone().sub(this.get("_3JScamera").position).length()*a)}},UpdateMaterialEnvironmentRotation:function(a){var b=new d.Vector4(a.x,a.y,a.z,a.w),c=this;return function(j){if(j&&j.hasOwnProperty("uniforms")&&
(j.uniforms.hasOwnProperty("envMapRotQuat")&&(j.uniforms.envMapRotQuat.value=b),j.uniforms.hasOwnProperty("lightPos")))for(var e=0;e<c.get("_renderercache").lights.holo_light.Lights.length&&4>e;++e){var g=c.get("_renderercache").lights.holo_light.Lights[e],g=new d.Vector3(g[0],g[1],g[2]);g.applyQuaternion(a);j.uniforms.lightPos.value[e]=g}}},FlipMaterialSide:function(a){return function(b){b&&(b.flipped!=a&&(b.side!=d.DoubleSide&&(b.side=b.side==d.FrontSide?d.BackSide:d.FrontSide),b.hasOwnProperty("uniforms")&&
b.uniforms.hasOwnProperty("isFloorReflection")&&(b.uniforms.isFloorReflection.value=d.FrontSide==a?0:1)),b.flipped=a)}},UpdateReflectionUniforms:function(a,b,c,d){this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_opacity.value=void 0!==a?a:this.get("_renderercache").reflections.opacity;this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_fade.value=void 0!==b?b:this.get("_renderercache").reflections.fade;this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_fade_position.value=
void 0!==c?c:this.get("_renderercache").reflections.fade_position;this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_fade_size.value=void 0!==d?d:this.get("_renderercache").reflections.fade_size;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.reflection_opacity.value=void 0!==a?a:this.get("_renderercache").reflections.opacity;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.reflection_fade.value=void 0!==b?b:this.get("_renderercache").reflections.fade;
this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.reflection_fade_position.value=void 0!==c?c:this.get("_renderercache").reflections.fade_position;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.reflection_fade_size.value=void 0!==d?d:this.get("_renderercache").reflections.fade_size;this.get("_renderercache").materials.CopyShaderMaterial.uniforms.reflection_opacity.value=void 0!==a?a:this.get("_renderercache").reflections.opacity;this.get("_renderercache").materials.CopyShaderMaterial.uniforms.reflection_fade.value=
void 0!==b?b:this.get("_renderercache").reflections.fade;this.get("_renderercache").materials.CopyShaderMaterial.uniforms.reflection_fade_position.value=void 0!==c?c:this.get("_renderercache").reflections.fade_position;this.get("_renderercache").materials.CopyShaderMaterial.uniforms.reflection_fade_size.value=void 0!==d?d:this.get("_renderercache").reflections.fade_size},IsReflectionsRenderingEnabled:function(){return this.get("_SceneLoaded")&&this.get("_3JSsceneBBox").min.y<this.get("_3JScamera").position.y&&
("JSON"==this.get("_reflection_config")&&this.get("_renderercache").reflections.enabled||"ON"==this.get("_reflection_config"))},FlipScene:function(a){a.applyMatrix(this.get("_reflection_Y_scale"));a.applyMatrix(this.get("_reflection_Y_translation"))},UnflipScene:function(a){a.applyMatrix(this.get("_reflection_Y_opp_translation"));a.applyMatrix(this.get("_reflection_Y_scale"))},RenderScene:function(a,b){this.get("_3JSrenderer").render(a,this.get("_3JScamera"),b)},RenderOpaqueScene:function(a){this.RenderScene(this.get("_3JSsceneOp"),
a);var b=function(a){return function(b){b instanceof d.Mesh&&b.material&&(b.material.depthWrite=a)}};this.get("_3JSrenderer").autoClear=!1;for(var c=0;c<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++c){var j=this.get("_3JSsceneOpCoincidentGroupsPasses")[c];this.get("_3JSsceneOpCoincidentGroups")[j].traverse(b(!1));this.RenderScene(this.get("_3JSsceneOpCoincidentGroups")[j],a);this.get("_3JSrenderer").context.colorMask(!1,!1,!1,!1);this.get("_3JSsceneOpCoincidentGroups")[j].traverse(b(!0));
this.RenderScene(this.get("_3JSsceneOpCoincidentGroups")[j],a);this.get("_3JSrenderer").context.colorMask(!0,!0,!0,!0)}this.get("_3JSrenderer").autoClear=!0},RenderOpaqueSceneDepth:function(a){this.get("_3JSsceneOpDepth").overrideMaterial=this.get("_renderercache").materials.D0ShaderMaterial;this.RenderScene(this.get("_3JSsceneOpDepth"),a);this.get("_3JSrenderer").autoClear=!1;for(var b=0;b<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++b){var c=this.get("_3JSsceneOpCoincidentGroupsPasses")[b];
this.get("_3JSsceneOpCoincidentGroupsDepth")[c].overrideMaterial=this.get("_renderercache").materials.D0ShaderMaterial;this.RenderScene(this.get("_3JSsceneOpCoincidentGroupsDepth")[c],a)}this.get("_3JSrenderer").autoClear=!0},RenderOpaqueSceneDiffuse:function(a){this.RenderScene(this.get("_3JSsceneOpaqueDiffuse"),a);var b=function(a){return function(b){b instanceof d.Mesh&&b.material&&(b.material.depthWrite=a)}};this.get("_3JSrenderer").autoClear=!1;for(var c=0;c<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++c){var j=
this.get("_3JSsceneOpCoincidentGroupsPasses")[c];this.get("_3JSsceneOpCoincidentGroupsDiffuse")[j].traverse(b(!1));this.RenderScene(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[j],a);this.get("_3JSrenderer").context.colorMask(!1,!1,!1,!1);this.get("_3JSsceneOpCoincidentGroupsDiffuse")[j].traverse(b(!0));this.RenderScene(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[j],a);this.get("_3JSrenderer").context.colorMask(!0,!0,!0,!0)}this.get("_3JSrenderer").autoClear=!0},RenderTransparentScene:function(a,
b){this.get("_3JSsceneTransp").traverse(b);this.RenderScene(this.get("_3JSsceneTransp"),a);var c=function(a){return function(b){b instanceof d.Mesh&&b.material&&(b.material.depthWrite=a)}};this.get("_3JSrenderer").autoClear=!1;for(var j=0;j<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++j){var e=this.get("_3JSsceneTranspCoincidentGroupsPasses")[j];this.get("_3JSsceneTranspCoincidentGroups")[e].traverse(b);this.get("_3JSsceneTranspCoincidentGroups")[e].traverse(c(!1));this.RenderScene(this.get("_3JSsceneTranspCoincidentGroups")[e],
a);this.get("_3JSrenderer").context.colorMask(!1,!1,!1,!1);this.get("_3JSsceneTranspCoincidentGroups")[e].traverse(c(!0));this.RenderScene(this.get("_3JSsceneTranspCoincidentGroups")[e],a);this.get("_3JSrenderer").context.colorMask(!0,!0,!0,!0)}this.get("_3JSrenderer").autoClear=!0},RenderTransparentSceneDepth:function(a,b){this.get("_3JSsceneTranspDepth").overrideMaterial=b;this.RenderScene(this.get("_3JSsceneTranspDepth"),a);this.get("_3JSsceneTranspDepth").overrideMaterial=null;this.get("_3JSrenderer").autoClear=
!1;for(var c=0;c<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++c){var d=this.get("_3JSsceneTranspCoincidentGroupsPasses")[c];this.get("_3JSsceneTranspCoincidentGroupsDepth")[d].overrideMaterial=b;this.RenderScene(this.get("_3JSsceneTranspCoincidentGroupsDepth")[d],a);this.get("_3JSsceneTranspCoincidentGroupsDepth")[d].overrideMaterial=null}this.get("_3JSrenderer").autoClear=!0},RenderTransparentSceneDiffuse:function(a,b){this.get("_3JSsceneTranspDiffuse").traverse(b);this.RenderScene(this.get("_3JSsceneTranspDiffuse"),
a);var c=function(a){return function(b){b instanceof d.Mesh&&b.material&&(b.material.depthWrite=a)}};this.get("_3JSrenderer").autoClear=!1;for(var j=0;j<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++j){var e=this.get("_3JSsceneTranspCoincidentGroupsPasses")[j];this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[e].traverse(b);this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[e].traverse(c(!1));this.RenderScene(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[e],a);this.get("_3JSrenderer").context.colorMask(!1,
!1,!1,!1);this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[e].traverse(c(!0));this.RenderScene(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[e],a);this.get("_3JSrenderer").context.colorMask(!0,!0,!0,!0)}this.get("_3JSrenderer").autoClear=!0},SetSizeOfRTSrc:function(a,b){return function(c){c instanceof d.Mesh&&c.material.hasOwnProperty("uniforms")&&c.material.uniforms.hasOwnProperty("canvas_size")&&(c.material.uniforms.canvas_size.value=new d.Vector2(a,b))}},SetAsRTSrc:function(a,b,c,j){var e=
Math.max(arguments.length-2,0),g=this;return function(h){h instanceof d.Mesh&&h.material.hasOwnProperty("uniforms")&&(h.material.uniforms.hasOwnProperty("DX1RT")&&(h.material.uniforms.hasOwnProperty("DX2RT")&&h.material.uniforms.hasOwnProperty("NBRTSRC")&&h.material.uniforms.hasOwnProperty("canvas_size"))&&(h.material.uniforms.canvas_size.value=new d.Vector2(a,b),h.material.uniforms.DX1RT.value=c?c:g.get("_DummyTexture"),h.material.uniforms.DX2RT.value=j?j:g.get("_DummyTexture"),h.material.uniforms.NBRTSRC.value=
e),h.material.uniforms.hasOwnProperty("transparent")&&(h.material.uniforms.transparent.value=c?1:0))}},RenderDepthPeel:function(a,b,c,j,e,g,h,f,k,l,n,q,m,r){this.get("_3JSrenderer").setClearColor(m,1);this.RenderOpaqueSceneDepth(f);this.get("_3JSrenderer").autoClearDepth=!0;this.get("_renderercache").materials.DepthOnlyShaderMaterial.uniforms.DX1RT.value=f;this.get("_renderercache").materials.DepthOnlyShaderMaterial.uniforms.NBRTSRC.value=1;this.RenderTransparentSceneDepth(g,this.get("_renderercache").materials.DepthOnlyShaderMaterial);
this.get("_3JSrenderer").autoClearDepth=!1;this.get("_3JSrenderer").setClearColor(m,1);this.RenderTransparentScene(g,this.SetAsRTSrc(j,e,f));this.get("_3JSrenderer").autoClearDepth=!0;this.RenderTransparentSceneDepth(h,this.get("_renderercache").materials.DepthOnlyShaderMaterial);this.get("_3JSrenderer").autoClearDepth=!1;this.get("_3JSrenderer").setClearColor(r,1);this.RenderTransparentSceneDiffuse(h,this.SetAsRTSrc(j,e,f));this.get("_3JSrenderer").autoClearDepth=!0;if(1<this.get("_current_nb_peels")&&
this.get("_SceneLoaded")){this.get("_3JSrenderer").setClearColor(m,1);this.get("_renderercache").materials.D1ShaderMaterial.uniforms.D0RT.value=f;this.RenderTransparentSceneDepth(k,this.get("_renderercache").materials.D1ShaderMaterial);this.get("_renderercache").materials.D2ShaderMaterial.uniforms.DX1RT.value=f;this.get("_3JSrenderer").setClearColor(m,1);for(var p=0;p<this.get("_current_nb_peels")-1;++p){this.get("_3JSrenderer").autoClearDepth=!0;this.get("_3JSrenderer").autoClearColor=!0;this.get("_renderercache").materials.DepthOnlyShaderMaterial.uniforms.DX2RT.value=
p%2?l:k;this.get("_renderercache").materials.DepthOnlyShaderMaterial.uniforms.NBRTSRC.value=2;this.RenderTransparentSceneDepth(n,this.get("_renderercache").materials.DepthOnlyShaderMaterial);this.get("_3JSrenderer").autoClearDepth=!1;this.RenderTransparentScene(n,this.SetAsRTSrc(j,e,f,p%2?l:k));this.get("_3JSrenderer").autoClearDepth=!0;this.get("_3JSrenderer").autoClearColor=!1;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.CX1RT.value=n;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.TransparencyStack.value=
h;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBGBlend.value=0;var t=new d.Mesh(c,this.get("_renderercache").materials.ColorBlendShaderMaterial),o=new d.Scene;o.add(t);this.get("_3JSrenderer").render(o,b,g);this.get("_3JSrenderer").autoClearColor=!0;this.get("_3JSrenderer").autoClearDepth=!0;this.get("_3JSrenderer").autoClearColor=!1;this.RenderTransparentSceneDepth(h,this.get("_renderercache").materials.DepthOnlyShaderMaterial);this.get("_3JSrenderer").autoClearDepth=
!1;this.get("_3JSrenderer").autoClearColor=!1;this.RenderTransparentSceneDiffuse(h,this.SetAsRTSrc(j,e,f,p%2?l:k));this.get("_3JSrenderer").autoClearColor=!0;this.get("_3JSrenderer").autoClearDepth=!0;this.get("_renderercache").materials.D2ShaderMaterial.uniforms.DX2RT.value=p%2?l:k;this.RenderTransparentSceneDepth(p%2?k:l,this.get("_renderercache").materials.D2ShaderMaterial)}}this.get("_3JSrenderer").setClearColor(m,1);this.RenderOpaqueScene(n);a&&(this.get("_3JSrenderer").autoClear=!1,this.get("_3JSrenderer").render(this.get("_3JSsceneHightlights"),
this.get("_3JScamera"),n),this.get("_3JSrenderer").autoClear=!0);this.get("_3JSrenderer").setClearColor(r,1);this.RenderOpaqueSceneDiffuse(q)},Render:function(a,b,c){if(!this.get("_emptyOpaqueScene")||!this.get("_emptyTransparentScene")){var j=b?b:this.get("_context").clientWidth,e=c?c:this.get("_context").clientHeight;if(a||this.get("_resetRenderTarget"))this.InitializeRenderTargets(j,e),this.CameraUpdate(!1,j,e),this.set("_resetRenderTarget",!1);this.get("_renderercache");var c=this.get("_renderercache").materials.enablehighlights,
g=this.get("_renderercache").materials.enablehardedgehighlights,b=this.get("_renderercache").materials.enablehorizonhighlights,h=this.get("_renderercache").annotationsproperties.labelsproperties.visible,f=this.get("_renderercache").annotationsproperties.dimensionsproperties.visible,k=h&&f;this.UpdateShadersUniforms();var l=this.get("_ColorStackRT"),n=new d.OrthographicCamera(j/-2,j/2,e/2,e/-2,-1E5,1E5);n.position.z=1E4;var q=new d.PlaneGeometry(j,e),m,r,p,t,x;if(this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.loaded&&
this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.enabled){m=this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.data;t=this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.original_width;x=this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.original_height;var s=m.image.naturalWidth,u=m.image.naturalHeight;t||(t=s);x||(x=u);var E=j/e,A=s/x;p=r=1;E<A?r=E/A:p=A/E;r*=t/s;p*=x/u;t=-0.5*r+0.5*t/s;x=-0.5*p+
0.5*x/u}aa.Update();u=aa.GetCountPerMinute();u!=this.get("_current_fps")&&(o.Log("Average framerate: "+u),this.set("_current_fps",u));if(this.get("_emptyTransparentScene")){u=null;if(this.IsReflectionsRenderingEnabled()){u=this.get("_PeelColorRT");s=new d.Color(0,0,0);this.get("_3JSrenderer").setClearColor(s,1);this.FlipScene(this.get("_3JSsceneOp"));for(w=0;w<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++w)y=this.get("_3JSsceneOpCoincidentGroupsPasses")[w],this.FlipScene(this.get("_3JSsceneOpCoincidentGroups")[y]);
this.ApplyFctToAllMaterials(this.FlipMaterialSide(d.BackSide));w=0;y=Object.keys(this.get("_renderercache").lights.dir_light);for(K=y.length;w<K;++w)if(D=this.get("_renderercache").lights.dir_light[y[w]])D.position.set(-D.position.x,D.position.y,-D.position.z),D.needsUpdate=!0;this.RenderOpaqueScene(u,!0);this.UnflipScene(this.get("_3JSsceneOp"));for(w=0;w<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++w)y=this.get("_3JSsceneOpCoincidentGroupsPasses")[w],this.UnflipScene(this.get("_3JSsceneOpCoincidentGroups")[y]);
this.ApplyFctToAllMaterials(this.FlipMaterialSide(d.FrontSide));w=0;y=Object.keys(this.get("_renderercache").lights.dir_light);for(K=y.length;w<K;++w)if(D=this.get("_renderercache").lights.dir_light[y[w]])D.position.set(-D.position.x,D.position.y,-D.position.z),D.needsUpdate=!0}m?(this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.canvas_size.value=new d.Vector2(j,e),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop.value=m,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop_enabled.value=
1,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop_scale.value=new d.Vector2(r,p),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop_offset.value=new d.Vector2(t,x),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection.value=u,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_enabled.value=this.IsReflectionsRenderingEnabled()?1:0,j=new d.Mesh(q,this.get("_renderercache").materials.BackdropShaderMaterial),
e=new d.Scene,e.add(j),this.get("_3JSrenderer").render(e,n,a?l:null),this.get("_3JSrenderer").autoClear=!1):this.IsReflectionsRenderingEnabled()?(this.get("_3JSrenderer").setClearColor(this.get("_backgroundColor"),this.get("_backgroundAlpha")),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.canvas_size.value=new d.Vector2(j,e),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop.value=this.get("_DummyTexture"),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop_enabled.value=
0,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection.value=u,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_enabled.value=1,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.default_bg_color.value=new d.Vector4(this.get("_backgroundColor").r,this.get("_backgroundColor").g,this.get("_backgroundColor").b,this.get("_backgroundAlpha")),j=new d.Mesh(q,this.get("_renderercache").materials.BackdropShaderMaterial),e=new d.Scene,
e.add(j),this.get("_3JSrenderer").render(e,n,a?l:null),this.get("_3JSrenderer").autoClear=!1):(this.get("_3JSrenderer").setClearColor(this.get("_backgroundColor"),this.get("_backgroundAlpha")),this.get("_3JSrenderer").autoClear=!0);this.RenderOpaqueScene(a?l:null,!1);this.get("_3JSrenderer").autoClear=!1;c&&(b&&(this.get("_3JSsceneOp").overrideMaterial=this.get("_renderercache").materials.outline,this.get("_3JSrenderer").render(this.get("_3JSsceneOp"),this.get("_3JScamera"),a?l:null),this.get("_3JSsceneOp").overrideMaterial=
null),g&&this.get("_3JSrenderer").render(this.get("_3JSsceneHightlights"),this.get("_3JScamera"),a?l:null));k?this.get("_3JSrenderer").render(this.get("_3JSsceneAnnotations"),this.get("_3JScamera"),a?l:null):(h&&this.get("_3JSrenderer").render(this.get("_3JSsceneLabels"),this.get("_3JScamera"),a?l:null),f&&this.get("_3JSrenderer").render(this.get("_3JSsceneDimensions"),this.get("_3JScamera"),a?l:null))}else{this.get("_interactiveFrameRate")&&this.get("_enableInteractionOptimization")?(u>this.get("_target_fps_max")?
this.set("_current_nb_peels",this.get("_current_nb_peels")+1):u<this.get("_target_fps_min")&&this.set("_current_nb_peels",this.get("_current_nb_peels")-1),this.set("_current_nb_peels",Math.max(Math.min(this.get("_current_nb_peels"),this.get("_nb_max_peels")),this.get("_nb_min_peels")))):this.set("_current_nb_peels",this.get("_nb_max_peels"));var u=this.get("_OpaqueDepthRT"),v=this.get("_D1RT"),z=this.get("_D2RT"),s=this.get("_PeelColorRT"),E=this.get("_TransparencyStackRT"),A=this.get("_OpaqueBackgroundMaskRT"),
B=this.get("_MirrorColorStackRT"),F=this.get("_MirrorColorStackRT2"),C=this.get("_MirrorOpaqueDepthRT"),G=this.get("_MirrorPeelColorRT"),H=this.get("_MirrorTransparencyStackRT");this.get("_FadedMirrorTransparencyStackRT");var I=this.get("_MirrorOpaqueBackgroundMaskRT");this.get("_3JSsceneOp").traverse(this.SetSizeOfRTSrc(j,e));this.get("_3JSsceneTransp").traverse(this.SetSizeOfRTSrc(j,e));this.get("_3JSsceneTranspDepth").traverse(this.SetSizeOfRTSrc(j,e));this.get("_3JSsceneTranspDiffuse").traverse(this.SetSizeOfRTSrc(j,
e));this.get("_3JSsceneOpaqueDiffuse").traverse(this.SetSizeOfRTSrc(j,e));this.get("_3JSrenderer").autoClear=!0;var J=new d.Color(1,1,1),L=new d.Color(0,0,0),M=this.get("_backgroundColor"),N=this.get("_backgroundAlpha");this.get("_renderercache").materials.CopyShaderMaterial.uniforms.canvas_size.value=new d.Vector2(j,e);this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.canvas_size.value=new d.Vector2(j,e);this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBGBlend.value=
0;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBackdrop.value=0;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop.value=this.get("_DummyTexture");this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.CX1RT.value=this.get("_DummyTexture");this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.TransparencyStack.value=this.get("_DummyTexture");this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.OpaqueRT.value=
this.get("_DummyTexture");this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.ColorStackRT.value=this.get("_DummyTexture");this.get("_renderercache").materials.DepthOnlyShaderMaterial.uniforms.canvas_size.value=new d.Vector2(j,e);this.get("_renderercache").materials.D1ShaderMaterial.uniforms.canvas_size.value=new d.Vector2(j,e);this.get("_renderercache").materials.D2ShaderMaterial.uniforms.canvas_size.value=new d.Vector2(j,e);if(this.IsReflectionsRenderingEnabled()){this.FlipScene(this.get("_3JSsceneOp"));
this.FlipScene(this.get("_3JSsceneOpDepth"));this.FlipScene(this.get("_3JSsceneOpaqueDiffuse"));for(var w=0;w<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++w){var y=this.get("_3JSsceneOpCoincidentGroupsPasses")[w];this.FlipScene(this.get("_3JSsceneOpCoincidentGroups")[y]);this.FlipScene(this.get("_3JSsceneOpCoincidentGroupsDepth")[y]);this.FlipScene(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[y])}this.FlipScene(this.get("_3JSsceneTransp"));this.FlipScene(this.get("_3JSsceneTranspDepth"));
this.FlipScene(this.get("_3JSsceneTranspDiffuse"));for(w=0;w<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++w)y=this.get("_3JSsceneTranspCoincidentGroupsPasses")[w],this.FlipScene(this.get("_3JSsceneTranspCoincidentGroups")[y]),this.FlipScene(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[y]),this.FlipScene(this.get("_3JSsceneTranspCoincidentGroupsDepth")[y]);this.ApplyFctToAllMaterials(this.FlipMaterialSide(d.BackSide));for(var w=0,y=Object.keys(this.get("_renderercache").lights.dir_light),
K=y.length;w<K;++w){var D=this.get("_renderercache").lights.dir_light[y[w]];D&&(D.position.set(-D.position.x,D.position.y,-D.position.z),D.needsUpdate=!0)}this.RenderDepthPeel(!1,n,q,j,e,B,H,C,v,z,G,I,L,J);this.UnflipScene(this.get("_3JSsceneOp"));this.UnflipScene(this.get("_3JSsceneOpDepth"));this.UnflipScene(this.get("_3JSsceneOpaqueDiffuse"));for(w=0;w<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++w)y=this.get("_3JSsceneOpCoincidentGroupsPasses")[w],this.UnflipScene(this.get("_3JSsceneOpCoincidentGroups")[y]),
this.UnflipScene(this.get("_3JSsceneOpCoincidentGroupsDepth")[y]),this.UnflipScene(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[y]);this.UnflipScene(this.get("_3JSsceneTransp"));this.UnflipScene(this.get("_3JSsceneTranspDepth"));this.UnflipScene(this.get("_3JSsceneTranspDiffuse"));for(w=0;w<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++w)y=this.get("_3JSsceneTranspCoincidentGroupsPasses")[w],this.UnflipScene(this.get("_3JSsceneTranspCoincidentGroups")[y]),this.UnflipScene(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[y]),
this.UnflipScene(this.get("_3JSsceneTranspCoincidentGroupsDepth")[y]);this.ApplyFctToAllMaterials(this.FlipMaterialSide(d.FrontSide));w=0;y=Object.keys(this.get("_renderercache").lights.dir_light);for(K=y.length;w<K;++w)if(D=this.get("_renderercache").lights.dir_light[y[w]])D.position.set(-D.position.x,D.position.y,-D.position.z),D.needsUpdate=!0}this.RenderDepthPeel(c&&g,n,q,j,e,l,E,u,v,z,s,A,L,J);this.get("_3JSrenderer").getContext().colorMask(!1,!1,!1,!0);this.get("_3JSrenderer").setClearColor(L,
0);this.get("_3JSrenderer").clearTarget(l,!0,!1,!1);this.get("_3JSrenderer").getContext().colorMask(!0,!0,!0,!0);this.get("_3JSrenderer").setClearColor(L,1);this.get("_3JSrenderer").autoClearColor=!1;v=new d.Mesh(q,this.get("_renderercache").materials.ColorBlendShaderMaterial);g=new d.Scene;g.add(v);this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBGBlend.value=1;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.BGColor.value=M;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.BGAlpha.value=
N;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop.value=m;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBackdrop.value=m?1:0;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBackdropAlpha.value=m?0:1;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop_scale.value=new d.Vector2(r,p);this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop_offset.value=new d.Vector2(t,
x);this.IsReflectionsRenderingEnabled()?(this.get("_3JSrenderer").autoClearColor=!0,this.get("_3JSrenderer").setClearColor(L,0),m=new d.Mesh(q,this.get("_renderercache").materials.CopyShaderMaterial),r=new d.Scene,r.add(m),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableMirror.value=1,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.CX1RT.value=G,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.TransparencyStack.value=H,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.OpaqueRT.value=
I,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.ColorStackRT.value=B,this.get("_3JSrenderer").render(g,n,F),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableMirror.value=0,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBackdrop.value=1,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBackdropAlpha.value=1,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop_scale.value=
new d.Vector2(1,1),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop_offset.value=new d.Vector2(0,0),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop.value=F,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.CX1RT.value=s,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.TransparencyStack.value=E,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.OpaqueRT.value=A,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.ColorStackRT.value=
l,this.get("_3JSrenderer").render(g,n,B),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableMirror.value=0):(this.get("_3JSrenderer").autoClearColor=!0,this.get("_3JSrenderer").setClearColor(L,0),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableMirror.value=0,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.CX1RT.value=s,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.TransparencyStack.value=E,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.OpaqueRT.value=
A,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.ColorStackRT.value=l,this.get("_3JSrenderer").render(g,n,B));this.get("_3JSrenderer").autoClearColor=!0;if(c&&b||k||h||f)this.get("_3JSrenderer").clear(!1,!0,!1),this.get("_3JSrenderer").autoClear=!1,this.get("_3JSsceneTransp").overrideMaterial=this.get("_renderercache").materials.D0ShaderMaterial,this.get("_3JSrenderer").render(this.get("_3JSsceneTransp"),this.get("_3JScamera"),u),this.get("_3JSsceneTransp").overrideMaterial=
null,c&&b&&(this.get("_renderercache").materials.outline.uniforms.canvas_size.value=new d.Vector2(j,e),this.get("_renderercache").materials.outline.uniforms.D0RT.value=u,this.get("_3JSsceneOp").overrideMaterial=this.get("_renderercache").materials.outline,this.get("_3JSrenderer").render(this.get("_3JSsceneOp"),this.get("_3JScamera"),B),this.get("_3JSsceneOp").overrideMaterial=null,this.get("_3JSsceneTransp").overrideMaterial=this.get("_renderercache").materials.outline,this.get("_3JSrenderer").render(this.get("_3JSsceneTransp"),
this.get("_3JScamera"),B),this.get("_3JSsceneTransp").overrideMaterial=null),k?this.get("_3JSrenderer").render(this.get("_3JSsceneAnnotations"),this.get("_3JScamera"),B):(h&&this.get("_3JSrenderer").render(this.get("_3JSsceneLabels"),this.get("_3JScamera"),B),f&&this.get("_3JSrenderer").render(this.get("_3JSsceneDimensions"),this.get("_3JScamera"),B)),this.get("_3JSrenderer").autoClear=!0;a||(this.get("_3JSrenderer").setClearColor(L,0),this.get("_renderercache").materials.CopyShaderMaterial.transparent=
!0,this.get("_renderercache").materials.CopyShaderMaterial.blending=d.AdditiveBlending,this.get("_renderercache").materials.CopyShaderMaterial.uniforms.canvas_size.value=new d.Vector2(j,e),this.get("_renderercache").materials.CopyShaderMaterial.uniforms.CXRT.value=B,this.get("_renderercache").materials.CopyShaderMaterial.uniforms.OpaqueRT.value=this.get("_DummyTexture"),this.get("_renderercache").materials.CopyShaderMaterial.uniforms.EnableMask.value=0,this.get("_renderercache").materials.CopyShaderMaterial.uniforms.EnableRefOpacity.value=
0,this.get("_renderercache").materials.CopyShaderMaterial.uniforms.EnableInvRefOpacity.value=0,m=new d.Mesh(q,this.get("_renderercache").materials.CopyShaderMaterial),r=new d.Scene,r.add(m),this.get("_3JSrenderer").render(r,n,null));this.get("_3JSrenderer").autoClear=!1}this.get("_3JSrenderer").autoClear=!0;a&&this.set("_resetRenderTarget",!0)}},StartInteractiveFramerate:function(){this.set("_interactiveFrameRate",!0);this.set("_current_nb_peels",this.get("_nb_min_peels"))},EndInteractiveFramerate:function(a){this.set("_interactiveFrameRate",
!1);(void 0===a||a)&&this.Render()},Animate:function(){o.Log("View Animate function");var a=this,b=function(){if(a.get("_enableAnimations")){requestAnimationFrame(b);var c=a.get("_renderercache").cameras.defaultcamera;c.azimuthAngle=(c.azimuthAngle+0.1+180)%360-180;a.CameraUpdate();a.Render()}};b()},Resize:function(a,b,c){this.get("_3JSrenderer").setSize(b?b:this.get("_context").clientWidth,c?c:this.get("_context").clientHeight);this.InitializeRenderTargets();this.CameraUpdate(!0,b,c)},SetHighlights:function(a,
b){this.get("_renderercache").materials.enablehighlights=a;this.ApplyHighlightsConfiguration();(void 0==b||b)&&this.Render()},SetHighlightsConfiguration:function(a,b,c){var d=this.get("_renderercache").materials;d.enablehardedgehighlights=b;d.enablehorizonhighlights=a;this.ApplyHighlightsConfiguration();(void 0==c||c)&&this.Render()},ApplyHighlightsConfiguration:function(){var a=this.get("_renderercache").materials,a=a.enablehardedgehighlights&&a.enablehighlights;this.get("_renderercache").materials.highlight.polygonOffset=
a},SetHighlightsColor:function(a,b,c,j){this.get("_renderercache").materials.highlight.color.setHex((a<<16)+(b<<8)+c);this.get("_renderercache").materials.outline.uniforms.color.value=new d.Vector3(a/255,b/255,c/255);this.get("_renderercache").materials.enablehighlights&&(void 0==j||j)&&this.Render()},SetBackgroundColor:function(a,b,c,j,e){this.set("_backgroundColor",new d.Color(a,b,c));this.set("_backgroundAlpha",j);this.get("_renderercache").materials.hasOwnProperty("ColorBlendShaderMaterial")&&
(this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.enabled=!1);(void 0==e||e)&&this.Render()},SetLabelsVisible:function(a,b,c,d){var e=this.get("_renderercache").nodeviewproperties;if(a){if(void 0==e[a].threejsnodes.labelnode)throw"SetLabelsVisible: invalid labelnode";e[a].threejsnodes.labelnode.visible=b;e[a].threejsnodes.labelnode._visible_rank=c}else this.get("_renderercache").annotationsproperties.labelsproperties.visible=b;(void 0==d||d)&&this.CameraUpdate(!0)},SetDimensionsVisible:function(a,
b,c,j,e,g,h,f,k,l,n){var q=this.get("_renderercache").nodeviewproperties;if(a)if(void 0==q[a].threejsnodes.dimensionsnode||"undefined"!==typeof l&&l){"undefined"!==typeof l&&l&&"undefined"!==typeof q[a].threejsnodes.dimensionsnode&&this.get("_3JSsceneDimensions").remove(q[a].threejsnodes.dimensionsnode);l=new d.Object3D;l.visible=b||j||g;var m=q[a].threejsnodes[Object.keys(q[a].threejsnodes)[0]],m=m[Object.keys(m)[0]],m=new d.BoundingBoxHelper(m,16777215);m.update();for(var m=m.box,r=m.size(),p=this.get("_textSpriteMaker"),
o,x,s,u=0;4>u;u++){switch(u){case 0:o="BottomFront";x="RightBack";s="RightBottom";break;case 1:o="TopFront";x="RightFront";s="LeftBottom";break;case 2:o="TopBack";x="LeftFront";s="RightTop";break;case 3:o="BottomBack",x="LeftBack",s="LeftTop"}var v=new d.Vector3(m.max.x,m.min.y+(m.max.y-m.min.y)/2,m.min.z);"TopFront"==o?v.z=m.max.z:"TopBack"==o?(v.x=m.min.x,v.z=m.max.z):"BottomBack"==o&&(v.x=m.min.x);var A=new d.Vector3(m.min.x,m.max.y,m.min.z+(m.max.z-m.min.z)/2);"RightFront"==x?A.x=m.max.x:"LeftFront"==
x?(A.x=m.max.x,A.y=m.min.y):"LeftBack"==x&&(A.y=m.min.y);var z=new d.Vector3(m.min.x+(m.max.x-m.min.x)/2,m.max.y,m.min.z);"LeftBottom"==s?z.y=m.min.y:"RightTop"==s?z.z=m.max.z:"LeftTop"==s&&(z.y=m.min.y,z.z=m.max.z);"undefined"===typeof k&&(k=0);var C,B,F;null==f?(C=r.y.toFixed(k),B=r.z.toFixed(k),F=r.x.toFixed(k)):(C=f.hasOwnProperty("width_sub_text")&&""!=f.width_sub_text?f.width_sub_text:r.y.toFixed(k),B=f.hasOwnProperty("height_sub_text")&&""!=f.height_sub_text?f.height_sub_text:r.z.toFixed(k),
F=f.hasOwnProperty("depth_sub_text")&&""!=f.depth_sub_text?f.depth_sub_text:r.x.toFixed(k),f.hasOwnProperty("width_prefix")&&(C=f.width_prefix+C),f.hasOwnProperty("height_prefix")&&(B=f.height_prefix+B),f.hasOwnProperty("depth_prefix")&&(F=f.depth_prefix+F),f.hasOwnProperty("width_suffix")&&(C+=f.width_suffix),f.hasOwnProperty("height_suffix")&&(B+=f.height_suffix),f.hasOwnProperty("depth_suffix")&&(F+=f.depth_suffix));C=p.MakeTextSprite(C,this.get("_renderercache").annotationsproperties.dimensionsproperties.parameters,
v,!1,!1,"BottomFront"==o||"BottomBack"==o,"TopFront"==o||"TopBack"==o,"BottomFront"==o||"TopFront"==o,"BottomBack"==o||"TopBack"==o);C.visible=b;B=p.MakeTextSprite(B,this.get("_renderercache").annotationsproperties.dimensionsproperties.parameters,A,"RightBack"==x||"RightFront"==x,"LeftBack"==x||"LeftFront"==x,!1,!1,"LeftFront"==x||"RightFront"==x,"LeftBack"==x||"RightBack"==x);B.visible=j;F=p.MakeTextSprite(F,this.get("_renderercache").annotationsproperties.dimensionsproperties.parameters,z,"RightBottom"==
s||"RightTop"==s,"LeftBottom"==s||"LeftTop"==s,"RightBottom"==s||"LeftBottom"==s,"RightTop"==s||"LeftTop"==s,!1,!1);F.visible=g;l.add(C,B,F);this.get("_3JSdimensionsBBox").box.expandByPoint(v);this.get("_3JSdimensionsBBox").box.expandByPoint(A);this.get("_3JSdimensionsBBox").box.expandByPoint(z)}l._visible_rank_w=c;l._visible_rank_h=e;l._visible_rank_d=h;l.user_visibility_w=b;l.user_visibility_h=j;l.user_visibility_d=g;this.get("_3JSsceneDimensions").add(l);q[a].threejsnodes.dimensionsnode=l;this.CameraUpdate(!1)}else{for(u=
0;4>u;u+=3)q[a].threejsnodes.dimensionsnode.children[i].visible=b,q[a].threejsnodes.dimensionsnode.children[i+1].visible=j,q[a].threejsnodes.dimensionsnode.children[i+2].visible=g;q[a].threejsnodes.dimensionsnode.visible=b||j||g;q[a].threejsnodes.dimensionsnode._visible_rank_w=c;q[a].threejsnodes.dimensionsnode._visible_rank_h=e;q[a].threejsnodes.dimensionsnode._visible_rank_d=h;q[a].threejsnodes.dimensionsnode.user_visibility_w=b;q[a].threejsnodes.dimensionsnode.user_visibility_h=j;q[a].threejsnodes.dimensionsnode.user_visibility_d=
g}else this.get("_renderercache").annotationsproperties.dimensionsproperties.visible=b||j||g;(void 0==n||n)&&this.Render()},SetLabelText:function(a,b,c,j){var e=this.get("_renderercache").nodeviewproperties;if("undefined"===typeof e[a]||!a)throw"ViewerView: Invalid node URL";"undefined"!==typeof e[a].threejsnodes.labelnode&&this.get("_3JSsceneLabels").remove(e[a].threejsnodes.labelnode);var g=e[a].threejsnodes[Object.keys(e[a].threejsnodes)[0]],g=g[Object.keys(g)[0]],g=new d.BoundingBoxHelper(g,16777215);
g.update();for(var h=g.box,g=this.get("_textSpriteMaker"),f=h.max,h=h.min,f=[{x:h.x,y:h.y,z:h.z,horPosOffset:!1,vertPosOffset:!0,depthPosOffset:!1},{x:h.x,y:h.y,z:f.z,horPosOffset:!1,vertPosOffset:!1,depthPosOffset:!1},{x:h.x,y:f.y,z:h.z,horPosOffset:!0,vertPosOffset:!0,depthPosOffset:!1},{x:h.x,y:f.y,z:f.z,horPosOffset:!0,vertPosOffset:!1,depthPosOffset:!1},{x:f.x,y:h.y,z:h.z,horPosOffset:!1,vertPosOffset:!0,depthPosOffset:!0},{x:f.x,y:h.y,z:f.z,horPosOffset:!1,vertPosOffset:!1,depthPosOffset:!0},
{x:f.x,y:f.y,z:h.z,horPosOffset:!0,vertPosOffset:!0,depthPosOffset:!0},{x:f.x,y:f.y,z:f.z,horPosOffset:!0,vertPosOffset:!1,depthPosOffset:!0}],h=new d.Object3D,k=0;8>k;++k){var l=f[k],n=new d.Vector3(l.x,l.y,l.z),l=g.MakeTextSprite(b,this.get("_renderercache").annotationsproperties.labelsproperties.parameters,n,l.horPosOffset,!l.horPosOffset,l.vertPosOffset,!l.vertPosOffset,l.depthPosOffset,!l.depthPosOffset);this.get("_3JSlabelsBBox").box.expandByPoint(n);h.add(l)}h._visible_rank=c;this.get("_3JSsceneLabels").add(h);
e[a].threejsnodes.labelnode=h;e[a].threejsnodes.labelnode.user_visibility=0!=c;this.CameraUpdate(j)},SetLabelsParameters:function(a,b){this.get("_renderercache").annotationsproperties.labelsproperties.parameters=a;(void 0==b||b)&&this.Render()},SetDimensionsParameters:function(a,b){this.get("_renderercache").annotationsproperties.dimensionsproperties.parameters=a;(void 0==b||b)&&this.Render()},ResetMainSceneVisibility:function(a){var b=function(a){a instanceof d.Scene||a instanceof d.Mesh||(a.visible=
!0)};this.get("_3JSsceneOp").traverse(b);this.get("_3JSsceneTransp").traverse(b);this.get("_3JSsceneHightlights").traverse(b);(void 0==a||a)&&this.Render()},ToggleNodeVisibility:function(a,b,c,d){this.SetNodeVisibility(a,null,b,c,d)},SetNodeVisibility:function(a,b,c,j,e){for(var g,h=0,f=Object.keys(this.get("_renderercache").nodeviewproperties[a].threejsnodes),k=f.length;h<k;++h){var l=function(a){a instanceof d.Scene||a instanceof d.Mesh||(a.visible=null===b?!a.visible:b)};g=this.get("_renderercache").nodeviewproperties[a].threejsnodes[f[h]];
for(var n=0,o=Object.keys(g),m=o.length;n<m;n++){var r=g[o[n]];l(r);if(void 0!=c&&c)for(var p=0,t=Object.keys(r.children),v=t.length;p<v;++p)r.children[t[p]].traverse(l);void 0!=j&&j&&r.parent&&r.parent.traverseParents(l)}}(void 0==e||e)&&this.Render()},GetNodeInfo:function(a,b){switch(b){case "NODEOBJECTVIS":var c=a.threejsnodes[Object.keys(a.threejsnodes)[0]];return c[Object.keys(c)[0]].visible;case "NODELABELVIS":if(c=a.threejsnodes.labelnode)return c._visible_rank;o.Log("ViewerView Warning: No existing label for "+
a);return 0;case "NODEDIMENSIONVISINFO":if(c=a.threejsnodes.dimensionsnode){for(var d=c.children,e=!1,g=!1,h=!1,f=0;12>f;f+=3)e=e||d[f].visible,g=g||d[f+1].visible,h=h||d[f+2].visible;c={width:e,height:g,depth:h,w_rank:c._visible_rank_w,h_rank:c._visible_rank_h,d_rank:c._visible_rank_d}}else o.Log("No existing dimensions for "+a),c={width:!1,height:!1,depth:!1,w_rank:0,h_rank:0,d_rank:0};return c;default:console.err("Unknown queried data type")}},Get:function(a,b){var c=this.get("_renderercache").nodeviewproperties[a];
if(c)return this.GetNodeInfo(c,b);o.Log("ViewerView Warning: No existing node for "+a)},LogMemoryReport:function(){o.Log("Node View Properties Size: "+v.get("SizeOf")(this.get("_renderercache").nodeviewproperties)/1E6+"MB");o.Log("_3JSsceneOp Size: "+v.get("SizeOf")(this.get("_3JSsceneOp"))/1E6+"MB");o.Log("_3JSsceneOpDepth Size: "+v.get("SizeOf")(this.get("_3JSsceneOpDepth"))/1E6+"MB");o.Log("_3JSsceneOpaqueDiffuse Size: "+v.get("SizeOf")(this.get("_3JSsceneOpaqueDiffuse"))/1E6+"MB");o.Log("_3JSsceneTransp Size: "+
v.get("SizeOf")(this.get("_3JSsceneTransp"))/1E6+"MB");o.Log("_3JSsceneTranspDepth Size: "+v.get("SizeOf")(this.get("_3JSsceneTranspDepth"))/1E6+"MB");o.Log("_3JSsceneTranspDiffuse Size: "+v.get("SizeOf")(this.get("_3JSsceneTranspDiffuse"))/1E6+"MB");for(var a=0;a<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++a){var b=this.get("_3JSsceneOpCoincidentGroupsPasses")[a];o.Log("_3JSsceneOpCoincidentGroups["+b+"] Size: "+v.get("SizeOf")(this.get("_3JSsceneOpCoincidentGroups")[b])/1E6+"MB");o.Log("_3JSsceneOpCoincidentGroupsDepth["+
b+"] Size: "+v.get("SizeOf")(this.get("_3JSsceneOpCoincidentGroupsDepth")[b])/1E6+"MB");o.Log("_3JSsceneOpCoincidentGroupsDiffuse["+b+"] Size: "+v.get("SizeOf")(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[b])/1E6+"MB")}for(a=0;a<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++a)b=this.get("_3JSsceneTranspCoincidentGroupsPasses")[a],o.Log("_3JSsceneTranspCoincidentGroups["+b+"] Size: "+v.get("SizeOf")(this.get("_3JSsceneTranspCoincidentGroups")[b])/1E6+"MB"),o.Log("_3JSsceneTranspCoincidentGroupsDepth["+
b+"] Size: "+v.get("SizeOf")(this.get("_3JSsceneTranspCoincidentGroupsDepth")[b])/1E6+"MB"),o.Log("_3JSsceneTranspCoincidentGroupsDiffuse["+b+"] Size: "+v.get("SizeOf")(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[b])/1E6+"MB");o.Log("_3JSsceneHightlights Size: "+v.get("SizeOf")(this.get("_3JSsceneHightlights"))/1E6+"MB");o.Log("_3JSsceneLabels Size: "+v.get("SizeOf")(this.get("_3JSsceneLabels"))/1E6+"MB");o.Log("_3JSsceneDimensions Size: "+v.get("SizeOf")(this.get("_3JSsceneDimensions"))/1E6+
"MB");o.Log("_3JSsceneAnnotations Size: "+v.get("SizeOf")(this.get("_3JSsceneAnnotations"))/1E6+"MB")},SetReflections:function(a,b,c,d,e,g){this.set("_reflection_config",a);"ON"==a?this.UpdateReflectionUniforms(b,c,d,e):"JSON"==a&&this.UpdateReflectionUniforms();(void 0==g||g)&&this.Render()},SetAnimations:function(a){this.set("_enableAnimations",a);this.Animate()},SetInteractionOptimization:function(a){this.set("_enableInteractionOptimization",a)},SetQualityLevel:function(a,b){this.set("_nb_max_peels",
a);(void 0==b||b)&&this.Render()},SetLightingContrast:function(a,b){this.set("_lighting_contrast",a);this.UpdateLightingContrast();(void 0==b||b)&&this.Render()},UpdateLightingContrast:function(){for(var a=0,b=Object.keys(this.get("_renderercache").lights.dir_light),c=b.length;a<c;a++){var j=b[a];this.get("_renderercache").lights.dir_light[j].intensity=this.get("_lighting_contrast")}a=0;b=Object.keys(this.get("_renderercache").lights.amb_light);for(c=b.length;a<c;a++){var j=b[a],j=this.get("_renderercache").lights.amb_light[j],
e=100+100*(0.5-this.get("_lighting_contrast")),g=new d.Color(7829367);g.r=g.r*e/100;g.g=g.g*e/100;g.b=g.b*e/100;j.color=g}},AppendRendererToDocument:function(){"function"===typeof this.get("_context").appendChild&&this.get("_context").appendChild(this.get("_3JSrenderer").domElement)},GetSnapshot:function(a,b,c){this.Render(!0,b,c);var d=this.get("_3JSrenderer").getContext(),e=new Uint8Array(4*b*c);d.readPixels(0,0,b,c,d.RGBA,d.UNSIGNED_BYTE,e);d=document.createElement("canvas");d.width=b;d.height=
c;var g=d.getContext("2d"),b=g.createImageData(b,c);b.data.set(e);for(var h,f,k,e=0;e<b.height/2;e++)for(c=0;c<b.width;c++)h=b.width*e+c,f=b.width*(b.height-1-e)+c,h*=4,f*=4,k=b.data[f],b.data[f]=b.data[h],b.data[h]=k,k=b.data[f+1],b.data[f+1]=b.data[h+1],b.data[h+1]=k,k=b.data[f+2],b.data[f+2]=b.data[h+2],b.data[h+2]=k,k=b.data[f+3],b.data[f+3]=b.data[h+3],b.data[h+3]=k;g.putImageData(b,0,0);"function"===typeof this.get("_context").appendChild&&this.CameraUpdate(!0,this.get("_context").clientWidth,
this.get("_context").clientHeight);return d.toDataURL("image/"+a)}})});