/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("component/smartnames/encoding/smartnamestringpart",["require","exports","module"],function(k,l){var m=function(){};(function(){this.isSmartNamePart=function(){return null!==this._smartName};this.isTextPart=function(){return null!==this._text};this.getAsSmartName=function(){return this._smartName};this.getAsText=function(){return this._text}}).call(m.prototype);l.makeSmartNamePart=function(d){if(null==d)throw'A "SmartName" part of a SmartName string can not be null.';var i=new m;i._smartName=
d;i._text=null;return i};l.makePlainTextPart=function(d){if(null==d)throw'A "Text" part of a SmartName string can not be null.';var i=new m;i._smartName=null;i._text=d;return i}});
define("component/smartnames/encoding/smartnameargumentencoding",["utils/wcrerror","utils/extendedstring"],function(k){var l={},m=function(d,i){this._delimeterChar=d;this._escapeChar=i};(function(){this.encodeSmartName=function(d,i){for(var f=d,c=0;c<i.length;c++)var j=i[c].replaceAll(this._escapeChar,this._escapeChar+this._escapeChar).replaceAll(this._delimeterChar,this._escapeChar+this._delimeterChar),f=f+this._delimeterChar,f=f+j;return f.toString()};this.decodeSmartNameArguments=function(d){for(var i=
[],f=!1,c="",j=0;j<d.length;j++){var a=d.charAt(j);if(a===this._escapeChar)f&&(c+=this._escapeChar),f=!f;else if(a===this._delimeterChar)f?(c+=this._delimeterChar,f=!1):(i.push(c),c="");else{if(f)throw new k("SMARTNAME_ARGUMENT_PARSING_ILLEGAL_ESCAPE_CHARACTER","Parsing of arguments of SmartName failed. Found a single escape character in the string.");c+=a}}i.push(c);if(f)throw new k("SMARTNAME_ARGUMENT_PARSING_ILLEGAL_ESCAPE_CHARACTER","Parsing of arguments of SmartName failed. Found a single escape character in the string.");
return i}}).call(m.prototype);l.DEFAULT=new m(":","\\");l.constructor=m;return l});
define("component/smartnames/encoding/smartname",["../encoding/smartnameargumentencoding"],function(k){var l=function(){if(1===arguments.length){var l=k.DEFAULT.decodeSmartNameArguments(arguments[0]);this._name=l[0];this._arguments=1<l.length?l.slice(1,l.length):[]}else if(1<arguments.length)this._name=arguments[0],2==arguments.length&&arguments[1].constructor==Array?this._arguments=arguments[1]:(this._arguments=Array.prototype.slice.call(arguments),this._arguments=this._arguments.slice(1,this._arguments.length));
else if(1>arguments.length)throw Error("A SmartName requires at least one 'name' parameter.");};(function(){this.getName=function(){return this._name};this.getArguments=function(){return this._arguments};this.getFullName=function(){return k.DEFAULT.encodeSmartName(this._name,this._arguments)};this.equals=function(k){if(k instanceof l){var d=k.getName()===this.getName(),k=this._compareArguments(k);return d&&k}return!1};this._compareArguments=function(k){if(this._arguments.length===k.getArguments().length){for(var d=
0;d<this._arguments.length;d++)if(this._arguments[d]!==k.getArguments()[d])return!1;return!0}return!1}}).call(l.prototype);return l});
define("component/smartnames/encoding/smartnameencoding",["./smartnamestringpart","./smartname","utils/wcrerror","underscore","utils/extendedstring"],function(k,l,m,d){function i(j){if(!1===j)throw Error("Something is wrong in the implementation of the SmartNameEncoding. Assert failed.");}var f={},c=function(j,a,h,g,b){this._startOfSmartName=j;this._endOfSmartName=a;this._escapeChar=h;if(this._fuzzyEncoding=g)this._smartnameLookupFunction=b;this._charactersToEscape=[];g=h+j+a;for(b=0;b<g.length;b++){var c=
g.charAt(b);d.contains(this._charactersToEscape,c)||this._charactersToEscape.push(c)}this._charactersToEscape=[h,j.charAt(0),a.charAt(0)];i(-1===j.indexOf(h));i(-1===a.indexOf(h))};(function(){this.escapeString=function(c){return this._fuzzyEncoding?c:this._escapeStringInternal(c)};this._escapeStringInternal=function(c){for(var a=0;a<this._charactersToEscape.length;a++)c=c.replaceAll(""+this._charactersToEscape[a],""+this._escapeChar+this._charactersToEscape[a]);return c};this.unescapeString=function(c){return this._fuzzyEncoding?
c:this._unescapeStringInternal(c)};this._unescapeStringInternal=function(c){for(var a=this._charactersToEscape.length-1;0<=a;a--)c=c.replaceAll(""+this._escapeChar+this._charactersToEscape[a],""+this._charactersToEscape[a]);return c};this.encodeSmartNameString=function(c){for(var a="",h="",g=0;g<c.length;g++){var b=c[g];b.isTextPart()?h+=b.getAsText():(a+=this.escapeString(h),h="",a+=this._startOfSmartName,a+=this._escapeStringInternal(b.getAsSmartName().getFullName()),a+=this._endOfSmartName)}return a+=
this.escapeString(h)};this.encodeSmartNameStringSingleSmartName=function(c){return this._startOfSmartName+this._escapeStringInternal(c.getFullName())+this._endOfSmartName};this._revertDecodedOpenSmartName=function(c,a){var h="";0<a.length&&a[a.length-1].isTextPart()&&(h+=a.pop().getAsText());return h+c};this.decodeSmartNameString=function(c){for(var a=[],h=-1,g="",b=0;b<c.length;b++){var n=c.charAt(b);if(n===this._escapeChar)if(this._fuzzyEncoding&&-1===h)g+=n;else if(b+1<c.length){var e=c.charAt(b+
1);if(d.contains(this._charactersToEscape,e))g+=e,b++;else if(this._fuzzyEncoding)g=this._revertDecodedOpenSmartName(c.substring(h,b),a),g+=n,h=-1;else throw new m("SMARTNAME_PARSING_ILLEGAL_ESCAPE_CHARACTER","Parsing of string with SmartNames failed. Found a single escape character in the string.");}else if(this._fuzzyEncoding)g=this._revertDecodedOpenSmartName(c.substring(h,b),a),g+=n,h=-1;else throw new m("SMARTNAME_PARSING_ILLEGAL_ESCAPE_CHARACTER","Parsing of string with SmartNames failed. Found a single escape character in the string.");
else if(b+this._startOfSmartName.length<=c.length&&this._startOfSmartName===c.substring(b,b+this._startOfSmartName.length)){this._fuzzyEncoding&&0<=h&&(g=this._revertDecodedOpenSmartName(c.substring(h,b),a),h=-1);if(0<=h)throw new m("SMARTNAME_PARSING_SMARTNAME_ALREADY_OPEN","Parsing of string with SmartNames failed. SmartName started within a SmartName.");0<g.length&&a.push(k.makePlainTextPart(g));g="";h=b;b+=this._startOfSmartName.length-1}else if(b+this._endOfSmartName.length<=c.length&&this._endOfSmartName===
c.substring(b,b+this._endOfSmartName.length)){if(-1===h)if(this._fuzzyEncoding){g+=n;continue}else throw new m("SMARTNAME_PARSING_SMARTNAME_NOT_OPEN","Parsing of string with SmartNames failed. SmartName was closed before the SmartName was opened.");else{e=null;try{e=new l(g)}catch(o){if(this._fuzzyEncoding){g=this._revertDecodedOpenSmartName(c.substring(h,b),a);g+=n;h=-1;continue}else throw o;}if(this._fuzzyEncoding&&!this._smartnameLookupFunction(e)){g=this._revertDecodedOpenSmartName(c.substring(h,
b),a);g+=n;h=-1;continue}a.push(k.makeSmartNamePart(e));g="";h=-1}b+=this._endOfSmartName.length-1}else g+=n}this._fuzzyEncoding&&0<=h&&(g=this._revertDecodedOpenSmartName(c.substring(h),a),h=-1);if(0<=h)throw new m("SMARTNAME_PARSING_SMARTNAME_NEVER_CLOSED","Parsing of string with SmartNames failed. SmartName was never closed.");0<g.length&&a.push(k.makePlainTextPart(g));return a};this.containsSmartName=function(c){if(c)for(var c=this.decodeSmartNameString(c),a=0;a<c.length;a++)if(c[a].isSmartNamePart())return!0;
return!1};this.modifySmartNameEncodedString=function(c,a,h){if(void 0===a||null===a)a=function(b){return b};if(void 0===h||null===h)h=function(b){return b};for(var c=this.decodeSmartNameString(c),g=0;g<c.length;g++){var b=c[g];b.isSmartNamePart()?(b=b.getAsSmartName(),b=h(b),c[g]=k.makeSmartNamePart(b)):(b=b.getAsText(),b=a(b),c[g]=k.makePlainTextPart(b))}return this.encodeSmartNameString(c)}}).call(c.prototype);f.SAVEDSEARCH=new c("{","}","!",!1);f.AUTONAMING=new c("[","]","\u00a7",!1);f.WORKFLOWEDITOR=
new c("<","/>","\u00a7",!0,function(c){c.getName();return!0});f.UNIVERSALCOPYPASTEENCODING=new c("[","]","\\",!1);f.constructor=c;return f});define("utils/webcss-text!component/smartnames/input/smartnameeditpanel-style.css",[],function(){return".WcrPageContent .SmartNameEditPopover {\r\n\tz-index: 61;\r\n\tborder: 1px solid #ccc;\r\n\tbackground-color: rgba(250,250,250,1);\r\n}\r\n.WcrPageContent .SmartNameParamConfig {\r\n\twidth: 485px;\r\n\tmargin: 8px;\r\n}\r\n.WcrPageContent .SmartNameParamConfig .form-compact .form-group label {\r\n\ttext-align: right;\r\n}\r\n.WcrPageContent .SmartNameParamConfig .ToolbarWrapper {\r\n\twidth: 100%;\r\n\tmargin-top: -8px;\r\n}\r\n.WcrPageContent .SmartNameParamConfig .ToolbarWrapper > .AddRemoveButtonWrapper {\r\n\tfloat: left;\r\n\ttext-align: left;\r\n}\r\n.WcrPageContent .SmartNameParamConfig .ToolbarWrapper > .AddRemoveButtonWrapper > button {\r\n\tmargin-right: 3px;\r\n}\r\n.WcrPageContent .SmartNameParamConfig .ToolbarWrapper > .SaveCancelButtonWrapper {\r\n\tfloat: right;\r\n\ttext-align: right;\r\n}\r\n.WcrPageContent .SmartNameParamConfig .ToolbarWrapper > .SaveCancelButtonWrapper > button {\r\n\tmargin-left: 3px;\r\n}"});
define("component/smartnames/input/smartnameeditpanel-view",["jquery","utils/webi18n!SmartNameSelector","utils/webcss!./smartnameeditpanel-style.css"],function(k,l){var m=function(d,i,f){this._parameterSmartFields=[];this._labels=f&&f.labels?f.labels:[];this._hasStrictParams=f&&!0==f.hasStrictParams?!0:!1;f.smartnameInputOptions.dictionaryService&&(this._dictionaryService=f.smartnameInputOptions.dictionaryService);f.smartnameInputOptions.encoding&&(this._encoding=f.smartnameInputOptions.encoding);
f.smartnameInputOptions.displayFunction&&(this._displayFunction=f.smartnameInputOptions.displayFunction);f.smartnameInputOptions.selectorDisplayFunction&&(this._selectorDisplayFunction=f.smartnameInputOptions.selectorDisplayFunction);this._onSave=[];this._onCancel=[];this._wrapper=k("<div>",{"class":"SmartNameParamConfig"});this._paramForm=k("<div>",{"class":"parameter-panel form-horizontal form-compact notOnlyOffsetLabels"});if(0<i.length||0<this._labels.length){for(d=0;d<i.length;d++)this.addParameter(i[d]);
i=this._labels.length-i.length;if(0<i)for(d=0;d<i;d++)this.addParameter("")}else this.addParameter("");i=k("<div>",{"class":"AddRemoveButtonWrapper"});d=k("<i>",{"class":"icon icon-WCR_Plus"});this._addParameterButton=k("<button>",{"class":"btn btn-default btn-xs"}).append(d);this._addParameterButton.on("click",function(){this.addParameter("")}.bind(this));d=k("<i>",{"class":"icon icon-WCR_Minus"});this._removeParameterButton=k("<button>",{"class":"btn btn-default btn-xs"}).append(d);this._removeParameterButton.on("click",
function(){this.removeLastParameter()}.bind(this));d=k("<div>",{"class":"SaveCancelButtonWrapper"});this._saveButton=k("<button>",{"class":"btn btn-primary btn-xs"}).text(l.t("SMARTNAME_EDIT_SAVE"));this._saveButton.on("click",function(){this.doSave()}.bind(this));this._cancelButton=k("<button>",{"class":"btn btn-default btn-xs"}).append(l.t("SMARTNAME_EDIT_CANCEL"));this._cancelButton.on("click",function(){this.doCancel()}.bind(this));f=k("<div>",{"class":"ToolbarWrapper clearfix"});i.append(this._addParameterButton);
i.append(this._removeParameterButton);d.append(this._cancelButton);d.append(this._saveButton);this._hasStrictParams||f.append(i);f.append(d);this._wrapper.append(this._paramForm);this._wrapper.append(f)};m.prototype.addParameter=function(d){var i=this._parameterSmartFields.length,f=k("<div>",{"class":"form-group"}),c="Param "+(i+1);i<this._labels.length&&(this._labels[i]&&0<this._labels[i].length)&&(c=this._labels[i]);i=k("<label>",{"class":"col-sm-12 col-lg-4"}).text(c);f.append(i);i=new (require("component/smartnames/smartfield/smartfield"))(k("<input>",
{type:"text"}),!1,this._dictionaryService,this._displayFunction,this._selectorDisplayFunction,this._encoding);i.setWidth("100%");c=k("<div>",{"class":"col-sm-12 col-lg-8"}).append(i.getJQElement());f.append(c);i.setIsInline(!0);i.setValue(d);this._parameterSmartFields.push(i);this._paramForm.append(f)};m.prototype.removeLastParameter=function(){0!==this._parameterSmartFields.length&&(this._parameterSmartFields.splice(-1,1),this._paramForm.children().last().remove())};m.prototype.getArguments=function(){for(var d=
[],i=0;i<this._parameterSmartFields.length;i++){var f=this._parameterSmartFields[i].getValue();void 0!==f&&d.push(f)}return d};m.prototype.onSave=function(d){this._onSave.push(d)};m.prototype.onCancel=function(d){this._onCancel.push(d)};m.prototype.doSave=function(){for(var d=0;d<this._onSave.length;d++)this._onSave[d]()};m.prototype.doCancel=function(){for(var d=0;d<this._onCancel.length;d++)this._onCancel[d]()};m.prototype.getJQElement=function(){return this._wrapper};m.prototype.disable=function(){this._saveButton.hide();
for(var d=0;d<this._parameterSmartFields.length;d++)this._parameterSmartFields[d].disable()};m.prototype.enable=function(){this._saveButton.show();for(var d=0;d<this._parameterSmartFields.length;d++)this._parameterSmartFields[d].enable()};m.prototype.destroy=function(){for(var d=0;d<this._parameterSmartFields.length;d++)this._parameterSmartFields[d].destroy()};m.prototype.resize=function(){for(var d=0;d<this._parameterSmartFields.length;d++)this._parameterSmartFields[d].resize()};return m});
define("component/smartnames/input/smartnameeditpanel",["jquery","./smartnameeditpanel-view","component/smartnames/encoding/smartname"],function(k,l,m){k=function(d,i){this._name=d.getName();this._arguments=d.getArguments();this._view=new l(this._name,this._arguments,i)};k.prototype.getName=function(){return this._name};k.prototype.getArguments=function(){return this._view.getArguments()};k.prototype.getSmartName=function(){return new m(this.getName(),this.getArguments())};k.prototype.onSave=function(d){this._view.onSave(d)};
k.prototype.onCancel=function(d){this._view.onCancel(d)};k.prototype.getJQElement=function(){return this._view.getJQElement()};k.prototype.disable=function(){this._view.disable()};k.prototype.enable=function(){this._view.enable()};k.prototype.resize=function(){this._view.resize()};k.prototype.destroy=function(){this._view.destroy()};return k});define("utils/webcss-text!component/popover/popover-style.css",[],function(){return"\r\n.wcr-popover {\r\n\tz-index: 10;\r\n\tposition: absolute;\r\n\tbackground-color: #bbbbbb;\r\n\tborder: 0;\r\n}\r\n.wcr-popover.opened-bottom, \r\n.wcr-popover.opened-left, \r\n.wcr-popover.opened-right, {\r\n\t-webkit-box-shadow: 0 5px 10px rgba(0, 0, 0, 0.2);\r\n\t-moz-box-shadow: 0 5px 10px rgba(0, 0, 0, 0.2);\r\n\tbox-shadow: 0 5px 10px rgba(0, 0, 0, 0.2);\r\n}\r\n.wcr-popover.opened-top {\r\n\t-webkit-box-shadow: 5px 0px 10px rgba(0, 0, 0, 0.2);\r\n\t-moz-box-shadow: 5px 0px 10px rgba(0, 0, 0, 0.2);\r\n\tbox-shadow: 0px 0px 10px rgba(0, 0, 0, 0.2);\r\n}\r\n.wcr-popover .arrow-up,\r\n.wcr-popover .arrow-right,\r\n.wcr-popover .arrow-down,\r\n.wcr-popover .arrow-left {\r\n\tz-index: 10;\r\n\tposition: absolute;\r\n\twidth: 0;\r\n\theight: 0;\r\n}\r\n.wcr-popover .arrow-up,\r\n.wcr-popover .arrow-down {\r\n\tborder-left: 7px solid transparent;\r\n\tborder-right: 7px solid transparent;\r\n}\r\n.wcr-popover .arrow-right,\r\n.wcr-popover .arrow-left {\r\n\tborder-top: 7px solid transparent;\r\n\tborder-bottom: 7px solid transparent;\r\n}\r\n.wcr-popover .arrow-up {\r\n\tborder-bottom: 7px solid #bbbbbb;\r\n}\r\n.wcr-popover .arrow-right {\r\n\tborder-left: 7px solid #bbbbbb;\r\n}\r\n.wcr-popover .arrow-down {\r\n\tborder-top: 7px solid #bbbbbb;\r\n}\r\n.wcr-popover .arrow-left {\r\n\tborder-right: 7px solid #bbbbbb;\r\n}"});
define("component/popover/Popover",["utils/ShapeUtils","utils/webcss!./popover-style.css","jquery","underscore"],function(k,l,m,d){l=function(i,f,c,j,a,h,g,b,n,e){this.context=i;this.container=f;this.restrict=c;this.minHeight=b;this._placementOptions=["top","right","bottom","left"];this._hasCustomPlacementOptions=!1;this.placement=j?j:"bottom";this.element=m("<div />").addClass("wcr-popover");this.arrowColor=this.color=a;e&&(this.arrowColor=e);this.color&&this.element.css("background-color",a);(this.cssClass=
h)&&this.element.addClass(h);this.maxSizeOverwritesCss=n;this.element.on("contentResized",d.bind(function(e){this._recalculatePositions();e.stopPropagation()},this));this.restrictBorder=void 0===g?10:g;this._arrow=m("<div />");this._content=m("<div />").addClass("content");void 0===this.minHeight&&this.element.append(this._arrow);this.element.append(this._content);if(void 0===h||n)i=800,f=this.restrict.innerHeight()*this.restrictBorder,i=Math.min(i,this.restrict.innerWidth()-2*this.restrictBorder),
this._content.css({"max-height":f,"max-width":i});this._placements=void 0;this._createPlacements();this.MAX_DEPTH=this._placements.length;this._addedToContainer=!1;this._onAddedToContainerCallbacks=[];this._onDestroyCallbacks=[];this._isActive=!1};l.prototype._createPlacements=function(){this._placements=this._placementOptions.slice(0);if(!this._hasCustomPlacementOptions){var i=d.indexOf(this._placements,this.placement);0>i&&(i=0);this._placements.splice(i,0,"innerLeft")}};l.prototype.setPlacementOptions=
function(i){this._placementOptions=i.splice(0);this.placement=this._placementOptions[0]?this._placementOptions[0]:"bottom";this._hasCustomPlacementOptions=!0;this._createPlacements()};l.prototype._getContextRect=function(){return k.rectMake(this.context.offset().left,this.context.offset().top,this.context.outerWidth(!0),this.context.outerHeight(!0))};l.prototype._getRestrictRect=function(){return k.rectMake(this.restrict.offset().left,this.restrict.offset().top,this.restrict.innerWidth(),this.restrict.innerHeight())};
l.prototype._getElementSize=function(){return new k.Size(this.element.outerWidth(!0),this.element.outerHeight(!0))};l.prototype._getArrowSize=function(){return new k.Size(this._arrow.outerWidth(!0),this._arrow.outerHeight(!0))};l.prototype._restrictToBorders=function(i,d,c){i.left<c.left()+this.restrictBorder&&(i.left=c.left()+this.restrictBorder);i.top<c.top()+this.restrictBorder&&(i.top=c.top()+this.restrictBorder);i.left+d.width>c.right()-this.restrictBorder&&(i.left=Math.max(0,c.right()-d.width-
this.restrictBorder));if((void 0===this.minHeight||c.bottom()-this.restrictBorder-i.top<this.minHeight)&&i.top+d.height>c.bottom()-this.restrictBorder)i.top=Math.max(0,c.bottom()-d.height-this.restrictBorder)};l.prototype._getNextPlacement=function(i){return this._placements[(d.indexOf(this._placements,i)+1)%this._placements.length]};l.prototype._resetArrowColor=function(){this._arrow.css("border-top-color","");this._arrow.css("border-bottom-color","");this._arrow.css("border-left-color","");this._arrow.css("border-right-color",
"")};l.prototype._setArrow=function(d){this._resetArrowColor();this._arrow.removeClass();switch(d){case "top":this._arrow.addClass("arrow-down");this.arrowColor&&this._arrow.css("border-top-color",this.arrowColor);break;case "bottom":this._arrow.addClass("arrow-up");this.arrowColor&&this._arrow.css("border-bottom-color",this.arrowColor);break;case "left":this._arrow.addClass("arrow-right");this.arrowColor&&this._arrow.css("border-left-color",this.arrowColor);break;case "right":this._arrow.addClass("arrow-left");
this.arrowColor&&this._arrow.css("border-right-color",this.arrowColor);break;case "innerLeft":this._arrow.addClass("arrow-left"),this.arrowColor&&this._arrow.css("border-right-color",this.arrowColor)}};l.prototype._calculatePositions=function(d,f){if(d>=this.MAX_DEPTH)this._setArrow(this.placement);else{this._setArrow(f);var c=this._getContextRect(),j=this._getArrowSize(),a=this._getElementSize(),h=this._getRestrictRect(),g,b;switch(f){case "top":g={top:c.top()-j.height,left:c.left()+c.size.width/
2-j.width/2};b={top:c.top()-j.height-a.height,left:c.left()+c.size.width/2-a.width/2};break;case "bottom":g={top:c.top()+c.size.height,left:c.left()+c.size.width/2-j.width/2};b={top:c.top()+j.height+c.size.height,left:c.left()+c.size.width/2-a.width/2};break;case "left":g={top:c.top()+c.size.height/2-j.height/2,left:c.left()-j.width};b={top:c.top()+c.size.height/2-a.height/2,left:c.left()-j.width-a.width};break;case "right":g={top:c.top()+c.size.height/2-j.height/2,left:c.left()+c.size.width};b={top:c.top()+
c.size.height/2-a.height/2,left:c.left()+c.size.width+j.width};break;case "innerLeft":g={top:c.top()+c.size.height/2-j.height/2,left:c.left()};b={top:c.top()+c.size.height/2-a.height/2,left:c.left()+j.width};break;case "bottomLeft":g={top:c.top()+c.size.height/2-j.height/2,left:c.left()+j.width/2},b={top:c.top()+j.height+c.size.height,left:c.left()}}if(g.top<=h.top()+this.restrictBorder||g.top+j.height>=h.bottom()-this.restrictBorder||g.left<=h.left()+this.restrictBorder||g.left+j.width>=h.right()-
this.restrictBorder)return this._calculatePositions(d+1,this._getNextPlacement(f));this._restrictToBorders(b,a,h,this.minHeight);switch(f){case "top":if(b.top+(void 0===this.minHeight?a.height:Math.min(a.height,this.minHeight))>g.top)return this._calculatePositions(d+1,this._getNextPlacement(f));break;case "bottom":if(b.top<g.top+j.height)return this._calculatePositions(d+1,this._getNextPlacement(f));break;case "left":if(b.left+a.width>g.left)return this._calculatePositions(d+1,this._getNextPlacement(f));
break;case "right":if(b.left<g.left+j.width)return this._calculatePositions(d+1,this._getNextPlacement(f));break;case "innerLeft":if(b.left<g.left+j.width)return this._calculatePositions(d+1,this._getNextPlacement(f))}g.top=Math.floor(g.top);g.left=Math.floor(g.left);b.top=Math.floor(b.top);b.left=Math.floor(b.left);c={arrow:g,content:b,placement:f};if(void 0!==this.cssClass&&this.maxSizeOverwritesCss)switch(f){case "bottom":case "bottomLeft":c.contentMaxHeight=this.restrict.offset().top+this.restrict.innerHeight()-
this.restrictBorder-b.top;break;case "top":c.contentMaxHeight=g.top-this.restrict.offset().top-this.restrictBorder}return c}};l.prototype._recalculatePositions=function(){if(this._addedToContainer){var i=this._content.scrollTop();this.element.css({"max-height":"","max-width":""});this._content.css({"max-height":"","max-width":""});var f=this._calculatePositions(0,this.placement);f?(d.each(this._placementOptions,function(c){this.element.removeClass("opened-"+c)},this),this.element.addClass("opened-"+
f.placement),this.element.offset(f.content),this._arrow.offset(f.arrow),void 0!==f.contentMaxHeight&&this._content.css("max-height",f.contentMaxHeight)):this.hide();this._content.scrollTop(i)}};l.prototype.setContext=function(d){this.context=d};l.prototype.setPreferredPlacement=function(d){this.placement=d;this._createPlacements()};l.prototype.show=function(){this._addedToContainer||(this.container.append(this.element),this._addedToContainer=!0,d.each(this._onAddedToContainerCallbacks,function(d){d()}));
this.element.show();this._recalculatePositions();this._isActive=!0};l.prototype.hide=function(){this.element.hide();this._isActive=!1};l.prototype.isActive=function(){return this._isActive};l.prototype.destroy=function(){d.each(this._onDestroyCallbacks,function(d){d()});this._content.detach();this.element.remove()};l.prototype.setContent=function(d){this._content.empty().append(d)};l.prototype.setContainer=function(d){this._container=d};l.prototype.appendContent=function(d){this._content.append(d)};
l.prototype.onAddedToContainer=function(d){this._onAddedToContainerCallbacks.push(d)};l.prototype.onDestroy=function(d){this._onDestroyCallbacks.push(d)};l.prototype.getContentDiv=function(){return this._content};l.prototype.getElement=function(){return this.element};return l});
define("lib/ace/snippets","require exports module ./lib/oop ./lib/event_emitter ./lib/lang ./range ./anchor ./keyboard/hash_handler ./tokenizer ./lib/dom ./editor".split(" "),function(k,l){var m=k("./lib/oop"),d=k("./lib/event_emitter").EventEmitter,i=k("./lib/lang"),f=k("./range").Range;k("./anchor");var c=k("./keyboard/hash_handler").HashHandler,j=k("./tokenizer").Tokenizer,a=f.comparePoints,h=function(){this.snippetMap={};this.snippetNameMap={}};(function(){m.implement(this,d);this.getTokenizer=
function(){function e(e,b,a){e=e.substr(1);return/^\d+$/.test(e)&&!a.inFormatString?[{tabstopId:parseInt(e,10)}]:[{text:e}]}function b(e){return"(?:[^\\\\"+e+"]|\\\\.)"}h.$tokenizer=new j({start:[{regex:/:/,onMatch:function(e,b,a){return a.length&&a[0].expectIf?(a[0].expectIf=!1,a[0].elseBranch=a[0],[a[0]]):":"}},{regex:/\\./,onMatch:function(e,b,a){b=e[1];"}"==b&&a.length?e=b:-1!="`$\\".indexOf(b)?e=b:a.inFormatString&&("n"==b?e="\n":"t"==b?e="\n":-1!="ulULE".indexOf(b)&&(e={changeCase:b,local:"a"<
b}));return[e]}},{regex:/}/,onMatch:function(e,b,a){return[a.length?a.shift():e]}},{regex:/\$(?:\d+|\w+)/,onMatch:e},{regex:/\$\{[\dA-Z_a-z]+/,onMatch:function(b,a,g){b=e(b.substr(1),a,g);g.unshift(b[0]);return b},next:"snippetVar"},{regex:/\n/,token:"newline",merge:!1}],snippetVar:[{regex:"\\|"+b("\\|")+"*\\|",onMatch:function(e,b,a){a[0].choices=e.slice(1,-1).split(",")},next:"start"},{regex:"/("+b("/")+"+)/(?:("+b("/")+"*)/)(\\w*):?",onMatch:function(e,b,a){b=a[0];b.fmtString=e;e=this.splitRegex.exec(e);
b.guard=e[1];b.fmt=e[2];b.flag=e[3];return""},next:"start"},{regex:"`"+b("`")+"*`",onMatch:function(e,b,a){a[0].code=e.splice(1,-1);return""},next:"start"},{regex:"\\?",onMatch:function(e,b,a){a[0]&&(a[0].expectIf=!0)},next:"start"},{regex:"([^:}\\\\]|\\\\.)*:?",token:"",next:"start"}],formatString:[{regex:"/("+b("/")+"+)/",token:"regex"},{regex:"",onMatch:function(e,b,a){a.inFormatString=!0},next:"start"}]});h.prototype.getTokenizer=function(){return h.$tokenizer};return h.$tokenizer};this.tokenizeTmSnippet=
function(e,b){return this.getTokenizer().getLineTokens(e,b).tokens.map(function(e){return e.value||e})};this.$getDefaultValue=function(e,b){if(/^[A-Z]\d+$/.test(b)){var a=b.substr(1);return(this.variables[b[0]+"__"]||{})[a]}if(/^\d+$/.test(b))return(this.variables.__||{})[b];b=b.replace(/^TM_/,"");if(e)switch(a=e.session,b){case "CURRENT_WORD":var g=a.getWordRange();case "SELECTION":case "SELECTED_TEXT":return a.getTextRange(g);case "CURRENT_LINE":return a.getLine(e.getCursorPosition().row);case "PREV_LINE":return a.getLine(e.getCursorPosition().row-
1);case "LINE_INDEX":return e.getCursorPosition().column;case "LINE_NUMBER":return e.getCursorPosition().row+1;case "SOFT_TABS":return a.getUseSoftTabs()?"YES":"NO";case "TAB_SIZE":return a.getTabSize();case "FILENAME":case "FILEPATH":return"";case "FULLNAME":return"Ace"}};this.variables={};this.getVariableValue=function(e,b){return this.variables.hasOwnProperty(b)?this.variables[b](e,b)||"":this.$getDefaultValue(e,b)||""};this.tmStrFormat=function(e,b,a){var g=b.guard,g=RegExp(g,(b.flag||"").replace(/[^gi]/,
"")),h=this.tokenizeTmSnippet(b.fmt,"formatString"),c=this,e=e.replace(g,function(){c.variables.__=arguments;for(var e=c.resolveVariables(h,a),b="E",g=0;g<e.length;g++){var o=e[g];if("object"==typeof o)if(e[g]="",o.changeCase&&o.local){var d=e[g+1];d&&"string"==typeof d&&(e[g]="u"==o.changeCase?d[0].toUpperCase():d[0].toLowerCase(),e[g+1]=d.substr(1))}else o.changeCase&&(b=o.changeCase);else"U"==b?e[g]=o.toUpperCase():"L"==b&&(e[g]=o.toLowerCase())}return e.join("")});this.variables.__=null;return e};
this.resolveVariables=function(e,b){function a(b){b=e.indexOf(b,h+1);-1!=b&&(h=b)}for(var g=[],h=0;h<e.length;h++){var c=e[h];if("string"==typeof c)g.push(c);else if("object"==typeof c)if(c.skip)a(c);else if(!(c.processed<h))if(c.text){var d=this.getVariableValue(b,c.text);d&&c.fmtString&&(d=this.tmStrFormat(d,c));c.processed=h;null==c.expectIf?d&&(g.push(d),a(c)):d?c.skip=c.elseBranch:a(c)}else null!=c.tabstopId?g.push(c):null!=c.changeCase&&g.push(c)}return g};this.insertSnippetForSelection=function(e,
b){var a=e.getCursorPosition(),c=e.session.getLine(a.row),h=e.session.getTabString(),d=c.match(/^\s*/)[0];a.column<d.length&&(d=d.slice(0,a.column));var n=this.tokenizeTmSnippet(b),n=this.resolveVariables(n,e),n=n.map(function(e){return"\n"==e?e+d:"string"==typeof e?e.replace(/\t/g,h):e}),i=[];n.forEach(function(e,b){if("object"==typeof e){var a=e.tabstopId,g=i[a];g||(g=i[a]=[],g.index=a,g.value="");if(-1===g.indexOf(e)&&(g.push(e),a=n.indexOf(e,b+1),-1!==a))if(a=n.slice(b+1,a),a.some(function(e){return"object"===
typeof e})&&!g.value)g.value=a;else if(a.length&&(!g.value||"string"!==typeof g.value))g.value=a.join("")}});i.forEach(function(e){e.length=0});a={};for(c=0;c<n.length;c++){var j=n[c];if("object"==typeof j){var f=j.tabstopId,k=n.indexOf(j,c+1);if(a[f])a[f]===j&&(a[f]=null);else{var l=i[f],m;if("string"==typeof l.value)m=[l.value];else{m=l.value;for(var w=[],s=0;s<m.length;s++){var r=m[s];if("object"==typeof r){if(a[r.tabstopId])continue;var z=m.lastIndexOf(r,s-1),r=w[z]||{tabstopId:r.tabstopId}}w[s]=
r}m=w}m.unshift(c+1,Math.max(0,k-c));m.push(j);a[f]=j;n.splice.apply(n,m);-1===l.indexOf(j)&&l.push(j)}}}var x=0,t=0,y="";n.forEach(function(e){"string"===typeof e?("\n"===e[0]?(t=e.length-1,x++):t+=e.length,y+=e):e.start?e.end={row:x,column:t}:e.start={row:x,column:t}});a=e.getSelectionRange();c=e.session.replace(a,y);(new g(e)).addTabstops(i,a.start,c,e.inVirtualSelectionMode&&e.selection.index)};this.insertSnippet=function(e,b){var a=this;if(e.inVirtualSelectionMode)return a.insertSnippetForSelection(e,
b);e.forEachSelection(function(){a.insertSnippetForSelection(e,b)},null,{keepOrder:!0});e.tabstopManager&&e.tabstopManager.tabNext()};this.$getScope=function(e){var b=e.session.$mode.$id||"",b=b.split("/").pop();if("html"===b||"php"===b){"php"===b&&!e.session.$mode.inlinePhp&&(b="html");var a=e.getCursorPosition(),e=e.session.getState(a.row);"object"===typeof e&&(e=e[0]);e.substring&&("js-"==e.substring(0,3)?b="javascript":"css-"==e.substring(0,4)?b="css":"php-"==e.substring(0,4)&&(b="php"))}return b};
this.getActiveScopes=function(e){var e=this.$getScope(e),b=[e],a=this.snippetMap;a[e]&&a[e].includeScopes&&b.push.apply(b,a[e].includeScopes);b.push("_");return b};this.expandWithTab=function(e,b){var a=this,g=e.forEachSelection(function(){return a.expandSnippetForSelection(e,b)},null,{keepOrder:!0});g&&e.tabstopManager&&e.tabstopManager.tabNext();return g};this.expandSnippetForSelection=function(e,b){var a=e.getCursorPosition(),g=e.session.getLine(a.row),c=g.substring(0,a.column),h=g.substr(a.column),
d=this.snippetMap,n;this.getActiveScopes(e).some(function(e){(e=d[e])&&(n=this.findMatchingSnippet(e,c,h));return!!n},this);if(!n)return!1;if(b&&b.dryRun)return!0;e.session.doc.removeInLine(a.row,a.column-n.replaceBefore.length,a.column+n.replaceAfter.length);this.variables.M__=n.matchBefore;this.variables.T__=n.matchAfter;this.insertSnippetForSelection(e,n.content);this.variables.M__=this.variables.T__=null;return!0};this.findMatchingSnippet=function(e,b,a){for(var g=e.length;g--;){var c=e[g];if(!c.startRe||
c.startRe.test(b))if(!c.endRe||c.endRe.test(a))if(c.startRe||c.endRe)return c.matchBefore=c.startRe?c.startRe.exec(b):[""],c.matchAfter=c.endRe?c.endRe.exec(a):[""],c.replaceBefore=c.triggerRe?c.triggerRe.exec(b)[0]:"",c.replaceAfter=c.endTriggerRe?c.endTriggerRe.exec(a)[0]:"",c}};this.snippetMap={};this.snippetNameMap={};this.register=function(e,b){function a(b){b&&!/^\^?\(.*\)\$?$|^\\b$/.test(b)&&(b="(?:"+b+")");return b||""}function g(b,e,c){b=a(b);e=a(e);c?(b=e+b)&&"$"!=b[b.length-1]&&(b+="$"):
(b+=e)&&"^"!=b[0]&&(b="^"+b);return RegExp(b)}function c(e){e.scope||(e.scope=b||"_");b=e.scope;h[b]||(h[b]=[],d[b]={});var a=d[b];if(e.name){var j=a[e.name];j&&n.unregister(j);a[e.name]=e}h[b].push(e);e.tabTrigger&&!e.trigger&&(!e.guard&&/^\w/.test(e.tabTrigger)&&(e.guard="\\b"),e.trigger=i.escapeRegExp(e.tabTrigger));e.startRe=g(e.trigger,e.guard,!0);e.triggerRe=RegExp(e.trigger,"",!0);e.endRe=g(e.endTrigger,e.endGuard,!0);e.endTriggerRe=RegExp(e.endTrigger,"",!0)}var h=this.snippetMap,d=this.snippetNameMap,
n=this;e||(e=[]);e&&e.content?c(e):Array.isArray(e)&&e.forEach(c);this._signal("registerSnippets",{scope:b})};this.unregister=function(e,b){function a(e){var h=c[e.scope||b];h&&h[e.name]&&(delete h[e.name],e=(h=g[e.scope||b])&&h.indexOf(e),0<=e&&h.splice(e,1))}var g=this.snippetMap,c=this.snippetNameMap;e.content?a(e):Array.isArray(e)&&e.forEach(a)};this.parseSnippetFile=function(e){for(var e=e.replace(/\r/g,""),b=[],a={},g=/^#.*|^({[\s\S]*})\s*$|^(\S+) (.*)$|^((?:\n*\t.*)+)/gm,c;c=g.exec(e);){if(c[1])try{a=
JSON.parse(c[1]),b.push(a)}catch(h){}if(c[4])a.content=c[4].replace(/^\t/gm,""),b.push(a),a={};else{var d=c[2];c=c[3];"regex"==d?(d=/\/((?:[^\/\\]|\\.)*)|$/g,a.guard=d.exec(c)[1],a.trigger=d.exec(c)[1],a.endTrigger=d.exec(c)[1],a.endGuard=d.exec(c)[1]):"snippet"==d?(a.tabTrigger=c.match(/^\S*/)[0],a.name||(a.name=c)):a[d]=c}}return b};this.getSnippetByName=function(e,b){var a=this.snippetNameMap,c;this.getActiveScopes(b).some(function(b){(b=a[b])&&(c=b[e]);return!!c},this);return c}}).call(h.prototype);
var g=function(b){if(b.tabstopManager)return b.tabstopManager;b.tabstopManager=this;this.$onChange=this.onChange.bind(this);this.$onChangeSelection=i.delayedCall(this.onChangeSelection.bind(this)).schedule;this.$onChangeSession=this.onChangeSession.bind(this);this.$onAfterExec=this.onAfterExec.bind(this);this.attach(b)};(function(){this.attach=function(b){this.index=0;this.ranges=[];this.tabstops=[];this.selectedTabstop=this.$openTabstops=null;this.editor=b;this.editor.on("change",this.$onChange);
this.editor.on("changeSelection",this.$onChangeSelection);this.editor.on("changeSession",this.$onChangeSession);this.editor.commands.on("afterExec",this.$onAfterExec);this.editor.keyBinding.addKeyboardHandler(this.keyboardHandler)};this.detach=function(){this.tabstops.forEach(this.removeTabstopMarkers,this);this.selectedTabstop=this.tabstops=this.ranges=null;this.editor.removeListener("change",this.$onChange);this.editor.removeListener("changeSelection",this.$onChangeSelection);this.editor.removeListener("changeSession",
this.$onChangeSession);this.editor.commands.removeListener("afterExec",this.$onAfterExec);this.editor.keyBinding.removeKeyboardHandler(this.keyboardHandler);this.editor=this.editor.tabstopManager=null};this.onChange=function(b){var c=b.data.range,b="r"==b.data.action[0],g=c.start,h=c.end,c=g.row,d=h.row-c,n=h.column-g.column;b&&(d=-d,n=-n);if(!this.$inChange&&b){var j=this.selectedTabstop;if(j&&!j.some(function(b){return 0>=a(b.start,g)&&0<=a(b.end,h)}))return this.detach()}for(var j=this.ranges,
i=0;i<j.length;i++){var f=j[i];f.end.row<g.row||(b&&0>a(g,f.start)&&0<a(h,f.end)?(this.removeRange(f),i--):(f.start.row==c&&f.start.column>g.column&&(f.start.column+=n),f.end.row==c&&f.end.column>=g.column&&(f.end.column+=n),f.start.row>=c&&(f.start.row+=d),f.end.row>=c&&(f.end.row+=d),0<a(f.start,f.end)&&this.removeRange(f)))}j.length||this.detach()};this.updateLinkedFields=function(){var b=this.selectedTabstop;if(b&&b.hasLinkedRanges){this.$inChange=!0;for(var a=this.editor.session,c=a.getTextRange(b.firstNonLinked),
g=b.length;g--;){var h=b[g];if(h.linked){var d=l.snippetManager.tmStrFormat(c,h.original);a.replace(h,d)}}this.$inChange=!1}};this.onAfterExec=function(b){b.command&&!b.command.readOnly&&this.updateLinkedFields()};this.onChangeSelection=function(){if(this.editor){for(var b=this.editor.selection.lead,a=this.editor.selection.anchor,c=this.editor.selection.isEmpty(),g=this.ranges.length;g--;)if(!this.ranges[g].linked){var h=this.ranges[g].contains(b.row,b.column),d=c||this.ranges[g].contains(a.row,a.column);
if(h&&d)return}this.detach()}};this.onChangeSession=function(){this.detach()};this.tabNext=function(b){var a=this.tabstops.length,b=this.index+(b||1),b=Math.min(Math.max(b,1),a);b==a&&(b=0);this.selectTabstop(b);0===b&&this.detach()};this.selectTabstop=function(b){this.$openTabstops=null;var a=this.tabstops[this.index];a&&this.addTabstopMarkers(a);this.index=b;if((a=this.tabstops[this.index])&&a.length){this.selectedTabstop=a;if(this.editor.inVirtualSelectionMode)this.editor.selection.setRange(a.firstNonLinked);
else{b=this.editor.multiSelect;b.toSingleRange(a.firstNonLinked.clone());for(var c=a.length;c--;)(!a.hasLinkedRanges||!a[c].linked)&&b.addRange(a[c].clone(),!0);b.ranges[0]&&b.addRange(b.ranges[0].clone())}this.editor.keyBinding.addKeyboardHandler(this.keyboardHandler)}};this.addTabstops=function(a,c,g){this.$openTabstops||(this.$openTabstops=[]);a[0]||(g=f.fromPoints(g,g),b(g.start,c),b(g.end,c),a[0]=[g],a[0].index=0);var h=[this.index+1,0],d=this.ranges;a.forEach(function(b,a){for(var e=this.$openTabstops[a]||
b,g=b.length;g--;){var n=b[g],j=f.fromPoints(n.start,n.end||n.start),i=j.start,k=c;0==i.row&&(i.column+=k.column);i.row+=k.row;i=j.end;k=c;0==i.row&&(i.column+=k.column);i.row+=k.row;j.original=n;j.tabstop=e;d.push(j);e!=b?e.unshift(j):e[g]=j;n.fmtString?(j.linked=!0,e.hasLinkedRanges=!0):e.firstNonLinked||(e.firstNonLinked=j)}e.firstNonLinked||(e.hasLinkedRanges=!1);e===b&&(h.push(e),this.$openTabstops[a]=e);this.addTabstopMarkers(e)},this);2<h.length&&(this.tabstops.length&&h.push(h.splice(2,1)[0]),
this.tabstops.splice.apply(this.tabstops,h))};this.addTabstopMarkers=function(b){var a=this.editor.session;b.forEach(function(b){b.markerId||(b.markerId=a.addMarker(b,"ace_snippet-marker","text"))})};this.removeTabstopMarkers=function(b){var a=this.editor.session;b.forEach(function(b){a.removeMarker(b.markerId);b.markerId=null})};this.removeRange=function(b){var a=b.tabstop.indexOf(b);b.tabstop.splice(a,1);a=this.ranges.indexOf(b);this.ranges.splice(a,1);this.editor.session.removeMarker(b.markerId);
b.tabstop.length||(a=this.tabstops.indexOf(b.tabstop),-1!=a&&this.tabstops.splice(a,1),this.tabstops.length||this.detach())};this.keyboardHandler=new c;this.keyboardHandler.bindKeys({Tab:function(b){(!l.snippetManager||!l.snippetManager.expandWithTab(b))&&b.tabstopManager.tabNext(1)},"Shift-Tab":function(b){b.tabstopManager.tabNext(-1)},Esc:function(b){b.tabstopManager.detach()},Return:function(){return!1}})}).call(g.prototype);var b=function(b,a){b.row==a.row&&(b.column-=a.column);b.row-=a.row};
k("./lib/dom").importCssString(".ace_snippet-marker {    -moz-box-sizing: border-box;    box-sizing: border-box;    background: rgba(194, 193, 208, 0.09);    border: 1px dotted rgba(211, 208, 235, 0.62);    position: absolute;}");l.snippetManager=new h;var n=k("./editor").Editor;(function(){this.insertSnippet=function(b,a){return l.snippetManager.insertSnippet(this,b,a)};this.expandSnippet=function(b){return l.snippetManager.expandWithTab(this,b)}}).call(n.prototype)});
define("lib/ace/autocomplete/popup","require exports module ../edit_session ../virtual_renderer ../editor ../range ../lib/event ../lib/lang ../lib/dom".split(" "),function(k,l){k("../edit_session");var m=k("../virtual_renderer").VirtualRenderer,d=k("../editor").Editor,i=k("../range").Range,f=k("../lib/event"),c=k("../lib/lang"),j=k("../lib/dom"),a=function(a){a=new m(a);a.$maxLines=4;a=new d(a);a.setHighlightActiveLine(!1);a.setShowPrintMargin(!1);a.renderer.setShowGutter(!1);a.renderer.setHighlightGutterLine(!1);
a.$mouseHandler.$focusWaitTimout=0;a.$highlightTagPending=!0;return a};j.importCssString(".ace_editor.ace_autocomplete .ace_marker-layer .ace_active-line {    background-color: #CAD6FA;    z-index: 1;}.ace_editor.ace_autocomplete .ace_line-hover {    border: 1px solid #abbffe;    margin-top: -1px;    background: rgba(233,233,253,0.4);}.ace_editor.ace_autocomplete .ace_line-hover {    position: absolute;    z-index: 2;}.ace_editor.ace_autocomplete .ace_scroller {   background: none;   border: none;   box-shadow: none;}.ace_rightAlignedText {    color: gray;    display: inline-block;    position: absolute;    right: 4px;    text-align: right;    z-index: -1;}.ace_editor.ace_autocomplete .ace_completion-highlight{    color: #000;    text-shadow: 0 0 0.01em;}.ace_editor.ace_autocomplete {    width: 280px;    z-index: 200000;    background: #fbfbfb;    color: #444;    border: 1px lightgray solid;    position: fixed;    box-shadow: 2px 3px 5px rgba(0,0,0,.2);    line-height: 1.4;}");
l.AcePopup=function(h){var g=j.createElement("div"),b=new a(g);h&&h.appendChild(g);g.style.display="none";b.renderer.content.style.cursor="default";b.renderer.setStyle("ace_autocomplete");b.setOption("displayIndentGuides",!1);b.setOption("dragDelay",150);h=function(){};b.focus=h;b.$isFocused=!0;b.renderer.$cursorLayer.restartTimer=h;b.renderer.$cursorLayer.element.style.opacity=0;b.renderer.$maxLines=8;b.renderer.$keepTextAreaAtCursor=!1;b.setHighlightActiveLine(!1);b.session.highlight("");b.session.$searchHighlight.clazz=
"ace_highlight-marker";b.on("mousedown",function(a){var e=a.getDocumentPosition();b.selection.moveToPosition(e);o.start.row=o.end.row=e.row;a.stop()});var d,e=new i(-1,0,-1,Infinity),o=new i(-1,0,-1,Infinity);o.id=b.session.addMarker(o,"ace_active-line","fullLine");b.setSelectOnHover=function(a){a?e.id&&(b.session.removeMarker(e.id),e.id=null):e.id=b.session.addMarker(e,"ace_line-hover","fullLine")};b.setSelectOnHover(!1);b.on("mousemove",function(a){d?d.x==a.x&&d.y==a.y||(d=a,d.scrollTop=b.renderer.scrollTop,
a=d.getDocumentPosition().row,e.start.row!=a&&(e.id||b.setRow(a),k(a))):d=a});b.renderer.on("beforeRender",function(){if(d&&-1!=e.start.row){d.$pos=null;var a=d.getDocumentPosition().row;e.id||b.setRow(a);k(a,!0)}});b.renderer.on("afterRender",function(){var a=b.getRow(),e=b.renderer.$textLayer,a=e.element.childNodes[a-e.config.firstRow];a!=e.selectedNode&&(e.selectedNode&&j.removeCssClass(e.selectedNode,"ace_selected"),(e.selectedNode=a)&&j.addCssClass(a,"ace_selected"))});var g=function(){k(-1)},
k=function(a,c){a!==e.start.row&&(e.start.row=e.end.row=a,c||b.session._emit("changeBackMarker"),b._emit("changeHoverMarker"))};b.getHoveredRow=function(){return e.start.row};f.addListener(b.container,"mouseout",g);b.on("hide",g);b.on("changeSelection",g);b.session.doc.getLength=function(){return b.data.length};b.session.doc.getLine=function(a){a=b.data[a];return"string"==typeof a?a:a&&a.value||""};g=b.session.bgTokenizer;g.$tokenizeRow=function(a){var a=b.data[a],e=[];if(!a)return e;"string"==typeof a&&
(a={value:a});a.caption||(a.caption=a.value||a.name);for(var c=-1,g,h,d=0;d<a.caption.length;d++)h=a.caption[d],g=a.matchMask&1<<d?1:0,c!==g?(e.push({type:a.className||""+(g?"completion-highlight":""),value:h}),c=g):e[e.length-1].value+=h;a.meta&&a.meta.length+a.caption.length<b.renderer.$size.scrollerWidth/b.renderer.layerConfig.characterWidth-2&&e.push({type:"rightAlignedText",value:a.meta});return e};g.$updateOnChange=h;g.start=h;b.session.$computeWidth=function(){return this.screenWidth=0};b.$blockScrolling=
Infinity;b.isOpen=!1;b.isTopdown=!1;b.data=[];b.setData=function(a){b.data=a||[];b.setValue(c.stringRepeat("\n",a.length),-1);b.setRow(0)};b.getData=function(a){return b.data[a]};b.getRow=function(){return o.start.row};b.setRow=function(a){a=Math.max(-1,Math.min(this.data.length,a));o.start.row!=a&&(b.selection.clearSelection(),o.start.row=o.end.row=a||0,b.session._emit("changeBackMarker"),b.moveCursorTo(a||0,0),b.isOpen&&b._signal("select"))};b.on("changeSelection",function(){b.isOpen&&b.setRow(b.selection.lead.row);
b.renderer.scrollCursorIntoView()});b.hide=function(){this.container.style.display="none";this._signal("hide");b.isOpen=!1};b.show=function(a,e,c){var g=this.container,h=window.innerHeight,j=window.innerWidth,i=a.top+this.$borderSize;i+1.4*this.renderer.$maxLines*e>h-e&&!c?(g.style.top="",g.style.bottom=h-i+"px",b.isTopdown=!1):(g.style.top=i+e+"px",g.style.bottom="",b.isTopdown=!0);g.style.display="";this.renderer.$textLayer.checkForSizeChanges();a=a.left;a+g.offsetWidth>j&&(a=j-g.offsetWidth);g.style.left=
a+"px";this._signal("show");d=null;b.isOpen=!0};b.getTextLeftOffset=function(){return this.$borderSize+this.renderer.$padding+this.$imageSize};b.$imageSize=0;b.$borderSize=1;return b}});
define("lib/ace/autocomplete/util",["require","exports","module"],function(k,l){l.parForEach=function(d,i,f){var c=0,j=d.length;0===j&&f();for(var a=0;a<j;a++)i(d[a],function(a,g){c++;c===j&&f(a,g)})};var m=/[a-zA-Z_0-9\$\-\u00A2-\uFFFF]/;l.retrievePrecedingIdentifier=function(d,i,f){for(var f=f||m,c=[],i=i-1;0<=i;i--)if(f.test(d[i]))c.push(d[i]);else break;return c.reverse().join("")};l.retrieveFollowingIdentifier=function(d,i,f){for(var f=f||m,c=[];i<d.length;i++)if(f.test(d[i]))c.push(d[i]);else break;
return c}});
define("lib/ace/autocomplete","require exports module ./keyboard/hash_handler ./autocomplete/popup ./autocomplete/util ./lib/event ./lib/lang ./lib/dom ./snippets".split(" "),function(k,l){var m=k("./keyboard/hash_handler").HashHandler,d=k("./autocomplete/popup").AcePopup,i=k("./autocomplete/util");k("./lib/event");var f=k("./lib/lang"),c=k("./lib/dom"),j=k("./snippets").snippetManager,a=function(){this.autoSelect=this.autoInsert=!0;this.exactMatch=!1;this.keyboardHandler=new m;this.keyboardHandler.bindKeys(this.commands);this.blurListener=
this.blurListener.bind(this);this.changeListener=this.changeListener.bind(this);this.mousedownListener=this.mousedownListener.bind(this);this.mousewheelListener=this.mousewheelListener.bind(this);this.changeTimer=f.delayedCall(function(){this.updateCompletions(!0)}.bind(this));this.tooltipTimer=f.delayedCall(this.updateDocTooltip.bind(this),50)};(function(){this.gatherCompletionsId=0;this.$init=function(){this.popup=new d(document.body||document.documentElement);this.popup.on("click",function(a){this.insertMatch();
a.stop()}.bind(this));this.popup.focus=this.editor.focus.bind(this.editor);this.popup.on("show",this.tooltipTimer.bind(null,null));this.popup.on("select",this.tooltipTimer.bind(null,null));this.popup.on("changeHoverMarker",this.tooltipTimer.bind(null,null));return this.popup};this.getPopup=function(){return this.popup||this.$init()};this.openPopup=function(a,b,c){this.popup||this.$init();this.popup.setData(this.completions.filtered);var e=a.renderer;this.popup.setRow(this.autoSelect?0:-1);if(c)c&&
!b&&this.detach();else{this.popup.setTheme(a.getTheme());this.popup.setFontSize(a.getFontSize());b=e.layerConfig.lineHeight;c=e.$cursorLayer.getPixelPosition(this.base,!0);c.left-=this.popup.getTextLeftOffset();var h=a.container.getBoundingClientRect();c.top+=h.top-e.layerConfig.offset;c.left+=h.left-a.renderer.scrollLeft;c.left+=e.$gutterLayer.gutterWidth;this.popup.show(c,b)}};this.detach=function(){this.editor.keyBinding.removeKeyboardHandler(this.keyboardHandler);this.editor.off("changeSelection",
this.changeListener);this.editor.off("blur",this.blurListener);this.editor.off("mousedown",this.mousedownListener);this.editor.off("mousewheel",this.mousewheelListener);this.changeTimer.cancel();this.hideDocTooltip();this.popup&&this.popup.isOpen&&(this.gatherCompletionsId+=1,this.popup.hide());this.base&&this.base.detach();this.activated=!1;this.completions=this.base=null};this.changeListener=function(){var a=this.editor.selection.lead;(a.row!=this.base.row||a.column<this.base.column)&&this.detach();
this.activated?this.changeTimer.schedule():this.detach()};this.blurListener=function(a){var b=document.activeElement,c=this.editor.textInput.getElement();b!=c&&(b.parentNode!=this.popup.container&&b!=this.tooltipNode&&a.relatedTarget!=this.tooltipNode&&a.relatedTarget!=c)&&this.detach()};this.mousedownListener=function(){this.detach()};this.mousewheelListener=function(){this.detach()};this.goTo=function(a){var b=this.popup.getRow(),c=this.popup.session.getLength()-1;switch(a){case "up":b=0>=b?c:b-
1;break;case "down":b=b>=c?-1:b+1;break;case "start":b=0;break;case "end":b=c}this.popup.setRow(b)};this.insertMatch=function(a){a||(a=this.popup.getData(this.popup.getRow()));if(!a)return!1;if(a.completer&&a.completer.insertMatch)a.completer.insertMatch(this.editor,a);else{if(this.completions.filterText)for(var b=this.editor.selection.getAllRanges(),c=0,e;e=b[c];c++)e.start.column-=this.completions.filterText.length,this.editor.session.remove(e);a.snippet?j.insertSnippet(this.editor,a.snippet):this.editor.execCommand("insertstring",
a.value||a)}this.detach()};this.commands={Up:function(a){a.completer.goTo("up")},Down:function(a){a.completer.goTo("down")},"Ctrl-Up|Ctrl-Home":function(a){a.completer.goTo("start")},"Ctrl-Down|Ctrl-End":function(a){a.completer.goTo("end")},Esc:function(a){a.completer.detach()},Space:function(a){a.completer.detach();a.insert(" ")},Return:function(a){return a.completer.insertMatch()},"Shift-Return":function(a){a.completer.insertMatch(!0)},Tab:function(a){var b=a.completer.insertMatch();if(!b&&!a.tabstopManager)a.completer.goTo("down");
else return b},PageUp:function(a){a.completer.popup.gotoPageUp()},PageDown:function(a){a.completer.popup.gotoPageDown()}};this.gatherCompletions=function(a,b){var c=a.getSession(),e=a.getCursorPosition(),h=c.getLine(e.row),d=i.retrievePrecedingIdentifier(h,e.column);this.base=c.doc.createAnchor(e.row,e.column-d.length);this.base.$insertRight=!0;var j=[],f=a.completers.length;a.completers.forEach(function(h){h.getCompletions(a,c,e,d,function(e,h){e||(j=j.concat(h));var d=a.getCursorPosition(),o=c.getLine(d.row);
b(null,{prefix:i.retrievePrecedingIdentifier(o,d.column,h[0]&&h[0].identifierRegex),matches:j,finished:0===--f})})});return!0};this.showPopup=function(a){this.editor&&this.detach();this.activated=!0;this.editor=a;a.completer!=this&&(a.completer&&a.completer.detach(),a.completer=this);a.keyBinding.addKeyboardHandler(this.keyboardHandler);a.on("changeSelection",this.changeListener);a.on("blur",this.blurListener);a.on("mousedown",this.mousedownListener);a.on("mousewheel",this.mousewheelListener);this.updateCompletions()};
this.updateCompletions=function(a){if(a&&this.base&&this.completions){var b=this.editor.getCursorPosition(),b=this.editor.session.getTextRange({start:this.base,end:b});if(b!=this.completions.filterText){this.completions.setFilter(b);if(!this.completions.filtered.length||1==this.completions.filtered.length&&this.completions.filtered[0].value==b&&!this.completions.filtered[0].snippet)return this.detach();this.openPopup(this.editor,b,a)}}else{var c=this.gatherCompletionsId;this.gatherCompletions(this.editor,
function(b,d){var j=function(){if(d.finished)return this.detach()}.bind(this),i=d.prefix,f=d&&d.matches;if(!f||!f.length)return j();if(!(0!==i.indexOf(d.prefix)||c!=this.gatherCompletionsId)){this.completions=new h(f);this.exactMatch&&(this.completions.exactMatch=!0);this.completions.setFilter(i);f=this.completions.filtered;if(!f.length||1==f.length&&f[0].value==i&&!f[0].snippet)return j();if(this.autoInsert&&1==f.length&&d.finished)return this.insertMatch(f[0]);this.openPopup(this.editor,i,a)}}.bind(this))}};
this.cancelContextMenu=function(){this.editor.$mouseHandler.cancelContextMenu()};this.updateDocTooltip=function(){var a=this.popup,b=a.data,c=b&&(b[a.getHoveredRow()]||b[a.getRow()]),e=null;if(!c||!this.editor||!this.popup.isOpen)return this.hideDocTooltip();this.editor.completers.some(function(a){a.getDocTooltip&&(e=a.getDocTooltip(c));return e});e||(e=c);"string"==typeof e&&(e={docText:e});if(!e||!e.docHTML&&!e.docText)return this.hideDocTooltip();this.showDocTooltip(e)};this.showDocTooltip=function(a){this.tooltipNode||
(this.tooltipNode=c.createElement("div"),this.tooltipNode.className="ace_tooltip ace_doc-tooltip",this.tooltipNode.style.margin=0,this.tooltipNode.style.pointerEvents="auto",this.tooltipNode.tabIndex=-1,this.tooltipNode.onblur=this.blurListener.bind(this));var b=this.tooltipNode;a.docHTML?b.innerHTML=a.docHTML:a.docText&&(b.textContent=a.docText);b.parentNode||document.body.appendChild(b);var a=this.popup,h=a.container.getBoundingClientRect();b.style.top=a.container.style.top;b.style.bottom=a.container.style.bottom;
320>window.innerWidth-h.right?(b.style.right=window.innerWidth-h.left+"px",b.style.left=""):(b.style.left=h.right+1+"px",b.style.right="");b.style.display="block"};this.hideDocTooltip=function(){this.tooltipTimer.cancel();if(this.tooltipNode){var a=this.tooltipNode;!this.editor.isFocused()&&document.activeElement==a&&this.editor.focus();this.tooltipNode=null;a.parentNode&&a.parentNode.removeChild(a)}}}).call(a.prototype);a.startCommand={name:"startAutocomplete",exec:function(c){c.completer||(c.completer=
new a);c.completer.autoInsert=c.completer.autoSelect=!0;c.completer.showPopup(c);c.completer.cancelContextMenu()},bindKey:"Ctrl-Space|Ctrl-Shift-Space|Alt-Space"};var h=function(a,b){this.filtered=this.all=a;this.filterText=b||"";this.exactMatch=!1};(function(){this.setFilter=function(a){var b=a.length>this.filterText&&0===a.lastIndexOf(this.filterText,0)?this.filtered:this.all;this.filterText=a;var b=this.filterCompletions(b,this.filterText),b=b.sort(function(a,b){return b.exactMatch-a.exactMatch||
b.score-a.score}),c=null;this.filtered=b=b.filter(function(a){a=a.snippet||a.caption||a.value;if(a===c)return!1;c=a;return!0})};this.filterCompletions=function(a,b){var c=[],e=b.toUpperCase(),h=b.toLowerCase(),d=0,j;a:for(;j=a[d];d++){var f=j.value||j.caption||j.snippet;if(f){var i=-1,k=0,l=0,m,q;if(this.exactMatch){if(b!==f.substr(0,b.length))continue a}else for(var v=0;v<b.length;v++){m=f.indexOf(h[v],i+1);q=f.indexOf(e[v],i+1);m=0<=m?0>q||m<q?m:q:q;if(0>m)continue a;q=m-i-1;0<q&&(-1===i&&(l+=10),
l+=q);k|=1<<m;i=m}j.matchMask=k;j.exactMatch=l?0:1;j.score=(j.score||0)-l;c.push(j)}}return c}}).call(h.prototype);l.Autocomplete=a;l.FilteredList=h});
define("lib/ace/autocomplete/text_completer",["require","exports","module","../range"],function(k,l){var m=k("../range").Range,d=/[^a-zA-Z_0-9\$\-\u00C0-\u1FFF\u2C00-\uD7FF\w]+/;l.getCompletions=function(i,f,c,j,a){var h=f.getTextRange(m.fromPoints({row:0,column:0},c)).split(d).length-1,g=f.getValue().split(d),b=Object.create(null),n=g[h];g.forEach(function(a,c){if(a&&a!==n){var d=Math.abs(h-c),d=g.length-d;b[a]=b[a]?Math.max(d,b[a]):d}});i=Object.keys(b);a(null,i.map(function(a){return{caption:a,
value:a,score:b[a],meta:"local"}}))}});
define("lib/ace/ext/language_tools","require exports module ../snippets ../autocomplete ../config ../lib/lang ../autocomplete/util ../autocomplete/text_completer ../editor ../config".split(" "),function(k,l){function m(a){var b=a.getCursorPosition(),c=a.session.getLine(b.row),e=j.retrievePrecedingIdentifier(c,b.column);a.completers.forEach(function(a){a.identifierRegexps&&a.identifierRegexps.forEach(function(a){!e&&a&&(e=j.retrievePrecedingIdentifier(c,b.column,a))})});return e}var d=k("../snippets").snippetManager,
i=k("../autocomplete").Autocomplete,f=k("../config"),c=k("../lib/lang"),j=k("../autocomplete/util"),a=k("../autocomplete/text_completer"),h={getCompletions:function(a,b,c,e,h){if(b.$mode.completer)return b.$mode.completer.getCompletions(a,b,c,e,h);a=a.session.getState(c.row);b=b.$mode.getCompletions(a,b,c,e);h(null,b)}},g={getCompletions:function(a,b,c,e,h){var g=d.snippetMap,j=[];d.getActiveScopes(a).forEach(function(a){for(var a=g[a]||[],b=a.length;b--;){var c=a[b],e=c.name||c.tabTrigger;e&&j.push({caption:e,
snippet:c.content,meta:c.tabTrigger&&!c.name?c.tabTrigger+"\u21e5 ":"snippet",type:"snippet"})}},this);h(null,j)},getDocTooltip:function(a){"snippet"==a.type&&!a.docHTML&&(a.docHTML=["<b>",c.escapeHTML(a.caption),"</b><hr></hr>",c.escapeHTML(a.snippet)].join(""))}},b=[g,a,h];l.setCompleters=function(a){b=a||[]};l.addCompleter=function(a){b.push(a)};l.textCompleter=a;l.keyWordCompleter=h;l.snippetCompleter=g;var n={name:"expandSnippet",exec:function(a){return d.expandWithTab(a)},bindKey:"Tab"},e=function(a,
b){o(b.session.$mode)},o=function(a){var b=a.$id;d.files||(d.files={});u(b);a.modes&&a.modes.forEach(o)},u=function(a){if(a&&!d.files[a]){var b=a.replace("mode","snippets");d.files[a]={};f.loadModule(b,function(b){b&&(d.files[a]=b,!b.snippets&&b.snippetText&&(b.snippets=d.parseSnippetFile(b.snippetText)),d.register(b.snippets||[],b.scope),b.includeScopes&&(d.snippetMap[b.scope].includeScopes=b.includeScopes,b.includeScopes.forEach(function(a){u("ace/mode/"+a)})))})}},p=function(a){var b=a.editor,
c=b.completer&&b.completer.activated;"backspace"===a.command.name?c&&!m(b)&&b.completer.detach():"insertstring"===a.command.name&&(m(b)&&!c)&&(b.completer||(b.completer=new i),b.completer.autoSelect=!1,b.completer.autoInsert=!1,b.completer.showPopup(b))},a=k("../editor").Editor;k("../config").defineOptions(a.prototype,"editor",{enableBasicAutocompletion:{set:function(a){a?(this.completers||(this.completers=Array.isArray(a)?a:b),this.commands.addCommand(i.startCommand)):this.commands.removeCommand(i.startCommand)},
value:!1},enableLiveAutocompletion:{set:function(a){a?(this.completers||(this.completers=Array.isArray(a)?a:b),this.commands.on("afterExec",p)):this.commands.removeListener("afterExec",p)},value:!1},enableSnippets:{set:function(a){a?(this.commands.addCommand(n),this.on("changeMode",e),e(null,this)):(this.commands.removeCommand(n),this.off("changeMode",e))},value:!1}})});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/smartnameinfo",[],function(){var k=function(k){this._name=k};(function(){this.getFullName=function(){return this._name}}).call(k.prototype);return k});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/smartnameanchor",["lib/ace/anchor","lib/ace/lib/oop"],function(k,l){var m=k.Anchor,d=function(d,f,c,j){this._info=j;this._isvalidanchor=!0;m.call(this,d,f,c)};l.inherits(d,k.Anchor);(function(){this.getSmartNameInfo=function(){return this._info};this.setSmartNameInfo=function(d){this._info=d};this.applyDeltas=function(d){if(("removeText"===d.action||"removeLines"===d.action)&&d.range.start.column<=this.column&&d.range.end.column>
this.column)return this._isvalidanchor=!1;m.prototype.onChange.call(this,{data:d});return!0};this.isValid=function(){return this._isvalidanchor};this.onChange=function(){}}).call(d.prototype);return d});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/smartnameanchorcontrol",["./smartnameanchor","./smartnameinfo","lib/ace/range"],function(k,l,m){function d(a){void 0===a.smartnameanchors&&(a.smartnameanchors=[]);return a.smartnameanchors}var i=m.Range,f={},c=new l("?");c.unresolved=!0;var j=function(a,c,g){for(var a=d(a),b=0;b<a.length;b++){var j=a[b],e=j.getPosition();if(e.row===c&&e.column===g)return j}return null};f.getSmartNameInfoAt=function(a,h,d){a=j(a,h,d);return null!==
a?a.getSmartNameInfo():c};f.setSmartNameInfoAt=function(a,c,g,b){var j=new k(a,c,g,b);d(a).push(j);c={action:"addSmartName",range:new i(c,g,c,g+1),smartname:{row:c,column:g,info:b}};a._signal("change",{data:c})};f.applyDelta=function(a,c){for(var g=d(a),b=[],j=0;j<g.length;j++){var e=g[j];e.applyDeltas(c)||(b.push(e),g.splice(j,1),j--)}for(j=0;j<b.length;j++){var e=b[j],g=e.row,f=e.column,e=e._info,e={action:"removeSmartName",range:new i(g,f,g,f+1),smartname:{row:g,column:f,info:e}};a._signal("change",
{data:e})}};f.renameSmartName=function(a,c,d,b){var f=j(a.doc,c,d);if(null!=f){var e=f.getSmartNameInfo(),k=new l(b);if(b===e.getFullName())return!1;f.setSmartNameInfo(k);c={action:"renameSmartName",range:new i(c,d,c,d+1),smartname:{row:c,column:d,oldinfo:e,newinfo:k}};a.doc._signal("change",{data:c});return!0}return!1};f.setActiveSmartName=function(a,c,d){f.clearActiveSmartName(a);var b=j(a,c,d);null!=b&&(c={action:"changeActiveSmartName",range:new i(c,d,c,d+1),ignore:!0},a.activeAnchor=b,a._signal("change",
{data:c}))};f.clearActiveSmartName=function(a){if(a.activeAnchor&&a.activeAnchor.isValid()){var c=a.activeAnchor.getPosition(),c={action:"changeActiveSmartName",range:new i(c.row,c.column,c.row,c.column+1),ignore:!0};a.activeAnchor=null;a._signal("change",{data:c})}};f.getActiveSmartNamePosition=function(a){return a.activeAnchor&&a.activeAnchor.isValid()?a.activeAnchor.getPosition():null};f.provideSmartNameAPI=function(a,c,d){var b=a.getSession(),n=j(b.doc,c,d);return null===n?null:{isValid:function(){return n.isValid()},
setActive:function(a){n.isValid()&&(a?(a=n.getPosition(),f.setActiveSmartName(b.doc,a.row,a.column)):f.clearActiveSmartName(b.doc))},isActive:function(){return n.isValid()&&n===b.doc.activeAnchor},getSmartName:function(){return n.getSmartNameInfo().getFullName()},setSmartName:function(a){if(n.isValid()){var c=n.getPosition();f.renameSmartName(b,c.row,c.column,a)}},getSmartNameBoundingClientRect:function(c){if(n.isValid()){var d=n.getPosition(),h=(new i(d.row,d.column,d.row,d.column+1)).toScreenRange(b),
g=a.renderer;g.$textLayer.checkForSizeChanges();var d=g.scroller.getBoundingClientRect(),j=h.start.column*g.characterWidth+g.$padding+d.left-g.scrollLeft,f=h.end.column*g.characterWidth+g.$padding+d.left-g.scrollLeft,k=h.start.row*g.lineHeight+d.top-g.scrollTop,h=(h.end.row+1)*g.lineHeight+d.top-g.scrollTop;c&&(j<d.left&&(j=d.left),j>d.right&&(j=d.right),f<d.left&&(f=d.left),f>d.right&&(f=d.right),k<d.top&&(k=d.top),k>d.bottom&&(k=d.bottom),h<d.top&&(h=d.top),h>d.bottom&&(h=d.bottom));return{left:j,
top:k,width:f-j,height:h-k}}return null}}};f.undoRedo=function(a,c,d){var b=c.action;("addSmartName"===b||"removeSmartName"===b)&&d!==("addSmartName"===b)&&f.setSmartNameInfoAt(a,c.smartname.row,c.smartname.column,c.smartname.info);if("renameSmartName"===b){var b=d?c.smartname.oldinfo:c.smartname.newinfo,k=j(a,c.smartname.row,c.smartname.column);null!=k&&(k.setSmartNameInfo(b),c={action:"renameSmartName",range:new i(c.smartname.row,c.smartname.column,c.smartname.row,c.smartname.column+1),smartname:{row:c.smartname.row,
column:c.smartname.column,oldinfo:d?c.smartname.newinfo:c.smartname.oldinfo,newinfo:d?c.smartname.oldinfo:c.smartname.newinfo}},a._signal("change",{data:c}))}};return f});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/smartnameextensionutils",["component/smartnames/encoding/smartname","component/smartnames/encoding/smartnamestringpart","component/smartnames/encoding/smartnameencoding","./smartnameinfo","./smartnameanchorcontrol"],function(k,l,m,d,i){var f={SMARTNAMECHAR:"\u0010",getSmartNameDisplayString:function(c,d){if(void 0!==c.displayFunction){var a=new k(d.getFullName());return c.displayFunction(a)}return"["+d.getFullName()+"]"},parseText:function(c,
j,a){if(c.isSmartNamesEnabled()){for(var h={text:"",smartnames:[]},j=j.replaceAll("\n","").replaceAll("\r",""),c=(!0===a?m.UNIVERSALCOPYPASTEENCODING:c.getSmartNameEncoding()).decodeSmartNameString(j),j=0;j<c.length;j++)a=c[j],a.isTextPart()?h.text+=a.getAsText():(h.smartnames.push({index:h.text.length,info:new d(a.getAsSmartName().getFullName())}),h.text+=f.SMARTNAMECHAR);return h}return{text:j,smartnames:[]}},tryParseText:function(c,d,a){if(c.isSmartNamesEnabled())try{return f.parseText(c,d,a)}catch(h){return{text:d.replaceAll("\n",
"").replaceAll("\r","").replaceAll(""+f.SMARTNAMECHAR,"?"),smartnames:[]}}else return{text:d,smartnames:[]}},recompileText:function(c,d,a,h,g){if(c.isSmartNamesEnabled()){for(var b=[],n=0;n<h.length;n++)if(h.charAt(n)===f.SMARTNAMECHAR){var e=i.getSmartNameInfoAt(d,0,a+n);b.push(l.makeSmartNamePart(new k(e.getFullName())))}else b.push(l.makePlainTextPart(""+h.charAt(n)));return(!0===g?m.UNIVERSALCOPYPASTEENCODING:c.getSmartNameEncoding()).encodeSmartNameString(b)}return h},addSmartNameAnchors:function(c,
d,a){for(var h=0;h<a.length;h++)i.setSmartNameInfoAt(c,0,a[h].index+d.start.column,a[h].info)},startSmartNameChangeGroup:function(c){void 0==c.smartnamechangeready&&(c.smartnamechangeready=0);c.smartnamechangeready++},stopSmartNameChangeGroup:function(c,d){c.smartnamechangeready--;c._signal("change",{data:{action:"changeAfterSmartNames",range:d}})},isInSmartNameChangeReady:function(c){return void 0==c.smartnamechangeready?!0:0===c.smartnamechangeready},getSmartNameEditAPI:function(c,d,a){return c.getSession().isSmartNamesEnabled()&&
c.getSession().getLine(d).charAt(a)===f.SMARTNAMECHAR?i.provideSmartNameAPI(c,d,a):null}};return f});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/smartnametooltip","require exports module lib/ace/lib/oop lib/ace/lib/event lib/ace/tooltip ./smartnameextensionutils ./smartnameanchorcontrol".split(" "),function(k,l){function m(a){a.smartnameTooltip||(f.call(this,a.container),a.smartnameTooltip=this,this.editor=a,this.update=this.update.bind(this),this.onMouseMove=this.onMouseMove.bind(this),this.onMouseOut=this.onMouseOut.bind(this),i.addListener(a.renderer.scroller,"mousemove",
this.onMouseMove),i.addListener(a.renderer.content,"mouseout",this.onMouseOut),i.addListener(a,"change",function(a){"changeActiveSmartName"===a.data.action&&this.lastHoverSmartName&&this.update()}.bind(this)))}var d=k("lib/ace/lib/oop"),i=k("lib/ace/lib/event"),f=k("lib/ace/tooltip").Tooltip,c=k("./smartnameextensionutils"),j=k("./smartnameanchorcontrol");d.inherits(m,f);(function(){this.update=function(){this.$timer=null;var a=this.editor.renderer;if(1E3<this.lastT-(a.timeStamp||0))a.rect=null,a.timeStamp=
this.lastT,this.maxHeight=window.innerHeight,this.maxWidth=window.innerWidth;var d=a.rect||(a.rect=a.scroller.getBoundingClientRect()),g=Math.floor((this.y+a.scrollTop-d.top)/a.lineHeight),a=Math.round((this.x+a.scrollLeft-d.left-a.$padding)/a.characterWidth),b=this.editor.session,f=b.screenToDocumentPosition(g,a),a=g=!1;b.getLine(f.row).charAt(f.column)===c.SMARTNAMECHAR?(d=j.getSmartNameInfoAt(b.getDocument(),f.row,f.column),b=j.getActiveSmartNamePosition(b.getDocument()),b=null!==b&&b.row===f.row&&
b.column===f.column,d===this.lastHoverSmartName&&b===this.lastSmartNameActive?(g=!1,a=this.isOpen):(f=$(this.getElement()),f.empty(),this.lastHoverSmartName=d,this.lastSmartNameActive=b,this.editor.smartnameTooltipFunction&&(g=a=this.editor.smartnameTooltipFunction(d.getFullName(),b,f)))):(this.lastHoverSmartName=null,g=a=!1);a?(g&&(this.width=this.getWidth(),this.height=this.getHeight()),this.show(null,this.x,this.y)):this.hide()};this.onMouseMove=function(a){this.x=a.clientX;this.y=a.clientY;this.isOpen&&
(this.lastT=a.timeStamp,this.setPosition(this.x,this.y));this.$timer||(this.$timer=setTimeout(this.update,100))};this.onMouseOut=function(a){if(!a||!a.currentTarget.contains(a.relatedTarget))this.hide(),this.$timer=clearTimeout(this.$timer),this.lastHoverSmartName=null};this.setPosition=function(a,c){a+10+this.width>this.maxWidth&&(a=window.innerWidth-this.width-10);if(c>0.75*window.innerHeight||c+20+this.height>this.maxHeight)c=c-this.height-30;f.prototype.setPosition.call(this,a+10,c+20)};this.destroy=
function(){this.onMouseOut();i.removeListener(this.editor.renderer.scroller,"mousemove",this.onMouseMove);i.removeListener(this.editor.renderer.content,"mouseout",this.onMouseOut);delete this.editor.smartnameTooltip}}).call(m.prototype);l.SmartNameTooltip=m});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-editor","lib/ace/editor lib/ace/range ./smartnameinfo ./smartnameextensionutils ./smartnametooltip utils/extendedstring".split(" "),function(k,l,m,d,i){var f=l.Range,c=i.SmartNameTooltip;(function(){this.insertSmartName=function(a){d.startSmartNameChangeGroup(this.getSession().getDocument());this.insert(d.SMARTNAMECHAR);var c=this.getCursorPosition().column-1,g=new f(0,c,0,c+1);d.addSmartNameAnchors(this.getSession().getDocument(),
g,[{index:0,info:new m(a)}]);d.stopSmartNameChangeGroup(this.getSession().getDocument(),g);this._triggerSmartNameEditing({row:0,column:c})};this.getSmartNameEncodedValue=function(){return d.recompileText(this.getSession(),this.getSession().getDocument(),0,this.getValue())};this.isChangeReady=function(){return d.isInSmartNameChangeReady(this.getSession().getDocument())};this.setSmartNameEncodedValue=function(a){a=d.parseText(this.getSession(),a);d.startSmartNameChangeGroup(this.getSession().getDocument());
this.setValue(a.text);var c=new f(0,0,0,a.text.length);d.addSmartNameAnchors(this.getSession().getDocument(),c,a.smartnames);d.stopSmartNameChangeGroup(this.getSession().getDocument(),c);this.navigateFileEnd()};this.configureSmartNameTooltip=function(a){this.smartnameTooltipFunction=a;new c(this)};this.initSmartNameEditListener=function(a){this.onEditSmartNameCallback=a;this.on("click",function(a){a=a.getDocumentPosition();this._triggerSmartNameEditing(a)}.bind(this))};this._triggerSmartNameEditing=
function(a){if(this.onEditSmartNameCallback&&(a=d.getSmartNameEditAPI(this,a.row,a.column),null!=a))this.onEditSmartNameCallback(a)};this.insertBase=this.insert;this.insert=function(a,c){this.getSession().isSmartNamesEnabled()&&(a=a.replaceAll("\r","").replaceAll("\n",""));this.insertBase(a,c)};var j=this.onPaste;this.onPaste=function(a){a=d.tryParseText(this.session,a,!0);d.startSmartNameChangeGroup(this.session.getDocument());j.call(this,a.text);var c=this.getCursorPosition().column-a.text.length,
c=new f(0,c,0,c+a.text.length);d.addSmartNameAnchors(this.session.getDocument(),c,a.smartnames);d.stopSmartNameChangeGroup(this.session.getDocument(),c)};this.getCopyText=function(){var a=this.getSelectionRange().start.column,c=this.getSelectedText(),c=d.recompileText(this.getSession(),this.getSession().getDocument(),a,c,!0);this._signal("copy",c);return c}}).call(k.Editor.prototype)});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-edit_session",["lib/ace/edit_session","lib/ace/range","./smartnameanchorcontrol","./smartnameextensionutils"],function(k,l,m,d){(function(){var i=l.Range,f=d.SMARTNAMECHAR;this.isSmartNamesEnabled=function(){return void 0===this._smartNamesEnabled?!1:this._smartNamesEnabled};this.enableSmartNames=function(c){void 0!==c&&(this._smartNamesEnabled=!0,this._smartNameEncoding=c)};this.getSmartNameEncoding=function(){return this._smartNameEncoding};
this.$getStringScreenWidth=function(c,j,a){function h(b){if(9==b)a+=g.getScreenTabSize(a);else{var c;if(c=4352<=b)c=4352>b?!1:4352<=b&&4447>=b||4515<=b&&4519>=b||4602<=b&&4607>=b||9001<=b&&9002>=b||11904<=b&&11929>=b||11931<=b&&12019>=b||12032<=b&&12245>=b||12272<=b&&12283>=b||12288<=b&&12350>=b||12353<=b&&12438>=b||12441<=b&&12543>=b||12549<=b&&12589>=b||12593<=b&&12686>=b||12688<=b&&12730>=b||12736<=b&&12771>=b||12784<=b&&12830>=b||12832<=b&&12871>=b||12880<=b&&13054>=b||13056<=b&&19903>=b||19968<=
b&&42124>=b||42128<=b&&42182>=b||43360<=b&&43388>=b||44032<=b&&55203>=b||55216<=b&&55238>=b||55243<=b&&55291>=b||63744<=b&&64255>=b||65040<=b&&65049>=b||65072<=b&&65106>=b||65108<=b&&65126>=b||65128<=b&&65131>=b||65281<=b&&65376>=b||65504<=b&&65510>=b;a=c?a+2:a+1}}if(0==j)return[0,0];null==j&&(j=Infinity);var a=a||0,g=this,b,i;for(i=0;i<c.length;i++){b=c.charCodeAt(i);if(b==f.charCodeAt(0)&&this.isSmartNamesEnabled()){b=m.getSmartNameInfoAt(this.getDocument(),0,i);b=d.getSmartNameDisplayString(this.getDocument(),
b);for(var e=0;e<b.length;e++){var k=b.charCodeAt(e);h(k)}}else h(b);if(a>j)break}return[a,i]};this.getWordRangeBase=this.getWordRange;this.getWordRange=function(c,d){return this.getLine(c).charAt(d)==f&&this.isSmartNamesEnabled()?new i(c,d,c,d+1):this.getWordRangeBase(c,d)};this.moveText=function(c,f,a){var h=this.getTextRange(c),h=d.recompileText(this,this.getDocument(),c.start.column,h,!0),g=this.getFoldsInRange(c),f=i.fromPoints(f,f);if(!a){this.remove(c);var b=c.start.row-c.end.row,k=b?-c.end.column:
c.start.column-c.end.column;k&&(f.start.row==c.end.row&&f.start.column>c.end.column&&(f.start.column+=k),f.end.row==c.end.row&&f.end.column>c.end.column&&(f.end.column+=k));b&&f.start.row>=c.end.row&&(f.start.row+=b,f.end.row+=b)}a=d.parseText(this,h,!0);d.startSmartNameChangeGroup(this.getDocument());h=a.text;f.end=this.insert(f.start,h);h=new i(0,f.start.column,0,f.start.column+a.text.length);d.addSmartNameAnchors(this.getDocument(),h,a.smartnames);d.stopSmartNameChangeGroup(this.getDocument(),
h);if(g.length){var e=c.start,c=f.start,b=c.row-e.row,k=c.column-e.column;this.addFolds(g.map(function(a){a=a.clone();a.start.row==e.row&&(a.start.column+=k);a.end.row==e.row&&(a.end.column+=k);a.start.row+=b;a.end.row+=b;return a}))}return f}}).call(k.EditSession.prototype)});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-document",["lib/ace/document","lib/ace/range","./smartnameanchorcontrol","./smartnameextensionutils"],function(k,l,m,d){var i=l.Range,f=m.undoRedo,c=m.applyDelta;(function(){this._insertLinesBase=this._insertLines;this._insertLines=function(f,a){d.startSmartNameChangeGroup(this);var h=this._insertLinesBase(f,a),g=new i(f,0,f+a.length,0);c(this,{action:"insertLines",range:g});d.stopSmartNameChangeGroup(this,g);return h};
this.insertInLineBase=this.insertInLine;this.insertInLine=function(f,a){d.startSmartNameChangeGroup(this);var h=this.insertInLineBase(f,a),g=i.fromPoints(f,h);c(this,{action:"insertText",range:g});d.stopSmartNameChangeGroup(this,g);return h};this.removeInLineBase=this.removeInLine;this.removeInLine=function(f,a,h){if(a!=h){d.startSmartNameChangeGroup(this);var g=new i(f,a,f,h);c(this,{action:"removeText",range:g});f=this.removeInLineBase(f,a,h);d.stopSmartNameChangeGroup(this,g);return f}};this._removeLinesBase=
this._removeLines;this._removeLines=function(f,a){d.startSmartNameChangeGroup(this);var h=new i(f,0,a+1,0);c(this,{action:"removeLines",range:h});var g=this._removeLinesBase(f,a);d.stopSmartNameChangeGroup(this,h);return g};this.applyDeltas=function(c){for(var a=0;a<c.length;a++){var d=c[a],g=i.fromPoints(d.range.start,d.range.end);"insertLines"==d.action?this.insertLines(g.start.row,d.lines):"insertText"==d.action?this.insert(g.start,d.text):"removeLines"==d.action?this._removeLines(g.start.row,
g.end.row-1):"removeText"==d.action?this.remove(g):f(this,d,!1)}};this.revertDeltas=function(c){for(var a=c.length-1;0<=a;a--){var d=c[a],g=i.fromPoints(d.range.start,d.range.end);"insertLines"==d.action?this._removeLines(g.start.row,g.end.row-1):"insertText"==d.action?this.remove(g):"removeLines"==d.action?this._insertLines(g.start.row,d.lines):"removeText"==d.action?this.insert(g.start,d.text):f(this,d,!0)}}}).call(k.Document.prototype)});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-layer-text",["lib/ace/layer/text","lib/ace/lib/lang","./smartnameanchorcontrol","./smartnameextensionutils","utils/ConvertUtils"],function(k,l,m,d){(function(){this.$renderToken=function(i,f,c,j){var a=this,h=/\x10|\t|&|<|( +)|([\x00-\x1f\x80-\xa0\xad\u1680\u180E\u2000-\u200f\u2028\u2029\u202F\u205F\u3000\uFEFF])|[\u1100-\u115F\u11A3-\u11A7\u11FA-\u11FF\u2329-\u232A\u2E80-\u2E99\u2E9B-\u2EF3\u2F00-\u2FD5\u2FF0-\u2FFB\u3000-\u303E\u3041-\u3096\u3099-\u30FF\u3105-\u312D\u3131-\u318E\u3190-\u31BA\u31C0-\u31E3\u31F0-\u321E\u3220-\u3247\u3250-\u32FE\u3300-\u4DBF\u4E00-\uA48C\uA490-\uA4C6\uA960-\uA97C\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFAFF\uFE10-\uFE19\uFE30-\uFE52\uFE54-\uFE66\uFE68-\uFE6B\uFF01-\uFF60\uFFE0-\uFFE6]/g,
g=function(b,c,d,e){if(c)return a.showInvisibles?"<span class='ace_invisible ace_invisible_space'>"+l.stringRepeat(a.SPACE_CHAR,b.length)+"</span>":l.stringRepeat("\u00a0",b.length);if("&"==b)return"&#38;";if("<"==b)return"&#60;";if("\t"==b)return b=a.session.getScreenTabSize(f+e),f+=b-1,a.$tabStrings[b];if("\u3000"==b)return b=a.showInvisibles?"ace_cjk ace_invisible ace_invisible_space":"ace_cjk",c=a.showInvisibles?a.SPACE_CHAR:"",f+=1,"<span class='"+b+"' style='width:"+2*a.config.characterWidth+
"px'>"+c+"</span>";if(d)return"<span class='ace_invisible ace_invisible_space ace_invalid'>"+a.SPACE_CHAR+"</span>";f+=1;return"<span class='ace_cjk' style='width:"+2*a.config.characterWidth+"px'>"+b+"</span>"},b=j.replace(h,function(b,c,e,i,j){return b==d.SMARTNAMECHAR&&a.session.isSmartNamesEnabled()?(c=a.session.screenToDocumentPosition(0,f+i),b=m.getSmartNameInfoAt(a.session.getDocument(),c.row,c.column),e=m.getActiveSmartNamePosition(a.session.getDocument()),c=null!=e&&c.row===e.row&&c.column===
e.column,b=d.getSmartNameDisplayString(a.session.getDocument(),b),f+=b.length-1,b=b.replace(h,g),"<span class='ace_smartname"+(c?" ace_smartname_active":"")+"'>"+b+"</span>"):g(b,c,e,i,j)});if(this.$textToken[c.type])i.push(b);else{var k="ace_"+c.type.replace(/\./g," ace_"),e="";"fold"==c.type&&(e=" style='width:"+c.value.length*this.config.characterWidth+"px;' ");i.push("<span class='",k,"'",e,">",b,"</span>")}return f+j.length}}).call(k.Text.prototype)});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-mouse-dragdrop_handler",["lib/ace/config","lib/ace/lib/event","lib/ace/range","./smartnameanchorcontrol","./smartnameextensionutils"],function(k,l,m,d,i){var f=m.Range;k.on("editor",function(c){var d=c.container,a;l.addListener(d,"dragstart",function(f){if(!this.cancelDrag&&d.draggable){var g=c.session.selection.getRange().start.column,f=f.dataTransfer;f.clearData();var b=c.session.getTextRange(),b=i.recompileText(c.session,
c.session.getDocument(),g,b,!0);f.setData("Text",b);a=!0}}.bind(this));l.addListener(d,"dragend",function(){a=!1}.bind(this));l.addListener(d,"drop",function(){if(!a){var d=c.getSelectedText(),g=i.tryParseText(c.session,d,!0);g.text!==d&&(i.startSmartNameChangeGroup(c.session.getDocument()),d=c.getSelectionRange(),d.isEmpty()||c.session.remove(d),c.session.insert(d.start,g.text),d=new f(0,d.start.column,0,d.start.column+g.text.length),i.addSmartNameAnchors(c.session.getDocument(),d,g.smartnames),
i.stopSmartNameChangeGroup(c.session.getDocument(),d))}}.bind(this))})});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-autocomplete",["lib/ace/autocomplete","lib/ace/autocomplete/util","./smartnameextensionutils"],function(k,l,m){l.retrievePrecedingIdentifier=function(d,i){var f=d.lastIndexOf(m.SMARTNAMECHAR,i),c=d.lastIndexOf("[",i);return-1===c||-1!==f&&c<f?"":d.substring(c,i)};(function(){this.insertMatch=function(d){d||(d=this.popup.getData(this.popup.getRow()));if(!d&&(d=this.popup.getData(0),!d))return!1;if(d.completer&&d.completer.insertMatch)d.completer.insertMatch(this.editor,
d);else{if(this.completions.filterText)for(var i=this.editor.selection.getAllRanges(),f=0,c;c=i[f];f++)c.start.column-=this.completions.filterText.length,this.editor.session.remove(c);d.snippet?snippetManager.insertSnippet(this.editor,d.snippet):d.smartname?this.editor.insertSmartName(d.smartname):this.editor.execCommand("insertstring",d.value||d)}this.detach()};delete this.commands.Space}).call(k.Autocomplete.prototype)});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-all","./mod-ace-editor ./mod-ace-edit_session ./mod-ace-document ./mod-ace-layer-text ./mod-ace-mouse-dragdrop_handler ./mod-ace-autocomplete".split(" "),function(){});
define("component/smartnames/input/smartnameinput","component/smartnames/encoding/smartnameencoding component/smartnames/encoding/smartnamestringpart component/smartnames/encoding/smartname ./smartnameeditpanel component/popover/Popover utils/webi18n!SmartNameSelector underscore jquery lib/ace/ace lib/ace/ext/language_tools ./ace-modifications-for-smartnamesupport/mod-ace-all".split(" "),function(k,l,m,d,i,f,c,j,a){function h(a){var b="[",b="ProjAttr"==a.getName()?b+(a.getArguments()[0]+" (Project)"):
"DocAttr"==a.getName()?b+(a.getArguments()[0]+" (Document)"):b+a.getFullName();return b+"]"}var g="showSettingsMenu goToNextError goToPreviousError centerselection gotoline fold unfold toggleFoldWidget toggleParentFoldWidget foldall foldOther unfoldall findnext findprevious selectOrFindNext selectOrFindPrevious find togglerecording replaymacro jumptomatching selecttomatching expandToMatching removeline duplicateSelection sortlines togglecomment toggleBlockComment modifyNumberUp modifyNumberDown replace copylinesup movelinesup copylinesdown movelinesdown cut_or_delete removetolinestart removetolineend outdent indent blockoutdent blockindent splitline transposeletters touppercase tolowercase expandtoline".split(" "),
b=function(b,e){b=void 0===b?document.createElement("div"):j(b).get(0);void 0===e&&(e={});void 0===e.readOnly&&(e.readOnly=!1);void 0===e.encoding&&(e.encoding=k.SAVEDSEARCH);this._encoding=e.encoding;this._mark=(this._markaware=!1===e.markaware?!1:!0)&&(!0===e.mark?!0:!1);this._markid=void 0!==e.markid?e.markid:"@";this._marksn=this._encoding.encodeSmartNameString([l.makeSmartNamePart(new m(this._markid))]);var o=a.edit(b);this._editor=o;this._div=j(b);this._formcontrol=this._div.wrap(j("<div/>")).parent();
b.SmartNameInput=this;o.$blockScrolling=Infinity;var u=o.getValue();o.getSession().enableSmartNames(this._encoding);this.setValue(u);this._displayFunction=e.displayFunction||h;o.getSession().getDocument().displayFunction=this._displayFunction;o.setOptions({highlightActiveLine:!1,highlightSelectedWord:!1});this.readOnly=e.readOnly;this.disabled=!1;this.readOnly?(o.setReadOnly(!0),o.setTheme("component/smartnames/input/themes/smartnames-display")):(this._formcontrol.addClass("form-control"),o.setTheme("component/smartnames/input/themes/smartnames-input"));
o.getSession().gutterRenderer={getWidth:function(){return 0},getText:function(){return""}};o.renderer.setOptions({showLineNumbers:!1,maxLines:1,printMargin:0,printMarginColumn:0,showPrintMargin:!1,displayIndentGuides:!1,showGutter:!1});o.renderer.setPadding(10);this._formcontrol.css({"padding-left":"0px","padding-right":"0px"});o.commands.removeCommands(g);o.commands.addCommand({name:"myCommand",bindKey:{win:"Ctrl-F",mac:"Command-F"},exec:function(){},readOnly:!0});var p=c.bind(function(a){a?(this._smartNameEditPopoverDiv&&
this._smartNameEditPopoverDiv.show(),this._smartNameEditPopover&&this._smartNameEditPopover.show()):this._destroySmartNameEditPanel()},this);this._recalculateSmartNameEditPopover=c.bind(function(a){a&&this._smartNameEditPopover&&(a=a.getSmartNameBoundingClientRect(!0),this._smartNameEditPopoverDiv||(this._smartNameEditPopoverDiv=j("<div />"),j("body").append(this._smartNameEditPopoverDiv)),this._smartNameEditPopoverDiv.css({position:"absolute",width:a.width,height:a.height,top:a.top+window.pageYOffset,
left:a.left+window.pageXOffset}),this._smartNameEditPopover.setContext(this._smartNameEditPopoverDiv),this._smartNameEditPopover.isActive()&&this._smartNameEditPopover.show())},this);this._lastAPI=null;o.initSmartNameEditListener(function(a){this._lastAPI&&this._smartNameEditPanel&&this._lastAPI.setSmartName(this._smartNameEditPanel.getSmartName().getFullName());var b=new m(a.getSmartName()),c={};"List"==b.getName()?(c.labels=[f.t("SMARTNAME_LIST_NAME"),f.t("SMARTNAME_LIST_RESULT_COLUMN"),f.t("SMARTNAME_LIST_LOOKUP_COLUMN"),
f.t("SMARTNAME_LIST_LOOKUP_VALUE")],c.hasStrictParams=!0,c.smartnameInputOptions=e,this._smartNameEditPanel=new d(b,c),this.isDisabled()?this._smartNameEditPanel.disable():this._smartNameEditPanel.enable(),this._smartNameEditPopover||(this._smartNameEditPopover=new i(this.getJQElement(),j("body"),j("body"),"bottom","#FAFAFA","SmartNameEditPopover",void 0,void 0,void 0,"#CCC")),this._smartNameEditPopover.setContent(this._smartNameEditPanel.getJQElement()),this._smartNameEditPanel.onSave(function(){var b=
this._smartNameEditPanel.getSmartName();a.setSmartName(b.getFullName());p(!1);a.setActive(!1)}.bind(this)),this._smartNameEditPanel.onCancel(function(){p(!1);a.setActive(!1)}.bind(this)),a.setActive(!0),this._recalculateSmartNameEditPopover(a),p(!0),this._lastAPI=a):p(!1)}.bind(this));this._editor.configureSmartNameTooltip(function(a,b,c){return"List"==(new m(a)).getName()&&!b?(c.text(f.t("SMARTNAME_LIST_TOOLTIP")),!0):!1});this.onValueChange(c.bind(function(){this._lastAPI&&!this._lastAPI.isValid()&&
(p(!1),this._lastAPI.setActive(!1),this._lastAPI=null)},this))};(function(){this._addMark=function(a){this._mark&&(!this._encoding.containsSmartName(a)&&0<a.length)&&(a=this._marksn+a);return a};this._removeMark=function(a){if(this._markaware&&a.length>=this._marksn.length){for(var a=this._encoding.decodeSmartNameString(a),b=0;b<a.length;b++){var c=a[b];c.isSmartNamePart()&&c.getAsSmartName().getName()===this._markid&&(a.splice(b,1),b--)}a=this._encoding.encodeSmartNameString(a)}return a};this.getValue=
function(){return this._addMark(this._editor.getSmartNameEncodedValue())};this.setValue=function(a){try{this._encoding.decodeSmartNameString(a)}catch(b){window.console.error("Error: Illegal value used in setValue on SmartField. Falling back to text..."),a=this._encoding.escapeString(a)}this._editor.setSmartNameEncodedValue(this._removeMark(a))};this.clear=function(){this._editor.setValue("")};this.onBlur=function(a){this._editor.on("blur",function(){try{a()}catch(b){console.error("An error was thrown in a blur listener: "+
b)}})};this.onValueChange=function(a){var b=this;this._editor.on("change",function(){try{b._editor.isChangeReady()&&a(b.getValue())}catch(c){console.error("An error was thrown in a change listener: "+c)}})};this.setSmartNames=function(a){var b=a.map(c.bind(function(a){var b=this._displayFunction(a);return{caption:b,value:b,score:1,meta:"",smartname:a.getFullName()}},this));this._editor.setOptions({enableLiveAutocompletion:[{getCompletions:function(a,c,d,f,g){g(null,b)}}]});this._editor.resize(!0)};
this.insertText=function(a){this._editor.insert(a);this._editor.renderer.scrollCursorIntoView()};this.insertSmartName=function(a){this._editor.insertSmartName(a);this._editor.renderer.scrollCursorIntoView()};this.show=function(){this._formcontrol.show()};this.hide=function(){this._formcontrol.hide()};this.focus=function(){this._editor.focus()};this.blur=function(){this._editor.blur()};this.resize=function(){this._editor.resize();this._recalculateSmartNameEditPopover(this._lastAPI);this._smartNameEditPanel&&
this._smartNameEditPanel.resize()};this.isDisabled=function(){return this.disabled};this.disable=function(){this.disabled||(this.disabled=!0,this._editor.setReadOnly(!0),this._div.addClass("ace_smartinput_disabled"),this._smartNameEditPanel&&this._smartNameEditPanel.disable())};this.enable=function(){this.disabled&&(this.disabled=!1,this._editor.setReadOnly(!1),this._div.removeClass("ace_smartinput_disabled"),this._smartNameEditPanel&&this._smartNameEditPanel.enable())};this._destroySmartNameEditPanel=
function(){this._smartNameEditPopover&&(this._smartNameEditPopoverDiv.remove(),this._smartNameEditPopoverDiv=null,this._smartNameEditPopover.destroy(),this._smartNameEditPopover=null);this._smartNameEditPanel&&(this._smartNameEditPanel.destroy(),this._smartNameEditPanel=null)};this.destroy=function(){var a=this.getValue();this._destroySmartNameEditPanel();this.stopEditing();this._editor.destroy();this.getJQElement().text(a).removeClass("ace_editor").removeClass("ace-smartnamefield-display").removeClass("ace-smartnamefield-input");
try{delete this._div.get(0).SmartNameInput}catch(b){}};this.stopEditing=function(){this._editor.completer&&this._editor.completer.getPopup()&&this._editor.completer.getPopup().hide()};this.getJQElement=function(){return this._formcontrol}}).call(b.prototype);b.wcrinit=function(a){new b(a)};b.wcrdestroy=function(a){a.SmartNameInput.destroy()};return b});