/*
 (c) 2015, Vladimir Agafonkin
 RBush, a JavaScript library for high-performance 2D spatial indexing of points and rectangles.
 https://github.com/mourner/rbush
*/

(function(){function l(a,b){if(!(this instanceof l))return new l(a,b);this._maxEntries=Math.max(4,a||9);this._minEntries=Math.max(2,Math.ceil(0.4*this._maxEntries));b&&this._initFormat(b);this.clear()}function n(a,b){a.bbox=o(a,0,a.children.length,b)}function o(a,b,c,d){for(var g=[Infinity,Infinity,-Infinity,-Infinity],e;b<c;b++)e=a.children[b],p(g,a.leaf?d(e):e.bbox);return g}function p(a,b){a[0]=Math.min(a[0],b[0]);a[1]=Math.min(a[1],b[1]);a[2]=Math.max(a[2],b[2]);a[3]=Math.max(a[3],b[3]);return a}
function x(a,b){return a.bbox[0]-b.bbox[0]}function y(a,b){return a.bbox[1]-b.bbox[1]}function t(a){return(a[2]-a[0])*(a[3]-a[1])}function r(a){return a[2]-a[0]+(a[3]-a[1])}function u(a,b){return a[0]<=b[0]&&a[1]<=b[1]&&b[2]<=a[2]&&b[3]<=a[3]}function s(a,b){return b[0]<=a[2]&&b[1]<=a[3]&&b[2]>=a[0]&&b[3]>=a[1]}function v(a,b,c,d,g){for(var e=[b,c],f;e.length;)c=e.pop(),b=e.pop(),c-b<=d||(f=b+Math.ceil((c-b)/d/2)*d,w(a,b,c,f,g),e.push(b,f,f,c))}function w(a,b,c,d,g){for(var e,f,i,h,j;c>b;){600<c-
b&&(e=c-b+1,f=d-b+1,i=Math.log(e),h=0.5*Math.exp(2*i/3),j=0.5*Math.sqrt(i*h*(e-h)/e)*(0>f-e/2?-1:1),i=Math.max(b,Math.floor(d-f*h/e+j)),f=Math.min(c,Math.floor(d+(e-f)*h/e+j)),w(a,i,f,d,g));e=a[d];f=b;h=c;q(a,b,d);for(0<g(a[c],e)&&q(a,b,c);f<h;){q(a,f,h);f++;for(h--;0>g(a[f],e);)f++;for(;0<g(a[h],e);)h--}0===g(a[b],e)?q(a,b,h):(h++,q(a,h,c));h<=d&&(b=h+1);d<=h&&(c=h-1)}}function q(a,b,c){var d=a[b];a[b]=a[c];a[c]=d}l.prototype={all:function(){return this._all(this.data,[])},search:function(a){var b=
this.data,c=[],d=this.toBBox;if(!s(a,b.bbox))return c;for(var g=[],e,f,i,h;b;){e=0;for(f=b.children.length;e<f;e++)i=b.children[e],h=b.leaf?d(i):i.bbox,s(a,h)&&(b.leaf?c.push(i):u(a,h)?this._all(i,c):g.push(i));b=g.pop()}return c},collides:function(a){var b=this.data,c=this.toBBox;if(!s(a,b.bbox))return!1;for(var d=[],g,e,f,i;b;){g=0;for(e=b.children.length;g<e;g++)if(f=b.children[g],i=b.leaf?c(f):f.bbox,s(a,i)){if(b.leaf||u(a,i))return!0;d.push(f)}b=d.pop()}return!1},load:function(a){if(!a||!a.length)return this;
if(a.length<this._minEntries){for(var b=0,c=a.length;b<c;b++)this.insert(a[b]);return this}a=this._build(a.slice(),0,a.length-1,0);this.data.children.length?this.data.height===a.height?this._splitRoot(this.data,a):(this.data.height<a.height&&(b=this.data,this.data=a,a=b),this._insert(a,this.data.height-a.height-1,!0)):this.data=a;return this},insert:function(a){a&&this._insert(a,this.data.height-1);return this},clear:function(){this.data={children:[],height:1,bbox:[Infinity,Infinity,-Infinity,-Infinity],
leaf:!0};return this},remove:function(a){if(!a)return this;for(var b=this.data,c=this.toBBox(a),d=[],g=[],e,f,i,h;b||d.length;){b||(b=d.pop(),f=d[d.length-1],e=g.pop(),h=!0);if(b.leaf&&(i=b.children.indexOf(a),-1!==i)){b.children.splice(i,1);d.push(b);this._condense(d);break}!h&&!b.leaf&&u(b.bbox,c)?(d.push(b),g.push(e),e=0,f=b,b=b.children[0]):f?(e++,b=f.children[e],h=!1):b=null}return this},toBBox:function(a){return a},compareMinX:function(a,b){return a[0]-b[0]},compareMinY:function(a,b){return a[1]-
b[1]},toJSON:function(){return this.data},fromJSON:function(a){this.data=a;return this},_all:function(a,b){for(var c=[];a;)a.leaf?b.push.apply(b,a.children):c.push.apply(c,a.children),a=c.pop();return b},_build:function(a,b,c,d){var g=c-b+1,e=this._maxEntries,f;if(g<=e)return f={children:a.slice(b,c+1),height:1,bbox:null,leaf:!0},n(f,this.toBBox),f;d||(d=Math.ceil(Math.log(g)/Math.log(e)),e=Math.ceil(g/Math.pow(e,d-1)));f={children:[],height:d,bbox:null};var g=Math.ceil(g/e),e=g*Math.ceil(Math.sqrt(e)),
i,h,j;for(v(a,b,c,e,this.compareMinX);b<=c;b+=e){h=Math.min(b+e-1,c);v(a,b,h,g,this.compareMinY);for(i=b;i<=h;i+=g)j=Math.min(i+g-1,h),f.children.push(this._build(a,i,j,d-1))}n(f,this.toBBox);return f},_chooseSubtree:function(a,b,c,d){for(var g,e,f,i,h,j,k,m;;){d.push(b);if(b.leaf||d.length-1===c)break;k=m=Infinity;g=0;for(e=b.children.length;g<e;g++)f=b.children[g],h=t(f.bbox),j=(Math.max(f.bbox[2],a[2])-Math.min(f.bbox[0],a[0]))*(Math.max(f.bbox[3],a[3])-Math.min(f.bbox[1],a[1]))-h,j<m?(m=j,k=h<
k?h:k,i=f):j===m&&h<k&&(k=h,i=f);b=i}return b},_insert:function(a,b,c){var d=this.toBBox,c=c?a.bbox:d(a),d=[],g=this._chooseSubtree(c,this.data,b,d);g.children.push(a);for(p(g.bbox,c);0<=b;)if(d[b].children.length>this._maxEntries)this._split(d,b),b--;else break;this._adjustParentBBoxes(c,d,b)},_split:function(a,b){var c=a[b],d=c.children.length,g=this._minEntries;this._chooseSplitAxis(c,g,d);d=this._chooseSplitIndex(c,g,d);d={children:c.children.splice(d,c.children.length-d),height:c.height};c.leaf&&
(d.leaf=!0);n(c,this.toBBox);n(d,this.toBBox);b?a[b-1].children.push(d):this._splitRoot(c,d)},_splitRoot:function(a,b){this.data={children:[a,b],height:a.height+1};n(this.data,this.toBBox)},_chooseSplitIndex:function(a,b,c){var d,g,e,f,i,h,j;i=h=Infinity;for(d=b;d<=c-b;d++){g=o(a,0,d,this.toBBox);e=o(a,d,c,this.toBBox);var k=g,m=e;f=Math.max(k[0],m[0]);var l=Math.max(k[1],m[1]),n=Math.min(k[2],m[2]),k=Math.min(k[3],m[3]);f=Math.max(0,n-f)*Math.max(0,k-l);g=t(g)+t(e);f<i?(i=f,j=d,h=g<h?g:h):f===i&&
g<h&&(h=g,j=d)}return j},_chooseSplitAxis:function(a,b,c){var d=a.leaf?this.compareMinX:x,g=a.leaf?this.compareMinY:y,e=this._allDistMargin(a,b,c,d),b=this._allDistMargin(a,b,c,g);e<b&&a.children.sort(d)},_allDistMargin:function(a,b,c,d){a.children.sort(d);var d=this.toBBox,g=o(a,0,b,d),e=o(a,c-b,c,d),f=r(g)+r(e),i,h;for(i=b;i<c-b;i++)h=a.children[i],p(g,a.leaf?d(h):h.bbox),f+=r(g);for(i=c-b-1;i>=b;i--)h=a.children[i],p(e,a.leaf?d(h):h.bbox),f+=r(e);return f},_adjustParentBBoxes:function(a,b,c){for(;0<=
c;c--)p(b[c].bbox,a)},_condense:function(a){for(var b=a.length-1,c;0<=b;b--)0===a[b].children.length?0<b?(c=a[b-1].children,c.splice(c.indexOf(a[b]),1)):this.clear():n(a[b],this.toBBox)},_initFormat:function(a){var b=["return a"," - b",";"];this.compareMinX=new Function("a","b",b.join(a[0]));this.compareMinY=new Function("a","b",b.join(a[1]));this.toBBox=new Function("a","return [a"+a.join(", a")+"];")}};"function"===typeof define&&define.amd?define("rbush",[],function(){return l}):"undefined"!==
typeof module?module.exports=l:"undefined"!==typeof self?self.rbush=l:window.rbush=l})();