/**
	 * Create a new AnimationOptions object of the given type
	 * see http://greweb.me/2012/02/bezier-curve-based-easing-functions-from-concept-to-implementation/
	 * 
	 * MIT License
	 *
	 * KeySpline - use bezier curve for transition easing function
	 * Copyright (c) 2012 Gaetan Renaudeau <renaudeau.gaetan@gmail.com>
	 *
	 * Permission is hereby granted, free of charge, to any person obtaining a
	 * copy of this software and associated documentation files (the "Software"),
	 * to deal in the Software without restriction, including without limitation
	 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
	 * and/or sell copies of the Software, and to permit persons to whom the
	 * Software is furnished to do so, subject to the following conditions:
	 *
	 * The above copyright notice and this permission notice shall be included in
	 * all copies or substantial portions of the Software.
	 *
	 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
	 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
	 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
	 * DEALINGS IN THE SOFTWARE.
	 * 
	 * Notice: changed by Esko to become prototyped
	 */

define("web-viewer/core/CoreConstants",{TOOLS:{PAN:"pan",ZOOM:"zoom",TOUCH:"touch",NOTOUCH:"notouch",ANNOTATION:"annotationtool",DYNCONTENT:"dyncontenttool",ANNOTATION_TOUCH_DRAW:"annotationTouchDrawTool",ANNOTATION_TOUCH:"annotationTouchTool",ANNOTATION_DRAW:"annotationdrawtool",ANNOTATION_NOTE_DRAW:"annotationnotetool",ANNOTATION_INDICATOR:"annotationindicatortool",COMPARE_ANCHOR_ALIGNMENT:"compareAnchorTool",MEASURE_BARCODE:"measureBarcodeTool",MEASURE_BRAILLE:"measureBrailleTool",MEASURE_EYEDROPPER:"measureEyeDropperTool",
MEASURE_RULER:"measureRulerTool",MEASURE_CALIPER:"measureCaliperTool",MEASURE_SCREEN_RULING:"measureScreenRulingTool",INTERRUPT:"interruptTool",NAVIGATIONPAN:"navigationPanTool",MOUSE_LOCATOR:"mouseLocatorTool"},SizeUnits:{MM:0,CM:1,INCH:2,PIXELS:3,POINTS:4},EyeDropperUnits:{SQMM:0,SQCM:1,SQINCH:2,PIXELS:3,PERCENT:5},ResolutionUnits:{PPI:0,PPMM:1,PPCM:2},UnitsLocNames:["Unitmm","Unitcm","UnitInchShort","UnitPixelsShort","UnitPoint"],UnitsFixes:[2,3,3,0,1],ResUnitsLocNames:["UnitResInch","UnitResmm",
"UnitRescm"],ResUnitsFixes:[3,2,3],ScreenUnitsLocNames:["UnitScreenInch","UnitScreenmm","UnitScreencm"],ScreenUnitsFixes:[2,1,2],EyeDropperUnitsLocNames:"Unitmm2 Unitcm2 UnitInch2 UnitPixels  UnitPercent".split(" "),EyeDropperUnitsShortLocNames:"Unitmm2 Unitcm2 UnitInch2Short UnitPixelsShort  UnitPercent".split(" "),EyeDropperUnitsFixes:[2,3,3,0,0,2]});
define("web-viewer/layout/LayoutConstants",{LayoutItemType:{WIDGET:0,TOOLBARCOMPONENT:1},Widget:{CHANNELS:"channelsWidget",CAD:"cadWidget",APPROVAL:"approvalDetailsWidget",HELP:"help/helpWidget",ANNOTATION:"annotationWidget",COMPARE:"compareWidget",PAGELIST:"pagelist/pagelistWidget",DEBUG:"debugWidget",INFO:"infoWidget",VIEWPORT:"ViewportWidget",ALIGNWIZARD:"compareAlignmentWizardWidget",DOCUMENTINFO:"documentInfo/DocumentInfoWidget",MESSAGE:"message/MessageWidget",NAVIGATOR:"navigation/NavigatorWidget",
VIEWCONTROLS:"viewControlsWidget",ATTRIBUTE_CATEGORY:"attributeCategoryWidget",VIEW3D:"View3DWidget",TEXTCONTENT:"textContent/TextContentWidget"},ToolbarComponent:{ANNOTATION:"annotationControls",DYNCONTENT:"dynContentControls",APPROVAL:"approvalControls",COMPARE:"compareControls",MEASURE:"measureControls",NAVIGATE:"navigationControls",PAGELIST:"pagelistControls",DOCUMENTSELECTOR:"documentSelector",PAGESELECTION:"pageselectionControls",VIEW3D:"view3DControls"},LayoutMode:{BASIC:0,RESTRICTED:1,WIZARD:2,
MOBILE_VIEW:3,MOBILE_READERSPREAD:4,MOBILE_ANNOTATION:5,MOBILE_COMPARE:6,MOBILE_3D:7},LayoutType:{AUTOMATIC:"automatic",DESKTOP:"desktop",MOBILE:"mobile",FLEX:"flex"},MobileLayoutModeBarOrder:[3,6,4,7,5],ViewerStyle:{ADVANCED:0,NORMAL:1,RESTRICTED:2,SIMPLIFIED:3}});
define("web-viewer/core/ViewerFacade",["web-viewer/core/CoreConstants","web-viewer/layout/LayoutConstants"],function(f,g){var e=function(d,c,b){this.i18n=null;this.emit=function(){c.emit.apply(c,arguments)};this.eDelimiter=c.delimiter;this.on=function(){c.on.apply(c,arguments)};this.off=function(){c.off.apply(c,arguments)};this.once=function(){c.once.apply(c,arguments)};this.many=function(){c.many.apply(c,arguments)};this.listeners=function(){return c.listeners.apply(c,arguments)};this.removeAllListeners=
function(){c.removeAllListeners.apply(c,arguments)};this.openDocuments=function(a){d.openDocuments(a)};this.getDocumentController=function(){return d.getDocumentController()};this.getConfig=function(){return d.getConfig()};this.getCurrentUser=function(){return d.getCurrentUser()};this.debug=b;this.getProperty=function(a){return d.getProperty(a)};this.getDataAdapter=function(){return d.getDataAdapter()};this.getContext=function(){return d.getAppContext()};this.requestModule=function(a,b,n){void 0===
n&&(n=!0);d.requestModule(a,b,n)};this.getModule=function(a){return d.getModuleIfAvailable(a)};this.whenModuleAvailable=function(a,b,n){return d.whenModuleAvailable(a,b,n)};this.whenAllModulesAreLoaded=function(a){return d.whenAllModulesAreLoaded(a)};this.getLoadedModules=function(){return d.getLoadedModules()};this.injectState=function(a){return d.injectState(a)};this.getViewerState=function(){return d.getState()};this.ajax=function(a,b){return d.ajax(a,b)};this.startMode=function(a){return d.startMode(a)};
this.stopMode=function(a){return d.stopMode(a)};this.stopActiveMode=function(){return d.stopActiveMode()};this.getActiveMode=function(){return d.getActiveMode()};this.getLayoutType=function(){return d.getLayoutType()};this.isMobile=function(){return d.getLayoutType()===g.LayoutType.MOBILE};this.switchLayout=function(a){d.switchLayout(a)};this.getFeatureDetector=function(){return d.getFeatureDetector()};this.canFetchFragments=function(){return d.canFetchFragments()}};e.prototype.getOption=function(d){return this.getCurrentUser().getOption(d)};
e.prototype.setOption=function(d,c,b){return this.getCurrentUser().setOption(d,c,b)};e.prototype.setOptionCallback=function(d,c,b){return this.getCurrentUser().setOption(d,c,!1,b)};e.prototype.resetOption=function(d){return this.getCurrentUser().resetOption(d)};e.prototype.getActiveDocument=function(){return this.getDocumentController().getActiveDocument()};e.prototype.getActivePage=function(){return this.getDocumentController().getActivePage()};e.prototype.getUnits=function(){var d=this.getCurrentUser().getOption("PREFERENCES_UNIT_SIZE");
isNaN(d)&&(d=this.getProperty("units"),d=isNaN(d)?f.SizeUnits.MM:parseInt(d,10));return d};e.prototype.getUnitsLocName=function(d){void 0===d&&(d=this.getUnits());return d===f.SizeUnits.PIXELS&&this.getActivePage()&&this.getActivePage().hasCad()&&!this.getActivePage().hasGraphics()?f.UnitsLocNames[f.SizeUnits.POINTS]:f.UnitsLocNames[d]};e.prototype.getUnitsFix=function(d){return void 0!==d?f.UnitsFixes[d]:f.UnitsFixes[this.getUnits()]};e.prototype.getResolutionUnits=function(){return this.getCurrentUser().getOption("PREFERENCES_UNIT_RESOLUTION")};
e.prototype.getResolutionUnitsLocName=function(){return f.ResUnitsLocNames[this.getResolutionUnits()]};e.prototype.getResolutionUnitsFix=function(d){return void 0!==d?f.ResUnitsFixes[d]:f.ResUnitsFixes[this.getResolutionUnits()]};e.prototype.getScreenUnits=function(){return this.getCurrentUser().getOption("PREFERENCES_UNIT_SCREENRULING")};e.prototype.getScreenUnitsLocName=function(){return f.ScreenUnitsLocNames[this.getScreenUnits()]};e.prototype.getScreenUnitsFix=function(d){return void 0!==d?f.ScreenUnitsFixes[d]:
f.ScreenUnitsFixes[this.getScreenUnits()]};e.prototype.loadBundle=function(d,c,b){this.i18n.loadBundle(d,c,b)};e.prototype.t=function(d,c,b){return this.i18n.t.apply(this.i18n,arguments)};e.prototype.isParameterUpdateOngoing=function(){return this.getDocumentController().isParameterUpdateOngoing()};return e});
define("web-viewer/data/DocumentController",["web-viewer/core/PrivateChannel","utils/Map","utils/StringSet","underscore"],function(f,g,e,d){var c=function(b,a){this.f=b;f.installTo(this,b,"doc");this._nextIID=0;this._documents=new g;this._linkedDocuments=new g;this._adapter=a;this._pendingParameterUpdateOrigins=new e;this._parameterUpdateOngoing=!0;this._documentsLoading=0;this._debouncedExecuteParameterUpdateIfAllowed=d.debounce(d.bind(this._executeParameterUpdateIfAllowed,this),20);var h=d.debounce(d.bind(this._notifyParametersUpdated,
this),20);this.on("**.page.*.parameters.changed",d.bind(function(){this._parameterUpdateOngoing||h()},this));var n=d.debounce(d.bind(this._notifyStateParametersUpdated,this),20);this.on("**.page.*.stateParameter.changed",d.bind(function(a){n(a)},this));this.f.on("intercept.fragmentURL",d.bind(this.interceptFragmentURL,this))};c.prototype.openDocuments=function(b){this._documentsLoading=this._adapter.getNumberOfDocuments(b);this._adapter.openDocuments(b,d.bind(function(a,b){this._documentsLoading--;
this.addDocument(a,b);if(a.hasLinkedDocument()){var n=a.getLinkedDocument();this._linkedDocuments.add(n.getIID(),n)}},this))};c.prototype.createNewLinkedCadFromOverlay=function(b,a){if(this._cadOverlay||a){a||(a=this._cadOverlay);var h=this._activePage.getDocument().getLinkedDocumentPage(),n=this._adapter.getDeepCopy(a,void 0,void 0,this.getNextIID());this._activePage.getDocument().setLinkedDocumentPage(n);this._linkedDocuments.add(n.getDocument().getIID(),n.getDocument());b||this.changeCadOverlay(n);
this._emit("newLinkedCad",h,n)}else h=this._activePage.getDocument().getLinkedDocumentPage(),this._activePage.getDocument().setLinkedDocumentPage(null),this._cadOverlay=null,this._emit("newLinkedCad",h,null)};c.prototype.addNewLinkedDocument=function(b,a){var h=this._activePage.getDocument().getLinkedDocumentPage(),n=b.getDocumentVersion().getPage();this._activePage.getDocument().setLinkedDocumentPage(n);this._linkedDocuments.add(b.getIID(),b);a||this.changeCadOverlay(n);this._emit("newLinkedCad",
h,n)};c.prototype.loadDocumentPages=function(b,a){var h=this.getDocument(b);void 0!==h&&(h=h.getDocumentVersion(a),void 0!==h&&this._adapter.getPagesOfDocumentVersion(h,d.bind(function(){this._emit("loaded")},this)))};c.prototype.getLinkedDocuments=function(){return this._linkedDocuments.values()};c.prototype.getDocument=function(b){var a=this._documents.get(b);return a?a:this._linkedDocuments.get(b)};c.prototype.getDocumentPage=function(b){var b=b.split("_"),a=this.getDocument(b[0]);if(a&&(a=a.getDocumentVersion(b[1])))return a.getPage(b[2])};
c.prototype.willNeedParameterUpdate=function(b){this._pendingParameterUpdateOrigins.has(b)||(this._pendingParameterUpdateOrigins.add(b),this._parameterUpdateOngoing=!0,d.each([this._activePage,this._differencePage,this._cadOverlay],function(a){a&&a.setParametersAvailable(!1)},this),this._emit("parameters.willChange",b),this._adapter.cancelDocumentParametersUpdate())};c.prototype.readyForParameterUpdate=function(b,a,h){void 0!==this._pendingParameterUpdateOrigins.remove(b)&&(this._emit("parameters.readyForUpdate",
b),a&&this.whenParametersAvailable(a,h),0===this._pendingParameterUpdateOrigins.size()&&this._debouncedExecuteParameterUpdateIfAllowed())};c.prototype._executeParameterUpdateIfAllowed=function(){0===this._pendingParameterUpdateOrigins.size()&&(this._emit("parameters.startUpdate"),this._updateParameters(d.bind(function(){var b;d.each([this._activePage,this._differencePage,this._cadOverlay],function(a){a&&a.setParametersAvailable(!0)},this);this._emit("parameters.beforeEndUpdate",this._activePageHasChanged,
this._differencePageHasChanged,this._cadOverlayHasChanged);this._emit("parameters.endUpdate",this._activePageHasChanged,this._differencePageHasChanged,this._cadOverlayHasChanged);this._emit("parameters.afterEndUpdate",this._activePageHasChanged,this._differencePageHasChanged,this._cadOverlayHasChanged);var a=this.getActivePage(),h=this.getDifferencePage();a&&this._emit("activePageParametersChange",a,h);this._activePageHasChanged&&this._emit("activePageChangedAndParametersAvailable",this._previousActivePage,
a);(a||this._activePageHasChanged)&&this._emit("activePageChangedAndParametersAvailableOrChange",this._previousActivePage,a);h&&this._emit("differencePageParametersChange",a,h);this._differencePageHasChanged&&this._emit("differencePageChangedAndParametersAvailable",this._previousDifferencePage,h);(h||this._differencePageHasChanged)&&this._emit("differencePageChangedAndParametersAvailableOrChange",this._previousDifferencePage,h);if(this._activePageHasChanged||this._differencePageHasChanged)b=this._activePageHasChanged?
this._previousActivePage:this._previousDifferencePage,this._emit("activeOrDifferencePageChangedAndParametersAvailable",a,h,b,this._activePageHasChanged);if(a||h||this._activePageHasChanged||this._differencePageHasChanged)b=this._activePageHasChanged?this._previousActivePage:this._differencePageHasChanged?this._previousDifferencePage:void 0,this._emit("activeOrDifferencePageChangedAndParametersAvailableOrChange",a,h,b,this._activePageHasChanged);this._cadOverlayHasChanged&&this._emit("cadOverlayChangedAndParametersAvailable",
this._previousCadOverlay,this._cadOverlay);(this._activePageHasChanged||this._differencePageHasChanged||this._cadOverlayHasChanged)&&this._emit("activeOrDifferenceOrCadOverlayChangedAndParametersAvailable",a,h,this._cadOverlay);this._parameterUpdateOngoing=!1;this._emit("parameters.changed",a,h);this._cadOverlayHasChanged=this._differencePageHasChanged=this._activePageHasChanged=!1;this._previousDifferencePage=this._previousActivePage=void 0},this)))};c.prototype._notifyParametersUpdated=function(){if(!this._parameterUpdateOngoing){var b=
this.getActivePage(),a=this.getDifferencePage();b&&(this._emit("activePageParametersChange",b,a),this._emit("activePageChangedAndParametersAvailableOrChange",b,b));a&&(this._emit("differencePageParametersChange",b,a),this._emit("differencePageChangedAndParametersAvailableOrChange",a,a));(b||a)&&this._emit("activeOrDifferencePageChangedAndParametersAvailableOrChange",b,a,a,!1)}};c.prototype._notifyStateParametersUpdated=function(b){var a=this.getDifferencePage(),h=this.getCadOverlay();b===a?this._emit("referencePageStateParametersChanged",
this.getActivePage(),this.getDifferencePage()):b===h&&this._emit("cadOverlayPageStateParametersChanged",this.getActivePage(),this.getDifferencePage(),this.getCadOverlay())};c.prototype.isParameterUpdateOngoing=function(){return this._parameterUpdateOngoing};c.prototype.whenParametersAvailable=function(b,a){a&&(b=d.bind(b,a));if(this.isParameterUpdateOngoing())this.once("parameters.changed",b);else b(this.getActivePage(),this.getDifferencePage())};c.prototype._updateParameters=function(b){this._adapter.updateDocumentParameters(this._activePage,
this._differencePage,this._cadOverlay,b)};c.prototype.getActivePage=function(){return this._activePage};c.prototype.hasActiveDocumentPage=function(){return void 0!==this._activePage};c.prototype.hasActiveDocumentPageWithParametersAvailable=function(){return void 0!==this._activePage&&this._activePage.isParametersAvailable()};c.prototype.hasCadOverlaywWithParametersAvailable=function(){return this._cadOverlay&&this._cadOverlay.isParametersAvailable()};c.prototype.hasDifferenceDocumentPage=function(){return void 0!==
this._differencePage};c.prototype.hasDifferenceDocumentPageWithParametersAvailable=function(){return void 0!==this._differencePage&&this._differencePage.isParametersAvailable()};c.prototype.getDifferencePage=function(){return this._differencePage};c.prototype.getNextIID=function(){return this._nextIID++};c.prototype.addDocument=function(b,a){this._documents.add(b.getIID(),b);this._emit("loaded",b);a&&void 0!==b.getDocumentVersion()&&void 0!==b.getDocumentVersion().getFirstPage()&&this.changeActivePage(b.getDocumentVersion().getFirstPage())};
c.prototype.getActiveDocument=function(){if(this.hasActiveDocumentPage()){var b=this._activePage.getDocument();return!this.hasDocument(b)?(this.f.emit("error.WARNING","Trying to get an already removed document"),null):b}return null};c.prototype.getDifferenceDocument=function(){if(this.hasDifferenceDocumentPage()){var b=this._differencePage.getDocument();return!this.hasDocument(b)?(this.f.emit("error.WARNING","Trying to get an already removed document"),null):b}return null};c.prototype.getActiveDocumentVersion=
function(){if(this.hasActiveDocumentPage()){var b=this._activePage.getDocumentVersion();return!this.hasDocument(b.getDocument())?(this.f.emit("error.WARNING","Trying to get an already removed document version"),null):b}return null};c.prototype.getDifferenceDocumentVersion=function(){if(this.hasDifferenceDocumentPage()){var b=this._differencePage.getDocumentVersion();return!this.hasDocument(b.getDocument())?(this.f.emit("error.WARNING","Trying to get an already removed document version"),null):b}return null};
c.prototype.hasDocument=function(b){return this._documents.has(b.getIID())};c.prototype.changeActivePage=function(b){if(b){var a=b.getDocument(),h=this._activePage,n=null;h&&(n=h.getDocumentVersion());if(this.hasDocument(a)){b={oldActivePage:this._activePage,newActivePage:b,diffPage:this._differencePage};this.f.emit("intercept.activePageChange",b);b.diffPage!==this._differencePage&&this.changeDifferencePage(b.diffPage);this._activePage=b.newActivePage;var j=this._activePage.getDocumentVersion();if(h!=
this._activePage){this.willNeedParameterUpdate("ACTIVE_PAGE_CHANGE");this._activePageHasChanged=!0;(this._previousActivePage=h)&&h.resetState();var c=d.bind(function(){if(this._activePage.hasLinkedPage()){var a=this._activePage.getLinkedPage();this.changeCadOverlay(a)}else this.changeCadOverlay();this._emit("page.active",h,this._activePage);n!=j&&this._emit("documentVersion.active",n,j);this.readyForParameterUpdate("ACTIVE_PAGE_CHANGE")},this);this._activePage.needsDataUpdate()?this._adapter.updateDocumentData(this._activePage,
d.bind(function(){c()},this)):c();return!0}return!1}}else this.f.emit("error.WARNING","Trying to change the active page to undefined")};c.prototype.resetDifferencePage=function(){var b=this._differencePage;void 0!==b&&(this.willNeedParameterUpdate("RESET_DIFFERENCE_PAGE"),this._differencePageHasChanged=!0,this._previousDifferencePage=b,this._differencePage=void 0,b.resetState(),this._emit("page.difference",b,this._differencePage),this.readyForParameterUpdate("RESET_DIFFERENCE_PAGE"))};c.prototype.changeDifferencePage=
function(b){if(void 0===b)this.resetDifferencePage();else{var a=b.getDocument(),h=this._differencePage;this.hasDocument(a)&&(this._differencePage=b,h!=this._differencePage&&(this.willNeedParameterUpdate("DIFFERENCE_PAGE_CHANGE"),this._differencePageHasChanged=!0,(this._previousDifferencePage=h)&&h.resetState(),this._emit("page.difference",h,this._differencePage),this.readyForParameterUpdate("DIFFERENCE_PAGE_CHANGE")))}};c.prototype.whenActiveDocumentVersionChanged=function(b,a){a&&(b=d.bind(b,a));
var h=this.getActiveDocumentVersion();h&&b(void 0,h);this.on("documentVersion.active",b)};c.prototype.whenDocumentsLoaded=function(b,a,h){a&&(b=d.bind(b,a));0===this._documentsLoading&&0<this._documents.size()&&b(this.getAllDocuments());if(h||0!==this._documentsLoading)this.on("loaded",d.bind(function(){0===this._documentsLoading&&b(this.getAllDocuments())},this))};c.prototype.whenDocumentsLoadedOrChange=function(b,a){this.whenDocumentsLoaded(b,a,!0)};c.prototype.loadedDocumentChanged=function(){this._emit("loaded")};
c.prototype.changeCadOverlay=function(b){var a=this._cadOverlay;b&&this._activePage.hasCad()&&(this.f.debug.error("Setting a CAD overlay is not allowed when the active document is a CAD document"),b=void 0);a!==b&&(this._cadOverlay=b,this.willNeedParameterUpdate("CAD_OVERLAY_CHANGE"),this._cadOverlayHasChanged=!0,(this._previousCadOverlay=a)&&a.resetState(),this._emit("page.cadOverlay",a,this._cadOverlay),this.readyForParameterUpdate("CAD_OVERLAY_CHANGE"))};c.prototype.getCadOverlay=function(){return this._cadOverlay};
c.prototype.whenActivePageChanged=function(b,a){a&&(b=d.bind(b,a));var h=this.getActivePage();h&&b(void 0,h);this.on("page.active",b)};c.prototype.whenDifferencePageChanged=function(b,a){a&&(b=d.bind(b,a));var h=this.getDifferencePage();h&&b(void 0,h);this.on("page.difference",b)};c.prototype.whenActiveOrDifferencePageChanged=function(b,a){a&&(b=d.bind(b,a));(this.getActivePage()||this.getDifferencePage())&&b();this.on("page.difference",b);this.on("page.active",b)};c.prototype.whenActivePageParametersChange=
function(b,a){a&&(b=d.bind(b,a));this.on("activePageParametersChange",b)};c.prototype.whenReferencePageStateParametersChange=function(b,a){a&&(b=d.bind(b,a));this.on("referencePageStateParametersChanged",b)};c.prototype.whenCadOverlayPageStateParametersChange=function(b,a){a&&(b=d.bind(b,a));this.on("cadOverlayPageStateParametersChanged",b)};c.prototype.whenDifferencePageParametersChange=function(b,a){a&&(b=d.bind(b,a));this.on("differencePageParametersChange",b)};c.prototype.whenActivePageChangedAndParametersAvailable=
function(b,a){a&&(b=d.bind(b,a));this.on("activePageChangedAndParametersAvailable",b);this.hasActiveDocumentPageWithParametersAvailable()?b(void 0,this.getActivePage()):this.isParameterUpdateOngoing()&&!this._activePageHasChanged&&this.whenParametersAvailable(function(a){b(void 0,a)})};c.prototype.whenActivePageChangedAndParametersAvailableOrChange=function(b,a){a&&(b=d.bind(b,a));this.on("activePageChangedAndParametersAvailableOrChange",b);this.hasActiveDocumentPageWithParametersAvailable()&&b(void 0,
this.getActivePage())};c.prototype.whenDifferencePageChangedAndParametersAvailable=function(b,a){a&&(b=d.bind(b,a));this.on("differencePageChangedAndParametersAvailable",b);this.hasDifferenceDocumentPageWithParametersAvailable()?b(void 0,this.getCadOverlay()):this.isParameterUpdateOngoing()&&(this._differencePage&&!this._differencePageHasChanged)&&this.whenParametersAvailable(function(a,n){b(void 0,n)})};c.prototype.whenDifferencePageChangedAndParametersAvailableOrChange=function(b,a){a&&(b=d.bind(b,
a));this.on("differencePageChangedAndParametersAvailableOrChange",b);this.hasDifferenceDocumentPageWithParametersAvailable()&&b(void 0,this.getDifferencePage())};c.prototype.whenCadOverlayChanged=function(b,a){a&&(b=d.bind(b,a));this.on("page.cadOverlay",b);this._cadOverlay&&b(void 0,this._cadOverlay)};c.prototype.whenCadOverlayChangedAndParametersAvailable=function(b,a){a&&(b=d.bind(b,a));this.on("cadOverlayChangedAndParametersAvailable",b);this.hasCadOverlaywWithParametersAvailable()?b(void 0,this.getCadOverlay()):
this.isParameterUpdateOngoing()&&(this._cadOverlay&&!this._cadOverlayHasChanged)&&this.whenParametersAvailable(function(){b(void 0,this._cadOverlay)},this)};c.prototype.whenActiveOrDifferencePageChangedAndParametersAvailable=function(b,a){a&&(b=d.bind(b,a));this.on("activeOrDifferencePageChangedAndParametersAvailable",b);this.hasActiveDocumentPageWithParametersAvailable()||this.hasDifferenceDocumentPageWithParametersAvailable()?b(this.getActivePage(),this.getDifferencePage(),void 0,!0):this.isParameterUpdateOngoing()&&
(!this._activePageHasChanged&&!this._differencePageHasChanged)&&this.whenParametersAvailable(function(a,n){b(a,n,void 0,!0)})};c.prototype.whenActiveOrDifferenceOrCadOverlayChangedAndParametersAvailable=function(b,a){a&&(b=d.bind(b,a));this.on("activeOrDifferenceOrCadOverlayChangedAndParametersAvailable",b);this.hasActiveDocumentPageWithParametersAvailable()||this.hasDifferenceDocumentPageWithParametersAvailable()||this.hasCadOverlaywWithParametersAvailable()?b(this.getActivePage(),this.getDifferencePage(),
this.getCadOverlay()):this.isParameterUpdateOngoing()&&(!this._activePageHasChanged&&!this._differencePageHasChanged&&!this._cadOverlayHasChanged)&&this.whenParametersAvailable(function(){b(this._activePage,this._differencePage,this._cadOverlay)},this)};c.prototype.whenActiveOrDifferencePageChangedAndParametersAvailableOrChange=function(b,a){a&&(b=d.bind(b,a));this.on("activeOrDifferencePageChangedAndParametersAvailableOrChange",b);(this.hasActiveDocumentPageWithParametersAvailable()||this.hasDifferenceDocumentPageWithParametersAvailable())&&
b(this.getActivePage(),this.getDifferencePage(),void 0,!0)};c.prototype.interceptFragmentURL=function(b){this._activePage&&this._activePage.interceptFragmentURL(b)};c.prototype.hasDocumentMultipleVersions=function(b){return this._documents.get(b).hasMultipleVersions()};c.prototype.getDocumentCount=function(){return this._documents.size()};c.prototype.getDocuments=function(){return this._documents.values()};c.prototype.getAllDocuments=function(){return d.sortBy(this._documents.values(),function(b){return b.get("docname")?
b.get("docname").toLowerCase():b.getIID()})};return c});define("web-viewer/core/Extendable",[],function(){return{installTo:function(f){f._override=function(f,e){var d=this[f];void 0===d&&(d=function(){});this[f]=function(){var c=this._super;this._super=d;var b=e.apply(this,arguments);this._super=c;return b}}}}});
define("web-viewer/data/AbstractDocument",["web-viewer/core/Extendable","web-viewer/core/PrivateChannel","underscore"],function(f,g){var e=function(d,c,b){g.installTo(this,d,["doc",c]);this.f=d;this.documentID=c;this._documentType=b;this._documentVersions=[];this._data={};this._linkedDocumentPage=null};e.prototype.getIID=function(){return this.documentID};e.prototype.get=function(d){if(void 0!==this._data[d])return this._data[d]};e.prototype.setLinkedDocumentPage=function(d){this._linkedDocumentPage=
d};e.prototype.getLinkedDocument=function(){return this._linkedDocumentPage?this._linkedDocumentPage.getDocument():void 0};e.prototype.getLinkedDocumentPage=function(){return this._linkedDocumentPage};e.prototype.hasLinkedDocument=function(){return null!==this._linkedDocumentPage&&void 0!==this._linkedDocumentPage};e.prototype.getDocumentType=function(){return this._documentType};e.prototype.set=function(d,c){var b=this._data[d];if(void 0===b||void 0!=b&&b!=c)this._data[d]=c;return!0};e.prototype.addDocumentVersion=
function(d){this._documentVersions[d.getVersionId()]=d};e.prototype.addDocumentPage=function(d,c){this._documentVersions[d].addPage(c.getPagenum(),c)};e.prototype.getDocumentVersion=function(d){if(void 0===d&&0<this._documentVersions.length)return _.last(this._documentVersions);if(this._documentVersions[d])return this._documentVersions[d]};e.prototype.hasDocumentVersion=function(d){return void 0!==this._documentVersions[d]};e.prototype.hasMultipleVersions=function(){return 2<_.size(this._documentVersions)};
e.prototype.getAllDocumentVersions=function(){return this._documentVersions.slice(0)};e.prototype.loadVersionsForDocumentPage=function(){};return e});
define("web-viewer/data/AbstractDocumentVersion",["web-viewer/core/Extendable","web-viewer/core/PrivateChannel","underscore"],function(f,g){var e=function(d,c,b){g.installTo(this,d,["doc",c.getIID(),"version",b]);this._f=d;this._doc=c;this._versionId=b;this._versionData={};this._pages=[]};e.prototype.get=function(d){if(void 0!==this._versionData[d])return this._versionData[d]};e.prototype.set=function(d,c){var b=this._versionData[d];if(void 0===b||void 0!==b&&b!=c)this._versionData[d]=c;return!0};
e.prototype.getDocument=function(){return this._doc};e.prototype.getVersionId=function(){return this._versionId};e.prototype.requestPage=function(d,c){var b=this.getPage(d);if(void 0===b)this.once(["page",d,"loaded"],_.bind(function(){c(this.getPage(d))},this)),this.loadPage(d);else if(null===b)this.once(["page",d,"loaded"],_.bind(function(){c(this.getPage(d))},this));else c(b)};e.prototype.loadPage=function(d){this._pages[d]=null;this._emit("page.loading",d);this._pages[d]=void 0};e.prototype.addPage=
function(d,c){this._pages[d]=c;this._emit("page."+d+".loaded",c)};e.prototype.getPage=function(d){return void 0===d?this.getFirstPage():this._pages[d]};e.prototype.hasPage=function(d){return void 0!==this._pages[d]};e.prototype.getPageCount=function(){};e.prototype.isLatestVersion=function(){return this._doc.getDocumentVersion().getVersionId()===this._versionId};e.prototype.isMultiPage=function(){return 1<this.getPageCount()};e.prototype.isPageList=function(){return void 0!==this.get("isPageList")&&
this.get("isPageList")};e.prototype.getFirstPage=function(){for(var d=0;d<this._pages.length&&!this._pages[d];)d++;return this._pages[d]};e.prototype.getFirstNotBlankPage=function(){for(var d=0;d<this._pages.length&&(!this._pages[d]||this._pages[d].isBlankPage());)d++;return this._pages[d]};e.prototype.getLastPage=function(){return _.last(this._pages)};e.prototype.getAllPages=function(){return _.without(this._pages.slice(0),null,void 0)};return e});
define("web-viewer/layout/LayoutItem",["web-viewer/layout/LayoutConstants"],function(f){var g=function(e,d,c){this.name=e;this.type=d;this._factory=c;this._itemLayoutType=this._item=null};g.prototype.getItem=function(e){if(null===this._item||this._itemLayoutType!=e)this._item=this._factory(e),this._itemLayoutType=e;return this._item};g.prototype.isWidget=function(){return this.type===f.LayoutItemType.WIDGET};g.prototype.isToolbarComponent=function(){return this.type===f.LayoutItemType.TOOLBARCOMPONENT};
return g});
define("web-viewer/layout/LayoutModel",["web-viewer/core/PrivateChannel","web-viewer/layout/LayoutConstants","web-viewer/layout/LayoutItem"],function(f,g,e){var d=function(c){f.installTo(this,c,["layoutModel"]);this.f=c;this._items={};this._layoutModes={}};d.prototype.hasItem=function(c){return void 0!==this._items[c]};d.prototype.addWidget=function(c,b){var a=new e(c,g.LayoutItemType.WIDGET,b);this._items[a.name]=a;this._emit("itemAdded",a)};d.prototype.addToolbarComponent=function(c,b){var a=new e(c,
g.LayoutItemType.TOOLBARCOMPONENT,b);this._items[a.name]=a;this._emit("itemAdded",a)};d.prototype.getLayoutItemType=function(c){if(this.hasItem(c))return this._items[c].type};d.prototype.getLayoutItem=function(c){if(this.hasItem(c))return this._items[c].getItem()};d.prototype.registerLayoutMode=function(c){this._layoutModes[c.getName()]=c};d.prototype.getLayoutMode=function(c){return this._layoutModes[c]};return d});
define("web-viewer/layout/LayoutManager","domReady! web-viewer/utils/ListenerUtil web-viewer/layout/LayoutModel web-viewer/layout/LayoutConstants utils/DomUtils underscore jquery".split(" "),function(f,g,e,d,c,b,a){f=function(a,n,j,c,i){g.mixin(this,a);this.f=a;this._layoutModel=new e(this.f);this._registerListener("layout.loadCSS",this.loadCSS,this);this._layout=null;this._layoutType=this.f.getLayoutType();var a=this._getLayoutStatePreference(),q="",f=null;this._layoutType===d.LayoutType.MOBILE?
(q="web-viewer/layout/mobile/MobileLayout",f=a.layout[d.LayoutType.MOBILE]):this._layoutType===d.LayoutType.FLEX?(q="web-viewer/layout/flex/FlexLayout",f=a.layout[d.LayoutType.FLEX]):(q="web-viewer/layout/desktop/DesktopLayout",f=a.layout[d.LayoutType.DESKTOP]);var m=[],s=[],t=this._registerListener("layout.addWidget",function(a,b){m.push({name:a,factory:b})}),v=this._registerListener("layout.addToolbarComponent",function(a,b){s.push({name:a,factory:b})});requirejs([q],b.bind(function(a){this._layout=
new a(this.f,this._layoutModel,n,f,j,c);b.each(m,function(a){this._layoutModel.hasItem(a.name)||this._layoutModel.addWidget(a.name,a.factory)},this);b.each(s,function(a){this._layoutModel.hasItem(a.name)||this._layoutModel.addToolbarComponent(a.name,a.factory)},this);this._unregisterListener(t);this._unregisterListener(v);this._registerListener("layout.addWidget",function(a,b){this._layoutModel.hasItem(a)||this._layoutModel.addWidget(a,b)},this,this.f);this._registerListener("layout.addToolbarComponent",
function(a,b){this._layoutModel.hasItem(a)||this._layoutModel.addToolbarComponent(a,b)},this,this.f);this._registerListener("layout.changed",this._persistLayout,this,this._layout);this._registerListener("layout.resetToDefault",b.partial(this._persistLayout,!0),this,this.f);i&&i(this)},this))};f.prototype.loadCSS=function(a,b){c.loadCss(a,b)};f.prototype._persistLayout=b.debounce(function(a){if(this._layout.isLayoutStatePersisted()){var b=this._getLayoutStatePreference();b.layout[this._layoutType]=
a?void 0:this._layout.getLayoutState();this.f.setOption("LAYOUT_STATE",JSON.stringify(b))}},100);f.prototype._getLayoutStatePreference=function(){var b=this.f.getOption("LAYOUT_STATE");if(void 0!==b&&""!==b)try{if(b=a.parseJSON(b),!b.layout){var n=b,b={layout:{}};b.layout[d.LayoutType.DESKTOP]=n}}catch(j){this.f.emit("error.SEVERE","Could not restore layout configuration",j),b={layout:{}}}else b={layout:{}};return b};f.prototype.switchLayout=function(h){if(this._layoutType!=h){var n=a("<div/>").show().addClass("modalOverlay").text(this.f.t("Loading"));
this.f.getContext().append(n);this.f.setOptionCallback("LAYOUT_PREFERENCE",h,b.bind(function(a){a&&this.f.emit("viewer.request.close",window.location,"SaveAndSwitchLayout","SwitchLayoutWithoutSave");n.remove()},this))}};return f});
define("web-viewer/core/AbstractModule",["web-viewer/core/Extendable","web-viewer/core/PrivateChannel","underscore"],function(f,g,e){var d=function(c,b,a){this.f=c;this.silenced=b||!1;this.name=a;this._onUnsilence=[];f.installTo(this);g.installTo(this,c,"module."+a)};d.prototype._publish=function(){this.silenced?this._onUnsilence.push(arguments):this.f.emit.apply(this.f,arguments)};d.prototype._unSilence=function(){e.each(this._onUnsilence,e.bind(function(c){this.f.emit.apply(this.f,c)},this));this._onUnsilence=
[];this.silenced=!1};d.prototype.setSilenced=function(c){c?this.silenced=!0:this._unSilence()};d.prototype._publishWidget=function(c,b){this._publish("layout.addWidget",c,b)};d.prototype._publishToolbarComponent=function(c,b){this._publish("layout.addToolbarComponent",c,b)};d.prototype._publishTool=function(c){this._publish("toolManager.addTool",c)};d.prototype._unpublishTool=function(c){this._publish("toolManager.removeTool",c)};d.prototype.hasUnsavedElements=function(){return!1};d.prototype.getUnsavedElementsName=
function(){return this.name};d.prototype.saveAllUnsavedElements=function(c){c&&c()};d.prototype.getState=function(){};d.prototype.setState=function(){};return d});
define("web-viewer/featureDetector/FeatureDetectorModule",["web-viewer/core/AbstractModule","modernizr"],function(f,g){var e=function(d,c){f.call(this,d,c,"featureDetector")};e.prototype=Object.create(f.prototype);e.prototype.constructor=e;e.prototype.isMobile=function(){return!0===this.f.getProperty("isMobile")};e.prototype.isIOS=function(){return/(iPad|iPhone|iPod)/i.test(navigator.userAgent)};e.prototype.hasTouch=function(){return g.touch||0<=navigator.userAgent.indexOf("Trident")&&0<=navigator.userAgent.indexOf("Touch")};
e.prototype.hasCanvas=function(){return g.canvas};return e});
define("web-viewer/layout/AbstractWidget","web-viewer/core/Extendable web-viewer/core/PrivateChannel jquery utils/ShapeUtils Mousetrap underscore".split(" "),function(f,g,e,d,c,b){e=function(a,h){f.installTo(this);g.installTo(this,a,["widget",h]);this.collapsed=!1;this.visible=!0;this._isModal=!1;this.f=a;this._enabled=!0;this._title=h;this._icon="icon icon-WCR_Cont-Circle";this._currentCursor="cursor-default";this._options={};this.getID=function(){return h};this.setOption=function(a,b){var h=this._options[a];
h!==b&&(this._options[a]=b,this._emit("options.changed."+a,h,b))};this.getOption=function(a){return this._options[a]};this.getOptions=function(){return b.clone(this._options)}};e.prototype.setOptions=function(a){b.each(a,function(a,b){this.setOption(b,a)},this)};e.prototype.getTitle=function(){return this._title};e.prototype.setTitle=function(a){this._title!==a&&(this._title=a,this._emit("titlechanged",a))};e.prototype.getIcon=function(){return this._icon};e.prototype.setIcon=function(a){this._icon!==
a&&(this._icon=a,this._emit("iconchanged",a))};e.prototype.setContext=function(a,b){a?(this.context=a,this.headerExtra=b,this.setCursor(this._currentCursor),this._emit("contextAvailable")):this.f.emit("error.WARNING","Can't call setContext without context!")};e.prototype.destroy=function(){this._emit("destroyed")};e.prototype.isContextAvailable=function(){return void 0!==this.context};e.prototype.whenContextAvailable=function(a,h){h&&(a=b.bind(a,h));if(this.isContextAvailable())a();else this.once("contextAvailable",
a)};e.prototype.setVisible=function(a){this.visible!==a&&(this.visible=a,this._emit("visible",a))};e.prototype.isVisible=function(){return this.visible};e.prototype.setCollapsed=function(a){this.collapsed!==a&&(this.collapsed=a,this._emit("collapsed",a))};e.prototype.isCollapsed=function(){return this.collapsed};e.prototype.setModal=function(a){this._isModal=a};e.prototype.resized=function(){};e.prototype._fireResized=function(){this._emit("resized")};e.prototype.fireModalResize=function(){this._emit("modalResize")};
e.prototype.resizing=function(){};e.prototype.setCursor=function(a){this.whenContextAvailable(b.bind(function(){a!=this._currentCursor&&(this.context.removeClass(this._currentCursor),this.context.addClass(a),this._currentCursor=a)},this))};e.prototype.getWidgetType=function(){return"dockable"};e.prototype.getMinimumSize=function(){return new d.Size(100,30)};e.prototype.getPreferredSize=function(){var a=this.context.clone(!1);a.css({position:"absolute",visibility:"hidden",overflow:"auto",height:"auto",
width:this.context.width()-2});this.f.getContext().append(a);a.css({overflow:"hidden"});a.css({overflow:"auto"});var b=new d.Size(a.outerWidth(!0),a.outerHeight(!0));a.remove();return b};e.prototype.willFill=function(){return!1};e.prototype.getMaximumSize=function(){};e.prototype.movingStarted=function(){this._emit("movingStarted")};e.prototype.movingStopped=function(){this._emit("movingStopped")};e.prototype.dragged=function(a,b){this._emit("dragged",a,b)};e.prototype.bindKeys=function(a){for(var b=
0;b<a.length;b++)c.bind(a[b][0],a[b][1],a[b][2])};e.prototype.unbindKeys=function(a){for(var b=0;b<a.length;b++)c.unbind(a[b][0],a[b][1],a[b][2])};e.prototype.setEnabled=function(a){this._enabled!==a&&(this._enabled=a,this._emit("enabled",a))};e.prototype.isEnabled=function(){return this._enabled};e.prototype.makeVisible=function(){this.isEnabled()||this.setEnabled(!0);this._didRequestMakeVisible=!0;this._emit("makeVisible")};e.prototype.didRequestMakeVisible=function(){return this._didRequestMakeVisible};
e.prototype.setMakeVisibleRequestAccepted=function(){this._didRequestMakeVisible=!1};return e});
define("web-viewer/message/MessageWidgetWrapper",["web-viewer/layout/AbstractWidget","web-viewer/layout/LayoutConstants","component/message/MessageComponent","jquery","underscore"],function(f,g,e){var d=function(c,b){f.call(this,c,g.Widget.MESSAGE);this._messageModel=b;this._messageWidget=null};d.prototype=Object.create(f.prototype);d.prototype.constructor=d;d.widgetName=g.Widget.MESSAGE;d.prototype.getWidgetType=function(){return"messagebar"};d.prototype.setContext=function(c){f.prototype.setContext.call(this,
c);null==this._messageWidget&&(this._messageWidget=new e.MessageWidget(this._messageModel,c));this.context.addClass("enableTextSelection")};return d});
define("web-viewer/message/MessageModule",["web-viewer/core/AbstractModule","web-viewer/message/MessageWidgetWrapper","component/message/MessageComponent","underscore"],function(f,g,e,d){var c=function(b,a){f.call(this,b,a,"message");this._messageModel=new e.MessageModel;this._publishWidget(g.widgetName,d.bind(function(){return this._messageWidgetWrapper=new g(b,this._messageModel)},this));this.f.on("userMessage",d.bind(this._handleMessageEvent,this));this.f.on("userMessage.markObsolete",d.bind(this._markObsolete,
this));this.f.on("error.SEVERE",d.bind(function(a){this._addToMessageQueue(new e.Message("error",a))},this));this.f.on("error.WARNING",d.bind(function(a,b){this._addToMessageQueue(new e.Message("warn",a,void 0,b))},this))};c.prototype=Object.create(f.prototype);c.prototype.constructor=c;c.prototype._addToMessageQueue=function(b){this.f.debug.log("Message received",b);this._messageModel.addToMessageQueue(b)};c.prototype._handleMessageEvent=function(){var b=arguments.length;if(1===b)d.isString(arguments[0])?
this._addToMessageQueue(new e.Message("info",arguments[0])):this._addToMessageQueue(arguments[0]);else if(2===b)this._addToMessageQueue(new e.Message(arguments[0],arguments[1]));else if(3===b)d.isBoolean(arguments[2])?this._addToMessageQueue(new e.Message(arguments[0],arguments[1],!1,arguments[2])):this._addToMessageQueue(new e.Message(arguments[0],arguments[1],arguments[2],!1));else if(4===b)this._addToMessageQueue(new e.Message(arguments[0],arguments[1],arguments[2],arguments[3]));else if(5===b)this._addToMessageQueue(new e.Message(arguments[0],
arguments[1],arguments[2],arguments[3],arguments[4]));else if(6===b){var a=arguments[4];(!arguments[5]||!d.some(this._messageQueue,function(b){return b.tag===a})&&(!this._messageWidget||!this._messageWidget.isShownMessageWithTag(a)))&&this._addToMessageQueue(new e.Message(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4]))}else this.f.debug.debug("Unrecognized userMessage event",arguments)};c.prototype._markObsolete=function(b){this._messageModel.markObsolete(b)};return c});
define("web-viewer/utils/ConversionConstants",{MM_TO_INCH:25.4,MM_TO_CM:10,DEFAULT_POSTSCRIPT_PPI:72,DEFAULT_SCREEN_PPI:96,FIXED_BARCODE_DPMM:300/25.4,POINTS_TO_MM_RATIO:25.4/72,MM_TO_POINT_RATIO:72/25.4,PX_TO_MM_RATIO:25.4/96,MM_TO_PX_RATIO:96/25.4});define("web-viewer/utils/GEOUtils",["underscore","utils/ShapeUtils","web-viewer/utils/ConversionConstants"],function(f,g,e){return{convertPSPointsToMM:function(d){return d*e.POINTS_TO_MM_RATIO},convertMMToPSPoints:function(d){return d*e.MM_TO_POINT_RATIO}}});
define("web-viewer/utils/ViewerUtils","utils/ShapeUtils web-viewer/utils/GEOUtils web-viewer/core/CoreConstants web-viewer/utils/ConversionConstants underscore jquery".split(" "),function(f,g,e,d,c){return{rgbToHex:function(b,a,h){return this.toHex(b)+this.toHex(a)+this.toHex(h)},toHex:function(b){b=parseInt(b,10);if(isNaN(b))return"00";b=Math.max(0,Math.min(b,255));return"0123456789ABCDEF".charAt((b-b%16)/16)+"0123456789ABCDEF".charAt(b%16)},hexFromInt:function(b){return this.rgbToHex(b>>16&255,
b>>8&255,b>>0&255)},intFromHex:function(b){b=this.rgbColor(b);return(b.r&255)<<16|(b.g&255)<<8|(b.b&255)<<0},rgbIntToBgrInt:function(b){var a=this.toHex(b>>16&255),h=this.toHex(b>>8&255),b=this.toHex(b>>0&255);return parseInt(b+h+a,16)},rgbColor:function(b){return(b=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(b))?{r:parseInt(b[1],16),g:parseInt(b[2],16),b:parseInt(b[3],16)}:null},trim:function(b){b=b.replace(/(^\s*)|(\s*$)/gi,"");b=b.replace(/[ ]{2,}/gi," ");return b=b.replace(/\n /,"\n")},convertFromMmValue:function(b,
a,h,c){var j=b;if(a==e.SizeUnits.INCH)j=b/d.MM_TO_INCH;else if(a==e.SizeUnits.CM)j=b/d.MM_TO_CM;else if(a==e.SizeUnits.PIXELS||a==e.SizeUnits.POINTS)j=isNaN(c)?b*d.MM_TO_POINT_RATIO:b*c;return void 0!==h?j.toFixed(h):j.toString()},convertToMmValue:function(b,a,h,c){var j=b;if(a==e.SizeUnits.INCH)j=b*d.MM_TO_INCH;else if(a==e.SizeUnits.CM)j=b*d.MM_TO_CM;else if(a==e.SizeUnits.PIXELS||a==e.SizeUnits.POINTS)j=isNaN(c)?b*d.POINTS_TO_MM_RATIO:b/c;return void 0!==h?j.toFixed(h):j.toString()},convertFromInchToMm:function(b,
a){return(b*d.MM_TO_INCH).toFixed(a)},convertResolutionFromPpmmValue:function(b,a,h){a===e.ResolutionUnits.PPMM?b*=1:a===e.ResolutionUnits.PPCM?b*=d.MM_TO_CM:a===e.ResolutionUnits.PPI&&(b*=d.MM_TO_INCH);return void 0!==h?b.toFixed(h):b.toString()},convertResolutionToPpmmValue:function(b,a,h){a===e.ResolutionUnits.PPMM?b/=1:a===e.ResolutionUnits.PPCM?b/=d.MM_TO_CM:a===e.ResolutionUnits.PPI&&(b/=d.MM_TO_INCH);return void 0!==h?b.toFixed(h):b.toString()},closestAngle:function(b,a){var h=360*Math.round(b/
360*a)/a;360<=h&&(h-=360);return h},pointAtLength:function(b,a,h){var c=a*Math.PI/180,a=h.x+b*Math.cos(c),b=h.y+b*Math.sin(c);return new f.Point(a,b)},startsWith:function(b,a){return 0===b.indexOf(a)},endsWith:function(b,a){var h=b.length-a.length,c=b.indexOf(a,h);return-1!==c&&c===h},generateUniqueDOMId:function a(h){for(var c=Math.floor(1E4*Math.random()),c=h+c;document.getElementById(c);)return a(h);return c},dateFromString:function(a){var h=a.substring(2,6),c=a.substring(6,8),j=a.substring(8,
10),d=a.substring(10,12),e=a.substring(12,14),q=a.substring(14,16),f=a.substring(16,19),a=a.substring(20,22);return new Date(h+"-"+c+"-"+j+"T"+d+":"+e+":"+q+".000"+f+":"+a)},twoDigits:function(a){return 9<a?""+a:"0"+a},stringFromDate:function(a){var h=a.getTimezoneOffset(),c=0>=h?"+":"-",h=Math.abs(h),j=Math.floor(h/60),h=h-60*j,c=c+(this.twoDigits(j)+"'"+this.twoDigits(h)+"'");return"D:"+a.getUTCFullYear()+this.twoDigits(a.getUTCMonth()+1)+this.twoDigits(a.getUTCDate())+this.twoDigits(a.getHours())+
this.twoDigits(a.getMinutes())+this.twoDigits(a.getUTCSeconds())+c},randomString:function(a){for(var h="";0<a;--a)h+="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"[Math.round(61*Math.random())];return h},rectToString:function(a){var h=g.convertMMToPSPoints(a.origin.x),c=g.convertMMToPSPoints(a.origin.y),j=g.convertMMToPSPoints(a.right()),a=g.convertMMToPSPoints(a.bottom());return h+","+c+","+j+","+a},parseFloat:function(a){if(c.isString(a)){if(a=a.trim())return+a.replace(/,/,".")}else if(c.isNumber(a))return a},
parseFirstFloat:function(a){if(c.isString(a)){if(a=a.trim())return parseFloat(a.replace(/,/,"."))}else if(c.isNumber(a))return a},isCloseTo:function(a,h,c){return Math.abs(h-a)<Math.pow(10,-c)/2}}});
define("lib/AnimationOptions",["underscore"],function(){var f=function(f){this._types={ease:[0.25,0.1,0.25,1],linear:[0,0,1,1],"ease-in":[0.42,0,1,1],"ease-out":[0,0,0.58,1],"ease-in-out":[0.42,0,0.58,1]};this._options=this._types[f];this._options||(this._options=this._types.linear);this._mX1=this._options[0];this._mY1=this._options[1];this._mX2=this._options[2];this._mY2=this._options[3]};f.prototype.get=function(f){return this._mX1==this._mY1&&this._mX2==this._mY2?f:this._calcBezier(this._getTForX(f),
this._mY1,this._mY2)};f.prototype._a=function(f,e){return 1-3*e+3*f};f.prototype._b=function(f,e){return 3*e-6*f};f.prototype._c=function(f){return 3*f};f.prototype._calcBezier=function(f,e,d){return((this._a(e,d)*f+this._b(e,d))*f+this._c(e))*f};f.prototype._getSlope=function(f,e,d){return 3*this._a(e,d)*f*f+2*this._b(e,d)*f+this._c(e)};f.prototype._getTForX=function(f){for(var e=f,d=0;4>d;++d){var c=this._getSlope(e,this._mX1,this._mX2);if(0==c)break;var b=this._calcBezier(e,this._mX1,this._mX2)-
f,e=e-b/c}return e};return f});
define("web-viewer/viewport/ViewportWorld","underscore utils/Transformation utils/ShapeUtils web-viewer/core/PrivateChannel web-viewer/utils/ViewerUtils lib/AnimationOptions".split(" "),function(f,g,e,d,c,b){var a=function(a,b,c){d.installTo(this,a,["transform",b]);this._initialStartZoom=this._minZoom=this._maxZoom=this._transform=this._initialTransformation=void 0;this._initialZoom=c?c:1;this._allowAnimation=!0;this._animationFramerate=45;this._defaultAnimationDuration=250;this._currentAnimation=
null;this._rotation=0;this._offsetSize=new e.Size;this._zoom=1;this._flipViewFromBack=this._flip=!1;this._worldSize=new e.Size;this._sceneSize=new e.Size;this._worldOrigin=new e.Point;this._worldResolution={x:0,y:0};this._didChangeSinceLastZoomToFit=!1;this._animationTimer=null};a.prototype.recalculateInitialStartZoom=function(){if(0===this._worldSize.width||0===this._worldSize.height)return this._zoom;var a=!0;0===this._rotation%180&&(a=!1);var a=Math.min((a?this._sceneSize.height:this._sceneSize.width)/
this._worldSize.width,(a?this._sceneSize.width:this._sceneSize.height)/this._worldSize.height),a=a*this._initialZoom,b=this.getIntegerZoom(-this.getNumberOfMinZoomLevels()),c=this.getIntegerZoom(this.getNumberOfMaxZoomLevels());if(this._minZoom!==b||this._maxZoom!==c)this._minZoom=b,this._maxZoom=c,this._emit("minMaxZoomChanged",this,this._minZoom,this._maxZoom);return this._initialStartZoom=a};a.prototype.isFullView=function(){return this._zoom===this._initialStartZoom};a.prototype.isSmallerThanFullView=
function(){return this._zoom<this._initialStartZoom};a.prototype.getInitialStartZoom=function(){return this._initialStartZoom};a.prototype.getInitialZoom=function(){return this._initialZoom};a.prototype.zoomToFit=function(a){this._offsetSize=new e.Size;this.transform({fixedzoom:this.recalculateInitialStartZoom(),animated:a});this._didChangeSinceLastZoomToFit=!1};a.prototype.zoomToFitWidth=function(a){this._reportChange();var b=!0;0===this._rotation%180&&(b=!1);var c=null;b?0!==this._worldSize.height&&
(c=this._worldSize.height):0!==this._worldSize.width&&(c=this._worldSize.width);this._offsetSize=new e.Size;null!==c?(b=this._sceneSize.width/c,b*=this._initialZoom,this.transform({fixedzoom:b,animated:a})):this.updateTransformation(a)};a.prototype.zoomToFitHeight=function(a){this._reportChange();var b=!0;0===this._rotation%180&&(b=!1);var c=null;b?0!==this._worldSize.width&&(c=this._worldSize.width):0!==this._worldSize.height&&(c=this._worldSize.height);this._offsetSize=new e.Size;null!==c?(b=this._sceneSize.height/
c,b*=this._initialZoom,this.transform({fixedzoom:b,animated:a})):this.updateTransformation(a)};a.prototype.zoomOneToOne=function(a,b){this._reportChange();var c=b;void 0===c&&(this._worldResolution&&0!==this._worldResolution.x)&&(c=this._worldResolution.x);this.transform({fixedzoom:c,animated:a})};a.prototype.getZoom=function(){return this._zoom};a.prototype.getZoomPercentage=function(){return this._worldResolution&&0!==this._worldResolution.x?100*(this._zoom/this._worldResolution.x):0};a.prototype.getNumberOfZoomLevels=
function(){return this.getNumberOfMinZoomLevels()+this.getNumberOfMaxZoomLevels()+1};a.prototype.getNumberOfMinZoomLevels=function(){return 16};a.prototype.getNumberOfMaxZoomLevels=function(){return 9};a.prototype.getMaxZoom=function(){return this._maxZoom};a.prototype.getMinZoom=function(){return this._minZoom};a.prototype.zoomToSceneRect=function(a,b){this._reportChange();var c=this.getWorldRectFromScene(a),d=Math.abs(this._sceneSize.width/c.size.width),e=Math.abs(this._sceneSize.height/c.size.height),
q=this.getRotation()%360;if(90===q||270===q)d=Math.abs(this._sceneSize.width/c.size.height),e=Math.abs(this._sceneSize.height/c.size.width);this.transform({fixedzoom:Math.min(d,e),middle:c.center(),animated:b})};a.prototype.setSceneSize=function(a){this._sceneSize=a;this.updateTransformation(!1,!0)};a.prototype.getSceneSize=function(){return this._sceneSize};a.prototype.getSceneBounds=function(){return new e.Rect(null,this._sceneSize.copy())};a.prototype.getWorldSize=function(){return this._worldSize};
a.prototype.getWorldBounds=function(){return new e.Rect(this._worldOrigin.copy(),this._worldSize.copy())};a.prototype.setWorldBounds=function(a){this._worldSize=a.size.copy();this._worldOrigin=a.origin.copy();this.updateTransformation(!1);this._emit("worldBoundsChanged")};a.prototype.isAnimating=function(){return null!=this._currentAnimation&&!this._currentAnimation.done};a.prototype.isAnimatingRotation=function(){var a=this.getTransformation(),b=this.calculateCurrentTransformation(),a=a.getRotation(),
b=b.getRotation();return a!=b};a.prototype.getRotation=function(){return this._rotation};a.prototype.getTransformation=function(){this._transform||this.updateTransformation();return this._transform.copy()};a.prototype.rubber=function(a,b,c){var d=(a-b)/(c-b);return 0>=d?a:b+(c-b)*(d/(1+d))};a.prototype.constrainZoom=function(a){return this._zoom>this._maxZoom?(this._zoom=a?this.rubber(this._zoom,this._maxZoom,1.6*this._maxZoom):this._maxZoom,!0):this._zoom<this._minZoom?(this._zoom=a?this.rubber(this._zoom,
this._minZoom,this._minZoom/1.6):this._minZoom,!0):!1};a.prototype.constrainRotation=function(a){a&&0!==this._rotation%90&&(this._rotation=parseInt(this._rotation,10)%360,0>this._rotation&&(this._rotation+=360),this._rotation=c.closestAngle(this._rotation,4))};a.prototype.constrainPan=function(a){var b=this.getMiddle();if(this.isSmallerThanFullView())this._offsetSize=new e.Size;else{var c=this._worldSize.copy(),d=!1;90===this._rotation%180&&(d=!0);var i=this.recalculateInitialStartZoom();this._zoom<
i&&(i=this._zoom*this._initialZoom);var q=0.5*(c.width-this._sceneSize.width/i+this._sceneSize.width/this._zoom),f=0.5*(c.width+this._sceneSize.width/i-this._sceneSize.width/this._zoom),m=0.5*(c.height-this._sceneSize.height/i+this._sceneSize.height/this._zoom),g=0.5*(c.height+this._sceneSize.height/i-this._sceneSize.height/this._zoom);d&&(q=0.5*(c.height-this._sceneSize.width/i-this._sceneSize.width/this._zoom),f=0.5*(c.height+this._sceneSize.width/i+this._sceneSize.width/this._zoom),m=0.5*(c.width-
this._sceneSize.height/i-this._sceneSize.height/this._zoom),g=0.5*(c.width+this._sceneSize.height/i+this._sceneSize.height/this._zoom));i=b.copy();b.offset(new e.Size(-this._worldOrigin.x,-this._worldOrigin.y));i.offset(new e.Size(-this._worldOrigin.x,-this._worldOrigin.y));90===this._rotation%360?i=new e.Point(c.height-b.y,b.x):180===this._rotation%360?i=new e.Point(c.width-b.x,c.height-b.y):270===this._rotation%360&&(i=new e.Point(b.y,c.width-b.x));i.x<q&&(i.x=q);i.x>f&&(i.x=f);i.y<m&&(i.y=m);i.y>
g&&(i.y=g);d?(q=0,f=c.height,m=0,g=c.width):(q=0,f=c.width,m=0,g=c.height);i.x<q&&(i.x=q);i.x>f&&(i.x=f);i.y<m&&(i.y=m);i.y>g&&(i.y=g);b=i;90===this._rotation%360?b=new e.Point(i.y,c.height-i.x):180===this._rotation%360?b=new e.Point(c.width-i.x,c.height-i.y):270===this._rotation%360&&(b=new e.Point(c.width-i.y,i.x));b.offset(new e.Size(this._worldOrigin.x,this._worldOrigin.y));if(a){a=this.getMiddle();c=new e.Point;c.x=Math.round(a.x-b.x);c.y=Math.round(a.y-b.y);a=b;b=Math.sqrt(c.x*c.x+c.y*c.y);
if(0.01>b)return!1;d=this.rubber(b,0,200/this._zoom);c.x*=d/b;c.y*=d/b;a.x+=c.x;a.y+=c.y;this.setMiddle(a);return!0}a=this.getMiddle();if(a.equals(b))return!1;this.setMiddle(b);return!0}};a.prototype.setMiddle=function(a){this._reportChange();var b=this.getWorldBounds().center();this._offsetSize=new e.Size(b.x-a.x,b.y-a.y)};a.prototype.getMiddle=function(){var a=this.getWorldBounds().center();return new e.Point(a.x-this._offsetSize.width,a.y-this._offsetSize.height)};a.prototype.updateTransformation=
function(a,c,j){j||(this.constrainZoom(!1),this.constrainPan(!1),this.constrainRotation(c));c=this.calculateCurrentTransformation();void 0===this._transform&&(this._transform=c);c.equals(this._transform)&&(a=!1);this.isAnimationAllowed()||(a=!1);if(a){f.isBoolean(a)&&(a={});a.duration||(a.duration=this._defaultAnimationDuration);j=100/(a.duration/this._animationFramerate)/100;a.type||(a.type="ease-in-out");var d=new b(a.type);d.from=a.interrupt&&this._currentAnimation&&!this._currentAnimation.done?
this._currentAnimation.to:this._transform;d.to=c;d.gain=j;d.progress=0;d.done=!1;this.updateTransformationAnimated(d);this._currentAnimation&&(this._currentAnimation.done=!0);this._currentAnimation=d}else this.isAnimating()&&this.cancelAnimation(!0),this._transform=c,this.fireTransformChanged()};a.prototype.calculateCurrentTransformation=function(){var a=new e.Rect(null,new e.Size(this._sceneSize.width/this._zoom,this._sceneSize.height/this._zoom)),b=(a.size.width-this._worldSize.width)/2,c=(a.size.height-
this._worldSize.height)/2,d=new g;d.scale(this._zoom,this._zoom);d.translate(a.size.width/2,a.size.height/2);d.rotate(this._rotation*(Math.PI/180));this.isFlip()&&d.scale(-1,1);this.isFlipViewFromBack()&&(0===this._rotation%180?d.scale(-1,1):d.scale(1,-1));d.translate(-a.size.width/2,-a.size.height/2);d.translate(b,c);this._worldOrigin&&d.translate(-this._worldOrigin.x,-this._worldOrigin.y);d.translate(this._offsetSize.width,this._offsetSize.height);d.e=Math.floor(d.e);d.f=Math.floor(d.f);return d};
a.prototype.updateTransformationAnimated=f.throttle(function(a){if(!a.done){if(0.9999<a.progress||1<=a.progress)a.progress=1;a.from.equals(a.to)&&(a.progress=1);var b=a.get(a.progress),c=new g;c.a=a.from.a*(1-b)+a.to.a*b;c.b=a.from.b*(1-b)+a.to.b*b;c.c=a.from.c*(1-b)+a.to.c*b;c.d=a.from.d*(1-b)+a.to.d*b;c.e=a.from.e*(1-b)+a.to.e*b;c.f=a.from.f*(1-b)+a.to.f*b;this._transform=c;1<=a.progress?(a.done=!0,this._currentAnimation==a&&(this._currentAnimation=null),this.fireTransformChanged()):(this.fireTransformChanged(),
this._animationTimer=setTimeout(f.bind(function(){a.progress+=a.gain;this.updateTransformationAnimated(a)},this),this._animationFramerate))}},0);a.prototype.transform=function(a,b){this._reportChange();a.rotate&&(this._rotation=(this._rotation+a.rotate+360)%360,this._emit("rotated"));a.fixedrotation&&(this._rotation=a.fixedrotation%360,this._emit("rotated"));a.flip&&(this._flip=!this._flip,this._emit("flipped"));if(a.offsetX||a.offsetY){var c=a.offsetY?a.offsetY:0;this._offsetSize.width+=a.offsetX?
a.offsetX:0;this._offsetSize.height+=c}void 0!==a.flipViewFromBack&&(this._flipViewFromBack=a.flipViewFromBack,this._emit("flippedViewFromBack"));a.zoom&&(this._worldResolution&&0!==this._worldResolution.x?(c=Math.round(Math.log(this._zoom/this._worldResolution.x)/Math.log(2)),this._zoom=this.getIntegerZoom(c+a.zoom)):this._zoom*=Math.pow(2,a.zoom));a.fixedzoom&&(this._zoom=a.fixedzoom);this.isAnimationAllowed()||this.cancelAnimation();a.fixedoffset&&(this._offsetSize=a.fixedoffset);a.middle&&this.setMiddle(a.middle);
b||this.updateTransformation(a.animated,a.constrainRotation,a.tmpDisableConstraints)};a.prototype.getIntegerZoom=function(a){return this._worldResolution.x*Math.pow(2,a)};a.prototype.setInitialTransformation=function(a){this._reportChange();this._initialTransformation=a};a.prototype.getInitialTransformation=function(){return this._initialTransformation};a.prototype.fitInRect=function(a,b,c){this._reportChange();var d=Math.abs(this._sceneSize.width/a.size.width),e=Math.abs(this._sceneSize.height/a.size.height),
d=Math.min(d,e);c&&(d=Math.min(0.8*d,this._maxZoom));this.transform({fixedzoom:d,middle:a.center(),animated:b})};a.prototype.getOffsetSize=function(){return this._offsetSize.copy()};a.prototype.setOffsetSize=function(a,b){this._reportChange();this._offsetSize=a;this.updateTransformation(b)};a.prototype.getTargetViewPort=function(a){var b=this.getWorldRectFromScene(this.getSceneBounds(),this.calculateCurrentTransformation());a||(b=b.calculateOverlap(this.getWorldBounds()));return b};a.prototype.getAnimationDestinationTargetViewPort=
function(){if(this.isAnimating()){var a=this.getWorldRectFromScene(this.getSceneBounds(),this._currentAnimation.to);return a=a.calculateOverlap(this.getWorldBounds())}return this.getTargetViewPort()};a.prototype.getWorldSizeFromScene=function(a,b){b||(b=this.getTransformation());var c=this.getWorldPointFromScene(new e.Point,b),d=this.getWorldPointFromScene(new e.Point(a.width,a.height),b);return new e.Size(d.x-c.x,d.y-c.y)};a.prototype.getWorldPointFromScene=function(a,b){b||(b=this.getTransformation());
return b.createInverse().transformedPoint(a)};a.prototype.getWorldRectFromScene=function(a,b){b||(b=this.getTransformation());var c=b.createInverse().transformedRect(a),d=this.getZoom();1E-6>1-c.origin.y*d&&(c.origin.y+=1E-6/d);1E-6>1-c.origin.x*d&&(c.origin.x+=1E-6/d);return c};a.prototype.getSceneRectFromWorld=function(a,b){b||(b=this.getTransformation());return b.transformedRect(a)};a.prototype.getScenePointFromWorld=function(a,b){b||(b=this.getTransformation());return b.transformedPoint(a)};a.prototype.fireTransformChanged=
function(){this._emit("transformChanged",this)};a.prototype.toggleAnimation=function(a){(this._allowAnimation=a)||this.cancelAnimation()};a.prototype.isFlip=function(){return this._flip};a.prototype.isFlipViewFromBack=function(){return this._flipViewFromBack};a.prototype.setWorldResolution=function(a){this._worldResolution=a};a.prototype.getWorldResolution=function(){return this._worldResolution};a.prototype.isDeepZoom=function(){return 16<=this._zoom/this._worldResolution.x||16<=this._zoom/this._worldResolution.y};
a.prototype._reportChange=function(){this._didChangeSinceLastZoomToFit=!0};a.prototype.didChangeTransformSinceLastZoomToFit=function(){return this._didChangeSinceLastZoomToFit};a.prototype.cancelAnimation=function(a){this._animationTimer&&this._currentAnimation&&(clearTimeout(this._animationTimer),!this._currentAnimation.done&&!a&&(this._transform=this._currentAnimation.to,this.fireTransformChanged()),this._currentAnimation.done=!0,this._currentAnimation=null)};a.prototype.isAnimationAllowed=function(){return this._allowAnimation&&
1E3>this.getZoomPercentage()};a.prototype.resetOrientation=function(){this._flip=!1;this._emit("flipped");this._rotation=0;this._emit("rotated");this._flipViewFromBack=!1;this._emit("flippedViewFromBack")};return a});
define("web-viewer/viewport/tools/AbstractTool",["underscore","utils/ShapeUtils","web-viewer/core/Extendable","web-viewer/core/PrivateChannel","Mousetrap"],function(f,g,e,d,c){var b=function(a,b){e.installTo(this);d.installTo(this,a,["tool",b]);this.f=a;var c=!1;this.isActive=function(){return c};this.getIID=function(){return b};this.requestActivation=function(){a.emit("toolManager.request.activation",this)};this.requestDeactivation=function(){a.emit("toolManager.request.deactivation",this)};this.passiveEvents=
{};this.passiveKeyEvents=[];this.activeEvents={};this.activeKeyEvents=[];this.persistentKeyEvents=[];this.activate=function(a){c=!0;this._widget.whenContextAvailable(f.bind(function(){this.doActivation();this.isActive()&&this._emit("activated",a)},this))};this.deactivate=function(a){this.doDeactivation();c=!1;this._emit("deactivated",a)};var j={},k;this.registerActiveEvents=function(a){f.each(a,function(a){this.activeEvents[a]=f.bind(function(b){this.getState(k)[a](b)},this)},this)};this.registerPassiveEvents=
function(a){f.each(a,function(a){this.passiveEvents[a]=f.bind(function(b){this.getState(k)[a](b)},this)},this)};this.registerState=function(a,b){j[a]=b};this.changeState=function(a){if(k!==a){var b=k;j[b]&&j[b].leaveState&&j[b].leaveState(a);k=a;this._emit('State changed to "'+a+'"');j[a]&&j[a].enterState&&j[a].enterState(b);this.cursorShouldChange()}};this.getState=function(a){return j[a]};this.getCurrentState=function(){return this.getState(k)};this.getCurrentStateName=function(){return k}};b.prototype.sceneToWorld=
function(a){if(this._widget)return this._widget.getWorld().getWorldPointFromScene(a);this.f.emit("error.SEVERE","Requesting world point with no widget present");return a};b.prototype.sceneToWorldRect=function(a){if(this._widget)return this._widget.getWorld().getWorldRectFromScene(a);this.f.emit("error.SEVERE","Requesting world rectangle with no widget present");return null};b.prototype.sceneToWorldSize=function(a){if(this._widget)return this._widget.getWorld().getWorldSizeFromScene(a);this.f.emit("error.SEVERE",
"Requesting world rectangle with no widget present");return null};b.prototype.getWorldResolution=function(){if(this._widget)return this._widget.getWorld().getWorldResolution();this.f.emit("error.SEVERE","Requesting world resolution with no widget present");return null};b.prototype.keepPointWithinWorldBounds=function(a,b){var c=this._widget.getWorld().getWorldBounds();return this.keepPointWithinRect(a,c,b)};b.prototype.keepPointWithinRect=function(a,b,c){var d=0,d=a.x<b.left()||a.x>b.right()?a.x<b.left()?
b.left():b.right():a.x,e=0,e=a.y<b.top()||a.y>b.bottom()?a.y<b.top()?b.top():b.bottom():a.y;return c?this._widget.getWorld().getScenePointFromWorld(new g.Point(d,e)):new g.Point(d,e)};b.prototype.keepMoveSizeWithinRect=function(a,b,c){var d=b.left()+c.width,e=b.right()+c.width,i=b.top()+c.height,b=b.bottom()+c.height,f=new g.Size;Math.min(d,e)>=a.left()&&(Math.max(d,e)<=a.right()&&Math.min(i,b)>=a.top()&&Math.max(i,b)<=a.bottom())&&(f.width=c.width,f.height=c.height);return f};b.prototype.canBeInterrupted=
function(){return!0};b.prototype.canBeActivated=function(){return!0};b.prototype.setCursor=function(a){this._widget&&this._widget.setCursor(a)};b.prototype.cursorShouldChange=function(){this.isActive()&&this.setCursor(this.getDefaultCursor())};b.prototype.getDefaultCursor=function(){return"cursor-default"};b.prototype.passivate=function(){this._widget.whenContextAvailable(f.bind(function(){this.doPassivation();this._emit("passivated")},this))};b.prototype.doPassivation=function(){this._context=this._widget.context;
this._context.on(this.passiveEvents);this.bindKeys(this.persistentKeyEvents);this.bindKeys(this.passiveKeyEvents)};b.prototype.depassivate=function(){this._context&&this._context.off(this.passiveEvents);this.unbindKeys(this.passiveKeyEvents);this._emit("depassivated")};b.prototype.doActivation=function(){this._context=this._widget.context;this._context.off(this.passiveEvents);this._context.on(this.activeEvents);this.unbindKeys(this.passiveKeyEvents);this.bindKeys(this.activeKeyEvents)};b.prototype.doDeactivation=
function(){this._context&&(this._context.off(this.activeEvents),this._context.on(this.passiveEvents));this.unbindKeys(this.activeKeyEvents);this.bindKeys(this.passiveKeyEvents)};b.prototype.requestView=function(a){return this._widget.requestView(a)};b.prototype.requestCanvasLayer=function(a){if(this._viewForActiveCanvasLayer=this.requestView(a))this._layer=this._viewForActiveCanvasLayer.addLayer(this.getIID())};b.prototype.releaseCanvasLayer=function(){this._layer&&(this._viewForActiveCanvasLayer.removeLayer(this.getIID()),
this._layer=void 0)};b.prototype.getCanvasCtx=function(){if(this._layer)return this._layer.getCanvasContext()};b.prototype.getCanvasSize=function(){if(this._layer)return new g.Size(this._layer.getCanvas()[0].width,this._layer.getCanvas()[0].height)};b.prototype.getScenePoint=function(a){var b=this.getIconOffset(),a=void 0!==a.pageX?b?new g.Point(a.pageX+b.width,a.pageY+b.height):new g.Point(a.pageX,a.pageY):void 0!==a.clientX?b?new g.Point(a.clientX+b.width,a.clientY+b.height):new g.Point(a.clientX,
a.clientY):new g.Point;return(b=this._widget.requestView(a))?(b=b.getViewContext().offset(),a.offsetXY(-b.left,-b.top),a):new g.Point};b.prototype.getIconOffset=function(){return null};b.prototype.getWorldPoint=function(a){return this.sceneToWorld(this.getScenePoint(a))};b.prototype.bindKeys=function(a){for(var b=0;b<a.length;b++)c.bind(a[b][0],a[b][1],a[b][2])};b.prototype.unbindKeys=function(a){for(var b=0;b<a.length;b++)c.unbind(a[b][0],a[b][1],a[b][2])};b.prototype.getPanelAt=function(a){a=a.pageX?
new g.Point(a.pageX,a.pageY):new g.Point(a.clientX,a.clientY);return this._widget.getPanelAt(a)};b.prototype.initialize=function(a,b){this._widget=a;this._toolManager=b};return b});define("web-viewer/viewport/tools/InterruptTool",["web-viewer/viewport/tools/AbstractTool","web-viewer/core/CoreConstants"],function(f,g){var e=function(d){f.call(this,d,g.TOOLS.INTERRUPT)};e.prototype=Object.create(f.prototype);e.prototype.constructor=e;e.prototype.canBeInterrupted=function(){return!1};return e});
define("web-viewer/viewport/tools/ToolManager",["web-viewer/core/PrivateChannel","web-viewer/viewport/tools/InterruptTool","web-viewer/core/CoreConstants","web-viewer/layout/LayoutConstants","underscore"],function(f,g,e,d,c){var b=function(a,b){f.installTo(this,a,"toolManager");this.f=a;this._widget=b;this._defaultTool=this.f.getLayoutType()===d.LayoutType.MOBILE?e.TOOLS.TOUCH:e.TOOLS.ZOOM;this._loadedTools={};this._toolStack=[];this._disallowedTools=this._allowedTools=null;this._interruptTool=new g(a);
this._addTool(this._interruptTool);this.on("addTool",c.bind(function(a){this._addTool(a)},this));this.on("removeTool",c.bind(function(a){this._removeTool(a)},this));this.on("request.activation",c.bind(function(a){this._requestActivation(a)},this));this.on("request.deactivation",c.bind(function(a){this._deactivateToolImpl(a,!1,!0,!1)},this));this.on("deactivateTool",c.bind(function(a){this._deactivateToolImpl(a,!1,!0)},this));this.on("activeTool",c.bind(function(a){a(this.getActiveTool())},this));
this.on("activateTool",c.bind(function(a,b){void 0===b&&(b=!1);this._activateToolImpl(a,b,!1)},this));this.on("requestTool",c.bind(function(a,b){b(this._loadedTools[a])},this));this.on("interruptTools",c.bind(function(a){a?this._activateInterruptTool():this._deactivateInterruptTool()},this));this.on("request.allowAllTools",c.bind(function(){this.allowAllToolsExcept(null)},this));this.on("request.allowAllToolsExcept",c.bind(function(a){this.allowAllToolsExcept(a)},this));this.on("request.disallowAllToolsExcept",
c.bind(function(a){this.disallowAllToolsExcept(a)},this))};b.prototype._addTool=function(a){a&&(this._loadedTools[a.getIID()]=a,a.initialize(this._widget,this),a.passivate(),a.getIID()==this._defaultTool&&this._isToolAllowed(this._defaultTool)&&this._activateTool(a))};b.prototype._removeTool=function(a){if(c.isString(a)&&(a=this._loadedTools[a],!a)){this.f.emit("error.WARNING","Trying to deactivate a tool which isn't loaded");return}a.isActive()&&this._deactivateToolImpl(a,!1,!0,!1);this._toolStack=
c.without(this._toolStack,a);a.depassivate();delete this._loadedTools[a.getIID()]};b.prototype._activateTool=function(a){this._activateToolImpl(a,!1,!1)};b.prototype._activateToolImpl=function(a,b,d,j){if(this._isToolAllowed(a)){if(c.isString(a)&&(a=this._loadedTools[a],!a)){this.f.emit("error.WARNING","Trying to activate a tool which isn't loaded");return}if(a)if(a.canBeActivated()){var e=this.getActiveTool();if(e&&!d){if(e==a)return;this._deactivateToolImpl(void 0,b,!1,j)}c.last(this._toolStack)!=
a&&this._toolStack.push(a);a.activate(j);this.getActiveTool()===a&&(this._widget.setCursor(a.getDefaultCursor()),this.f.emit("toolManager.activated",a))}else this.f.debug.warn("Trying to activate tool which refuses to activate",a);else this.f.emit("error.SEVERE","Can't activate tool.",a)}else this._emit("request.denied",a)};b.prototype._deactivateToolImpl=function(a,b,d,j){if(c.isString(a)&&(a=this._loadedTools[a],!a)){this.f.emit("error.WARNING","Trying to deactivate a tool which isn't loaded");
return}if(a){if(a!=this.getActiveTool()){this.f.emit("error.WARNING","Trying to deactive a tool which is not the current active tool",a);return}}else a=this.getActiveTool();if(a&&(a.deactivate(j),b||this._toolStack.pop(),this.f.emit("toolManager.deactivated",a),d)){for(a=c.last(this._toolStack);a&&!this._isToolAllowed(a);)this._toolStack.pop(),a=c.last(this._toolStack);this._toolStack.pop();a||this._isToolAllowed(this._defaultTool)&&(a=this._loadedTools[this._defaultTool]);a&&this._activateToolImpl(a,
!1,!0)}};b.prototype._activateInterruptTool=function(){this._activateToolImpl(this._interruptTool,!0,!1,!0)};b.prototype._deactivateInterruptTool=function(){this._deactivateToolImpl(this._interruptTool,!1,!0,!1)};b.prototype.getActiveTool=function(){return c.last(this._toolStack)};b.prototype._requestActivation=function(a){if(this._isToolAllowed(a)){var b=this.getActiveTool();b&&b!=a&&!b.canBeInterrupted(a)?this._emit("request.denied",a):this._activateToolImpl(a,!0,!1,!0)}else this._emit("request.denied",
a)};b.prototype._isToolAllowed=function(a){c.isString(a)||(a=a.getIID());if(a===e.TOOLS.INTERRUPT)return!0;var b=!0;this._allowedTools&&(b=c.contains(this._allowedTools,a));this._disallowedTools&&c.contains(this._disallowedTools,a)&&(b=!1);return b};b.prototype.allowAllToolsExcept=function(a){this._allowedTools=null;this._disallowedTools=a;this._emit("allowedAllToolsExcept",a);this._enforceToolAllowance()};b.prototype.disallowAllToolsExcept=function(a){this._allowedTools=a;this._disallowedTools=null;
this._emit("disallowedAllToolsExcept",a);this._enforceToolAllowance()};b.prototype._enforceToolAllowance=function(){var a=this.getActiveTool();a&&!this._isToolAllowed(a)&&this._deactivateToolImpl(a,!1,!0,!1);!a&&this._isToolAllowed(this._defaultTool)&&this._activateTool(this._defaultTool)};return b});define("web-viewer/viewport/ViewportConstants",{ViewsLayoutMode:{AUTOMATIC:0,HORIZONTAL:1,VERTICAL:2},PanelsLayoutMode:{AUTOMATIC:0,VERTICAL:1,HORIZONTAL:2},PanelBorderWidth:2});
define("web-viewer/utils/DrawUtils",["underscore","utils/ShapeUtils","web-viewer/utils/ViewerUtils","utils/Cache","utils/DashUtils"],function(f,g,e,d,c){function b(a,b,c,h,d){var e=a.width,m=a.height,f=document.createElement("canvas");f.width=e;f.height=m;var g=f.getContext("2d");g.drawImage(a,0,0,e,m);a=g.getImageData(0,0,e,m);for(e=0;e<a.data.length;e+=4)a.data[e]*=b/255,a.data[e+1]*=c/255,a.data[e+2]*=h/255;g.putImageData(a,0,0);void 0===d&&(d=new Image);d.src=f.toDataURL();return d}var a=new d(30,
!1);a._loadItem=function(a){var b=new Image;b.onload=f.bind(function(){this._registerItem(a,b)},this);b.src=a};var h=new d(30,!1);h._loadItem=function(c){var h=c.split("|"),d={r:h[1],g:h[2],b:h[3]},e=f.bind(function(a,h){var d=new Image;d.onload=f.bind(function(){this._registerItem(c,d)},this);b(a,h.r,h.g,h.b,d)},this);(h=a.get(h[0],function(a){e(a,d)}))&&e(h,d)};return{LWTYPE_RECT:-1,LWTYPE_ELLIPSE:-2,LWTYPE_LINEARRAY:-3,LWTYPE_LINE:-4,LWTYPE_ARROW:-5,LWTYPE_IMAGE:-7,LWTYPE_TEXT:-21,LWTYPE_DASHEDBOX:-100,
LWTYPE_DASHEDLINE:-101,LWANCHOR_TOPLEFT:1,LWANCHOR_TOPRIGHT:2,LWANCHOR_TOPCENTER:3,LWANCHOR_BOTTOMLEFT:4,LWANCHOR_BOTTOMRIGHT:5,LWANCHOR_BOTTOMCENTER:6,LWANCHOR_CENTERLEFT:7,LWANCHOR_CENTERRIGHT:8,LWANCHOR_CENTERCENTER:9,LWANCHOR_CENTERFREE:10,LWANCHOR_HORIZONTAL:11,LWANCHOR_VERTICAL:12,LWANCHOR_START:13,LWANCHOR_END:14,drawOverlay:function(b,d,f,i,q,l,m,s,t){var v=0;l||(l=1);d.save();if(void 0!==i){var o=i.left(),w=i.top(),o=o*l,p=w*l;if(1E-6>Math.abs(o%1)||1E-6>Math.abs(1-o%1))o=Math.round(o);if(1E-6>
Math.abs(p%1)||1E-6>Math.abs(1-p%1))p=Math.round(p);w=0.5+o%1;o=0.5+p%1;d.translate(w/l,o/l)}d.globalAlpha=t?t:1;for(t=0;t<f.length;t++)if(p=f[t],null!=p){var r=p.rect.copy();if(p.staticsize)var z=r.center(),r=new g.Size(r.size.width/l,r.size.height/l),r=new g.Rect(new g.Point(z.x-r.width/2,z.y-r.height/2),r);if(!i||!r||g.rectIsNull(r)||i.rectIntersect(p.rect)||p.type==this.LWTYPE_TEXT){v++;d.save();var u=Math.floor(p.linewidth);0===u&&(u=1);p.staticwidth||(u=1<l?u/Math.ceil(l):u/l);var x=p.color,
A=p.fillcolor;null!==s&&void 0!==s&&(x=s,A&&(A=s));var z=A?!0:!1,y=x?!0:!1;x&&(d.strokeStyle=x);if(z)if(s){var F=e.rgbColor(A);d.fillStyle="rgba("+F.r+", "+F.g+", "+F.b+", 0.5)"}else d.fillStyle=A;u&&(d.lineWidth=u);switch(p.type){case this.LWTYPE_RECT:x=p.cornerRadius?p.cornerRadius:0;this.drawRect(d,r.origin.x,r.origin.y,r.size.width,r.size.height,x,z,y);break;case this.LWTYPE_ELLIPSE:this.drawEllipse(d,r.origin.x,r.origin.y,r.size.width,r.size.height,z,y);break;case this.LWTYPE_IMAGE:y=p.imageRef;
z=a.get(y,q);if(!z)continue;u=void 0;p.color&&(u=p.rgbColor(),u=h.get([y,u.r,u.g,u.b].join("|"),q));y=r.origin.x;x=r.origin.y;x-=z.naturalHeight/l;0==r.size.width||0==r.size.height?(d.save(),y=r,m&&(x=m.copy(),x.translate(w/l,o/l),y=x.transformedRect(y)),d.setTransform(1,0,0,1,0,0),A=x=0,p.imageOffset&&(x=p.imageOffset.width,A=p.imageOffset.height),d.drawImage(u?u:z,Math.ceil(y.origin.x-0.5)-x,Math.ceil(y.origin.y-0.5)-A),d.restore()):d.drawImage(u?u:z,y,x,r.size.width,r.size.height);break;case this.LWTYPE_TEXT:A||
(d.fillStyle=x);u=e.parseFloat(p.textoptions["font-size"]);p.staticsize&&(u*=l);d.font=u+"px "+p.textoptions["font-family"];z=e.trim(p.textoptions.text);d.textAlign=p.textoptions.textAlignment;i&&(y=d.measureText(z).width,u=new g.Size(y,u),u=g.rectMake(r.origin.x-u.width/2,r.origin.y-u.height/2,u.width,u.height),i.rectIntersect(u));d.save();p.staticsize?(y=r,m&&(y=m.transformedRect(y)),d.setTransform(1,0,0,1,0,0),d.fillText(z,y.origin.x,y.origin.y),d.restore()):(d.translate(r.origin.x,r.origin.y),
d.rotate(p.textoptions.rotate*Math.PI/180),d.translate(-r.origin.x,-r.origin.y),d.fillText(z,r.origin.x,r.origin.y));d.restore();break;case this.LWTYPE_DASHEDBOX:y=p.dash;d.save();d.lineWidth=u;c.drawDashedRect(d,r,y,!p.staticwidth?l:null);d.restore();break;case this.LWTYPE_DASHEDLINE:y=p.dash;d.beginPath();0==r.size.width?c.drawDash(d,r.origin.x,r.origin.y,r.origin.x,r.origin.y+r.size.height,y):c.drawDash(d,r.origin.x,r.origin.y,r.origin.x+r.size.width,r.origin.y,y);d.stroke();break;default:u=p.type==
this.LWTYPE_ARROW?!0:!1,x=p.pointArray,y=p.dash,d.beginPath(),0<x.length&&this.drawLine(b,d,x,u,m,l,z,y)}p.showIndicator&&(d.save(),d.setTransform(1,0,0,1,0,0),u=14,d.font=u+"px Arial",d.textAlign="center",z=p.indicatorText,x=d.measureText(z).width,y=u=72*u/96,A=0.5*y,x+=A,y+=A,A=r,m&&(A=m.transformedRect(A)),r=A.origin,p.type==this.LWTYPE_ELLIPSE?r.x=A.center().x-x/2:p.pointArray&&0<p.pointArray.length&&(r=m.transformedPoint(p.pointArray[0])),A=new g.Rect(new g.Point(r.x,r.y),new g.Size(x,y)),d.fillStyle=
p.indicatorColor,d.strokeStyle="black",d.lineWidth=2,x=0,this.drawRect(d,A.origin.x,A.origin.y,A.size.width,A.size.height,x,!0,!0),d.fillStyle=p.indicatorTextColor,d.fillText(z,A.center().x,r.y+y/2+u/2),d.restore());d.restore()}}d.restore()},generateTintImage:b,drawRect:function(a,b,c,h,d,e,m,f){"undefined"==typeof f&&(f=!0);"undefined"===typeof e&&(e=5);a.save();a.beginPath();a.moveTo(b+e,c);a.lineTo(b+h-e,c);a.quadraticCurveTo(b+h,c,b+h,c+e);a.lineTo(b+h,c+d-e);a.quadraticCurveTo(b+h,c+d,b+h-e,
c+d);a.lineTo(b+e,c+d);a.quadraticCurveTo(b,c+d,b,c+d-e);a.lineTo(b,c+e);a.quadraticCurveTo(b,c,b+e,c);a.closePath();f&&a.stroke();m&&a.fill();a.restore()},drawLine:function(a,b,h,d,q,l,m,s){b.beginPath();for(var t=0;t<h.length;t++){var v=h[t],o=new g.Point(v.x,v.y),w=Math.ceil(v.x*l)/l,p=Math.ceil(v.y*l)/l;void 0===this.dashedLineWarning&&(this.dashedLineWarning=f.once(function(){a.i18n.loadBundle("viewer",function(){a.emit("error.WARNING",a.i18n.t("DashedLineSupport"))})}));var r=s;s&&l&&(r=f.map(s,
function(a){return a/l}));var z=!0;r&&(void 0!==b.setLineDash?b.setLineDash(r):void 0!==b.mozDash?b.mozDash=r:z=!1);switch(v.type){case 0:b.moveTo(w,p);break;case 1:if(z)b.lineTo(w,p);else{var u=h[t-1],u=new g.Point(u.x,u.y);c.drawDash(b,u.x,u.y,w,p,r)}break;case 2:u=new g.Point(v.v1,v.v2);w=new g.Point(v.v3,v.v4);z||this.dashedLineWarning();b.bezierCurveTo(o.x,o.y,u.x,u.y,w.x,w.y);break;case 3:u=h[t-1];u=new g.Point(u.x,u.y);w=v.v1;p=v.v3;r=v.v4;v=v.v5;z||this.dashedLineWarning();this.drawArcFrom(b,
u,o,w,r,v,p);break;case 4:o=new g.Point(v.x,v.y);u=o.copy();u.x-=10*v.v3;u.y-=10*v.v2;w=u.copy();w.x-=5*v.v3;w.y-=5*v.v2;z=Math.atan2(u.y-o.y,u.x-o.x)+Math.PI/2;b.moveTo(o.x,o.y);b.lineTo(u.x,u.y);b.save();b.translate(w.x,w.y);b.rotate(z);b.translate(-w.x,-w.y);b.font="8px Arial";b.textAlign="center";b.fillStyle="blue";o=e.parseFloat(v.v1).toFixed(2);b.fillText(o,w.x,w.y);b.restore();break;default:console.log("a line that is not supported: "+v.type)}}m||b.stroke();d&&1<h.length&&(b.beginPath(),o=
h[0],h=h[1],2==h.type?(d=new g.Point(h.v1,h.v2),o=new g.Point(h.v3,h.v4)):(d=new g.Point(o.x,o.y),o=new g.Point(h.x,h.y)),h=o,q&&(d=q.transformedPoint(d),h=q.transformedPoint(h),b.save(),b.setTransform(1,0,0,1,0,0)),d=new g.Point(h.x-d.x,h.y-d.y),o=Math.sqrt(d.x*d.x+d.y*d.y),0===o?(d.x=0,d.y=0):(d.x/=o,d.y/=o),s=new g.Point(-d.y,d.x),d.x*=8,d.y*=8,s.x*=8,s.y*=8,o=new g.Point(h.x,h.y),o.x+=-d.x+s.x,o.y+=-d.y+s.y,u=new g.Point(o.x,o.y),u.x-=2*s.x,u.y-=2*s.y,b.moveTo(o.x,o.y),b.lineTo(h.x,h.y),b.lineTo(u.x,
u.y),q&&b.restore());m?b.fill():b.stroke()},drawArcFrom:function(a,b,c,h,d,e){if(0!=Math.abs(b.x-c.x).toFixed(2)){var d=new g.Point(c.x-b.x,c.y-b.y),d=Math.sqrt(d.x*d.x+d.y*d.y),m=new g.Point((c.x+b.x)/2,(c.y+b.y)/2),f=Math.sqrt(h*h-d/2*(d/2));e||(f=-f);d=new g.Point(m.x-f*(b.y-c.y)/d,m.y-f*(c.x-b.x)/d);f=(b.x-d.x)/h;m=(c.x-d.x)/h;f=1<f?1:f;m=1<m?1:m;m=-1>m?-1:m;f=Math.acos(-1>f?-1:f);m=Math.acos(m);b.y<d.y&&(f=-f);c.y<d.y&&(m=-m);a.lineTo(b.x,b.y);a.arc(d.x,d.y,h,f,m,e)}a.lineTo(c.x,c.y)},drawDash:c.drawDash,
drawEllipse:function(a,b,c,h,d,e,m){var f=0.5522848*(h/2),g=0.5522848*(d/2),v=b+h,o=c+d,h=b+h/2,d=c+d/2;a.beginPath();a.moveTo(b,d);a.bezierCurveTo(b,d-g,h-f,c,h,c);a.bezierCurveTo(h+f,c,v,d-g,v,d);a.bezierCurveTo(v,d+g,h+f,o,h,o);a.bezierCurveTo(h-f,o,b,d+g,b,d);a.closePath();e&&a.fill();m&&a.stroke()},distanceFromPointToSegment:function(a,b,c,h){if(b.x>c.x){if(a.x<c.x-h||a.x>b.x+h)return h+1}else if(a.x<b.x-h||a.x>c.x+h)return h+1;if(b.y>c.y){if(a.y<c.y-h||a.y>b.y+h)return h+1}else if(a.y<b.y-h||
a.y>c.y+h)return h+1;var d=new g.Point;d.x=c.x-b.x;d.y=c.y-b.y;c=new g.Point;c.x=a.x-b.x;c.y=a.y-b.y;if(0!=d.x||0!=d.y)if(a=d.x*d.x+d.y*d.y,b=d.x*c.x+d.y*c.y,0<b&&b<a)return d=d.y*c.x-d.x*c.y,d*d>h*h*a?h+1:Math.abs(d/Math.sqrt(a));d=c.x*c.x+c.y*c.y;return d>h*h?h+1:Math.sqrt(d)},distanceFromPointToEllipse:function(a,b,c){if(0==b.size.width||0==b.size.height||a.x<b.origin.x-c||a.y<b.origin.y-c||a.x>b.origin.x+b.size.width+c||a.y>b.origin.y+b.size.height+c)return c+1;var h=new g.Point(0,0);h.x=b.origin.x+
b.size.width/2;h.y=b.origin.y+b.size.height/2;var d=new g.Point;d.x=a.x-h.x;d.y=a.y-h.y;d.x*=2/b.size.width;d.y*=2/b.size.height;a=Math.sqrt(d.x*d.x+d.y*d.y);if(1E-4>a)return 0;d.x*=b.size.width*(1-a)/(2*a);d.y*=b.size.height*(1-a)/(2*a);a=d.x*d.x+d.y*d.y;return a>c*c?c+1:Math.sqrt(a)},distanceOfScenePoint:function(a,b,c,d){d||(d=6);var h=-1,e=a.pointArray;if(e&&0!=e.length)if(1==e.length){var m=c.transformedPoint(e[0].point),m=new g.Point(m.x,m.y);Math.abs(m.x-b.x)<d&&Math.abs(m.y-b.y)<d&&(h=999)}else for(a=
0;a<e.length-1;a++){var m=c.transformedPoint(e[a]),f=c.transformedPoint(e[a+1]),m=new g.Point(m.x,m.y),f=new g.Point(f.x,f.y),m=this.distanceFromPointToSegment(b,m,f,d);m<=d&&(h=m)}else if(c=c.transformedRect(a.rect),a.staticsize&&(c=c.center(),e=new g.Size(a.rect.size.width,a.rect.size.height),c=new g.Rect(new g.Point(c.x-e.width/2,c.y-e.height/2),e)),e=new g.Rect(new g.Point(c.origin.x-d,c.origin.y-d),new g.Size(c.size.width+2*d,c.size.height+2*d)),c.normalize(),e.normalize(),a.type==this.LWTYPE_ELLIPSE)a.fillcolor?
c.containsPoint(b)?h=1:e.containsPoint(b)&&(h=999):(m=this.distanceFromPointToEllipse(b,c,d),m<=d&&(h=m));else{if(a.type==this.LWTYPE_IMAGE&&a.imagetouchspot)var m=a.imagetouchspot,f=m.size.width,t=m.size.height,e=new g.Rect(new g.Point(e.origin.x+m.origin.x,e.origin.y+m.origin.y),new g.Size(f+2*d,t+2*d));e.containsPoint(b)&&((a.fillcolor||a.type==this.LWTYPE_IMAGE)&&!a.treatAsOutline?h=999:(new g.Rect(new g.Point(c.origin.x+d,c.origin.y+d),new g.Size(c.size.width-2*d,c.size.height-2*d))).containsPoint(b)||
(h=999))}return h},drawDashedLine:c.drawDashedLine,drawDashedRect:c.drawDashedRect}});
define("web-viewer/utils/Fragment",["utils/Cache","underscore"],function(f,g){var e=new Image,d=function(c,b){this.rect=c;this.zoom=b;this.image=new Image;this.dirty=this.fetched=!1};d.prototype.fetchImage=function(c,b,a,d){this.image=e;c.get(b,g.bind(function(b){void 0===b||b.error?d.call(void 0):(this.image=b,this.fetched=!0,a.call(b))},this))};d.prototype.getImage=function(){return this.image};d.prototype.setImage=function(c){this.image=$("<img>").attr("src",c)[0];this.fetched=!0};d.prototype.isFetched=
function(){return this.fetched};d.prototype.isDirty=function(){return this.dirty};d.prototype.makeDirty=function(){this.dirty=!0};d.prototype.getRect=function(){return this.rect};d.prototype.getZoom=function(){return this.zoom};d.prototype.getNaturalWidth=function(){return this.image.naturalWidth};d.prototype.getNaturalHeight=function(){return this.image.naturalHeight};return d});
define("web-viewer/viewport/model/ViewportFragmentManager",["underscore","utils/ShapeUtils","web-viewer/utils/Fragment"],function(f,g,e){function d(a,b){return Math.abs(a-b)<=c}var c=1E-5,b=function(a,b,c){this.f=a;this.delegate=b;this.world=c;this.fragments=[];this.dirtyInitialFragment=this.initialFragment=null;this.fragmentCache=this.f.getModule("viewport").getImageCache()};b.prototype.getAllFragments=function(){var a=this.fragments.slice(0);a.prepend(this.intialFragment);return a};b.prototype.getInitialFragment=
function(){return!this.initialFragment||!this.initialFragment.isFetched()?this.dirtyInitialFragment:this.initialFragment};b.prototype.isRectCoveredBy=function(a,b){return a.rectEquals(b)||b.containsRect(a)};b.prototype.isFragmentCoveredBy=function(a,b){return d(a.getZoom(),b.getZoom())&&this.isRectCoveredBy(a.getRect(),b.getRect())};b.prototype.preloadFragment=function(a,b){if(!(0===a.size.width||0===a.size.height)){var c=new e(a,b),d=this.getInitialFragment();if(!d||d.isDirty()||!this.isFragmentCoveredBy(c,
d)){for(d=0;d<this.fragments.length;d++){var g=this.fragments[d];if(!g.isDirty()&&this.isFragmentCoveredBy(c,g))return}for(d=0;d<this.fragments.length&&c.getZoom()>=this.fragments[d].getZoom();)d++;this.fragments.splice(d,0,c);c.age=0;c.fetchImage(this.fragmentCache,this.getUrlForFragment(c),f.bind(this._fragmentFetched,this),f.bind(this._removeFragment,this,c))}}};b.prototype.getApplicableFragments=function(a,b){var c=[],e,k=null,i=this.getInitialFragment();if(i&&i.isFetched()){if(!i.isDirty()&&
a.rectEquals(i.getRect())&&d(i.getZoom(),b))return i.perfectFit=!0,c.push(i),c;i.perfectFit=!1}else i=null;var q=[],l=[],m=0,s=0,t=function(a){a.isDirty()?l.push(a):q.push(a);a.age--},v=a.calculateOverlap(this.world.getWorldBounds());for(e=0;e<this.fragments.length;e++){var o=this.fragments[e];o.age+=3;if(!k&&o.isFetched())if(m++,o.isDirty()&&s++,o.getZoom()<=b){if(g.rectIntersection(o.getRect(),a)&&(!i||!(o.getZoom()<i.getZoom()&&i.getZoom()>b)))d(o.getZoom(),b)&&this.isRectCoveredBy(v,o.getRect())?
(o.perfectFit=!0,o.isDirty()||(k=o)):o.perfectFit=!1,t(o)}else this.world.isAnimating()&&3*o.getZoom()<=b&&g.rectIntersection(o.getRect(),a)&&t(o)}if(k)i&&c.push(i),k.age=-3,c.push(k);else{e=o=0;k=l[o];for(t=q[e];k&&(!t||k.getZoom()<t.getZoom());)k.age-=1,c.push(k),k=l[++o];for(;e<q.length;){o=q[e+1];if(!o||!this.isRectCoveredBy(a.calculateOverlap(q[e].getRect()),o.getRect()))q[e].age-=1,c.push(q[e]);e++}}if(i&&(0==c.length||i.getZoom()<=b)){for(e=0;e<c.length&&c[e].getZoom()<i.getZoom();)e++;c.splice(e,
0,i)}m=m-s-5;if(0<m){s=f.sortBy(this.fragments,function(a,b,c){return 100*a.age+(c.length-b)});for(e=s.length-1;0<=e&&0<m;e--)o=s[e],o!==i&&(o.isFetched()&&!o.isDirty()&&!f.contains(c,o))&&(this._removeFragment(o),m--)}return c};b.prototype.getUrlForFragment=function(a){return this.delegate.getURLForFragment(a)};b.prototype._fragmentFetched=function(){this.cleanupDirtyFragments();this.delegate.fragmentsChanged()};b.prototype._removeFragment=function(a){a=f.indexOf(this.fragments,a);0<=a&&this.removeFragmentAtIndex(a)};
b.prototype.removeFragmentAtIndex=function(a){this.fragments.splice(a,1)};b.prototype.cleanupDirtyFragments=function(){var a=f.filter(this.fragments,function(a){return!a.isDirty()});a.length!=this.fragments.length&&f.some(a,function(a){return a.isFetched()})&&(this.fragments=a);this.dirtyInitialFragment=null};b.prototype.markAllAsDirty=function(){this.cleanupDirtyFragments();f.each(this.fragments,function(a){a.makeDirty()});(this.dirtyInitialFragment=this.initialFragment)&&this.dirtyInitialFragment.makeDirty();
this.initialFragment=null};b.prototype.cleanupFragments=function(){this.fragments=[];this.dirtyInitialFragment=this.initialFragment=null};b.prototype.calculateRoundedWorldBounds=function(){var a=this.world.getWorldBounds(),b=this.world.getInitialStartZoom();a.size.width=Math.floor(a.size.width*b)/b;a.size.height=Math.floor(a.size.height*b)/b;return a};b.prototype.updateInitialFragment=function(){var a=this.calculateRoundedWorldBounds();if(0<this.world.getInitialStartZoom()&&(!this.initialFragment||
!d(this.initialFragment.getZoom(),this.world.getInitialStartZoom())||!this.initialFragment.getRect().rectEquals(a)))this.dirtyInitialFragment=this.initialFragment,this.initialFragment=new e(a,this.world.getInitialStartZoom()),this.initialFragment.isInitial=!0,this.initialFragment.fetchImage(this.fragmentCache,this.getUrlForFragment(this.initialFragment),f.bind(this._fragmentFetched,this),f.bind(function(){this.initialFragment=null},this))};return b});
define("web-viewer/viewport/ViewportLayer","jquery underscore web-viewer/utils/DrawUtils utils/ShapeUtils utils/Transformation web-viewer/utils/ListenerUtil web-viewer/utils/Fragment web-viewer/utils/ConversionConstants web-viewer/viewport/model/ViewportFragmentManager utils/HTTPUtils component/popover/Popover".split(" "),function(f,g,e,d,c,b,a,h,n,j,k){var i=function(a,c,d,h,e){this.f=a;b.mixin(this,a);this._id=e;this._canvas=f("<canvas>").css({position:"absolute",top:0,left:0}).attr("id",this._id);
this._layerModel=null;this._view=c;this._canvasIsShown=this._visible=!0;this._listeners=[];this._world=d;this._transform=h;this._shouldBuffer=this._enableBuffer=!1;this._buffer=null;this._interactive=this._dirty=this._debugBuffer=!1;this.throttledRender=g.throttle(g.bind(this.render,this),40);this.debouncedRepaint=g.debounce(g.bind(function(){var a=this._dirty;this._dirty=!1;this.preloadViewportFragment();this.throttledRender();a&&this.f.emit("viewportLayer.finishedImageDataRequest",this._id)},this),
40);this._fragmentManager=new n(this.f,{getURLForFragment:g.bind(function(a){return this.generateFragmentURL(a)},this),fragmentsChanged:this.throttledRender},this._world);this._overwriteOptions={}};i.prototype.getLayerModel=function(){return this._layerModel};i.prototype.setLayerModel=function(a){this._unregisterAllListeners();this._layerModel=a;this._registerListener("modelChanged",this.onLayerModelChange,this,this._layerModel);this._registerListener("popoverAdded",this.onPopoverAdded,this,this._layerModel);
this._registerListener("popoverRemoved",this.onPopoverRemoved,this,this._layerModel);this._registerListener("repaint",this.repaint,this,this._layerModel);this._registerListener("fragmentsDirty",this.markAllFragmentsAsDirty,this,this._layerModel);this._registerListener("cleanupFragments",this.cleanupFragments,this,this._layerModel);this._registerListener("overwriteOption.**",this.markAllFragmentsAsDirty,this,this._layerModel);this._registerListener("changed.visible",function(){this.repaint()},this,
this._layerModel);this.repaint()};i.prototype.destroy=function(){this._unregisterAllListeners();this.hideAllPopovers();this._canvas.remove()};i.prototype.onLayerModelChange=function(){this.throttledRender()};i.prototype.startInteractive=function(){this._interactive=this._shouldBuffer=!0;this.hideAllNonInteractivePopovers();this.hideAllPopups()};i.prototype.stopInteractive=function(){this._interactive=this._shouldBuffer=!1;this._world.isAnimating()||(this.drawPopovers(),this.drawPopups(),this.preloadViewportFragment())};
i.prototype.setVisible=function(a){this._visible=a;this.repaint()};i.prototype.setSize=function(a){if(this._canvas[0].width!=a.width||this._canvas[0].height!=a.height)this._canvas[0].width=a.width,this._canvas[0].height=a.height,this.render()};i.prototype.getCanvas=function(){return this._canvas};i.prototype.getCanvasContext=function(){return this._canvas[0].getContext("2d")};i.prototype.setOverwriteOptions=function(a){this._overwriteOptions=a;this.markAllFragmentsAsDirty()};i.prototype.isVisible=
function(){return this._visible&&(!this._layerModel||this._layerModel.isVisible())};i.prototype.getClosestLineworkFromPoint=function(a,b){if(this._layerModel){for(var c=null,d=-1,h=this.getTransformMatrix(),f=this._world.getWorldRectFromScene(this._world.getSceneBounds(),h),i=this._layerModel.getLinework(),g=0;g<i.length;g++){var j=i[g];if(!j.rect||!(0<j.rect.size.width&&0<j.rect.size.height)||f.rectIntersect(j.rect)){var n=e.distanceOfScenePoint(j,a,h,b);if(0<n&&(0>d||n<=d))c=j,d=n}}return c}};i.prototype.getClosestLineworkPointFromPoint=
function(a,b){var c=null;if(null!==this._layerModel)for(var h=this.getTransformMatrix(),h=this._world.getWorldRectFromScene(this._world.getSceneBounds(),h),e=new d.Size(b,b),f=new d.Rect(new d.Point(a.x-b/2,a.y-b/2),e),e=this.getWorldPointFromScene(a),f=this.getWorldRectFromScene(f),i=this._layerModel.getLinework(),g=0;g<i.length;g++){var j=i[g];if(j.snapable&&(j.pointArray&&0<j.pointArray.length)&&(!j.rect||!(0<j.rect.size.width&&0<j.rect.size.height&&!h.rectIntersect(j.rect))))for(var j=j.pointArray,
n=0;n<j.length;n++){var k=j[n];if(f.containsPoint(k)&&(k=new d.Point(k.x,k.y),!c||k.getDistance(e)<c.getDistance(e)))c=k}}return c?this.getScenePointFromWorld(c):null};i.prototype.getWorldPointFromScene=function(a){return this._world.getWorldPointFromScene(a,this.getTransformMatrix())};i.prototype.getWorldRectFromScene=function(a){return this._world.getWorldRectFromScene(a,this.getTransformMatrix())};i.prototype.getSceneRectFromWorld=function(a){return this._world.getSceneRectFromWorld(a,this.getTransformMatrix())};
i.prototype.getScenePointFromWorld=function(a){return this._world.getScenePointFromWorld(a,this.getTransformMatrix())};i.prototype.getLayerTransform=function(){var a=this._layerModel.getTransform().copy(),b=new c,d=this._world.getWorldSize().width/2-a.e,h=this._world.getWorldSize().height/2-a.f;b.translate(d,h);b.concatenate(a);b.translate(-d,-h);return b};i.prototype.convertLayerRectToWorld=function(a){return this.getLayerTransform().transformedRect(a)};i.prototype.convertWorldRectToLayer=function(a){return this.getLayerTransform().createInverse().transformedRect(a)};
i.prototype.convertLayerPointToWorld=function(a){return this.getLayerTransform().transformedPoint(a)};i.prototype.convertWorldPointToLayer=function(a){return this.getLayerTransform().createInverse().transformedPoint(a)};i.prototype.getTransformMatrix=function(){var a=new c;if(this._layerModel){var b=this._layerModel.getTransform();a.preConcatenate(b)}var b=this._world.getWorldSize().width/2-this._transform.e,d=this._world.getWorldSize().height/2-this._transform.f;a.preTranslate(-b,-d);a.preConcatenate(this._transform);
a.preTranslate(b,d);a.preConcatenate(this._world.getTransformation());return a};i.prototype.getZoom=function(){var a=this._world.getTransformation();return Math.sqrt(a.c*a.c+a.d*a.d)};i.prototype.addFragment=function(a,b){if(!isNaN(b)){var c=this._layerModel.getMaximumResolution();0<=c&&(b=Math.min(c,b));this._fragmentManager.preloadFragment(a,b,!0)}};i.prototype.generateFragmentURL=function(a){var a=this._layerModel.getContextForFragment(a),b=a.params.color;void 0===a.params.file&&void 0!==a.params.diff&&
(a.params.file=a.params.diff,delete a.params.diff,a.params.rs=1==a.params.rs?2:1);a.params=g.extend(a.params,this._overwriteOptions);delete a.params.colorBITWISE;void 0!==this._overwriteOptions.colorBITWISE&&(b=void 0!==b?a.params.color&this._overwriteOptions.colorBITWISE:this._overwriteOptions.colorBITWISE,a.params.color=b);delete a.params.isDefaultView;a=j.constructURL(a.servlet,a.params);return a=a.replace(/%2C/g,",")};i.prototype.getApplicableFragments=function(a,b){return this._fragmentManager.getApplicableFragments(a,
b)};i.prototype.markAllFragmentsAsDirty=function(){this._dirty||(this._dirty=!0,this.canFetchFragments()&&this.f.emit("viewportLayer.startImageDataRequest",this._id));this._fragmentManager.markAllAsDirty();this.repaint()};i.prototype.cleanupFragments=function(){this._fragmentManager.cleanupFragments();this.repaint()};i.prototype.repaint=function(a,b){a&&(this._world=a);b&&(this._transform=b);this._canvasIsShown!=this.isVisible()&&(this._canvasIsShown=this.isVisible(),this._canvas.toggle(this._canvasIsShown));
this.debouncedRepaint();this.throttledRender()};i.prototype.canFetchFragments=function(){return null!==this._layerModel&&!this._interactive&&this.isVisible()&&void 0!==this._world&&null!==this._world&&this._layerModel.hasGraphics()&&0<this._world.getZoom()&&this.f.canFetchFragments()};i.prototype.preloadViewportFragment=function(){if(this.canFetchFragments()){var a=this._world.getZoom(),b=this._world.getAnimationDestinationTargetViewPort();b.size.width=Math.floor(b.size.width*a)/a;b.size.height=Math.floor(b.size.height*
a)/a;this._layerModel.shouldAutoFetchFragments()?(this.addFragment(b,a),this._world.isAnimating()||this._fragmentManager.updateInitialFragment()):this._layerModel.preloadFragment(b,a)}};i.prototype.zoomingStarted=function(){this._isZooming=!0};i.prototype.zoomingStopped=function(){this._isZooming=!1};i.prototype.panningStarted=function(){if(null!==this._layerModel&&this._layerModel.hasLinework(this._view.getPanel().getModel().getName())&&!this._layerModel.hasBuffer(this._view.getPanel().getModel().getName())&&
this._canvasIsShown){var b=this._world.getZoom(),c=this._world.getTargetViewPort(!0),h=this._world.getRotation(),e=this._world.isFlip();if(this._world.isFlipViewFromBack()){if(90===h||270===h)h=(h+180)%360;e=!e}var h=(360+h)%360,f=c.size.width,i=c.size.height;270===h%360?(i>f&&!e&&(c.origin.x-=i-f),c.size=new d.Size(i,f)):90===h%360&&(f>i?c.origin.y+=i-f:i>f&&e&&(c.origin.x-=i-f),c.size=new d.Size(i,f));b=new a(c,b);f=this._world.getSceneBounds();c=document.createElement("canvas");i=Math.max(f.size.width,
f.size.height);90===h%360||270===h%360?(c.width=i,c.height=i):(c.width=f.size.width,c.height=f.size.height);f=c.getContext("2d");f.translate(c.width/2,c.height/2);e&&f.scale(-1,1);f.rotate((360-h%360)/180*Math.PI);f.translate(-c.width/2,-c.height/2);f.drawImage(this._canvas[0],0,0);b.image=c;b.fetched=!0;void 0!==this._layerModel.setBuffer&&this._layerModel.setBuffer(b)}};i.prototype.panningStopped=function(){null!==this._layerModel&&(this._layerModel.hasLinework(this._view.getPanel().getModel().getName())&&
void 0!==this._layerModel.setBuffer)&&(this._layerModel.setBuffer(null),this.throttledRender())};i.prototype.render=function(){if(this._layerModel&&this._world&&this._transform&&!(0===this._world.getWorldSize().width&&0===this._world.getWorldSize().height)&&this.isVisible()){this._world.isAnimating()&&(this.hideAllPopovers(),this.hideAllPopups());var a=this.getCanvasContext();a.setTransform(1,0,0,1,0,0);a.clearRect(0,0,this._canvas.width(),this._canvas.height());var b=this.getTransformMatrix();a.transform(b.a,
b.b,b.c,b.d,b.e,b.f);var c=b.getScaleX(),d=this._world.getWorldRectFromScene(this._world.getSceneBounds(),b);this._renderBackground(a);this._renderFragments(a,d,c);this._renderLinework(a,d,c,b);this._layerModel.render(a,d,c,b);this._world.isAnimating()||(this.drawPopovers(),this.drawPopups())}};i.prototype._renderBackground=function(a){var b=this._layerModel.getBackgroundOptions();if(0<g.size(b)){a.save();for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c]);b=this._world.getWorldBounds();b=this._layerModel.getTransform().createInverse().transformedRect(b);
a.fillRect(b.origin.x,b.origin.y,b.size.width,b.size.height);a.restore()}};i.prototype._renderFragments=function(a,b,c){if(this._layerModel.hasGraphics()){b=this._layerModel.shouldAutoFetchFragments()?this.getApplicableFragments(b,c):this._layerModel.fragments(b,c);a.save();c=this._world.getZoom();a.scale(1/c,1/c);for(var d=0;d<b.length;d++){var h=b[d];if(h.isFetched()){var e=h.getRect(),f=Math.floor(e.origin.x*c),i=Math.floor(e.origin.y*c),g=Math.ceil(e.size.width*c),e=Math.ceil(e.size.height*c);
5E-4>Math.abs(h.getZoom()-c)&&(g=h.getNaturalWidth(),e=h.getNaturalHeight());a.drawImage(h.image,f,i,g,e)}}a.restore()}};i.prototype._renderLinework=function(a,b,c,d){if(!this._layerModel.hasBuffer(this._view.getPanel().getModel().getName())||!this._layerModel.hasLinework(this._view.getPanel().getModel().getName())){var h=this._layerModel.getLinework(this._world.isAnimating(),this._world.isAnimatingRotation(),b,this._view.getModel().getID(),this._view.getPanel().getModel().getName(),this._isZooming);
h&&0<h.length&&(this._buffer=null,e.drawOverlay(this.f,a,h,b,g.bind(this.throttledRender,this),c,d,this._layerModel.getLineworkColor(),this._layerModel.getAlpha()))}else this._layerModel.hasLinework(this._view.getPanel().getModel().getName())&&this._layerModel.hasBuffer(this._view.getPanel().getModel().getName())&&this._renderBuffer(a,c,d)};i.prototype._renderBuffer=function(a,b,c){var d=this._layerModel.getBuffer();if(null!==d){a.save();b=this._world.getZoom();c=this._world.getTransformation();a.setTransform(1,
0,0,1,0,0);a.transform(c.a,c.b,c.c,c.d,c.e,c.f);a.scale(1/b,1/b);if(d.isFetched()){var h=d.getRect(),c=h.origin.x*b,e=h.origin.y*b,f=h.size.width*b,h=h.size.height*b,i=d.getImage();5E-4>Math.abs(d.getZoom()-b)&&(f=i.width,h=i.height);a.drawImage(i,c,e,f,h)}a.restore()}};i.prototype.onPopoverAdded=function(a){var b=this._layerModel.getPopoverModel(a);if(void 0===this._layerModel.getPopover(a)){var c={},d=f("<div>").css("pointer-events","none");this.f.getContext().find(".viewport").append(d);c.popoverDiv=
d;d=new k(d,b.getContext(),this._canvas,b.getPreferredPosition(),"#fff",b.getClass(),b.getRestrictBorder());d.element.mouseenter(function(a){f(this).hide();a=document.elementFromPoint(a.clientX,a.clientY);f(this).show();f(a).mouseenter()});if(b.onAddedToContainer)d.onAddedToContainer(b.onAddedToContainer);if(b.onDestroy)d.onDestroy(b.onDestroy);d.setContent(b.getContent());c.popover=d;this._layerModel.savePopover(c,a);this.drawPopovers()}};i.prototype.onPopoverRemoved=function(a){var b=this._layerModel.getPopover(a);
b&&(b.popover.hide(),b.popover.destroy(),b.popoverDiv.remove(),this._layerModel.removePopover(a))};i.prototype.hideAllPopovers=function(){null!==this._layerModel&&g.each(this._layerModel.getAllPopovers(),function(a){a.popover.hide();a.popoverDiv.hide()})};i.prototype.hideAllNonInteractivePopovers=function(){null!==this._layerModel&&g.each(this._layerModel.getAllPopovers(),function(a,b){this._layerModel.getPopoverModel(b).isInteractive()||(a.popover.hide(),a.popoverDiv.hide())},this)};i.prototype.drawPopovers=
function(){this._layerModel&&(this.isVisible()&&this._view.isActive())&&g.each(this._layerModel.getAllPopovers(),function(a,b){a.popover.restrict=this._canvas;a.popoverDiv.show();var c=this._layerModel.getPopoverModel(b),d=c.getFrame();if(d){var d=this._world.getSceneRectFromWorld(d,this.getTransformMatrix()),h=this._view.getViewLocation(),e=0;this._view.isTitleVisible()&&(e=this._view.getTitleHeight());a.popoverDiv.css({position:"absolute",width:d.size.width+10+"px",height:d.size.height+10+"px",
top:d.origin.y+h.y+e-5+"px",left:d.origin.x+h.x-5+"px"});a.popover.setPreferredPlacement(c.getPreferredPosition());a.popover.show()}},this)};i.prototype.hideAllPopups=function(){this._layerModel&&g.each(this._layerModel.getPopupModels(),function(a){a.getPopup(this).hide()},this)};i.prototype.drawPopups=function(){this._layerModel&&this._canvasIsShown&&g.each(this._layerModel.getPopupModels(),function(a){var b=a.getPopup(this);if(a.isShown()&&!this._interactive){var c=this.getScenePointFromWorld(a.getWorldOrigin()),
e=a.getWorldSize().copy();e.width*=h.MM_TO_PX_RATIO;e.height*=h.MM_TO_PX_RATIO;var f=a.getSceneOffset();f&&(c.x+=f.width,c.y+=f.height);b.setRect(new d.Rect(c,e));if(0===b.listeners("resized").length)b.on("resized",g.bind(function(b,c){var e=a.getSceneOffset();e&&(b.origin.x-=e.width,b.origin.y-=e.height);e=this.getWorldRectFromScene(b);e.size.width=b.size.width*h.PX_TO_MM_RATIO;e.size.height=b.size.height*h.PX_TO_MM_RATIO;var e=this.getWorldPointFromScene(b.origin),f=b.size.copy();f.width*=h.PX_TO_MM_RATIO;
f.height*=h.PX_TO_MM_RATIO;a.onResized(new d.Rect(e,f),c)},this));if(0===b.listeners("dragged").length)b.on("dragged",g.bind(function(b){var c=a.getSceneOffset();c&&(b.x-=c.width,b.y-=c.height);a.onDragged(this.getWorldPointFromScene(b))},this));b.show()}else b.hide()},this)};return i});
define("web-viewer/viewport/ViewportView",["underscore","web-viewer/viewport/ViewportLayer","utils/ShapeUtils","web-viewer/utils/ListenerUtil"],function(f,g,e,d){var c=function(b,a,c,e){this._world=a;this.f=b;this.id=c;d.mixin(this,b);this.element=this._viewWrapper=$("<div />").addClass("view").attr("name",this.id);this._title=null;this._viewTitle=$("<div />").addClass("viewTitle");this._viewWrapper.append(this._viewTitle);this._titleShown=!1;this._viewDiv=$("<div />").css({position:"relative"});
this._viewWrapper.append(this._viewDiv);this.borders={left:!1,right:!1};this._isActive=!1;this._rect=null;this._viewportPanel=e;this.layers={};this._disabledLayers=[];this._isPanning=!1;this._viewportViewModel=void 0;this._overwriteOptions={};this._throttledRender=f.throttle(this._renderView,40);this.recalculateViewSize();this._registerListener("viewport.startInteractive",function(){f.each(this.layers,function(a){a.startInteractive()})},this);this._registerListener("viewport.stopInteractive",function(){f.each(this.layers,
function(a){a.stopInteractive()})},this);this.element.mouseenter(f.bind(function(){this._isActive=!0},this));this.element.mouseleave(f.bind(function(){this._isActive=!1},this))};c.prototype.getLayer=function(b){return this.layers[b]};c.prototype.isActive=function(){return this._isActive||this.isDefaultView()&&!this._viewportPanel.isViewportWidgetActive()};c.prototype.getClosestLineworkPointFromPoint=function(b,a,c){var d=null,e;e=c?f.filter(this.layers,function(a){return a.getLayerModel()?f.contains(c,
a.getLayerModel().getName()):!1}):this.layers;f.each(e,function(c){if((c=c.getClosestLineworkPointFromPoint(b,a))&&(!d||c.getDistance(b)<d.getDistance(b)))return d=c,!0});return d};c.prototype.getClosestLineworkFromPoint=function(b,a,c){var d=null,e;e=a?f.filter(this.layers,function(b){return b.getLayerModel()?f.contains(a,b.getLayerModel().getName()):!1}):this.layers;f.each(e,function(a){d||(d=a.getClosestLineworkFromPoint(b,c))});return d};c.prototype.recalculateViewSize=function(){var b={width:this._viewWrapper.innerWidth(),
height:this._viewWrapper.innerHeight()-this._viewTitle.outerHeight(!0)};this.borders.left&&(b.width--,b["border-left"]="1px solid");this.borders.right&&(b.width--,b["border-right"]="1px solid");this._viewDiv.css(b)};c.prototype.hideLayer=function(b,a){this.layers[b]&&this.layers[b].setVisible(!a)};c.prototype.hideAllLayers=function(b){f.each(this.layers,function(a,c){this.hideLayer(c,b)},this)};c.prototype.setRect=function(b){this._viewWrapper.css({position:"absolute",width:b.size.width,height:b.size.height,
top:b.top(),left:b.left()});this._rect=b;this.resizeLayers();this.repaint()};c.prototype.getViewLocation=function(){var b=new e.Point;null!==this._rect&&(b=this._rect.origin.copy());var a=this._viewportPanel.getPosition();void 0!==a&&(b.x+=a.x,b.y+=a.y);return b};c.prototype.getWrapperContext=function(){return this._viewWrapper};c.prototype.getViewContext=function(){return this._viewDiv};c.prototype.resizeLayers=function(){this.recalculateViewSize();f.each(this.layers,f.bind(function(b){this._resizeLayer(b)},
this))};c.prototype._resizeLayer=function(b){b.setSize(new e.Size($(this._viewDiv).width(),$(this._viewDiv).height()))};c.prototype._insertLayerAtIndex=function(b,a){var c=this._viewDiv.children().size();0>b&&(b=Math.max(0,c+1+b));b<c?this._viewDiv.children().eq(Math.max(0,b)).before(a):this._viewDiv.append(a)};c.prototype.addLayer=function(b){var a=this.layers[b];if(!a){a=new g(this.f,this,this._world,this._viewportViewModel.getTransform(),this.id+"_"+b);a.setOverwriteOptions(this._getOverwriteOptions());
var c=this._viewportViewModel.indexForLayer(b,this.layers);this._insertLayerAtIndex(c,a.getCanvas());a.setVisible(this.isLayerVisible(b));this.layers[b]=a}(b=this._viewportViewModel.modelForLayer(b))&&a.setLayerModel(b);this.recalculateViewSize();this._resizeLayer(a);return a};c.prototype._getOverwriteOptions=function(){return this._overwriteOptions};c.prototype.repaint=function(b,a){this._viewportViewModel.isShown()&&(void 0!==b&&(this._world=b),this._throttledRender(a))};c.prototype.setModel=function(b){this._viewportViewModel&&
this._unregisterAllListenersForObject(this._viewportViewModel);this._viewportViewModel=b;this._registerListener("layerAdded",this._addLayerToView,this,this._viewportViewModel);this._registerListener("layerRemoved",this.removeLayer,this,this._viewportViewModel);this._registerListener("titleChanged",this._repaintTitle,this,this._viewportViewModel);this._registerListener("showChanged",this._showHide,this,this._viewportViewModel);for(b=0;b<this._viewportViewModel.numberOfLayers();b++){var a=this._viewportViewModel.nameForLayerAtIndex(b);
this.addLayer(a)}};c.prototype.getModel=function(){return this._viewportViewModel};c.prototype.removeLayer=function(b){this.layers[b]?(this.layers[b].destroy(),delete this.layers[b]):this.f.debug.debug("Trying to remove a layer that does not exists: "+b)};c.prototype._addLayerToView=function(b){this.addLayer(b);this._throttledRender(b)};c.prototype._showHide=function(){this._viewportViewModel.isShown()?(this._viewWrapper.show(),this.hideAllLayers(!1)):(this.hideAllLayers(!0),this._viewWrapper.hide())};
c.prototype.getTitleHeight=function(){return $(this._viewTitle).outerHeight(!0)};c.prototype.isTitleVisible=function(){return this._titleShown};c.prototype._repaintTitle=function(){var b=this._viewportViewModel.getTitle();null!==this._title&&(b=this._title);b?(this._viewTitle.text(b),this._viewTitle.attr("title",b),this._titleShown||(this._viewTitle.show(),this._titleShown=!0,this.recalculateViewSize(),this.resizeLayers())):(this._viewTitle.empty(),this._titleShown&&(this._viewTitle.hide(),this._titleShown=
!1,this.recalculateViewSize(),this.resizeLayers()))};c.prototype._renderView=function(b){this._repaintTitle();b?(b=this.layers[b])&&b.repaint(this._world,this._viewportViewModel.getTransform()):f.each(this.layers,function(a){a.repaint(this._world,this._viewportViewModel.getTransform())},this)};c.prototype.isPanning=function(){return this._isPanning};c.prototype.setBorderVisibility=function(b,a){this.borders.left=b;this.borders.right=a};c.prototype.destroy=function(){this._unregisterAllListeners();
f.each(this.layers,function(b){b.destroy()});this.element.remove()};c.prototype.getID=function(){return this.id};c.prototype.setOverwriteOptions=function(b){this._overwriteOptions=b;f.each(this.layers,function(a){a.setOverwriteOptions(b)})};c.prototype.toggleLayer=function(b,a){var c=this.layers[b];c&&c.setVisible(a);a?this._disabledLayers=f.without(this._disabledLayers,b):this._disabledLayers.push(b)};c.prototype.toggleLayers=function(b,a){f.each(b,function(b){this.toggleLayer(b,a)},this)};c.prototype.isLayerVisible=
function(b){return 0>f.indexOf(this._disabledLayers,b)};c.prototype.setTitle=function(b){this._title=b;this._repaintTitle()};c.prototype.isDefaultView=function(){return this._viewportViewModel.isDefaultView()&&this._overwriteOptions.isDefaultView};c.prototype.panningStarted=function(){this._isPanning=!0;f.each(this.layers,function(b){b.panningStarted()})};c.prototype.panningStopped=function(){this._isPanning=!0;f.each(this.layers,function(b){b.panningStopped()})};c.prototype.zoomingStarted=function(){this._isZooming=
!0;f.each(this.layers,function(b){b.zoomingStarted()})};c.prototype.zoomingStopped=function(){this._isZooming=!1;f.each(this.layers,function(b){b.zoomingStopped()})};c.prototype.getPanel=function(){return this._viewportPanel};return c});
define("web-viewer/viewport/ViewportPanel","web-viewer/utils/ListenerUtil utils/ShapeUtils web-viewer/viewport/ViewportView web-viewer/viewport/ViewportConstants underscore jquery".split(" "),function(f,g,e,d,c,b){var a=function(a,d,e,g){this.f=a;f.mixin(this,a);this._viewObjects={};this._widgetModel=e;this._panelModel=d;this._viewportWorld=g;this.element=b("<div/>").attr("name",d.getName()).css({top:0,left:0}).addClass("viewportPanel");this.container=b("<div />").addClass("viewportPanelContainer");
this.element.append(this.container);this._debouncedLayout=c.debounce(this._layout,50);this.updateOverwriteOptions=c.debounce(this._updateOverwriteOptions,20);this._registerListener("changed.overwriteOption.**",this.updateOverwriteOptions,this,this._panelModel);this._registerListener("changed.disabledLayers",this.updateDisabledLayers,this,this._panelModel);this._registerListener("changed.headerText",this.updatePanelHeader,this,this._panelModel);this._registerListener("changed.view.toggle.*",this.layout,
this,this._widgetModel);this._registerListener("changed.view.order",this.layout,this,this._widgetModel);this._registerListener("changed.view.remove",function(a){this._destroyView(a.getID())},this,this._widgetModel);this._registerListener("changed.layout.*",this.layout,this,this._widgetModel);this._registerListener("viewport.startPanning",c.bind(function(){this._isPanning=!0;c.each(this._viewObjects,function(a){a.panningStarted()})},this));this._registerListener("viewport.stopPanning",c.bind(function(){this._isPanning=
!1;c.each(this._viewObjects,function(a){a.panningStopped()})},this));this._registerListener("viewport.startZooming",c.bind(function(){this._isZooming=!0;c.each(this._viewObjects,function(a){a.zoomingStarted()})},this));this._registerListener("viewport.stopZooming",c.bind(function(){this._isZooming=!1;c.each(this._viewObjects,function(a){a.zoomingStopped()})},this));this.repaint=c.throttle(c.bind(function(){this._repaint()},this),40)};a.prototype.destroy=function(){this._unregisterAllListeners();c.each(this._viewObjects,
function(a){a.destroy()});this.element.remove()};a.prototype.isViewportWidgetActive=function(){return this._widgetModel.isWidgetActive()};a.prototype.layout=function(){this.hasBeenLayouted?this._debouncedLayout():this._layout()};a.prototype.getModel=function(){return this._panelModel};a.prototype._layout=function(){var a=this._widgetModel.getResolvedViewsLayoutMode(),b=this._widgetModel.getShownViewKeys();this.viewCount={total:b.length};a===d.ViewsLayoutMode.HORIZONTAL?this._layoutViewsHorizontal(b):
a===d.ViewsLayoutMode.VERTICAL?this._layoutViewsVertical(b):this._layoutViewsAutomatic(b);0<this.viewCount.total&&(this.hasBeenLayouted=!0);this.updatePanelHeader()};a.prototype._layoutViewsVertical=function(a){var b=new g.Size(this.container.width(),this.container.height()),d=a.length;this.viewCount.x=d;this.viewCount.y=1;var e=Math.ceil(b.width/d),f=Math.ceil(b.height/1),b=new g.Size(e,f);this._widgetModel.setSizeForView(b);c.each(a,function(b,c){var d=this.getView(b);d.setBorderVisibility(!1,c<
a.length-1);d.setRect(g.rectMake(e*c,0,e,f))},this)};a.prototype._layoutViewsHorizontal=function(a){var b=new g.Size(this.container.width(),this.container.height()),d=a.length;this.viewCount.x=1;this.viewCount.y=d;var e=Math.ceil(b.width/1),f=Math.ceil(b.height/d),b=new g.Size(e,f);this._widgetModel.setSizeForView(b);c.each(a,function(a,b){var c=this.getView(a);c.setBorderVisibility(!1,!1);c.setRect(g.rectMake(0,f*b,e,f))},this)};a.prototype._layoutViewsAutomatic=function(a){var b=new g.Size(this.container.width(),
this.container.height()),d=a.length,e=d,f=1;if(1<d){e=Math.floor(Math.round(Math.sqrt(d)*b.width/b.height));1>e&&(e=1);var f=Math.floor((d+e-1)/e),e=Math.floor((d+f-1)/f),q=e*f-d;if(1<e&&1<f&&0<q){var l=e+1,m=Math.floor((d+l-1)/l),s=l*m-d,t=f+1,v=Math.floor((d+t-1)/t),d=v*t-d;Math.min(s,d)<q&&(s<=d?(e=l,f=m):(e=v,f=t))}}this.viewCount.x=e;this.viewCount.y=f;var o=Math.ceil(b.width/e),w=Math.ceil(b.height/f),b=new g.Size(o,w);this._widgetModel.setSizeForView(b);c.each(a,function(a,b){var c=this.getView(a);
c.setBorderVisibility(!1,b%e<e-1);c.setRect(g.rectMake(o*Math.floor(b%e),w*Math.floor(b/e),o,w))},this)};a.prototype._repaint=function(){c.each(this._widgetModel.getShownViewKeys(),function(a){this.getView(a).repaint(this._viewportWorld)},this)};a.prototype._updateOverwriteOptions=function(){var a=this._panelModel.getOverwriteOptions();c.each(this._widgetModel.getShownViewKeys(),function(b){this.getView(b).setOverwriteOptions(a)},this)};a.prototype.updateDisabledLayers=function(a,b){var d=c.difference(a,
b);c.each(this._viewObjects,function(a){a.toggleLayers(d,!0);a.toggleLayers(b,!1)})};a.prototype.getView=function(a){return this._viewObjects[a]?this._viewObjects[a]:this._createView(a)};a.prototype._createView=function(a){var b=new e(this.f,this._viewportWorld,this._panelModel.getName()+"_"+a,this);b.setModel(this._widgetModel.getViewModel(a));b.setOverwriteOptions(this._panelModel.getOverwriteOptions());b.toggleLayers(this._panelModel.getDisabledLayers(),!1);this._viewObjects[a]=b;this.container.append(b.element);
return b};a.prototype._destroyView=function(a){this._viewObjects[a]&&(this._viewObjects[a].destroy(),delete this._viewObjects[a])};a.prototype.getViewAt=function(a){var a=a.copy(),b=this.element.offset();a.x-=b.left;a.y-=b.top;var b=this._widgetModel.getResolvedViewsLayoutMode(),c=this._widgetModel.getSizeForView();if(!(0===c.width||0===c.height)){var e=0,e=b===d.ViewsLayoutMode.HORIZONTAL?Math.floor(a.y/c.height):b===d.ViewsLayoutMode.VERTICAL?Math.floor(a.x/c.width):Math.floor(a.y/c.height)*this.viewCount.x+
Math.floor(a.x/c.width);return this._viewObjects[this._widgetModel.getIDForShownViewsAtIndex(e)]}};a.prototype.getViewIfExists=function(a){return this._viewObjects[a]};a.prototype.setBounds=function(a,b){this.element.css({left:a.x,top:a.y,width:b.width,height:b.height});this.position=a;this.layout()};a.prototype.getPosition=function(){return void 0!==this.position?this.position.copy():new g.Point};a.prototype.updatePanelHeader=function(){var a=this._panelModel.getHeaderText(),b=this._widgetModel.getShownViewKeys().length,
c=this._widgetModel.getIDForViewAtIndex(0);null!==a&&0<b?this._viewObjects[c].setTitle(a):1<b?this.f.i18n.loadBundle("viewer",function(){this._viewObjects[c].setTitle(this.f.i18n.t("CaptionComposite"))},this):1===b&&this._viewObjects[c].setTitle(null)};return a});
define("web-viewer/viewport/ViewportWidget","web-viewer/layout/AbstractWidget web-viewer/viewport/ViewportWorld utils/ShapeUtils web-viewer/viewport/tools/ToolManager web-viewer/viewport/ViewportConstants web-viewer/viewport/ViewportPanel utils/OrderedObject web-viewer/utils/ListenerUtil web-viewer/layout/LayoutConstants jquery underscore".split(" "),function(f,g,e,d,c,b,a,h,n,j,k){g=function(a,b){f.call(this,a,n.Widget.VIEWPORT);h.mixin(this,a);this._toolManager=new d(this.f,this);this._world=b;
this._widgetModel=null;this._panelObjects={};this._element=j("<div />").addClass("viewport");this.repaint=k.throttle(k.bind(function(){this._repaint()},this),40);this.layout=k.debounce(k.bind(function(){this._layout()},this),40);this._didZoomToFit=!1;this._registerListener("transformChanged",this.repaint,this,this._world);this.f.getDocumentController().whenActivePageChanged(function(a,b){a!==b&&(this._didZoomToFit=!1)},this);this.f.getDocumentController().whenDifferencePageChanged(function(a,b){a!==
b&&(this._didZoomToFit=!1)},this);this._registerListener("parameters.endUpdate",this._verifyWorld,this,this.f.getDocumentController());this._verifyWorld();this._element.mouseenter(k.bind(function(){this._widgetModel.setWidgetActive(!0)},this));this._element.mouseleave(k.bind(function(){this._widgetModel.setWidgetActive(!1)},this))};g.prototype=Object.create(f.prototype);g.prototype.constructor=g;g.widgetName=n.Widget.VIEWPORT;g.prototype.setWidgetModel=function(a){this._widgetModel&&this._unregisterAllListenersForObject(this._widgetModel);
this._widgetModel=a;this._registerListener("changed.panel.order",this.layout,this,this._widgetModel);this._registerListener("changed.panel.remove",this._destroyPanel,this,this._widgetModel);this._registerListener("changed.view.size",this._verifyWorld,this,this._widgetModel);this._registerListener("changed.layout.*",this.layout,this,this._widgetModel);this.layout();this.repaint()};g.prototype.getSize=function(){return new e.Size(this._element.innerWidth(),this._element.innerHeight())};g.prototype.requestView=
function(a){if(k.isString(a))return this.getFirstViewOccurrence(a);var b=null,b=a instanceof e.Point?a.copy():a.pageX?new e.Point(a.pageX,a.pageY):new e.Point(a.clientX,a.clientY);if(a=this.getPanelAt(b))return a.getViewAt(b)};g.prototype._verifyWorld=function(){if(!this._widgetModel)return!1;var a=this._widgetModel.getWorldBounds();if(!a)return!1;var b=!1,c=this._widgetModel.getSizeForView();c.equals(this._world.getSceneSize())||(this._world.setSceneSize(c),b=!0);var d=this._widgetModel.getWorldResolution();
void 0!==d&&this._world.setWorldResolution(d);a.rectEquals(this._world.getWorldBounds())||(this._world.setWorldBounds(a),b=!0);a=0!==this._world.getWorldSize().width&&0!==this._world.getWorldSize().height;d=0!==this._world.getSceneSize().width&&0!==this._world.getSceneSize().height;if((!this._didZoomToFit||b&&!this._world.didChangeTransformSinceLastZoomToFit())&&a&&d)this._world.zoomToFit(!1),0<c.width&&(0<c.height&&!this.f.isParameterUpdateOngoing())&&(this._didZoomToFit=!0);b&&this._world.getInitialTransformation()&&
this._world.transform(this._world.getInitialTransformation());return b};g.prototype.getWorld=function(){return this._world};g.prototype.setContext=function(a){f.prototype.setContext.call(this,a);this.context.append(this._element)};g.prototype.getWidgetType=function(){return"maincontent"};g.prototype.resized=function(){this.layout()};g.prototype.getPanel=function(a){return void 0!==this._panelObjects[a]?this._panelObjects[a]:this._createPanel(a)};g.prototype._createPanel=function(a){var c=new b(this.f,
this._widgetModel.getPanelModel(a),this._widgetModel,this._world);this._panelObjects[a]=c;this._element.append(c.element);return c};g.prototype._destroyPanel=function(a){a=a.getName();void 0!==this._panelObjects[a]&&(this._panelObjects[a].destroy(),delete this._panelObjects[a],this.layout())};g.prototype.getPanelAt=function(a){var a=a.copy(),b=this._element.offset();a.x-=b.left;a.y-=b.top;b=0;b=this._widgetModel.getResolvedPanelsLayoutMode()===c.PanelsLayoutMode.HORIZONTAL?Math.floor(a.y/(Math.ceil(this._element.height()/
this._widgetModel.getPanelCount())+c.PanelBorderWidth)):Math.floor(a.x/(Math.ceil(this._element.width()/this._widgetModel.getPanelCount())+c.PanelBorderWidth));return this._panelObjects[this._widgetModel.getPanelNameAtIndex(b)]};g.prototype._layout=function(){if(void 0!==this._widgetModel&&this._widgetModel.getWorldBounds()){var a=this._widgetModel.getPanelOrder(),b=a.length;0<b&&(this._widgetModel.getResolvedPanelsLayoutMode()===c.PanelsLayoutMode.HORIZONTAL?this._layoutPanelsHorizontal(a,b):this._layoutPanelsVertical(a,
b))}};g.prototype._layoutPanelsVertical=function(a,b){var d=new e.Size(Math.ceil((this._element.width()-(b-1)*c.PanelBorderWidth)/b),this._element.height());k.each(a,function(a,h){var f=this.getPanel(a);f.setBounds(new e.Point((d.width+c.PanelBorderWidth)*h,0),d);h<b-1&&(f.element.css("border-right-width",c.PanelBorderWidth+"px"),f.element.css("border-right-style","solid"));f.element.css("border-bottom",0)},this)};g.prototype._layoutPanelsHorizontal=function(a,b){var d=new e.Size(this._element.width(),
Math.ceil((this._element.height()-(b-1)*c.PanelBorderWidth)/b));k.each(a,function(a,h){var f=this.getPanel(a),g=new e.Point(0,(d.height+c.PanelBorderWidth)*h);f.setBounds(g,d);h<b-1&&(f.element.css("border-bottom-width",c.PanelBorderWidth+"px"),f.element.css("border-bottom-style","solid"));f.element.css("border-right",0)},this)};g.prototype._repaint=function(){this._widgetModel&&this._widgetModel.getWorldBounds()&&(this._verifyWorld(),k.each(this._widgetModel.getPanelOrder(),function(a){this.getPanel(a).repaint()},
this))};g.prototype.getFirstViewOccurrence=function(a){for(var b=this._widgetModel.getPanelOrder(),c=0;c<b.length;c++){var d=this._panelObjects[b[c]];if(d&&(d=d.getViewIfExists(a)))return d}return null};g.prototype.getElement=function(){return this._element};g.prototype.setBackgroundColor=function(a){this._element.css({"background-color":void 0===a?"":"#"+a})};return g});
define("web-viewer/core/AbstractModel",["web-viewer/core/PrivateChannel","underscore"],function(f,g){var e=function(d,c){this.f=d;this.channelName=c;f.installTo(this,this.f,this.channelName)};e.prototype._fireChange=function(d,c,b,a){if(!d){var h=!1;if(b===a)h=!1;else if(void 0!==a&&void 0!==b&&null!==a&&null!==b&&g.isFunction(a.equals)&&a.constructor===b.constructor)h=!b.equals(a);else if(g.isArray(b)&&g.isArray(a))if(b.length===a.length)for(var e=0;e<b.length&&!h;e++)b[e]!=a[e]&&(h=!0);else h=!0;
else h=b!==a;h&&(arguments[1].unshift("changed"),this._emit.apply(this,g.rest(arguments)))}};e.mixin=function(d){d._fireChange=function(c,b,a,d){e.prototype._fireChange.apply(this,c,b,a,d)}};return e});
define("web-viewer/viewport/model/ViewportPanelModel",["web-viewer/core/AbstractModel","underscore"],function(f,g){var e=function(d,c,b,a){f.call(this,d,["module","viewport","panel",c]);this._name=c;this._overwriteOptions={};void 0!==b&&(this._overwriteOptions=g.clone(b));this._disabledLayers=[];void 0!==a&&(this._disabledLayers=a.slice(0));this._headerText=null};e.prototype=Object.create(f.prototype);e.prototype.constructor=e;e.prototype.getName=function(){return this._name};e.prototype.toggleLayer=
function(d,c){var b=this._disabledLayers.slice(0);c?this._disabledLayers=g.without(this._disabledLayers,d):0>g.indexOf(this._disabledLayers,d)&&this._disabledLayers.push(d);this._fireChange(!1,["disabledLayers"],b,this._disabledLayers.slice(0))};e.prototype.isLayerEnabled=function(d){return!this.isLayerDisabled(d)};e.prototype.isLayerdisabled=function(d){return 0<=g.indexOf(this._disabledLayers,d)};e.prototype.getDisabledLayers=function(){return this._disabledLayers.slice(0)};e.prototype.getOverwriteOptions=
function(d){return d?this._overwriteOptions:g.clone(this._overwriteOptions)};e.prototype.getOverwriteOption=function(d){return this._overwriteOptions[d]};e.prototype.setOverwriteOption=function(d,c){var b=this.getOverwriteOption(d);this._overwriteOptions[d]=c;this._fireChange(!1,["overwriteOption",d],b,c)};e.prototype.setOverwriteOptions=function(d){g.each(d,function(c,b){this.setOverwriteOption(b,c)},this)};e.prototype.deleteOverwriteOption=function(d){var c=this.getOverwriteOption(d);delete this._overwriteOptions[d];
this._fireChange(!1,["overwriteOption",d],c,void 0)};e.prototype.getHeaderText=function(){return this._headerText};e.prototype.setHeaderText=function(d){var c=this._headerText;this._headerText=d;this._fireChange(!1,["headerText"],c,d)};return e});
define("web-viewer/viewport/model/ViewportWidgetModel","web-viewer/core/AbstractModel utils/ShapeUtils web-viewer/viewport/ViewportConstants utils/OrderedObject web-viewer/viewport/model/ViewportPanelModel underscore".split(" "),function(f,g,e,d,c,b){var a=function(a,b){f.call(this,a,["viewport","widget","model"]);this.id=b;this._viewportViewModels=new d;this._globalLayers={};this._viewsLayoutMode=e.ViewsLayoutMode.AUTOMATIC;this._panelsLayoutMode=e.PanelsLayoutMode.AUTOMATIC;this._sizeForView=new g.Size;
this._panels=new d;this.addPanel("default",{isDefaultView:!0});this._isActive=!1};a.prototype=Object.create(f.prototype);a.prototype.constructor=a;a.prototype.getWorldSize=function(){};a.prototype.getWorldBounds=function(){};a.prototype.getWorldResolution=function(){return{x:0,y:0}};a.prototype.setWidgetActive=function(a){this._isActive=a};a.prototype.isWidgetActive=function(){return this._isActive};a.prototype.createView=function(a,b,c){b=this.createModelForView(a,b,c);this._addView(a,b)};a.prototype._addView=
function(a,c){if(this._viewportViewModels.getItemByKey(a))throw"Trying to add view with already existing name";var d=this.getViewsOrder();this._viewportViewModels.addItem(a,c);b.each(this._globalLayers,function(b,c){this.addLayer(c,b,a)},this);this._fireChange(!1,["view","add"],void 0,c);this._fireChange(!1,["view","order"],d,this.getViewsOrder())};a.prototype.toggleView=function(a,b){if(void 0!==this._viewportViewModels.getItemByKey(a)){var c=this._viewportViewModels.getItemByKey(a).isShown();this._viewportViewModels.getItemByKey(a).setShown(b);
this._fireChange(!1,["view","toggle",a],c,b)}};a.prototype.removeView=function(a){var b=this.getViewsOrder(),a=this._viewportViewModels.removeByKey(a);this._fireChange(!1,["view","remove"],a,void 0);this._fireChange(!1,["view","order"],b,this.getViewsOrder())};a.prototype.getViewCount=function(){return this._viewportViewModels.getLength()};a.prototype.getViewModel=function(a){return this._viewportViewModels.getItemByKey(a)};a.prototype.getIDForViewAtIndex=function(a){return this._viewportViewModels.getKeyByIndex(a)};
a.prototype.getModelForViewAtIndex=function(a){return this._viewportViewModels.getItemByIndex(a)};a.prototype.getViews=function(){return this._viewportViewModels.getOrderedObjectList()};a.prototype.getShownViewKeys=function(){return b.filter(this._viewportViewModels.getKeys(),function(a){return this._viewportViewModels.getItemByKey(a).isShown()},this)};a.prototype.getIDForShownViewsAtIndex=function(a){return this.getShownViewKeys()[a]};a.prototype.createModelForView=function(){throw"Not Implemented";
};a.prototype.setViewsOrder=function(a){var c=this.getViewsOrder(),d=this._viewportViewModels.getKeys(),e=b.difference(d,a,["Main"]);0<=b.indexOf(d,"Main")&&(a=b.without(a,"Main"),a.unshift("Main"));a=a.concat(e);this._viewportViewModels.setOrder(a);this._fireChange(!1,["view","order"],c,this.getViewsOrder())};a.prototype.getViewsOrder=function(){return this._viewportViewModels.getKeys()};a.prototype.setSizeForView=function(a){var b=this._sizeForView;this._sizeForView=a;this._fireChange(!1,["view",
"size"],b,a)};a.prototype.getSizeForView=function(){return this._sizeForView};a.prototype.getViewsLayoutMode=function(){return this._viewsLayoutMode};a.prototype.setViewsLayoutMode=function(a){var b=this._viewsLayoutMode;this._viewsLayoutMode=a;this._fireChange(!1,["layout","views"],b,this._viewsLayoutMode)};a.prototype.getResolvedViewsLayoutMode=function(){return 1<this.getPanelCount()&&this._viewsLayoutMode===e.PanelsLayoutMode.AUTOMATIC?this._panelsLayoutMode===e.PanelsLayoutMode.HORIZONTAL?e.ViewsLayoutMode.VERTICAL:
e.ViewsLayoutMode.HORIZONTAL:this._viewsLayoutMode};a.prototype.getPanelsLayoutMode=function(){return this._panelsLayoutMode};a.prototype.getResolvedPanelsLayoutMode=function(){var a=this._panelsLayoutMode;a===e.PanelsLayoutMode.AUTOMATIC&&(a=this._viewsLayoutMode===e.ViewsLayoutMode.VERTICAL?e.PanelsLayoutMode.HORIZONTAL:e.PanelsLayoutMode.VERTICAL);return a};a.prototype.setPanelsLayoutMode=function(a){var b=this._panelsLayoutMode;this._panelsLayoutMode=a;this._fireChange(!1,["layout","panels"],
b,this._panelsLayoutMode)};a.prototype.addPanel=function(a,b,d){var e=this._panels.getKeys(),f=this._panels.getItemByKey(a);void 0!==f?this._panels.moveItemByKeyToEnd(a):(f=new c(this.f,a,b,d),this._panels.addItem(a,f),this._fireChange(!1,["panel","add"],void 0,f));this._fireChange(!1,["panel","order"],e,this._panels.getKeys());return f};a.prototype.getPanelModel=function(a){return this._panels.getItemByKey(a)};a.prototype.removePanel=function(a){var b=this._panels.getKeys(),a=this._panels.removeByKey(a);
this._fireChange(!1,["panel","remove"],a,void 0);this._fireChange(!1,["panel","order"],b,this._panels.getKeys())};a.prototype.setPanelOrder=function(a){var b=this._panels.getKeys();this._panels.setOrder(a);this._fireChange(!1,["panel","order"],b,this._panels.getKeys())};a.prototype.getPanelOrder=function(){return this._panels.getKeys()};a.prototype.getPanelCount=function(){return this._panels.getLength()};a.prototype.getPanelNameAtIndex=function(a){return this._panels.getKeyByIndex(a)};a.prototype.getPanelAtIndex=
function(a){return this._panels.getItemByIndex(a)};a.prototype.addLayer=function(a,c,d){void 0!==d?this._viewportViewModels.getItemByKey(d)&&this._viewportViewModels.getItemByKey(d).addLayer(a,c):(b.each(this._viewportViewModels.getItemsAsObject(),function(b){b.addLayer(a,c)}),this._globalLayers[a]=c)};a.prototype.removeLayer=function(a,c){void 0!==c?this._viewportViewModels.getItemByKey(c)&&this._viewportViewModels.getItemByKey(c).removeLayer(a):(b.each(this._viewportViewModels.getItemsAsObject(),
function(b){b.removeLayer(a)}),delete this._globalLayers[a])};a.prototype.toggleLayer=function(a,c,d){void 0!==d?this._viewportViewModels.getItemByKey(d)&&this._viewportViewModels.getItemByKey(d).toggleLayer(a):(d=this._globalLayers[a])?d.toggle(c):b.each(this._viewportViewModels.getItemsAsObject(),function(b){b.toggleLayer(a,c)})};return a});
define("web-viewer/viewport/ViewportModule","web-viewer/core/AbstractModule web-viewer/viewport/ViewportWidget web-viewer/viewport/model/ViewportWidgetModel web-viewer/viewport/ViewportWorld web-viewer/utils/ViewerUtils utils/ShapeUtils utils/StringSet jquery utils/Cache web-viewer/utils/ListenerUtil underscore".split(" "),function(f,g,e,d,c,b,a,h,n,j,k){e=function(b,c){f.call(this,b,c,"viewport");j.mixin(this,b);this._initializeImageCache();this.widgetModel=null;this._disabledAnimationSources=[];
this._ongoingImageDataLoads=0;this._pendingImageRequests=new a;this.world=new d(this.f,"viewportWidget",b.getProperty("initialZoom"));this.widget=new g(b,this.world);b.requestModule("featureDetector",function(a){a.hasCanvas()?b.debug.log("Canvas feature available"):(b.debug.log("Canvas feature NOT available"),b.i18n.loadBundle("viewer",function(){b.emit("userMessage","error",b.i18n.t("CanvasNotAvailable"),b.getProperty("javaViewerURL"))}))});this._publishWidget(g.widgetName,k.bind(function(){return this.widget},
this));this._registerListener("viewport.transform",this.transform,this);this._registerListener("viewport.toggleAnimation",this.toggleAnimations,this);this._registerListener("viewport.zoomToFit",function(a){this.zoomToFit(a.animated)},this);this._registerListener("viewport.zoomToFitWidth",function(a){this.zoomToFitWidth(a.animated)},this);this._registerListener("viewport.zoomToFitHeight",function(a){this.zoomToFitHeight(a.animated)},this);this._registerListener("viewport.zoomOneToOne",function(a){this.zoomOneToOne(a.animated,
a.worldResolution)},this);this._registerListener("viewport.fitInRect",function(a){this.fitInRect(a.rect,a.animated,a.constrain)},this);this._registerListener("viewport.repaint",function(){this.widget&&this.widget.repaint()},this);this._registerListener("viewportLayer.startImageDataRequest",function(a){this._pendingImageRequests.add(a);0===this._ongoingImageDataLoads&&this._emit("startLoadingImageData")},this);this._registerListener("viewportLayer.finishedImageDataRequest",function(a){this._pendingImageRequests.remove(a)&&
(0===this._pendingImageRequests.size()&&0===this._ongoingImageDataLoads)&&this._emit("finishedLoadingImageData")},this);this.f.getDocumentController().whenActivePageChanged(function(){this.world&&this.world.resetOrientation()},this);this.f.getDocumentController().whenActiveOrDifferenceOrCadOverlayChangedAndParametersAvailable(function(){this.world.zoomToFit(!1)},this)};e.prototype=Object.create(f.prototype);e.prototype.constructor=e;e.prototype.setWidgetModel=function(a){this.widget.setWidgetModel(a);
(this.widgetModel=a)&&this._emit("widgetModelAvailable")};e.prototype.getWidgetModel=function(){return this.widgetModel};e.prototype._initializeImageCache=function(){this._imageCache=new n(75,!0);this._imageCache.getAlternativeName=function(a){if(0<a.indexOf("dmode=7")&&0<a.indexOf("rs=")){var b=a.replace(/.*file=([^&]+).*/,"$1"),c=a.replace(/.*diff=([^&]+).*/,"$1"),d=a.replace(/.*rs=([^&]+).*/,"$1");return a.replace(/file=([^&]+)/,"file="+c).replace(/diff=([^&]+)/,"diff="+b).replace(/rs=([^&]+)/,
"rs="+("2"==d?1:2))}return null};var a=this;this._imageCache._loadItem=k.partial(function(b,c){var d=new Image,e="viewportImageCache_"+c;d.onload=k.bind(function(){this._registerItem(c,d);a._stopLoadingImageData(e)},this);d.onerror=k.bind(function(){d.error=!0;this._registerItem(c,void 0);a._stopLoadingImageData(e)},this);a._startLoadingImageData(e);d.src=c},this.f)};e.prototype._startLoadingImageData=function(a){this.f.emit("loading.start",a);0===this._ongoingImageDataLoads&&0<this._pendingImageRequests.size()&&
this._emit("startLoadingImageData");this._ongoingImageDataLoads++};e.prototype._stopLoadingImageData=function(a){this.f.emit("loading.stop",a);this._ongoingImageDataLoads--;0===this._ongoingImageDataLoads&&this._emit("finishedLoadingImageData")};e.prototype.whenFinishedLoadingImageData=function(a,b){b&&(a=k.bind(a,b));if(0===this._ongoingImageDataLoads&&0===this._pendingImageRequests.size())a();else this.once("finishedLoadingImageData",a)};e.prototype.getImageCache=function(){return this._imageCache};
e.prototype.createView=function(a,b,c){this.widgetModel&&this.widgetModel.createView(a,b,c)};e.prototype.removeView=function(a){this.widgetModel&&this.widgetModel.removeView(a)};e.prototype.getFirstViewOccurrence=function(a){if(this.widget)return this.widget.getFirstViewOccurrence(a)};e.prototype.toggleView=function(a,b){this.widgetModel&&this.widgetModel.toggleView(a,b)};e.prototype.setViewsOrder=function(a){this.widgetModel&&this.widgetModel.setViewsOrder(a)};e.prototype.setViewsLayoutMode=function(a){this.widgetModel&&
this.widgetModel.setViewsLayoutMode(a)};e.prototype.addLayer=function(a,b,c){this.widgetModel&&this.widgetModel.addLayer(a,b,c)};e.prototype.removeLayer=function(a,b){this.widgetModel&&this.widgetModel.removeLayer(a,b)};e.prototype.toggleLayer=function(a,b,c){this.widgetModel&&this.widgetModel.toggleLayer(a,b,c)};e.prototype.transform=function(a){this.world.transform(a)};e.prototype.toggleAnimations=function(a,b){b?this._disabledAnimationSources=k.without(this._disabledAnimationSources,a):this._disabledAnimationSources.push(a);
this.world.toggleAnimation(0===this._disabledAnimationSources.length)};e.prototype.zoomToFit=function(a){this.world.zoomToFit(a)};e.prototype.zoomToFitWidth=function(a){this.world.zoomToFitWidth(a)};e.prototype.zoomToFitHeight=function(a){this.world.zoomToFitHeight(a)};e.prototype.zoomOneToOne=function(a,b){this.world.zoomOneToOne(a,b)};e.prototype.getZoomPercentage=function(){return this.world.getZoomPercentage()};e.prototype.getNumberOfZoomLevels=function(){return this.world.getNumberOfZoomLevels()};
e.prototype.getMinZoom=function(){return this.world.getMinZoom()};e.prototype.getMaxZoom=function(){return this.world.getMaxZoom()};e.prototype.getResolution=function(){return this.world.getZoom()};e.prototype.getRotation=function(){return this.world.getRotation()};e.prototype.isFlip=function(){return this.world.isFlip()};e.prototype.fitInRect=function(a,b,c){this.world.fitInRect(a,b,c)};e.prototype.setPanelsLayoutMode=function(a){this.widgetModel&&this.widgetModel.setPanelsLayoutMode(a)};e.prototype.getPanelModel=
function(a){if(this.widgetModel)return this.widgetModel.getPanelModel(a)};e.prototype.addPanel=function(a,b,c){if(this.widgetModel)return this.widgetModel.addPanel(a,b,c)};e.prototype.removePanel=function(a){this.widgetModel&&this.widgetModel.removePanel(a)};e.prototype.getVisibleRect=function(){return this.world.getTargetViewPort()};e.prototype.getWorldBounds=function(){return this.world.getWorldBounds()};e.prototype.getMiddle=function(){return this.world.getMiddle()};e.prototype.getZoom=function(){return this.world.getZoom()};
e.prototype.getState=function(){return{world:{rotation:this.world.getRotation(),offsetSize:this.world.getOffsetSize(),zoom:this.world.getZoom(),isFullView:this.world.isFullView(),sceneSize:this.widget.getSize(),worldBounds:this.world.getWorldBounds(),flip:this.world.isFlip(),flipViewFromBack:this.world.isFlipViewFromBack(),visibleRect:this.world.getTargetViewPort()}}};e.prototype.setState=function(a){this.f.getDocumentController().whenActivePageChangedAndParametersAvailable(k.bind(function(){this.f.whenModuleAvailable("viewport",
function(){if(void 0!==a){var c=a.world;void 0!==c&&(this.world.setWorldBounds(c.worldBounds),this.world.setInitialTransformation({fixedrotation:c.rotation,fixedoffset:c.offsetSize,fixedzoom:c.zoom,flip:c.flip,flipViewFromBack:c.flipViewFromBack}),this.world.setSceneSize(new b.Size(c.visibleRect.size.width,c.visibleRect.size.height)))}},this)},this))};e.prototype.getWorld=function(){return this.world};e.prototype.setWidgetBackgroundColor=function(a){this.widget.setBackgroundColor(a)};e.prototype.whenWidgetModelAvailable=
function(a,b){b&&(a=k.bind(a,b));if(this.widgetModel)a();else this.once("widgetModelAvailable",a)};return e});
define("web-viewer/core/ViewerModeManager",["web-viewer/core/PrivateChannel","underscore"],function(f){var g=function(e){this.f=e;f.installTo(this,e,"viewerModeManager");this._activeMode=null};g.prototype.startMode=function(e){e!=this._activeMode&&(this.stopActiveMode(),this._activeMode=e,this._activeMode.toggle(!0),this._emit("start",e))};g.prototype.stopMode=function(e){this._activeMode===e?this.stopActiveMode():this.f.debug.warn("Stopping a mode which isn't the active mode")};g.prototype.stopActiveMode=
function(){if(this._activeMode){var e=this._activeMode;this._activeMode.toggle(!1);this._activeMode=null;this._emit("stop",e)}};g.prototype.getActiveMode=function(){return this._activeMode};return g});
define("web-viewer/compare/CompareConstants",[],function(){return{diffMode:{UNDEFINED:-1,CURRENTVERSION:0,DIFFVERSION:1,SHOWBOTHCHANGES:2,SHOWBOTHCHANGESHIGHLIGHT:3,SHOWBOTHCHANGESONLY:4,SHOWBOTHSIDEBYSIDE:5,RECTOVERSOATSIDE:6,SHOWBOTHONTOP:7,RECTOVERSOATTOP:8,READERSPREAD:9,BLINKING_CURRENT:10,SHOWBOTHSIDEBYSIDEHIGHLIGHT:11,SHOWBOTHSIDEBYSIDECHANGESONLY:12},blinkingSpeed:1E3,mode:{SHOW_CURRENT:"showCurrent",SHOW_DIFFERENCE:"showDifference",BLINKING:"blinking",DIFFERENCE:"difference",SIDEBYSIDE:"sidebyside",
READERSPREAD:"readerspread",ALIGNMENT:"alignment",SHOWBOTHONTOP:"showBothOnTop"},modeNameToLanguageKey:{showCurrent:"DiffCurrentTT",showDifference:"DiffPrevTT",blinking:"DiffBothBlinkingTT",difference:"compareDifferenceMode",sidebyside:"DiffBothSplitTT",showBothOnTop:"DiffShowBothOnTopTT",alignment:"AnchorAlignWizardTitle",readerspread:"ReaderSpreadModeTitle"},sideBySideToDiffMode:{5:2,11:3,12:4},colorSpace:{DEFAULT:0,CHANNELS:1,HSV:2,AUTOMATIC:3},channelsMode:{AUTO:0},showDifferenceMode:{SHOW:2,
HIGHLIGHT:3,ONLY:4},diffModeToMode:{UNDEFINED:"SHOW_CURRENT",CURRENTVERSION:"SHOW_CURRENT",DIFFVERSION:"SHOW_DIFFERENCE",SHOWBOTHCHANGES:"DIFFERENCE",SHOWBOTHCHANGESHIGHLIGHT:"DIFFERENCE",SHOWBOTHCHANGESONLY:"DIFFERENCE",SHOWBOTHSIDEBYSIDE:"SIDEBYSIDE",RECTOVERSOATSIDE:null,SHOWBOTHONTOP:"SHOWBOTHONTOP",RECTOVERSOATTOP:null,READERSPREAD:"READERSPREAD",BLINKING_CURRENT:"BLINKING",SHOWBOTHSIDEBYSIDEHIGHLIGHT:"SIDEBYSIDE",SHOWBOTHSIDEBYSIDECHANGESONLY:"SIDEBYSIDE"},cornerAutoAlign:{TOPLEFT:0,TOPCENTER:1,
TOPRIGHT:2,CENTERLEFT:3,CENTERED:4,CENTERRIGHT:5,BOTTOMLEFT:6,BOTTOMCENTER:7,BOTTOMRIGHT:8},cornerAlignIcons:{"0":"icon-WCR_Align-TopLeft",1:"icon-WCR_Align-TopCenter",2:"icon-WCR_Align-TopRight",3:"icon-WCR_Align-MiddleLeft",4:"icon-WCR_Align-MiddleCenter",5:"icon-WCR_Align-MiddleRight",6:"icon-WCR_Align-BottomLeft",7:"icon-WCR_Align-BottomCenter",8:"icon-WCR_Align-BottomRight"},referenceRotation:{NOTROTATED:0,ROTATED90:90,ROTATED180:180,ROTATED270:270},pagelistCompareRange:{CURRENT:0,CURRENTANDFOLLOWING:1,
ALL:2},pagelistSide:{LEFTPAGE:1,RIGHTPAGE:2},anchorAlignment:{DEFAULT:"/wcr-static/web-viewer/layout/img/crosshair.png",ACTIVE:"/wcr-static/web-viewer/layout/img/crosshair_active.png",SIZE:{width:14,height:14},OFFSET:{width:7,height:7}}}});
define("web-viewer/utils/Coordinates",["web-viewer/utils/ViewerUtils","web-viewer/compare/CompareConstants"],function(f,g){var e=function(d){this.f=d;this._compareModule=this._viewportModule=this._cadModule=null};e.prototype.getTransformedPoint=function(d){if(d){var c=this.f.getDocumentController(),b=c.getActivePage(),a=c.getDifferencePage(),c=c.getCadOverlay();if(b.hasCad()||c)if(this._cadModule||(this._cadModule=this.f.getModule("cad")),this._viewportModule||(this._viewportModule=this.f.getModule("viewport")),
this._cadModule&&this._viewportModule)if(b.hasCad()){this._compareModule||(this._compareModule=this.f.getModule("compare"));if(this._compareModule&&(c=this._compareModule.getDiffMode(),a&&(a.hasCad()&&a.getCad())&&c===g.diffMode.DIFFVERSION&&(c=this._cadModule.getReferenceTransform())&&a.getCad()))return d=c.createInverse().transformedPoint(d),d.y-=a.getCad().getSize().height,d.y=-d.y,d;if((a=this._cadModule.getCurrentPageCadModel())&&a.getCad()&&b.getCad())a=a.getCad().getOrigin(),d=d.copy(),d.x+=
a.x,d.y-=a.y,d.y-=b.getCad().getSize().height,d.y=-d.y}else if((b=this._cadModule.getOverlayTransform())&&c.getCad())d=b.createInverse().transformedPoint(d),d.y-=c.getCad().getSize().height,d.y=-d.y}return d};e.prototype._calculateTransformedPoint=function(){};return e});
define("web-viewer/viewport/model/ViewportPopoverModel",["underscore","web-viewer/core/PrivateChannel","web-viewer/utils/Coordinates"],function(f,g,e){return function(d,c){g.installTo(this,d,["popoverModel",c]);this.f=d;this._coordinates=new e(this.f);this.getID=function(){return c};this.getFrame=function(){return null};this.getContent=function(){return null};this.onAddedToContainer=function(){};this.onDestroy=function(){};this.getPreferredPosition=function(){return"left"};this.getRestrictBorder=
function(){};this.getContext=function(){return d.getContext()};this.getClass=function(){};this.isInteractive=function(){return!1}}});
define("web-viewer/viewport/model/ViewportLayerModel","underscore web-viewer/core/AbstractModel utils/Transformation utils/ShapeUtils web-viewer/core/PrivateChannel web-viewer/viewport/model/ViewportPopoverModel".split(" "),function(f,g,e,d){var c=function(b,a){g.call(this,b,["layerModel",a]);this.f=b;this._name=a;this.transform=new e;this.popoverModels={};this.popupModels={};this.fragmentUrlOverwriteOptions={};this._visible=!0;this._popovers={}};c.prototype=Object.create(g.prototype);c.prototype.constructor=
c;c.prototype.getName=function(){return this._name};c.prototype.savePopover=function(b,a){this._popovers[a]=b};c.prototype.getPopover=function(b){return this._popovers[b]};c.prototype.getAllPopovers=function(){return this._popovers};c.prototype.removePopover=function(b){delete this._popovers[b]};c.prototype.addPopoverModel=function(b){this.popoverModels[b.getID()]||(this.popoverModels[b.getID()]=b,this._emit("popoverAdded",b.getID()))};c.prototype.removePopoverModel=function(b){delete this.popoverModels[b];
this._emit("popoverRemoved",b)};c.prototype.getPopoverModel=function(b){return this.popoverModels[b]};c.prototype.addPopupModel=function(b){this.popupModels[b.getId()]=b};c.prototype.removePopupModel=function(b){this.popupModels[b].onDestroy();delete this.popupModels[b]};c.prototype.removeAllPopupModels=function(){f.each(this.popupModels,function(b){this.removePopupModel(b.getId())},this)};c.prototype.getPopupModel=function(b){return this.popupModels[b]};c.prototype.getPopupModels=function(){return this.popupModels};
c.prototype.getLinework=function(){return[]};c.prototype.getBackgroundOptions=function(){return{}};c.prototype.getTransform=function(){return this.transform};c.prototype.getRotation=function(){return 0};c.prototype.isFlipped=function(){return!1};c.prototype.resetTransformation=function(){this.transform=new e};c.prototype.getMaximumResolution=function(){return-1};c.prototype.modelChanged=function(){this._emit("modelChanged")};c.prototype.preloadFragment=function(){};c.prototype.getContextForFragment=
function(b){b={rectangle:b.getRect(),resolution:b.getZoom(),servlet:"",params:{x1:0,x2:0,y1:0,y2:0}};this.f.emit("intercept.fragmentURL",b);b.params=f.extend(b.params,this.fragmentUrlOverwriteOptions);return b};c.prototype.getLineworkColor=function(){return null};c.prototype.getAlpha=function(){};c.prototype.setOverwriteOption=function(b,a){var c=this.fragmentUrlOverwriteOptions[b];this.fragmentUrlOverwriteOptions[b]=a;this._fireChange(!1,["overwriteOption",b],c,a)};c.prototype.setOverwriteOptions=
function(b){var a=this.fragmentUrlOverwriteOptions.slice(0);this.fragmentUrlOverwriteOptions=b;this._fireChange(!1,["overwriteOption"],a,b.slice(0))};c.prototype.getOverwriteOptions=function(){return this.fragmentUrlOverwriteOptions};c.prototype.removeOverwriteOption=function(b){var a=this.fragmentUrlOverwriteOptions[b];delete this.fragmentUrlOverwriteOptions[b];this._fireChange(!1,["overwriteOption",b],a,void 0)};c.prototype.destroy=function(){};c.prototype.shouldAutoFetchFragments=function(){return!1};
c.prototype.hasGraphics=function(){return!1};c.prototype.hasLinework=function(){return!1};c.prototype.hasBuffer=function(){return!1};c.prototype.getBuffer=function(){return null};c.prototype._markAllAsDirty=function(){this._emit("fragmentsDirty")};c.prototype._cleanupFragments=function(){this._emit("cleanupFragments")};c.prototype.toggle=function(b){var a=this._visible;this._visible=b;this._fireChange(!1,["visible"],a,b)};c.prototype.isVisible=function(){return this._visible};c.prototype.render=function(){};
c.prototype.calculateTransformation=function(b,a,c,e,f,g,i,q,l){void 0!==b&&(void 0!==b.size&&void 0!==a)&&(this.offset=c,this.getTransform().rotate(-e*(Math.PI/180),b.size.width/2,-b.size.height/2),f&&(this.getTransform().translate(b.size.width/2,-b.size.height/2),this.getTransform().flip(0,0)),90===e%180&&f?(this.getTransform().translate(b.size.width/2,-b.size.height/2),this.getTransform().translate(-this.offset.width,-this.offset.height)):(f&&this.getTransform().translate(-b.size.width/2,b.size.height/
2),this.getTransform().translate(this.offset.width,this.offset.height)),b=new d.Size(b.size.width/2-this.getTransform().e,b.size.height/2-this.getTransform().f),this.getTransform().translate(-b.width,-b.height),this.getTransform().preTranslate(b.width,b.height),i&&(l&&this.getTransform().preTranslate(-l.x,-l.y),this.getTransform().preFlip(0,0),l&&this.getTransform().preTranslate(l.x,l.y)),g&&(q?this.getTransform().preRotate(g*(Math.PI/180),q.x,q.y):this.getTransform().preRotate(g*(Math.PI/180),0,
0)))};return c});
define("web-viewer/viewport/model/ViewportViewModel",["utils/Transformation","web-viewer/core/PrivateChannel","underscore","web-viewer/viewport/model/ViewportLayerModel"],function(f,g,e){var d=function(c,b,a,d){g.installTo(this,c,["viewport","viewmodel",b]);this._layers={};this._title=a;this._IID=b;this._shown=!0;this._isDefaultView=d;this._transform=new f};d.prototype.getLayers=function(){return this._layers};d.prototype.addLayer=function(c,b){this._layers[c]=b;this._emit("layerAdded",c)};d.prototype.removeLayer=
function(c){delete this._layers[c];this._emit("layerRemoved",c)};d.prototype.getLayer=function(c){return this._layers[c]};d.prototype.numberOfLayers=function(){return e.keys(this._layers).length};d.prototype.nameForLayerAtIndex=function(c){return e.keys(this._layers)[c]};d.prototype.modelForLayer=function(c){return this._layers[c]};d.prototype.modelForLayerAtIndex=function(c){return this._layers[this.nameForLayerAtIndex(c)]};d.prototype.transformLayer=function(c,b){var a=this._layers[c];a&&a.getTransform().transform(b)};
d.prototype.getID=function(){return this._IID};d.prototype.indexForLayer=function(c){return e.indexOf(e.keys(this._layers),c)};d.prototype.getTransform=function(){return this._transform};d.prototype.setTitle=function(c){this._title!==c&&(this._title=c,this._emit("titleChanged"))};d.prototype.getTitle=function(){return this._title};d.prototype.setShown=function(c){this._shown!==c&&(this._shown=c,this._emit("showChanged"))};d.prototype.isShown=function(){return this._shown};d.prototype.toggleLayer=
function(c,b){var a=this.getLayer(c);void 0!==a&&a.toggle(b)};d.prototype.isDefaultView=function(){return this._isDefaultView};return d});
define("web-viewer/webviewer/WebviewerViewModel",["web-viewer/viewport/model/ViewportViewModel","underscore"],function(f,g){var e=function(d,c,b,a){f.call(this,d,c,b,a);var e="Graphics Cad currentDiffCad referenceDiffCad referenceCad CadOverlay DynContent DynContentPopup Annotations AnnotationPopups".split(" ");this.indexForLayer=function(a,b){var c=g.keys(b);c.push(a);c=g.intersection(e,c);return g.indexOf(c,a)}};e.prototype=Object.create(f.prototype);return e.prototype.constructor=e});
define("web-viewer/webviewer/WebviewerWidgetModel","underscore web-viewer/webviewer/WebviewerViewModel web-viewer/viewport/model/ViewportWidgetModel utils/ShapeUtils web-viewer/utils/ViewerUtils web-viewer/utils/ConversionConstants".split(" "),function(f,g,e,d,c,b){f=function(a){e.call(this,a,"webviewer");this.f=a};f.prototype=Object.create(e.prototype);f.prototype.constructor=f;f.prototype.createModelForView=function(a,b,c){return new g(this.f,a,b,c)};f.prototype.getWorldBounds=function(){var a=
this.f.getActivePage(),b=this.f.getDocumentController().getDifferencePage(),e=this.f.getDocumentController().getCadOverlay();if(void 0!==a&&void 0!==b&&a.hasCad()&&b.hasCad()){if(this.f.getModule("cad")){var e=a.getOrigin(!0),f=b.getOrigin(!0),g=a.getPageSize(),a=b.getPageSize();if(null!==e&&null!==f)return b.getCad()&&b.getCad().getLocation()?(f=b.getCad().getLocation().origin,a=b.getCad().getLocation().size):f=new d.Point(f.x-e.x,e.y+g.height-(f.y+a.height)),b=new d.Rect(null,g),f=new d.Rect(f,
a),b.calculateArea(f)}}else{if(a&&a.hasCad())return new d.Rect(a.getOrigin(),a.getPageSize());if(a){f=new d.Rect(a.getOrigin(),new d.Size(c.parseFloat(a.getParam("sizex")),c.parseFloat(a.getParam("sizey"))));if(a.isBlankPage()&&(!b||b.isBlankPage()))b=a.getMargins(),f.size.height+=b.top+b.bottom,f.size.width+=b.left+b.right,a.isReaderSpread()&&(f.size.width*=2);return e&&e.getCad&&e.getCad()?(e.getCad()&&e.getCad().getLocation()?b=e.getCad().getLocation():(b=e.getCad().getOrigin(),a=new d.Size(c.parseFloat(e.get("offsetx")),
c.parseFloat(e.get("offsety"))),e=e.getPageSize(),b=new d.Rect(new d.Point(-a.width+b.x,a.height-(e.height+b.y)),e)),f=new d.Rect(new d.Point,f.size),b.calculateArea(f)):f}}};f.prototype.getWorldResolution=function(){var a={x:0,y:0},d=this.f.getActivePage();if(void 0!==d&&d.isParametersAvailable()){var e=d.getParam("resolutionx"),d=d.getParam("resolutiony");a.x=void 0!==e?c.parseFloat(e):b.DEFAULT_POSTSCRIPT_PPI;a.y=void 0!==d?c.parseFloat(d):b.DEFAULT_POSTSCRIPT_PPI;return a}};return f});
define("web-viewer/webviewer/WebviewerModule",["web-viewer/core/AbstractModule","web-viewer/webviewer/WebviewerWidgetModel"],function(f,g){var e=function(d,c){f.call(this,d,c,"webviewer");this.webviewerWidgetModel=new g(d);d.getModule("viewport").setWidgetModel(this.webviewerWidgetModel);var b=this.f.getDocumentController();this._pageChanged(void 0,this.f.getActivePage());this._pageChanged(void 0,b.getCadOverlay());b.whenActivePageChanged(this._pageChanged,this);b.whenCadOverlayChanged(this._pageChanged,
this)};e.prototype=Object.create(f.prototype);e.prototype.constructor=e;e.prototype._pageChanged=function(d,c){var b=this.webviewerWidgetModel.getViewModel("Main");(void 0===b||null===b)&&this.webviewerWidgetModel.createView("Main","",!0);c&&((c.hasCad()||c.hasLinkedPage())&&this.f.requestModule("cad",void 0,!1),(c.hasGraphics()||c.isBlankPage())&&this.f.requestModule("graphics",void 0,!1),this.f.getProperty("allowAttributeCategory")&&(!this.f.isMobile()&&c.getAttributeCategoryID&&c.getAttributeCategoryID())&&
this.f.requestModule("attributeCategory",void 0,!1),c.get("has3DPerspective")&&this.f.requestModule("view3D",void 0,!1),c.whenParametersAvailable(_.bind(function(){(c.hasGraphics()||c.isBlankPage())&&c.getDocumentVersion().isMultiPage()&&this.f.requestModule("pagelist",void 0,!1)},this)))};return e});
define("web-viewer/core/AbstractDebug",[],function(){var f=function(f){f.on("error.SEVERE",function(){"undefined"!=typeof console&&(console.error?console.error.apply?console.error.apply(console,arguments):console.error("ERROR",arguments):console.log&&console.log.apply?console.log.apply(console,arguments):console.log&&console.log("ERROR",arguments))})};f.prototype.log=function(){};f.prototype.warn=function(){};f.prototype.error=function(){};f.prototype.debug=function(){};return f});
define("web-viewer/core/DevDebug",["web-viewer/core/AbstractDebug","jquery","underscore"],function(f){var g=function(e){f.call(this,e);window.gViewerDebug=window.gViewerDebug||[];window.gViewerDebug.push(this)};g.prototype=Object.create(f.prototype);return g.prototype.constructor=g});
define("web-viewer/core/Core","lib/EventEmitter2 web-viewer/core/ViewerFacade web-viewer/data/DocumentController web-viewer/data/AbstractDocument web-viewer/data/AbstractDocumentVersion component/loadingindicator/LoadingIndicator web-viewer/layout/LayoutManager web-viewer/featureDetector/FeatureDetectorModule web-viewer/message/MessageModule web-viewer/viewport/ViewportModule web-viewer/layout/component/ViewerToolbarButton web-viewer/layout/component/ModalPopup web-viewer/layout/LayoutConstants web-viewer/core/ViewerModeManager utils/I18n utils/XMLUtils utils/ConvertUtils jquery web-viewer/webviewer/WebviewerModule web-viewer/core/DevDebug underscore".split(" "),function(f,
g,e,d,c,b,a,h,n,j,k,i,q,l,m,s,t,v,o,w,p){return function(c,d){function u(a,b){var c="loadSourceFile_"+a;E.emit("loading.start",c);requirejs(["web-viewer/"+a],function(a){b&&b(a);E.emit("loading.stop",c)},function(d){B.emit("error.SEVERE","Failed loading source "+a,d);b&&b(null);E.emit("loading.stop",c)})}function x(a,b,c){E.emit(["module",b,"startInitialization"]);a=new a(B,c);G[b]=a;E.emit(["module","loaded",b],a);return a}function A(a,b,c){c=c||!1;if(G.hasOwnProperty(a)){var d=G[a];c||d.setSilenced(!1);
b&&b(d)}else I.hasOwnProperty(a)?(K.hasOwnProperty(a)&&!c&&delete K[a],b&&I[a].push(b)):(I[a]=[],c&&(K[a]=1),b&&I[a].push(b),E.emit(["module","loading",a]),u(a+"/"+t.capitaliseFirstLetter(a)+"Module",function(b){var c=null;b?(c=K.hasOwnProperty(a),c=x(b,a,c)):E.emit("error.SEVERE","Failed to load module "+a);for(var b=I[a],d=0;d<b.length;d++)b[d](c);delete I[a];delete K[a]}))}function y(){var a="";p.each(G,function(b){b.hasUnsavedElements()&&(a+="\r\n"+b.getUnsavedElementsName())});if(0<a.length)return B.i18n.t("ExitViewer")+
a}var F=v("<div>").css({background:"url('"+requirejs.toUrl("web-viewer/layout/img/loaderTransparent.gif")+"') no-repeat 2px center","padding-left":"20px",font:"normal 11px/20px Verdana,Arial,Helvetica,sans-serif",margin:"20px",height:"20px"}).text("Loading...");c.empty().append(F);var E=new f({wildcard:!0,delimiter:".",newListener:!0});E.setMaxListeners(0);var C={getProperty:function(a){return d.get(a)},getConfig:function(){return d},getAppContext:function(){return c}},J,L,H;v.ajaxSetup({beforeSend:function(a,
b){a._viewerLoadKey=b.url;E.emit("loading.start",b.url)},complete:function(a){E.emit("loading.stop",a._viewerLoadKey)},timeout:6E4});var D=new w(E);D.log("CORE","Debugger activated",D);D.log("CORE","Initializing ViewerFacade",D);var B=new g(C,E,D);B.on("loading.start",function(a){b.start(a)});B.on("loading.stop",function(a){b.stop(a)});D.log("CORE","Initializing viewerModeManager");var M=new l(B),N=!1;C.stopMode=function(a){return M.stopMode(a)};C.startMode=function(a){return M.startMode(a)};C.stopActiveMode=
function(){return M.stopActiveMode()};C.getActiveMode=function(){return M.getActiveMode()};C.canFetchFragments=function(){return!H.isParameterUpdateOngoing()&&!N};E.on("core.loadSourceFile",u);var G={},I={},K={};C.requestModule=function(){};C.ajax=function(a,b){b=p.extend({dataType:"xml",success:function(){},error:function(){},cache:!1,processData:!0,contentType:"application/x-www-form-urlencoded; charset=UTF-8",type:"GET",data:"",noAjaxParam:!1},b);b.noAjaxParam||(a=0>a.indexOf("?")?a+"?ajax=1":
a+"&ajax=1");return v.ajax(a,{dataType:b.dataType,success:function(a,c,d){if(a&&"xml"===b.dataType){var e=a.getElementsByTagName("code");if(e[0]&&"001"===s.textContent(e[0])){B.i18n.loadBundle("viewer",function(){B.emit("error.SEVERE",B.i18n.t("WCSessionLostError"),a)});return}}b.success(a,c,d)},error:function(a,c,d){b.error(a,c,d)},cache:b.cache,processData:b.processData,contentType:b.contentType,type:b.type,data:b.data,timeout:b.timeout})};C.whenAllModulesAreLoaded=function(a){B.once("allModulesAreLoaded",
a)};C.getModuleIfAvailable=function(a){return G[a]};C.whenModuleAvailable=function(a,b,c){void 0!==c&&(b=p.bind(b,c));c=G[a];if(void 0!==c)b(c);else E.once(["module","loaded",a],b)};C.getLoadedModules=function(){return G};C.injectState=function(a){C.whenAllModulesAreLoaded(p.bind(function(){if(void 0!==a.compare){var b=G.compare;void 0!==b&&b.setState(a.compare);delete a.compare}b=a.measure;delete a.measure;p.each(a,p.bind(function(a,b){void 0!==a&&C.whenModuleAvailable(b,function(b){b.setState(a)},
this)},this));if(void 0!==b){var c=G.measure;void 0!==c&&c.setState(b)}},this))};C.getState=function(){var a=this.getLoadedModules(),b={};p.each(a,function(a,c){b[c]=a.getState()});return b};D.debug("CORE","Initializing Message module");n||window.alert("Couldn't load Message module.");var O=x(n,"message",!0);D.debug("CORE","Initializing user object");J=d.getUser();J.setFacade(B);C.getCurrentUser=function(){return J};D.debug("CORE","Initializing DataAdapter");L=d.intializeAdapter(B);C.getDataAdapter=
function(){return L};D.debug("CORE","Initializing I18N");B.i18n=new m(J.getLocale(),L.getInstance(),d.get("languageLoadTimestamp"));B.i18n.loadBundle("viewer",function(){D.debug("I18N","General language bundle loaded");F.text(B.i18n.t("Loading"))});D.debug("CORE","Initializing DocumentController");H=new e(B,L);C.getDocumentController=function(){return H};C.openDocuments=function(a){H.openDocuments(a)};B.i18n.loadBundle("viewer",function(){v(window).on("beforeunload",y)});B.on("viewer.request.close",
function(a,b,c){var d={};p.each(G,function(a,b){a.hasUnsavedElements()&&(d[b]=a)});var b=b?b:"SaveAndExit",c=c?c:"ExitWithoutSave",e=function(){window.location===a?window.location.reload():window.location=a};p.isEmpty(d)?e():B.i18n.loadBundle("viewer",function(){var a=new i(B,"unsavedItemsPopup",B.getContext());a.setRemoveFromDomAfterUsage(!0);a.setOkBtnText(B.i18n.t(b));var h=new k(B,"exit",v("<span/>").text(B.i18n.t(c)),!1,function(){v(window).off("beforeunload",y);e()});a.addButton(h);a.setOkAction(function(){p.isEmpty(d)||
(a.enableOkBtn(!1),p.each(d,function(a,b){a.saveAllUnsavedElements(function(){delete d[b];p.isEmpty(d)&&(v(window).off("beforeunload",y),e())})}))});a.setHeader(v("<span/>").addClass("popupTitle").html(B.i18n.t("UnsavedItems")));a.setContent(v("<div/>").addClass("unsavedItemsContent").append(B.i18n.t("UnsavedItemsContent")));a.show();a.recalculateSize(400)})});D.debug("CORE","Core is now listening to module requests");C.requestModule=A;J.loadOptions(function(){D.debug("CORE","Initializing Feature detector module");
var e=x(h,"featureDetector",!0);C.getFeatureDetector=function(){return e};D.debug("CORE","Detecting layout type");var f=J.getOption("LAYOUT_PREFERENCE"),f=f===q.LayoutType.MOBILE&&e.hasTouch()||f===q.LayoutType.AUTOMATIC&&e.isMobile()?q.LayoutType.MOBILE:C.getProperty("viewerStyle")==q.ViewerStyle.SIMPLIFIED?q.LayoutType.FLEX:q.LayoutType.DESKTOP;C.getLayoutType=function(){return f};var g=p.after(2,function(){C.whenModuleAvailable("viewport",function(a){a.whenWidgetModelAvailable(function(){A("compare",
function(){N=!1;a.widget.repaint()},!1)})})});D.debug("CORE","Start loading viewport module");j||E.emit("error.SEVERE","Couldn't load viewport module!");var m=x(j,"viewport",!0);D.debug("CORE","Start loading webviewer module, this intializes the viewport widget with the correct widgetmodel");var v=x(o,"webviewer",!0);H.whenDocumentsLoaded(function(){if(1<H.getDocumentCount()||p.some(H.getDocuments(),function(a){return a.hasLinkedDocument()||a.hasMultipleVersions()||a.getDocumentVersion().isMultiPage()||
a.getDocumentVersion().isPageList()}))N=!0,A("compare",function(){N=!1},!0),g()});D.debug("CORE","Initializing LayoutManager");var i=new a(B,c,b,F,p.bind(function(){D.debug("CORE","Initialized LayoutManager",i);C.switchLayout=function(a){i.switchLayout(a)};O&&O.setSilenced(!1);D.debug("CORE","Unsilence Viewport and WebViewer module");m.setSilenced(!1);v.setSilenced(!1);g();D.debug("CORE","Start loading other modules");var a=d.getModules(),b=p.after(a.length,function(){B.emit("allModulesAreLoaded")});
p.each(a,function(a){A(a,b)})},this))});return B}});define("web-viewer/App",["web-viewer/core/Core"],function(f){var g=function(e,d,c){this._f=new f(e,c);this._f.openDocuments(d)};g.prototype.injectState=function(e){this._f.injectState(e)};return g});
define("web-viewer/annotation/AnnotationConstants",{AccessRight:{READ_ONLY:0,READ_WRITE:1},ActionPermissions:{DUPLICATE_WITHOUT_TEXT:"duplicateWithoutText",DUPLICATE:"duplicateAnnotation",CAN_BE_REPLIED_TO:"canBeRepliedTo"},AnnotationType:{ANNOT_RECT:0,ANNOT_ELLIPSE:4,ANNOT_HIGHLIGHT:6,ANNOT_LINE:1,ANNOT_ARROW:5,ANNOT_PIN:11,ANNOT_FREEFORM:3},AnnotationPin:{normal:"/wcr-static/web-viewer/layout/img/comment-raw.gif",highlighted:"/wcr-static/web-viewer/layout/img/commentselected-raw.gif",imagehotspotx:0,
imagehotspoty:0,imagetouchspotx:0,imagetouchspoty:0,imagetouchspotw:26,imagetouchspoth:24,imagewidth:26,imageheight:24},AnnotationElementName:{"0":"square",4:"circle",6:"highlight",1:"line",5:"line",11:"text",3:"ink"},AnnotationReplyName:{"0":"Rectangle",4:"Oval",6:"Highlight",1:"Line",5:"Arrow",11:"Note",3:"Freehand"},AnnotationReviewState:{STATUS_ACCEPTED:"Accepted",STATUS_REJECTED:"Rejected",STATUS_CANCELLED:"Cancelled",STATUS_COMPLETED:"Completed",STATUS_NONE:"None"},AnnotationReviewStateIcons:{STATUS_ACCEPTED:"icon-WCR_Approve",
STATUS_REJECTED:"icon-WCR_Reject",STATUS_CANCELLED:"icon-WCR_Canceled",STATUS_COMPLETED:"icon-WCR_Approve WCR_Completed",STATUS_NONE:"None"},AnnotationReviewStateLocs:{STATUS_ACCEPTED:"AnnStatusAccepted",STATUS_REJECTED:"AnnStatusRejected",STATUS_CANCELLED:"AnnStatusCancelled",STATUS_COMPLETED:"AnnStatusCompleted",STATUS_NONE:"AnnStatusNone"},AnnotationSortType:{SORT_BY_MODIFICATION_DATE:0,SORT_BY_CREATION_DATE:1},StepThroughMode:{WITH_REPLIES:0,BY_THREAD:1,WITH_ZOOM:2,WITH_LINKED:3},AnnotationViewType:{VIEWTYPE_ALL:0,
VIEWTYPE_ONLYFILE:1,VIEWTYPE_ONLYDIFF:2,VIEWTYPE_NONE:3},AnnotationComments:{"0":"AnnCommRect",4:"AnnCommOval",6:"AnnCommHighlight",1:"AnnCommLine",5:"AnnCommArrow",11:"AnnCommNote",3:"AnnCommFreehand"},AnnotationIcons:{"0":"annotRect",4:"annotOval",6:"annotHighlight",1:"annotLine",5:"annotArrow",11:"annotNote",3:"annotFreehand"},AnnotationToolIcons:{"0":{icon:"icon-WCR_Annotation-Rect icon-danger"},4:{icon:"icon-WCR_Annotation-Oval icon-danger"},6:{icon:"icon icon-WCR_Annotation-Highlight-cont",
sub:["icon icon-WCR_Annotation-Highlight-sub icon-yellow"]},1:{icon:"icon-WCR_Annotation-Line icon-danger"},5:{icon:"icon-WCR_Annotation-Arrow icon-danger"},11:{icon:"addNote"},3:{icon:"icon-WCR_Annotation-Freehand icon-danger"}},annotateMode:{NO_RESTRICTIONS:0,IF_APPROVED_SHOW_WARNING:1,IF_APPROVED_DISABLE:2,ALWAYS_DISABLE:3,IF_APPROVED_OR_REJECTED_SHOW_WARNING:4,IF_APPROVED_OR_REJECTED_DISABLE:5},allowedAnnotators:{ALL:0,ALL_APPROVERS:1,ALL_APPROVERS_AND_MASTER:2,PENDING_APPROVERS:3,PENDING_APPROVERS_AND_MASTER:4},
FilterOperators:{ALL:0,ANY:1},FilterTypes:{AUTHOR:0,REVIEWSTATE:1,REVIEWAUTHORANDSTATE:2,TYPE:3},FilterTypeNameLocs:{AUTHOR:"AnnotFilterAuthor",REVIEWSTATE:"AnnotFilterReviewState",REVIEWAUTHORANDSTATE:"AnnotFilterReviewAuthorAndState"},FilterCondition:{IS:0,ISNOT:1},AnnotationOriginTypes:{user:{id:"user",icon:"icon-WCR_AutoReview-cont icon-red",subIcon:"icon-WCR_User12 icon-default",langKey:"userAnnotations",group:"user"},barcode:{id:"barcode",icon:"icon-WCR_AutoReview-cont icon-red",subIcon:"icon-WCR_AutoReview-Barcode-sub icon-default",
langKey:"barcodeGVAnnotations",group:"GV",hideBtnOnGroupEmpty:!0},braille:{id:"braille",icon:"icon-WCR_AutoReview-cont icon-red",subIcon:"icon-WCR_AutoReview-Braille-sub icon-default",langKey:"brailleGVAnnotations",group:"GV",hideBtnOnGroupEmpty:!0},spelling:{id:"spelling",icon:"icon-WCR_AutoReview-cont icon-red",subIcon:"icon-WCR_AutoReview-Spell-sub icon-default",langKey:"spellingGVAnnotations",group:"GV",hideBtnOnGroupEmpty:!0},artwork:{id:"artwork",icon:"icon-WCR_AutoReview-cont icon-red",subIcon:"icon-WCR_AutoReview-Artwork-sub icon-default",
langKey:"artworkGVAnnotations",group:"GV",hideBtnOnGroupEmpty:!0},text:{id:"text",icon:"icon-WCR_AutoReview-cont icon-red",subIcon:"icon-WCR_AutoReview-Text-sub icon-default",langKey:"textGVAnnotations",group:"GV",hideBtnOnGroupEmpty:!0},editor:{id:"editor",icon:"icon-WCR_AutoReview-cont icon-red",subIcon:"icon-WCR_AutoReview-Esko-sub icon-default",langKey:"editorAnnotations",hideBtnOnEmpty:!0,group:"ext"},acrobat:{id:"acrobat",icon:"icon-WCR_AutoReview-cont icon-red",subIcon:"icon-WCR_AutoReview-Acrobat-sub icon-default",
langKey:"acrobatAnnotations",hideBtnOnEmpty:!0,group:"ext"},ext:{id:"ext",icon:"icon-WCR_AutoReview-cont icon-red",subIcon:"icon-WCR_AutoReview-External-sub icon-default",langKey:"extAnnotations",hideBtnOnEmpty:!0,group:"ext"}}});
define("web-viewer/approval/ApprovalConstants",{ViewerStateToComplexApprovalState:{"00001_0000000001":"Rejected","00001_0000000002":"Pending","00001_0000000003":"Approved","00001_0000000004":"ForceRejected","00001_0000000005":"ForceApproved","00001_0000000006":"ApprovedConditional","00001_0000000007":"ForceApprovedConditional"},ComplexApprovalStateToViewerState:{Rejected:"00001_0000000001",Pending:"00001_0000000002",MustApprove:"00001_0000000002",Approved:"00001_0000000003",ForceRejected:"00001_0000000004",
ForceApproved:"00001_0000000005",ApprovedConditional:"00001_0000000006",ForceApprovedConditional:"00001_0000000007"}});
define("web-viewer/cad/CadConstants",{CadLayerLocName:{MAIN:"LayerMain",SHEET:"LayerSheet",L1:"LayerL1",DIE:"LayerDie",STRIP:"LayerStrip",FSTRIP:"LayerFStrip",MSTRIP:"LayerMStrip",GUILL:"LayerGuill",VARNISH:"LayerVarnish",FINGERS:"LayerFingers",BLANK:"LayerBlank",USER1:"LayerUser1",USER2:"LayerUser2",USER3:"LayerUser3",USERDEFINED:"LayerUser",RULEPATH:"LayerRulepath"},CadClassName:{"0":"ClassMain",1:"ClassManufacturing",2:"ClassCutouts",3:"ClassDimensions",4:"ClassOverall",5:"ClassAnnotation",6:"ClassRegistration",
7:"ClassBleed",8:"ClassGraphics",9:"ClassCounter",10:"ClassCoating1",11:"ClassDiagram",12:"ClassOutsideGraphics",13:"ClassOutputLayer",14:"ClassCoating2",15:"ClassCoating3",16:"ClassInsideBleed",17:"ClassInsideGraphics",18:"ClassInsideCoating",19:"ClassCross",20:"ClassLabelGraphics",21:"ClassShrinkWrapGraphics"},CadDocType:{OneUp:1,Layout:2},CadTypes:{Nick:-11},ShowBridgesNicks:{NONE:1,BRIDGES:2,NICKS:3,BOTH:4},LineTypes:{1:[6,6],2:[6,3,3,3],3:[3,3],10:[11,3,3,3,3,3],20:[11,11],30:[16,1],40:[14,3],
50:[14,7],60:[11,3,3,3,3,3,3,3]},CadGraphicsMode:{BOTH:1,GRAPHICS_ONLY:2,CAD_ONLY:3},DefaultSide:{OUTSIDE:"-1",INSIDE:"1"},GrainFluteDirection:{VERTICAL:"1",HORIZONTAL:"2"},DieSide:{BACKSIDE:"1",KNIFESIDE:"-1"}});define("web-viewer/data/DataConstants",{documentPageType:{CAD:0,GRAPHICS:1,PAGELIST:2},imageType:{OTHER:0,GRAPHICS:1},charsequencePreferences:["LAYOUT_STATE","LAYOUT_PREFERENCE","ANNOTATION_FILTER"]});
define("web-viewer/data/AbstractDataAdapter",["web-viewer/core/PrivateChannel"],function(f){var g=function(e,d){this.f=e;this._instance=d;f.installTo(this,e,["doc"])};g.prototype.openDocuments=function(){};g.prototype.getInstance=function(){return this._instance};g.prototype.loadDocument=function(){};g.prototype.loadDocuments=function(){};g.prototype.getDeepCopy=function(){};g.prototype.loadVersionsOfDocumentPage=function(){};g.prototype.updateDocumentParameters=function(){};g.prototype.updateDocumentData=
function(){};g.prototype.cancelDocumentParametersUpdate=function(){};g.prototype.saveCadOverlay=function(){};g.prototype.show3DView=function(){};return g});
define("web-viewer/data/AbstractDocumentPage",["web-viewer/core/Extendable","web-viewer/core/PrivateChannel","web-viewer/data/DataConstants","underscore","utils/ShapeUtils"],function(f,g,e,d,c){f=function(b,a,c){this.f=b;var d=["doc",a.getDocument().getIID()];d.push("version",a.getVersionId());d.push("page",c);g.installTo(this,b,d);this._data={};this._parameters=null;this._state={};this._hasAnnotations=!1;this._docVersion=a;this._pagenum=parseInt(c,10);this._isReaderSpread=!1;this._linkedComparePage=
null;this._isParametersAvailable=this._isBlankPage=!1};f.prototype.get=function(b){if(void 0!==this._data[b])return this._data[b]};f.prototype.set=function(b,a){var c=this._data[b];this._data[b]=a;c!=a&&this._emit(["property",b,"changed"],c,a)};f.prototype.reset=function(b){delete this._data[b]};f.prototype.getData=function(){return d.clone(this._data)};f.prototype.getDocumentVersion=function(){return this._docVersion};f.prototype.getPagenum=function(){return this._pagenum};f.prototype.getDocument=
function(){return this._docVersion.getDocument()};f.prototype.getParam=function(b){if(null!==this._parameters&&void 0!==this._parameters[b])return this._parameters[b]};f.prototype.hasParam=function(b){return null!==this._parameters&&void 0!==this._parameters[b]};f.prototype.getParams=function(){return d.clone(this._parameters)};f.prototype.setParam=function(b,a){this._parameters[b]=a;this._emit("parameters.changed",this)};f.prototype.resetParam=function(b){delete this._parameters[b];this._emit("parameters.changed",
this)};f.prototype.rotatePage=function(b){this.setRotation(this.getRotation()+b)};f.prototype.setRotation=function(b){this.setStateParam("rotation",b%360)};f.prototype.flipPage=function(b){void 0===b&&(b=!this.getStateParam("flipped"));this.setStateParam("flipped",b)};f.prototype.getRotation=function(){var b=this.getStateParam("rotation");return b?1*b:0};f.prototype.isFlipped=function(){return void 0===this.getStateParam("flipped")?!1:this.getStateParam("flipped")&&!0};f.prototype.getOrigin=function(){return new c.Point};
f.prototype.getPageSize=function(){return new c.Size};f.prototype.getOriginalSize=function(){return new c.Size};f.prototype.getImageType=function(){return null!==this._parameters?parseInt(this._parameters.imagetype,10):-1};f.prototype.getImageURL=function(){this.f.emit("error.SEVERE","No getImageURL implementation is provided");return"UNDEFINED"};f.prototype.getInfoURL=function(){this.f.emit("error.SEVERE","No getInfoURL implementation is provided");return"UNDEFINED"};f.prototype.getMargins=function(){};
f.prototype.hasGraphics=function(){return void 0!==this._data.file};f.prototype.hasAnnotations=function(b){return b&&this._hasAnnotationsByOrigin?this._hasAnnotationsByOrigin[b]:this._hasAnnotations};f.prototype.hasCad=function(){return this._data.cad?!0:!1};f.prototype.hasLinkedPage=function(){return this.getDocument().hasLinkedDocument()};f.prototype.getLinkedPage=function(){return this.getDocument().getLinkedDocumentPage()};f.prototype.getUniqueID=function(){return this._docVersion.getDocument().getIID()+
"_"+this._docVersion.getVersionId()+"_"+this._pagenum};f.prototype.isParametersAvailable=function(){return null!==this._parameters&&this._isParametersAvailable};f.prototype.whenParametersAvailable=function(b,a){a&&(b=d.bind(b,a));if(this.isParametersAvailable())b(this);else this.once("parameters.available",d.bind(function(){b(this)},this))};f.prototype.setParameters=function(b){this._parameters=b;this._emit("parameters.changed",this)};f.prototype.resetParameters=function(){this._parameters=null};
f.prototype.interceptFragmentURL=function(){};f.prototype.setHasAnnotations=function(b,a){b!==this._hasAnnotations&&(this._hasAnnotations=b,this._emit("hasAnnotations.changed",this));this._hasAnnotationsByOrigin=a};f.prototype.equals=function(b){return b&&this.getUniqueID()==b.getUniqueID()&&this._docVersion==b._docVersion&&this._hasAnnotations==b._hasAnnotations&&d.every(this._data,function(a,c){return a==b._data[c]})?!0:!1};f.prototype.setParametersAvailable=function(b){(this._isParametersAvailable=
b)&&this._emit("parameters.available")};f.prototype.setCadDataAvailable=function(){this._emit("cadData.available")};f.prototype.setReaderSpread=function(b){this._isReaderSpread=b};f.prototype.isReaderSpread=function(){return this._isReaderSpread};f.prototype.getNextPage=function(b,a){var c=this.getDocumentVersion();void 0===b&&(b=1);for(var d=Math.min(this.getPagenum()+b,c.getPageCount()),e=c.getPage(d);(void 0===e||a&&e.isBlankPage())&&++d<=c.getPageCount();)e=c.getPage(d);return e};f.prototype.getPreviousPage=
function(b,a){var c=this.getDocumentVersion();void 0===b&&(b=1);for(var d=Math.max(this.getPagenum()-b,1),e=c.getPage(d);(void 0===e||a&&e.isBlankPage())&&1<=--d;)e=c.getPage(d);return e};f.prototype.getLinkedComparePage=function(){return this._linkedComparePage};f.prototype.setLinkedComparePage=function(b){this._linkedComparePage=b};f.prototype.resetLinkedComparePage=function(){this._linkedComparePage=null};f.prototype.hasLinkedComparePage=function(){return null!==this._linkedComparePage};f.prototype.isRectOnPage=
function(){};f.prototype.getPageVersionId=function(){return null};f.prototype.isBlankPage=function(){return this._isBlankPage};f.prototype.isDigitalFilmPage=function(){return!1};f.prototype.setStateParam=function(b,a){this._state[b]=a;this._emit("stateParameter.changed",this,b)};f.prototype.hasStateParam=function(b){return void 0!==this._state[b]};f.prototype.getStateParam=function(b){return this._state[b]};f.prototype.resetStateParam=function(b){delete this._state[b]};f.prototype.resetState=function(){this._state=
{}};f.prototype.getThumbnailUrl=function(){return null};f.prototype.getInformationForDocumentSelector=function(){return null};f.prototype.canSaveCadOverlay=function(){return!1};f.prototype.needsDataUpdate=function(){return!1};return f});
define("web-viewer/data/PreferencesConstants",{PREFERENCES_UNIT_SIZE:1,PREFERENCES_UNIT_RESOLUTION:2,PREFERENCES_VIEW_ZOOM_MODE:3,PREFERENCES_ANNOTATION_NEXT_MODE:4,PREFERENCES_CHANNELS_SINGESEPBLACK:5,PREFERENCES_FILEOPEN_RECENTPATH:6,PREFERENCES_FILEOPEN_FILTER:7,PREFERENCES_IMAGE_BACKGROUNDCOLOR:8,PREFERENCES_WINDOW_BACKGROUNDCOLOR:9,PREFERENCES_UNIT_SCREEN:10,PREFERENCES_UNIT_ANGLE:11,PREFERENCES_DISPLAY_MARGINS:12,PREFERENCES_MERGEFILES:13,PREFERENCES_HELPBLOCKERWARNING:14,PREFERENCES_DIFFMODE:15,
PREFERENCES_RULER_DISPLAY_MODE:16,PREFERENCES_RULER_DISPLAY_COLOR:17,PREFERENCES_UPDATE_PALETTE:18,PREFERENCES_ENABLE_BACKGROUNDCOLOR:19,PREFERENCES_SCREEN_ORIENTATION:20,PREFERENCES_DIFFMODE_COMPARE:21,PREFERENCES_DOCUMENTHISTORYDIALOG_DETAILSMODE:22,PREFERENCES_DOCUMENTHISTORYDIALOG_DOCKED:23,PREFERENCES_DOCUMENTSELECTDIALOG_DOCKED:24,PREFERENCES_RULER_ANGLE_MODE:25,PREFERENCES_RECTOVERSO_MODE:26,PREFERENCES_CHANNELNAME_MODE:27,PREFERENCES_COLORMATCHING:28,PREFERENCES_COLORMATCHING_PROMPT:29,PREFERENCES_DOCUMENTHISTORYDIALOG_REOPEN:30,
PREFERENCES_DOCUMENTSELECTDIALOG_REOPEN:31,PREFERENCES_PAGELISTDIALOG_REOPEN:32,PREFERENCES_PAGELISTDIALOG_DOCKED:33,PREFERENCES_PAGELIST_ICON_SIZE:34,PREFERENCES_READOUTDIALOG_SCREEN_VISIBLE:35,PREFERENCES_READOUTDIALOG_DOT_VISIBLE:36,PREFERENCES_SHOWBRIDGES_MODE:37,PREFERENCES_ANNOTATION_NOTE_COLOR:38,PREFERENCES_ANNOTATION_RECTANGLE_COLOR:39,PREFERENCES_DOCUMENTANNOTATIONDIALOG_REOPEN:40,PREFERENCES_DOCUMENTANNOTATIONDIALOG_DOCKED:41,PREFERENCES_ANNOTATION_FITVIEW:42,PREFERENCES_ANNOTATION_SHOWSELECTEDONLY:43,
PREFERENCES_ZOOMTOOLS_VISIBLE:44,PREFERENCES_TOOLSPANEL_VISIBLE:45,PREFERENCES_MARGIN_CLIP_MODE:46,PREFERENCES_MARGIN_DISPLAY_MODE:47,PREFERENCES_PANELMAINTOOLS_SKOWMASK:48,PREFERENCES_TOOLSPANELTOP_VISIBLE:49,PREFERENCES_ANNOTATION_SHOWCOUNT:50,PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY:51,PREFERENCES_ANNOTATIONTOOLS_VISIBLE:52,PREFERENCES_ANNOTATION_TOOLMODE:53,PREFERENCES_ANNOTATION_DATESORT_MODE:54,PREFERENCES_READOUTDIALOG_BARCODE_VISIBLE:55,PREFERENCES_DIFF_SPLITMODE:56,PREFERENCES_INKBOOKPATH:57,
PREFERENCES_READOUTDIALOG_BRAILLE_VISIBLE:58,PREFERENCES_VIEWX_PARAMETERS:59,PREFERENCES_VIEWXTOOLS_VISIBLE:60,PREFERENCES_BRAILLE_LANGUAGE:61,PREFERENCES_MERGE_SIMILAR_INKS:62,PREFERENCES_VIEWXTOOLS_ENABLE1BIT:63,PREFERENCES_ANTIALIASING:64,PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE:65,PREFERENCES_PILOT_SELECTSERVER:66,PREFERENCES_PILOT_SERVERNAME:67,PREFERENCES_RULER_DISPLAY_MODE_DA:68,PREFERENCES_RULER_DISPLAY_MODE_XY:69,PREFERENCES_RULER_DISPLAY_MODE_WH:70,PREFERENCES_CALIPER_DISPLAY_MODE:71,PREFERENCE_MONITOR_RES:72,
PREFERENCES_ZOOM_REALSIZE:73,PREFERENCES_PRINT_SPLITVIEW:78,PREFERENCES_PRINT_MAGNIFICATION:79,PREFERENCES_PRINT_MARG_TOP:80,PREFERENCES_PRINT_MARG_LEFT:81,PREFERENCES_PRINT_MARG_BOTTOM:82,PREFERENCES_PRINT_MARG_RIGHT:83,PREFERENCES_PRINT_ORIENTATION:84,PREFERENCES_PRINT_TYPE:85,PREFERENCES_PRINT_AREA:86,PREFERENCES_PRINT_CHANNELS:87,PREFERENCES_PRINT_RESOLUTION:88,PREFERENCES_PRINT_SCALETOFIT:89,PREFERENCES_HIGHLIGHTCOLORS:90,PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD:91,PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB:92,
PREFERENCES_HIGHLIGHTCOLORS_SEAMLESS_GUIDELINES:93,PREFERENCES_HIGHLIGHTCOLORS_MARGINS:94,PREFERENCES_HIGHLIGHTCOLORS_MARGINS_DIFF:95,LAYOUT_EXPAND_PAGETOOLS_STATE:100,LAYOUT_EXPAND_CHANNELS_STATE:101,LAYOUT_EXPAND_NAVIGATOR_STATE:102,LAYOUT_WINDOW_SIZE_X:103,LAYOUT_WINDOW_SIZE_Y:104,LAYOUT_MODE:105,LAYOUT_MAIN_PANEL_RIGHT_SPLITTER:106,LAYOUT_EXPAND_ANNOTATIONS_STATE:107,LAYOUT_EXPAND_APPROVAL_STATE:108,LAYOUT_NAVIGATOR_SIZE_X:109,LAYOUT_NAVIGATOR_SIZE_Y:110,LAYOUT_EXPAND_CAD_STATE:111,LAYOUT_LAYERSTABLE_SIZE:112,
LAYOUT_CLASSESTABLE_SIZE:113,LAYOUT_FRAME_SIZE_X:114,LAYOUT_FRAME_SIZE_Y:115,LAYOUT_FRAME_MAXIMIZED:116,LAYOUT_EXPAND_PAGEVIEW_STATE:117,LAYOUT_EXPAND_INFO_STATE:118,LAYOUT_LOOK_AND_FEEL:119,LAYOUT_CHANNELEDITDIALOG_WIDTH:120,LAYOUT_DOCUMENTSELECTDIALOG_WIDTH:121,LAYOUT_DOCUMENTSELECTDIALOG_HEIGHT:122,LAYOUT_DOCUMENTHISTORYDIALOG_WIDTH:123,LAYOUT_DOCUMENTHISTORYDIALOG_HEIGHT:124,LAYOUT_MAIN_PANEL_LEFT_SPLITTER:125,LAYOUT_EXPAND_DIFFADJUST:126,LAYOUT_PAGELISTDIALOG_WIDTH:127,LAYOUT_PAGELISTDIALOG_HEIGHT:128,
LAYOUT_DOCUMENTANNOTATIONDIALOG_WIDTH:129,LAYOUT_DOCUMENTANNOTATIONDIALOG_HEIGHT:130,MRU_COUNT:200,MRU_ENTRY1:201,PML_ENTRY1:301,PML_MAXENTRY:399,CONFIG_ISGRAPHOLAS:400,CONFIG_GRAPHOLASHOME:401,CONFIG_SHOWDIFFADJUST:402,CONFIG_COLORMATCHING:403,CONFIG_TOOLTIP_INITIAL:404,CONFIG_TOOLTIP_RESHOW:405,CONFIG_TOOLTIP_DISMISS:406,CONFIG_DIFF_PERCENTAGE:407,CONFIG_DIFF_COMPAREMODE:408,CONFIG_GRAPHOLAS_CENTERLINE:409,CONFIG_GRAPHOLAS_MICROCROSS:410,LAYOUT_STATE:1E3,LAYOUT_PREFERENCE:1010,CALIPER_PRESETS:1100,
PREFERENCES_UNIT_EYEDROPPER:1200,PREFERENCES_UNIT_SCREENRULING:1201,ANNOTATION_FILTER:1300,PREFERENCES_DIFFMODE_THRESHOLD:1400,PREFERENCES_DYNCONTENTTOOLS_VISIBLE:1500});
define("web-viewer/data/PreferencesDefaults",{PREFERENCES_ANNOTATION_NEXT_MODE:1,PREFERENCES_UNIT_RESOLUTION:2,PREFERENCES_READOUTDIALOG_DOT_VISIBLE:1,PREFERENCES_DISPLAY_MARGINS:0,LAYOUT_EXPAND_PAGEVIEW_STATE:1,PREFERENCES_ANNOTATIONTOOLS_VISIBLE:1,PREFERENCES_DYNCONTENTTOOLS_VISIBLE:1,PREFERENCES_DOCUMENTSELECTDIALOG_DOCKED:1,PREFERENCES_READOUTDIALOG_SCREEN_VISIBLE:1,PREFERENCES_MERGE_SIMILAR_INKS:-1,PREFERENCES_ANNOTATION_FITVIEW:1,PREFERENCES_PANELMAINTOOLS_SKOWMASK:127,PREFERENCES_DOCUMENTANNOTATIONDIALOG_REOPEN:1,
LAYOUT_EXPAND_CHANNELS_STATE:1,PREFERENCES_ZOOMTOOLS_VISIBLE:0,PREFERENCES_MERGEFILES:1,LAYOUT_MODE:1,PREFERENCES_CHANNELNAME_MODE:0,PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE:0,LAYOUT_NAVIGATOR_SIZE_Y:128,PREFERENCES_ANNOTATION_RECTANGLE_COLOR:-65536,PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD:-16776961,PREFERENCES_HIGHLIGHTCOLORS_MARGINS:-16744193,PREFERENCES_MARGIN_CLIP_MODE:1,PREFERENCES_DOCUMENTHISTORYDIALOG_DOCKED:1,PREFERENCES_ANNOTATION_SHOWSELECTEDONLY:1,LAYOUT_NAVIGATOR_SIZE_X:128,LAYOUT_MAIN_PANEL_RIGHT_SPLITTER:203,
PREFERENCES_WINDOW_BACKGROUNDCOLOR:5592405,PREFERENCES_ANTIALIASING:-1,PREFERENCES_MARGIN_DISPLAY_MODE:0,PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB:-65536,PREFERENCES_HIGHLIGHTCOLORS:-1,PREFERENCES_ANNOTATION_DATESORT_MODE:0,PREFERENCES_DOCUMENTSELECTDIALOG_REOPEN:0,PREFERENCES_DIFFMODE:1,PREFERENCES_DIFFMODE_COMPARE:2,PREFERENCES_PAGELISTDIALOG_DOCKED:1,PREFERENCES_RULER_DISPLAY_MODE:1,LAYOUT_EXPAND_NAVIGATOR_STATE:1,LAYOUT_MAIN_PANEL_LEFT_SPLITTER:209,PREFERENCES_TOOLSPANEL_VISIBLE:0,PREFERENCES_VIEW_ZOOM_MODE:0,
PREFERENCES_IMAGE_BACKGROUNDCOLOR:-1,LAYOUT_EXPAND_DIFFADJUST:0,MRU_COUNT:0,PREFERENCES_ANNOTATION_SHOWCOUNT:0,PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY:1,LAYOUT_CLASSESTABLE_SIZE:83,LAYOUT_EXPAND_PAGETOOLS_STATE:1,PREFERENCES_UNIT_ANGLE:0,LAYOUT_EXPAND_APPROVAL_STATE:1,LAYOUT_EXPAND_INFO_STATE:1,CONFIG_SHOWDIFFADJUST:0,PREFERENCES_RULER_DISPLAY_COLOR:-13022894,PREFERENCES_HIGHLIGHTCOLORS_SEAMLESS_GUIDELINES:-16711936,PREFERENCES_VIEWXTOOLS_ENABLE1BIT:0,PREFERENCES_PAGELISTDIALOG_REOPEN:0,LAYOUT_LOOK_AND_FEEL:0,
PREFERENCES_ANNOTATION_NOTE_COLOR:-256,PREFERENCES_UNIT_SCREEN:2,PREFERENCES_VIEWX_PARAMETERS:"",PREFERENCES_DIFF_SPLITMODE:4,PREFERENCES_DOCUMENTHISTORYDIALOG_REOPEN:0,CONFIG_DIFF_COMPAREMODE:0,PREFERENCES_SHOWBRIDGES_MODE:2,LAYOUT_EXPAND_CAD_STATE:1,PREFERENCES_TOOLSPANELTOP_VISIBLE:1,PREFERENCES_READOUTDIALOG_BRAILLE_VISIBLE:1,LAYOUT_LAYERSTABLE_SIZE:83,PREFERENCES_COLORMATCHING:2,PREFERENCES_READOUTDIALOG_BARCODE_VISIBLE:1,PREFERENCES_ANNOTATION_TOOLMODE:0,PREFERENCES_VIEWXTOOLS_VISIBLE:0,LAYOUT_EXPAND_ANNOTATIONS_STATE:1,
PREFERENCES_CHANNELS_SINGESEPBLACK:0,PREFERENCES_HIGHLIGHTCOLORS_MARGINS_DIFF:-32768,PREFERENCES_DOCUMENTANNOTATIONDIALOG_DOCKED:1,PREFERENCES_BRAILLE_LANGUAGE:0,PREFERENCES_RULER_DISPLAY_MODE_DA:1,PREFERENCES_RULER_DISPLAY_MODE_XY:0,PREFERENCES_RULER_DISPLAY_MODE_WH:0,PREFERENCE_MONITOR_RES:72/25.4+"",PREFERENCES_ZOOM_REALSIZE:0,PREFERENCES_PRINT_TYPE:0,PREFERENCES_PRINT_AREA:0,PREFERENCES_PRINT_CHANNELS:0,PREFERENCES_PRINT_RESOLUTION:150/25.4+"",PREFERENCES_PAGELIST_ICON_SIZE:1,LAYOUT_STATE:"",
LAYOUT_PREFERENCE:"automatic",PREFERENCES_UNIT_EYEDROPPER:5,PREFERENCES_SCREEN_ORIENTATION:1,ANNOTATION_FILTER:"",PREFERENCES_DIFFMODE_THRESHOLD:0});
define("web-viewer/data/User",["underscore","web-viewer/core/Extendable","web-viewer/core/PrivateChannel","web-viewer/utils/ViewerUtils","web-viewer/data/PreferencesDefaults"],function(f,g,e,d,c){var b=function(a,b,c,d,k){this.f=null;this.persistDebounced=f.debounce(f.bind(this._persistUserOptions,this),1E3);g.installTo(this);this._options={};this._originalNonPersistedValues={};this.getID=function(){return a};this.getUsername=function(){return b};this.lastname=d;this.first=c;void 0===k&&(k="en");
this.locale=k;this.setFacade=f.once(function(b){this.f=b;e.installTo(this,this.f,["user",a])})};b.prototype.getFullName=function(){return this.getUsername()};b.prototype.getLastName=function(){return this.lastname};b.prototype.getFirstName=function(){return this.first};b.prototype.getLocale=function(){return this.locale};b.prototype.setOption=function(a,b,c,d){var e=this._options[a];e!==b?(this._options[a]=b,this._emit("options.changed."+a,e,b),c?void 0===this._originalNonPersistedValues[a]&&(this._originalNonPersistedValues[a]=
e):(delete this._originalNonPersistedValues[a],d?this._persistUserOptions(d):this.persistDebounced())):d&&d(!0)};b.prototype.setOptions=function(a){f.each(a,function(a,b){this.setOption(b,a)},this)};b.prototype.initializeOption=function(a,b){var c=this._options[a];c!==b&&(this._options[a]=b,this._emit("options.changed."+a,c,b))};b.prototype.initializeOptions=function(a){f.each(a,function(a,b){this.initializeOption(b,a)},this)};b.prototype.getOptions=function(){return this._options};b.prototype.getOption=
function(a){return this._options[a]};b.prototype.getColor=function(a){return"#"+d.hexFromInt(this.getOption(a))};b.prototype.setColor=function(a,b){-1<b.indexOf("#")&&(b=b.replace("#",""));this.setOption(a,d.intFromHex(b))};b.prototype.persistOptions=function(){};b.prototype.loadOptions=function(){};b.prototype.resetOption=function(a){this.setOption(a,c[a])};b.prototype.getOptionDefault=function(a){return c[a]};b.prototype._persistUserOptions=function(a){var b=f.clone(this._options);f.each(this._originalNonPersistedValues,
function(a,c){b[c]=a});this.persistOptions(b,a)};return b});define("web-viewer/data/DataModule","web-viewer/data/AbstractDataAdapter web-viewer/data/AbstractDocument web-viewer/data/AbstractDocumentPage web-viewer/data/AbstractDocumentVersion web-viewer/data/DataConstants web-viewer/data/DocumentController web-viewer/data/PreferencesConstants web-viewer/data/PreferencesDefaults web-viewer/data/User".split(" "),function(){});
define("web-viewer/graphics/GraphicsConstants",{ChannelViewMode:{COMPOSITE_VIEW:0,AUTOMATIC_TILING:1,HORIZONTAL_TILING:2,VERTICAL_TILING:3},ChannelDiffMode:{CURRENT:0,PREVIOUS:1,IN_CURRENT_AND_MATCHED_WITH_PREVIOUS:2,IN_PREVIOUS_AND_MATCHED_WITH_CURRENT:3},ChannelViewModeLayoutMode:{COMPOSITE_VIEW:"AUTOMATIC",AUTOMATIC_TILING:"AUTOMATIC",HORIZONTAL_TILING:"HORIZONTAL",VERTICAL_TILING:"VERTICAL"},SingleChannelMode:{IN_CHANNEL_COLOR:0,IN_BLACK:1,IN_BLACK_WITH_SHOW_ALL_EFFECT:2},ResetToDefaultMode:{RESET_ORDER:0,
RESET_COLORS:1,RESET_BOTH:2},ChannelMatching:{IDENTICAL_MATCHING:0,NAME_MATCHING:1,SMART_NAME_MATCHING:2}});
define("web-viewer/layout/component/ColorPicker",["web-viewer/utils/ViewerUtils","component/tooltip/Tooltip","underscore","jquery","colorpicker"],function(f,g,e,d){var c=function(b,a){this._onColorPicked=b;this._colorBlock=this._color=void 0;this.element=this._colorBlock=void 0===a?d("<div />").addClass("colorblock"):a;this._lazyOnChange=e.debounce(e.bind(this._onChange,this),50);this.element.ColorPicker({onChange:this._lazyOnChange,onBeforeShow:e.bind(function(){d(this).ColorPickerSetColor(this._color)},
this),onSubmit:function(a,b,c,e){d(e).ColorPickerHide()}})};c.prototype._onChange=function(b,a){this._color=a.toUpperCase();this._updateColor();this._onColorPicked(this._color)};c.prototype._updateColor=function(){this._colorBlock.hasClass("colorblock")&&this._colorBlock.css("background-color","#"+this._color)};c.prototype.setColor=function(b){f.startsWith(b,"#")&&(b=b.substring(1));this._color!=b&&(this._color=b,this._updateColor())};c.prototype.getColor=function(){return this._color};c.prototype.show=
function(){this.element.ColorPickerShow()};c.prototype.hide=function(){this.element.ColorPickerHide()};c.prototype.destroy=function(){this.element.ColorPickerHide();d("#"+this.element.data("colorpickerId")).detach()};c.prototype.setTooltip=function(b,a,c,d){void 0===this.tooltip?this.tooltip=new g(b.i18n,this._colorBlock,b.getContext(),b.getContext(),b.isMobile(),a,c,d):this.tooltip.setTooltipContent(a,c,d)};return c});
define("web-viewer/layout/component/DropdownMiniButton",["web-viewer/layout/component/MiniButton","component/dropdownmenu/DropdownMenu","jquery","underscore"],function(f,g,e,d){e=function(c,b,a,e,n){f.call(this,c,b,a,!1,this.toggle);this.element.addClass("dropdown-mini-button");this.dropdown=new g(this.f.i18n,this.f.getContext(),this.f.isMobile(),"bottom","wcr-dropdown",void 0,e);this._dropdownEnabled=!0;this.leftClickAction=n;if(void 0===this.leftClickAction)this.leftClickAction=d.bind(function(){this.isEnabled()&&
this._dropdownEnabled&&(this.dropdown.isActive()?this.dropdown.hide():this.showDropdown())},this);else this.element.on("contextmenu",d.bind(function(a){a.preventDefault();a.stopPropagation();this.hideTooltip();this.isEnabled()&&this._dropdownEnabled&&this.showDropdown()},this));this.setAction(this.leftClickAction)};e.prototype=Object.create(f.prototype);e.prototype.constructor=e;e.prototype.isOpen=function(){return this.dropdown.isActive()};e.prototype.show=function(){this.element.css("display","inline-block")};
e.prototype.toggleButton=function(c){c?this.show():(this.dropdown.hide(),this.hide())};e.prototype.setActionText=function(c,b){this.dropdown.setActionText(c,b)};e.prototype.toggleOption=function(c,b){this.dropdown.toggleOption(c,b)};e.prototype.getOptionValue=function(c){return this.dropdown.getOptionValue(c)};e.prototype.setActionEnabled=function(c,b){this.dropdown.setActionEnabled(c,b)};e.prototype.isActionEnabled=function(c){return this.dropdown.isActionEnabled(c)};e.prototype.setWarning=function(){this.badge.addClass("warning");
this.setBadge("!")};e.prototype.removeWarning=function(){this.badge.removeClass("warning");this.setBadge("")};e.prototype.addAction=function(c){this.dropdown.addAction(c)};e.prototype.addOption=function(c){this.dropdown.addOption(c)};e.prototype.addDivider=function(){this.dropdown.addDivider()};e.prototype.addHeader=function(c){this.dropdown.addHeader(c)};e.prototype.clear=function(){this.dropdown.clear()};e.prototype.enableDropdown=function(){this._dropdownEnabled=!0};e.prototype.disableDropdown=
function(){this.dropdown.hide();this._dropdownEnabled=!1};e.prototype.showDropdown=function(){this.dropdown.show(this.element)};e.prototype.toggleElementVisibility=function(c,b){b?this.dropdown.showElement(c):this.dropdown.hideElement(c)};return e});
define("web-viewer/layout/component/SubtoolbarButton",["web-viewer/layout/component/ViewerToolbarButton","jquery"],function(f){var g=function(e,d,c,b,a){f.call(this,e,d,c,b,a);this.element.removeClass("btn").addClass("subtoolbar-btn")};g.prototype=Object.create(f.prototype);return g.prototype.constructor=g});
define("web-viewer/layout/component/DropdownSubtoolbarButton",["web-viewer/layout/component/SubtoolbarButton","component/dropdownmenu/DropdownMenu","jquery","underscore"],function(f,g){var e=function(d,c,b,a){f.call(this,d,c,b,a,this.toggle);this.dropdown=new g(this.f.i18n,this.f.getContext(),this.f.isMobile(),"bottom","wcr-dropdown")};e.prototype=Object.create(f.prototype);e.prototype.constructor=e;e.prototype.toggle=function(){this.isOpen()?this.hide():this.show()};e.prototype.isOpen=function(){return this.dropdown.isActive()};
e.prototype.show=function(){this.dropdown.show(this.element)};e.prototype.hide=function(){this.dropdown.hide()};e.prototype.setActionText=function(d,c){this.dropdown.setActionText(d,c)};e.prototype.toggleOption=function(d,c){this.dropdown.toggleOption(d,c)};e.prototype.getOptionValue=function(d){return this.dropdown.getOptionValue(d)};e.prototype.setActionEnabled=function(d,c){this.dropdown.setActionEnabled(d,c)};e.prototype.isActionEnabled=function(d){return this.dropdown.isActionEnabled(d)};e.prototype.addAction=
function(d){this.dropdown.addAction(d)};e.prototype.addOption=function(d){this.dropdown.addOption(d)};e.prototype.addDivider=function(){this.dropdown.addDivider()};return e});
define("web-viewer/layout/component/DropdownToolbarButton",["web-viewer/layout/component/ViewerToolbarButton","component/dropdownmenu/DropdownMenu","jquery","underscore"],function(f,g,e,d){e=function(c,b,a,e,n){f.call(this,c,b,a,e,this.toggle);this.leftClickAction=n;if(void 0===this.leftClickAction)this.setAction(d.bind(function(){this.isEnabled()&&this._dropdownEnabled&&(this.dropdown.isActive()?this.dropdown.hide():this.showDropdown())},this));else this.element.on("contextmenu",d.bind(function(a){a.preventDefault();
a.stopPropagation();this.isEnabled()&&this._dropdownEnabled&&this.showDropdown()},this));this._dropdownEnabled=!0;this.dropdown=new g(this.f.i18n,this.f.getContext(),this.f.isMobile(),"bottom","wcr-dropdown")};e.prototype=Object.create(f.prototype);e.prototype.constructor=e;e.prototype.toggle=function(){this.isActive()?this.leftClickAction(!1):this.leftClickAction(!0)};e.prototype.isOpen=function(){return this.dropdown.isActive()};e.prototype.showDropdown=function(){this.dropdown.show(this.element)};
e.prototype.setActionText=function(c,b){this.dropdown.setActionText(c,b)};e.prototype.toggleOption=function(c,b){this.dropdown.toggleOption(c,b)};e.prototype.getOptionValue=function(c){return this.dropdown.getOptionValue(c)};e.prototype.setActionEnabled=function(c,b){this.dropdown.setActionEnabled(c,b)};e.prototype.isActionEnabled=function(c){return this.dropdown.isActionEnabled(c)};e.prototype.addAction=function(c){this.dropdown.addAction(c)};e.prototype.addOption=function(c){this.dropdown.addOption(c)};
e.prototype.addDivider=function(){this.dropdown.addDivider()};e.prototype.enableDropdown=function(){this._dropdownEnabled=!0};e.prototype.disableDropdown=function(){this._dropdownEnabled=!1};e.prototype.clear=function(){this.dropdown.clear()};return e});
define("web-viewer/layout/component/SubToolbarButton",["web-viewer/layout/component/ViewerToolbarButton","jquery"],function(f){var g=function(e,d,c,b,a){f.call(this,e,d,c,b,a);this.element.removeClass("btn").addClass("subtoolbar-btn")};g.prototype=Object.create(f.prototype);return g.prototype.constructor=g});
define("web-viewer/layout/LayoutModule","web-viewer/layout/AbstractWidget web-viewer/layout/LayoutManager Template tpl component/button/Button component/toolbar/ButtonGroup web-viewer/layout/component/ColorPicker component/dropdownmenu/DropdownMenu web-viewer/layout/component/DropdownMiniButton web-viewer/layout/component/DropdownSubtoolbarButton web-viewer/layout/component/DropdownToolbarButton web-viewer/layout/component/SubtoolbarButton web-viewer/layout/component/ViewerToolbarButton web-viewer/layout/component/MiniButton web-viewer/layout/component/ModalPopup component/popover/Popover web-viewer/layout/component/Popup web-viewer/layout/component/SubToolbarButton web-viewer/layout/component/ViewerToolbarButton component/toolbar/ToolbarComponent component/tooltip/Tooltip".split(" "),function(){});
define("web-viewer/measure/MeasureConstants",{MeasureType:{Ruler:0,EyeDropper:1,Barcode:2,Braille:3,Caliper:4,ScreenRuling:5},BrailleLanguage:{Automatic:0,English:1,French:2,Polish:3,Portuguese:4,Russian:5,Spanish:6,Finnish:7,German:8,Italian:9,Latvian:10,Romanian:11,Slovene:12,Swedish:13,Hungarian:14,Dutch:15,Maltese:16},LanguageTranslationPrefix:"Lanuguage",LanguageAutomatic:"Automatic",LanguageDefault:"English",LanguageLocales:{en:"English",fr:"French",pl:"Polish",br:"Portuguese",ru:"Russian",
es:"Spanish",de:"German",it:"Italian",hu:"Hungarian",nl:"Dutch"},CaliperStyle:{Freeform:0,Fixed:1,Preset:2},RulerPoint:{DEFAULT:"/wcr-static/web-viewer/layout/img/crosshair_fine.png",OFFSET:{width:7,height:7},CLOSETODISTANCE:15},MeasureDrawType:{RECTANGLE:0,LINE:1,WIDTH:2,HEIGHT:3},ScreenRulingMode:{LINES:0,ANGLE:1,BOTH:2},ScreenRulingOrientation:{XMP:0,CW:1,CCW:2},ClickSize:{NORMAL:1,DIGITAL_FILM:64},ServerInfoFlags:{barCode:512,barCodeGV:8192,braille:1024}});
define("web-viewer/navigation/PanTool",["underscore","web-viewer/viewport/tools/AbstractTool","utils/ShapeUtils","web-viewer/utils/GEOUtils","web-viewer/core/CoreConstants"],function(f,g,e,d,c){d=function(b){g.call(this,b,c.TOOLS.PAN);var a=new e.Point(0,0),d=new e.Size,n=!1,j=f.bind(function(c,e){var f=a.sizeTo(c);if(0<Math.abs(f.width)||0<Math.abs(f.height)||e){f=this.sceneToWorld(a).sizeTo(this.sceneToWorld(c));f.add(d);var g=void 0;e&&(g={duration:200,type:"ease-out"},n&&(b.emit("toolManager.deactivateTool",
this),n=!1));this._widget.getWorld().setOffsetSize(f,g)}},this);this.registerState("default",{mousedown:f.bind(function(b){1===b.which&&(a=this.getScenePoint(b),d=this._widget.getWorld().getOffsetSize(),this.changeState("panning"),b.preventDefault())},this),mouseup:function(){},mousemove:function(){},mouseout:function(){},mouseleave:function(){},dblclick:f.bind(function(a){this.changeState("default");this._widget.getWorld().isSmallerThanFullView()?this._widget.getWorld().zoomToFit(!0):this.zoom(1,
this.getWorldPoint(a),!0)},this),contextmenu:f.bind(function(a){a.preventDefault();a.stopPropagation();this.zoom(-1,this.getWorldPoint(a),!0)},this)});var k=void 0,i=new e.Point(0,0);this.registerState("panning",f.defaults({enterState:function(){k&&(clearTimeout(k),k=null);b.emit("viewport.startInteractive");b.emit("viewport.startPanning");b.emit("layout.disableTextSelection")},leaveState:function(){a=new e.Point(0,0);b.emit("viewport.stopInteractive");b.emit("viewport.stopPanning");k=setTimeout(function(){b.emit("layout.enableTextSelection")},
500)},mouseup:f.bind(function(a){a.preventDefault();j(this.getScenePoint(a),!0);this.changeState("default")},this),mousemove:f.bind(function(a){i=this.getScenePoint(a);j(i,!1)},this),mouseout:f.bind(function(a){a.preventDefault();j(i,!0);this.changeState("default")},this),mouseleave:f.bind(function(a){a.preventDefault();j(i,!0);this.changeState("default")},this)},this.getState("default")));this.passiveKeyEvents=[];this.activeKeyEvents=[];this._override("initialize",function(c,d){this._super(c,d);
this.registerActiveEvents("mousedown mousemove mouseup mouseout mouseleave contextmenu dblclick".split(" "));var h=!1;this.passiveKeyEvents.push(["space",f.bind(function(){h||(h=!0,b.emit("toolManager.request.activation",this))},this),"keydown"]);this.passiveKeyEvents.push(["space",function(){h=!1},"keyup"]);this.activeKeyEvents.push(["space",f.bind(function(){h&&(h=!1,b.emit("toolManager.request.deactivation",this))},this),"keyup"]);this.passiveKeyEvents.push(["h",f.bind(function(a){a.preventDefault();
b.emit("toolManager.activateTool",this)},this),"keypress"]);this.passiveKeyEvents.push(["mod+up",f.bind(function(b){b.preventDefault();b.stopPropagation();this._setPanStart();b=this._widget.getWorld().getSceneSize();b=new e.Point(a.x,a.y+b.height/4);j(b,!0)},this),"keypress"]);this.passiveKeyEvents.push(["mod+down",f.bind(function(b){b.preventDefault();b.stopPropagation();this._setPanStart();b=this._widget.getWorld().getSceneSize();b=new e.Point(a.x,a.y-b.height/4);j(b,!0)},this),"keypress"]);this.passiveKeyEvents.push(["mod+right",
f.bind(function(b){b.preventDefault();b.stopPropagation();this._setPanStart();b=this._widget.getWorld().getSceneSize();b=new e.Point(a.x-b.width/4,a.y);j(b,!0)},this),"keypress"]);this.passiveKeyEvents.push(["mod+left",f.bind(function(b){b.preventDefault();b.stopPropagation();this._setPanStart();b=this._widget.getWorld().getSceneSize();b=new e.Point(a.x+b.width/4,a.y);j(b,!0)},this),"keypress"]);this.passiveKeyEvents.push(["f7",f.bind(function(a){a.preventDefault();a.stopPropagation();n=!0;b.emit("toolManager.activateTool",
this,!0)},this)])});this._setPanStart=function(){var b=this._widget.getWorld().getSceneSize();a=new e.Point(b.width/2,b.height/2);d=this._widget.getWorld().getOffsetSize()};this.getDefaultCursor=function(){return"cursor-move"};this.canBeInterrupted=function(){return"panning"!=this.getCurrentStateName()};this._override("doActivation",function(){this._super();this.changeState("default")});this._override("deactivate",function(a){this._super(a);this.changeState("default")});this.zoom=function(a,b,c){this._widget.getWorld().transform({zoom:a,
middle:b,animated:c})}};d.prototype=Object.create(g.prototype);return d.prototype.constructor=d});
define("web-viewer/utils/TouchUtil",["underscore","WV3Dlib/hammer","utils/ShapeUtils"],function(f,g,e){var d=function(c){this.ctx=c;var c=new g.Manager(c),b=new g.Pinch,a=new g.Tap({event:"singletap"}),d=new g.Tap({event:"doubletap",taps:2}),e=new g.Pan;c.add([b,a,d,e]);b.recognizeWith(e);b.requireFailure(e);d.recognizeWith(a);this.listeners={};c.on("singletap doubletap pinchstart pinchmove pinchend panstart panmove panend pancancel",f.bind(this.handleTouchEvent,this))};d.prototype.handleTouchEvent=
function(c){var b=c.type;this.listeners[b]&&0<this.listeners[b].length&&f.each(this.listeners[b],function(a){a(c)})};d.prototype.addSingleTapListener=function(c){this._addListener("singletap",c)};d.prototype.addDoubleTapListener=function(c){this._addListener("doubletap",c)};d.prototype.addPinchStartListener=function(c){this._addListener("pinchstart",c)};d.prototype.addPinchMoveListener=function(c){this._addListener("pinchmove",c)};d.prototype.addPinchEndListener=function(c){this._addListener("pinchend",
c);this._addListener("pinchcancel",c)};d.prototype.addPanStartListener=function(c){this._addListener("panstart",c)};d.prototype.addPanMoveListener=function(c){this._addListener("panmove",c)};d.prototype.addPanEndListener=function(c){this._addListener("panend",c);this._addListener("pancancel",c)};d.prototype.removeDoubleTapListener=function(c){this._removeListener("doubletap",c)};d.prototype.removePinchStartListener=function(c){this._removeListener("pinchstart",c)};d.prototype.removePinchMoveListener=
function(c){this._removeListener("pinchmove",c)};d.prototype.removePinchEndListener=function(c){this._removeListener("pinchcancel",c);this._removeListener("pinchend",c)};d.prototype.removePanStartListener=function(c){this._removeListener("panstart",c)};d.prototype.removePanMoveListener=function(c){this._removeListener("panmove",c)};d.prototype.removePanEndListener=function(c){this._removeListener("panend",c);this._removeListener("pancancel",c)};d.prototype.removeAllListeners=function(){this.listeners=
{}};d.prototype._addListener=function(c,b){this.listeners[c]||(this.listeners[c]=[]);0>f.indexOf(this.listeners[c],b)&&this.listeners[c].push(b)};d.prototype._removeListener=function(c,b){this.listeners[c]&&(this.listeners[c]=f.without(this.listeners[c],b))};d.prototype.preventDefault=function(c){c.preventDefault()};d.prototype.getScale=function(c){return c.scale};d.prototype.getRotation=function(c){return c.rotation};d.prototype.getCenter=function(c,b){var a=new e.Point;a.x=c.center.x;a.y=c.center.y;
b&&(a.x-=b.left,a.y-=b.top);return a};d.prototype.getScenePointFromTouch=function(c,b,a){c=this.getCenter(c);a||(a=b.requestView(c));a&&(b=a.getViewContext().offset(),c.offsetXY(-b.left,-b.top));return{view:a,point:c}};return d});
define("web-viewer/navigation/TouchTool",["underscore","web-viewer/viewport/tools/AbstractTool","web-viewer/utils/ViewerUtils","web-viewer/utils/TouchUtil","web-viewer/core/CoreConstants"],function(f,g,e,d,c){var b=function(a){g.call(this,a,c.TOOLS.TOUCH);this._touchUtil=null;this._allowRotation=!0;this._unlockRotation=!1;this._unlockRotationAngle=25;this._initTouchCenter=this._initRotate=this._initZoom=void 0};b.prototype=Object.create(g.prototype);b.prototype.constructor=b;b.prototype.startAction=
function(a){this._touchUtil.preventDefault(a);this.f.emit("viewport.startInteractive");this._unlockRotation=!1;var b=this._widget.getWorld();this._initZoom=b.getZoom();this._initRotate=b.getRotation();a=this._touchUtil.getScenePointFromTouch(a,this._widget);this._initTouchCenter=this.sceneToWorld(a.point);this._currentView=a.view};b.prototype.stopAction=function(a){this._touchUtil.preventDefault(a);delete this._currentView;this.f.emit("viewport.stopInteractive");this.releaseCanvasLayer();this._unlockRotation=
!1;this._widget.getWorld().transform({rubber:!1,animated:{duration:100,type:"ease-out"},constrainRotation:!0})};b.prototype.doubleTap=function(a){this._touchUtil.preventDefault(a);var a=this.getScenePointFromTouch(a),a=this._widget.getWorld().getWorldPointFromScene(a),b=this._widget.getWorld();b.isFullView()?b.transform({zoom:3,middle:a,animated:!0}):b.zoomToFit(!0)};b.prototype.pinchMove=function(a){this._touchUtil.preventDefault(a);var b=this._touchUtil.getScale(a),c=this._touchUtil.getRotation(a),
a=this.getScenePointFromTouch(a);this.updateWorld(a,b,c)};b.prototype.panAction=function(a){this._touchUtil.preventDefault(a);a=this.getScenePointFromTouch(a);this.updateWorld(a)};b.prototype.updateWorld=function(a,b,c){var d=this._widget.getWorld(),f={};b&&(f.fixedzoom=this._initZoom*b);c&&this._allowRotation&&(c=parseInt(c,10)%360,this._unlockRotation||(b=c-e.closestAngle(c,4),Math.abs(b)>this._unlockRotationAngle&&(this._unlockRotation=!0)),this._unlockRotation&&(f.fixedrotation=c+this._initRotate));
f.middle=this._initTouchCenter;d.transform(f,!0);f=d.getSceneBounds().center().sizeTo(a);a=d.getWorldSizeFromScene(f);f={};f.offsetX=a.width;f.offsetY=a.height;d.transform(f)};b.prototype.initialize=function(a,b){g.prototype.initialize.apply(this,arguments);this._touchUtil=new d(a.getElement()[0])};b.prototype.doDeactivation=function(){g.prototype.doDeactivation.call(this);this._touchUtil.removeAllListeners()};b.prototype.doActivation=function(){g.prototype.doActivation.call(this);this._touchUtil.addPinchStartListener(f.bind(function(a){this.f.emit("viewport.startZooming");
this.startAction(a)},this));this._touchUtil.addPinchMoveListener(f.bind(this.pinchMove,this));this._touchUtil.addPinchEndListener(f.bind(function(a){this.f.emit("viewport.stopZooming");this.stopAction(a)},this));this._touchUtil.addDoubleTapListener(f.bind(this.doubleTap,this));this._touchUtil.addPanStartListener(f.bind(function(a){this.f.emit("viewport.startPanning");this.startAction(a)},this));this._touchUtil.addPanMoveListener(f.bind(this.panAction,this));this._touchUtil.addPanEndListener(f.bind(function(a){this.f.emit("viewport.stopPanning");
this.stopAction(a)},this))};b.prototype.getScenePointFromTouch=function(a){return this._touchUtil.getScenePointFromTouch(a,this._widget,this._currentView).point};return b});
define("web-viewer/navigation/TouchPreventerTool",["underscore","web-viewer/viewport/tools/AbstractTool","web-viewer/utils/TouchUtil","web-viewer/core/CoreConstants"],function(f,g,e,d){var c=function(b){g.call(this,b,d.TOOLS.NOTOUCH);this._touchUtil=null};c.prototype=Object.create(g.prototype);c.prototype.constructor=c;c.prototype.doPassivation=function(){g.prototype.doPassivation.call(this);this._touchUtil.removeAllListeners()};c.prototype.initialize=function(b,a){g.prototype.initialize.apply(this,
arguments);this._touchUtil=new e(b.getElement()[0])};c.prototype.doActivation=function(){g.prototype.doActivation.call(this);var b=f.bind(function(a){this._touchUtil.preventDefault(a)},this);this._touchUtil.addPinchStartListener(f.bind(b,this));this._touchUtil.addPinchMoveListener(f.bind(b,this));this._touchUtil.addPinchEndListener(f.bind(b,this));this._touchUtil.addDoubleTapListener(f.bind(b,this));this._touchUtil.addPanStartListener(f.bind(b,this));this._touchUtil.addPanMoveListener(f.bind(b,this));
this._touchUtil.addPanEndListener(f.bind(b,this))};return c});
define("web-viewer/navigation/ZoomTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/utils/GEOUtils utils/Mousewheel web-viewer/utils/DrawUtils web-viewer/core/CoreConstants".split(" "),function(f,g,e,d,c,b,a){d=function(c){g.call(this,c,a.TOOLS.ZOOM);var d=1,j,k=0,i=new e.Point,q=!1,l=f.bind(function(){q&&(c.emit("toolManager.deactivateTool",this),q=!1)},this);this.registerState("default",f.bind(function(){var a=f.bind(function(a){d=a.altKey?-1:1;this.setCursor(-1==
d?"cursor-zoomOut":"cursor-zoomIn")},this);return{mousedown:f.bind(function(b){j=new e.Rect(this.getScenePoint(b));a(b);1===b.which&&this.changeState("couldStartDragging");b.preventDefault()},this),mouseup:f.bind(function(b){a(b);0<k?k--:(this.zoom((1===b.which?1:-1)*d,this.getWorldPoint(b),!0),this.changeState("default"),l(),b.preventDefault())},this),mousemove:function(b){a(b)},contextmenu:function(a){a.preventDefault();a.stopPropagation()},mouseleave:f.bind(function(){this.changeState("default")},
this),esc:f.bind(function(){this.changeState("default")},this),spacedown:function(){},spaceup:function(){},canBeInterrupted:!0}},this)());this.registerState("couldStartDragging",f.defaults({mousemove:f.bind(function(a){var b=this.getScenePoint(a);j.update(b);if(16<Math.abs(j.size.width)||16<Math.abs(j.size.height))this.requestCanvasLayer(a),this.changeState("dragging")},this),mouseleave:f.bind(function(){this.changeState("default")},this),esc:f.bind(function(){k++;this.changeState("default")},this),
canBeInterrupted:!1},this.getState("default")));var m=f.bind(function(){this.releaseCanvasLayer()},this),s=f.throttle(f.bind(function(){var a=this.getCanvasCtx();if(a){var c=this.getCanvasSize();a.clearRect(0,0,c.width,c.height);a.beginPath();a.strokeStyle="rgba(0, 0, 0, 1.0)";a.lineWidth=1;a.fillStyle="rgba(0, 0, 0, 0.40)";a.rect(0,0,c.width,c.height);a.fill();a.stroke();a.clearRect(j.origin.x,j.origin.y,j.size.width,j.size.height);a.beginPath();a.strokeStyle="rgba(210,210,210,0.9)";a.lineWidth=
1;b.drawDashedRect(a,j,[4,3]);a.stroke()}},this),40);this.registerState("dragging",f.defaults({enterState:function(){c.emit("layout.disableTextSelection");c.emit("viewport.startInteractive")},leaveState:function(a){if("panningSelection"!=a||"dragging"!=a)setTimeout(function(){c.emit("layout.enableTextSelection")},500),c.emit("viewport.stopInteractive")},mousedown:function(){k++},mousemove:f.bind(function(a){i=a=this.getScenePoint(a);j.update(a);s()},this),mouseleave:f.bind(function(){this.changeState("default");
m()},this),mouseup:f.bind(function(a){0<k?k--:(i=a=this.getScenePoint(a),j.update(a),this.zoomToSelection(j),this.changeState("default"),l(),m())},this),esc:f.bind(function(){k++;this.changeState("default");m()},this),spacedown:f.bind(function(){this.changeState("panningSelection")},this),canBeInterrupted:!1},this.getState("default")));this.registerState("panningSelection",f.defaults({mousemove:f.bind(function(a){var a=this.getScenePoint(a),b=i.sizeTo(a);i=a;j.origin.x+=b.width;j.origin.y+=b.height;
s()},this),spacedown:function(){},spaceup:f.bind(function(){this.changeState("dragging")},this)},this.getState("dragging")));this.passiveKeyEvents=[];this.activeKeyEvents=[];this.persistentKeyEvents=[];this._override("initialize",function(a,b){this._super(a,b);this.registerActiveEvents(["mousedown","mousemove","mouseup","mouseleave","contextmenu"]);this.persistentKeyEvents.push([["ctrl+plus","f5","ctrl+="],f.bind(function(a){a.preventDefault();a.returnValue=!1;this.zoom(1,void 0,!0)},this)]);this.persistentKeyEvents.push([["ctrl+-",
"f6"],f.bind(function(a){a.preventDefault();a.returnValue=!1;this.zoom(-1,void 0,!0)},this)]);this.persistentKeyEvents.push([["ctrl+0","f9"],function(a){a.shiftKey||(a.preventDefault(),c.emit("viewport.zoomToFit",{animated:!0}))}]);this.passiveKeyEvents.push(["z",f.bind(function(a){a.preventDefault();c.emit("toolManager.activateTool",this)},this),"keypress"]);this.passiveKeyEvents.push(["f8",f.bind(function(a){a.preventDefault();q=!0;c.emit("toolManager.activateTool",this,!0)},this)]);this.activeKeyEvents.push(["esc",
f.bind(function(a){a.preventDefault();this.getCurrentState().esc(a)},this),"keyup"]);this.activeKeyEvents.push(["space",f.bind(function(a){this.getCurrentState().spacedown(a)},this),"keydown"]);this.activeKeyEvents.push(["space",f.bind(function(a){this.getCurrentState().spaceup(a)},this),"keyup"])});this.zoom=function(a,b,c){this._widget.getWorld().transform({zoom:a,middle:b,animated:c})};this.zoomToSelection=function(a){this._widget.getWorld().zoomToSceneRect(a,!0)};this.canBeInterrupted=function(){return this.getCurrentState().canBeInterrupted};
this.getDefaultCursor=function(){return-1==d?"cursor-zoomOut":"cursor-zoomIn"};this._override("doActivation",function(){this._super();this.changeState("default")});this._override("deactivate",function(a){this._super(a);this.changeState("default");m()})};d.prototype=Object.create(g.prototype);d.prototype.constructor=d;d.prototype.getIconOffset=function(){return new e.Size(6,6)};d.prototype.doPassivation=function(){g.prototype.doPassivation.call(this);c.addListener(f.throttle(f.bind(this.handleScrollWheel,
this),150))};d.prototype.handleScrollWheel=function(a,b){0<this._widget.context.has(a.target).length&&(this.zoom(0>b?-1:1,this.getWorldPoint(a),!0),a.preventDefault())};return d});
define("web-viewer/layout/component/LogSlider",["component/tooltip/Tooltip","web-viewer/utils/ViewerUtils","jquery","jqueryUI","underscore"],function(f,g,e){g=function(d,c){this.f=d;this._minp=void 0===c.minp?0:c.minp;this._maxp=void 0===c.maxp?100:c.maxp;this.setOptions(c);this._onSliderChanged=c.onSliderChanged;this.element=e("<div />").addClass("sliderWrapper");this._slider=e("<div />").addClass("slider");this.element.append(this._slider);this._slider.slider({slide:_.bind(function(b,a){this._fireSliderChanged(a.value)},
this),min:this._minp,max:this._maxp});void 0!==c.tooltip&&(this._tooltip=new f(this.f.i18n,this.element,this.f.getContext(),this.f.getContext(),this.f.isMobile(),c.tooltip))};g.prototype._toValue=function(d){return Math.exp((d-this._minp)*this._scale+this._minv)};g.prototype._toPosition=function(d){return this._minp+(Math.log(d)-this._minv)/this._scale};g.prototype._fireSliderChanged=function(d){d=this._toValue(d);this._onSliderChanged(d)};g.prototype.setValue=function(d){d=this._toPosition(d);this._slider.slider("value",
d)};g.prototype.setOptions=function(d){this._minv=Math.log(void 0===d.minv?1:d.minv);this._maxv=Math.log(void 0===d.maxv?1E5:d.maxv);this._scale=(this._maxv-this._minv)/(this._maxp-this._minp)};return g});
define("web-viewer/navigation/ZoomBar",["web-viewer/layout/component/LogSlider","web-viewer/utils/ListenerUtil","web-viewer/layout/component/MiniButton","jquery","underscore"],function(f,g,e,d,c){var b=function(a){this.f=a;g.mixin(this,this.f);this.element=d("<div />").addClass("zoomBar clearfix");this._minButton=new e(this.f,"minZoom","icon-WCR_Minus",!0,c.bind(this._minZoom,this));this.element.append(this._minButton.element.addClass("minZoom"));this._zoomPercentage=d("<span />").addClass("zoomPercentage");
this.element.append(this._zoomPercentage);this._plusButton=new e(this.f,"plusZoom","icon-WCR_Plus",!0,c.bind(this._plusZoom,this));this.element.append(this._plusButton.element.addClass("plusZoom"));if(a=this.f.getModule("viewport"))this._slider=new f(this.f,{onSliderChanged:c.bind(this._sliderChanged,this),minp:1,maxp:a.getNumberOfZoomLevels()}),this._updateMinMax(),this.element.append(this._slider.element);this._registerListener("transform.viewportWidget.minMaxZoomChanged",this._updateMinMax,this);
this._registerListener("transform.viewportWidget.transformChanged",this._updateZoom,this)};b.prototype._sliderChanged=function(a){var b=this.f.getModule("viewport");b&&b.transform({fixedzoom:a,animated:!0})};b.prototype._updateZoom=function(){var a=this.f.getModule("viewport");if(a){var b=a.getZoomPercentage();this._zoomPercentage.text(b.toFixed(2)+"%");a=a.getZoom();this._slider.setValue(a)}};b.prototype._updateMinMax=function(){var a=this.f.getModule("viewport");if(a){var b=a.getMinZoom(),a=a.getMaxZoom();
this._slider.setOptions({minv:b,maxv:a})}};b.prototype._minZoom=function(){var a=this.f.getModule("viewport");a&&a.transform({zoom:-1,animated:!0})};b.prototype._plusZoom=function(){var a=this.f.getModule("viewport");a&&a.transform({zoom:1,animated:!0})};return b});
define("web-viewer/navigation/NavigatorPanTool",["underscore","web-viewer/viewport/tools/AbstractTool","utils/ShapeUtils","web-viewer/core/CoreConstants"],function(f,g,e,d){var c=function(b,a){g.call(this,b,d.TOOLS.NAVIGATIONPAN);this._startPoint=new e.Point;this._startOffset=new e.Size;this._currentCenter=new e.Size;this._viewport=a;this._lastMousePosition=null;this.registerState("default",{mousedown:f.bind(function(a){var b=this._viewport.getVisibleRect();if(!this._viewport.getWorldBounds().rectEquals(b)){var c=
this._widget.getNavigatorImageOffset(),a=new e.Point(a.pageX-c.left,a.pageY-c.top),c=this.convertScenePointToWorldPoint(a);this._startOffset=this._viewport.getWorld().getOffsetSize();this._startPoint=a;b.containsPoint(c)?this.changeState("panning"):this._viewport.getWorldBounds().containsPoint(c)&&(this._currentCenter=b.center(),this._updateViewport(a,!0),this._startPoint=this._widget.getNavigatorTransformation().transformedPoint(this._currentCenter),this.changeState("panning"))}},this),mouseup:function(){},
mousemove:function(){},mouseout:function(){},mouseleave:function(){},contextmenu:f.bind(function(a){a.preventDefault();a.stopPropagation()},this)});this.registerState("panning",f.defaults({enterState:f.bind(function(){this.setCursor("cursor-moveObject");this.f.emit("viewport.startInteractive");this.f.emit("viewport.startPanning");this.f.emit("layout.disableTextSelection")},this),leaveState:f.bind(function(){this.setCursor("cursor-default");this.f.emit("viewport.stopInteractive");this.f.emit("viewport.stopPanning");
this.f.emit("layout.enableTextSelection");this._lastMousePosition&&this._updateViewport(this._lastMousePosition,!1,!0)},this),mouseup:f.bind(function(a){a.preventDefault();this._lastMousePosition=null;this.changeState("default")},this),mousemove:f.bind(function(a){var b=this._widget.getNavigatorImageOffset();this._lastMousePosition=a=new e.Point(a.pageX-b.left,a.pageY-b.top);this._updateViewport(a,!1)},this),mouseout:f.bind(function(a){a.preventDefault();this.changeState("default")},this),mouseleave:f.bind(function(a){a.preventDefault();
this.changeState("default")},this)},this.getState("default")))};c.prototype=Object.create(g.prototype);c.prototype.constructor=c;c.prototype.initialize=function(b,a){g.prototype.initialize.call(this,b,a);this.registerActiveEvents("mousedown mousemove mouseup mouseout mouseleave contextmenu".split(" "))};c.prototype.getDefaultCursor=function(){return"panning"!=this.getCurrentStateName()?"cursor-default":"cursor-moveObject"};c.prototype.canBeInterrupted=function(){return"panning"!=this.getCurrentStateName()};
c.prototype.doActivation=function(){g.prototype.doActivation.call(this);this.changeState("default")};c.prototype.deactivate=function(b){g.prototype.deactivate.call(this,b);this.changeState("default")};c.prototype._updateViewport=function(b,a,c){var d=this._startPoint.sizeTo(b);if(0<Math.abs(d.width)||0<Math.abs(d.height)||a||c)c=new e.Size,c=a?this._currentCenter.sizeTo(this.convertScenePointToWorldPoint(b)):this.convertScenePointToWorldPoint(this._startPoint).sizeTo(this.convertScenePointToWorldPoint(b)),
c=new e.Size(-c.width,-c.height),c.add(this._startOffset),this._viewport.getWorld().setOffsetSize(c)};c.prototype.convertScenePointToWorldPoint=function(b){return this._widget.getNavigatorTransformation().createInverse().transformedPoint(b)};return c});
define("web-viewer/navigation/NavigatorWidget","web-viewer/layout/AbstractWidget web-viewer/layout/LayoutConstants web-viewer/layout/component/MiniButton web-viewer/navigation/ZoomBar jquery underscore utils/HTTPUtils web-viewer/utils/Fragment utils/Transformation web-viewer/utils/DrawUtils utils/ShapeUtils web-viewer/utils/ListenerUtil web-viewer/navigation/NavigatorPanTool web-viewer/compare/CompareConstants".split(" "),function(f,g,e,d,c,b,a,h,n,j,k,i,q,l){e=function(a){f.call(this,a,g.Widget.NAVIGATOR);
i.mixin(this,a);this.navigatorImage=c("<div>").addClass("navigatorImage");this._graphicsLayer=c("<canvas>").css({position:"absolute",top:0,left:0});this._cadLayer=c("<canvas>").css({position:"absolute",top:0,left:0});this._interactiveLayer=c("<canvas>").css({position:"absolute",top:0,left:0});this._worldTranformation=this._viewport=this._fragment=null;this.f.loadBundle("viewer",function(){this.setTitle(this.f.t("NavigatorTitle"))},this);this.setIcon("icon icon-WCR_Navigator");var d=b.debounce(this._renderNavigatorImage,
200),a=b.throttle(b.bind(function(){if(this._viewport){var a=this._viewport.getWorld().getRotation()%360,b=this._viewport.getWorldBounds();if(90==a||270==a)b.size=new k.Size(b.size.height,b.size.width);0!==b.size.width&&0!==b.size.height&&this._renderVisibleRect(this._interactiveLayer[0].getContext("2d"),b,a)}},this),10);this.resized=function(){d.call(this)};this._zoomBar=null;this._registerListener("transform.viewportWidget.worldBoundsChanged",d,this);this._registerListener("module.compare.changed.diffMode",
d,this);this._registerListener("module.viewport.finishedLoadingImageData",d,this);this._registerListener("cadModel.*.modelChanged",d,this);this._registerListener("transform.viewportWidget.rotated",d,this);this._registerListener("transform.viewportWidget.flipped",d,this);this._registerListener("transform.viewportWidget.flippedViewFromBack",d,this);this._registerListener("transform.viewportWidget.transformChanged",a,this);this._registerListener("modalResize",d,this,this);this._registerListener("collapsed",
d,this,this);this._registerListener("visible",d,this,this)};e.prototype=Object.create(f.prototype);e.prototype.constructor=e;e.widgetName=g.Widget.NAVIGATOR;e.prototype.setContext=function(a){f.prototype.setContext.call(this,a);a.append(this.navigatorImage);this.navigatorImage.append(this._graphicsLayer);this.navigatorImage.append(this._cadLayer);this.navigatorImage.append(this._interactiveLayer);this.f.whenModuleAvailable("viewport",function(a){this._viewport=a;this._panTool=new q(this.f,this._viewport);
this._panTool.initialize(this);this._panTool.activate();this._zoomBar=new d(this.f);this.context.addClass("navigatorWidget").append(this._zoomBar.element);this._renderNavigatorImage()},this)};e.prototype._renderNavigatorImage=function(){if(!this.isCollapsed()&&this.isVisible()&&this._viewport&&this.context){var a=this.f.getActivePage(),b=this.f.getDocumentController().getCadOverlay(),c=new k.Size(this.context.innerWidth(),this.context.innerHeight()-this._zoomBar.element.outerHeight()),d=this._viewport.world.getRotation()%
360,e=this._viewport.getWorldBounds();if(0!==e.size.width&&0!==e.size.height){if(90==d||270==d)e.size=new k.Size(e.size.height,e.size.width);this._pageRes=c.width/e.size.width;var f=c.width,h=e.size.height*this._pageRes,g=200;this._isModal&&(g=c.height);h>g&&(h=g,this._pageRes=h/e.size.height,f=e.size.width*this._pageRes);this.navigatorImage.height(Math.round(h));this.navigatorImage.width(Math.round(f));this._fireResized();c=new k.Size(f,h);g=new k.Size(f,h);if(90==d||270==d)g=new k.Size(h,f);a.hasGraphics()||
a.isBlankPage()?(this._graphicsLayer.show(),this._graphicsLayer[0].width=f,this._graphicsLayer[0].height=h,this._renderGraphicsImage(this._graphicsLayer[0].getContext("2d"),this._pageRes,c,g,e)):this._graphicsLayer.hide();a.hasCad()||b?(this._cadLayer.show(),this._cadLayer[0].width=f,this._cadLayer[0].height=h,this.f.getModule("cad")&&(a.hasCad()?this._renderCAD(this._cadLayer[0].getContext("2d"),a,this._pageRes,e,null,g):this._renderCAD(this._cadLayer[0].getContext("2d"),b,this._pageRes,e,!0,g))):
this._cadLayer.hide();this._interactiveLayer[0].width=f;this._interactiveLayer[0].height=h;this._renderVisibleRect(this._interactiveLayer[0].getContext("2d"),e,d)}}};e.prototype._renderGraphicsImage=function(c,d,e,f,g){if(!(0>=d||this.f.isParameterUpdateOngoing())){var i={resolution:d,rectangle:this._viewport.getWorldBounds(),servlet:"",params:{x1:0,x2:0,y1:0,y2:0}};this._fragment=new h(g,d);this.f.emit("intercept.fragmentURL",i);if(void 0===i.params.file&&void 0===i.params.diff)c.setTransform(1,
0,0,1,0,0),c.clearRect(0,0,this._graphicsLayer.width(),this._graphicsLayer.height()),this._transformCanvas(c,e,null,null),c.fillStyle="rgba(255, 255, 255, 1)",j.drawRect(c,0,0,f.width,f.height,0,!0,!1);else{if(void 0===i.params.file&&void 0!==i.params.diff)i.params.file=i.params.diff,delete i.params.diff,i.params.rs=1==i.params.rs?2:1;else if(i.params.dmode==l.diffMode.SHOWBOTHSIDEBYSIDE||i.params.dmode==l.diffMode.SHOWBOTHSIDEBYSIDEHIGHLIGHT||i.params.dmode==l.diffMode.SHOWBOTHSIDEBYSIDECHANGESONLY)i.params.dmode=
l.diffMode.CURRENTVERSION;delete i.params.colorBITWISE;delete i.params.isDefaultView;d=a.constructURL(i.servlet,i.params);d=d.replace(/%2C/g,",");this._fragment.fetchImage(this._viewport.getImageCache(),d,b.bind(function(){this._fragment.isFetched()&&(c.setTransform(1,0,0,1,0,0),c.clearRect(0,0,this._graphicsLayer.width(),this._graphicsLayer.height()),this._transformCanvas(c,e,null,null),c.drawImage(this._fragment.image,0,0,f.width,f.height))},this),function(){})}}};e.prototype._renderCAD=function(a,
c,d,e,f,h){c.requestCad(b.bind(function(){var b=this.f.getModule("cad"),c;c=f?b.getCadOverlayModel():b.getCurrentPageCadModel();var g=b.getReferencePageCadModel(),i=this._viewport.getWorldBounds();if(null!==c&&c.getCad()){var s=c.getCad().getOrigin();i.origin.x+=s.x;i.origin.y-=s.y;var n=c.getVisibleCadLines(),q=new k.Size,q=f?new k.Size(-e.origin.x,-e.origin.y):new k.Size(-s.x-e.origin.x,s.y-e.origin.y);a.setTransform(1,0,0,1,0,0);a.clearRect(0,0,this._cadLayer.width(),this._cadLayer.height());var q=
this._transformCanvas(a,e.size,q,d),F=null;f?(F=b.getOverlayTransform())&&a.transform(F.a,F.b,F.c,F.d,F.e,F.f):(a.save(),a.fillStyle=c.getBackgroundString(),j.drawRect(a,i.origin.x,i.origin.y,i.size.width,i.size.height,0,!0,!0),a.restore());var E=q.copy();if(b.compareDiffMode!==l.diffMode.DIFFVERSION||f)F&&E.concatenate(F),F=this.f.getModule("viewport").getWorld().getWorldRectFromScene(new k.Rect(null,new k.Size(this._cadLayer.width(),this._cadLayer.height())),E),j.drawOverlay(this.f,a,n,F,function(){},
h.width/i.size.width,q,c.getCadColor(),c.getAlpha());null!==g&&(null!==g.getCad()&&b.getReferenceTransform())&&(c=g.getVisibleCadLines(),q=b.getReferenceTransform(),q.preTranslate(s.x,-s.y),a.transform(q.a,q.b,q.c,q.d,q.e,q.f),E.concatenate(q),b=this.f.getModule("viewport").getWorld().getWorldRectFromScene(new k.Rect(null,new k.Size(this._cadLayer.width(),this._cadLayer.height())),E),j.drawOverlay(this.f,a,c,b,function(){},h.width/i.size.width,q,g.getCadColor(),g.getAlpha()))}},this))};e.prototype._renderVisibleRect=
function(a,b,c){var d=this._viewport.getVisibleRect();a.setTransform(1,0,0,1,0,0);a.clearRect(0,0,this._interactiveLayer.width(),this._interactiveLayer.height());this._worldTranformation=this._transformCanvas(a,b.size,new k.Size(-b.origin.x,-b.origin.y),this._pageRes);a.beginPath();a.strokeStyle="rgba(0, 0, 0, 1.0)";a.lineWidth=1/this._pageRes;a.fillStyle="rgba(0, 0, 0, 0.50)";90==c||270==c?a.rect(b.origin.x,b.origin.y,b.size.height,b.size.width):a.rect(b.origin.x,b.origin.y,b.size.width,b.size.height);
a.fill();a.stroke();a.clearRect(d.origin.x,d.origin.y,d.size.width,d.size.height);a.beginPath();a.strokeStyle="rgba(255,255,255,1)";a.lineWidth=1/this._pageRes;a.strokeStyle="rgba(0,0,0,1)";this._pageRes&&j.drawDashedRect(a,d,[2,5],this._pageRes);a.stroke()};e.prototype._transformCanvas=function(a,b,c,d){var e=this._viewport.world.isFlip(),f=this._viewport.world.isFlipViewFromBack(),h=this._viewport.world.getRotation()%360,g=new n;null!==d&&g.scale(d,d);g.translate(b.width/2,b.height/2);g.rotate(h*
(Math.PI/180));e&&g.scale(-1,1);f&&(0===h%180?g.scale(-1,1):g.scale(1,-1));90==h||270==h?g.translate(-b.width/2+(b.width-b.height)/2,-b.height/2-(b.width-b.height)/2):g.translate(-b.width/2,-b.height/2);null!==c&&g.translate(c.width,c.height);a.transform(g.a,g.b,g.c,g.d,g.e,g.f);return g};e.prototype.getNavigatorTransformation=function(){return this._worldTranformation};e.prototype.getMinimumSize=function(){return new k.Size(200,this.navigatorImage.height()+this._zoomBar.element.height())};e.prototype.getNavigatorImageOffset=
function(){return this.navigatorImage.offset()};return e});define("web-viewer/navigation/NavigationConstants",{ZoomOneToOneClick:{AUTO:0,REALSIZE:1}});
define("tpl!web-viewer/navigation/AdjustMonitorResolutionPopup",function(){return function(f){var g;return f=""+('<div class="wcr-form form-labels-on-top"><div class="form-group"><label>'+(null==(g=f.i18n("ZoomOneToOneAdjustResLabel"))?"":_.escape(g))+' </label><div class="form-entry"><div class="input-group"><input value="'+(null==(g=f.monitorResolution)?"":_.escape(g))+'" type="text" size="7" name="monitorResolution" class="monitorResolution form-control"></input><span class="input-group-addon"> '+
(null==(g=f.i18n(f.resolutionUnitsLangKey))?"":_.escape(g))+"</span></div></div></div></div>\r\n\r\n<p>"+(null==(g=f.i18n("ZoomOneToOneAdjustResHint"))?"":_.escape(g))+"<br />"+(null==(g=f.i18n("ZoomOneToOneAdjustResExample"))?"":_.escape(g))+"</p>\r\n<p>"+(null==(g=f.i18n("ZoomOneToOneAdjustResMoreInfo"))?"":_.escape(g))+' <a href="'+(null==(g=f.moreInfoLink)?"":_.escape(g))+'" target="_blank">'+(null==(g=f.i18n("ZoomOneToOneAdjustResMoreInfoLink"))?"":_.escape(g))+"</a></p>")}});
define("web-viewer/navigation/AdjustMonitorResolutionPopup","web-viewer/layout/component/ModalPopup Template web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants tpl!web-viewer/navigation/AdjustMonitorResolutionPopup jquery underscore".split(" "),function(f,g,e,d,c,b,a){d=function(d,n,j){f.call(this,d,n,d.getContext());this._navigationModule=j;this.f.i18n.loadBundle("viewer",a.bind(function(){this.setHeader(b("<span/>").addClass("popupTitle").html(this.f.i18n.t("ZoomOneToOneAdjustResTitle")));
this.setOkBtnText(this.f.i18n.t("OkButton"));this.setOkAction(a.bind(function(){this._navigationModule.okMonitorResolution()},this));this.setCancelAction(a.bind(function(){this._navigationModule.cancelMonitorResolution()},this))},this));this.element.addClass("adjustMonitorResolutionPopup");this.t=new g(this.f.i18n,c);this.t.setContext(this._popupContent.addClass("adjustMonitorResolutionPopupContent"));this.t.d.moreInfoLink="https://wiki.esko.com/display/KBA/KB134185394:+WebCenter+-+How+to+determine+the+Monitor+Resolution+for+Zoom+to+Actual+Size+in+the+HTML5+Viewer";
this.t.bind("focusout","[name=monitorResolution]",a.bind(function(a){var b=a.value,c=a.value.split("/");2==c.length&&(b=e.parseFloat(c[0])/e.parseFloat(c[1]));b=e.parseFloat(b);isNaN(b)&&(b=e.parseFloat(e.convertResolutionFromPpmmValue(this._navigationModule.getMonitorResolution(),this.f.getResolutionUnits())));b=e.parseFloat(e.convertResolutionToPpmmValue(b,this.f.getResolutionUnits()));a.value=e.convertResolutionFromPpmmValue(b,this.f.getResolutionUnits(),this.f.getResolutionUnitsFix());this._navigationModule.setMonitorResolution(b)},
this));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_RESOLUTION",a.bind(function(){this.isVisible()&&this.render()},this))};d.prototype=Object.create(f.prototype);d.prototype.constructor=d;d.prototype.render=a.throttle(function(){this.t.d.monitorResolution=e.convertResolutionFromPpmmValue(this._navigationModule.getMonitorResolution(),this.f.getResolutionUnits(),this.f.getResolutionUnitsFix());this.t.d.resolutionUnitsLangKey=this.f.getResolutionUnitsLocName();this.t.render();this._isInitialized&&
this.recalculateSize(500)},40);d.prototype.show=function(){this.render();f.prototype.show.call(this);this.recalculateSize(500)};return d});
define("web-viewer/navigation/NavigationModule","underscore web-viewer/core/AbstractModule web-viewer/navigation/PanTool web-viewer/navigation/TouchTool web-viewer/navigation/TouchPreventerTool web-viewer/navigation/ZoomTool web-viewer/navigation/NavigatorWidget web-viewer/navigation/NavigationConstants web-viewer/navigation/AdjustMonitorResolutionPopup component/toolbar/ToolbarComponent component/toolbar/ButtonGroup web-viewer/layout/component/ViewerToolbarButton web-viewer/layout/component/DropdownToolbarButton web-viewer/layout/LayoutConstants web-viewer/utils/ViewerUtils Mousetrap".split(" "),function(f,
g,e,d,c,b,a,h,n,j,k,i,q,l,m,s){var t=function(b,c){g.call(this,b,c,"navigation");this.requiresViewportAccess=!0;this._extraRotation=0;this._initializeTools(b);this._publishWidget(a.widgetName,f.bind(function(){return this._navigatorWidget=new a(b)},this))};t.prototype=Object.create(g.prototype);t.prototype.constructor=t;t.prototype._initializeTools=function(a){if(this.f.getLayoutType()===l.LayoutType.MOBILE){var h=new d(a);this._publishTool(h);h.requestActivation()}else{var g=new e(a),m=new b(a),
h=new c(a);this._publishTool(m);this._publishTool(g);this._publishTool(h);this._publishToolbarComponent(l.ToolbarComponent.NAVIGATE,f.bind(function(){var b=new j(l.ToolbarComponent.NAVIGATE,a),c=new k("NavigateGroup");c.setTitle(a.i18n,"viewer","NavBtnGroupTitle");b.addButtonGroup(c);var d=new i(a,"ZoomButton","icon icon-WCR_Zoom",!1);d.setTooltip("viewer","ZoomBtnTT");d.listenToTool(m);d.element.on("dblclick",function(b){a.emit("viewport.zoomToFit",{animated:!0});b.stopPropagation()});c.addButton(d);
d=new i(a,"ZoomInButton","icon icon-WCR_WF-ZoomIn",!1,function(){a.emit("viewport.transform",{zoom:1,animated:!0})});d.setTooltip("viewer","ZoomInCursor");c.addButton(d);d=new i(a,"ZoomOutButton","icon icon-WCR_WF-ZoomOut",!1,function(){a.emit("viewport.transform",{zoom:-1,animated:!0})});d.setTooltip("viewer","ZoomOutCursor");c.addButton(d);var e=new q(a,"ZoomToFitButton","icon icon-WCR_WF-ZoomFit",!1,function(){a.emit("viewport.zoomToFit",{animated:!0})});e.setTooltip("viewer","ZoomFitToPage");
c.addButton(e);this._zoomOneToOneButton=new q(a,"ZoomOneToOne","icon icon-WCR_Zoom1",!1,f.bind(this._zoomOneToOne,this));c.addButton(this._zoomOneToOneButton);d=new i(a,"PanButton","icon icon-WCR_Pan",!1);d.setTooltip("viewer","PanBtnTT");d.listenToTool(g);c.addButton(d);c=new k("RotFlipGroup");c.setTitle(a.i18n,"viewer","RotateBtnGroupTitle");b.addButtonGroup(c);this._rotateButton=new i(a,"RotateButton","icon icon-WCR_Orientation-Rotate1",!0,f.bind(function(a){var b=90;a.shiftKey&&(b=-90);this.f.emit("viewport.transform",
{rotate:b,animated:{interrupt:!0}})},this));c.addButton(this._rotateButton);this._flipButton=new i(a,"FlipButton","icon icon-WCR_Orientation-Mirror",!0,f.bind(function(){this._doToggleFlip()},this));c.addButton(this._flipButton);this.f.loadBundle("viewer",function(){e.addAction({name:"zoomFitWidth",content:a.i18n.t("ZoomFitWidth"),icon:"icon icon-WCR_Zoom-FitWidth",action:function(){a.emit("viewport.zoomToFitWidth",{animated:!0})}});e.addAction({name:"zoomFitHeight",content:a.i18n.t("ZoomFitHeight"),
icon:"icon icon-WCR_Zoom-FitHeight",action:function(){a.emit("viewport.zoomToFitHeight",{animated:!0})}});this._zoomOneToOneButton.addAction({name:"zoomOneToOnePixel",content:a.i18n.t("ZoomOneToOnePixel"),icon:"icon icon-WCR_ZoomPx",action:f.bind(this._zoomOneToOnePixel,this)});this._zoomOneToOneButton.addAction({name:"zoomOneToOneRealSize",content:a.i18n.t("ZoomOneToOneRealSize"),icon:"icon icon-WCR_Zoom1",action:f.bind(this._zoomOneToOneRealSize,this)});this._zoomOneToOneButton.addDivider();this._zoomOneToOneButton.addAction({name:"adjustMonitorResolution",
content:a.i18n.t("ZoomOneToOneAdjustRes"),action:f.bind(this._adjustMonitorResolution,this)});this._updateZoomOneToOneButton();this.f.getCurrentUser().on("options.changed.PREFERENCES_ZOOM_REALSIZE",f.bind(this._updateZoomOneToOneButton,this));this.f.getDocumentController().whenActivePageChanged(f.bind(this._updateZoomOneToOneButton,this));this._updateRotateButton();this.f.on("transform.viewportWidget.rotated",f.bind(this._updateRotateButton,this));this._updateFlipButton();this.f.on("transform.viewportWidget.flipped",
f.bind(this._updateFlipButton,this))},this);return b},this));s.bind("ctrl+m",f.bind(function(a){this._doToggleFlip();a.preventDefault();a.stopPropagation()},this),"keydown");s.bind(["ctrl+alt+plus","ctrl+alt+="],f.bind(function(a){this.f.emit("viewport.transform",{rotate:90,animated:{interrupt:!0}});a.preventDefault();a.stopPropagation()},this));s.bind("ctrl+alt+-",f.bind(function(a){this.f.emit("viewport.transform",{rotate:-90,animated:{interrupt:!0}});a.preventDefault();a.stopPropagation()},this))}};
t.prototype._doToggleFlip=function(){var a=this.f.getModule("viewport");a&&(0===a.getRotation()%180?this.f.emit("viewport.transform",{flip:!0,animated:!1}):this.f.emit("viewport.transform",{rotate:180,flip:!0,animated:!1}))};t.prototype._updateRotateButton=function(){var a=["icon icon-WCR_Orientation-Rotate1","icon icon-WCR_Orientation-Rotate2","icon icon-WCR_Orientation-Rotate3","icon icon-WCR_Orientation-Rotate4"],b=["Rotate90TT","Rotate180TT","Rotate270TT","Rotate0TT"],c=this.f.getModule("viewport");
c&&this._rotateButton&&(c=(c.getRotation()+this._extraRotation)/90%4,this._rotateButton.setIcon(a[c]),this._rotateButton.setTooltip("viewer",b[c]))};t.prototype.setExtraRotation=function(a){this._extraRotation=a;this._updateRotateButton()};t.prototype.resetExtraRotation=function(){this._extraRotation=0;this._updateRotateButton()};t.prototype._updateFlipButton=function(){var a=this.f.getModule("viewport");a&&this._flipButton&&(a.isFlip()?(this._flipButton.setIcon("icon icon-WCR_Orientation-MirrorReverse"),
this._flipButton.setTooltip("viewer","MirrorTT2")):(this._flipButton.setIcon("icon icon-WCR_Orientation-Mirror"),this._flipButton.setTooltip("viewer","MirrorTT")))};t.prototype._isZoomOneToOnePixel=function(){return this.f.getActivePage().hasGraphics()&&this.f.getOption("PREFERENCES_ZOOM_REALSIZE")===h.ZoomOneToOneClick.AUTO};t.prototype._updateZoomOneToOneButton=function(){this._zoomOneToOneButton&&(this._isZoomOneToOnePixel()?(this._zoomOneToOneButton.setTooltip("viewer","ZoomOneToOnePixel"),this._zoomOneToOneButton.setIcon("icon icon-WCR_ZoomPx")):
(this._zoomOneToOneButton.setTooltip("viewer","ZoomOneToOneRealSize"),this._zoomOneToOneButton.setIcon("icon icon-WCR_Zoom1")),this.f.getActivePage().hasGraphics()?this._zoomOneToOneButton.setActionEnabled("zoomOneToOnePixel",!0):this._zoomOneToOneButton.setActionEnabled("zoomOneToOnePixel",!1))};t.prototype._adjustMonitorResolution=function(){void 0===this._adjustMonitorResolutionPopup&&(this._adjustMonitorResolutionPopup=new n(this.f,"adjustMonitorResulutionPopup",this));this._adjustMonitorResolutionPopup.show()};
t.prototype._zoomOneToOne=function(){this._isZoomOneToOnePixel()?this._zoomOneToOnePixel():this._zoomOneToOneRealSize()};t.prototype._zoomOneToOnePixel=function(){this.f.getActivePage().hasGraphics()&&this.f.setOption("PREFERENCES_ZOOM_REALSIZE",h.ZoomOneToOneClick.AUTO);this.f.emit("viewport.zoomOneToOne",{animated:!0})};t.prototype._zoomOneToOneRealSize=function(){this.f.getActivePage().hasGraphics()&&this.f.setOption("PREFERENCES_ZOOM_REALSIZE",h.ZoomOneToOneClick.REALSIZE);this.f.emit("viewport.zoomOneToOne",
{animated:!0,worldResolution:this.getMonitorResolution()})};t.prototype.getMonitorResolution=function(){return void 0!==this._monitorResolution?this._monitorResolution:m.parseFloat(this.f.getOption("PREFERENCE_MONITOR_RES"))};t.prototype.setMonitorResolution=function(a){this._monitorResolution=a};t.prototype.okMonitorResolution=function(){this.f.setOption("PREFERENCE_MONITOR_RES",this.getMonitorResolution()+"");this._monitorResolution=void 0;this._zoomOneToOneRealSize();this._adjustMonitorResolutionPopup.hide()};
t.prototype.cancelMonitorResolution=function(){this._monitorResolution=void 0};return t});define("web-viewer/pagelist/PagelistConstants",{viewerThumbSize:{SMALL:0,MEDIUM:1,LARGE:2},thumbWidth:{SMALL:75,MEDIUM:100,LARGE:150},binding:{RIGHT:0,LEFT:1}});
define("web-viewer/print/PrintConstants",{PrintType:{PRINTCURRENTVIEW:0,PRINTIMAGEAREA:1,PRINTANNOTATIONOVERVIEW:2},PrintArea:{PRINTENTIREIMAGE:0,PRINTCURRENTVIEWAREA:1,PRINTCURRENTSELECTION:2},PrintChannels:{PRINTALLCHANNELS:0,PRINTSELECTEDCHANNELS:1},PrintAnnotationsSource:{PRINTANNOTATIONSCURRENT:0,PRINTANNOTATIONSREFERENCE:1}});
define("web-viewer/utils/LineworkPoint",["underscore"],function(){var f=function(){this.type=-1;this.v5=this.v4=this.v3=this.v2=this.v1=this.y=this.x=0};f.prototype.makeMoveTo=function(f,e){this.type=0;this.x=f;this.y=e};f.prototype.makeLineTo=function(f,e){this.type=1;this.x=f;this.y=e};f.prototype.makeBezier=function(f,e,d,c,b,a){this.type=2;this.x=f;this.y=e;this.v1=d;this.v2=c;this.v3=b;this.v4=a};f.prototype.makeArc=function(f,e,d,c,b,a,h){this.type=3;this.x=f;this.y=e;this.v1=d;this.v2=c;this.v3=
b;this.v4=a;this.v5=h};f.prototype.makeNick=function(f,e,d,c,b){this.type=4;this.x=f;this.y=e;this.v1=d;this.v2=c;this.v3=b};return f});
define("web-viewer/utils/LineWorkWrapper",["underscore","utils/ShapeUtils","web-viewer/core/Extendable","web-viewer/utils/DrawUtils","web-viewer/utils/LineworkPoint"],function(f,g,e,d){var c=function(){e.installTo(this);this.fillcolor=this.c=this.color=null;this.pointArray=[];this.rect=new g.Rect;this.type=0;this.linewidth=1;this.imageRef=this.imagetouchspot=this.imagehotspot=null;this.treatAsOutline=!1;this.textoptions={};this.showIndicator=this.selected=!1;this.indicatorColor=this.indicatorTextColor=
this.indicatorText=null;this.snapable=!1};c.prototype.move=function(b){this.rect.origin.x+=b.width;this.rect.origin.y+=b.height;if(this.pointArray&&0<this.pointArray.length)for(var a=0;a<this.pointArray.length;a++){var c=this.pointArray[a];c.x+=b.width;c.y+=b.height}};c.prototype.setRect=function(b,a){if(a&&this.pointArray&&2==this.pointArray.length){var c=b.topleft(),d=b.bottomright();this.pointArray[0].x==c.x&&this.pointArray[0].y==c.y||this.pointArray[0].x==this.pointArray[1].x&&this.pointArray[0].y==
this.pointArray[1].y?(this.pointArray[0].x=c.x,this.pointArray[0].y=c.y,this.pointArray[1].x=d.x,this.pointArray[1].y=d.y):(this.pointArray[1].x=c.x,this.pointArray[1].y=c.y,this.pointArray[0].x=d.x,this.pointArray[0].y=d.y)}this.rect=b};c.prototype.setStartEnd=function(b,a){this.pointArray&&2==this.pointArray.length&&(b?(this.pointArray[0].x=b.x,this.pointArray[0].y=b.y):b=new g.Point(this.pointArray[0].x,this.pointArray[0].y),a?(this.pointArray[1].x=a.x,this.pointArray[1].y=a.y):a=new g.Point(this.pointArray[1].x,
this.pointArray[1].y),this.setRect(new g.Rect(b,b.sizeTo(a))))};c.prototype.rgbaColor=function(b){var a=this.rgbColor();return"rgba("+a.r+","+a.g+","+a.b+","+b+")"};c.prototype.rgbColor=function(){var b=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(this.color);return b?{r:parseInt(b[1],16),g:parseInt(b[2],16),b:parseInt(b[3],16)}:null};c.prototype.calculateRectFromPointArray=function(){for(var b=null,a=null,c=null,d=null,e=0;e<this.pointArray.length;e++){var f=this.pointArray[e];if(!b||f.x<b)b=
f.x;if(!a||f.x>a)a=f.x;if(!c||f.y<c)c=f.y;if(!d||f.y>d)d=f.y}b=new g.Rect(new g.Point(b,c),new g.Size(a-b,d-c));b.normalize();this.rect=b};c.prototype.selectionAnchorPoint=function(b,a,e,f){var j=new c;j.type=d.LWTYPE_ELLIPSE;j.color=e;j.fillcolor=a;j.staticsize=!0;j.linewidth=1;j.rect=new g.Rect(new g.Point(b.x-5,b.y-5),new g.Size(10,10));j.anchor=f;j.linework=this;return j};c.prototype.getSelectionBox=function(){if(this.pointArray&&2<=this.pointArray.length)return[this.selectionAnchorPoint(new g.Point(this.pointArray[0].x,
this.pointArray[0].y),"rgb(153,152,187)","white",d.LWANCHOR_START),this.selectionAnchorPoint(new g.Point(this.pointArray[this.pointArray.length-1].x,this.pointArray[this.pointArray.length-1].y),"rgb(153,152,187)","white",d.LWANCHOR_END)];var b=[this.selectionAnchorPoint(this.rect.topleft(),"rgb(153,152,187)","white",d.LWANCHOR_TOPLEFT),this.selectionAnchorPoint(this.rect.topright(),"rgb(153,152,187)","white",d.LWANCHOR_TOPRIGHT),this.selectionAnchorPoint(this.rect.bottomleft(),"rgb(153,152,187)",
"white",d.LWANCHOR_BOTTOMLEFT),this.selectionAnchorPoint(this.rect.bottomright(),"rgb(153,152,187)","white",d.LWANCHOR_BOTTOMRIGHT),this.selectionAnchorPoint(this.rect.topcenter(),"rgb(153,152,187)","white",d.LWANCHOR_TOPCENTER),this.selectionAnchorPoint(this.rect.bottomcenter(),"rgb(153,152,187)","white",d.LWANCHOR_BOTTOMCENTER),this.selectionAnchorPoint(this.rect.centerleft(),"rgb(153,152,187)","white",d.LWANCHOR_CENTERLEFT),this.selectionAnchorPoint(this.rect.centerright(),"rgb(153,152,187)","white",
d.LWANCHOR_CENTERRIGHT)];return f.union(b)};c.prototype.scale=function(b){b&&(f.each(this.pointArray,function(a){a.x*=b.x;a.y*=b.y}),this.rect.origin.x*=b.x,this.rect.origin.y*=b.y,this.rect.size.width*=b.x,this.rect.size.height*=b.y)};return c});
define("web-viewer/core/AbstractConfig",["web-viewer/data/AbstractDataAdapter","web-viewer/core/Extendable"],function(f,g){var e=function(){g.installTo(this);this.properties={}};e.prototype.set=function(d,c){this.properties[d]=c};e.prototype.get=function(d){return this.properties[d]};e.prototype.initializeAdapter=function(d){return this.adapter=new f(d)};e.prototype.getUser=function(){};e.prototype.getModules=function(){return[]};return e});
define("web-viewer/viewControls/ViewControlsConstants",{compensateDist:{DISTONLY:1,SCALEONLY:2,DISTANDSCALE:3},trimboxMode:{ONCURRENTPAGE:0,ONBOTHINREADERSPREAD:1},marginClipMode:{CLIP_OFF:0,CLIP_IN_READERSPREAD:1,CLIP:2}});
define("web-viewer/webcenter/WebCenterDocumentPage","web-viewer/data/AbstractDocumentPage utils/XMLUtils web-viewer/utils/ViewerUtils utils/ShapeUtils web-viewer/data/DataConstants web-viewer/viewControls/ViewControlsConstants underscore".split(" "),function(f,g,e,d,c,b,a){g=function(b,d,e,g,i,q){f.call(this,b,d,e);this._adapter=q;this.documentType=this.getDocument().getDocumentType();this._pageVersionId=null;void 0!==i&&void 0!==i.pageindex&&(this._pageVersionId=i.docversion);void 0!==i&&void 0!==
i.blank&&(this._isBlankPage=!0);void 0!==i&&(this.set("canChangeAnnotations",i.can_change_annotations),this.set("canEditAttributes",i.can_edit_attributes),this.set("attributeCategoryID",i.attribute_category_id));if(this.documentType===c.documentPageType.GRAPHICS&&void 0!==g&&void 0!==i)this.set("hasDefaultData",i.hasDefaultData),this.set("margbot",i.margbot),this.set("margtop",i.margtop),this.set("margleft",i.margleft),this.set("margright",i.margright),this.set("vsize",i.vsize),this.set("hsize",i.hsize),
this.set("hasCorrectMargin",!d.isPageList()),this.set("docversionid",g.docversionid),this.set("pageDocversionid",i.docversionid),void 0===g.file?this.set("file",i.file):this.set("file",g.file),this.set("offsetx",i.offsetx),this.set("offsety",i.offsety),this.set("pageindex",i.pageindex),this.set("pagename",i.pagename),this.set("hscale",i.hscale),this.set("vscale",i.vscale),this.set("hdist",i.hdist),this.set("vdist",i.vdist),this.set("has3DPerspective","1"==g.has3DPerspective?!0:!1),this.set("canGenerate3D",
"1"==g.canGenerate3D?!0:!1),this.set("document_approval_code",i.document_approval_code),this.set("user_approval_code",i.user_approval_code),void 0!==i.cadregedit&&(this.set("cadregedit",i.cadregedit),this.set("isCadAlignmentSaved",1==i.saved?!0:!1));else if(this.documentType===c.documentPageType.CAD&&void 0!==g&&void 0!==i){this.set("cad",g.file);this.set("pageDocversionid",i.docversionid);a.isArray(i.style)?this.set("style",i.style[0]):this.set("style",i.style);if(i.metadata&&(i.metadata.design||
i.metadata.layout))b=i.metadata.design||i.metadata.layout,this.set("grainDirection",b.grain_direction),this.set("defaultSide",b.default_side),this.set("dieSide",b.die_side);this.setPageAlignmentData(i);this.set("docversionid",g.docversionid);this.set("has3DPerspective","1"==g.has3DPerspective?!0:!1);this.set("canGenerate3D","1"==g.canGenerate3D?!0:!1)}else void 0!==g&&void 0!==g.file&&(this.set("file",g.file),this._pageVersionId=g.docversion,this.set("hasCorrectMargin",!1));void 0!==i&&this.set("diffversion",
i.diffversion?!0:!1)};g.prototype=Object.create(f.prototype);g.prototype.constructor=g;g.prototype.setPageAlignmentData=function(a){this.set("offsetx",a.offsetx);this.set("offsety",a.offsety);e.isCloseTo(this._data.offsetx,0,7)&&this.set("offsetx",0);e.isCloseTo(this._data.offsety,0,7)&&this.set("offsety",0);void 0!==a.orientation&&(this.set("overlayIsFlipped",0<(+a.orientation&4)),this.set("overlayRotation",90*(4-a.orientation%4)%360))};g.prototype.getMargins=function(){var a={};a.bottom=e.parseFloat(this._data.margbot?
this._data.margbot:0);a.top=e.parseFloat(this._data.margtop?this._data.margtop:0);a.left=e.parseFloat(this._data.margleft?this._data.margleft:0);a.right=e.parseFloat(this._data.margright?this._data.margright:0);return a};g.prototype.getDocumentPageOrigin=function(){var a=this.getRotation()%360,b=this.isFlipped(),c=this.getMargins(),e=this.getParam("fileminx"),f=this.getParam("fileminy");90===a?(e-=c.bottom,f=b?f-c.right:f-c.left):180===a?(f-=c.bottom,e=b?e-c.left:e-c.right):270===a?(e-=c.top,f=b?
f-c.left:f-c.right):(f-=c.top,e=b?e-c.right:e-c.left);return new d.Point(e,f)};g.prototype.getTrimboxRect=function(){var a,b;this.isBlankPage()?(a=this.getMargins(),a=new d.Point(a.left,a.top),b=new d.Size(e.parseFloat(this.get("hsize")),e.parseFloat(this.get("vsize")))):(a=new d.Point(e.parseFloat(this.getParam("fileminx")),e.parseFloat(this.getParam("fileminy"))),b=new d.Size(e.parseFloat(this.getParam("filemaxx"))-a.x,e.parseFloat(this.getParam("filemaxy"))-a.y));return new d.Rect(a,b)};g.prototype.getPageSize=
function(){var a=this.getMargins();if(this.hasGraphics()){if(1E-9<Math.abs(e.parseFloat(this.get("hsize")))){var a=new d.Size(e.parseFloat(this.get("hsize"))+a.left+a.right,e.parseFloat(this.get("vsize"))+a.bottom+a.top),b=this.getCurrentScaling();b&&(a.width*=b.x,a.height*=b.y);return a}return new d.Size(e.parseFloat(this.getParam("sizex")),e.parseFloat(this.getParam("sizey")))}if(this.isBlankPage())return this.isReaderSpread()?(a=this.getMargins(),b=this.getTrimboxSize(),new d.Size(b.width+a.left+
a.right,b.height+a.top+a.bottom)):new d.Size(this.getParam("filemaxx")+a.left+a.right,this.getParam("filemaxy")+a.top+a.bottom);if(this.hasCad())return this.isCadAvailable&&this.isCadAvailable()?this.getCad().getSize():new d.Size};g.prototype.getMediaBoxRect=function(){var a=new d.Point(e.parseFloat(this.getParam("filemedminx")),e.parseFloat(this.getParam("filemedminy"))),b=new d.Size(e.parseFloat(this.getParam("filemedmaxx"))-a.x,e.parseFloat(this.getParam("filemedmaxy"))-a.y);return new d.Rect(a,
b)};g.prototype.getCurrentScaling=function(){var a=1,c=1;if(this.getStateParam("compensateDist")===b.compensateDist.DISTONLY||this.getStateParam("compensateDist")===b.compensateDist.DISTANDSCALE)a=1*a/e.parseFloat(this.get("vdist")),c=1*c/e.parseFloat(this.get("hdist"));if(this.getStateParam("compensateDist")===b.compensateDist.SCALEONLY||this.getStateParam("compensateDist")===b.compensateDist.DISTANDSCALE)a=1*a/e.parseFloat(this.get("vscale")),c=1*c/e.parseFloat(this.get("hscale"));return 1===a&&
1===c?null:new d.Point(c,a)};g.prototype.getInfoURL=function(a){return this._adapter.ViewServer("info.jsp",a)};g.prototype.isRectOnPage=function(a){var b=this.getMargins(),c=this.getPageSize(),c=new d.Rect(new d.Point(0,0),c);c.origin.offset(new d.Size(-b.left,-b.bottom));return c.rectIntersect(a)};g.prototype.getPageVersionId=function(){return this._pageVersionId};g.prototype.isDigitalFilmPage=function(){return this.hasGraphics()&&this.getParam("imagetype")===c.imageType.OTHER};g.prototype.getTrimboxSize=
function(){var a=e.parseFloat(this.get("hsize")),b=e.parseFloat(this.get("vsize"));return!a||!b?new d.Size:new d.Size(a,b)};g.prototype.getThumbnailUrl=function(){var a;if(this.hasGraphics())return a={file:this._data.file,px:50,py:50},this.f.getDataAdapter().ViewServer("thumbdata.jsp",a);if(this.hasCad())return a={docverid:this._docVersion.get("docversionid")},this.f.getDataAdapter().WebCenter("docgetthumbdata.jsp",a)};g.prototype.getInformationForDocumentSelector=function(){var a=this.getDocument(),
b=this.getDocumentVersion(),c={};c.documentName=a.get("docname");c.project=a.get("projectname");if(a.hasMultipleVersions()){c.versionNumber=this.getPageVersionId();if(void 0===c.versionNumber||null===c.versionNumber)c.versionNumber=b.getVersionId();c.versionNumber&&b.get("docRevision")&&(c.versionNumber+="("+b.get("docRevision")+")");c.versionId=b.getVersionId()}b=b.getPageCount();1<b&&(c.pageCount=b,c.pageNumber=this.getPagenum());c.thumbnailUrl=this.getThumbnailUrl();c.pageId=this.getUniqueID();
c.docType=a.getDocumentType();return c};g.prototype.canSaveCadOverlay=function(){return 1==this.get("cadregedit")};g.prototype.canEditAttributes=function(){return 1==this.get("canEditAttributes")};g.prototype.getAttributeCategoryID=function(){return this.get("attributeCategoryID")};g.prototype.needsDataUpdate=function(){return this.get("hasDefaultData")};g.prototype.canChangeAnnotations=function(){return 1==this.get("canChangeAnnotations")};return g});
define("web-viewer/webcenter/WebCenterDocumentVersion","web-viewer/data/AbstractDocumentVersion web-viewer/data/AbstractDocumentPage web-viewer/webcenter/WebCenterDocumentPage utils/XMLUtils web-viewer/utils/ViewerUtils underscore".split(" "),function(f,g,e,d,c,b){g=function(a,c,d,g,k,i){f.call(this,a,c,d);this._adapter=i;this._versionData.docversionid=g.docversionid;this._versionData.docversion=d;this._versionData.isMultiPage=void 0!==g.isMultiPage?g.isMultiPage:!1;b.isString(this._versionData.isMultiPage)&&
(this._versionData.isMultiPage="true"===this._versionData.isMultiPage?!0:!1);this._versionData.isPageList=void 0!==g.isPageList?g.isPageList:!1;b.isString(this._versionData.isPageList)&&(this._versionData.isPageList="true"===this._versionData.isPageList?!0:!1);this._versionData.docRevision=g.docrevision;void 0!==k&&void 0!==k.pagecount&&(this._versionData.pagecount=k.pagecount);!b.isArray(g)&&void 0!==g&&(c=1,k&&(c=k.pageno||1),a=new e(a,this,c,g,k,i),this.addPage(c,a))};g.prototype=Object.create(f.prototype);
g.prototype.constructor=g;g.prototype.addDocumentPageFromData=function(a){var b=new e(this._f,this,a.pageno,this._versionData,a,this._adapter);this.addPage(b.getPagenum(),b);void 0!==a.pagecount&&(this._versionData.pagecount=parseInt(a.pagecount))};g.prototype.isMultiPage=function(){return 1<this.getPageCount()||this._versionData.isMultiPage};g.prototype.getDocumentVersionID=function(){return this.get("docversionid")};g.prototype.getPageCount=function(){return this.get("pagecount")?this.get("pagecount"):
this._versionData.isMultiPage?this._pages.length-1:1};return g});
define("web-viewer/webcenter/WebCenterDocument","web-viewer/data/AbstractDocument web-viewer/data/DataConstants underscore web-viewer/webcenter/WebCenterDocumentVersion web-viewer/webcenter/WebCenterDocumentPage utils/XMLUtils".split(" "),function(f,g,e,d,c){var b=function(a,b,c,d,e){f.call(this,a,c,d);this.f=a;this._adapter=e;void 0!==b&&this._initializeWithDocInfo(b)};b.prototype=Object.create(f.prototype);b.prototype.constructor=b;b.prototype.addDocumentPageFromData=function(a){var b=this.getDocumentVersion(a.docversion);
if(void 0!==b&&a.docversionid===b._versionData.docversionid)b.addDocumentPageFromData(a);else if(a.isMultiPage&&void 0!==a.pageindex)if(b=this.getDocumentVersion(),b.addDocumentPageFromData(a),a.docversion>b.getVersionId()){var e=b.getVersionId();b._versionData.docversionid=a.docversionid;b._versionData.docversion=a.docversion;b._versionId=a.docversion;this._documentVersions[a.docversion]=b;delete this._documentVersions[e]}else a.docversion===b.getVersionId()&&a.docversionid>b._versionData.docversionid&&
(b._versionData.docversionid=a.docversionid,this._documentVersions[a.docversion]=b);void 0!==a.diff&&(b=this.getDocumentVersion(a.diffversion),void 0===b&&(b=new d(this.f,this,a.diffversion,{},void 0,this._adapter),this.addDocumentVersion(b)),e=new c(this.f,b,a.pageno,{file:a.diff},void 0,this._adapter),b.addPage(a.pageno,e))};b.prototype._initializeWithDocInfo=function(a){this.set("docid",a.docid);this.set("projectid",a.projectid);this.set("projectname",a.projectname+"");this.set("binding",a.binding);
if(this._documentType===g.documentPageType.GRAPHICS){var b={};b.docversionid=a.docversionid;this.set("docname",a.docname+"");this.set("projectname",a.projectname+"");b.file=a.file;b.isPageList=void 0!==a.pageindex;b.docrevision=a.docrevision;b=new d(this.f,this,a.docversion,b,a,this._adapter);this.addDocumentVersion(b);a.cadversionid&&this.set("linkedCADVersionID",a.cadversionid);if(a.isMultiPage&&void 0===a.versionlist&&void 0===a.pageindex){for(b=1;b<parseInt(a.docversion,10);b++){var f=new d(this.f,
this,b,{isMultiPage:a.isMultiPage},void 0,this._adapter);this.addDocumentVersion(f)}void 0!==a.diff&&(b=this.getDocumentVersion(a.diffversion),f=new c(this.f,b,a.pageno,{file:a.diff},void 0,this._adapter),b.addPage(a.pageno,f));a.pageNumber=1;this._adapter.loadVersionsOfDocumentPage(a,this,e.bind(function(){this.f.getDocumentController().loadedDocumentChanged()},this))}void 0!==a.versionlist&&(e.isArray(a.versionlist)||(a.versionlist=[a.versionlist]),e.each(a.versionlist,e.bind(function(a){a=new d(this.f,
this,a.docversion,a,void 0,this._adapter);this.addDocumentVersion(a)},this)))}else this._documentType===g.documentPageType.CAD&&(a.caddocname?this.set("docname",a.caddocname+""):this.set("docname",a.docname+""),void 0!==a.cadversionlist?(e.isArray(a.cadversionlist)||(a.cadversionlist=[a.cadversionlist]),e.each(a.cadversionlist,e.bind(function(b){b=new d(this.f,this,b.docversion,b,a,this._adapter);this.addDocumentVersion(b)},this))):void 0!==a.versionlist&&(e.isArray(a.versionlist)||(a.versionlist=
[a.versionlist]),e.each(a.versionlist,e.bind(function(b){b=new d(this.f,this,b.docversion,b,a,this._adapter);this.addDocumentVersion(b)},this))))};b.prototype.loadVersionsForDocumentPage=function(a,b){var c={docid:a.getDocument().getDocumentID(),docversionid:a.getDocumentVersion().getDocumentVersionID(),diffversion:null,pageNumber:a.getPagenum(),isPageList:a.getDocumentVersion().isPageList()};this._adapter.loadVersionsOfDocumentPage(c,this,b,a)};b.prototype.getDocumentID=function(){return this.get("docid")};
b.prototype.getProjectID=function(){return this.get("projectid")};return b});
define("web-viewer/utils/LineworkWrapper",["underscore","utils/ShapeUtils","web-viewer/core/Extendable","web-viewer/utils/DrawUtils","web-viewer/utils/LineworkPoint"],function(f,g,e,d){var c=function(){e.installTo(this);this.fillcolor=this.c=this.color=null;this.pointArray=[];this.rect=new g.Rect;this.type=0;this.linewidth=1;this.imageRef=this.imagetouchspot=this.imagehotspot=null;this.treatAsOutline=!1;this.textoptions={};this.showIndicator=this.selected=!1;this.indicatorColor=this.indicatorTextColor=
this.indicatorText=null;this.snapable=!1};c.prototype.move=function(b){this.rect.origin.x+=b.width;this.rect.origin.y+=b.height;if(this.pointArray&&0<this.pointArray.length)for(var a=0;a<this.pointArray.length;a++){var c=this.pointArray[a];c.x+=b.width;c.y+=b.height}};c.prototype.setRect=function(b,a){if(a&&this.pointArray&&2==this.pointArray.length){var c=b.topleft(),d=b.bottomright();this.pointArray[0].x==c.x&&this.pointArray[0].y==c.y||this.pointArray[0].x==this.pointArray[1].x&&this.pointArray[0].y==
this.pointArray[1].y?(this.pointArray[0].x=c.x,this.pointArray[0].y=c.y,this.pointArray[1].x=d.x,this.pointArray[1].y=d.y):(this.pointArray[1].x=c.x,this.pointArray[1].y=c.y,this.pointArray[0].x=d.x,this.pointArray[0].y=d.y)}this.rect=b};c.prototype.setStartEnd=function(b,a){this.pointArray&&2==this.pointArray.length&&(b?(this.pointArray[0].x=b.x,this.pointArray[0].y=b.y):b=new g.Point(this.pointArray[0].x,this.pointArray[0].y),a?(this.pointArray[1].x=a.x,this.pointArray[1].y=a.y):a=new g.Point(this.pointArray[1].x,
this.pointArray[1].y),this.setRect(new g.Rect(b,b.sizeTo(a))))};c.prototype.rgbaColor=function(b){var a=this.rgbColor();return"rgba("+a.r+","+a.g+","+a.b+","+b+")"};c.prototype.rgbColor=function(){var b=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(this.color);return b?{r:parseInt(b[1],16),g:parseInt(b[2],16),b:parseInt(b[3],16)}:null};c.prototype.calculateRectFromPointArray=function(){for(var b=null,a=null,c=null,d=null,e=0;e<this.pointArray.length;e++){var f=this.pointArray[e];if(!b||f.x<b)b=
f.x;if(!a||f.x>a)a=f.x;if(!c||f.y<c)c=f.y;if(!d||f.y>d)d=f.y}b=new g.Rect(new g.Point(b,c),new g.Size(a-b,d-c));b.normalize();this.rect=b};c.prototype.selectionAnchorPoint=function(b,a,e,f){var j=new c;j.type=d.LWTYPE_ELLIPSE;j.color=e;j.fillcolor=a;j.staticsize=!0;j.linewidth=1;j.rect=new g.Rect(new g.Point(b.x-5,b.y-5),new g.Size(10,10));j.anchor=f;j.linework=this;return j};c.prototype.getSelectionBox=function(){if(this.pointArray&&2<=this.pointArray.length)return[this.selectionAnchorPoint(new g.Point(this.pointArray[0].x,
this.pointArray[0].y),"rgb(153,152,187)","white",d.LWANCHOR_START),this.selectionAnchorPoint(new g.Point(this.pointArray[this.pointArray.length-1].x,this.pointArray[this.pointArray.length-1].y),"rgb(153,152,187)","white",d.LWANCHOR_END)];var b=[this.selectionAnchorPoint(this.rect.topleft(),"rgb(153,152,187)","white",d.LWANCHOR_TOPLEFT),this.selectionAnchorPoint(this.rect.topright(),"rgb(153,152,187)","white",d.LWANCHOR_TOPRIGHT),this.selectionAnchorPoint(this.rect.bottomleft(),"rgb(153,152,187)",
"white",d.LWANCHOR_BOTTOMLEFT),this.selectionAnchorPoint(this.rect.bottomright(),"rgb(153,152,187)","white",d.LWANCHOR_BOTTOMRIGHT),this.selectionAnchorPoint(this.rect.topcenter(),"rgb(153,152,187)","white",d.LWANCHOR_TOPCENTER),this.selectionAnchorPoint(this.rect.bottomcenter(),"rgb(153,152,187)","white",d.LWANCHOR_BOTTOMCENTER),this.selectionAnchorPoint(this.rect.centerleft(),"rgb(153,152,187)","white",d.LWANCHOR_CENTERLEFT),this.selectionAnchorPoint(this.rect.centerright(),"rgb(153,152,187)","white",
d.LWANCHOR_CENTERRIGHT)];return f.union(b)};c.prototype.scale=function(b){b&&(f.each(this.pointArray,function(a){a.x*=b.x;a.y*=b.y}),this.rect.origin.x*=b.x,this.rect.origin.y*=b.y,this.rect.size.width*=b.x,this.rect.size.height*=b.y)};return c});
define("web-viewer/cad/CadLine","web-viewer/utils/LineworkWrapper web-viewer/utils/LineworkPoint utils/ShapeUtils utils/XMLUtils web-viewer/utils/ViewerUtils web-viewer/utils/DrawUtils web-viewer/cad/CadConstants".split(" "),function(f,g,e,d,c,b,a){b=function(b,n,j){f.call(this);"Nicks"==b.nodeName?(this.type=a.CadTypes.Nick,this.linewidth=1,this.color="black"):this.type=d.attributeValue(b,"linetype");var k=d.attributeValue(b,"bridgeopt");k&&(this.bridgeopt=parseInt(k,10));if(null===this.type)n=d.attributeValue(b,
"stroke"),null!==n&&(this.color=n);else if(n=n[this.type])this.c=n.color,this.color="#"+c.rgbToHex(this.c.r,this.c.g,this.c.b),this.linewidth=n.width/4,"0"!==n.style&&(this.dash=a.LineTypes[n.style]);this.fillcolor=d.attributeValue(b,"fill");"none"===this.fillcolor&&(this.fillcolor=null);this.fillcolor&&"none"===d.attributeValue(b,"stroke")&&(this.linewidth=1);var i=d.attributeValue(b,"d");this.pointArray=[];for(var q=k=n=b=null,i=i.match(/[a-z][^a-z]*/ig),l=0;l<i.length;l++){var m=new g,s=c.trim(i[l]),
t=null,v=null,o=null,w=null,p=s.charAt(0);if("A"==p){var s=RegExp(/A\s(.+)\s(.+)\s(.+)\s(.+)\s(.+)\s(.+)\s(.+)/).exec(s),t=c.parseFloat(s[1]),v=c.parseFloat(s[2]),o=c.parseFloat(s[3]),w=c.parseFloat(s[4]),r=c.parseFloat(s[5]),p=c.parseFloat(s[6]),s=c.parseFloat(s[7]);m.makeArc(p,j-s,t,v,o,w,r);v=t=m.x;w=o=m.y}else if("C"==p){var t=RegExp(/C\s(.+)\s(.+)\s(.+)\s(.+)\s(.+)\s(.+)/).exec(s),p=c.parseFloat(t[1]),s=c.parseFloat(t[2]),r=c.parseFloat(t[3]),z=c.parseFloat(t[4]),u=c.parseFloat(t[5]),x=c.parseFloat(t[6]),
t=Math.min(p,r,u),v=Math.max(p,r,u),o=Math.min(j-s,j-z,j-x),w=Math.max(j-s,j-z,j-x);m.makeBezier(p,j-s,r,j-z,u,j-x)}else if("N"==p)o=RegExp(/N(.+)\s(.+)\s(.+)\s(.+)\s(.+)/).exec(s),p=c.parseFloat(o[1]),s=c.parseFloat(o[2]),t=c.parseFloat(o[3]),v=c.parseFloat(o[4]),o=c.parseFloat(o[5]),m.makeNick(p,j-s,t,v,o),v=t=m.x,w=o=m.y;else if("L"==p||"M"==p)t=RegExp(/.(.+)\s(.+)/).exec(s),s=c.parseFloat(t[1]),t=j-c.parseFloat(t[2]),"L"==p?m.makeLineTo(s,t):m.makeMoveTo(s,t),v=t=m.x,w=o=m.y;if(-1!=m.type){this.pointArray.push(m);
if(null===b||t<b)b=t;if(null===n||v>n)n=v;if(null===k||o<k)k=o;if(null===q||w>q)q=w}}j=new e.Rect(new e.Point(b,k),new e.Size(n-b,q-k));j.normalize();this.rect=j};b.prototype=Object.create(f.prototype);return b.prototype.constructor=b});
define("web-viewer/cad/CadText",["web-viewer/utils/LineworkWrapper","utils/ShapeUtils","utils/XMLUtils","web-viewer/utils/ViewerUtils"],function(f,g,e,d){var c=function(b,a,c,n){f.call(this);this.type=-21;for(var j=this.textoptions.rotation=0;j<b.attributes.length;j++){var k=b.attributes[j];this.textoptions[k.nodeName]=k.nodeValue}this.textoptions.rotate=null==this.textoptions.rotate?0:d.parseFloat(this.textoptions.rotate);c=b.getElementsByTagName("Tspan")[c];this.textoptions.text=c.firstChild.nodeValue;
b=e.attributeValue(c,"x");j=e.attributeValue(c,"y");0!==this.textoptions.rotate&&(k=-this.textoptions.rotate/180*Math.PI,c=b*Math.cos(k)-j*Math.sin(k),j=b*Math.sin(k)+j*Math.cos(k),b=c);this.rect=new g.Rect(new g.Point(0,0),new g.Size(0,0));this.rect.origin.x=b;this.rect.origin.y=n-j;if(a=a[this.textoptions.filltype])this.c=a.color,this.color="#"+d.rgbToHex(this.c.r,this.c.g,this.c.b);void 0!==this.textoptions.fill&&(this.color=this.textoptions.fill)};c.prototype=Object.create(f.prototype);return c.prototype.constructor=
c});
define("web-viewer/cad/CadFile","underscore utils/ShapeUtils utils/XMLUtils web-viewer/cad/CadLine web-viewer/cad/CadText web-viewer/cad/CadConstants web-viewer/utils/ViewerUtils".split(" "),function(f,g,e,d,c,b,a){var h=function(a,b,c){this.layerclass=a;this.layertype=b;this.layername=c;this.lines=[];this.oneUps=[]},n=function(b,k,i,q){this.cstyles=b;this.name=null;this.cadlayers=[];this._selectedClasses=this._selectedLayers=this.oneupClasses=null;this.alpha=1;this._xmlData=k;if(q)this.rect=i;else{this.rect=
new g.Rect;var i=a.parseFloat(e.attributeValue(k,"minx")),l=a.parseFloat(e.attributeValue(k,"miny")),m=a.parseFloat(e.attributeValue(k,"maxx")),s=a.parseFloat(e.attributeValue(k,"maxy"));this.rect.origin.x=i;this.rect.origin.y=l;this.rect.size.width=m-i;this.rect.size.height=s-l}this.originalOrigin=this.rect.origin.copy();this.doctype=e.attributeValue(k,"doctype");q?(this.name=e.attributeValue(k,"name"),k=k.getElementsByTagName("OneupLayer")):k=k.getElementsByTagName("Layer");for(var s=m=l=i=null,
t=0;t<k.length;t++){for(var v=k[t],o=e.attributeValue(v,"class"),w=e.attributeValue(v,"type"),p=e.attributeValue(v,"name"),o=new h(o,w,p,q),v=v.childNodes,w=0;w<v.length;w++){var r=v[w];if(1===r.nodeType)if("Path"==r.nodeName||"Nicks"==r.nodeName)p=new d(r,this.cstyles.plottingStyles,this.rect.size.height),"Path"==r.nodeName&&("3"!=o.layerclass&&"4"!=o.layerclass)&&(p.snapable=!0),o.lines.push(p),i=i?Math.min(i,p.rect.left()):p.rect.left(),l=l?Math.min(l,p.rect.top()):p.rect.top(),m=m?Math.max(m,
p.rect.right()):p.rect.right(),s=s?Math.max(s,p.rect.bottom()):p.rect.bottom();else if("TextGroup"==r.nodeName)for(var r=r.getElementsByTagName("Text"),z=0;z<r.length;z++)for(var u=r[z].getElementsByTagName("Tspan"),x=0;x<u.length;x++)p=new c(r[z],this.cstyles.plottingStyles,x,this.rect.size.height),o.lines.push(p);else"Oneup"==r.nodeName&&(p=new n(b,r,this.rect,!0),o.oneUps.push(p))}this.cadlayers.push(o);this.contentRect=new g.Rect(new g.Point(i,l),new g.Size(m-i,s-l));this.contentRect.normalize()}this._selectedLayers=
f.clone(this.cadlayers);this._selectedClasses=f.clone(this.getOneupClasses())};n.prototype.getSize=function(){return this.rect.size.copy()};n.prototype.getOrigin=function(){return this.rect.origin.copy()};n.prototype.getOriginalOrigin=function(){return this.originalOrigin};n.prototype.resetOrigin=function(){this.rect.origin=this.originalOrigin.copy()};n.prototype.setOrigin=function(a,b){this.rect.origin.x=a;this.rect.origin.y=b};n.prototype.getSelectedLayers=function(){return this._selectedLayers};
n.prototype.getSelectedClasses=function(){return this._selectedClasses};n.prototype.setLocation=function(a){this._location=a};n.prototype.getLocation=function(){return this._location};n.prototype.toggleLayer=function(a,b){if(0>a)this._selectedLayers=this._selectedLayers.length===this.cadlayers.length&&b?[]:f.clone(this.cadlayers);else{var c=this.cadlayers[a];c&&(a=f.indexOf(this._selectedLayers,c),0<=a?this._selectedLayers.splice(a,1):this._selectedLayers.push(c))}};n.prototype.toggleClass=function(a,
b){if(0>a)this._selectedClasses=this._selectedClasses.length===this.getOneupClasses().length&&b?[]:f.clone(this.getOneupClasses());else{var c=this.getOneupClasses()[a];if(c){var d=f.indexOf(this._selectedClasses,c);0>d?this._selectedClasses.push(c):this._selectedClasses.splice(d,1)}}};n.prototype.hideClasses=function(){this._selectedClasses=[]};n.prototype.hideLayers=function(){this._selectedLayers=[]};n.prototype.getOneupClasses=function(){if(!this.oneupClasses){var a=[];f.each(this.cadlayers,function(b){f.each(b.oneUps,
function(b){f.each(b.cadlayers,function(b){b=b.layerclass;0>f.indexOf(a,b)&&a.push(b)})})});this.oneupClasses=a}return this.oneupClasses};return n});
define("web-viewer/webcenter/WebCenterDataAdapter","web-viewer/data/AbstractDataAdapter web-viewer/webcenter/WebCenterDocument web-viewer/webcenter/WebCenterDocumentVersion web-viewer/webcenter/WebCenterDocumentPage web-viewer/data/DataConstants utils/HTTPUtils utils/XMLUtils web-viewer/utils/ViewerUtils web-viewer/graphics/GraphicsConstants web-viewer/viewControls/ViewControlsConstants web-viewer/annotation/AnnotationConstants web-viewer/cad/CadFile jquery underscore".split(" "),function(f,g,e,d,
c,b,a,h,n,j,k,i,q,l){j=function(a,b,c){f.call(this,a,b);this.instance=b;this.viewserver=c;this._parameterUpdateToken=0;this._cadStyles={};b=l.bind(function(){a.ajax(this.WebCenter("sessionalive.jsp"),{error:function(b,c,d){a.i18n.loadBundle("viewer",function(){a.emit("error.WARNING",a.i18n.t("WCSessionLostError"),b,c,d)})},success:function(){a.debug.log("Keep WebCenter session alive")}})},this);setInterval(b,3E5);this.f.on("intercept.fragmentURL",l.bind(this.interceptFragmentURL,this))};j.prototype=
Object.create(f.prototype);j.prototype.constructor=j;j.prototype.getNumberOfDocuments=function(a){if(void 0===a)return 0;if(l.isString(a))return 1;if(l.isObject(a))return a=a.pagelist.page,l.isArray(a)?a.length:1};j.prototype.openDocuments=function(a,b){l.isString(a)?this.loadDocument(a,b,!0):l.isObject(a)?this.loadDocuments(a,b):void 0!==a&&this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.t("UnknownDocumentError"),a)},this)};j.prototype.loadDocument=function(b,c,d){b=
this.WebCenter("getdocumentinfo.jsp",{docversionid:b});this.f.ajax(b,{success:l.bind(function(b){b=a.xml2obj(b);"0"==b.status.value?l.isArray(b.status.page)?l.each(b.status.page,l.bind(function(a){this._initDocument(a,c,d)},this)):this._initDocument(b.status.page,c,d):(this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("LoadingDocumentInfoError"),b)},this),c(null))},this),error:l.bind(function(a,b,d){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",
this.f.i18n.t("LoadingDocumentInfoError"),a,b,d)},this);c(null)},this)})};j.prototype.loadDocuments=function(a,b){var c=a.pagelist.page;l.isArray(c)?l.each(c,l.bind(function(c,d){var e=0===d;void 0!==a.pagelist.startpageindex&&(e=d===a.pagelist.startpageindex);this._initDocument(c,b,e)},this)):this._initDocument(c,b,!0)};j.prototype._initDocument=function(a,b,d){var e=this.f.getDocumentController(),f=null,h=null,i=a.docversion,j;if(void 0!==a.file||void 0!==a.blank)j=this.getDocumentByDocId(a.docid),
f=c.documentPageType.GRAPHICS,a.hasDefaultData=!0,a.isMultiPage=void 0!==a.pagecount&&1<a.pagecount?!0:!1,void 0===j?f=new g(this.f,a,e.getNextIID(),f,this):(j.addDocumentPageFromData(a),f=j);if(void 0!==a.cad){null!==f&&void 0!==a.cadid&&(a.docid=a.cadid,a.docversionid=a.cadversionid);if(null===f||!f.hasLinkedDocument())h=new g(this.f,a,e.getNextIID(),c.documentPageType.CAD,this);b&&null===f&&b(h,!1)}void 0===a.cad&&(void 0===a.file&&(void 0===a.pageno||1===parseInt(a.pageno,10))&&1!=a.blank)&&this.loadDocument(a.docversionid,
b,d);if(null!==f&&null!==h){for(var k,n=h.getAllDocumentVersions(),q=function(b){return b&&b.get("docversionid")===a.cadversionid},A=1;!k&&A<=n.length;A++){var y=n[A];y&&(k=l.find(y.getAllPages(),q))}f.setLinkedDocumentPage(k)}b&&null!==f?b(f,!1):j&&b(j,!1);d&&(null==f&&null!==h&&void 0!==h.getDocumentVersion(i)&&void 0!==h.getDocumentVersion(i).getFirstPage()?e.changeActivePage(h.getDocumentVersion(i).getFirstPage()):j&&void 0!==j.getDocumentVersion()&&void 0!==j.getDocumentVersion().getLastPage()?
e.changeActivePage(j.getDocumentVersion().getLastPage()):null!==f&&(void 0!==f.getDocumentVersion(i)&&void 0!==f.getDocumentVersion(i).getFirstPage())&&e.changeActivePage(f.getDocumentVersion(i).getFirstPage()))};j.prototype.WebCenter=function(a,c){return b.constructURL(a,c,this.instance)};j.prototype.ViewServer=function(a,c){return b.constructURL(a,c,this.viewserver)};j.prototype.getPathToWCRImages=function(){return this.instance+"images/"};j.prototype.getPathToJSFiles=function(){return this.instance+
"javascript/"};j.prototype.interceptFragmentURL=function(a){a.params.x1+=a.rectangle.left();a.params.y1+=a.rectangle.top();a.params.x2+=a.rectangle.right();a.params.y2+=a.rectangle.bottom();a.params.res=a.resolution;a.params.wc=6;a.servlet=this.viewserver+"thumbdata.jsp"};j.prototype.isUpdateTokenValid=function(a){return this._parameterUpdateToken===a};j.prototype.generateUpdateToken=function(){return++this._parameterUpdateToken};j.prototype.cancelDocumentParametersUpdate=function(){this.generateUpdateToken()};
j.prototype.shouldRequestCadDataForPage=function(a){a=a.get("cadData");return!a||!a.loaded};j.prototype.shouldRequestCadStyleForPage=function(a){return!this._cadStyles[a.get("style")]};j.prototype.updateDocumentParameters=function(a,b,c,d){var e=this.generateUpdateToken();a.getDocumentVersion().isPageList()||!a.get("hasCorrectMargin")?this._fetchPageInfo(a,l.bind(function(){b&&b.getDocumentVersion().isPageList()?this._fetchPageInfo(b,l.bind(function(){this._fetchParameters(e,a,b,c,d)},this)):this._fetchParameters(e,
a,b,c,d)},this)):b&&(b.getDocumentVersion().isPageList()||!b.get("hasCorrectMargin"))?this._fetchPageInfo(b,l.bind(function(){this._fetchParameters(e,a,b,c,d)},this)):this._fetchParameters(e,a,b,c,d)};j.prototype._fetchParameters=function(a,b,c,d,e){var f,g;if(b.hasGraphics()||b.isBlankPage()&&c&&c.hasGraphics()){b.isBlankPage()&&(c&&c.hasGraphics())&&(g=c,c=b,b=g);f=b.getMargins();var h=b.getTrimboxSize();f={wc:6,file:b.get("file"),ftbtlx:f.left,ftbtly:f.top,ftbbrx:h.width+f.left,ftbbry:h.height+
f.top};b.getDocumentVersion().isPageList()&&(f.pageno=b.getPagenum());b.getDocumentVersion().isMultiPage()&&(f.fmp=1);if(c){var h=c.getMargins(),i=c.getTrimboxSize();c.getDocumentVersion().isPageList()&&(f.diffpageno=c.getPagenum());f.dtbtlx=h.left;f.dtbtly=h.top;f.dtbbrx=i.width+h.left;f.dtbbry=i.height+h.top}this.f.emit("intercept.parameters",{params:f});g&&f.rs&&(f.rs=1==f.rs?2:1);void 0!==c&&!c.isBlankPage()&&(f.diff=c.get("file"),c.resetParameters());d&&this.shouldRequestCadDataForPage(d)&&(f.cad=
d.get("cad"),this.shouldRequestCadStyleForPage(d)&&(f.style=d.get("style")))}else b.hasCad()&&(this.shouldRequestCadDataForPage(b)?(f={wc:6,cad:b.get("cad")},this.shouldRequestCadStyleForPage(b)&&(f.style=b.get("style")),c&&(c.hasCad()&&this.shouldRequestCadDataForPage(c))&&(f.dcad=c.get("cad"))):c&&c.hasCad()&&this.shouldRequestCadDataForPage(c)?(g=b,b=c,c=g,f={wc:6,cad:b.get("cad")},this.shouldRequestCadStyleForPage(b)&&(f.style=b.get("style"))):e());f?(f.afs=1,g=this.ViewServer("parameters.jsp",
f),this.f.ajax(g,{success:l.bind(this._handleParametersResult,this,a,f,b,c,d,e)})):e&&this._whenCadDataAvailableForAllActiveFiles(a,b,c,d,e)};j.prototype._whenCadDataAvailableForAllActiveFiles=function(a,b,c,d,e){this.f.requestModule("cad",l.bind(function(){if(this.isUpdateTokenValid(a)){var f=l.filter([b,c,d],function(a){return a&&a.hasCad()?(a=a.get("cadData"),a.requested&&!1===a.loaded):!1},this),g=l.bind(function(a,b){this.isUpdateTokenValid(a)&&b()},this,a,e);0<f.length?(g=l.after(f.length,g),
l.each(f,function(a){a.on("cadData.available",g)})):g()}},this),!0)};j.prototype._handleParametersResult=function(b,c,d,e,f,g,h){var i=a.xml2obj(h);!i.status||-1==i.status.value?this.isUpdateTokenValid(b)&&this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerImageParmsError",this.f.i18n.t("file")),i.status.message,i)},this):(i.status.parameters.cad&&(i.status.parameters.cad.data&&this._loadCadDataFor(f?f:d,i.status.parameters.cad.data),i.status.parameters.cad.ddata&&
this._loadCadDataFor(e,i.status.parameters.cad.ddata),i.status.parameters.cad.style&&this._loadCadStyle(c.style,i.status.parameters.cad.style)),this._whenCadDataAvailableForAllActiveFiles(b,d,e,f,l.bind(function(){this._handleGraphicsParametersResult(b,d,e,f,g,i)},this)))};j.prototype._whenCadStyleAvailable=function(a,b,c){c&&(b=l.bind(b,c));if(this._cadStyles[a]&&"LOADING"!==this._cadStyles[a])b(this._cadStyles[a]);else this.once(["cadStyle",a,"available"],b)};j.prototype._loadCadStyle=function(a,
b){this._cadStyles[a]="LOADING";this._fetchPreviewData(b,l.bind(function(b){this._cadStyles[a]=b.documentElement;this._emit(["cadStyle",a,"available"],b.documentElement)},this))};j.prototype._loadCadDataFor=function(a,b,c){var d={requested:!0,loaded:!1};a.set("cadData",d);this._fetchPreviewData(b,l.bind(function(b){this._whenCadStyleAvailable(a.get("style"),function(e){d.loaded=!0;d.rawCad=b.documentElement;d.rawStyle=e;a.set("cadData",d);a.setCadDataAvailable();c&&c()},this)},this))};j.prototype._fetchPreviewData=
function(a,b,c){this.f.ajax(this.ViewServer("getcaddata.jsp",{url:a}),{success:l.bind(function(c){try{b(c)}finally{this.f.ajax(this.ViewServer("previewdelete.jsp",{url:a}),{error:l.bind(function(a,b,c){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("PreviewDeleteError"),a,b,c)},this)},this)})}},this),error:l.bind(function(a,b,d){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerCadReadError",this.f.i18n.t("file")),a,b,d)});
c&&c(a,b,d)},this)})};j.prototype._handleGraphicsParametersResult=function(a,b,c,d,e,f){if(this.isUpdateTokenValid(a)){var g={resolutionx:h.parseFloat(f.status.parameters.resolutionx),resolutiony:h.parseFloat(f.status.parameters.resolutiony),sizex:h.parseFloat(f.status.parameters.sizex),sizey:h.parseFloat(f.status.parameters.sizey),fileminx:h.parseFloat(f.status.parameters.fileminx),fileminy:h.parseFloat(f.status.parameters.fileminy),filemaxx:h.parseFloat(f.status.parameters.filemaxx),filemaxy:h.parseFloat(f.status.parameters.filemaxy),
filemedminx:h.parseFloat(f.status.parameters.filemedminx),filemedminy:h.parseFloat(f.status.parameters.filemedminy),filemedmaxx:h.parseFloat(f.status.parameters.filemedmaxx),filemedmaxy:h.parseFloat(f.status.parameters.filemedmaxy),imagetype:h.parseFloat(f.status.parameters.imagetype)};d&&d.setParameters({resolutionx:h.parseFloat(f.status.parameters.resolutionx),resolutiony:h.parseFloat(f.status.parameters.resolutiony),sizex:h.parseFloat(f.status.parameters.sizex),sizey:h.parseFloat(f.status.parameters.sizey),
imagetype:-1});var i={resolutionx:h.parseFloat(f.status.parameters.diffresx),resolutiony:h.parseFloat(f.status.parameters.diffresy),sizex:h.parseFloat(f.status.parameters.sizex),sizey:h.parseFloat(f.status.parameters.sizey),fileminx:h.parseFloat(f.status.parameters.diffminx),fileminy:h.parseFloat(f.status.parameters.diffminy),filemaxx:h.parseFloat(f.status.parameters.diffmaxx),filemaxy:h.parseFloat(f.status.parameters.diffmaxy),filemedminx:h.parseFloat(f.status.parameters.diffmedminx),filemedminy:h.parseFloat(f.status.parameters.diffmedminy),
filemedmaxx:h.parseFloat(f.status.parameters.diffmedmaxx),filemedmaxy:h.parseFloat(f.status.parameters.diffmedmaxy)};g.channel=[];i.channel=[];var j=[],k=[];void 0!==f.status.parameters.channel&&!l.isArray(f.status.parameters.channel)&&(f.status.parameters.channel=[f.status.parameters.channel]);l.each(f.status.parameters.channel,l.bind(function(a,b){a.serverID=b;void 0!==a.dmode||null!==a.dmode?(a.dmode=parseInt(a.dmode,10),isNaN(a.dmode)&&(a.dmode=null)):a.dmode=null;a.opaque=a.opaque?!0:!1;if(null===
a.dmode||a.dmode===n.ChannelDiffMode.CURRENT||a.dmode===n.ChannelDiffMode.IN_CURRENT_AND_MATCHED_WITH_PREVIOUS)g.channel.push(a),a.dmode===n.ChannelDiffMode.IN_CURRENT_AND_MATCHED_WITH_PREVIOUS&&j.push(a);else if(a.dmode===n.ChannelDiffMode.PREVIOUS||a.dmode===n.ChannelDiffMode.IN_PREVIOUS_AND_MATCHED_WITH_CURRENT)i.channel.push(a),a.dmode===n.ChannelDiffMode.IN_PREVIOUS_AND_MATCHED_WITH_CURRENT&&k.push(a)},this));for(a=0;a<j.length;a++)j[a].matchedWith=k[a].serverID,k[a].matchedWith=j[a].serverID;
var q;void 0!==c&&(a=1==f.status.parameters.annotations.diffexists,d=1==f.status.parameters.annotations.diffexistsext,q=this._createHasAnnotationsObj(d,a),c.setParameters(i),c.setHasAnnotations(a||d,q));void 0!==b&&(a=1==f.status.parameters.annotations.exists,d=1==f.status.parameters.annotations.existsext,q=this._createHasAnnotationsObj(d,a),b.setHasAnnotations(a||d,q),b.setParameters(g));e&&e()}else this.f.debug.log("_fetchParameters returned dirty result")};j.prototype._createHasAnnotationsObj=
function(a,b){var c={};c[k.AnnotationOriginTypes.user.id]=b;c[k.AnnotationOriginTypes.barcode.id]=a;c[k.AnnotationOriginTypes.braille.id]=a;c[k.AnnotationOriginTypes.artwork.id]=a;c[k.AnnotationOriginTypes.spelling.id]=a;c[k.AnnotationOriginTypes.text.id]=a;c[k.AnnotationOriginTypes.editor.id]=a;c[k.AnnotationOriginTypes.ext.id]=a;c[k.AnnotationOriginTypes.acrobat.id]=a;return c};j.prototype._fetchPageInfo=function(b,c){var d=this.WebCenter("getdocumentinfo.jsp",{docid:b.getDocument().getDocumentID(),
docversionid:b.getDocumentVersion().getDocumentVersionID(),pageno:b.getPagenum()});this.f.ajax(d,{success:l.bind(function(d){var d=a.xml2obj(d),e=d.status.page;if(void 0!==e){b.set("margbot",d.status.page.margbot);b.set("margtop",d.status.page.margtop);b.set("margleft",d.status.page.margleft);b.set("margright",d.status.page.margright);b.set("hsize",d.status.page.hsize);b.set("vsize",d.status.page.vsize);b.set("hasCorrectMargin",!0);b.set("pageno",d.status.page.pageno);b.set("offsetx",d.status.page.offsetx);
b.set("offsety",d.status.page.offsety);void 0!==d.status.page.cadregedit&&(b.set("cadregedit",d.status.page.cadregedit),b.set("isCadAlignmentSaved",1==d.status.page.saved?!0:!1));if(e.metadata&&(e.metadata.design||e.metadata.layout)){var f=e.metadata.design||e.metadata.layout;b.set("grainDirection",f.grain_direction);b.set("defaultSide",f.default_side);b.set("dieSide",f.die_side)}b.set("has3DPerspective","1"==e.has3DPerspective?!0:!1);b.set("canGenerate3D","1"==e.canGenerate3D?!0:!1);b.set("canEditAttributes",
e.can_edit_attributes);b.set("attributeCategoryID",e.attribute_category_id);b.set("canChangeAnnotations",e.can_change_annotations)}b.isBlankPage()&&(e={sizex:h.parseFloat(e.hsize),sizey:h.parseFloat(e.vsize),filemaxx:h.parseFloat(e.hsize),filemaxy:h.parseFloat(e.vsize)},b.setHasAnnotations(!1),b.setParameters(e));c&&c(d)},this),error:l.bind(function(a,b,d){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("LoadingDocumentInfoError"),a,b,d)},this);c&&c()},this)})};
j.prototype.getDeepCopy=function(a,b,c,f){var h=a._docVersion,j=h._doc;void 0===f&&(f=j.documentID);void 0===b&&(b=new g(this.f,void 0,f,a.documentType,this),b._data=q.extend(!0,{},j._data));f=c;void 0===f&&(f=new e(this.f,b,h._versionData.docversion,{docversionid:h._versionData.docversionid,docRevision:h._versionData.docRevision},void 0,this));h=new d(this.f,f,a._pagenum,void 0,void 0,this);h._data=q.extend(!0,{},a._data);h._parameters=q.extend(!0,{},a._parameters);h._state=q.extend(!0,{},a._state);
a._data.cadData&&(h._data.cadData=l.clone(a._data.cadData),a._data.cadData.cad&&(h._data.cadData.cad=new i(a._data.cadData.cad.cstyles,a._data.cadData.cad._xmlData)));h._state.compareOffset&&(h._state.compareOffset=a._state.compareOffset.copy());h.setReaderSpread(a.isReaderSpread());void 0===c&&b.addDocumentVersion(f);f.addPage(a.getPagenum(),h);return h};j.prototype.getPagesOfDocumentVersion=function(b,c){var d=b.getDocument(),e=this.WebCenter("getdocumentinfo.jsp",{docid:d.getDocumentID(),docversionid:b.getDocumentVersionID()});
this.f.ajax(e,{success:l.bind(function(b){b=a.xml2obj(b);l.each(b.status.page,l.bind(l.bind(function(a){d.addDocumentPageFromData(a)},this)));void 0!==c&&c()},this),error:l.bind(function(a,b,c){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("LoadingDocumentInfoError"),a,b,c)},this)},this)})};j.prototype.getDocumentByDocId=function(a){var b=l.find(this.f.getDocumentController().getAllDocuments(),function(b){return b.getDocumentID()===a});return b?b:l.find(this.f.getDocumentController().getLinkedDocuments(),
function(b){return b.getDocumentID()===a})};j.prototype.loadVersionsOfDocumentPage=function(b,c,f,g){var h=this.WebCenter("getdocumentinfo.jsp",{docid:b.docid,docversionid:b.docversionid,diffversion:b.diffversion,pageno:b.pageNumber}),i=b.pageNumber,j=b.isPageList,k=b.isMultiPage;this.f.ajax(h,{success:l.bind(function(b){var b=a.xml2obj(b),h=b.status.page.versionlist;void 0!==b.status.page&&void 0!==g&&(g.set("margbot",b.status.page.margbot),g.set("margtop",b.status.page.margtop),g.set("margleft",
b.status.page.margleft),g.set("margright",b.status.page.margright),g.set("hasCorrectMargin",!0));if(void 0!==h){l.isArray(h)||(h=[h]);var m=[];l.each(h,l.bind(function(a){var b=c._documentVersions[parseInt(a.docversion,10)];void 0===b?(a.isPageList=j,a.isMultiPage=k,b=new e(this.f,c,parseInt(a.docversion,10),a,void 0,this),c._documentVersions[parseInt(a.docversion,10)]=b):(b.set("docversionid",a.docversionid),b.set("isMultiPage","true"===a.isMultiPage));var f=new d(this.f,b,i,{file:a.file,versionNumber:a.docversion},
void 0,this);b.addPage(i,f);m[a.docversion]=f},this));f(m)}},this),error:l.bind(function(a,b,c){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("LoadingDocumentInfoError"),a,b,c)},this)},this)})};j.prototype.saveCadOverlay=function(b,c,d,e,f,g){if(b.canSaveCadOverlay()){var h=(4-d/90)%4;e&&(h+=4);var i;c&&(i=c.get("docversionid"));c=b.getMargins();h=this.WebCenter("setcadalignment.jsp",{docversionid:b.get("docversionid"),cadversionid:i,cadorgx:f.x,cadorgy:f.y,cadorientation:h,
hs:b.get("hsize"),vs:b.get("vsize"),ml:c.left,mt:c.top,mr:c.right,mb:c.bottom});this.f.ajax(h,{dataType:"xml",success:l.bind(function(c){var c=a.xml2obj(c),h="";if(c){if(c.status&&"0"===c.status.value){this.f.loadBundle("viewer",function(){this.f.emit("userMessage","success",this.f.t("SaveCadOverlaySuccess"),!0)},this);b.getLinkedPage()!==this.f.getDocumentController().getCadOverlay()&&this.f.getDocumentController().createNewLinkedCadFromOverlay();(c=this.f.getDocumentController().getCadOverlay())?
(c.set("offsetx",f.x),c.set("offsety",f.y),c.set("overlayRotation",d),c.set("overlayIsFlipped",e)):this.updateDocumentData(b,void 0,!0);g&&g(!0);return}"-1"===c.status&&(h=c.status.message)}this.f.emit("userMessage","warn",this.f.t("SaveCadOverlayFailed")+" "+h);g&&g(!1)},this),error:l.bind(function(){this.f.loadBundle("viewer",function(){this.f.emit("userMessage","warn",this.f.t("SaveCadOverlayFailed"))},this);g&&g(!1)},this)})}else this.f.emit("userMessage","warn",this.f.t("SaveCadOverlayFailed")),
g&&g(!1)};j.prototype.show3DView=function(a){a=this.WebCenter("doctypecolladaview.jsp",{docVerID:a.get("docversionid"),sourcePage:"javascript:window.close()"});window.open(a,"_blank")};j.prototype.updateDocumentData=function(a,b,d){this._fetchPageInfo(a,l.bind(function(e){if(e.status.page.file&&e.status.page.cad&&a===this.f.getActivePage()){var e=e.status.page,f=e.cadid,h=a.getLinkedPage();e.docid=e.cadid;e.docversionid=e.cadversionid;this.getDocumentByDocId(f)?(f=this.getDocumentByDocId(f).getDocumentVersion().getPage(),
f!==h&&this.f.getDocumentController().createNewLinkedCadFromOverlay(d,f),(h=a.getLinkedPage())&&h.setPageAlignmentData(e)):(e=new g(this.f,e,this.f.getDocumentController().getNextIID(),c.documentPageType.CAD,this),this.f.getDocumentController().addNewLinkedDocument(e,d))}else a.getDocument().hasLinkedDocument()&&(a.getDocument().setLinkedDocumentPage(),this.f.getDocumentController().changeCadOverlay());b&&b()},this))};return j});
define("web-viewer/webcenter/WebCenterConfig",["web-viewer/core/AbstractConfig","web-viewer/webcenter/WebCenterDataAdapter"],function(f,g){var e=function(d,c,b){f.call(this);this.modules=[];this.instance=d;this.user=b;this.viewserver=c};e.prototype=Object.create(f.prototype);e.prototype.constructor=e;e.prototype.addModule=function(d){this.modules.push(d)};e.prototype.intializeAdapter=function(d){return this.adapter=new g(d,this.instance,this.viewserver)};e.prototype.getUser=function(){return this.user};
e.prototype.getModules=function(){return this.modules};return e});
define("web-viewer/webcenter/WebCenterUser","web-viewer/data/User web-viewer/data/PreferencesConstants web-viewer/data/PreferencesDefaults web-viewer/data/DataConstants web-viewer/core/CoreConstants underscore".split(" "),function(f,g,e,d,c,b){var a=function(a,b,c,d,e,g){f.call(this,a,b,c,d,e);this.userIsAdmin=g;this.viewServerID=void 0};a.prototype=Object.create(f.prototype);a.prototype.constructor=a;a.prototype.getFullName=function(){var a=this.getLastName();this.first&&(a+=", "+this.first);return a+=
" ("+this.getUsername().toUpperCase()+")"};a.prototype.isAdmin=function(){return this.userIsAdmin};a.prototype.loadOptions=function(a){this.f.requestModule("featureDetector",b.bind(function(c){var d="";c.isMobile()&&(d="m");var c={name:this.getFullName(),address:window.screen.width+"x"+window.screen.height+d},e=this.f.getDataAdapter();e.ViewServer?(c=e.ViewServer("userid.jsp",c),this.f.ajax(c,{success:b.bind(function(c){var d=c.documentElement;"0"==(d.getElementsByTagName("value")[0].textContent||
d.getElementsByTagName("value")[0].text)?(this.viewServerID=d.getElementsByTagName("userid")[0].textContent||d.getElementsByTagName("userid")[0].text,c=e.ViewServer("getsettings.jsp",{userid:this.viewServerID}),this.f.ajax(c,{success:b.bind(function(b){var c=b.documentElement;"0"==(c.getElementsByTagName("value")[0].textContent||c.getElementsByTagName("value")[0].text)?(b=c.getElementsByTagName("settings")[0],this._handleSettings(b)):(this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",
this.f.i18n.t("ServerSettingsReadError"),c.getElementsByTagName("error")[0].textContent||c.getElementsByTagName("error")[0].text)},this),this.loadDefaultOptions());a()},this),error:b.bind(function(b,c,d){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerSettingsReadError"),b,c,d)},this);this.loadDefaultOptions();a()},this)})):(this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerSettingsReadError"),d.getElementsByTagName("error")[0]?
d.getElementsByTagName("error")[0].textContent:void 0)},this),this.loadDefaultOptions(),a())},this),error:b.bind(function(b,c,d){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerSettingsReadError"),b,c,d)},this);this.loadDefaultOptions();a()},this)})):(this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerSettingsReadError"),"Adapter cannot connect to Viewserver")},this),this.loadDefaultOptions(),a())},this))};a.prototype.loadDefaultOptions=
function(){this.setOptions(b.clone(e))};a.prototype._handleSettings=function(a){for(var f=b.invert(g),j=b.clone(e),a=a.firstChild;a;){if(1==a.nodeType){var k=a.nodeName,i=a.getElementsByTagName("id")[0].textContent||a.getElementsByTagName("id")[0].text,q=a.getElementsByTagName("value")[0].textContent||a.getElementsByTagName("value")[0].text;"settingint"==k&&(q=parseInt(q,10));if("settingchar"==k||!b.contains(d.charsequencePreferences,f[i]))j[f[i]]=q}a=a.nextSibling}this.f.getUnits()===c.SizeUnits.INCH?
(j.PREFERENCES_UNIT_SIZE=c.SizeUnits.INCH,j.PREFERENCES_UNIT_RESOLUTION=c.ResolutionUnits.PPI,j.PREFERENCES_UNIT_SCREENRULING=c.ResolutionUnits.PPI):(j.PREFERENCES_UNIT_SIZE=c.SizeUnits.MM,j.PREFERENCES_UNIT_RESOLUTION=c.ResolutionUnits.PPCM,j.PREFERENCES_UNIT_SCREENRULING=c.ResolutionUnits.PPCM);this.initializeOptions(j)};a.prototype.persistOptions=function(a,c){var d=this.f.getDataAdapter();if(d.ViewServer){var e=document.implementation.createDocument("","settings",null);b.each(a,function(a,c){var d=
e.createElementNS(null,b.isNumber(a)?"settingint":"settingchar"),f=e.createElementNS(null,"id");f.textContent=g[c];var h=e.createElementNS(null,"value");h.textContent=a;d.appendChild(f);d.appendChild(h);e.documentElement.appendChild(d)});var f=(new XMLSerializer).serializeToString(e),d=d.ViewServer("setsettings.jsp",{userid:this.viewServerID});this.f.ajax(d,{error:b.bind(function(a,b,d){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerSettingsWriteError"),
a,b,d)},this);c&&c(!1)},this),success:function(){c&&c(!0)},processData:!1,contentType:"text/xml",data:f,type:"POST"})}else this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerSettingsWriteError"),"Adapter cannot connect to Viewserver")},this),c&&c(!1)};return a});
define("web-viewer/webcenter/WebCenterModule","web-viewer/webcenter/WebCenterConfig web-viewer/webcenter/WebCenterDataAdapter web-viewer/webcenter/WebCenterDocument web-viewer/webcenter/WebCenterDocumentPage web-viewer/webcenter/WebCenterDocumentVersion web-viewer/webcenter/WebCenterModule web-viewer/webcenter/WebCenterUser".split(" "),function(){});