define("web-viewer/annotation/AnnotationFilter",["underscore","web-viewer/core/PrivateChannel","web-viewer/annotation/AnnotationConstants"],function(f,l,i){var j=function(d,c){l.installTo(this,d,["annotationFilter"]);this._annotationFilterModel=c};j.prototype.filterAnnotations=function(d){var c=[];if(this._annotationFilterModel.isCustomFilterActive()&&d)return c=f.filter(d,f.bind(function(c){return this.compliesToCustomFilter(c)},this)),this._annotationFilterModel.setNumberOfFilteredAnnotations(c.length),
c;if(d)return c=f.filter(d,f.bind(function(c){return this.compliesToFilter(c)},this)),this._annotationFilterModel.setNumberOfFilteredAnnotations(c.length),c;this._annotationFilterModel.setNumberOfFilteredAnnotations(0);return[]};j.prototype.filterIncomingAnnotations=function(d){var c=this._annotationFilterModel.getViewerUserFilter();if(0<c.length){var k=[];f.each(d,function(d){d.runThroughAnnotation(!0,!0,!0,f.bind(function(h){if(!f.some(c,function(c){return this._compliesToAuthor(h,c)},this)){if(h.inreplyto&&
!h.state){var m=f.indexOf(h.parent.replies,h);h.parent.replies.splice(m,1);return!0}if(h.state&&h.parent)return m=f.indexOf(h.parent.states,h),h.parent.states.splice(m,1),!0;if(!h.parent||h.linkedto)return k.push(h),!0}return!1},this))},this);f.each(k,function(c){c=f.indexOf(d,c);d.splice(c,1)})}return d};j.prototype.compliesToFilter=function(d){var c=this._annotationFilterModel.getOriginType();return c!==i.AnnotationOriginTypes.user.id&&c===d.originType?!0:this._compliesToUser(d)&&this._compliesToState(d)&&
this._compliesToType(d)};j.prototype.compliesToCustomFilter=function(d){var c=this._annotationFilterModel.getFilterRows();if(this._annotationFilterModel.getFilterOperator()==i.FilterOperators.ALL)return f.every(c,function(c){return this._checkCustomFilterRule(d,c)},this);if(this._annotationFilterModel.getFilterOperator()==i.FilterOperators.ANY)return f.some(c,function(c){return this._checkCustomFilterRule(d,c)},this)};j.prototype._checkCustomFilterRule=function(d,c){if(c.filterType==i.FilterTypes.AUTHOR)return c.filterCondition==
i.FilterCondition.IS?this._compliesToUser(d,c.filterOption):!this._compliesToUser(d,c.filterOption);if(c.filterType==i.FilterTypes.REVIEWSTATE)return c.filterCondition==i.FilterCondition.IS?this._compliesToCustomFilterState(d,c.filterOption):!this._compliesToCustomFilterState(d,c.filterOption);if(c.filterType==i.FilterTypes.REVIEWAUTHORANDSTATE)return c.filterCondition==i.FilterCondition.IS?this._compliesToReviewAuthorAndState(d,c.filterOption):!this._compliesToReviewAuthorAndState(d,c.filterOption)};
j.prototype._compliesToUser=function(d,c){var k=!0;void 0===c&&(c=this._annotationFilterModel.getSelectedUser());c&&(k=!1,d.runThroughAnnotation(!0,!0,!0,f.bind(function(d){if(d.username==c)return k=!0},this)));return k};j.prototype._compliesToType=function(d){return d.originType===this._annotationFilterModel.getOriginType()};j.prototype._compliesToAuthor=function(d,c){return c&&d.username==c?!0:!1};j.prototype._compliesToReviewAuthorAndState=function(d,c){var k=!1;if(c){var n=f.invert(i.AnnotationReviewState);
d.runThroughAnnotation(!0,!0,!1,f.bind(function(h){if(k=f.some(h.states,f.bind(function(h){h=h.getUserName()+" "+n[h.state];return c===h},this)))return!0},this))}return k};j.prototype._compliesToState=function(d){var c=!0,k=this._annotationFilterModel.getSelectedState();k&&(c=!1,"Any"==k?d.runThroughAnnotation(!0,!this._annotationFilterModel.isInverseState(),!1,f.bind(function(d){d=d.states;c=c||0<d.length},this)):d.runThroughAnnotation(!0,!this._annotationFilterModel.isInverseState(),!1,f.bind(function(d){f.some(d.states,
f.bind(function(h){return h.state==k},this))&&(c=!0)},this)),this._annotationFilterModel.isInverseState()&&(c=!c));return c};j.prototype._compliesToCustomFilterState=function(d,c){var k=!1;d.runThroughAnnotation(!0,!0,!1,f.bind(function(d){f.some(d.states,f.bind(function(h){return h.state==i.AnnotationReviewState[c]},this))&&(k=!0)},this));return k};return j});
define("web-viewer/annotation/Annotation","web-viewer/utils/LineworkWrapper web-viewer/utils/LineworkPoint utils/ShapeUtils utils/XMLUtils web-viewer/utils/ViewerUtils web-viewer/utils/GEOUtils web-viewer/utils/DrawUtils utils/StringSet web-viewer/annotation/AnnotationConstants underscore".split(" "),function(f,l,i,j,d,c,k,n,h,m){function o(e,g){var b=null;if(e.nodeType===Node.TEXT_NODE)b=g.createTextNode(e.textContent);else if(e.nodeType===Node.ELEMENT_NODE){b=g.createElement(e.nodeName.toLowerCase());
if(e.hasAttributes&&e.hasAttributes())for(var a=0;a<e.attributes.length;a++)b.setAttribute(e.attributes[a].name,e.attributes[a].value);if(e.hasChildNodes&&e.hasChildNodes())for(a=0;a<e.childNodes.length;a++){var h=o(e.childNodes[a],g);null!=h&&b.appendChild(h)}}return b}var a=function(e,g){f.call(this);this.f=e;this.creationdate=new Date;this.date=new Date;this.name=null;this.page=0;this.content=this.title=this.subject="";this.originType=g||h.AnnotationOriginTypes.user.id;this._view3DPosition=null;
this.lastname=this.firstname=this.username="";this.messagenumber=-1;this.parent=this.annottype=null;this.replies=[];this.inreplyto=null;this.links=[];this.linkedto=null;this.saved=!1;this.isNew=!0;this.states=[];this.statemodel=this.state=null;this.flags="print";this.popuprect=new i.Rect;this.popuppage=0;this.popupIsOpen=!1;this.originalAnnotationColor=this.modifiedContent=this.unsavedReplyText=null;this._modifications=new n;this._scaling=null;this._override("setRect",function(b,e){this._super(b,
e);this.setModified("LINEWORK")});this._override("move",function(b){this._super(b);(0!==b.width||0!==b.height)&&this.setModified("LINEWORK")});this._override("setStartEnd",function(b,e){this._super(b,e);this.setModified("LINEWORK")})};a.prototype=Object.create(f.prototype);a.prototype.constructor=a;a.prototype.getPermission=function(){return this.f.getCurrentUser().getUsername()==this.username?h.AccessRight.READ_WRITE:h.AccessRight.READ_ONLY};a.prototype.getPermissionFor=function(e){return e!==h.ActionPermissions.DUPLICATE_WITHOUT_TEXT};
a.prototype.getSortByAttr=function(){return this.content};a.prototype.getOutliningRect=function(){var e=m.union(this.links,[this]),g=m.min(e,function(b){return b.rect.left()}).rect.left(),b=m.max(e,function(b){return b.rect.top()}).rect.top(),a=m.max(e,function(b){return b.rect.right()}).rect.right(),e=m.min(e,function(b){return b.rect.bottom()}).rect.bottom();return new i.Rect(new i.Point(g,b),new i.Size(a-g,e-b))};a.prototype.getIconClass=function(){return h.AnnotationIcons[this.annottype]};a.prototype.isAnnotationModified=
function(){return 0===this.date-this.creationdate};a.prototype.initAnnotation=function(e,g,b,a,c){if(!this.name||0===this.name.length)void 0===a?this.f.emit("error.SEVERE","Problem initializing annotation","No model specified for generating unique name!"):this.name=a.generateUniqueName();c||(c=new i.Rect);this.rect=c;a&&(this._scaling=a.getCurrentScaling());g||(g=this.annotationcolor);this.annotationcolor=this.originalAnnotationColor=g;null===this.annotationcolor&&(this.annotationColor=this._getDefaultAnnotationColor(e));
this.color=g;this.annottype=e;this.setSelected(b);if(!this.subject||0===this.subject.length)this.subject=(null!=this.inreplyto?"Re: ":"")+h.AnnotationReplyName[this.annottype];switch(e){case h.AnnotationType.ANNOT_RECT:this.color=g;this.type=k.LWTYPE_RECT;break;case h.AnnotationType.ANNOT_ELLIPSE:this.color=g;this.type=k.LWTYPE_ELLIPSE;break;case h.AnnotationType.ANNOT_HIGHLIGHT:this.type=k.LWTYPE_RECT;this.treatAsOutline=!0;this.color=null;break;case h.AnnotationType.ANNOT_LINE:this.type=k.LWTYPE_LINE;
this.color=g;this.pointArray[0]=new l;this.pointArray[0].makeMoveTo(this.rect.origin.x,this.rect.origin.y);this.pointArray[1]=new l;this.pointArray[1].makeLineTo(this.rect.origin.x+this.rect.size.width,this.rect.origin.y+this.rect.size.height);break;case h.AnnotationType.ANNOT_ARROW:this.type=k.LWTYPE_ARROW;this.color=g;this.pointArray[0]=new l;this.pointArray[0].makeMoveTo(this.rect.origin.x,this.rect.origin.y);this.pointArray[1]=new l;this.pointArray[1].makeLineTo(this.rect.origin.x+this.rect.size.width,
this.rect.origin.y+this.rect.size.height);break;case h.AnnotationType.ANNOT_PIN:this.type=k.LWTYPE_IMAGE;this.imagehotspot=new i.Point(h.AnnotationPin.imagehotspotx,h.AnnotationPin.imagehotspoty);this.imagetouchspot=new i.Rect(new i.Point(h.AnnotationPin.imagetouchspotx,h.AnnotationPin.imagetouchspoty),new i.Size(h.AnnotationPin.imagetouchspotw,h.AnnotationPin.imagetouchspoth));break;case h.AnnotationType.ANNOT_FREEFORM:this.type=k.LWTYPE_LINEARRAY,this.color=g}};a.prototype.initWithXML=function(e,
g){this.saved=!0;this.isNew=!1;this.pointArray=[];this.name=j.attributeValue(e,"name");this.subject=j.attributeValue(e,"subject");this.title=j.attributeValue(e,"title");this.flags=j.attributeValue(e,"flags");this._view3DPosition={scale:d.parseFloat(j.attributeValue(e,"view3Dscale")),azimuth:d.parseFloat(j.attributeValue(e,"view3Dazimuth")),elevation:d.parseFloat(j.attributeValue(e,"view3Delevation"))};if(isNaN(this._view3DPosition.scale)||isNaN(this._view3DPosition.azimuth)||isNaN(this._view3DPosition.elevation))this._view3DPosition=
null;var b=/((\d+)\s)?(.+)/.exec(this.title);if(b){this.messagenumber=b[2];void 0===this.messagenumber&&(this.messagenumber=-1);var a=/([^,]+)(,\s(.+))?\s\((.+)\)/.exec(b[3]);a?(this.username=a[4],this.lastname=a[1],this.firstname=a[3]||""):(this.username=b[3],this.firstname=this.lastname="")}this.messagenumber=parseInt(this.messagenumber,10);this.page=j.attributeValue(e,"page");this.date=d.dateFromString(j.attributeValue(e,"date"));this.creationdate=d.dateFromString(j.attributeValue(e,"creationdate"));
this.state=j.attributeValue(e,"state");this.statemodel=j.attributeValue(e,"statemodel");this._parseContentsFromXML(e);if(b=j.attributeValue(e,"inreplyto"))this.inreplyto=b;if(b=j.attributeValue(e,"linkedto"))this.linkedto=b;var b=RegExp(/(.+),(.+),(.+),(.+)/),m=b.exec(j.attributeValue(e,"rect")),a=c.convertPSPointsToMM(m[1]),f=c.convertPSPointsToMM(m[2]),k=c.convertPSPointsToMM(m[3]),m=c.convertPSPointsToMM(m[4]),m=this._modifyAnnotatationCoords(a,f,k,m,g),a=m[0],f=m[1],k=m[2],m=m[3];switch(e.nodeName){case "square":this.initAnnotation(h.AnnotationType.ANNOT_RECT);
break;case "circle":this.initAnnotation(h.AnnotationType.ANNOT_ELLIPSE);break;case "highlight":this.initAnnotation(h.AnnotationType.ANNOT_HIGHLIGHT);break;case "text":this.rect.size.width=0;this.rect.size.height=0;this.initAnnotation(h.AnnotationType.ANNOT_PIN);break;case "ink":this.initAnnotation(h.AnnotationType.ANNOT_FREEFORM);if(!this.inreplyto){var o=e.getElementsByTagName("inklist")[0];if(o){for(var o=o.getElementsByTagName("gesture")[0],n="",q=0;q<o.childNodes.length;q++)n+=o.childNodes[q].nodeValue;
if(0<n.length)if(n=n.split(";"),o=new l,q=n[0].split(","),void 0!==q[0]&&void 0!==q[1]){o.makeMoveTo(c.convertPSPointsToMM(q[0]),c.convertPSPointsToMM(q[1]));this.pointArray.push(o);for(o=1;o<n.length;o++){var w=new l,q=n[o].split(",");if(void 0!==q[0]&&void 0!==q[1]){var t=c.convertPSPointsToMM(q[0]),q=c.convertPSPointsToMM(q[1]);w.makeLineTo(t,q);this.pointArray.push(w)}else this.f.emit("error.DEBUG","chunkpoint[0] || chunkpoint[1] is undefined...")}}else this.f.emit("error.DEBUG","chunkpoint[0] || chunkpoint[1] is undefined...");
this.calculateRectFromPointArray()}}break;case "line":(o=j.attributeValue(e,"subject"))&&"Arrow"==o?this.initAnnotation(h.AnnotationType.ANNOT_ARROW):this.initAnnotation(h.AnnotationType.ANNOT_LINE),this.inreplyto||(n=RegExp(/(.+),(.+)/),o=j.attributeValue(e,"start"),q=j.attributeValue(e,"end"),o=n.exec(o),t=n.exec(q),n=c.convertPSPointsToMM(o[1]),w=c.convertPSPointsToMM(o[2]),q=c.convertPSPointsToMM(t[1]),t=c.convertPSPointsToMM(t[2]),o=new l,o.makeMoveTo(n,w),n=new l,n.makeLineTo(q,t),this.pointArray[0]=
o,this.pointArray[1]=n,o=new i.Point(o.x,o.y),n=new i.Point(n.x,n.y),this.rect=new i.Rect(o,o.sizeTo(n)),this.rect.normalize())}this.rect.origin.x=a;this.rect.origin.y=m;this.rect.size.width=k-a;this.rect.size.height=f-m;a=j.attributeValue(e,"color");/^#?[a-f\d]{6}$/i.test(a)||(a=this._getDefaultAnnotationColor(this.annottype));this.annotationcolor=this.originalAnnotationColor=this.color=a;if(a=e.getElementsByTagName("popup")[0])this.popuppage=j.attributeValue(a,"page"),this.popupIsOpen="yes"==j.attributeValue(a,
"open"),k=b.exec(j.attributeValue(a,"rect")),b=c.convertPSPointsToMM(k[1]),a=c.convertPSPointsToMM(k[2]),f=c.convertPSPointsToMM(k[3]),k=c.convertPSPointsToMM(k[4]),this.popuprect.origin.x=b,this.popuprect.origin.y=a,this.popuprect.size.width=f-b,this.popuprect.size.height=k-a};a.prototype._modifyAnnotatationCoords=function(e,a,b,h){return[e,a,b,h]};a.prototype.duplicate=function(e,g,b,h,c){var d=new a(this.f);b?(d.initAnnotation(this.annottype,this.annotationcolor,!0,c),d.content=this.getTextContent()):
(m.each(this,function(b,e){d[e]=b}),d.modifiedContent=null,d.rect&&(d.rect=d.rect.copy()),d.popuprect&&(d.popuprect=d.popuprect.copy()));d.isNew=!0;d.name=c.generateUniqueName();e||(d.replies=[]);g||(d.states=[]);b?(e=this.inreplyto?this.parent:this,d.pointArray=[],m.each(e.pointArray,function(b){d.pointArray.push(m.clone(b))}),d.color=m.clone(e.color),d.rect=e.rect.copy(),d.popuprect=e.popuprect.copy()):d.pointArray=[];h?(d.links=[],m.each(this.links,function(b){b=b.duplicate(!1,!1,!0,!1,c);b.linkedto=
d.name;b.parent=d;d.links.push(b)})):d.links=[];return d};a.prototype.needsSelectionBox=function(){return this.annottype!=h.AnnotationType.ANNOT_PIN};a.prototype.setSelected=function(e){this.linewidth=(this.selected=e)?3:2;this.annottype===h.AnnotationType.ANNOT_HIGHLIGHT&&(this.fillcolor="rgba(255, 255, 0, "+(e?".8":".3")+")");this.annottype===h.AnnotationType.ANNOT_PIN&&(this.imageRef=e?h.AnnotationPin.highlighted:h.AnnotationPin.normal)};a.prototype.updateIndicator=function(){this.indicatorText=
""+this.messagenumber;this.linkedto?this.parent&&(this.indicatorText+="-"+(m.indexOf(this.parent.links,this)+2)):0<this.getGodfather().links.length&&(this.indicatorText+="-1");this.indicatorTextColor=this.getHeaderTextColor();this.indicatorColor=this.annotationcolor};a.prototype.getUserName=function(){return this.firstname?this.lastname+", "+this.firstname+" ("+this.username+")":this.lastname+" ("+this.username+")"};a.prototype.rgbColor=function(){var e=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(this.annotationcolor);
return e?{r:parseInt(e[1],16),g:parseInt(e[2],16),b:parseInt(e[3],16)}:null};a.prototype.getHeaderTextColor=function(){var e=this.rgbColor();return 0.5<0.3*(e.r/255)+0.59*e.g/255+0.11*e.b/255?"black":"white"};a.prototype.setModified=function(e){this._modifications.add(e);this.saved=0===this._modifications.size();this.date=new Date};a.prototype.setIsNew=function(e){this.isNew=e};a.prototype.cancelModified=function(e){"CONTENT"===e&&(this.modifiedContent=null);void 0!==e?this._modifications.remove(e):
this._modifications.clear();this.saved=0===this._modifications.size()};a.prototype.setBeingModified=function(e){void 0===e&&(e=null);this.modifiedContent!==e&&(this._modifications.add("CONTENT"),this.modifiedContent=e,this.saved=!1)};a.prototype.isBeingModified=function(){return!this.saved};a.prototype._runThroughAnnotation=function(e,a,b,h){if(a){var c=m.clone(e.replies);m.each(c,m.bind(function(e){h(e)||this._runThroughAnnotation(e,a,b,h)},this))}b&&(e=m.clone(e.states),m.each(e,m.bind(function(e){h(e)||
this._runThroughAnnotation(e,a,b,h)},this)))};a.prototype.runThroughAnnotation=function(e,a,b,h){(!e||!h(this))&&this._runThroughAnnotation(this,a,b,h)};a.prototype.toXML=function(e){var a=e.createElementNS(null,h.AnnotationElementName[this.annottype]);this.isNew&&!this.linkedto?a.setAttribute("title",this.getUserName()):a.setAttribute("title",this.messagenumber+" "+this.getUserName());(!this.name||0===this.name.length)&&this.f.emit("error.SEVERE","Trying to convert an annotation without a name to XML");
a.setAttribute("name",this.name);a.setAttribute("color",this.annotationcolor);a.setAttribute("creationdate",d.stringFromDate(this.creationdate));a.setAttribute("date",d.stringFromDate(this.date));a.setAttribute("flags",this.flags);a.setAttribute("page",this.page);var b=this.rect;this._scaling&&(b=new i.Rect(new i.Point(1*this.rect.origin.x/this._scaling.x,1*this.rect.origin.y/this._scaling.y),new i.Size(1*this.rect.size.width/this._scaling.x,1*this.rect.size.height/this._scaling.y)));a.setAttribute("rect",
d.rectToString(b));a.setAttribute("subject",this.subject);this.state&&a.setAttribute("state",this.state);this.statemodel&&a.setAttribute("statemodel",this.statemodel);this.inreplyto&&a.setAttribute("inreplyto",this.inreplyto);this.linkedto&&a.setAttribute("linkedto",this.linkedto);this._view3DPosition&&(a.setAttribute("view3Dscale",this._view3DPosition.scale),a.setAttribute("view3Dazimuth",this._view3DPosition.azimuth),a.setAttribute("view3Delevation",this._view3DPosition.elevation));if(!this.inreplyto)if(h.AnnotationType.ANNOT_FREEFORM==
this.annottype){for(var r=e.createElementNS(null,"inklist"),b=e.createElementNS(null,"gesture"),m="",k=0;k<this.pointArray.length;k++){var f=this.pointArray[k];0!==k&&(m+=";");m=this._scaling?m+(c.convertMMToPSPoints(1*f.x/this._scaling.x)+","+c.convertMMToPSPoints(1*f.y/this._scaling.y)):m+(c.convertMMToPSPoints(f.x)+","+c.convertMMToPSPoints(f.y))}b.textContent=m;r.appendChild(b);a.appendChild(r)}else if(h.AnnotationType.ANNOT_LINE==this.annottype||h.AnnotationType.ANNOT_ARROW==this.annottype)k=
this.pointArray[0],r=this.pointArray[1],b=this._scaling?new i.Rect(new i.Point(1*b.origin.x/this._scaling.x,1*b.origin.y/this._scaling.y),new i.Size(1*b.size.width/this._scaling.x,1*b.size.height/this._scaling.y)):new i.Rect(new i.Point(k.x,r.y),new i.Size(r.x-k.x,k.y-r.y)),a.setAttribute("rect",d.rectToString(b)),b=c.convertMMToPSPoints(k.x)+","+c.convertMMToPSPoints(k.y),m=c.convertMMToPSPoints(r.x)+","+c.convertMMToPSPoints(r.y),this._scaling&&(b=c.convertMMToPSPoints(1*k.x/this._scaling.x)+","+
c.convertMMToPSPoints(1*k.y/this._scaling.y),m=c.convertMMToPSPoints(1*r.x/this._scaling.x)+","+c.convertMMToPSPoints(1*r.y/this._scaling.y)),a.setAttribute("start",b),a.setAttribute("end",m),this.annottype==h.AnnotationType.ANNOT_ARROW&&(a.setAttribute("head","None"),a.setAttribute("tail","OpenArrow"));if(!this.linkedto||this.statemodel){r=e.createElement("contents-richtext");null!==this.modifiedContent&&(this.content=this.modifiedContent);if(this.content)if(b=this._parseMarkupToXMLDocument(this.content),
k=b.getElementsByTagName("body")[0])r.appendChild(o(k,e));else{m=e.createElement("body");if(b.hasChildNodes&&b.hasChildNodes())for(k=0;k<b.childNodes.length;k++)f=o(b.childNodes[k],e),null!=f&&m.appendChild(f);r.appendChild(m)}a.appendChild(r)}0===this.popuprect.origin.x&&0===this.popuprect.origin.y&&(this.popuprect.origin.x=this.rect.right(),this.popuprect.origin.y=this.rect.top());e=e.createElementNS(null,"popup");e.setAttribute("rect",d.rectToString(this.popuprect));e.setAttribute("page",this.popuppage);
e.setAttribute("open",this.popupIsOpen?"yes":"no");a.appendChild(e);return a};a.prototype._parseMarkupToXMLDocument=function(e){e=e.replace(/\&nbsp;/g," ");try{if((new DOMParser).parseFromString("","text/html")){var a=(new DOMParser).parseFromString(e,"text/html");if(a&&a.documentElement)return a.documentElement}}catch(b){}var a=document.implementation.createHTMLDocument(""),h=/<body>(.*)<\/body>/.exec(e);h&&1<=h.length&&(e=h[1]);(h=/<html>(.*)<\/html>/.exec(e))&&1<=h.length&&(e=h[1]);a.body.innerHTML=
e;return a.documentElement};a.prototype.getUserStateAnnotation=function(e){return m.find(this.states,function(a){return a.username===e})};a.prototype.getStringContent=function(e){var a=this.content.replace(/<([^<]*)>/g,"").trim();e&&a.length>e&&(a=a.substring(0,e)+"...");return a};a.prototype.setColor=function(e){null===e&&(e=this._getDefaultAnnotationColor(this.annottype));this.runThroughAnnotation(!0,!0,!0,function(b){b.annotationcolor!=e&&(b.annotationcolor=e,b.color=e,b.setModified("COLOR"))});
var a=this.getGodfather();m.each(a.links,function(b){b.annotationcolor!=e&&(b.annotationcolor=e,b.color=e,b.setModified("COLOR"))})};a.prototype.cancelModifiedColor=function(){this.cancelModified("COLOR");this.runThroughAnnotation(!0,!0,!0,function(e){e.cancelModified("COLOR")});var e=this.getGodfather();m.each(e.links,function(e){e.cancelModified("COLOR")})};a.prototype.resetAnnotationColor=function(){this.originalAnnotationColor&&this.setColor(this.originalAnnotationColor)};a.prototype.getGodfather=
function(){for(var e=this;e.parent;)e=e.parent;return e};a.prototype.getType=function(){return this.annottype};a.prototype.getTextContent=function(){return m.clone(this.content)};a.prototype.getMessageNumber=function(){return this.messagenumber};a.prototype.setUnsavedReply=function(e){this.setModified("REPLY");this.unsavedReplyText=e;""===e&&this.cancelModified("REPLY")};a.prototype.resetUnsavedReply=function(){this.unsavedReplyText=null;this.cancelModified("REPLY")};a.prototype.getUnsavedReply=function(){return this.unsavedReplyText};
a.prototype.hasUnsavedReply=function(){return null!==this.unsavedReplyText&&""!==this.unsavedReplyText};a.prototype.isStateObject=function(){return null!==this.state};a.prototype.setScale=function(e){this.scale(e);this._scaling=e};a.prototype.isScaled=function(){return null!==this._scaling&&void 0!==this._scaling};a.prototype.getScale=function(){return this._scaling};a.prototype._getDefaultAnnotationColor=function(e){return e==h.AnnotationType.ANNOT_PIN?this.f.getCurrentUser().getColor("PREFERENCES_ANNOTATION_NOTE_COLOR"):
this.f.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR")};a.prototype._parseContentsFromXML=function(e){e=e.getElementsByTagName("contents-richtext");this.content="<p></p>";if(0<e.length){var a=e[0].getElementsByTagName("body")[0];a||(a=e[0]);"undefined"!=typeof window.XMLSerializer?this.content=(new XMLSerializer).serializeToString(a):"undefined"!=typeof a.xml&&(this.content=a.xml)}};a.prototype.getExtraContent=function(){return null};a.prototype.set3DViewPosition=function(e){this._view3DPosition=
e;this.setModified("3DVIEW")};a.prototype.get3DViewPosition=function(){return this._view3DPosition};return a});
define("web-viewer/annotation/AnnotationFilterModel2",["web-viewer/core/PrivateChannel","web-viewer/annotation/AnnotationConstants","web-viewer/core/AbstractModel","underscore","jquery"],function(f,l,i,j,d){f=function(c){i.call(this,c,"annotationFilterModel");this.f=c;this._filterRows=[];this._filterOperator=l.FilterOperators.ALL;this._isCustomFilterEnabled=!1;this._selectedState=this._selectedUser=null;this._inverseState=!1;this._numberOfFilteredAnnotations=0;this._originType=l.AnnotationOriginTypes.user.id;
this._viewerUserFilter=(c=this.f.getProperty("showuser"))?c.split("|"):[];(this._annotationFilterPinnedState=void 0!==this.f.getOption("ANNOTATION_FILTER")&&""!==this.f.getOption("ANNOTATION_FILTER"))&&this.setFilterState(this.f.getOption("ANNOTATION_FILTER"))};f.prototype.resetFilter=function(){this._selectedState=this._selectedUser=null;this._inverseState=!1;this._originType=l.AnnotationOriginTypes.user.id;this._filterRows=[];this._filterRows.push(this.getDefaultFilterRow());this._filterOperator=
l.FilterOperators.ALL;this._isCustomFilterEnabled=!1;this._numberOfFilteredAnnotations=0;this._emit("filterReset",this);this._emit("filterChanged",this)};f.prototype.setSelectedUser=function(c){this._selectedUser=c;this._isCustomFilterEnabled=!1;this._emit("filterChanged",this);this.fireFilterStateChanged()};f.prototype.setOriginType=function(c){c!==this._originType&&(this._originType=c,this._isCustomFilterEnabled=!1,this._emit("filterChanged",this),this.fireFilterStateChanged())};f.prototype.getSelectedUser=
function(){return this._selectedUser};f.prototype.getOriginType=function(){return this._originType};f.prototype.setSelectedState=function(c,d){this._selectedState=c;this._inverseState=d;this._isCustomFilterEnabled=!1;this._emit("filterChanged",this);this.fireFilterStateChanged()};f.prototype.getSelectedState=function(){return this._selectedState};f.prototype.isInverseState=function(){return this._inverseState};f.prototype.addFilterRow=function(c,d,f,h){this._filterRows[c]={filterId:c,filterType:d,
filterCondition:f,filterOption:h}};f.prototype.addEmptyRow=function(){this._filterRows.push(this.getDefaultFilterRow());this._emit("filterChanged",this);return this._filterRows.length-1};f.prototype.updateFilterType=function(c,d,f){this._filterRows[c]&&(this._filterRows[c].filterType=d,this._filterRows[c].filterOption=f,this._emit("filterChanged",this))};f.prototype.updateFilterOption=function(c,d){this._filterRows[c]&&(this._filterRows[c].filterOption=d,this._emit("filterChanged",this))};f.prototype.updateFilterCondition=
function(c,d){this._filterRows[c]&&(this._filterRows[c].filterCondition=d,this._emit("filterChanged",this))};f.prototype.removeFilterRow=function(c){delete this._filterRows[c];this._emit("filterChanged",this)};f.prototype.removeAllFilterRows=function(){this._filterRows=[];this._emit("filterChanged",this)};f.prototype.getFilterRow=function(c){return this._filterRows[c]};f.prototype.getFilterRows=function(){0===this._filterRows.length&&this._filterRows.push(this.getDefaultFilterRow());return j.without(this._filterRows,
null,void 0)};f.prototype.setFilterRows=function(c){this._filterRows=c;this._emit("filterChanged",this)};f.prototype.getDefaultFilterRow=function(){return{filterId:this._filterRows.length,filterType:l.FilterTypes.REVIEWSTATE,filterCondition:l.FilterCondition.IS,filterOption:"STATUS_ACCEPTED"}};f.prototype.setCustomFilterActive=function(c){(this._isCustomFilterEnabled=c)&&0===this._filterRows.length&&this._filterRows.push(this.getDefaultFilterRow());this._emit("filterChanged",this)};f.prototype.isCustomFilterActive=
function(){return this._isCustomFilterEnabled};f.prototype.setFilterOperator=function(c){this._filterOperator=c;this._emit("filterChanged",this)};f.prototype.getFilterOperator=function(){return this._filterOperator};f.prototype.setNumberOfFilteredAnnotations=function(c){this._numberOfFilteredAnnotations=c};f.prototype.getNumberOfFilteredAnnotations=function(){return this._numberOfFilteredAnnotations};f.prototype.isAnnotationFilterPinned=function(){return this._annotationFilterPinnedState};f.prototype.toggleAnnotationPinnedState=
function(c){(this._annotationFilterPinnedState=void 0!==c?c:!this._annotationFilterPinnedState)?this.fireFilterStateChanged():this._emit("filterStateChanged",!1)};f.prototype.getFilterState=function(){var c={customFilterOperator:this._filterOperator,customFilterRows:j.compact(this._filterRows),isCustomFilterActive:this.isCustomFilterActive(),selectedUser:this._selectedUser,selectedState:this._selectedState,inverseState:this._inverseState};return JSON.stringify(c)};f.prototype.setFilterState=function(c){try{if(c=
d.parseJSON(c))this._isCustomFilterEnabled=c.isCustomFilterActive,this._filterOperator=c.customFilterOperator,this._filterRows=c.customFilterRows,j.each(this._filterRows,function(c,h){c.filterId=h},this),this._selectedUser=c.selectedUser,this._selectedState=c.selectedState,this._inverseState=c.inverseState}catch(f){}this._emit("filterChanged",this)};f.prototype.fireFilterStateChanged=function(){this._emit("filterStateChanged",!0)};f.prototype.getViewerUserFilter=function(){return this._viewerUserFilter};
return f});
define("web-viewer/annotation/AnnotationModel","web-viewer/core/PrivateChannel web-viewer/annotation/AnnotationFilter web-viewer/annotation/Annotation web-viewer/annotation/AnnotationConstants web-viewer/annotation/AnnotationFilterModel2 utils/ShapeUtils web-viewer/utils/ListenerUtil web-viewer/utils/ViewerUtils web-viewer/layout/component/ModalPopup web-viewer/layout/component/ViewerToolbarButton web-viewer/layout/LayoutConstants utils/OrderedObject underscore".split(" "),function(f,l,i,j,d,c,k,
n,h,m,o,a,e){var g=function(b,g){f.installTo(this,b,["annotationModel",g]);k.mixin(this,b);this.f=b;this._disabledReasons=new a;this._page=null;this._annotations=[];this._removedannotations=[];this._selectedAnnotations=[];this._filteredAnnotations=[];this._layoutType=null;this._annotationFilterModel=new d(this.f);this._orderedAnnotations=[];this._currentAnnotationIndex=-1;this._currentScaling=null;this.lockSelection=!1;this._disabledReasonChangedListener=this._addAnnotationsEnabledListener=null;this._isSavingAnnotations=
this._annotationListVisible=!1;var h=b.getCurrentUser();h.on("options.changed.PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE",e.bind(function(){this.modelChanged()},this));h.on("options.changed.PREFERENCES_ANNOTATION_NEXT_MODE",e.bind(function(){this._orderedAnnotations.length=0;this.modelChanged()},this));h.on("options.changed.PREFERENCES_ANNOTATION_DATESORT_MODE",e.bind(function(b,e){this.setSortingMode(e)},this));h.on("options.changed.PREFERENCES_ANNOTATION_SHOWSELECTEDONLY",e.bind(function(){this.modelChanged()},
this));this.setSortingMode(b.getOption("PREFERENCES_ANNOTATION_DATESORT_MODE"));this._canChangeAnnotations=!0;this._annotationmode=j.annotateMode.NO_RESTRICTIONS;b.getProperty("annotationmode")&&(this._annotationmode=parseInt(b.getProperty("annotationmode"),10));this._allowedAnnotators=j.allowedAnnotators.ALL;b.getProperty("annotatorsmode")&&(this._allowedAnnotators=parseInt(b.getProperty("annotatorsmode"),10));this.editabilityDependsOnApproval()&&(this._canChangeAnnotations=!1,b.loadBundle("viewer",
function(){this.setDisableReason("LOADING_APPROVAL",this.f.t("Loading"))},this));this._confirmedOnce=this._warnWhenChangingAnnotations=!1;this._filter=new l(b,this._annotationFilterModel);this._annotationFilterModel.on("filterChanged",e.bind(function(){this._filterAllAnnotations();this._orderedAnnotations=[]},this));this._temporarilyDisabled={isTemporarilyDisabled:!1,reason:"",enableAnnotationToggling:!1,showingCurrentAnnotations:!1,showingDifferenceAnnotations:!1}};g.prototype.setAnnotationListVisible=
function(b){this._annotationListVisible!==b&&(this._annotationListVisible=b,this._emit("annotationListVisible",b))};g.prototype.isAnnotationListVisible=function(){return this._annotationListVisible};g.prototype.currentOrdening=function(){return this.orderByCreationDate};g.prototype.toggleVisibility=function(b){if(void 0===b)b=1==this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE"),b=!b;else if(b&&1==this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE"))return;b?this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",
1):(this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",0),this.unselectAllAnnotations());this.modelChanged()};g.prototype.temporarilyDisable=function(b,e,a,g){this._temporarilyDisabled.isTemporarilyDisabled=b;this._temporarilyDisabled.reason=a;this._temporarilyDisabled.enableAnnotationToggling=e;this.unselectAllAnnotations();void 0!==g?("difference"==g?this.showTemporarilyDifferencePageAnnotations():"current"==g&&this.showTemporarilyActivePageAnnotations(),this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",
1,!0)):(this._temporarilyDisabled.showingCurrentAnnotations=!1,this._temporarilyDisabled.showingDifferenceAnnotations=!1);this.updateTemporarilyDisabledReason();this._emit("temporarilyDisableChanged");b||(this.setPage(this.f.getActivePage()),this._temporarilyDisabled.showingCurrentAnnotations=!0);this.modelChanged()};g.prototype.updateTemporarilyDisabledReason=function(){this.f.loadBundle("viewer",function(){this.isTemporarilyDisabled()&&!this.isTemporarilyCurrentPageAnnotationsShown()?(this.setDisableReason("TEMPORARY_DISABLE",
this._temporarilyDisabled.reason),this.isTemporarilyDifferencePageAnnotationsShown()&&this.setDisableReason("TEMPORARY_DISABLE",this.f.t("AnnDisabledDiffMode"))):this.removeDisableReason("TEMPORARY_DISABLE")},this)};g.prototype.isTemporarilyDisabledAndNoAnnotationsVisible=function(){return this._temporarilyDisabled.isTemporarilyDisabled&&!this._temporarilyDisabled.showingCurrentAnnotations&&!this._temporarilyDisabled.showingDifferenceAnnotations||!this.isAllowedToShowAnnotations()};g.prototype.isTemporarilyDisabled=
function(){return this._temporarilyDisabled.isTemporarilyDisabled};g.prototype.isTemporarilyDisabledAndCannotEdit=function(){return this._temporarilyDisabled.isTemporarilyDisabled&&!this._temporarilyDisabled.showingCurrentAnnotations||!this.isAllowedToShowAnnotations()};g.prototype.getTemporarilyDisabledMessage=function(){return this._temporarilyDisabled.reason};g.prototype.isTemporarilyCurrentPageAnnotationsShown=function(){return this._temporarilyDisabled.showingCurrentAnnotations&&this.isAllowedToShowAnnotations()};
g.prototype.isTemporarilyDifferencePageAnnotationsShown=function(){return this._temporarilyDisabled.showingDifferenceAnnotations&&this.isAllowedToShowAnnotations()};g.prototype.isTemporarilyAnnotationDocumentTogglingEnabled=function(){return this._temporarilyDisabled.enableAnnotationToggling&&this.isAllowedToShowAnnotations()};g.prototype.isAllowedToShowAnnotations=function(){return!e.some(this._disabledReasons.getItemsAsObject(),function(b){return b.hideAnnotations})};g.prototype.showTemporarilyDifferencePageAnnotations=
function(){if(this.isAllowedToShowAnnotations()){var b=this.f.getDocumentController().getDifferencePage();this.unselectAllAnnotations();this._temporarilyDisabled.showingDifferenceAnnotations=!0;this._temporarilyDisabled.showingCurrentAnnotations=!1;this.updateTemporarilyDisabledReason();this.setPage(b,e.bind(function(){this.updateTemporarilyDisabledReason();this._emit("temporarilyDisableChanged");this.modelChanged()},this))}};g.prototype.showTemporarilyActivePageAnnotations=function(){if(this.isAllowedToShowAnnotations()){var b=
this.f.getActivePage();this.unselectAllAnnotations();this.setPage(b,e.bind(function(){this._temporarilyDisabled.showingDifferenceAnnotations=!1;this._temporarilyDisabled.showingCurrentAnnotations=!0;this.updateTemporarilyDisabledReason();this._emit("temporarilyDisableChanged");this.modelChanged()},this))}};g.prototype.hideTemporarilyAnnotations=function(){this._temporarilyDisabled.showingDifferenceAnnotations=!1;this._temporarilyDisabled.showingCurrentAnnotations=!1;this.setPage(this.f.getDocumentController().getActivePage());
this.updateTemporarilyDisabledReason();this._emit("temporarilyDisableChanged");this.modelChanged()};g.prototype.getAnnotationsPage=function(){return this._page};g.prototype.editabilityDependsOnApproval=function(){return this._annotationmode===j.annotateMode.IF_APPROVED_SHOW_WARNING||this._annotationmode===j.annotateMode.IF_APPROVED_DISABLE||this._annotationmode===j.annotateMode.IF_APPROVED_OR_REJECTED_SHOW_WARNING||this._annotationmode===j.annotateMode.IF_APPROVED_OR_REJECTED_DISABLE||this._allowedAnnotators!==
j.allowedAnnotators.ALL||this._annotationmode===j.annotateMode.ALWAYS_DISABLE};g.prototype.canChangeAnnotations=function(b){return this.isTemporarilyDisabledAndCannotEdit()||this._cannotChangeAnnotationsOfCurrentPage()||!this._canChangeAnnotations?!1:!this._confirmedOnce&&this._warnWhenChangingAnnotations&&!b?(b=this._page.isApproved()?"AnnAlreadyApproved":"AnnAlreadyRejected",this._confirmedOnce=window.confirm(this.f.i18n.t(b))):!0};g.prototype.canChangeAnnotation=function(b){if(this.isTemporarilyDisabledAndCannotEdit()||
this._cannotChangeAnnotationsOfCurrentPage())return!1;var e=j.AccessRight.READ_ONLY;this._canChangeAnnotations&&(e=b.getPermission());return e==j.AccessRight.READ_WRITE};g.prototype._cannotChangeAnnotationsOfCurrentPage=function(){return this._page&&(!this._page.getDocumentVersion().isLatestVersion()||!this._page.canChangeAnnotations())};g.prototype.canDeleteAnnotation=function(b){return this.f.getProperty("annotationblockdeletesaved")&&!b.isNew?!1:this.canChangeAnnotation(b)};g.prototype.updateApprovalInfo=
function(){this._page&&this.f.loadBundle("viewer",function(){var b=this._canChangeAnnotations;this._canChangeAnnotations=!0;this._warnWhenChangingAnnotations=!1;var a="";if(this._annotationmode===j.annotateMode.ALWAYS_DISABLE)this._canChangeAnnotations=!1,a=this.f.t("AnnDisabled");else if(this._page.isApproved()&&(this._annotationmode===j.annotateMode.IF_APPROVED_SHOW_WARNING?this._warnWhenChangingAnnotations=this._canChangeAnnotations=!0:this._annotationmode===j.annotateMode.IF_APPROVED_DISABLE&&
(this._warnWhenChangingAnnotations=this._canChangeAnnotations=!1,a=this.f.t("AnnAlreadyApprovedBlocked"))),this._page.isApproved()||this._page.isRejected())this._annotationmode===j.annotateMode.IF_APPROVED_OR_REJECTED_SHOW_WARNING?this._warnWhenChangingAnnotations=this._canChangeAnnotations=!0:this._annotationmode===j.annotateMode.IF_APPROVED_OR_REJECTED_DISABLE&&(this._warnWhenChangingAnnotations=this._canChangeAnnotations=!1,a=this._page.isApproved()?this.f.t("AnnAlreadyApprovedBlocked"):this.f.t("AnnAlreadyRejectedBlocked"));
this._canChangeAnnotations&&this._page.isUnderApproval()&&this._allowedAnnotators!==j.allowedAnnotators.ALL&&(this._allowedAnnotators===j.allowedAnnotators.ALL_APPROVERS?this._page.isUserApprover()||(this._canChangeAnnotations=!1,a=this.f.t("AnnNotApproverBlocked")):this._allowedAnnotators===j.allowedAnnotators.ALL_APPROVERS_AND_MASTER?!this._page.isUserApprover()&&!this._page.isUserApprovalMaster(e.bind(this.updateApprovalInfo,this))&&(this._canChangeAnnotations=!1,a=this.f.t("AnnNotApproverOrMasterBlocked")):
this._allowedAnnotators===j.allowedAnnotators.PENDING_APPROVERS?this._page.isUserPendingApprover()||(this._canChangeAnnotations=!1,a=this.f.t("AnnNotPendingApproverBlocked")):this._allowedAnnotators===j.allowedAnnotators.PENDING_APPROVERS_AND_MASTER&&(!this._page.isUserPendingApprover()&&!this._page.isUserApprovalMaster(e.bind(this.updateApprovalInfo,this)))&&(this._canChangeAnnotations=!1,a=this.f.t("AnnNotPendingApproverOrMasterBlocked")));""!==a?(this.setDisableReason("ANNOTATORS_MODE",a),0<this.getUnsavedAnnotationCount()&&
this.reload()):this.removeDisableReason("ANNOTATORS_MODE");b!=this._canChangeAnnotations&&this._emit("readWriteChanged")},this)};g.prototype.onApprovalUpdated=function(){this.removeDisableReason("LOADING_APPROVAL");this.updateApprovalInfo()};g.prototype.setAnnotations=function(b){b=this._filter.filterIncomingAnnotations(b);this.scaleAllAnnotations(null);this._annotations=b;this._page&&this._page!==this.f.getDocumentController().getDifferencePage()&&this.scaleAllAnnotations(this._page.getCurrentScaling());
this._confirmedOnce=!1;this.setSortingMode(this.f.getOption("PREFERENCES_ANNOTATION_DATESORT_MODE"),!0);this._filterAllAnnotations(!0);this.modelContentChanged()};g.prototype.getAnnotations=function(){return this._annotations};g.prototype.getAnnotationOrigins=function(){return e.uniq(e.map(this._annotations,function(b){return b.originType}))};g.prototype.getAnnotationCount=function(){return e.filter(this._annotations,function(b){return b.getGodfather()===b},this).length};g.prototype._filterAllAnnotations=
function(b){var a=e.filter(this._annotations,function(b){return b.getGodfather()===b},this);this._filteredAnnotations=this._filter.filterAnnotations(a);this.currentOrdening();b||(this.modelChanged(),this.filterChanged())};g.prototype.getUsers=function(b){var a={};e.each(this._annotations,function s(g){if(!a[g.username]&&(!b||g.originType===b))a[g.username]=g.getUserName();0<g.replies.length&&e.each(g.replies,s)});void 0===a[this.f.getCurrentUser().getUsername()]&&(a[this.f.getCurrentUser().getUsername()]=
this.f.getCurrentUser().getFullName());return a};g.prototype._deleteOneAnnotation=function(b){this._annotations.splice(e.indexOf(this._annotations,b),1);0<=e.indexOf(this._filteredAnnotations,b)&&this._filteredAnnotations.splice(e.indexOf(this._filteredAnnotations,b),1);b.isNew||this._removedannotations.push(b)};g.prototype._renumberNewAnnotations=function(b){var a=this.getUnsavedAnnotations();e.each(a,e.bind(function(a){a.messagenumber>b&&(a.messagenumber-=1,a.updateIndicator())},this));this._emit("modelContentChanged")};
g.prototype.deleteAnnotation=function(b){this.canDeleteAnnotation(b)?this.f.i18n.loadBundle("viewer",e.bind(function(){b.inreplyto?this._deleteAnnotationWithoutConfirmation(b):(void 0===this._deleteAnnotationPopup&&(this._deleteAnnotationPopup=new h(this.f,"deleteAnnotationPopup",this.f.getContext()),this._deleteAnnotationPopup.setHeader($("<span/>").addClass("popupTitle").text(this.f.i18n.t("DeleteAnnotBtnTT"))),this._deleteAnnotationPopup.setContent($("<div/>").addClass("unsavedItemsContent").text(this.f.i18n.t("AnnDelete"))),
this._deleteAnnotationPopup.setOkBtnText(this.f.i18n.t("YesResponse")),this._deleteAnnotationPopup.setCancelBtnText(this.f.i18n.t("NoResponse"))),this._deleteAnnotationPopup.setOkAction(e.bind(function(){this._deleteAnnotationPopup.hide();this._deleteAnnotationWithoutConfirmation(b)},this)),this._deleteAnnotationPopup.show(),this._deleteAnnotationPopup.recalculateSize(400))},this)):this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.WARNING",this.f.i18n.t("AnnReadOnlyError"))},this)};g.prototype._deleteAnnotationWithoutConfirmation=
function(b){if(b.parent){var a=e.indexOf(b.parent.replies,b);-1<a?b.parent.replies.splice(a,1):(a=e.indexOf(b.parent.states,b),-1<a?b.parent.states.splice(a,1):-1<e.indexOf(b.parent.links,b)&&this._deleteAnnotationWithoutConfirmation(b.parent));b.isNew||this._removedannotations.push(b)}else this.unselectAllAnnotations(!0),e.each(b.links,function(b){this._deleteOneAnnotation(b)},this),this._deleteOneAnnotation(b),this._filterAllAnnotations(!0);this._emit("annotationDeleted",b);b.isNew&&this._renumberNewAnnotations(b.messagenumber);
this.modelChanged()};g.prototype.reload=function(b){var a=e.bind(function(){this._emit("reload.started");this.unselectAllAnnotations();this.resetAllAnnotations();this._page?(this.modelChanged(),this._page.reloadAnnotations(e.bind(function(b){b&&this.setAnnotations(this._page.getAnnotations());this.modelChanged();this._emit("reload.finished")},this))):this._emit("reload.finished")},this);b?a():this.promptToSaveUnsavedAnnotations(a,function(){},a)||a()};g.prototype.save=function(b,a){if(this._isSavingAnnotations)this.f.emit("error.WARNING",
this.f.i18n.t("AnnAreAlreadyBeingSaved"),!0);else if(this._emit("save.started"),this._isSavingAnnotations=!0,this.canChangeAnnotations()&&this._page){this.unselectAllAnnotations();e.each(this._annotations,function(b){if(b.hasUnsavedReply()){var a=b.getUnsavedReply();b.resetUnsavedReply();this.replyToAnnotation(b,a,!1)}},this);var g,h=this._removedannotations.slice(0);this._removedannotations=[];if(b){h=[];g=[];g.push(b);var c=b.getGodfather();e.each(c.links,function(b){!b.saved&&-1==e.indexOf(g,b)&&
g.push(b)})}else g=this.getUnsavedAnnotations();this._page.saveAnnotations(g,h,e.bind(function(b,e){this._isSavingAnnotations=!1;this._page==b&&this.setAnnotations(e);a&&a();this._emit("save.finished");this.modelChanged()},this,this._page))}else this._isSavingAnnotations=!1,this._emit("save.finished")};g.prototype.getUnsavedAnnotationCount=function(){var b=this.getUnsavedAnnotations().length,a=this.getDeletedAnnotations().length;return b+a};g.prototype.getUnsavedAnnotations=function(){var b=[];this.canChangeAnnotations(!0)&&
e.each(this._annotations,e.bind(function(a){a.runThroughAnnotation(!0,!0,!0,e.bind(function(a){(!a.saved||a.hasUnsavedReply())&&(-1==e.indexOf(b,a)&&this.canChangeAnnotation(a))&&b.push(a)},this));a=a.getGodfather();e.each(a.links,e.bind(function(a){(!a.saved||a.hasUnsavedReply())&&(-1==e.indexOf(b,a)&&this.canChangeAnnotation(a)&&!a.isStateObject())&&b.push(a)},this))},this));return b};g.prototype.getSavedAnnotations=function(){var b=[];e.each(this._annotations,function(a){a.saved&&b.push(a)});return b};
g.prototype.getDeletedAnnotations=function(){return this._removedannotations};g.prototype.getVisibleAnnotations=function(){return 0===this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE")||this.isTemporarilyDisabledAndNoAnnotationsVisible()?[]:this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY")&&0<this._selectedAnnotations.length?this._selectedAnnotations:this._filteredAnnotations};g.prototype.getFilteredAnnotations=function(){return this._filteredAnnotations};g.prototype.selectAnnotation=
function(b,a){var e;if(!(1===this._selectedAnnotations.length&&b==this._selectedAnnotations[0])){this.unselectAllAnnotations(!0,a);this._selectedAnnotations.push(b);var g=b.getGodfather();if(g.links)for(e=0;e<g.links.length;e++)this._selectedAnnotations.push(g.links[e]);if(b.linkedto&&(b=this.getAnnotation(b.linkedto))){for(e=0;e<b.links.length;e++)b.links[e]!=b&&this._selectedAnnotations.push(b.links[e]);this._selectedAnnotations.push(b)}this.ensureVisibility();this._layoutType==o.LayoutType.MOBILE&&
this.f.emit("module.annotation.zoomToAnnotation",b);this._emit("selectedAnnotation",b);this.modelChanged()}};g.prototype.ensureVisibility=function(){this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE")||this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",1)};g.prototype.getAnnotation=function(b){for(var a=0;a<this._annotations.length;a++)if(this._annotations[a].name==b)return this._annotations[a];return null};g.prototype.getAnnotationLinks=function(b){var a,e=[];if(b.links)for(a=0;a<b.links.length;a++)e.push(b.links[a]);
if(b.linkedto)for(a=0;a<this._annotations.length;a++)this._annotations[a].name==b.linkedto&&e.push(this._annotations[a]);return e};g.prototype.getReplies=function(b){var a=[];b.runThroughAnnotation(!1,!0,!1,function(b){a.push(b)});return a};g.prototype.unselectAllAnnotations=function(b,a){if(!(0>=this._selectedAnnotations.length||this.lockSelection&&!a)){var g=this._selectedAnnotations;this._selectedAnnotations=[];e.each(g,e.bind(function(b){this._emit("unselectedAnnotation",b)},this));b||this.modelChanged()}};
g.prototype.resetAllAnnotations=function(){this.scaleAllAnnotations(null);this.unselectAllAnnotations();this._annotations=[];this._removedannotations=[];this._page.resetAnnotations()};g.prototype.isAnnotationOrReplySelected=function(b){return null!==b?-1<e.indexOf(this._selectedAnnotations,b)?!0:0===b.replies.length?!1:e.some(b.replies,e.bind(function(b){return-1<e.indexOf(this._selectedAnnotations,b)},this)):!1};g.prototype.getSelectedAnnotations=function(){return this._selectedAnnotations};g.prototype.moveAnnotation=
function(b,a){if(!this.canChangeAnnotation(b))return!1;b.move(a);this.modelChanged();return!0};g.prototype.transformAnnotation=function(b,a){if(!this.canChangeAnnotation(b))return!1;b.setRect(a);this.modelChanged();return!0};g.prototype.updateStartEndOfAnnotation=function(b,a,e){if(!this.canChangeAnnotation(b))return!1;b.setStartEnd(a,e);this.modelChanged();return!0};g.prototype.addAnnotationWithRect=function(b,a,e){var g;g=this.f.getProperty("annotationcolor")?this.f.getProperty("annotationcolor"):
this.f.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR");var h=new i(this.f);h.initAnnotation(e,g,!1,this,b);a&&(h.content=a);this.addAnnotation(h)};g.prototype._nextNumberForOriginType=function(b){for(var a=0,e=0;e<this._annotations.length;e++)this._annotations[e].messagenumber>a&&this._annotations[e].originType===b&&(a=this._annotations[e].messagenumber);a++;return a};g.prototype.addAnnotation=function(b,a,g){if(this.checkCanChangeAnnotationsAndDisplayError())if(b.linkedto||(b.messagenumber=
this._nextNumberForOriginType(b.originType)),b.username=this.f.getCurrentUser().getUsername(),b.firstname=this.f.getCurrentUser().getFirstName(),b.lastname=this.f.getCurrentUser().getLastName(),b.creationdate=new Date,b.date=new Date,b.setModified("NEW"),this.ensureVisibility(),a)g||this.modelChanged(a,b);else{this._annotations.push(b);this._filterAllAnnotations(!0);var a=this._filter.compliesToFilter(b),h=!0;this._annotationFilterModel.isCustomFilterActive()&&(h=this._filter.compliesToCustomFilter(b));
a&&h?(!b.linkedto&&!g&&this._emit("annotationAdded",b,!1),this._filteredAnnotations.push(b),g||this.selectAnnotation(b)):(g||this._emit("annotationAdded",b,!0),this.f.i18n.loadBundle("viewer",function(){this.f.emit("userMessage","warn",this.f.i18n.t("AnnNotViewable"),e.bind(function(){this._annotationFilterModel.resetFilter()},this))},this))}};g.prototype.addLinkedAnnotation=function(b){var a=this.getSelectedAnnotations()[0];a?this.canChangeAnnotation(a)?this.checkCanChangeAnnotationsAndDisplayError()&&
(a=a.getGodfather(),a.linkedto&&(a=this.getAnnotation(a.linkedto)),b.linkedto=a.name,b.parent=a,a.links.push(b),b.messagenumber=a.messagenumber,this.addAnnotation(b),b.annotationcolor=a.color,b.color=a.color,this.selectAnnotation(a,!0)):this.f.i18n.loadBundle("viewer",function(){this.f.emit("userMessage","warn",this.f.i18n.t("AnnCannotAddLinkedToNonOwnedAnnotation"),!0)},this):this.f.i18n.loadBundle("viewer",function(){this.f.emit("userMessage","warn",this.f.i18n.t("NoAnnotationSelected"),!0)},this)};
g.prototype.replyToAnnotation=function(b,a,g){if(this.checkCanChangeAnnotationsAndDisplayError()){b.resetUnsavedReply();var h=b.duplicate(!1,!1,!1,!1,this);h.inreplyto=b.name;h.content=a;h.parent=b;b.replies.push(h);this.addAnnotation(h,b);g&&this.save(null,e.bind(function(){this.selectAnnotation(b,!0);h.cancelModified();h.setIsNew(!1)},this))}else b.resetUnsavedReply(),this.modelChanged()};g.prototype.setState=function(b,a){this.checkCanChangeAnnotationsAndDisplayError()&&this.f.i18n.loadBundle("viewer",
e.bind(function(){var e="<p>"+this.f.i18n.t("AnnStatusSetByText",a,this.f.getCurrentUser().getFullName())+"</p>",g=b.getUserStateAnnotation(this.f.getCurrentUser().getUsername());g?g.state!=a&&(g.state=a,g.content=e,g.setModified("STATE"),this.modelChanged(b)):(g=b.duplicate(!1,!1,!1,!1,this),g.inreplyto=b.name,g.content=e,g.parent=b,g.state=a,g.statemodel="Review",g.parent=b,g.linkedto=b.name,b.states.push(g),this.addAnnotation(g,b))},this))};g.prototype.checkCanChangeAnnotationsAndDisplayError=
function(){if(this.canChangeAnnotations())return!0;0<this.getDisabledReason().length&&this.f.emit("userMessage","warn",this.getDisabledReason());return!1};g.prototype.modelChanged=function(b,a){(a||b)&&this._emit("annotationUpdated",b,a);this._emit("modelChanged")};g.prototype.modelContentChanged=function(){this._orderedAnnotations.length=0;this._emit("modelContentChanged")};g.prototype.filterChanged=function(){this._emit("filterChanged")};g.prototype.orderByModificationDate=function(){this._filteredAnnotations=
e.sortBy(this._filteredAnnotations,function(b){var a=new Date(0);b.runThroughAnnotation(!0,!0,!0,function(b){b.date>a&&(a=b.date)});return a});this.currentOrdening=this.orderByModificationDate};g.prototype.orderByCreationDate=function(){this._filteredAnnotations=e.sortBy(this._filteredAnnotations,function(b){return b.creationdate});this.currentOrdening=this.orderByCreationDate};g.prototype.orderAnnotationsForStep=function(){var b=this.f.getOption("PREFERENCES_ANNOTATION_DATESORT_MODE")===j.AnnotationSortType.SORT_BY_CREATION_DATE,
a=[];0===this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")?e.each(this._filteredAnnotations,function(b){b.runThroughAnnotation(!0,!0,!1,function(b){a.push(b)})}):3===this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")?e.each(this._filteredAnnotations,function(b){a.push(b);a=a.concat(this.getAnnotationLinks(b))},this):a=this._filteredAnnotations;this._orderedAnnotations=e.sortBy(a,function(a){return b?-a.creationdate:-a.date});this._currentAnnotationIndex=e.indexOf(this._orderedAnnotations,this._selectedAnnotations[0])};
g.prototype.getNextAnnotation=function(){0===this._orderedAnnotations.length&&this.orderAnnotationsForStep();0<this._selectedAnnotations.length&&(this._currentAnnotationIndex=e.indexOf(this._orderedAnnotations,this._selectedAnnotations[0]));return this._orderedAnnotations[++this._currentAnnotationIndex%this._orderedAnnotations.length]};g.prototype.getPreviousAnnotation=function(){0===this._orderedAnnotations.length&&this.orderAnnotationsForStep();0<this._selectedAnnotations.length&&(this._currentAnnotationIndex=
e.indexOf(this._orderedAnnotations,this._selectedAnnotations[0]));0>--this._currentAnnotationIndex&&(this._currentAnnotationIndex=this._orderedAnnotations.length-1);return this._orderedAnnotations[this._currentAnnotationIndex%this._orderedAnnotations.length]};g.prototype.goToAnnotation=function(b){b=b?this.getNextAnnotation():this.getPreviousAnnotation();this.selectAnnotation(b,!0);var a=this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE");(2===a||3===a)&&this.f.emit("module.annotation.zoomToAnnotation",
b)};g.prototype.updateAllAnnotationColors=function(){var b=this.f.getCurrentUser().getColor("PREFERENCES_ANNOTATION_NOTE_COLOR"),a=this.f.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR");e.each(this._annotations,e.bind(function(e){this.canChangeAnnotation(e)&&(e.annottype==j.AnnotationType.ANNOT_PIN?e.setColor(b):e.setColor(a),this._emit("annotationUpdated",e))},this));this.modelChanged()};g.prototype.setSortingMode=function(b,a){b===j.AnnotationSortType.SORT_BY_CREATION_DATE?this.orderByCreationDate():
b===j.AnnotationSortType.SORT_BY_MODIFICATION_DATE&&this.orderByModificationDate();a||this.filterChanged()};g.prototype.generateUniqueName=function(){for(var b=100,a;void 0===a&&0<b;){var g=n.randomString(22);void 0===e.find(this._annotations,function(b){return b.name===g})&&(a=g);b--}void 0===a&&this.f.emit("error.SEVERE","Error while generating ID for new annotation");return a};g.prototype.setPage=function(b,a){if(b!=this._page){var g=this._page;this._approvalUpdatedListener&&g&&(g.getDocumentVersion().isPageList()?
g.off("approval.loaded",this._approvalUpdatedListener):g.getDocumentVersion().off("approval.update",this._approvalUpdatedListener));this.setAnnotations([]);this._emit("changed.page");this.unselectAllAnnotations(!1,!0);this._page=b;this._addAnnotationsEnabledListener&&this._unregisterListener(this._addAnnotationsEnabledListener);this._disabledReasonChangedListener&&this._unregisterListener(this._disabledReasonChangedListener);this._clearDisableReasons();b&&b.requestAnnotations(e.bind(function(e){this._page=
b;this.f.loadBundle("viewer",function(){b.canChangeAnnotations()?this.removeDisableReason("CANCHANGEANNOTATIONS"):this.setDisableReason("CANCHANGEANNOTATIONS",this.f.t("AnnReadOnlyCannotChangeAnnotations"));b.getDocumentVersion().isLatestVersion()?this.removeDisableReason("NOT_LATEST"):this.setDisableReason("NOT_LATEST",this.f.t("AnnReadOnlyNotLatestVersion"))},this);e?(this.setAnnotations(b.getAnnotations()),0===this.getAnnotationCount()&&"1"===this.f.getConfig().get("annotationaddglobal")&&(0<this.getDisabledReason().length||
!this.canChangeAnnotations()?(this._addAnnotationsEnabledListener=this._registerListener("readWriteChanged",function(){0===this.getDisabledReason().length&&(this.canChangeAnnotations()&&0===this.getAnnotationCount())&&(this._emit("addGlobalAnnotation"),this._unregisterListener(this._addAnnotationsEnabledListener),this._unregisterListener(this._disabledReasonChangedListener))},this,this),this._disabledReasonChangedListener=this._registerListener("disabledReasonChanged",function(){0===this.getDisabledReason().length&&
(this.canChangeAnnotations()&&0===this.getAnnotationCount())&&(this._emit("addGlobalAnnotation"),this._unregisterListener(this._addAnnotationsEnabledListener),this._unregisterListener(this._disabledReasonChangedListener))},this,this)):this._emit("addGlobalAnnotation"))):this.f.debug.error("Annotations were NOT fetched succesfully");this.updateTemporarilyDisabledReason();a&&a()},this));this._appovalUpdatedListener||(this._approvalUpdatedListener=e.bind(function(b){this.onApprovalUpdated(b)},this));
this.editabilityDependsOnApproval()&&(this.f.loadBundle("viewer",function(){this.setDisableReason("LOADING_APPROVAL",this.f.t("Loading"))},this),this.f.requestModule("approval",e.bind(function(){var a=b.getDocumentVersion();a.isPageList()?(b.on("approval.loaded",this._approvalUpdatedListener),b.requestPageApprovalSetup(this._approvalUpdatedListener)):(a.on("approval.update",this._approvalUpdatedListener),a.requestApprovalSetup(this._approvalUpdatedListener))},this)))}else void 0!==a&&a();this._annotationFilterModel.isAnnotationFilterPinned()||
this._annotationFilterModel.resetFilter();this.modelChanged()};g.prototype.getPage=function(){return this._page};g.prototype.getAnnotationsOffset=function(){return this._page.getAnnotationsOffset()};g.prototype.getDisabledReason=function(){if(0<this._disabledReasons.getLength()){var b=this._disabledReasons.getLast().reason;""===b&&e.some(this._disabledReasons.getItemsAsObject(),function(a){b=a.reason;return""!==b});return b}return""};g.prototype.setDisableReason=function(b,a,e,g){this._disabledReasons.addOrReplaceItem(b,
{reason:a,hideAnnotations:e,dontRemove:g});this._disabledReasons.moveItemByKeyToEnd(b);this._emit("disabledReasonChanged")};g.prototype.removeDisableReason=function(b){this._disabledReasons.removeByKey(b);this._emit("disabledReasonChanged")};g.prototype._clearDisableReasons=function(){var b=[];e.each(this._disabledReasons.getKeys(),function(a){this._disabledReasons.getItemByKey(a).dontRemove&&b.push(a)},this);this._disabledReasons.omitOthers(b);this._emit("disabledReasonChanged")};g.prototype.promptToSaveUnsavedAnnotations=
function(b,a,g){void 0===a&&(a=b);return this._page&&0<this.getUnsavedAnnotationCount()&&this.canChangeAnnotations(!0)?(this.f.loadBundle("viewer",function(){var c=new h(this.f,"unsavedAnnotationsPopup",this.f.getContext());c.setRemoveFromDomAfterUsage(!0);c.setOkAction(e.bind(function(){c.enableOkBtn(!1);this.save(null,e.bind(function(){c.hide();b&&b();this.toggleVisibility(!0)},this))},this));c.setCancelAction(e.bind(function(){a&&a();this.toggleVisibility(!0)},this));if(g){var d=new m(this.f,"dontSaveAnnotations",
$("<span>").append(this.f.t("RevertAnnChanges")),!1,e.bind(function(){c.hide();this.toggleVisibility(!0);g&&g()},this));c.addButton(d)}c.setHeader($("<span/>").addClass("popupTitle").text(this.f.i18n.t("AnnTitle")));c.setContent($("<div/>").addClass("unsavedItemsContent").text(this.f.i18n.t("AnnSavePrompt")));c.setOkBtnText(this.f.i18n.t("Save"));this.toggleVisibility(!1);c.show();c.recalculateSize(600)},this),!0):!1};g.prototype.setLockSelection=function(b){this.lockSelection=b};g.prototype.setLayoutType=
function(b){this._layoutType=b};g.prototype.getLayoutType=function(){return this._layoutType};g.prototype.scaleAllAnnotations=function(b){this._currentScaling&&e.each(this._annotations,function(b){b.isScaled()&&b.scale(new c.Point(1/b.getScale().x,1/b.getScale().y))},this);this._currentScaling=b;e.each(this._annotations,function(a){a.setScale(b)})};g.prototype.getCurrentScaling=function(){return this._currentScaling};g.prototype.getAnnotationFilterModel=function(){return this._annotationFilterModel};
return g});
define("web-viewer/annotation/AnnotationLayerModel",["web-viewer/viewport/model/ViewportLayerModel","utils/ShapeUtils","web-viewer/utils/ListenerUtil","web-viewer/viewControls/ViewControlsConstants","underscore"],function(f,l,i,j,d){j=function(c,d,n){f.call(this,c,d);i.mixin(this,c);this.f=c;this.annotationModel=n;this._registerListener("modelChanged",this._calculateTransformation,this,this.annotationModel);this._registerListener("modelContentChanged",this.modelChanged,this,this.annotationModel);this._registerListener("parameters.changed",
this._calculateTransformation,this,this.f.getDocumentController());this._registerListener("transform.viewportWidget.transformChanged",this._calculateTransformation,this)};j.prototype=Object.create(f.prototype);j.prototype.constructor=j;j.prototype._calculateTransformation=function(){var c=this.annotationModel.getAnnotationsPage();if(null!==c&&void 0!==c){this.resetTransformation();this.getTransform().scale(1,-1);var d=c.getRotation(),f=this.f.getModule("viewport").getWorldBounds(),h=new l.Size;h.add(this.annotationModel.getAnnotationsOffset());
this.calculateTransformation(f,c.getPageSize(),h,d,c.isFlipped())}this.modelChanged()};j.prototype.getLinework=function(c,f){var n=this.annotationModel.getVisibleAnnotations(),h=[];d.each(n,function(a){d.each(a.links,function(b){h.push(b)})});for(var n=d.union(n,h),m=[],o=this.f.getOption("PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE")&&!f,a=0;a<n.length;a++){var e=n[a];this.annotationModel.isAnnotationOrReplySelected(e)?(e.setSelected(!0),e.needsSelectionBox()&&this.annotationModel.canChangeAnnotation(e)&&
(m[a]=e.getSelectionBox())):e.setSelected(!1);o?(e.updateIndicator(),e.showIndicator=!0):e.showIndicator=!1}return d.union(n,h,d.without(d.flatten(m),void 0,null))};return j});
define("web-viewer/viewport/model/ViewportPopupModel",["underscore","web-viewer/core/PrivateChannel"],function(){var f=function(f,i){this.f=f;this.id=i;this.shown=!0};f.prototype.getId=function(){return this.id};f.prototype.show=function(){this.shown=!0};f.prototype.hide=function(){this.shown=!1};f.prototype.isShown=function(){return this.shown};f.prototype.getPopup=function(){};f.prototype.onDestroy=function(){};f.prototype.getWorldOrigin=function(){};f.prototype.getWorldSize=function(){};f.prototype.getSceneOffset=
function(){};f.prototype.onResized=function(){};f.prototype.onDragged=function(){};return f});
define("web-viewer/annotation/AnnotationPopup",["web-viewer/annotation/AnnotationConstants","web-viewer/layout/component/Popup","web-viewer/layout/component/MiniButton","jquery","underscore"],function(f,l,i,j,d){var c=function(c,d,h,m){this.f=c;l.call(this,c,d,m);this.annotation=h;this.element.addClass("annotationPopup");this.annotationNumber=j("<span />").addClass("annotationNumber");this.icon=j("<i />");this.title=j("<span />").addClass("annotationTitle")};c.prototype=Object.create(l.prototype);
c.prototype.constructor=c;c.prototype._initialize=function(){this._isInitialized||(l.prototype._initialize.call(this),this.headerWrapper.addClass("annotationPopupHeader"),this.header.append(this.annotationNumber),this.header.append(this.icon),this.header.append(this.title),this.pinIcon=new i(this.f,"pin","pinned icon-WCR_Pin12",!0,d.bind(function(c){this._emit("pinned",!this.annotation.popupIsOpen);c.stopPropagation()},this)),this.headerIcons.prepend(this.pinIcon.element),c.prototype.repaint.call(this))};
c.prototype.repaint=function(){this._isInitialized&&(this.annotation.popupIsOpen?(this.pinIcon.setIcon("pinned icon-WCR_Pin12"),this.pinIcon.setTooltip("viewer","UnpinPopupTT")):(this.pinIcon.setIcon("unpinned icon-WCR_Pin12"),this.pinIcon.setTooltip("viewer","PinPopupTT")),this.setAnnotationNumber(this.annotation.messagenumber),this.annotationNumber.css({color:this.annotation.getHeaderTextColor(),"background-color":this.annotation.annotationcolor}),this.setTitle(this.annotation.getUserName()),this.setIcon(f.AnnotationIcons[this.annotation.annottype]))};
c.prototype.setTitle=function(c){this.title.text(c)};c.prototype.remove=function(){this.removeAllListeners("pinned");l.prototype.remove.call(this)};c.prototype.setIcon=function(c){this.icon.removeClass().addClass("icon").addClass(c)};c.prototype.setAnnotationNumber=function(c){this.annotationNumber.text(c)};return c});
define("web-viewer/layout/component/RichTextEditor",["web-viewer/utils/ViewerUtils","jquery","underscore"],function(f,l,i){var j=function(d){this.f=d;this.onTextChangeCallbacks=[];this.id=f.generateUniqueDOMId("richText_");this.element=l("<div />").addClass("richText").attr("id",this.id);this.element.data("richTextObj",this);this.titleBar=l("<h3 />").addClass("title");this.titleBar.hide();this.actionBar=l("<div />").addClass("actionBar").addClass("clearfix");this.textAreaDiv=l("<div />").addClass("wrapper");
this.textArea=l("<textarea />").addClass("text");this.textAreaId="textArea_"+this.id;this.textArea.attr("id",this.textAreaId);this.initialized=!1;this.element.append(this.titleBar).append(this.textAreaDiv.append(this.textArea)).append(this.actionBar);this._fireTextChanges=!0};j.prototype.setContent=function(){};j.prototype.getContent=function(){return""};j.prototype.setButtons=function(d){this.actionBar.empty();i.each(d,function(c){c&&this.actionBar.append(c.element)},this)};j.prototype.setTitle=
function(d){this.titleBar.text(d);this.titleBar.show()};j.prototype.init=function(){};j.prototype._fireTextChanged=function(){this._shouldFireTextChanged()&&i.each(this.onTextChangeCallbacks,function(d){d()})};j.prototype._shouldFireTextChanged=function(){return this._fireTextChanges};j.prototype.isInitialized=function(){return this.initialized};j.prototype.destroy=function(){};j.prototype.onTextChanged=function(d){this.onTextChangeCallbacks.push(d)};j.prototype.beforeDetach=function(){};j.prototype.repair=
function(){};j.prototype.setHeight=function(d){this.isInitialized()&&(d-=this.actionBar.outerHeight(!0),d=Math.max(d,80),this.textAreaDiv.css("height",d))};return j});
define("web-viewer/layout/component/RichTextEditorTextarea",["web-viewer/layout/component/RichTextEditor","web-viewer/utils/ViewerUtils","utils/ConvertUtils","jquery","underscore"],function(f,l,i,j,d){l=function(c){f.call(this,c)};l.prototype=Object.create(f.prototype);l.prototype.constructor=l;l.prototype.setContent=function(c){this.textArea.val(i.convertHTMLStringToRaw(c))};l.prototype.getContent=function(){return this.isInitialized()?"<html><body>"+i.convertRawStringToHTML(this.textArea.val())+
"</body></html>":""};l.prototype.init=function(c){this.initialized?(c&&c(),this.textArea.focus()):(this.initialized=!0,this.textArea.on("keyup change",d.bind(this._fireTextChanged,this)),this.textArea.focus(),c&&c())};l.prototype.destroy=function(){this.textArea.off("keyup change");this.initialized=!1};return l});
define("web-viewer/layout/component/RichTextEditorTinyMCE",["web-viewer/layout/component/RichTextEditor","web-viewer/utils/ViewerUtils","tinyMCE","jquery","underscore"],function(f,l,i,j){var d="br cn cz de en es fr hu it jp nl pl ru th tr tw".split(" "),c=[],l=function(c){f.call(this,c);this.editor=void 0;this._cssContentFile="../wcr-static/web-viewer/layout/component/less/tinymce/tinymce_content_"+c.getLayoutType()+".css"};l.prototype=Object.create(f.prototype);l.prototype.constructor=Object.create(l);
l.prototype.setContent=function(c){this.textArea.val(c);this.initialized&&this.editor.setContent(c)};l.prototype.getContent=function(){return this.initialized?this.editor.getContent():""};l.prototype.init=function(f){if(this.initialized)f&&f(),this.editor.focus();else{var n=this.f.getCurrentUser().getLocale();_.contains(d,n)?this._initMCE(f,n):_.contains(c,n)?this._initMCE(f,"en"):this.f.ajax(requirejs.toUrl("lib/tinymce/langs/"+n+".js"),{dataType:"text",timeout:2E3,success:_.bind(function(){d.push(n);
this._initMCE(f,n)},this),error:_.bind(function(){c.push(n);this._initMCE(f,"en")},this)})}};l.prototype._initMCE=function(c,d){i.init({selector:"#"+this.textAreaId,menubar:!1,statusbar:!1,plugins:"paste fullpage",toolbar:"bold italic underline strikethrough | subscript superscript | undo redo",toolbar_items_size:"small",skin:"lightgrayflat",content_css:this._cssContentFile,element_format:"xhtml",doctype:"<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'>",
fullpage_default_doctype:"<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'>",inline_styles:!0,language:d,valid_elements:"p[style],p[style]/li,div,span[style],span[style],br,nobr,sub,sup,strike/s,strong/b,i,u,s,a,h?,big,small,font,tt,code,var,kbd,em,samp,center,a[href|title|style]",auto_focus:this.textAreaId,setup:_.bind(function(h){this.editor=h;h.on("keyup",_.bind(function(){this._fireTextChanged()},this));h.on("redo",_.bind(function(){this._fireTextChanged()},
this));h.on("undo",_.bind(function(){this._fireTextChanged()},this));h.on("change",_.bind(function(){this._fireTextChanged()},this));h.on("init",_.bind(function(){this.initialized=!0;c&&c()},this))},this),paste_preprocess:function(h,c){c.content=c.content.replace(/<(\/)?table[^>]*>/gi,"<$1div>");c.content=c.content.replace(/<(\/)?tr[^>]*>/gi,"<$1p>");c.content=c.content.replace(/<th[^>]*>/gi,"<span><strong>");c.content=c.content.replace(/<\/th[^>]*>/gi,"</strong></span>&nbsp;");c.content=c.content.replace(/<td[^>]*>/gi,
"<span>");c.content=c.content.replace(/<\/td[^>]*>/gi,"</span>&nbsp;")},height:"100%"})};l.prototype._shouldFireTextChanged=function(){return this.editor&&this.editor.isDirty()&&this._fireTextChanges};l.prototype.destroy=function(){this.initialized&&this.editor.destroy();this.initialized=!1};l.prototype.beforeDetach=function(){this.isInitialized()&&(this._fireTextChanges=!1,this.destroy(),this._fireTextChanges=!0)};l.prototype.repair=function(){this.init()};l.prototype.setHeight=function(c){if(this.isInitialized()){var d=
this.textAreaDiv.find(".mce-toolbar-grp").outerHeight(!0);4!==d%26&&(d=30);c=c-this.actionBar.outerHeight(!0)-d;c=Math.max(c,80);j("#"+this.textAreaId+"_ifr").css("height",c)}};return l});define("web-viewer/layout/component/RichTextEditorFactory",["web-viewer/layout/component/RichTextEditorTextarea","web-viewer/layout/component/RichTextEditorTinyMCE"],function(f,l){return{createEditor:function(i){return i.getFeatureDetector().isIOS()?new f(i):new l(i)}}});
define("web-viewer/annotation/AnnotationCharLineCount",["web-viewer/utils/ViewerUtils","component/tooltip/Tooltip","utils/ConvertUtils","jquery","underscore"],function(f,l,i,j){f=function(d){this.element=j("<div />").addClass("charLineCount");this.showing=!1;this.f=d;this.tooltip=null};f.prototype.update=function(d){this.showing&&(d=i.getCharacterLineCount(d),this.element.text(d.charCount+"/"+d.lineCount),this.tooltip?this.tooltip.setTooltipContent("viewer","charLineCount",[d.charCount,d.lineCount]):
this.tooltip=new l(this.f.i18n,this.element,this.f.getContext(),this.f.getContext(),this.f.isMobile(),"viewer","charLineCount",[d.charCount,d.lineCount]))};f.prototype.show=function(){this.element.show();this.showing=!0};f.prototype.hide=function(){this.element.hide();this.showing=!1};return f});
define("web-viewer/layout/AutoTimeLabel",["component/tooltip/Tooltip","web-viewer/utils/ViewerUtils","utils/ConvertUtils","jquery"],function(f,l,i,j){return function(d,c){function k(c){var h=Math.floor(((new Date).getTime()-c.getTime())/1E3),f=Math.floor(h/86400),h=h-86400*f,o=Math.floor(h/3600),h=Math.floor((h-3600*o)/60),a,e=null;0<f?1==f?e=d.i18n.t("dateYesterday"):5>f?a=f+d.i18n.t("daysAbbreviation"):e=i.getLangFormattedDate(d.i18n,c):0<o?a=o+d.i18n.t("hoursAbbreviation"):0<h?a=h+d.i18n.t("minutesAbbreviation"):
(d.i18n.t("secondsAbbreviation"),a="< 1"+d.i18n.t("minutesAbbreviation"));return e?e:d.i18n.t("timeAgo",a)}this.editOnTop=!0;this.element=j("<span>");this.date=c;this.tooltip=new f(d.i18n,this.element,d.getContext(),d.getContext(),d.isMobile(),i.getLangFormattedDateAndTime(d.i18n,this.date));this.updateText=function(c){d.i18n.loadBundle("viewer",_.bind(function(){this.element.text(k(this.date));var h="",h=c?d.i18n.t("createdOn"):d.i18n.t("modifiedOn");this.tooltip.setTooltipContent(h+i.getLangFormattedDateAndTime(d.i18n,
this.date))},this))};this.updateText()}});
define("web-viewer/annotation/AnnotationSingleRow","web-viewer/layout/AutoTimeLabel web-viewer/annotation/AnnotationConstants web-viewer/annotation/AnnotationCharLineCount web-viewer/layout/component/MiniButton web-viewer/layout/component/DropdownMiniButton web-viewer/layout/component/ViewerToolbarButton component/toolbar/ButtonGroup component/tooltip/Tooltip web-viewer/layout/component/RichTextEditorFactory web-viewer/layout/component/ColorPicker jquery underscore HTMLTruncator".split(" "),function(f,
l,i,j,d,c,k,n,h,m,o,a){var e=function(e,b,h,m,n,p,v){this.element=o("<div/>").addClass(h?"main":"reply");this.selected=!1;this.f=e;this._MAX_CHARS=300;this._hideHeader=n;this._annotation=b;this._main=h;this._annotationModel=m;this._isForMobile=v;this._visible=!0;this._hideHeader||(e=o("<div/>").addClass("annotHeader"),this.element.append(e),this._main&&e.append(o("<i>").addClass("icon").addClass(this._annotation.getIconClass())),h=o("<span />").addClass("userName").text(this._annotation.getUserName()),
e.append(h),this._main&&!this._isForMobile&&(this._view3D=new d(this.f,"3DView","icon icon-WCR_Actions-3D12"),this._view3D.setTooltip("viewer","annot3DView"),e.append(this._view3D.element.addClass("view3d"))),this._timelabel=new f(this.f,this._annotation.date),this._timelabel.element.addClass("date").addClass("pull-right"),e.append(this._timelabel.element),this.updateTimer=a.bind(function(){this._timelabel.date=this._annotation.date;this._timelabel.updateText(this._annotation.isAnnotationModified())},
this));this._content=o("<div/>").addClass("annotContent");this.element.append(this._content);this._actionsDiv=o("<div/>").addClass("annotActions").addClass("clearfix");this._moreActions=new d(this.f,"moreActions","icon-WCR_More-horizontal");this._moreActions.addButtonClass("annotAction");this._moreActions.setTooltip("viewer","moreActions");this._annotationColorPicker=this._richTextEditor=void 0;this._actionsDiv.append(this._moreActions.element);var x=new c(this.f,"saveEdit","icon-WCR_Save12 marginRight5",
!0,a.bind(function(b){this._annotation.content=this._richTextEditor.getContent();this._annotation.setModified("CONTENT");this._annotationModel.save();this.closeRichText();b.stopPropagation()},this)),q=new c(this.f,"cancelReply","icon-WCR_Revert12 marginRight5",!0,a.bind(function(b){this._annotation.resetAnnotationColor();this._annotationModel.modelChanged(this._annotation);this._annotation.cancelModifiedColor();this._richTextEditor.setContent("");this._annotation.cancelModified("CONTENT");this._annotationModel.modelChanged();
this.closeRichText();b.stopPropagation()},this));this._editActionsGroup=new k("editActionsGroup",[q,x]);this._editActionsGroup.element.addClass("pull-right");b.getPermissionFor(l.ActionPermissions.DUPLICATE_WITHOUT_TEXT)&&(this._duplicateWithoutText=new j(this.f,"annotationCopyWithoutText","icon-WCR_Annotation-Duplicate-NoText",!0,a.bind(function(b){this.f.emit("module.annotation.duplicateWithoutText",this._annotation);b.stopPropagation()},this)),this._duplicateWithoutText.addButtonClass("annotAction"),
this._duplicateWithoutText.setTooltip("viewer","DuplicateWithoutTextAnnotBtnTT"),this._actionsDiv.append(this._duplicateWithoutText.element));b.getPermissionFor(l.ActionPermissions.DUPLICATE)&&(this._duplicateAction=new j(this.f,"annotationDuplicate","icon-WCR_Annotation-Duplicate",!0,a.bind(function(b){this.f.emit("module.annotation.duplicateAnnotation",this._annotation);b.stopPropagation()},this)),this._duplicateAction.addButtonClass("annotAction"),this._annotation.originType===l.AnnotationOriginTypes.user.id?
this._duplicateAction.setTooltip("viewer","DuplicateAnnotBtnTT"):this._duplicateAction.setTooltip("viewer","DuplicateToUserAnnotBtnTT"),this._actionsDiv.append(this._duplicateAction.element));this._main&&(this._isForMobile&&(this._view3DMobile=new j(this.f,"3DView","icon icon-WCR_Actions-3D12",!0,a.bind(function(){this.f.emit("module.annotation.show3DView",this._annotation)},this)),this._view3DMobile.addButtonClass("annotAction"),this._view3DMobile.setTooltip("viewer","annot3DView"),this._actionsDiv.append(this._view3DMobile.element)),
this._zoomAction=new j(this.f,"annotationZoom","icon-WCR_ZoomFit",!0,a.bind(function(b){this.f.emit("module.annotation.zoomToAnnotation",this._annotation);b.stopPropagation()},this)),this._zoomAction.addButtonClass("annotAction"),this._zoomAction.setTooltip("viewer","ZoomAnnotBtnTT"),this._actionsDiv.append(this._zoomAction.element));this._statusAction=new d(this.f,"setReviewStatus","icon-WCR_Approve-submenu");this._statusAction.addButtonClass("annotAction");this._statusAction.setTooltip("viewer",
"SetReviewStateBtnTT");this._actionsDiv.append(this._statusAction.element);this._isForMobile&&void 0!==p&&this._actionsDiv.append(p);this._charLineCount=new i(this.f);this._actionsDiv.append(this._charLineCount.element);this.element.append(this._actionsDiv);this._reviews=o("<ul/>").addClass("Review").hide();this.element.append(this._reviews);this.element.mouseenter(a.bind(function(){this.mouseEntered=!0;this.showOrHideOptions()},this)).mouseleave(a.bind(function(){this.mouseEntered=!1;this.showOrHideOptions()},
this));this.f.i18n.loadBundle("viewer",a.bind(function(){this._moreActions.addAction({name:"annotationEdit",content:this.f.i18n.t("EditAnnotBtnTT"),icon:"icon-WCR_Annotate",action:a.bind(function(){this._annotation.isNew?this._annotationModel.selectAnnotation(this._annotation,!0):(this._initializeRichTextEditor(),this._richTextEditor.isInitialized()||(this._content.after(this._richTextEditor.element),this._richTextEditor.element.trigger("makeMeVisible")),this._richTextEditor.element.show(),this._content.hide(),
this._actionsDiv.hide(),this._charLineCount.element.insertAfter(this._editActionsGroup.element),this._richTextEditor.setContent("<html>"+this._annotation.content+"</html>"),this.updateColorPicker(),this._richTextEditor.init())},this)});this._moreActions.addAction({name:"duplicateAnnotation",content:this.f.i18n.t("DuplicateAnnotBtnTT"),icon:"icon-WCR_Annotation-Duplicate",action:a.bind(function(b){b.which&&(this.f.emit("module.annotation.duplicateAnnotation",this._annotation),b.stopPropagation())},
this)});this._annotation.getPermissionFor(l.ActionPermissions.DUPLICATE_WITHOUT_TEXT)&&this._moreActions.addAction({name:"duplicateWithoutText",content:this.f.i18n.t("DuplicateWithoutTextAnnotBtnTT"),icon:"icon-WCR_Annotation-Duplicate-NoText",action:a.bind(function(b){b.which&&(this.f.emit("module.annotation.duplicateWithoutText",this._annotation),b.stopPropagation())},this)});this._moreActions.addAction({name:"annotationSave",content:this.f.i18n.t("SaveAnnotBtnTT"),icon:"icon-WCR_Save",action:a.bind(function(){this._annotationModel.save()},
this)});this._moreActions.addAction({name:"annotationDelete",content:this.f.i18n.t("DeleteAnnotBtnTT"),icon:"icon-WCR_Trash",action:a.bind(function(){this._annotationModel.deleteAnnotation(this._annotation)},this)});this._main&&!this._isForMobile&&(this._moreActions.addAction({name:"update3DView",content:this.f.i18n.t("annot3DViewUpdate"),icon:"icon icon-WCR_Annotation-3D-Update",action:a.bind(function(){this.f.emit("module.annotation.update3DView",this._annotation)},this)}),this._moreActions.addAction({name:"delete3DView",
content:this.f.i18n.t("annot3DViewDelete"),icon:"icon icon-WCR_Annotation-3D-Delete",action:a.bind(function(){this.f.emit("module.annotation.delete3DView",this._annotation)},this)}));x.element.addClass("btn-mini").addClass("btn-success").append(this.f.i18n.t("Save"));q.element.addClass("btn-mini").append(this.f.i18n.t("CancelButton"));a.each(l.AnnotationReviewStateLocs,a.bind(function(b,e){"STATUS_ANY"!=e&&this._statusAction.addAction({name:e,content:this.f.i18n.t(b),action:a.bind(function(){this._annotationModel.setState(this._annotation,
l.AnnotationReviewState[e])},this),icon:l.AnnotationReviewStateIcons[e]})},this));this._view3D&&(this._view3D.addAction({name:"update3DView",content:this.f.i18n.t("annot3DViewUpdate"),icon:"icon icon-WCR_Annotation-3D-Update",action:a.bind(function(){this.f.emit("module.annotation.update3DView",this._annotation)},this)}),this._view3D.addAction({name:"delete3DView",content:this.f.i18n.t("annot3DViewDelete"),icon:"icon icon-WCR_Annotation-3D-Delete",action:a.bind(function(){this.f.emit("module.annotation.delete3DView",
this._annotation)},this)}));this._updateView3DButtons()},this))};e.prototype.closeRichText=function(){this._actionsDiv.show();this._actionsDiv.append(this._charLineCount.element);this._content.show();this._richTextEditor.element.hide()};e.prototype.showHideCharLineCount=function(a){var b=this._annotation.getGodfather();a&&this._annotationModel.isAnnotationOrReplySelected(b)?(this._charLineCount.show(),this._charLineCount.update(this._annotation.content)):this._charLineCount.hide()};e.prototype.repaintRow=
function(){this._hideHeader||this.updateTimer();!this._annotation.isBeingModified()&&void 0!==this._richTextEditor?this.closeRichText():this.updateColorPicker();this._updateView3DButtons();this._content.empty();this._content.removeClass("noContent");var e=this._annotation.getExtraContent();e&&e.element&&(this._content.append(e.element),e.tooltip&&(this.extraContentTooltip&&this.extraContentTooltip.destroy(),this.extraContentTooltip=new n(this.f.i18n,e.element,this.f.getContext(),this.f.getContext(),
this.f.isMobile(),e.tooltip)));if(this._annotation.content&&0<this._annotation.content.length){var b=o("<div>").html(this._annotation.content);this._content.append(b);this.f.i18n.loadBundle("viewer",a.bind(function(){b.truncate({max_length:this._MAX_CHARS,more:this.f.i18n.t("ReadMore"),less:this.f.i18n.t("ReadLess"),css_more_class:"truncator-link truncator-more",css_less_class:"truncator-link truncator-less",link_prefix:"",link_suffix:""})},this))}else e||this.f.i18n.loadBundle("viewer",function(){this._content.addClass("noContent");
this._annotation.isNew?this._content.text(this.f.t("AnnNewClickToEdit")):this._content.text(this.f.t("AnnNoContent"))},this);this.showOrHideOptions();this._updateReviews(this._annotation.states);this.showHideCharLineCount(this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT"));this._annotationModel.canChangeAnnotations(!0)?(this._annotationModel.canChangeAnnotation(this._annotation)?(this._moreActions.show(),this._duplicateAction&&this._duplicateAction.hide(),this._duplicateWithoutText&&this._duplicateWithoutText.hide()):
(this._moreActions.hide(),this._duplicateAction&&this._duplicateAction.show(),this._duplicateWithoutText&&this._duplicateWithoutText.show()),this._statusAction.show(),this._moreActions.setActionEnabled("annotationDelete",this._annotationModel.canDeleteAnnotation(this._annotation))):(this._duplicateAction&&this._duplicateAction.hide(),this._duplicateWithoutText&&this._duplicateWithoutText.hide(),this._moreActions.hide(),this._statusAction.hide())};e.prototype.shouldShowOptions=function(){return this._isForMobile?
this.selected:this.selected||this.mouseEntered||this._moreActions.isOpen()||this._statusAction.isOpen()};e.prototype.showOrHideOptions=function(){this.showOptions(this.shouldShowOptions())};e.prototype.showOptions=function(a){a?this._isForMobile?this._actionsDiv.show():this._actionsDiv.removeClass("hideOptions"):this._isForMobile?this._actionsDiv.hide():this._actionsDiv.addClass("hideOptions")};e.prototype._updateReviews=function(e){this.f.i18n.loadBundle("viewer",function(){this._reviews.empty();
for(var b=0;b<e.length;b++){var h=o("<li/>"),c=o("<a/>"),d=o("<i/>").addClass("icon").addClass(l.AnnotationReviewStateIcons[a.invert(l.AnnotationReviewState)[e[b].state]]),f=a.invert(l.AnnotationReviewState)[e[b].state],f=o("<span/>").text('"'+this.f.i18n.t(l.AnnotationReviewStateLocs[f])+'": '+e[b].getUserName());c.append(d);c.append(f);h.append(c);this._reviews.append(h)}},this);this._reviews.toggle(0<e.length)};e.prototype._initializeRichTextEditor=function(){this._richTextEditor||(this._richTextEditor=
h.createEditor(this.f),!this.f.getProperty("annotationcolor")&&this._main&&(this._annotationColorPicker=new m(a.bind(function(a){this._annotation.setColor("#"+a);this._annotationModel.modelChanged(this._annotation)},this)),this._annotationColorPicker.setColor(this._annotation.annotationcolor),this._annotationColorPicker.element.addClass("annotationColorPicker"),this._annotationColorPicker.setTooltip(this.f,"general","ChangeColor")),this._richTextEditor.setButtons([this._editActionsGroup,this._annotationColorPicker]),
this._richTextEditor.onTextChanged(a.bind(function(){this._charLineCount.update(this._richTextEditor.getContent());this._annotation.setBeingModified(this._richTextEditor.getContent());this._annotationModel.modelChanged()},this)))};e.prototype._updateView3DButtons=function(){var a=null!==this._annotation.get3DViewPosition(),b=this.f.getModule("view3D"),b=b&&b.is3DWidgetEnabled(),e=this._annotationModel.canChangeAnnotation(this._annotation);this._view3D&&(this._view3D.toggleButton(a),this._view3D.toggleElementVisibility("update3DView",
e&&b),this._view3D.toggleElementVisibility("delete3DView",e&&a),e?this._view3D.enableDropdown():this._view3D.disableDropdown());this._view3DMobile&&(a?this._view3DMobile.show():this._view3DMobile.hide());this._moreActions&&(this._moreActions.toggleElementVisibility("delete3DView",e&&a),this._moreActions.toggleElementVisibility("update3DView",e&&b))};e.prototype.setSelected=function(a){this.selected=a;this.element.toggleClass("selected",this.selected);this.repaintRow()};e.prototype.onDetachFromDOM=
function(){this._richTextEditor&&this._richTextEditor.beforeDetach();this._hideAllTooltips()};e.prototype._hideAllTooltips=function(){this.extraContentTooltip&&this.extraContentTooltip.hide();this._duplicateAction&&this._duplicateAction.hideTooltip();this._duplicateWithoutText&&this._duplicateWithoutText.hideTooltip();this._zoomAction&&this._zoomAction.hideTooltip();this._timelabel.tooltip.hide();this._moreActions.hideTooltip()};e.prototype.onReattachToDOM=function(){this._richTextEditor&&this._richTextEditor.repair()};
e.prototype.updateColorPicker=function(){this._annotationColorPicker&&this._annotationColorPicker.setColor(this._annotation.annotationcolor)};e.prototype.setVisible=function(a){this._visible=a;this.element.toggle(a)};e.prototype.isVisible=function(){return this._visible};e.prototype.setAnnotation=function(a){this._annotation=a;this.repaintRow()};return e});
define("web-viewer/annotation/AnnotationRow","web-viewer/annotation/AnnotationSingleRow web-viewer/layout/component/ViewerToolbarButton component/toolbar/ButtonGroup web-viewer/layout/component/RichTextEditorFactory web-viewer/annotation/AnnotationCharLineCount web-viewer/annotation/AnnotationConstants web-viewer/layout/component/MiniButton jquery underscore".split(" "),function(f,l,i,j,d,c,k,n,h){var m=function(m,a,e,g,b,r){this.f=m;this._replyLimit=b;this._replyLimit||(this._replyLimit=2);this._annotation=
a;this._annotationModel=e;this._limitReplyCount=!0;this._totalReplyCount=this._shownReplyCount=0;this.name=this._annotation.name;this.element=n("<div>").addClass("annotation").toggleClass("cannot-reply",!this._annotation.getPermissionFor(c.ActionPermissions.CAN_BE_REPLIED_TO));this.annotationRows={};this.selected=!1;this._isForMobile=r;this._repliesDiv=n("<div/>").addClass("replies");this._moreReplies=n("<p/>").addClass("MoreReplies clearfix");this._moreRepliesLabel=n("<a/>");this._moreRepliesLabel.on("click",
h.bind(function(b){this.toggleReplyLimit();b.stopPropagation()},this));this._moreReplies.append(this._moreRepliesLabel);this._moreReplies.hide();g||(this.title=n("<span/>").addClass("annotationNumber"),this.element.append(this.title));r?(a=new k(this.f,"annotationAddReply","icon-WCR_Comment",!0,h.bind(function(b){this._showRichTextEditor(b)},this)),a.addButtonClass("annotAction"),this._replyText=a.element):(this._replyText=n("<input/>"),this.f.i18n.loadBundle("viewer",h.bind(function(){this._replyText.attr("placeholder",
this.f.i18n.t("AnnReplyTT"))},this)),this._replyText.on("click",function(b){b.preventDefault();b.stopPropagation()}),this._replyText.on("focus",h.bind(function(b){this._showRichTextEditor(b)},this)));this._reply=n("<div/>").append(this._replyText).addClass("addReply");this._richTextEditor=j.createEditor(this.f);this._saveReply=new l(this.f,"saveReply","icon-WCR_Save12 marginRight5",!0,h.bind(function(b){this._annotationModel.replyToAnnotation(this._annotation,this._richTextEditor.getContent(),!0);
this._closeRichText();b.stopPropagation()},this));this._cancelReply=new l(this.f,"cancelReply","icon-WCR_Revert12 marginRight5",!0,h.bind(function(b){this._closeRichText();this._richTextEditor.setContent("");this._annotation.resetUnsavedReply();this._annotationModel.modelChanged();b.stopPropagation()},this));this._replyActionsGroup=new i("replyActionsGroup",[this._cancelReply,this._saveReply]);this._replyActionsGroup.element.addClass("pull-right");m.i18n.loadBundle("viewer",h.bind(function(){this._saveReply.element.addClass("btn-mini").addClass("btn-success").append(this.f.i18n.t("Save"));
this._cancelReply.element.addClass("btn-mini").append(this.f.i18n.t("CancelButton"))},this));this._charLineCount=new d(m);this.showHideCharLineCount(this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT"));this._richTextEditor.onTextChanged(h.bind(function(){this._charLineCount.update(this._richTextEditor.getContent());this._annotation.setUnsavedReply(this._richTextEditor.getContent());this._annotationModel.modelChanged()},this));this._richTextEditor.setButtons([this._replyActionsGroup,this._charLineCount]);
this._mainRow=new f(this.f,this._annotation,!0,this._annotationModel,g,this._replyText,this._isForMobile);this.element.append(this._mainRow.element);this.annotationRows[this._annotation.name]=this._mainRow;this.element.append(this._repliesDiv);this._repliesDiv.prepend(this._moreReplies);r||this.element.append(this._reply);this.annotationUpdated();this.updateReplyLimitLabel()};m.prototype._closeRichText=function(){this._replyText.show();this._richTextEditor.setContent("");this._richTextEditor.element.hide()};
m.prototype._showRichTextEditor=function(c){this._replyText.hide();this._richTextEditor.isInitialized()||this._replyText.after(this._richTextEditor.element);this._richTextEditor.element.show();this._annotation.setUnsavedReply("");this._richTextEditor.setContent("<html><body></body></html>");this._richTextEditor.init(h.bind(function(){this._charLineCount.update(this._richTextEditor.getContent());this._richTextEditor.element.trigger("makeMeVisible");this._richTextEditor.element.trigger("contentResized")},
this));c.preventDefault();c.stopPropagation()};m.prototype.showHideCharLineCount=function(c,a){c&&this._annotationModel.isAnnotationOrReplySelected(this._annotation)?(this._charLineCount.show(),this._charLineCount.update(this._richTextEditor.getContent())):this._charLineCount.hide();a&&h.each(this.annotationRows,function(a){a.showHideCharLineCount(c)})};m.prototype.annotationUpdated=function(c){this.element.css({"border-color":this._annotation.annotationcolor});this.title&&(this.title.text(this._annotation.getMessageNumber()),
this.title.css({color:this._annotation.getHeaderTextColor(),"background-color":this._annotation.annotationcolor}));this._mainRow.setAnnotation(this._annotation);var a=this._annotationModel.getReplies(this._annotation);this._totalReplyCount=a.length;var e=[];h.each(this.annotationRows,function(b,a){e.push(a)});this._annotation.runThroughAnnotation(!0,!0,!1,function(b){b=h.indexOf(e,b.name);-1<b&&e.splice(b,1)});h.each(e,function(b){this.annotationRows[b].element.remove();delete this.annotationRows[b]},
this);var g=this._totalReplyCount;this._limitReplyCount&&(g=this._replyLimit);c&&(c=a.length-h.indexOf(a,c.parent),c<=a.length&&(g=Math.max(g,c)));this._shownReplyCount=Math.min(g,this._totalReplyCount);for(c=0;c<this._totalReplyCount;c++){var b=a[c],d=this.annotationRows[b.name];d||(d=new f(this.f,b,!1,this._annotationModel,void 0,void 0,this._isForMobile),this._repliesDiv.append(d.element),this.annotationRows[b.name]=d,d.setSelected(this.selected),d.setVisible(!1));this._totalReplyCount-1-c<g?(d.setAnnotation(b),
d.setVisible(!0)):d&&d.setVisible(!1)}this._repliesDiv.prepend(this._moreReplies);this.shouldShowMoreRepliesLink()?this._moreReplies.show():this._moreReplies.hide();this.updateReplyLimitLabel();this.showHideCharLineCount(this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT"));this._annotationModel.canChangeAnnotations(!0)&&!this._annotation.isNew?(this._reply.show(),null===this._annotation.getUnsavedReply()?(this._replyText.show(),this._closeRichText()):this._richTextEditor.setContent(this._annotation.getUnsavedReply())):
(this._reply.hide(),this._replyText.hide())};m.prototype.shouldShowMoreRepliesLink=function(){return this._totalReplyCount>this._replyLimit};m.prototype.toggleReplyLimit=function(c){this._limitReplyCount=void 0===c?!this._limitReplyCount:c;this.annotationUpdated();this.updateReplyLimitLabel();this._moreReplies.trigger("contentResized")};m.prototype.updateReplyLimitLabel=function(){if(this._limitReplyCount){var c=this._totalReplyCount-this._shownReplyCount;1>=c?this._moreRepliesLabel.text(this.f.i18n.t("AnnShowOneMoreReply")):
this._moreRepliesLabel.text(this.f.i18n.t("AnnShowMoreReplies",c))}else this._moreRepliesLabel.text(this.f.i18n.t("AnnShowLessReplies"))};m.prototype.updateTimers=function(){h.each(this.annotationRows,function(c){c.updateTimer()})};m.prototype.setSelected=function(c){this.selected=c;h.each(this.annotationRows,function(a){a.setSelected(c)});this.element.toggleClass("selected",c);this.showHideCharLineCount(this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT"))};m.prototype.onDetachFromDOM=function(){this.detachedFromDOM||
(this.detachedFromDOM=!0,this._richTextEditor.beforeDetach(),h.each(this.annotationRows,function(c){c.onDetachFromDOM()}))};m.prototype.onReattachToDOM=function(){this.detachedFromDOM&&(this.detachedFromDOM=!1,this._richTextEditor.repair(),h.each(this.annotationRows,function(c){c.onReattachToDOM()}))};m.prototype.setAvailableHeight=function(c){if(null!==this._annotation.getUnsavedReply()){var a=c-10;this.shouldShowMoreRepliesLink()&&(a-=this._moreReplies.outerHeight(!0));h.each(this.annotationRows,
function(e){e.isVisible()&&(a-=e.element.outerHeight(!0))});this._richTextEditor.setHeight(a)}};m.prototype.setAnnotation=function(c){this._annotation=c;this.annotationUpdated()};m.prototype.getAnnotation=function(){return this._annotation};return m});
define("web-viewer/annotation/AnnotationPopupNew","web-viewer/annotation/AnnotationPopup web-viewer/layout/component/ColorPicker web-viewer/layout/component/ViewerToolbarButton component/toolbar/ButtonGroup web-viewer/layout/component/RichTextEditorFactory web-viewer/annotation/AnnotationCharLineCount web-viewer/annotation/AnnotationRow underscore".split(" "),function(f,l,i,j,d,c){var k=function(c,h,d,k,a){f.call(this,c,h,d,a);this.element.removeClass("annotationPopup").addClass("annotationPopupNew");
this.annotation.popuprect.size.width||(this.annotation.popuprect.size.width=72);this.annotation.popuprect.size.height||(this.annotation.popuprect.size.height=45);this.annotation.popuprect.origin.x||(this.annotation.popuprect.origin.x=this.annotation.rect.right());this.annotation.popuprect.origin.y||(this.annotation.popuprect.origin.y=this.annotation.rect.bottom()-this.annotation.popuprect.size.height);this.annotationModel=k};k.prototype=Object.create(f.prototype);k.prototype.constructor=k;k.prototype._initialize=
function(){f.prototype._initialize.call(this);this.richTextEditor=d.createEditor(this.f);this.richTextEditor.setContent(this.annotation.content);var k;this.f.getProperty("annotationcolor")||(k=new l(_.bind(function(a){this.annotation.setColor("#"+a);this.annotationModel.modelChanged(this.annotation)},this)),k.setColor(this.annotation.annotationcolor),k.element.addClass("annotationColorPicker"),k.setTooltip(this.f,"general","ChangeColor"));var h=new i(this.f,"saveAnnot","icon-WCR_Save12 marginRight5",
!1,_.bind(function(a){this.annotation.content=this.richTextEditor.getContent();this.annotationModel.save();a.stopPropagation()},this)),m=new i(this.f,"deleteAnnot","icon-WCR_Trash12 marginRight5",!1,_.bind(function(a){this.annotationModel.deleteAnnotation(this.annotation);a.stopPropagation()},this)),o=new j("AnnotationActionsGroup",[m,h]);o.element.addClass("pull-right");this.f.i18n.loadBundle("viewer",_.bind(function(){h.element.addClass("btn-mini").addClass("btn-success").append(this.f.i18n.t("Save"));
m.element.addClass("btn-mini").append(this.f.i18n.t("Delete"))},this));this.charLineCount=new c(this.f);this.richTextEditor.setButtons([k,o,this.charLineCount]);this.richTextEditor.onTextChanged(_.bind(function(){this.charLineCount.update(this.richTextEditor.getContent());this.annotation.setBeingModified(this.richTextEditor.getContent())},this));this.setContent(this.richTextEditor.element);this.richTextEditor.init(_.bind(function(){this._repaintCharLineCount();this.on("contentResized",_.bind(function(a){this.richTextEditor.setHeight(a.height)},
this));this.richTextEditor.setHeight(this._outerContent.height())},this))};k.prototype.repaint=function(){this._isInitialized&&(f.prototype.repaint.call(this),this._repaintCharLineCount())};k.prototype._repaintCharLineCount=function(){this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT")?(this.charLineCount.show(),this.charLineCount.update(this.richTextEditor.getContent())):this.charLineCount.hide()};k.prototype.remove=function(){this.annotationColorPicker&&this.annotationColorPicker.destroy();this.richTextEditor&&
this.richTextEditor.destroy();f.prototype.remove.call(this)};return k});
define("web-viewer/annotation/AnnotationPopupExisting",["web-viewer/annotation/AnnotationPopup","web-viewer/annotation/AnnotationRow","underscore"],function(f,l,i){var j=function(d,c,k,i,h){f.call(this,d,c,k,h);this.annotationModel=i};j.prototype=Object.create(f.prototype);j.prototype.constructor=j;j.prototype._initialize=function(){f.prototype._initialize.call(this);this.row=new l(this.f,this.annotation,this.annotationModel,!0);this.row.setSelected(!0);this.annotationExistingContent=$("<div>").addClass("AnnotationTable enableTextSelection").append(this.row.element);
this.setContent(this.annotationExistingContent);this.on("contentResized",i.bind(function(d){this.row.setAvailableHeight(d.height)},this));this.row.setAvailableHeight(this.content.height())};j.prototype.repaint=function(d){this._isInitialized&&(f.prototype.repaint.call(this),this.row.annotationUpdated(d))};return j});
define("web-viewer/annotation/AnnotationPopupModel","web-viewer/viewport/model/ViewportPopupModel web-viewer/annotation/AnnotationPopupNew web-viewer/annotation/AnnotationPopupExisting web-viewer/annotation/AnnotationConstants utils/ShapeUtils underscore".split(" "),function(f,l,i,j,d){var c=function(c,d,h,m){f.call(this,c,d);this.annotation=h;this.annotationModel=m;this.popup=null};c.prototype=Object.create(f.prototype);c.prototype.constructor=c;c.prototype.repaint=function(c){null!=this.popup&&
this.popup.repaint(c)};c.prototype.getPopup=function(c){c=c.getCanvas();null===this.popup?this._createPopup(c):this.popup.setContainment(c);return this.popup};c.prototype._createPopup=function(c){this.popup=this.annotation.isNew?new l(this.f,this.id,this.annotation,this.annotationModel,c):new i(this.f,this.id,this.annotation,this.annotationModel,c);this.popup.on("closed",_.bind(this.onClosed,this));this.popup.on("pinned",_.bind(this.onPinned,this));this.popup.on("clicked",_.bind(this.onClicked,this))};
c.prototype.onDestroy=function(){null!=this.popup&&this.popup.remove()};c.prototype.onResized=function(c,d){var h=c.copy();h.origin.y-=h.size.height;this.annotation.popuprect.rectEquals(h)||(this.annotation.popuprect=h,d||this._fireAnnotationChanged("POPUP_SIZE"))};c.prototype.onDragged=function(c){c=c.copy();c.y-=this.annotation.popuprect.size.height;this.annotation.popuprect.origin.equals(c)||(this.annotation.popuprect.origin=c,this._fireAnnotationChanged("POPUP_POSITION"))};c.prototype.onClosed=
function(){this.annotationModel.unselectAllAnnotations(!0,!0);this.annotation.popupIsOpen&&(this.annotation.popupIsOpen=!1,this.annotation.setModified("POPUP_PINNED"));this.annotationModel.modelChanged(this.annotation)};c.prototype.onPinned=function(c){this.annotation.popupIsOpen!==c&&(this.annotation.popupIsOpen=c,this._fireAnnotationChanged("POPUP_PINNED")||this.popup.repaint())};c.prototype.onClicked=function(){this.annotationModel.selectAnnotation(this.annotation)};c.prototype._fireAnnotationChanged=
function(c){return this.annotationModel.canChangeAnnotation(this.annotation)?(this.annotation.setModified(c),this.annotationModel.modelChanged(this.annotation),!0):!1};c.prototype.getWorldOrigin=function(){return new d.Point(this.annotation.popuprect.left(),this.annotation.popuprect.bottom())};c.prototype.getWorldSize=function(){return this.annotation.popuprect.size};c.prototype.getSceneOffset=function(){if(this.annotation.getType()==j.AnnotationType.ANNOT_PIN)return new d.Size(j.AnnotationPin.imagewidth,
0)};return c});
define("web-viewer/annotation/AnnotationPopupsLayerModel",["web-viewer/viewport/model/ViewportLayerModel","web-viewer/annotation/AnnotationPopupModel","underscore"],function(f,l,i){var j=function(d,c,k){f.call(this,d,c);this.f=d;this.annotationModel=k;this._createModels();this.annotationModel.on("modelContentChanged",i.bind(function(){this.removeAllPopupModels();this._createModels()},this));this.annotationModel.on("modelChanged",i.bind(function(){var c=this.annotationModel.getAnnotationsPage();if(null!==
c&&void 0!==c){this.resetTransformation();this.getTransform().scale(1,-1);var h=c.getRotation(),d=this.f.getModule("viewport").getWorldBounds();this.calculateTransformation(d,c.getPageSize(),this.annotationModel.getAnnotationsOffset(),h,c.isFlipped())}this.modelChanged()},this));this.annotationModel.on("selectedAnnotation",i.bind(function(c){if(this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT")){var h=c.getGodfather(),d=this.getPopupModel(h.name);void 0!==d&&(h==c?d.repaint():d.repaint(c))}this._updateModels();
this.modelChanged()},this));this.annotationModel.on("unselectedAnnotation",i.bind(function(c){this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT")&&(c=this.getPopupModel(c.getGodfather().name),void 0!==c&&c.repaint());this._updateModels()},this));this.annotationModel.on("annotationDeleted",i.bind(function(c){var h=c.getGodfather();c==h?this.removePopupModel(c.name):(c=this.getPopupModel(h.name),void 0!==c&&c.repaint())},this));this.annotationModel.on("annotationAdded",i.bind(function(c){this._createModel(c)},
this));this.annotationModel.on("annotationUpdated",i.bind(function(c,h){var d=this.getPopupModel(c.getGodfather().name);void 0!==d&&d.repaint(h);this._updateModels()},this));this.annotationModel.on("annotationListVisible",i.bind(function(){this._updateModels();this.modelChanged()},this));this.annotationModel.on("readWriteChanged",i.bind(function(){i.each(this.getPopupModels(),function(c){c.repaint()},this);this.modelChanged()},this));this.annotationModel.on("temporarilyDisableChanged",i.bind(function(){this._updateModels()},
this));this.f.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWSELECTEDONLY",i.bind(function(){this._updateModels();this.modelChanged()},this));this.f.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY",i.bind(function(){this._updateModels();this.modelChanged()},this));this.f.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWCOUNT",i.bind(function(){i.each(this.getPopupModels(),function(c){var h=this.annotationModel.getAnnotation(c.getId());
this.annotationModel.isAnnotationOrReplySelected(h)&&c.repaint()},this);this.modelChanged()},this));this.f.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATIONTOOLS_VISIBLE",i.bind(function(){this._updateModels()},this))};j.prototype=Object.create(f.prototype);j.prototype.constructor=j;j.prototype._updateModels=function(){this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE")?this.annotationModel.isAnnotationListVisible()?this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY")?0<this.annotationModel.getSelectedAnnotations().length?
i.each(this.getPopupModels(),function(d){this._showSelected(d)},this):i.each(this.getPopupModels(),function(d){this._showPinnedOrSelected(d)},this):this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY")?i.each(this.getPopupModels(),function(d){this._showSelected(d)},this):i.each(this.getPopupModels(),function(d){this._showPinnedOrSelected(d)},this):i.each(this.getPopupModels(),function(d){this._showPinnedOrSelected(d)},this):i.each(this.getPopupModels(),function(d){d.hide()},this)};j.prototype._showSelected=
function(d){var c=this.annotationModel.getAnnotation(d.getId());this.annotationModel.isAnnotationOrReplySelected(c)?d.show():d.hide()};j.prototype._showPinnedOrSelected=function(d){var c=this.annotationModel.getAnnotation(d.getId());!this.annotationModel.isTemporarilyDisabledAndNoAnnotationsVisible()&&c&&(c.popupIsOpen||this.annotationModel.isAnnotationOrReplySelected(c))?d.show():d.hide()};j.prototype._createModels=function(){i.each(this.annotationModel.getAnnotations(),function(d){this._createModel(d)},
this);this._updateModels();this.modelChanged()};j.prototype._createModel=function(d){d.linkedto||(d=new l(this.f,d.name,d,this.annotationModel),this.addPopupModel(d))};return j});
define("web-viewer/annotation/AnnotationTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/utils/DrawUtils web-viewer/utils/ViewerUtils web-viewer/annotation/AnnotationConstants web-viewer/annotation/Annotation web-viewer/core/CoreConstants".split(" "),function(f,l,i,j,d,c,k,n){d=function(h,d){l.call(this,h,n.TOOLS.ANNOTATION);this.f=h;this._annotationModel=d;this._defaultState="defaultState";this._hoverState="hoverState";this._draggingState="draggingState";this._anchorState=
"anchorState";this._anchor=void 0;this._touchDown=this._targetAnnotation=null;this.registerState(this._defaultState,function(c){return{mousemove:function(a){var e=c._getAnnotationLayer(a);e&&e.isVisible()&&(c._verifyObjects(a,e),(c._targetAnnotation||c._anchor)&&c.requestActivation())},mouseup:function(){},mousedown:function(a){c._getAnnotationLayer(a)&&(d.unselectAllAnnotations(),a.originalEvent.preventDefault())},mouseout:function(){c.isActive()&&h.emit("toolManager.request.deactivation",c)},mouseleave:function(){c.isActive()&&
h.emit("toolManager.request.deactivation",c)},contextmenu:function(a){a.preventDefault();a.stopPropagation();return!1}}}(this));this.registerState(this._hoverState,f.defaults(function(f){return{mousedown:function(a){1===a.which&&(f._verifyObjects(a),f._touchDown=f._getAnnotationLayer(a).getWorldPointFromScene(f.getScenePoint(a)),f._anchor&&f._targetAnnotation.annottype!=c.AnnotationType.ANNOT_FREEFORM?(h.emit("viewport.startInteractive"),f.changeState(f._anchorState)):f._targetAnnotation&&(h.emit("viewport.startInteractive"),
d.selectAnnotation(f._targetAnnotation),f.changeState(f._draggingState)));a.originalEvent.preventDefault()},mousemove:function(a){f._verifyObjects(a);f.cursorShouldChange()}}}(this),this.getState(this._defaultState)));this.registerState(this._draggingState,f.defaults(function(c){return{mousemove:function(a){c.cursorShouldChange();var e=c._getAnnotationLayer(a).getWorldPointFromScene(c.getScenePoint(a)),g=c._widget.getWorld().getWorldBounds(),a=c._getAnnotationLayer(a).convertWorldRectToLayer(new i.Rect(new i.Point,
g.size));a.origin.y=-(a.size.height+a.origin.y)-g.origin.y;a.origin.x+=g.origin.x;g=c.keepMoveSizeWithinRect(a,c._targetAnnotation.rect,c._touchDown.sizeTo(e));d.moveAnnotation(c._targetAnnotation,g);c._touchDown=e},mouseup:function(){h.emit("viewport.stopInteractive");c.changeState(c._hoverState)},mouseout:function(){h.emit("viewport.stopInteractive");c.changeState(c._hoverState)},enterState:function(){h.emit("viewport.startInteractive")},leaveState:function(){h.emit("viewport.stopInteractive")}}}(this),
this.getState(this._defaultState)));this.registerState(this._anchorState,f.defaults(function(c){return{mousemove:function(a){var a=c._getWorldPoint(a),e,g=null;switch(c._anchor.anchor){case j.LWANCHOR_TOPLEFT:g="NW";break;case j.LWANCHOR_TOPCENTER:g="N";break;case j.LWANCHOR_TOPRIGHT:g="NE";break;case j.LWANCHOR_BOTTOMLEFT:g="SW";break;case j.LWANCHOR_BOTTOMCENTER:g="S";break;case j.LWANCHOR_BOTTOMRIGHT:g="SE";break;case j.LWANCHOR_CENTERLEFT:g="W";break;case j.LWANCHOR_CENTERRIGHT:g="E"}e=g;if(null!=
e){g=c._anchor.linework.rect.copy();if(-1<e.indexOf("E")||-1<e.indexOf("W"))if(-1<e.indexOf("W")){var b=c._anchor.linework.rect.left()-a.x;g.origin.x-=b;g.size.width+=b}else b=c._anchor.linework.rect.right()-a.x,g.size.width-=b;if(-1<e.indexOf("N")||-1<e.indexOf("S"))-1<e.indexOf("N")?(e=c._anchor.linework.rect.top()-a.y,g.origin.y-=e,g.size.height+=e):(e=c._anchor.linework.rect.bottom()-a.y,g.size.height-=e);d.transformAnnotation(c._anchor.linework,g)}else c._anchor.anchor==j.LWANCHOR_START?d.updateStartEndOfAnnotation(c._anchor.linework,
a,null):c._anchor.anchor==j.LWANCHOR_END&&d.updateStartEndOfAnnotation(c._anchor.linework,null,a);c._touchDown=a},mouseup:function(){h.emit("viewport.stopInteractive");c.cursorShouldChange();c.changeState(c._hoverState)},mouseleave:function(){h.emit("viewport.stopInteractive");c.cursorShouldChange();c.changeState(c._hoverState)},mouseout:function(){}}}(this),this.getState(this._defaultState)));this._override("initialize",f.bind(function(c,a){this._super(c,a);this.persistentKeyEvents.push(["del",f.bind(function(){0<
this._annotationModel.getSelectedAnnotations().length&&f.each(this._annotationModel.getSelectedAnnotations(),f.bind(function(a){this._annotationModel.deleteAnnotation(a)},this))},this),"keyup"]);this.changeState(this._defaultState);this.registerPassiveEvents(["mousemove","mousedown"]);this.registerActiveEvents("mousemove mousedown mouseup mouseout mouseleave contextmenu".split(" "))},this));this._override("activate",f.bind(function(c){this._super(c);this.changeState(this._hoverState)},this));this._override("deactivate",
f.bind(function(c){this._super(c);this.changeState(this._defaultState)},this))};d.prototype=Object.create(l.prototype);d.prototype.constructor=d;d.prototype.getDefaultCursor=function(){return this._anchor?this._cursorForAnchor():this.getCurrentStateName()==this._draggingState?this._annotationModel.canChangeAnnotation(this._targetAnnotation)?"cursor-moveObject":"cursor-notAllowed":"cursor-select"};d.prototype._deActivate=function(){this.isActive()&&(this.changeState(this._defaultState),this.f.emit("toolManager.request.deactivation",
this))};d.prototype._cursorForAnchor=function(){var h="cursor-moveObject";if(this._anchor.linework.annottype==c.AnnotationType.ANNOT_ARROW||this._anchor.linework.annottype==c.AnnotationType.ANNOT_LINE)return h;var d=this._getAnnotationLayer("Main");if(!d)return h;var f=d.getScenePointFromWorld(this._anchor.rect.center()),a=new i.Size(this._anchor.rect.size.width,this._anchor.rect.size.height),f=new i.Rect(new i.Point(f.x-a.width/2,f.y-a.height/2),a),d=d.getSceneRectFromWorld(this._anchor.linework.rect);
f.containsPoint(d.topleft())?h="NW":f.containsPoint(d.topcenter())?h="N":f.containsPoint(d.topright())?h="NE":f.containsPoint(d.centerleft())?h="W":f.containsPoint(d.centerright())?h="E":f.containsPoint(d.bottomleft())?h="SW":f.containsPoint(d.bottomcenter())?h="S":f.containsPoint(d.bottomright())&&(h="SE");return"cursor-resize"+h};d.prototype._getAnnotationLayer=function(c){if(c=this._widget.requestView(c))if(c=c.getLayer("Annotations"))return c;return null};d.prototype._getClosestLineworkFromPoint=
function(c,d){var f=d;f||(f=this._getAnnotationLayer(c));return f?f.getClosestLineworkFromPoint(this.getScenePoint(c)):null};d.prototype._getWorldPoint=function(c){var d=this._annotationModel.getAnnotationsPage(),c=this.keepPointWithinWorldBounds(this.getWorldPoint(c),!1);c.y=d.getPageSize().height-c.y;var f=d.getDocumentPageOrigin();c.offset(new i.Size(-f.x,f.y));var a=d.getTrimboxRect().size,f=0;0!==a.width&&0!==a.height&&(f=d.getPageSize().height-(a.height+d.getMargins().top+d.getMargins().bottom));
a=d.getMargins();d.isReaderSpread()&&d.get("isRightPage")&&(a.left=-a.left);c.offset(new i.Size(-a.left,-a.bottom-f));return c};d.prototype._verifyObjects=function(c,d){if(!d&&(d=this._getAnnotationLayer(c),!d))return;var f=this._getClosestLineworkFromPoint(c,d);this._anchor=this._targetAnnotation=null;f&&(f instanceof k?this._targetAnnotation=f:f.anchor&&(this._anchor=f,this._targetAnnotation=f.linework));!f&&!this._targetAnnotation&&this._deActivate(c)};return d});
define("web-viewer/annotation/AnnotationDrawTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/utils/GEOUtils web-viewer/utils/DrawUtils web-viewer/annotation/Annotation web-viewer/utils/LineworkPoint web-viewer/utils/ListenerUtil web-viewer/annotation/AnnotationConstants web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(f,l,i,j,d,c,k,n,h,m,o){j=function(a,e,g){l.call(this,a,o.TOOLS.ANNOTATION_DRAW);n.mixin(this,a);var b;this.drawLinkedAnnotation=
!1;this._annotationModule=g;this._annotationModel=e;this.setAnnotationType=function(b){a.setOption("PREFERENCES_ANNOTATION_TOOLMODE",b)};this.getAnnotationType=function(){return a.getOption("PREFERENCES_ANNOTATION_TOOLMODE")};this.setAnnotationColor=function(b){a.getCurrentUser().setColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR",b)};this.getAnnotationColor=function(){return a.getProperty("annotationcolor")?a.getProperty("annotationcolor"):a.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR")};
this.getDefaultCursor=function(){return"cursor-drawAnnotation"};this.addGlobalAnnotation=function(){this.drawLinkedAnnotation||e.unselectAllAnnotations(!0,!0);var g=a.getModule("viewport").getWorldBounds();m("Main")&&(b=new c(a),b.initAnnotation(this.getAnnotationType(),this.getAnnotationColor(),!1,e),b.rect=a.getModule("viewport").getWorld().getSceneRectFromWorld(g),j("Main"))};this._registerListener("addGlobalAnnotation",function(){if(this.f.isParameterUpdateOngoing())var b=this._registerListener("parameters.changed",
function(){this._unregisterListener(b);this.addGlobalAnnotation()},this,this.f.getDocumentController());else this.addGlobalAnnotation()},this,this._annotationModel);var m=f.bind(function(b){if(b=this._widget.requestView(b))if(b=b.getLayer("Annotations"))return b;return null},this);this.registerState("default",{mousedown:function(){},mouseup:function(){},mousemove:function(){},mouseout:function(){},contextmenu:function(b){b.preventDefault();b.stopPropagation();return!1},mouseleave:function(){},click:function(){},
canBeInterrupted:!0});this.registerState("draw",f.defaults({mousedown:f.bind(function(g){if(1===g.which){this._annotationModel.getAnnotationFilterModel().setOriginType(h.AnnotationOriginTypes.user.id);this.drawLinkedAnnotation||e.unselectAllAnnotations(!0,!0);this.requestCanvasLayer(g);var d=this.keepPointWithinWorldBounds(this.getWorldPoint(g),!0);b=new c(a);b.initAnnotation(this.getAnnotationType(),this.getAnnotationColor(),!1,e);b.rect=new i.Rect(d,new i.Size);this.changeState("drawing")}g.originalEvent.preventDefault()},
this)},this.getState("default")));var j=f.bind(function(a){p();a||(b=null);b&&2===b.pointArray.length&&b.pointArray[0].x==b.pointArray[1].x&&b.pointArray[0].y==b.pointArray[1].y&&(b=null);if(null!==b&&(0===Math.abs(b.rect.size.width)||0>=Math.abs(b.rect.size.height)))0===Math.abs(b.rect.size.width)&&0>=Math.abs(b.rect.size.height)?b=null:b.annottype!=h.AnnotationType.ANNOT_ARROW&&b.annottype!=h.AnnotationType.ANNOT_LINE&&(b=null);if(b){var e=m(a);e?(b.rect=e.getWorldRectFromScene(b.rect),this._annotationModel.getPage().isReaderSpread()?
this._annotationModule.promptIfAnnotationOutsidePage(b.rect,f.bind(function(a){var c=this.drawLinkedAnnotation;a&&!c&&(this.drawLinkedAnnotation=!0);this.createAnnotation(b,e);a&&!c&&(this.drawLinkedAnnotation=!1)},this),function(){b=null},this.drawLinkedAnnotation):this.createAnnotation(b,e)):b=null}this.changeState("draw")},this);this.createAnnotation=function(b,a){for(var c=0;c<b.pointArray.length;c++){var g=b.pointArray[c],d=new i.Point(g.x,g.y),d=a.getWorldPointFromScene(d);g.x=d.x;g.y=d.y}this.drawLinkedAnnotation?
e.addLinkedAnnotation(b):(e.addAnnotation(b),this.isActive()&&this.requestDeactivation())};var s=f.throttle(f.bind(function(){var a=this.getCanvasCtx();if(a){var e=this.getCanvasSize();a.clearRect(0,0,e.width,e.height);b&&d.drawOverlay(this.f,a,[b])}},this),40);this.registerState("drawing",f.defaults({enterState:function(){a.emit("viewport.startInteractive");a.emit("layout.disableTextSelection")},leaveState:function(){a.emit("viewport.stopInteractive");setTimeout(function(){a.emit("layout.enableTextSelection")},
500)},mousemove:f.bind(function(a){var e=b.rect.copy(),c=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!0);if(this.getAnnotationType()==h.AnnotationType.ANNOT_FREEFORM){a=new k;if(0===b.pointArray.length)a.makeMoveTo(b.rect.origin.x,b.rect.origin.y);else{var g=b.pointArray[b.pointArray.length-1];if(0>Math.abs(g.x-c.x)||0>Math.abs(g.y-c.y))return;a.makeLineTo(c.x,c.y)}b.pointArray.push(a);c=Math.abs(a.x-e.origin.x);a.x<e.origin.x?(c=Math.abs(e.origin.x-a.x),e.origin.x=a.x,e.size.width+=c):
c>e.size.width&&(e.size.width=c);c=Math.abs(a.y-e.origin.y);a.y<e.origin.y?(c=Math.abs(e.origin.y-a.y),e.origin.y=a.y,e.size.height+=c):c>e.size.height&&(e.size.height=c)}else e.size=b.rect.origin.sizeTo(c);b.setRect(e,!0);s()},this),mouseclick:function(){},mouseup:function(b){j(b)},mouseleave:function(){j()},mousedown:function(b){b.originalEvent.preventDefault()},canBeInterrupted:!1},this.getState("default")));this.canBeInterrupted=function(){return!1};this.activeKeyEvents=[];this.persistentKeyEvents=
[];this._override("initialize",function(b,a){this._super(b,a);this.changeState("default");this.registerActiveEvents("mousedown mousemove mouseup mouseout mouseleave contextmenu".split(" "));this.activeKeyEvents.push(["shift",f.bind(function(){this.drawLinkedAnnotation=!0},this),"keydown"]);this.activeKeyEvents.push(["shift",f.bind(function(){this.drawLinkedAnnotation=!1},this),"keyup"])});var p=f.bind(function(){this.releaseCanvasLayer()},this);this.canBeActivated=function(){return e.canChangeAnnotations()};
this._override("activate",function(b){this._super(b);this.getAnnotationType();this.getAnnotationColor();e.setLockSelection(!0);this.changeState("draw")});this._override("deactivate",function(b){this._super(b);this.changeState("default");p();this.drawLinkedAnnotation=!1;e.setLockSelection(!1)});a.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATIONTOOLS_VISIBLE",f.bind(function(b,a){!a&&this.isActive()&&this.requestDeactivation()},this))};j.prototype=Object.create(l.prototype);return j.prototype.constructor=
j});
define("web-viewer/annotation/AnnotationIndicatorTool","underscore web-viewer/viewport/tools/AbstractTool web-viewer/viewport/model/ViewportLayerModel utils/ShapeUtils web-viewer/annotation/AnnotationConstants web-viewer/core/CoreConstants".split(" "),function(f,l,i,j,d,c){f=function(d,f){l.call(this,d,c.TOOLS.ANNOTATION_INDICATOR);this.f=d;this.layerModel=new i(d,"annotationIndication");this.layerModel.annotation=null;this.layerModel.tool=this;this.layerModel.annotationModel=f;this.layerModel.alpha=0.7;
this.layerModel.render=function(c,d){c.fillStyle="rgba(0, 0, 0, "+this.alpha+")";c.clearRect(d.origin.x,d.origin.y,d.size.width,d.size.height);c.beginPath();c.rect(d.origin.x,d.origin.y,d.size.width,d.size.height);c.fill();c.save();if(this.annotation){var f=Math.abs(this.tool.sceneToWorldSize(new j.Size(10,10)).width),a=this.annotationModel.getAnnotationsPage();if(null!==a&&void 0!==a){this.resetTransformation();this.getTransform().scale(1,-1);var e=a.getRotation(),g=this.f.getModule("viewport").getWorldBounds();
this.calculateTransformation(g,a.getPageSize(),this.annotationModel.getAnnotationsOffset(),e,a.isFlipped())}a=this.annotation.rect.copy();a.normalize();c.clearRect(a.origin.x-f,a.origin.y+a.size.height+f,a.size.width+2*f,-a.size.height-2*f);e=this.annotationModel.getAnnotationLinks(this.annotation);for(g=0;g<e.length;g++)a=e[g].rect.copy(),a.normalize(),c.clearRect(a.origin.x-f,a.origin.y+a.size.height+f,a.size.width+2*f,-a.size.height-2*f)}c.restore()};this._override("activate",function(){this._super();
this.f.getModule("viewport").addLayer("annotationIndication",this.layerModel)});this._override("deactivate",function(c){this._super(c);this.f.getModule("viewport").removeLayer("annotationIndication")})};f.prototype=Object.create(l.prototype);f.prototype.constructor=f;f.prototype.canBeInterrupted=function(){return!1};f.prototype.setAnnotation=function(c){this.layerModel.annotation=c};return f});
define("web-viewer/annotation/AnnotationOriginSelector",["jquery","web-viewer/annotation/AnnotationConstants","component/toolbar/ButtonGroup","component/toolbar/ToolbarButton","component/tooltip/Tooltip"],function(f,l,i,j){var d=function(c,d,j,h,m){this._filterModel=d;this._annotationModel=j;this._annotationModel.on("modelChanged",_.bind(this._enableToolbarButtons,this));this._annotationModel.on("modelContentChanged",_.bind(this._enableToolbarButtons,this));this._annotationModel.on("modelContentChanged",
_.bind(this._activateToolbarButtons,this));this._filterModel.on("filterChanged",_.bind(this._activateToolbarButtons,this));this.f=c;this._buttonGroup=new i("annotationTypeButtonGroup");this.element=f("<div class='annotation-origin-selector'/>").append(this._buttonGroup.element);this._context=h;this._isMobile=m;this._buttons={};this._initTypeFilters()};d.prototype._initTypeFilters=function(){_.each(l.AnnotationOriginTypes,function(c){var d=c.id,i=c.icon;c.subIcon&&(i=f("<i class='icon containerIcon icon-normal'/>").addClass(i),
i.append(f("<i class='icon subIcon icon-normal'/>").addClass(c.subIcon)));c=new j(this.f.i18n,this._context,this._isMobile,d,i,this._isMobile,_.bind(function(){this._filterModel.setOriginType(d);this._annotationModel.unselectAllAnnotations()},this),this.f.i18n.t(c.langKey));this._buttonGroup.addButton(c);this._buttons[d]=c},this);this._enableToolbarButtons();this._activateToolbarButtons()};d.prototype._enableToolbarButtons=function(){var c=_.uniq(_.map(this._annotationModel.getAnnotations(),function(c){return c.originType})),
d=_.uniq(_.map(c,function(c){return l.AnnotationOriginTypes[c].group}));_.each(this._buttons,function(f,h){var m=_.find(c,function(a){return h===a}),i=_.find(d,function(a){return l.AnnotationOriginTypes[h].group===a});f.setEnabled(m||h===l.AnnotationOriginTypes.user.id);var a=l.AnnotationOriginTypes[h];a&&a.hideBtnOnEmpty?m?f.show():f.hide():a&&a.hideBtnOnGroupEmpty&&(i?f.show():f.hide())})};d.prototype._activateToolbarButtons=function(){var c=this._filterModel.getOriginType();_.each(this._buttons,
function(d){d.setActive(d.name===c)})};return d});
define("tpl!web-viewer/annotation/AnnotationCustomFilterPopup",function(){return function(f){var l,i="",i=i+('\r\n    <div class="filterOperator">\r\n        <span class="operatorText">'+(null==(l=f.i18n("FilterMatch"))?"":_.escape(l))+'</span>\r\n        <select class="filterOperatorSelector">\r\n            <option ');0==f.filterOperator&&(i+='selected="selected"');i+=' value="0">'+(null==(l=f.i18n("AnnotFilterAllOperator"))?"":_.escape(l))+"</option>    \r\n            <option ";1==f.filterOperator&&
(i+='selected="selected"');i+=' value="1">'+(null==(l=f.i18n("AnnotFilterAnyOperator"))?"":_.escape(l))+'</option>\r\n        </select>\r\n        <span class="operatorText">'+(null==(l=f.i18n("FilterOperator"))?"":_.escape(l))+'</span>\r\n    </div>\r\n    <div class="filterRows">\r\n        ';_.each(f.getFilterRows(),function(j,d){i+='\r\n            <div class="" data-bind="'+(null==(l=d)?"":_.escape(l))+'">\r\n                '+(null==(l=f.callTemplate("web-viewer/annotation/AnnotationCustomFilterRow",
j,"filter"))?"":l)+"\r\n            </div>\t\r\n        "});return i+='\r\n    </div>\r\n    <a class="addFilterRow">\r\n        <i class="icon-WCR_Filter-Add12"></i><span class="addFilterRowText">'+(null==(l=f.i18n("AnnotFilterAddRow"))?"":_.escape(l))+"</span>\r\n    </a>"}});
define("tpl!web-viewer/annotation/AnnotationCustomFilterRow",function(){return function(f){var l,i="",i=i+('<div class="filterRow" data-bind="'+(null==(l=f.filter.filterId)?"":_.escape(l))+'">\r\n    <select class="filterType">\r\n        ');_.each(f.getFilterTypes(),function(j,d){i+="\r\n            <option ";f.filter.filterType==d&&(i+='selected="selected"');i+=' value="'+(null==(l=d)?"":_.escape(l))+'">'+(null==(l=f.i18n(j))?"":_.escape(l))+"</option>\r\n        "});i+='\r\n    </select>\r\n    <select class="filterCondition">\r\n        <option ';
0==f.filter.filterCondition&&(i+='selected="selected"');i+=' value="0">'+(null==(l=f.i18n("AnnotFilterIs"))?"":_.escape(l))+"</option>\r\n        <option ";1==f.filter.filterCondition&&(i+='selected="selected"');i+=' value="1">'+(null==(l=f.i18n("AnnotFilterIsNot"))?"":_.escape(l))+'</option>\r\n    </select>\r\n    <select class="filterOption">\r\n        ';_.each(f.getOptions(f.filter.filterType,f.filter.filterOption),function(j,d){i+="\r\n            <option ";f.filter.filterOption===d&&(i+='selected="selected"');
i+=" ";"hidden"===d&&(i+="selected hidden");i+=' value="'+(null==(l=d)?"":_.escape(l))+'">\r\n                '+(null==(l=j)?"":_.escape(l))+"\r\n            </option>\r\n        "});i+="  \r\n    </select>\r\n    ";0!==f.filter.filterId&&(i+='\r\n        <a class="removeFilterRow" data-bind="'+(null==(l=f.filter.filterId)?"":_.escape(l))+'">\r\n            <i class="icon-WCR_Filter-Remove12"></i>\r\n        </a>\r\n    ');return i+="\r\n</div>"}});
define("web-viewer/annotation/AnnotationCustomFilterPopup","web-viewer/core/PrivateChannel web-viewer/layout/component/Popup web-viewer/layout/component/ViewerToolbarButton Template web-viewer/annotation/AnnotationConstants tpl!web-viewer/annotation/AnnotationCustomFilterPopup tpl!web-viewer/annotation/AnnotationCustomFilterRow jquery underscore".split(" "),function(f,l,i,j,d,c,k,n,h){k=function(m,k,a){l.call(this,m,k,m.getContext());f.installTo(this,m,["annotationFilterPopup"]);this.element.addClass("annotation-custom-filter-popup");
this._annotationModel=a;this._filterModel=this._annotationModel.getAnnotationFilterModel();this._savedFilterState=null;this._wasCustomFilterActive=!1;this._filterContent=n("<div>").addClass("annotationFilter");this._location=null;this.content.append(this._filterContent);this._okButton=new i(this.f,"okButton",n("<span/>"),!1,h.bind(function(){this._filterModel.setCustomFilterActive(!0);this._filterModel.fireFilterStateChanged();this.hide()},this));this._okButton.addClass("btn-success");this._cancelButton=
new i(this.f,"cancelButton",n("<span/>"),!1,h.bind(function(){this._filterModel.setFilterState(this._savedFilterState);this._savedFilterState=null;this._wasCustomFilterActive||this._filterModel.setCustomFilterActive(!1);this.hide()},this));this._cancelButton.addClass("btn");this.addButton(this._cancelButton.element);this.addButton(this._okButton.element);this.t=new j(this.f.i18n,c);this.t.setContext(this._filterContent);this.t.d.getFilterRows=h.bind(function(){return this._filterModel.getFilterRows()},
this);this.t.d.getFilterTypes=h.bind(function(){return h.values(d.FilterTypeNameLocs)},this);this.t.d.getOptions=h.bind(function(a,c){var b=this._annotationModel.getUsers(d.AnnotationOriginTypes.user.id);if(a==d.FilterTypes.AUTHOR)return c&&void 0===b[c]&&(b.hidden=this.f.i18n.t("AnnotFilterUserNotAvailable")),b;if(a==d.FilterTypes.REVIEWSTATE||a==d.FilterTypes.REVIEWAUTHORANDSTATE){var f={};h.each(d.AnnotationReviewStateLocs,function(b,a){f[a]=this.f.i18n.t(b)},this);if(a==d.FilterTypes.REVIEWSTATE)return f;
var m={};h.each(b,function(a,e){h.each(f,function(b,e){m[a+" "+e]=a+" "+b});e!==h.last(h.keys(b))&&(m[a+"Delimiter"]="\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500")},this);c&&void 0===m[c]&&(m.hidden=this.f.i18n.t("AnnotFilterUserNotAvailable"));return m}},this);this.on("closed",h.bind(function(){this.hide()},this));this.t.bind("click",".addFilterRow",function(){var a=this._filterModel.addEmptyRow();this._addFilterRow(a)},this);this.t.bind("click",".removeFilterRow",function(a){a=
n(a).attr("data-bind");this._removeFilterRow(a)},this);this.t.bind("change",".filterType",function(a){var c=n(a).parent().attr("data-bind"),a=n(a).val(),b=this.t.d.getOptions(a);this._filterModel.updateFilterType(c,a,h.first(h.keys(b)));this._rerenderFilterRow(c)},this);this.t.bind("change",".filterCondition",function(a){var c=n(a).parent().attr("data-bind"),a=n(a).val();this._filterModel.updateFilterCondition(c,a)},this);this.t.bind("change",".filterOption",function(a){var c=n(a).parent().attr("data-bind"),
a=n(a).val();this._filterModel.updateFilterOption(c,a)},this);this.t.bind("change",".filterOperatorSelector",function(a){a=n(a).val();this._filterModel.setFilterOperator(a)},this);this.f.i18n.loadBundle("viewer",function(){this.setHeader(n("<span/>").addClass("popupTitle").html(this.f.i18n.t("CustomAnnotationFilter")));this._okButton.element.html(this.f.i18n.t("ApplyCustomFilter"));this._cancelButton.element.html(this.f.i18n.t("AppDialogCancel"))},this)};k.prototype=Object.create(l.prototype);k.prototype.constructor=
k;k.prototype.render=function(){this.f.i18n.loadBundle("viewer",function(){this.t.d.filterOperator=this._filterModel.getFilterOperator();this.t.render()},this)};k.prototype._rerenderFilterRow=function(c){var d=this._filterModel.getFilterRow(c);this.content.find(".filterRow[data-bind='"+c+"']").html(this.t.d.callTemplate("web-viewer/annotation/AnnotationCustomFilterRow",d,"filter"))};k.prototype._addFilterRow=function(c){c=this._filterModel.getFilterRow(c);this.content.find(".filterRows").append(this.t.d.callTemplate("web-viewer/annotation/AnnotationCustomFilterRow",
c,"filter"));this.recalculateSize(this._location,475)};k.prototype._removeFilterRow=function(c){this.content.find(".filterRow[data-bind='"+c+"']").remove();this._filterModel.removeFilterRow(c);this.recalculateSize(this._location,475)};k.prototype.show=function(c){this._savedFilterState=this._filterModel.getFilterState();this._wasCustomFilterActive=this._filterModel.isCustomFilterActive();this.render();this._location=c;this._filterModel.setCustomFilterActive(!0);l.prototype.show.call(this,c,475)};
return k});
define("web-viewer/annotation/AnnotationWidget","web-viewer/layout/AbstractWidget web-viewer/annotation/AnnotationRow web-viewer/annotation/AnnotationOriginSelector web-viewer/annotation/AnnotationCustomFilterPopup jquery web-viewer/annotation/AnnotationConstants utils/ShapeUtils web-viewer/layout/component/MiniButton component/button/Button component/toolbar/ButtonGroup web-viewer/layout/component/DropdownMiniButton web-viewer/layout/LayoutConstants web-viewer/layout/component/ViewerToolbarButton underscore".split(" "),function(f,
l,i,j,d,c,k,n,h,m,o,a,e,g){e=function(b,e,l,s){f.call(this,b,a.Widget.ANNOTATION);this.f=b;this.annotationModel=l;this.annotationModule=e;this.annotationRows={};this._isForMobile=s===a.LayoutType.MOBILE;this.detailsDiv=d("<div>").addClass("annotationDetails enableTextSelection");this.nonScrollablePart=d("<div>").addClass("nonScrollablePart");this._annotationOriginSelector=new i(b,l.getAnnotationFilterModel(),l,this.detailsDiv,this._isForMobile);this.nonScrollablePart.append(this._annotationOriginSelector.element);
this.detailsDiv.append(this.nonScrollablePart);this.warningMessage=d("<div/>").addClass("alert").text(this.annotationModel.getDisabledReason()).toggle(0<this.annotationModel.getDisabledReason().length);this.nonScrollablePart.append(this.warningMessage);this.temporarilyDisabledDiv=d("<div/>").addClass("annotationsTemporarilyDisabled").hide();this.nonScrollablePart.append(this.temporarilyDisabledDiv);this.showCurrentFileAnnotationsButton=new h(this.f.i18n,this.f.getContext(),this.f.isMobile(),"currentDocument",
d("<span/>").text("current").prepend(d("<i>").addClass("icon icon-WCR_Compare-Current")),!0,g.bind(function(){this.annotationModule.toggleCurrentPageAnnotations()},this));this.showCurrentFileAnnotationsButton.element.addClass("btn");this.showDifferenceFileAnnotationsButton=new h(this.f.i18n,this.f.getContext(),this.f.isMobile(),"differenceDocument",d("<span/>").text("reference").prepend(d("<i>").addClass("icon icon-WCR_Compare-Reference")),!0,g.bind(function(){this.annotationModule.toggleDifferencePageAnnotations()},
this));this.showDifferenceFileAnnotationsButton.element.addClass("btn");this.annotationToggleGroup=new m("annotationToggleBetweenCurrentAndDifference",[this.showCurrentFileAnnotationsButton,this.showDifferenceFileAnnotationsButton]);this.temporaryAnnotationToggler=d("<div/>").addClass("temporaryAnnotationToggle");b.i18n.loadBundle("viewer",function(){this.temporaryAnnotationToggler.append(d("<span/>").text(this.f.t("AnnShowAnnotationsFor")+": ")).append(d("<br/>")).append(this.annotationToggleGroup.element);
this.showCurrentFileAnnotationsButton.setContent(d("<span/>").text(this.f.t("CaptionCurrent")).prepend(d("<i>").addClass("icon icon-WCR_Compare-Current")));this.showDifferenceFileAnnotationsButton.setContent(d("<span/>").text(this.f.t("CaptionPrevious")).prepend(d("<i>").addClass("icon icon-WCR_Compare-Reference")))},this);this.temporarilyDisabledDiv.append(this.temporaryAnnotationToggler);this.temporaryAnnotationToggler.hide();this.header=d("<div>").addClass("annotationFilter");this._annotationFilters=
d("<div>").addClass("annotationFilterSelectors");this._customFilters=d("<div>").addClass("customFilterControls");this.header.append(this._annotationFilters);this._numberOfSelectedThreads=d("<span/>").addClass("threadsCount");this.header.append(this._customFilters);this._customFilters.append(this._numberOfSelectedThreads);this.annotationModel.getAnnotationFilterModel().on("filterStateChanged",g.bind(function(){this.annotationModel.getAnnotationFilterModel().getOriginType()!==c.AnnotationOriginTypes.user.id?
(this._annotationFilters&&this._annotationFilters.hide(),this._pinFilterButton&&this._pinFilterButton.element.hide(),this._openFilterPopupButton&&this._openFilterPopupButton.element.hide(),this._duplicateFilteredAnnotationsButton&&(g.all(this.annotationModel.getFilteredAnnotations(),function(b){return b.getPermissionFor(c.ActionPermissions.DUPLICATE)})?this._duplicateFilteredAnnotationsButton.element.show():this._duplicateFilteredAnnotationsButton.element.hide()),this._copyFilteredAnnotationsWithoutText&&
this._copyFilteredAnnotationsWithoutText.element.show()):(this._annotationFilters&&this._annotationFilters.show(),this._pinFilterButton&&this._pinFilterButton.element.show(),this._openFilterPopupButton&&this._openFilterPopupButton.element.show(),this._duplicateFilteredAnnotationsButton&&this._duplicateFilteredAnnotationsButton.element.hide(),this._copyFilteredAnnotationsWithoutText&&this._copyFilteredAnnotationsWithoutText.element.hide())},this));this._isForMobile||(this._customFilterPopup=new j(this.f,
"customFilter",this.annotationModel),this.annotationModel.getAnnotationFilterModel().on("filterReset",g.bind(function(){this._customFilterPopup.isVisible()&&this._customFilterPopup.hide()},this)),this._pinFilterButton=new n(this.f,"pinFilter","icon-WCR_Pin12",!0,g.bind(function(){this.annotationModel.getAnnotationFilterModel().toggleAnnotationPinnedState();this._updateFilterPinnedIcon()},this)),this._updateFilterPinnedIcon(),this._pinFilterButton.element.addClass("pinAnnotationFilter"),this._copyFilteredAnnotationsWithoutText=
new n(this.f,"duplicateAllFilteredAnnotationWithoutText"," icon icon-WCR_Annotation-Duplicate-NoText12",!0,g.bind(function(){this.f.emit("module.annotation.duplicateAllFilteredAnnotationWithoutText")},this)),this._copyFilteredAnnotationsWithoutText.setTooltip("viewer","duplicateAllFilteredAnnotationWithoutText"),this._copyFilteredAnnotationsWithoutText.element.addClass("pinAnnotationFilter"),this._copyFilteredAnnotationsWithoutText.element.hide(),this._duplicateFilteredAnnotationsButton=new n(this.f,
"duplicateAllFiltered","icon icon-WCR_Annotation-Duplicate12",!0,g.bind(function(){this.f.emit("module.annotation.duplicateAllFilteredAnnotations")},this)),this._duplicateFilteredAnnotationsButton.setTooltip("viewer","duplicateAllFilteredAnnotations"),this._duplicateFilteredAnnotationsButton.element.addClass("pinAnnotationFilter"),this._duplicateFilteredAnnotationsButton.element.hide(),this._openFilterPopupButton=new n(this.f,"customFilter","icon-WCR_Filter12",!0,g.bind(function(){var b=250>this.context.offset().left?
this.context.width():this.context.offset().left-250,b=new k.Point(b,this.context.offset().top);this._customFilterPopup.show(b)},this)),this._openFilterPopupButton.element.addClass("customFilterBtn"),this._openFilterPopupButton.setTooltip("viewer","OpenCustomFilterPopup"),this._customFilters.append(this._copyFilteredAnnotationsWithoutText.element),this._customFilters.append(this._duplicateFilteredAnnotationsButton.element));this.annotationsListWrapper=d("<div>").addClass("annotationListWrapper");this.annotationsListWrapper.on("makeMeVisible",
g.partial(function(b,a){var c=d(a.target).offset().top,e=d(a.target).outerHeight(),g=d(this).offset().top,f=d(this).outerHeight();if(0>c-g||c+e>g+f)c=d(this).scrollTop()+c-g,d(this).scrollTop(c);b._visibleItem=d(a.target);a.preventDefault();a.stopPropagation()},this));this._isForMobile||(this._customFilters.append(this._openFilterPopupButton.element),this._customFilters.append(this._pinFilterButton.element));this.detailsDiv.append(this.annotationsListWrapper);this.annotationList=d("<div>").addClass("annotationList");
this._isForMobile?this.annotationsListWrapper.append(this.header):this.nonScrollablePart.append(this.header);this.annotationsListWrapper.append(this.annotationList);b.i18n.loadBundle("viewer",function(){this.setTitle(this.f.i18n.t("AnnWidgetTitle"))},this);this.setIcon("icon icon-WCR_Comment");this.inDOM={};this.toBeRemovedFromDOM={};this.saveButton=null;this.disableSaveButton=!1;this.annotationModel.on("disabledReasonChanged",g.bind(function(){this.warningMessage.text(this.annotationModel.getDisabledReason());
this.warningMessage.toggle(0<this.annotationModel.getDisabledReason().length);this.resized()},this));this.annotationModel.on("save.finished",g.bind(function(){this.disableSaveButton=!1;this.updateSaveButton();this.reloadButton.setEnabled(!0)},this));this.annotationModel.on("readWriteChanged",g.bind(function(){g.each(this.annotationRows,function(b){b.annotationUpdated()})},this));this.saveButton=new n(b,"saveAnnotations","icon-WCR_Save",!0,g.bind(function(){this.annotationModel.save()},this),"fontIconDisabled icon-WCR_Save");
this.updateSaveButton();this.stepThroughButton=new n(b,"stepThroughAnn","icon-WCR_Step",!0,g.bind(function(b){b.shiftKey?this.annotationModel.goToAnnotation(!1):this.annotationModel.goToAnnotation(!0)},this));this.stepThroughButton.setDisabledIcon("icon-WCR_Step fontIconDisabled");this.stepThroughButton.element.on("contextmenu",g.bind(function(b){b.preventDefault();this.stepThroughButton.isEnabled()&&this.annotationModel.goToAnnotation(!1)},this));this.stepThroughButton.setTooltip("viewer","StepThroughAnnTT");
this.reloadButton=new n(b,"reloadAnnotations","icon-WCR_Refresh",!0,g.bind(function(){this.annotationModel.reload()},this),"icon-WCR_Refresh fontIconDisabled");this.reloadButton.setTooltip("viewer","ReloadMiniBtnTT");this.annotationModel.on("save.started",g.bind(function(){this.reloadButton.setEnabled(!1);this.disableSaveButton=!0;this.updateSaveButton()},this));this.annotationModel.on("reload.started",g.bind(function(){this.reloadButton.setEnabled(!1)},this));this.annotationModel.on("reload.finished",
g.bind(function(){this.reloadButton.setEnabled(!0)},this));this.annotationModel.on("temporarilyDisableChanged",g.bind(this.updateListVisibility,this));this.annotationModel.on("disabledReasonChanged",g.bind(this.updateListVisibility,this));this.updateListVisibility();b.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_DATESORT_MODE",g.bind(function(b,a){this.setSortByMode(a)},this));b.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_NEXT_MODE",g.bind(function(b,a){this.setStepThroughMode(a)},
this));b.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWSELECTEDONLY",g.bind(function(b,a){this.setShowSelectedAnnotationOnly(0<a)},this));b.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY",g.bind(function(b,a){this.setShowSelectedAnnotationPopupOnly(0<a)},this));b.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE",g.bind(function(b,a){this.setShowSequenceLabel(0<a)},this));b.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWCOUNT",
g.bind(function(b,a){this.setShowCharLineCounter(0<a)},this));this.optionButton=new o(b,"annotationSettings","icon-WCR_Settings-submenu");b.i18n.loadBundle("viewer",function(){function b(a,c){c&&this.setStepThroughMode(a,!0)}function a(b,c){c&&this.setSortByMode(b,!0)}this.optionButton.addOption({name:"stepByThread",content:this.f.i18n.t("AnnSortThread"),onchange:g.bind(b,this,c.StepThroughMode.BY_THREAD),selected:this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")==c.StepThroughMode.BY_THREAD,userCannotUncheck:!0});
this.optionButton.addOption({name:"stepWithReplies",content:this.f.i18n.t("AnnSortDate"),onchange:g.bind(b,this,c.StepThroughMode.WITH_REPLIES),selected:this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")==c.StepThroughMode.WITH_REPLIES,userCannotUncheck:!0});this.optionButton.addOption({name:"stepWithZoom",content:this.f.i18n.t("AnnSortThreadFit"),onchange:g.bind(b,this,c.StepThroughMode.WITH_ZOOM),selected:this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")==c.StepThroughMode.WITH_ZOOM,userCannotUncheck:!0});
this.optionButton.addOption({name:"stepWithLinked",content:this.f.i18n.t("AnnSortAreaFit"),onchange:g.bind(b,this,c.StepThroughMode.WITH_LINKED),selected:this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")==c.StepThroughMode.WITH_LINKED,userCannotUncheck:!0});this.optionButton.addDivider();this.optionButton.addOption({name:"showselann",content:this.f.i18n.t("AnnListShowSel"),onchange:g.bind(function(b){this.setShowSelectedAnnotationOnly(b,!0)},this),selected:0<this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY")});
this.optionButton.addOption({name:"showselannpopup",content:this.f.i18n.t("AnnListShowSelPopup"),onchange:g.bind(function(b){this.setShowSelectedAnnotationPopupOnly(b,!0)},this),selected:0<this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY")});this.optionButton.addOption({name:"shownumber",content:this.f.i18n.t("AnnSeqLabelShow"),onchange:g.bind(function(b){this.setShowSequenceLabel(b,!0)},this),selected:0<this.f.getOption("PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE")});this.optionButton.addOption({name:"showCharLineCount",
content:this.f.i18n.t("AnnCountShow"),onchange:g.bind(function(b){this.setShowCharLineCounter(b,!0)},this),selected:0<this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT")});this.optionButton.addDivider();this.optionButton.addOption({name:"sortbycreationdate",content:this.f.i18n.t("DateSortCreation"),onchange:g.bind(a,this,c.AnnotationSortType.SORT_BY_CREATION_DATE),selected:this.f.getOption("PREFERENCES_ANNOTATION_DATESORT_MODE")===c.AnnotationSortType.SORT_BY_CREATION_DATE,userCannotUncheck:!0});
this.optionButton.addOption({name:"sortbymodificationdate",content:this.f.i18n.t("DateSortModification"),onchange:g.bind(a,this,c.AnnotationSortType.SORT_BY_MODIFICATION_DATE),selected:this.f.getOption("PREFERENCES_ANNOTATION_DATESORT_MODE")===c.AnnotationSortType.SORT_BY_MODIFICATION_DATE,userCannotUncheck:!0});this.setShowSelectedAnnotationOnly(0<this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY"),!1);this.updateWarningBadge()},this);this.on("movingStarted",g.bind(function(){this.context&&
this.context.find("[id^=richText_]").each(function(){var b=d(this).data("richTextObj");b&&b.isInitialized()&&(b.destroy(),b.isDestroyed=!0)})},this));this.on("movingStopped",g.bind(function(){this.context&&this.context.find("[id^=richText_]").each(function(){var b=d(this).data("richTextObj");b&&b.isDestroyed&&g.defer(function(){b.init()})})},this));this.on("visible",function(b){l.setAnnotationListVisible(b)});l.setAnnotationListVisible(this.isVisible());l.on("selectedAnnotation",g.bind(this.selectAnnotation,
this));l.on("unselectedAnnotation",g.bind(this.deselectAnnotation,this));l.on("annotationAdded",g.bind(function(b,a){a||this.addAnnotation(b,!0)},this));l.on("annotationUpdated",g.bind(this.updateAnnotation,this));l.on("annotationDeleted",g.bind(this.deleteAnnotation,this));var p=g.bind(function(){this._updateButtons();this.renderCompleteWidget()},this),v=g.bind(function(){this._updateButtons()},this);this._override("setContext",function(b,a){this._super(b,a);this.renderCompleteWidget();this.context.append(this.detailsDiv);
this.headerExtra.append(this.saveButton.element).append(this.stepThroughButton.element).append(this.reloadButton.element).append(this.optionButton.element);this._updateButtons();this.annotationModel.on("filterChanged",p);this.annotationModel.on("modelContentChanged",p);this.annotationModel.on("modelChanged",v);this.annotationModel.on("changed.page",g.bind(function(){var b=g.keys(this.inDOM);g.each(b,function(b){this._removeFromDOM(b)},this);this.annotationRows={}},this));this.startHeartBeat();this.resized()});
this._override("destroy",function(){this._super();l.off("filterChanged",p);l.off("modelContentChanged",p);l.off("modelChanged",v);this.stopHeartBeat()})};e.prototype=Object.create(f.prototype);e.prototype.constructor=e;e.widgetName=a.Widget.ANNOTATION;e.prototype.getMinimumSize=function(){return new k.Size(250,150)};e.prototype.willFill=function(){return!0};e.prototype._updateButtons=function(){this.updateSaveButton();this.updateStepThroughButton(!0)};e.prototype.updateSaveButton=function(){if(this.saveButton)if(this.disableSaveButton)this.saveButton.setEnabled(!1);
else{var b=this.annotationModel.getUnsavedAnnotationCount();0<b?(this.saveButton.setEnabled(!0),this.saveButton.setBadge(b),0<this.annotationModel.getUnsavedAnnotations().length?0<this.annotationModel.getDeletedAnnotations().length?this.saveButton.setTooltip("viewer","SaveMiniBtnTT",[this.annotationModel.getUnsavedAnnotations().length,this.annotationModel.getDeletedAnnotations().length]):this.saveButton.setTooltip("viewer","SaveMiniBtnAnnTT",[this.annotationModel.getUnsavedAnnotations().length]):
this.saveButton.setTooltip("viewer","SaveMiniBtnDelTT",[this.annotationModel.getDeletedAnnotations().length])):this.saveButton.setEnabled(!1)}};e.prototype.updateWarningBadge=function(){var b=this.optionButton.getOptionValue("showselann"),a=this.optionButton.getOptionValue("showselannpopup");b||a?(this.optionButton.setWarning(),this.f.i18n.loadBundle("viewer",function(){var c=this.f.i18n.t("AnnWidgetOptionsTT")+".",c=c+("<br />"+this.f.i18n.t("Warning"));b&&(c+="  "+this.f.i18n.t("OnlySelectedAnnotationWarningTT"));
a&&this.optionButton.isActionEnabled("showselannpopup")&&(b&&(c+="<br />"),c+="  "+this.f.i18n.t("OnlySelectedAnnotationPopupWarningTT"));this.optionButton.setTooltip(c)},this)):(this.optionButton.removeWarning(),this.optionButton.setTooltip("viewer","AnnWidgetOptionsTT"))};e.prototype.updateStepThroughButton=function(b){0===g.size(this.annotationModel.getFilteredAnnotations())||!b?this.stepThroughButton.setEnabled(!1):this.stepThroughButton.setEnabled(!0)};e.prototype.setSortByMode=function(b,a){a&&
this.f.setOption("PREFERENCES_ANNOTATION_DATESORT_MODE",b);this.optionButton.toggleOption("sortbycreationdate",b==c.AnnotationSortType.SORT_BY_CREATION_DATE);this.optionButton.toggleOption("sortbymodificationdate",b==c.AnnotationSortType.SORT_BY_MODIFICATION_DATE)};e.prototype.setShowSelectedAnnotationOnly=function(b,a){a&&this.f.setOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY",b?1:0);b&&(this.optionButton.toggleOption("showselannpopup",!1),this.f.setOption("PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY",
0));this.updateWarningBadge()};e.prototype.setShowSelectedAnnotationPopupOnly=function(b,a){a&&this.f.setOption("PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY",b?1:0);b&&(this.optionButton.toggleOption("showselann",!1),this.f.setOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY",0));this.updateWarningBadge()};e.prototype.setStepThroughMode=function(b,a){a&&this.f.setOption("PREFERENCES_ANNOTATION_NEXT_MODE",b);this.optionButton.toggleOption("stepWithReplies",b==c.StepThroughMode.WITH_REPLIES);this.optionButton.toggleOption("stepByThread",
b==c.StepThroughMode.BY_THREAD);this.optionButton.toggleOption("stepWithZoom",b==c.StepThroughMode.WITH_ZOOM);this.optionButton.toggleOption("stepWithLinked",b==c.StepThroughMode.WITH_LINKED)};e.prototype.setShowSequenceLabel=function(b,a){a&&this.f.setOption("PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE",b?1:0);this.optionButton.toggleOption("shownumber",b)};e.prototype.setShowCharLineCounter=function(b,a){a&&this.f.setOption("PREFERENCES_ANNOTATION_SHOWCOUNT",b?1:0);this.optionButton.toggleOption("showCharLineCount",
b);g.each(this.annotationRows,function(a){a.showHideCharLineCount(b,!0)})};e.prototype.renderCompleteWidget=function(){this._isDirty||(this._isDirty=!0,this.f.i18n.loadBundle("viewer",function(){g.defer(g.bind(function(){this._isDirty=!1;this.renderHeader();this.renderAnnotationList()},this))},this))};e.prototype.renderHeader=function(){this._annotationFilters.empty();var b=this.annotationModel.getAnnotationOrigins();1<b.length||1===b.length&&b[0]!==c.AnnotationOriginTypes.user.id?this._annotationOriginSelector.element.show():
this._annotationOriginSelector.element.hide();this._usercombo=d("<select>");var b=d("<option/>").text(this.f.i18n.t("AnnAllUsers")).val("All"),a=d("<option selected disabled hidden value=''/>").text(this.f.i18n.t("AnnotFilterCustomEnabled"));this.annotationModel.getAnnotationFilterModel().isCustomFilterActive()&&this._usercombo.append(a);this._usercombo.append(b);b=this.annotationModel.getUsers(c.AnnotationOriginTypes.user.id);g.each(b,function(b,a){var c=d("<option/>").text(b).val(a);this._usercombo.append(c)},
this);var e=this.annotationModel.getAnnotationFilterModel().getSelectedUser();e&&!this.annotationModel.getAnnotationFilterModel().isCustomFilterActive()&&(0<this._usercombo.find("option").filter(function(b,a){return d(a).attr("value")===e}).length?this._usercombo.val(e):(b=d("<option hidden selected/>").text(this.f.i18n.t("AnnotFilterUserNotAvailable")),this._usercombo.append(b)));this._annotationFilters.append(this._usercombo);this._usercombo.on("change",g.bind(function(b){"All"!=b.target.value?
this.annotationModel.getAnnotationFilterModel().setSelectedUser(b.target.value):this.annotationModel.getAnnotationFilterModel().setSelectedUser(null)},this));this._statecombo=d("<select>");b=d("<option/>").text(this.f.i18n.t("AnnAllReviewState")).val("All");a=d("<option selected disabled hidden value=''/>").text(this.f.i18n.t("AnnotFilterCustomEnabled"));this.annotationModel.getAnnotationFilterModel().isCustomFilterActive()&&this._statecombo.append(a);this._statecombo.append(b);this._statecombo.append(d("<option>").text("------------------------------").attr("disabled",
"disabled"));b=d("<option/>").text(this.f.i18n.t("AnnStatusAny")).val("Any");this._statecombo.append(b);b=d("<option/>").text(this.f.i18n.t("AnnNoReviewState")).val("NOT_Any");this._statecombo.append(b);this._statecombo.append(d("<option>").text("------------------------------").attr("disabled","disabled"));g.each(c.AnnotationReviewState,function(b,a){var e=d("<option/>").text(this.f.i18n.t(c.AnnotationReviewStateLocs[a])).val(c.AnnotationReviewState[a]);this._statecombo.append(e)},this);this._statecombo.append(d("<option>").text("------------------------------").attr("disabled",
"disabled"));g.each(c.AnnotationReviewState,function(b,a){var e=d("<option/>").text(this.f.i18n.t("AllExcept",this.f.i18n.t(c.AnnotationReviewStateLocs[a]))).val("NOT_"+c.AnnotationReviewState[a]);this._statecombo.append(e)},this);this._annotationFilters.append(this._statecombo);this._statecombo.on("change",g.bind(function(b){if("All"!=b.target.value){var a=-1<b.target.value.indexOf("NOT_"),b=b.target.value;a&&(b=b.substring(4));this.annotationModel.getAnnotationFilterModel().setSelectedState(b,a)}else this.annotationModel.getAnnotationFilterModel().setSelectedState(null,
!1);return!0},this));(b=this.annotationModel.getAnnotationFilterModel().getSelectedState())&&!this.annotationModel.getAnnotationFilterModel().isCustomFilterActive()&&this._statecombo.val((this.annotationModel.getAnnotationFilterModel().isInverseState()?"NOT_":"")+b);this._customFilterPopup&&this._customFilterPopup.isVisible()&&this._customFilterPopup.render();this._updateNumberOfSelectedAnnotations()};e.prototype._updateNumberOfSelectedAnnotations=function(){this.f.i18n.loadBundle("viewer",function(){var b=
this.f.i18n.t("SelectedThreadsCount",this.annotationModel.getAnnotationFilterModel().getNumberOfFilteredAnnotations(),this.annotationModel.getAnnotationCount());this._numberOfSelectedThreads.text(b)},this)};e.prototype.renderAnnotationList=function(){var b=this.annotationModel.getFilteredAnnotations();this.toBeRemovedFromDOM=g.clone(this.inDOM);g.each(b,function(b){if(!(b.linkedto&&0<b.linkedto.length))if(this.annotationRows[b.name]){var a=this.annotationRows[b.name];a.element.next("hr").remove();
a.setAnnotation(b);this._addToDom(a);a.element.show()}else this.addAnnotation(b)},this);g.each(this.toBeRemovedFromDOM,function(b,a){this._removeFromDOM(a)},this);this.toBeRemovedFromDOM={};this._fireResized()};e.prototype._addToDom=function(b){this.inDOM[b.name]=1;delete this.toBeRemovedFromDOM[b.name];b.onDetachFromDOM();this.annotationList.append(b.element).append(d("<hr/>"));b.onReattachToDOM()};e.prototype._removeFromDOM=function(b){if(this.inDOM[b]){var a=this.annotationRows[b];a&&(a.element.next("hr").remove(),
a.onDetachFromDOM(),a.element.detach());delete this.toBeRemovedFromDOM[b];delete this.inDOM[b]}};e.prototype.addAnnotation=function(b,a){if(!(b.linkedto&&0<b.linkedto.length)){var c=new l(this.f,b,this.annotationModel,void 0,void 0,this._isForMobile);this.annotationRows[b.name]=c;var e=c.element;this._addToDom(c);e.on("click",g.bind(function(b){this.annotationModel.selectAnnotation(c.getAnnotation(),!0);b.stopPropagation()},this));var d=!1,f=!1;e.on("mousedown",g.bind(function(){d=!0;setTimeout(g.bind(function(){d&&
(f=!0,this.f.emit("module.annotation.highlightAnnotation",c.getAnnotation()))},this),500)},this));e.on("mouseup",g.bind(function(){d&&f&&this.f.emit("toolManager.deactivateTool","annotationindicatortool");f=d=!1},this));e.on("mouseout",g.bind(function(){d&&f&&this.f.emit("toolManager.deactivateTool","annotationindicatortool");f=d=!1},this));e.on("mouseleave",g.bind(function(){d&&f&&this.f.emit("toolManager.deactivateTool","annotationindicatortool");f=d=!1},this));this.annotationModel.isAnnotationOrReplySelected(b)&&
this.selectAnnotation(b);this._updateNumberOfSelectedAnnotations();a&&this._fireResized()}};e.prototype.selectAnnotation=function(b){this.annotationRows[b.inreplyto]&&this.annotationRows[b.inreplyto].toggleReplyLimit(!1);if(this.annotationRows[b.name]||this.annotationRows[b.inreplyto])b=this.annotationRows[b.name]||this.annotationRows[b.inreplyto].annotationRows[b.name],b.setSelected(!0),b.element.trigger("makeMeVisible")};e.prototype.deselectAnnotation=function(b){var a;this.annotationRows[b.name]&&
(a=this.annotationRows[b.name]);this.annotationRows[b.inreplyto]&&(this.annotationRows[b.inreplyto].toggleReplyLimit(),void 0===a&&(a=this.annotationRows[b.inreplyto].annotationRows[b.name]));a&&a.setSelected(!1)};e.prototype.updateAnnotation=function(b,a){if(this.annotationRows[b.name])this.annotationRows[b.name].annotationUpdated(a);else if(b.linkedto&&!b.parent&&this.annotationRows[b.linkedto])this.annotationRows[b.linkedto].annotationUpdated();else{var c=b.getGodfather();c!==b&&this.updateAnnotation(c,
b)}};e.prototype.deleteAnnotation=function(b){this.annotationRows[b.name]?(this._removeFromDOM(b.name),delete this.annotationRows[b.name]):b.linkedto&&!b.parent&&this.annotationRows[b.linkedto]?(this._removeFromDOM(b.linkedto),delete this.annotationRows[b.linkedto]):(b=b.getGodfather(),this.updateAnnotation(b));this._updateNumberOfSelectedAnnotations();this._fireResized()};e.prototype.resized=function(){this.annotationsListWrapper.css("height","");this.isContextAvailable()&&"flex"!==this.detailsDiv.css("display")&&
g.defer(g.bind(function(){this.context.css("overflow","hidden");this.annotationsListWrapper.css("height","auto");var b=this.context.outerHeight(!0);this._isForMobile||(b-=this.header.outerHeight(!0));this.warningMessage.is(":visible")&&(b-=this.warningMessage.outerHeight(!0));this.temporarilyDisabledDiv.is(":visible")&&(b-=this.temporarilyDisabledDiv.outerHeight(!0));this._annotationOriginSelector.element.is(":visible")&&(b-=this._annotationOriginSelector.element.outerHeight(!0));0<b&&this.annotationsListWrapper.css("height",
b);this._visibleItem&&this._visibleItem.trigger("makeMeVisible");this.context.css("overflow","auto")},this))};e.prototype.getPreferredSize=function(){return new k.Size(this.annotationsListWrapper.outerWidth(!0),this.annotationsListWrapper.outerHeight(!0)+this.nonScrollablePart.outerHeight(!0))};e.prototype.startHeartBeat=function(){this.canRunTimer=!0;this.updateTimers()};e.prototype.stopHeartBeat=function(){this.canRunTimer=!1};e.prototype._updateFilterPinnedIcon=function(){this.annotationModel.getAnnotationFilterModel().isAnnotationFilterPinned()?
(this._pinFilterButton.setIcon("pinned icon-WCR_Pin12"),this._pinFilterButton.setTooltip("viewer","AnnotFilterPinOn")):(this._pinFilterButton.setIcon("unpinned icon-WCR_Pin12"),this._pinFilterButton.setTooltip("viewer","AnnotFilterPinOff"))};e.prototype.updateTimers=function(){this.canRunTimer&&(g.each(this.annotationRows,function(b){b.updateTimers()}),setTimeout(g.bind(function(){this.updateTimers()},this),3E4))};e.prototype.updateListVisibility=function(){this.annotationModel.isTemporarilyDisabled()?
(this.temporarilyDisabledDiv.toggle(this.annotationModel.isTemporarilyAnnotationDocumentTogglingEnabled()),this.temporaryAnnotationToggler.toggle(this.annotationModel.isTemporarilyAnnotationDocumentTogglingEnabled()),this.showCurrentFileAnnotationsButton.setActive(this.annotationModel.isTemporarilyCurrentPageAnnotationsShown()),this.showDifferenceFileAnnotationsButton.setActive(this.annotationModel.isTemporarilyDifferencePageAnnotationsShown()),this.annotationModel.isTemporarilyDisabledAndNoAnnotationsVisible()?
(this.header.hide(),this.annotationsListWrapper.hide(),this.updateStepThroughButton(!1),this.reloadButton.setEnabled(!1)):(this.header.show(),this.annotationsListWrapper.show(),this.updateStepThroughButton(!0),this.reloadButton.setEnabled(!0))):(this.header.show(),this.annotationsListWrapper.show(),this.temporarilyDisabledDiv.hide(),this.updateStepThroughButton(!0),this.reloadButton.setEnabled(!0));this.resized()};return e});
define("web-viewer/annotation/GVAnnotationConstants",{GVTypes:{barcode:{contentProperties:{"Decoded Value:":{langKey:"BarcodeValue"},"Decoded ValueLeft/Bottom:":{langKey:"BarcodeValueLeftBottom"},"Decoded Value Left/Bottom:":{langKey:"BarcodeValueLeftBottom"},"Decoded ValueRight/Top:":{langKey:"BarcodeValueRightTop"},"Decoded Value Right/Top:":{langKey:"BarcodeValueRightTop"},"Type:":{langKey:"BarcodeType"},"Grade:":{langKey:"BarcodeGrade"},"Magnification:":{langKey:"BarcodeMagnification"},"BWR:":{langKey:"BarcodeBWR"}}},
braille:{contentProperties:{"Language:":{langKey:"BrailleSelLang"},"Translation:":{langKey:"BrailleTranslation",stop:"EOF"}}},text:{contentProperties:{"Type:":{langKey:"TextCompareType"},"Master:":{langKey:"TextCompareMaster"},"Sample:":{langKey:"TextCompareSample"}},valueProperties:{Bold:"TextCompareTypeBold",Case:"TextCompareTypeCase",Change:"TextCompareTypeChange",Color:"TextCompareTypeColor",Deletion:"TextCompareTypeDeletion",Size:"TextCompareTypeSize",Space:"TextCompareTypeSpace","Sub/Super":"TextCompareTypeSubSuper",
"Font Type":"TextCompareTypeFontType",Hyphen:"TextCompareTypeHyphen",Insertion:"TextCompareTypeInsertion",Italic:"TextCompareTypeItalic",Location:"TextCompareTypeLocation",Underline:"TextCompareTypeUnderline"}}}});define("tpl!web-viewer/annotation/AnnotationGV",function(){return function(f){var l,i="",i=i+"<p>";_.each(f.lines,function(f){i+="\r\n\t"+(null==(l=f.key)?"":_.escape(l))+" "+(null==(l=f.value)?"":_.escape(l))+"<br/>\r\n"});return i+="</p>"}});
define("web-viewer/annotation/AnnotationGV","web-viewer/annotation/Annotation web-viewer/annotation/AnnotationConstants web-viewer/annotation/GVAnnotationConstants utils/XMLUtils tpl!./AnnotationGV jquery".split(" "),function(f,l,i,j,d,c){var k=function(c,d){f.call(this,c,d);this.imageTooltip=this.imageWrapper=null};k.prototype=Object.create(f.prototype);k.prototype.constructor=k;k.prototype._parseContentsFromXML=function(c){var f=c.getElementsByTagName("contents-richtext");0===f.length&&(f=c.getElementsByTagName("contents"));
var m=[];if(0<f.length){var k=f[0].getElementsByTagName("body")[0];k||(k=f[0]);var a=k.textContent;i.GVTypes[this.originType]&&i.GVTypes[this.originType].contentProperties?(_.each(i.GVTypes[this.originType].contentProperties,function(c,b){var e=a.indexOf(b);if(-1!==e){var e=a.substr(e+b.length),d;c.stop||(d=e.indexOf("\n"),-1===d&&(d=void 0));d=e.substr(0,d).trim();i.GVTypes[this.originType].valueProperties&&i.GVTypes[this.originType].valueProperties[d]&&(d=this.f.i18n.t(i.GVTypes[this.originType].valueProperties[d]));
m.push({key:this.f.i18n.t(c.langKey),value:d})}},this),this.content=d({lines:m})):this.content="<p>"+k.textContent+"</p>"}f=j.attributeValue(c,"tMaster");c=j.attributeValue(c,"tSample");if(null!==f&&null!==c){this.imageWrapper="<div class='imageWrapper'>"+("<img class='masterImage' src='data:image/png;base64,"+f+"' alt='Master'/>")+("<img class='sampleImage' src='data:image/png;base64,"+c+"' alt='Sample'/>")+"</div>";var e=this.content="";_.each(m,function(a,b){0<b&&(e+="<br />");e+=a.key+" "+a.value});
this.imageTooltip=e}else this.imageTooltip=this.imageWrapper=null;this.lastname=this.f.i18n.t(this.originType+"Title")};k.prototype.initWithXML=function(c,d,m){f.prototype.initWithXML.call(this,c,d,m);this.messagenumber=m};k.prototype._modifyAnnotatationCoords=function(c,d,f,i,a){var e=-(a.trimboxOffset.width-a.mediaboxOffest.width),a=a.trimboxOffset.height-a.mediaboxOffest.height;return[c+e,d+a,f+e,i+a]};k.prototype.getPermission=function(){return l.AccessRight.READ_ONLY};k.prototype.getPermissionFor=
function(c){switch(c){case l.ActionPermissions.DUPLICATE:return this.originType!==l.AnnotationOriginTypes.artwork.id;case l.ActionPermissions.DUPLICATE_WITHOUT_TEXT:return!0;case l.ActionPermissions.CAN_BE_REPLIED_TO:return!1}};k.prototype.getExtraContent=function(){return this.imageWrapper?{element:c(this.imageWrapper),tooltip:this.imageTooltip}:null};k.prototype.getTextContent=function(){return this.imageTooltip?this.imageTooltip:f.prototype.getTextContent.call(this)};k.prototype.getIconClass=function(){return this.originType===
l.AnnotationOriginTypes.braille.id||this.originType===l.AnnotationOriginTypes.barcode.id||this.originType===l.AnnotationOriginTypes.text.id||this.originType===l.AnnotationOriginTypes.artwork.id||this.originType===l.AnnotationOriginTypes.spelling.id?l.AnnotationOriginTypes[this.originType].subIcon:f.prototype.getIconClass.call(this)};return k});
define("web-viewer/annotation/AnnotationDataExtensions","web-viewer/annotation/Annotation web-viewer/annotation/AnnotationGV web-viewer/data/AbstractDocumentPage utils/ShapeUtils utils/XMLUtils web-viewer/utils/ViewerUtils web-viewer/annotation/AnnotationConstants underscore".split(" "),function(f,l,i,j,d,c,k,n){return function(h){function m(a){var c="";if(a.inreplyto)return(a=a.getGodfather())&&0<=a.messagenumber&&(c=" ("+a.messagenumber+")"),h.i18n.t("AnnCommReply")+c;0<=a.messagenumber&&!a.isNew&&
(c=" ("+a.messagenumber+")");return h.i18n.t(k.AnnotationComments[a.annottype])+c}var o=h.getDataAdapter();o.WebCenter?(i.prototype._initAnnotationModule=function(){this._annotData||(this._annotData={dataStatus:"notAvailable",onAnnotationsAvailableCallbacks:[],annotations:[]})},i.prototype.requestAnnotations=function(a){this._initAnnotationModule();"available"===this._annotData.dataStatus?a(!0):"loading"===this._annotData.dataStatus?this._annotData.onAnnotationsAvailableCallbacks.push(a):this.hasAnnotations()?
(this._annotData.onAnnotationsAvailableCallbacks.push(a),this._fetchAnnotationsFromServer()):a(!0)},i.prototype.reloadAnnotations=function(a){this._initAnnotationModule();"loading"===this._annotData.dataStatus?this._annotData.onAnnotationsAvailableCallbacks.push(a):(this._annotData.onAnnotationsAvailableCallbacks.push(a),this._fetchAnnotationsFromServer())},i.prototype.resetAnnotations=function(){this._annotData.dataStatus="notAvailable";this._annotData.annotations=[]},i.prototype._fireOnAnnotationsAvailableCallbacks=
function(a){n.each(this._annotData.onAnnotationsAvailableCallbacks,function(c){c&&c(a)});this._annotData.onAnnotationsAvailableCallbacks=[];this._annotData.dataStatus=a?"available":"notAvailable"},i.prototype._fetchAnnotationsFromServer=function(){var a={};this.hasGraphics()?a.file=this.get("file"):this.hasCad()&&(a.cad=this.get("cad"),a.style=this.get("style"));this._annotData.dataStatus="loading";var c=[];this.hasAnnotations(k.AnnotationOriginTypes.user.id)&&c.push(this._getUserAnnotations(a));
this._hasGVAnnotations()&&c.push(this._getGVAnnotations(a));var d=$.Deferred(),b=!0;$.when.apply($,c).done(n.bind(function(){var b=[];n.each(arguments,function(a){b=b.concat(a)});this._annotData.annotations=b;d.resolve(b)},this)).fail(n.bind(function(a){h.i18n.loadBundle("viewer",function(){h.emit("error.SEVERE",h.i18n.t("AnnOpenError",""),a)});b=!1;d.reject()},this)).always(n.bind(function(){this._fireOnAnnotationsAvailableCallbacks(b)},this));return d.promise()},i.prototype._getAnnotationsFromURL=
function(a,c,g){var b=$.Deferred(),f;h.ajax(a,n.extend({success:n.bind(function(a){if(a){var c=a.getElementsByTagName("status");if(c[0]&&(c=c[0].getElementsByTagName("value"),c[0]&&"-1"===d.textContent(c[0]))){b.reject();return}}f=this._parseAnnotationData(a,this._annotData.annotations,g);b.resolve(f)},this),error:n.bind(function(a){try{var c=(new DOMParser).parseFromString(a.responseText,"text/xml");f=this._parseAnnotationData(c,this._annotData.annotations,g);b.resolve(f);return}catch(e){}b.reject(a.responseText)},
this)},c));return b.promise()},i.prototype._getUserAnnotations=function(a){a=o.ViewServer("getannotations.jsp",a);return this._getAnnotationsFromURL(a,{},k.AnnotationOriginTypes.user.id)},i.prototype._hasGVAnnotations=function(){return this.hasAnnotations(k.AnnotationOriginTypes.artwork.id)||this.hasAnnotations(k.AnnotationOriginTypes.braille.id)||this.hasAnnotations(k.AnnotationOriginTypes.barcode.id)||this.hasAnnotations(k.AnnotationOriginTypes.text.id)||this.hasAnnotations(k.AnnotationOriginTypes.spelling.id)||
this.hasAnnotations(k.AnnotationOriginTypes.ext.id)||this.hasAnnotations(k.AnnotationOriginTypes.editor.id)||this.hasAnnotations(k.AnnotationOriginTypes.acrobat.id)},i.prototype._getGVAnnotations=function(a){this.getDocumentVersion().isMultiPage()&&(a.fmp=1,a.page=this.getPagenum()-1);a.afs=1;var a=o.ViewServer("getannotations.jsp",a),c=$.Deferred();this._getAnnotationsFromURL(a).done(function(a){c.resolve(a)}).fail(function(){c.resolve([])});return c},i.prototype._parseAnnotationData=function(a,
c,d){this._initAnnotationModule();var b={};if(!a)return[];var i=[];try{var m=a.getElementsByTagName("annots"),j,l;m&&1<=m.length&&(j=a.getElementsByTagName("annots")[0]);j&&(l=j.firstChild);var n={};if(null!=c)for(a=0;a<c.length;a++)c[a].runThroughAnnotation(!0,!0,!0,function(a){n[a.name]=a});for(var c={},o;l;){if(1===l.nodeType){var q=l.getAttribute("name"),a=null;n[q]?(a=n[q],a.replies=[],a.links=[],a.states=[],a.resetUnsavedReply(),a.cancelModified(),a._scaling=null,delete n[q]):(o=this._getAnnotationSourceFromXML(l,
d),a=o===k.AnnotationOriginTypes.user.id?new f(h):this._createAnnotation(o));o=a.originType;b[o]=b[o]?++b[o]:1;a.initWithXML(l,{trimboxOffset:this.getAnnotationsOffset(),mediaboxOffest:this.getAnnotationsOffset(!0)},b[o]);c[a.name]=a}l=l.nextSibling}var n=null,w;for(w in c)if(c.hasOwnProperty(w)){var t=c[w];if(t.inreplyto){var y=c[t.inreplyto];y&&(t.parent=y,t.state?y.states.push(t):y.replies.push(t))}else t.linkedto?c[t.linkedto]&&(c[t.linkedto].links.push(t),i.push(c[w]),t.parent=c[t.linkedto],
t.messagenumber=t.parent.messagenumber,t.updateIndicator()):i.push(c[w])}}catch(z){h.i18n.loadBundle("viewer",function(){h.emit("error.SEVERE",h.i18n.t("AnnDisplayError"),z)})}return i},i.prototype._getAnnotationSourceFromXML=function(a,e){if(e)return e;var g=d.attributeValue(a,g);if(g){if(c.startsWith(g,"GVBarcode")||c.startsWith(g,"Barcode"))return k.AnnotationOriginTypes.barcode.id;if(c.startsWith(g,"GVBraille")||c.startsWith(g,"BrailleProof"))return k.AnnotationOriginTypes.braille.id;if(c.startsWith(g,
"GVSpell"))return k.AnnotationOriginTypes.spelling.id;if(c.startsWith(g,"GVArtwork"))return k.AnnotationOriginTypes.artwork.id;if(c.startsWith(g,"GVText"))return k.AnnotationOriginTypes.text.id;if(c.startsWith(g,"Global Vision")){var b=d.attributeValue(a,b);if(b){if(c.endsWith(b,"Spelling"))return k.AnnotationOriginTypes.spelling.id;if(c.endsWith(b,"Change"))return k.AnnotationOriginTypes.text.id;if(c.endsWith(b,"Difference"))return k.AnnotationOriginTypes.artwork.id}}}if(g=d.attributeValue(a,"source"))if(b=
g.lastIndexOf("-"),0<b)return g.substr(b+1,g.lastIndexOf(".")-b-1);return k.AnnotationOriginTypes.ext.id},i.prototype._createAnnotation=function(a){return new l(h,a)},i.prototype.getAnnotations=function(){this._initAnnotationModule();return this._annotData.annotations},i.prototype.getAnnotationsOffset=function(a){var c=this.f.getModule("viewport"),d=this.getRotation()%360,b=this.isFlipped(),c=c.getWorldBounds(),f=this.getPageSize();if(this.hasGraphics())return a=a?this.getMediaBoxRect():this.getTrimboxRect(),
d=!b&&0===d||b&&90===d?a.bottomleft():!b&&90===d||b&&180===d?a.topleft():!b&&180===d||b&&270===d?a.topright():a.bottomright(),new j.Size(d.x,-(c.size.height-d.y));if(this.hasCad()){a=new j.Point;this.getCad()&&this.getCad().getLocation()&&(a=this.getCad().getLocation().origin.copy());if(!b&&0===d)a.y+=f.height;else if(b||90!==d)!b&&180===d?a.x+=f.width:b||(a.x+=f.height,a.y+=f.width);b&&90===d?a.y+=f.width:b&&180===d||(b&&270===d?a.x+=f.height:b&&(a.x+=f.width,a.y+=f.height));return new j.Size(a.x,
-(c.size.height-a.y))}return new j.Size},i.prototype.saveAnnotations=function(a,c,d){var b=document.implementation.createDocument("http://ns.adobe.com/xfdf/","xfdf",null);try{b.characterSet="UTF-8"}catch(f){}try{b.charset="UTF-8"}catch(i){}var m=document.createElementNS(null,"annots");b.documentElement.appendChild(m);for(var k=[],j=[],l=0;l<a.length;l++)a[l].isNew?k.push(a[l]):j.push(a[l]),m.appendChild(a[l].toXML(b));var q=[];c&&0<c.length&&n.each(c,function(a){a.runThroughAnnotation(!0,!0,!0,function(a){q.push(a.name)})});
a={};this.get("file")?a.file=this.get("file"):this.get("cad")&&(a.cad=this.get("cad"),a.style=this.get("style"));q&&0<q.length&&(a.remove=q);m=o.ViewServer("changeannotations.jsp",a);b=[this._getAnnotationsFromURL(m,{processData:!1,contentType:"text/xml; charset=UTF-8",data:b,type:"POST"})];this._hasGVAnnotations()&&b.push(this._getGVAnnotations(a));$.when.apply($,b).done(n.bind(function(){var a=[];n.each(arguments,function(b){a=a.concat(b)});this._annotData.annotations=a;this._fireOnAnnotationsAvailableCallbacks(!0);
this._processAfterParsingSavedAnnotations(k,j,c,d)},this)).fail(n.bind(function(a){h.i18n.loadBundle("viewer",function(){h.emit("error.SEVERE",h.i18n.t("AnnSaveError",""),a)})},this))},i.prototype._processAfterParsingSavedAnnotations=function(a,c,d,b){var f=this.getAnnotations(),i=n.pluck(f,"originType"),m={};n.each(i,function(a){m[a]=!0});this.setHasAnnotations(0<n.size(f),m);this.reportAnnotations(a,c,d,function(a){b&&b(f);a&&((a=h.getProperty("annotationcallbackurl"))&&h.ajax(a,{dataType:void 0,
noAjaxParam:!0}),h.i18n.loadBundle("viewer",function(){h.emit("userMessage","success",h.i18n.t("AnnotationsSaved"),!0)}))})},i.prototype.reportAnnotations=function(a,c,d,b){var f=0;a&&(f+=a.length);c&&(f+=c.length);d&&(f+=d.length);0===f&&b(!0);var m=0,i=!0,k=function(a){a||(i=!1);m++;m===f&&b&&b(i)};h.i18n.loadBundle("viewer",n.bind(function(){a&&n.each(a,function(a){a.cancelModified();this.alertOnAnnotationAdded(a,k)},this);c&&n.each(c,function(a){a.cancelModified();this.alertOnAnnotationModified(a,
k)},this);d&&n.each(d,function(a){this.alertOnAnnotationDelete(a,k)},this)},this))},i.prototype.alertOnAnnotationAdded=function(a,c){var d=a.date.getTime()==a.creationdate.getTime(),b=m(a),d=h.i18n.t(d?"AnnCommAdded":"AnnCommAdded2",b,a.getStringContent(130),a.getUserName(),h.i18n.d("AnnCommDate",a.creationdate),h.i18n.d("AnnCommDate",a.date));this.getDocumentVersion().isMultiPage()&&(d=h.i18n.t("PagesString",this.getPagenum(),this.getPagenum(),this.getDocumentVersion().getPageCount())+d);this.updateApprovalState(d,
c)},i.prototype.alertOnAnnotationDelete=function(a,c,d){if(!d&&a.replies&&0<a.replies.length){var b=n.after(a.replies.length,n.bind(function(){this.alertOnAnnotationDelete(a,c,!0)},this));n.each(a.replies,function(a){this.alertOnAnnotationDelete(a,b)},this)}else{var d=a.date.getTime()==a.creationdate.getTime(),f=m(a),d=h.i18n.t(d?"AnnCommDeleted":"AnnCommDeleted2",f,a.getStringContent(130),h.getCurrentUser().getFullName(),a.getUserName(),h.i18n.d("AnnCommDate",new Date),h.i18n.d("AnnCommDate",a.creationdate),
h.i18n.d("AnnCommDate",a.date));this.getDocumentVersion().isMultiPage()&&(d=h.i18n.t("PagesString",this.getPagenum(),this.getPagenum(),this.getDocumentVersion().getPageCount())+d);this.updateApprovalState(d,c)}},i.prototype.alertOnAnnotationModified=function(a,c){var d=m(a),d=h.i18n.t("AnnCommModded",d,a.getStringContent(130),h.getCurrentUser().getFullName(),a.getUserName(),h.i18n.d("AnnCommDate",a.creationdate),h.i18n.d("AnnCommDate",new Date));this.getDocumentVersion().isMultiPage()&&(d=h.i18n.t("PagesString",
this.getPagenum(),this.getPagenum(),this.getDocumentVersion().getPageCount())+d);this.updateApprovalState(d,c)},i.prototype.updateApprovalState=function(a,c){var d={approvalcomments:a,projectid:this.getDocument().get("projectid"),docid:this.getDocument().get("docid"),docversionid:this.get("pageDocversionid"),pageno:this.getPagenum()};void 0!==this.get("pageindex")&&(d.pageindex=this.get("pageindex"));void 0!==this.get("pagename")&&(d.pagename=this.get("pagename"));var b=o.WebCenter("updateapprovalstate.jsp");
h.ajax(b,{success:function(){c&&c(!0)},error:function(a,b,d){h.i18n.loadBundle("viewer",function(){h.emit("error.SEVERE",h.i18n.t("DocumentHistoryUpdateError"),a,b,d)});c&&c(!1)},data:d,type:"POST"})}):h.emit("error.SEVERE","Can't initialize Annotations on a non-webcenter data-adapter")}});
define("web-viewer/annotation/AnnotationNoteDrawTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/annotation/Annotation web-viewer/annotation/AnnotationConstants web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(f,l,i,j,d,c,k){var n=function(h,m,n){l.call(this,h,k.TOOLS.ANNOTATION_NOTE_DRAW);this.drawLinkedAnnotation=!1;this._annotationModel=m;this._annotationModule=n;this.setAnnotationColor=function(a){h.getCurrentUser().setColor("PREFERENCES_ANNOTATION_NOTE_COLOR",
a)};this.getAnnotationColor=function(){return h.getProperty("annotationcolor")?h.getProperty("annotationcolor"):h.getCurrentUser().getColor("PREFERENCES_ANNOTATION_NOTE_COLOR")};this.getDefaultCursor=function(){return"cursor-drawComment"};var a=f.bind(function(a){if(a=this._widget.requestView(a))if(a=a.getLayer("Annotations"))return a;return null},this);this.registerState("default",{contextmenu:function(a){a.preventDefault();a.stopPropagation();return!1},click:f.bind(function(e){var g=a(e);if(g){var e=
this.keepPointWithinWorldBounds(this.getWorldPoint(e),!0),e=new i.Rect(e,new i.Size),b=new j(h);b.initAnnotation(d.AnnotationType.ANNOT_PIN,this.getAnnotationColor(),!1,m);e=g.getWorldRectFromScene(e);e.origin.x=c.parseFloat(e.origin.x.toFixed(2));e.origin.y=c.parseFloat(e.origin.y.toFixed(2));b.rect=e;this._annotationModel.getPage().isReaderSpread()?this._annotationModule.promptIfAnnotationOutsidePage(b.rect,f.bind(function(){this.addAnnotation(b)},this),function(){b=null}):this.addAnnotation(b)}},
this)});this.canBeInterrupted=function(){return!0};this.activeKeyEvents=[];this.persistentKeyEvents=[];this._override("initialize",function(a,c){this._super(a,c);this.changeState("default");this.registerActiveEvents(["contextmenu","click"]);this.activeKeyEvents.push(["shift",f.bind(function(){this.drawLinkedAnnotation=!0},this),"keydown"]);this.activeKeyEvents.push(["shift",f.bind(function(){this.drawLinkedAnnotation=!1},this),"keyup"])});this._override("activate",function(a){this._super(a);m.setLockSelection(!0)});
this.canBeActivated=function(){return m.canChangeAnnotations()};this._override("deactivate",function(a){this._super(a);this.drawLinkedAnnotation=!1;m.setLockSelection(!1)});h.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATIONTOOLS_VISIBLE",f.bind(function(a,c){!c&&this.isActive()&&this.requestDeactivation()},this))};n.prototype=new l;n.prototype.constructor=n;n.prototype.addAnnotation=function(c){this.drawLinkedAnnotation?this._annotationModel.addLinkedAnnotation(c):(this._annotationModel.addAnnotation(c),
this.requestDeactivation())};return n});
define("web-viewer/annotation/AnnotationTouchDrawTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/utils/GEOUtils web-viewer/utils/DrawUtils web-viewer/utils/TouchUtil web-viewer/annotation/Annotation web-viewer/utils/LineworkPoint web-viewer/annotation/AnnotationConstants web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(f,l,i,j,d,c,k,n,h,m,o){j=function(a,c,g){l.call(this,a,o.TOOLS.ANNOTATION_TOUCH_DRAW);var b=void 0;this.drawLinkedAnnotation=
!1;this._annotationModel=c;this._annotationModule=g;this.setAnnotationType=function(){};this.getAnnotationType=function(){return h.AnnotationType.ANNOT_FREEFORM};this.setAnnotationColor=function(b){a.getCurrentUser().setColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR",b)};this.getAnnotationColor=function(){return a.getProperty("annotationcolor")?a.getProperty("annotationcolor"):a.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR")};this.getDefaultCursor=function(){return"cursor-drawAnnotation"};
var m=f.bind(function(a){if(a=this._widget.requestView(a))if(a=a.getLayer("Annotations"))return a;return null},this);this.registerState("default",{panstart:function(){},panmove:function(){},panend:function(){},canBeInterrupted:!0});this.registerState("draw",f.defaults({panstart:f.bind(function(d){this.requestCanvasLayer(d.pointers[0]);d=this.keepPointWithinWorldBounds(this.getWorldPoint(d.pointers[0]),!0);b=new k(a);b.initAnnotation(h.AnnotationType.ANNOT_FREEFORM,this.getAnnotationColor(),!1,c);
b.rect=new i.Rect(d,new i.Size);this.changeState("drawing")},this)},this.getState("default")));var j=f.bind(function(a){p();a||(b=null);b&&2===b.pointArray.length&&b.pointArray[0].x==b.pointArray[1].x&&b.pointArray[0].y==b.pointArray[1].y&&(b=null);if(null!==b&&(0===Math.abs(b.rect.size.width)||0>=Math.abs(b.rect.size.height)))b=null;if(b){var c=m(a);c?(b.rect=c.getWorldRectFromScene(b.rect),this._annotationModel.getPage().isReaderSpread()?this._annotationModule.promptIfAnnotationOutsidePage(b.rect,
f.bind(function(){this.createAnnotation(b,c)},this),function(){b=null}):this.createAnnotation(b,c)):b=null}this.changeState("draw")},this);this.createAnnotation=function(a,b){for(var d=0;d<a.pointArray.length;d++){var f=a.pointArray[d],h=new i.Point(f.x,f.y),h=b.getWorldPointFromScene(h);f.x=h.x;f.y=h.y}c.addAnnotation(a);this.requestDeactivation()};var s=f.throttle(f.bind(function(){var a=this.getCanvasCtx();if(a){var c=this.getCanvasSize();a.clearRect(0,0,c.width,c.height);b&&d.drawOverlay(this.f,
a,[b])}},this),40);this.registerState("drawing",f.defaults({enterState:function(){a.emit("viewport.startInteractive");a.emit("layout.disableTextSelection")},leaveState:function(){a.emit("viewport.stopInteractive");setTimeout(function(){a.emit("layout.enableTextSelection")},500)},panmove:f.bind(function(a){var c=b.rect.copy(),e=this.keepPointWithinWorldBounds(this.getWorldPoint(a.pointers[0]),!0),a=new n;if(0===b.pointArray.length)a.makeMoveTo(b.rect.origin.x,b.rect.origin.y);else{var d=b.pointArray[b.pointArray.length-
1];if(0>Math.abs(d.x-e.x)||0>Math.abs(d.y-e.y))return;a.makeLineTo(e.x,e.y)}b.pointArray.push(a);e=Math.abs(a.x-c.origin.x);a.x<c.origin.x?(e=Math.abs(c.origin.x-a.x),c.origin.x=a.x,c.size.width+=e):e>c.size.width&&(c.size.width=e);e=Math.abs(a.y-c.origin.y);a.y<c.origin.y?(e=Math.abs(c.origin.y-a.y),c.origin.y=a.y,c.size.height+=e):e>c.size.height&&(c.size.height=e);b.setRect(c,!0);s()},this),panend:function(a){j(a.pointers[0])},canBeInterrupted:!1},this.getState("default")));this.canBeInterrupted=
function(){return!1};this.activeKeyEvents=[];this.persistentKeyEvents=[];var p=f.bind(function(){this.releaseCanvasLayer()},this);this.canBeActivated=function(){return c.canChangeAnnotations()};a.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATIONTOOLS_VISIBLE",f.bind(function(a,b){!b&&this.isActive()&&this.requestDeactivation()},this))};j.prototype=Object.create(l.prototype);j.prototype.constructor=j;j.prototype.initialize=function(a,e){l.prototype.initialize.apply(this,arguments);this._touchUtil=
new c(a.getElement()[0]);this.changeState("default")};j.prototype.doActivation=function(){l.prototype.doActivation.call(this);this._annotationModel.setLockSelection(!0);this._touchUtil.addPanStartListener(f.bind(function(a){this.getCurrentState().panstart(a)},this));this._touchUtil.addPanMoveListener(f.bind(function(a){this.getCurrentState().panmove(a)},this));this._touchUtil.addPanEndListener(f.bind(function(a){this.getCurrentState().panend(a)},this));this.changeState("draw");this.drawLinkedAnnotation=
!1};j.prototype.doDeactivation=function(){l.prototype.doDeactivation.call(this);this.changeState("default");this.releaseCanvasLayer();this._touchUtil.removeAllListeners();this._annotationModel.setLockSelection(!1)};return j});
define("web-viewer/annotation/AnnotationTouchTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/utils/TouchUtil web-viewer/annotation/Annotation web-viewer/core/CoreConstants".split(" "),function(f,l,i,j,d,c){var k=function(d,h){l.call(this,d,c.TOOLS.ANNOTATION_TOUCH);this.f=d;this._annotationModel=h;this._defaultState="defaultState";this._annotationSelectedState="annotationSelectedState";this._annotationSelectedPanningState="annotationSelectedPanningState";this.registerState(this._defaultState,
function(c){return{enterState:function(){c._annotationModel.unselectAllAnnotations();c._activeAnnotation=null},panstart:function(){},panmove:function(){},panend:function(){},singletap:function(d){d=c.getScenePointFromTouch(d);d.view&&((d=c.getClosestAnnotation(d.view,d.point))?c._annotationModel.selectAnnotation(d):c._annotationModel.unselectAllAnnotations())}}}(this));this.registerState(this._annotationSelectedState,function(c){return f.defaults({enterState:function(){},panstart:function(d){var a=
c.getScenePointFromTouch(d);if(a.view){var e=c.getClosestAnnotation(a.view,a.point);c._activeAnnotation===e&&c._annotationModel.canChangeAnnotation(e)&&(c.changeState(c._annotationSelectedPanningState),c._previousPoint=c._getAnnotationLayer(a.view).getWorldPointFromScene(c.getScenePoint(d.pointers[0])),c.requestActivation())}},panmove:function(){},panend:function(){}},c.getState(c._defaultState))}(this));this.registerState(this._annotationSelectedPanningState,function(c){return{enterState:function(){c.f.emit("viewport.startInteractive");
c.f.emit("layout.disableTextSelection")},leaveState:function(){c.isActive()&&c.requestDeactivation();c.f.emit("viewport.stopInteractive");setTimeout(function(){c.f.emit("layout.enableTextSelection")},500)},panstart:function(){},panmove:function(d){if(c.isActive()){var a=c._widget.requestView(d.pointers[0]);if(a){var d=c._getAnnotationLayer(a).getWorldPointFromScene(c.getScenePoint(d.pointers[0])),e=c._widget.getWorld().getWorldBounds(),a=c._getAnnotationLayer(a).convertWorldRectToLayer(new i.Rect(new i.Point,
e.size));a.origin.y=-(a.size.height+a.origin.y)-e.origin.y;a.origin.x+=e.origin.x;a=c.keepMoveSizeWithinRect(a,c._activeAnnotation.rect,c._previousPoint.sizeTo(d));h.moveAnnotation(c._activeAnnotation,a);c._previousPoint=d}}else c.changeState(c._annotationSelectedState)},panend:function(){c.changeState(c._annotationSelectedState)}}}(this));this._annotationModel.on("unselectedAnnotation",f.bind(function(){this.changeState(this._defaultState)},this));this._annotationModel.on("selectedAnnotation",f.bind(function(c){c!=
this._activeAnnotation&&(this._activeAnnotation=c,this.changeState(this._annotationSelectedState))},this))};k.prototype=Object.create(l.prototype);k.prototype.constructor=k;k.prototype.getScenePointFromTouch=function(c){return this._touchUtil.getScenePointFromTouch(c,this._widget)};k.prototype.getClosestAnnotation=function(c,f){var i=c.getClosestLineworkFromPoint(f,["Annotations"],30);if(i){if(i instanceof d)return i;if(i.anchor&&i.linework instanceof d)return i.linework}return null};k.prototype.initialize=
function(c,d){l.prototype.initialize.apply(this,arguments);this._touchUtil=new j(c.getElement()[0]);this.changeState(this._defaultState);this._touchUtil.addSingleTapListener(f.bind(function(c){this.getCurrentState().singletap(c)},this));this._touchUtil.addPanStartListener(f.bind(function(c){this.getCurrentState().panstart(c)},this));this._touchUtil.addPanMoveListener(f.bind(function(c){this.getCurrentState().panmove(c)},this));this._touchUtil.addPanEndListener(f.bind(function(c){this.getCurrentState().panend(c)},
this))};k.prototype._getAnnotationLayer=function(c){return c&&(c=c.getLayer("Annotations"))?c:null};return k});
define("web-viewer/annotation/AnnotationToolbarComponent","component/toolbar/ToolbarComponent component/toolbar/ButtonGroup web-viewer/layout/component/ViewerToolbarButton web-viewer/layout/component/SubtoolbarButton web-viewer/layout/component/ColorPicker web-viewer/layout/LayoutConstants web-viewer/annotation/AnnotationConstants".split(" "),function(f,l,i,j,d,c,k){var n=function(h,m,n,a){f.call(this,c.ToolbarComponent.ANNOTATION,h);this.f=h;this.annotationModel=m;var e=new l("AnnotateGroup");e.setTitle(h.i18n,
"viewer","AnnBtnGroupTitle");this.addButtonGroup(e);var g=new i(h,"HideAnnotationsButton",h.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE")?"icon-WCR_Annotation-Hide":"icon-WCR_Annotation-Show",!0,function(){m.toggleVisibility()});g.setTooltip("viewer",h.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE")?"HideAnnotationsBtnTT":"ShowAnnotationsBtnTT");h.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATIONTOOLS_VISIBLE",function(a,b){b?(g.setTooltip("viewer","HideAnnotationsBtnTT"),g.setIcon("icon-WCR_Annotation-Hide")):
(g.setTooltip("viewer","ShowAnnotationsBtnTT"),g.setIcon("icon-WCR_Annotation-Show"));q()});e.addButton(g);var b=new i(h,"AnnotateButton","icon icon-WCR_Annotation-Global-cont icon-danger",!0,function(){m.toggleVisibility(!0)});b.setTooltip("viewer","AddAnnotationBtnTT");b.listenToTool(n,!0);e.addButton(b);h.getOption("PREFERENCES_ANNOTATION_TOOLMODE")!=k.ANNOT_PIN&&b.setIcon(k.AnnotationToolIcons[h.getOption("PREFERENCES_ANNOTATION_TOOLMODE")].icon,k.AnnotationToolIcons[h.getOption("PREFERENCES_ANNOTATION_TOOLMODE")].sub);
h.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_TOOLMODE",function(a,c){c!=k.ANNOT_PIN&&b.setIcon(k.AnnotationToolIcons[c].icon,k.AnnotationToolIcons[c].sub)});var r=new f("AnnotationSelectorSubtoolbar");b.addSubtoolbarComponent(r);var u=new l("AnnotateSubGroup");r.addButtonGroup(u);var s=void 0,p=new j(h,"RectangleButton",k.AnnotationToolIcons[k.AnnotationType.ANNOT_RECT].icon,!0,function(){n.setAnnotationType(k.AnnotationType.ANNOT_RECT);s&&s.setColor(n.getAnnotationColor())});p.listenToToolOption("annotationdrawtool",
"PREFERENCES_ANNOTATION_TOOLMODE",k.AnnotationType.ANNOT_RECT);p.setTooltip("viewer","AnnRectTT");p.setIcon(k.AnnotationToolIcons[k.AnnotationType.ANNOT_RECT].icon,k.AnnotationToolIcons[k.AnnotationType.ANNOT_RECT].sub);u.addButton(p);p=new j(h,"OvalButton","addOval",!0,function(){n.setAnnotationType(k.AnnotationType.ANNOT_ELLIPSE);s&&s.setColor(n.getAnnotationColor())});p.listenToToolOption("annotationdrawtool","PREFERENCES_ANNOTATION_TOOLMODE",k.AnnotationType.ANNOT_ELLIPSE);p.setTooltip("viewer",
"AnnOvalTT");p.setIcon(k.AnnotationToolIcons[k.AnnotationType.ANNOT_ELLIPSE].icon,k.AnnotationToolIcons[k.AnnotationType.ANNOT_ELLIPSE].sub);u.addButton(p);p=new j(h,"LineButton","addLine",!0,function(){n.setAnnotationType(k.AnnotationType.ANNOT_LINE);s&&s.setColor(n.getAnnotationColor())});p.listenToToolOption("annotationdrawtool","PREFERENCES_ANNOTATION_TOOLMODE",k.AnnotationType.ANNOT_LINE);p.setTooltip("viewer","AnnLineTT");p.setIcon(k.AnnotationToolIcons[k.AnnotationType.ANNOT_LINE].icon,k.AnnotationToolIcons[k.AnnotationType.ANNOT_LINE].sub);
u.addButton(p);p=new j(h,"ArrowButton","addArrow",!0,function(){n.setAnnotationType(k.AnnotationType.ANNOT_ARROW);s&&s.setColor(n.getAnnotationColor())});p.listenToToolOption("annotationdrawtool","PREFERENCES_ANNOTATION_TOOLMODE",k.AnnotationType.ANNOT_ARROW);p.setTooltip("viewer","AnnArrowTT");p.setIcon(k.AnnotationToolIcons[k.AnnotationType.ANNOT_ARROW].icon,k.AnnotationToolIcons[k.AnnotationType.ANNOT_ARROW].sub);u.addButton(p);p=new j(h,"FreeformButton","addFreehand",!0,function(){n.setAnnotationType(k.AnnotationType.ANNOT_FREEFORM);
s&&s.setColor(n.getAnnotationColor())});p.listenToToolOption("annotationdrawtool","PREFERENCES_ANNOTATION_TOOLMODE",k.AnnotationType.ANNOT_FREEFORM);p.setTooltip("viewer","AnnFreehandTT");p.setIcon(k.AnnotationToolIcons[k.AnnotationType.ANNOT_FREEFORM].icon,k.AnnotationToolIcons[k.AnnotationType.ANNOT_FREEFORM].sub);u.addButton(p);p=new j(h,"HighlightButton","addHighlight",!0,function(){n.setAnnotationType(k.AnnotationType.ANNOT_HIGHLIGHT);s&&s.setColor(n.getAnnotationColor())});p.listenToToolOption("annotationdrawtool",
"PREFERENCES_ANNOTATION_TOOLMODE",k.AnnotationType.ANNOT_HIGHLIGHT);p.setTooltip("viewer","AnnHighlightTT");p.setIcon(k.AnnotationToolIcons[k.AnnotationType.ANNOT_HIGHLIGHT].icon,k.AnnotationToolIcons[k.AnnotationType.ANNOT_HIGHLIGHT].sub);u.addButton(p);u=new l("AnnotateSubGroupGlobAction");r.addButtonGroup(u);p=new j(h,"GlobalAnnotation","addGlobalAnnotation",!0,function(a){n.setAnnotationType(k.AnnotationType.ANNOT_RECT);n.addGlobalAnnotation(a)});p.setTooltip("viewer","AnnNewRectGlobal");p.setIcon("icon-WCR_Annotation-Global-cont icon-danger",
["icon icon-WCR_Annotation-Global-sub icon-white"]);u.addButton(p);h.getProperty("annotationcolor")||(u=new l("AnnotateSubGroupColor"),r.addButtonGroup(u),s=new d(function(a){n.setAnnotationColor("#"+a)}),h.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_RECTANGLE_COLOR",function(){s.setColor(h.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR"))}),s.setColor(h.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR")),r=new j(h,"ColorSelector",s.element,!0),
r.setTooltip("viewer","AnnColorDefaultRect"),p=new j(h,"ColorReset","icon icon-WCR_WF-Undo",!0,_.bind(function(){h.resetOption("PREFERENCES_ANNOTATION_RECTANGLE_COLOR");this.askToChangeAnnotationColors()},this)),p.setIcon("icon icon-WCR_WF-Undo"),p.setTooltip("viewer","AnnResetDefaultColor"),u.addButton(r),u.addButton(p));var v=new i(h,"CommentButton","addComment",!0,function(){m.toggleVisibility(!0)});v.listenToTool(a,!0);v.setTooltip("viewer","AnnCommNote");v.setIcon("icon icon-WCR_Annotation-Note-sub");
e.addButton(v);if(!h.getProperty("annotationcolor")){r=new f("AnnotationNoteSelectorSubtoolbar");v.addSubtoolbarComponent(r);e=new l("AnnotateNoteSubGroup");r.addButtonGroup(e);var x=new d(function(b){a.setAnnotationColor("#"+b)});h.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_NOTE_COLOR",function(){x.setColor(a.getAnnotationColor())});x.setColor(a.getAnnotationColor());r=new j(h,"ColorSelector",x.element,!0);r.setTooltip("viewer","AnnColorDefaultNote");u=new j(h,"ColorReset","icon icon-WCR_WF-Undo",
!0,_.bind(function(){h.resetOption("PREFERENCES_ANNOTATION_NOTE_COLOR");this.askToChangeAnnotationColors()},this));u.setTooltip("viewer","AnnResetNoteColor");e.addButton(r);e.addButton(u)}var q=function(){if(m.canChangeAnnotations(!0))b.setEnabled(!0),v.setEnabled(!0);else{var c="";0<m.getDisabledReason().length&&(c=m.getDisabledReason());b.setDisabledTooltip(c);v.setDisabledTooltip(c);n.isActive()&&n.requestDeactivation();a.isActive()&&a.requestDeactivation();b.setEnabled(!1);v.setEnabled(!1)}g.setEnabled(!m.isTemporarilyDisabledAndNoAnnotationsVisible())};
q();m.on("readWriteChanged",q);m.on("temporarilyDisableChanged",q);m.on("disabledReasonChanged",q)};n.prototype=Object.create(f.prototype);n.prototype.constructor=n;n.toolbarName=c.ToolbarComponent.ANNOTATION;n.prototype.askToChangeAnnotationColors=function(){this.f.i18n.loadBundle("viewer",_.bind(function(){confirm(this.f.i18n.t("AnnUpdateColors"))&&this.annotationModel.updateAllAnnotationColors()},this))};return n});
define("web-viewer/annotation/AnnotationTouchToolbarComponent",["component/toolbar/ToolbarComponent","component/toolbar/ButtonGroup","web-viewer/layout/component/ViewerToolbarButton","web-viewer/layout/LayoutConstants"],function(f,l,i,j){var d=function(c,d,n){f.call(this,j.ToolbarComponent.ANNOTATION,c);this.f=c;this.annotationModel=d;var h=new l("AnnotateGroup");h.setTitle(c.i18n,"viewer","AnnBtnGroupTitle");this.addButtonGroup(h);var m=new i(c,"AnnotateButton","icon-WCR_Add",!0,function(){d.toggleVisibility(!0)});
m.listenToTool(n,!0);h.addButton(m);c=function(){if(d.canChangeAnnotations(!0))m.setEnabled(!0);else{var c="";0<d.getDisabledReason().length&&(c=d.getDisabledReason());m.setDisabledTooltip(c);n.isActive()&&n.requestDeactivation();m.setEnabled(!1)}};c();d.on("readWriteChanged",c);d.on("temporarilyDisableChanged",c);d.on("disabledReasonChanged",c)};d.prototype=Object.create(f.prototype);d.prototype.constructor=d;d.toolbarName=j.ToolbarComponent.ANNOTATION;return d});
define("web-viewer/annotation/AnnotationModule","underscore web-viewer/core/AbstractModule web-viewer/annotation/AnnotationModel web-viewer/annotation/AnnotationLayerModel web-viewer/annotation/AnnotationPopupsLayerModel web-viewer/annotation/AnnotationTool web-viewer/annotation/AnnotationDrawTool web-viewer/annotation/AnnotationIndicatorTool web-viewer/annotation/AnnotationWidget utils/Transformation utils/ShapeUtils web-viewer/annotation/AnnotationDataExtensions web-viewer/annotation/AnnotationNoteDrawTool web-viewer/annotation/AnnotationTouchDrawTool web-viewer/annotation/AnnotationTouchTool web-viewer/annotation/AnnotationToolbarComponent web-viewer/annotation/AnnotationTouchToolbarComponent web-viewer/annotation/AnnotationConstants web-viewer/layout/component/ModalPopup web-viewer/layout/LayoutConstants web-viewer/utils/ListenerUtil".split(" "),
function(f,l,i,j,d,c,k,n,h,m,o,a,e,g,b,r,u,s,p,v,x){m=function(d,j){function m(a){var b=p().createInverse();return new o.Rect(b.transformedPoint(a.origin),b.transformedSize(a.size))}l.call(this,d,j,"annotation");x.mixin(this,d);this.annotationModel=new i(this.f,"annotation");this.layerModels={};a(d);this._drawTool=new k(d,this.annotationModel,this);this._noteDrawTool=new e(d,this.annotationModel,this);this._indicatorTool=new n(d,this.annotationModel);this._publishTool(this._indicatorTool);this.f.isMobile()?
(this._touchDrawTool=new g(d,this.annotationModel,this),this._publishTool(this._touchDrawTool),this._selectTool=new b(d,this.annotationModel)):(this._publishTool(this._drawTool),this._publishTool(this._noteDrawTool),this._selectTool=new c(d,this.annotationModel));this._publishTool(this._selectTool);this._annotateComponent=null;this._publishToolbarComponent(r.toolbarName,f.bind(function(a){return this._annotateComponent=a===v.LayoutType.MOBILE?new u(d,this.annotationModel,this._touchDrawTool):new r(d,
this.annotationModel,this._drawTool,this._noteDrawTool)},this));this._annotationWidget=null;this._publishWidget(h.widgetName,f.bind(function(a){this.annotationModel.setLayoutType(a);return this._annotationWidget=new h(d,this,this.annotationModel,a)},this));this.on("highlightAnnotation",f.bind(function(a){this.annotationModel.selectAnnotation(a,!0);this._indicatorTool.setAnnotation(a);d.emit("toolManager.request.activation","annotationindicatortool")},this));this.on("duplicateAnnotation",f.bind(function(a){a.getPermissionFor(s.ActionPermissions.DUPLICATE)&&
(this.annotationModel.getAnnotationFilterModel().setOriginType(s.AnnotationOriginTypes.user.id),this._duplicateAnnotation(a,!1,!1,!0,!0))},this));this.on("duplicateWithoutText",f.bind(function(a){a.getPermissionFor(s.ActionPermissions.DUPLICATE_WITHOUT_TEXT)&&(this.annotationModel.getAnnotationFilterModel().setOriginType(s.AnnotationOriginTypes.user.id),this._duplicateAnnotation(a,!1,!1,!0,!0,!0))},this));this.on("duplicateAllFilteredAnnotations",f.bind(function(){var a=f.filter(this.annotationModel.getFilteredAnnotations(),
function(a){return a.getPermissionFor(s.ActionPermissions.DUPLICATE)});0<a.length&&(this.annotationModel.getAnnotationFilterModel().setOriginType(s.AnnotationOriginTypes.user.id),f.each(a,function(a){this._duplicateAnnotation(a,!1,!1,!0,!0,!1,!0)},this),this.annotationModel.modelChanged(),this.annotationModel.modelContentChanged())},this));this.on("duplicateAllFilteredAnnotationWithoutText",f.bind(function(){var a=f.filter(this.annotationModel.getFilteredAnnotations(),function(a){return a.getPermissionFor(s.ActionPermissions.DUPLICATE_WITHOUT_TEXT)});
0<a.length&&(this.annotationModel.getAnnotationFilterModel().setOriginType(s.AnnotationOriginTypes.user.id),f.each(a,function(a){this._duplicateAnnotation(a,!1,!1,!0,!0,!0,!0)},this),this.annotationModel.modelChanged(),this.annotationModel.modelContentChanged())},this));this.on("zoomToAnnotation",f.bind(function(a){var b={},c=a.rect.copy();3!==d.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")&&(c=a.getOutliningRect());var e=null;20>Math.abs(c.size.width)&&(e=(20-c.size.width)/2,c.origin.x-=e,c.size.width=
20);20>Math.abs(c.size.height)&&(e=(20-c.size.height)/2,c.origin.y-=e,c.size.height=20);b.rect=p().transformedRect(c);b.constrain=!0;b.animated=!0;this.annotationModel.ensureVisibility();this.annotationModel.getLayoutType()!==v.LayoutType.MOBILE&&this.annotationModel.selectAnnotation(a,!0);d.emit("viewport.fitInRect",b)},this));this.on("temporarilyDisable",f.bind(function(a,b,c,d){this.annotationModel.temporarilyDisable(a,b,c,d)},this));var p=f.bind(function(){return this.layerModels.AnnotationLayer.getTransform().copy()},
this);this.on("createAnnotation",f.bind(function(a,b,c){void 0===c&&(c=s.AnnotationType.ANNOT_RECT);this.annotationModel.addAnnotationWithRect(m(a),b,c)},this));this._registerListener("intercept.activePageChange",function(a){var b=a.newActivePage,c=a.oldActivePage;b!==c&&this.promptToSaveUnsavedAnnotations(f.bind(function(){this.f.getDocumentController().changeActivePage(b)},this),f.bind(function(){},this),f.bind(function(){this.annotationModel.resetAllAnnotations();this.f.getDocumentController().changeActivePage(b)},
this))&&(a.newActivePage=c)},this);this._registerListener("viewControls.compensationChanged",function(){if(this.annotationModel){var a=this.annotationModel.getAnnotationsPage();a!==this.f.getDocumentController().getDifferencePage()&&(a=a.getCurrentScaling(),this.annotationModel.scaleAllAnnotations(a))}},this,this.f);this._registerListener("filterStateChanged",function(a){a?this.f.setOption("ANNOTATION_FILTER",this.annotationModel.getAnnotationFilterModel().getFilterState()):this.f.resetOption("ANNOTATION_FILTER")},
this,this.annotationModel.getAnnotationFilterModel());this._registerListener("annotationAdded",function(a){this.f.isMobile()||this._save3DView(a)},this,this.annotationModel);this.on("update3DView",f.bind(function(a){this._save3DView(a)},this));this.on("delete3DView",f.bind(function(a){this._save3DView(a,!0)},this));this.on("show3DView",f.bind(function(a){this._show3DView(a)},this));this._registerListener("selectedAnnotation",function(a){this.annotationModel.getLayoutType()!==v.LayoutType.MOBILE&&
this._show3DView(a.getGodfather(),!1)},this,this.annotationModel);this.f.whenModuleAvailable("view3D",f.bind(function(a){a.on("3DWidget.enabled",f.bind(function(){this.annotationModel.modelContentChanged()},this))},this));this.f.getDocumentController().whenActiveOrDifferencePageChangedAndParametersAvailable(this._whenActiveOrDifferencePageChangedAndParametersAvailable,this);this.f.getDocumentController().whenActiveOrDifferencePageChangedAndParametersAvailableOrChange(this._whenActiveOrDifferencePageChangedAndParametersAvailableOrChange,
this)};m.prototype=Object.create(l.prototype);m.prototype.constructor=m;m.prototype._show3DView=function(a,b){var c=this.f.getModule("view3D"),d=a.get3DViewPosition();c&&d&&(this.annotationModel.getLayoutType()===v.LayoutType.MOBILE?c.show3D(d):c.setCameraPosition(d),(void 0===b||b)&&this.annotationModel.selectAnnotation(a,!0))};m.prototype._save3DView=function(a,b){if(a.getGodfather()===a)if(b)a.set3DViewPosition(null),this.annotationModel.selectAnnotation(a,!0),this.annotationModel.modelChanged(a);
else{var c=this.f.getModule("view3D");if(c&&(c=c.getCameraPosition()))a.set3DViewPosition(c),this.annotationModel.selectAnnotation(a,!0),this.annotationModel.modelChanged(a)}};m.prototype.hasUnsavedElements=function(){return 0<this.annotationModel.getUnsavedAnnotationCount()};m.prototype.saveAllUnsavedElements=function(a){this.annotationModel.save(null,a)};m.prototype._whenActiveOrDifferencePageChangedAndParametersAvailableOrChange=function(a,b){if(void 0===this.layerModels.AnnotationLayer){this.layerModels.AnnotationLayer=
new j(this.f,"Annotations",this.annotationModel);this.layerModels.AnnotationPopupsLayer=new d(this.f,"AnnotationPopups",this.annotationModel);var c=this.f.getModule("viewport");c.addLayer("Annotations",this.layerModels.AnnotationLayer);c.addLayer("AnnotationPopups",this.layerModels.AnnotationPopupsLayer,"Main")}this.annotationModel.isTemporarilyDisabled()?this.annotationModel.isTemporarilyCurrentPageAnnotationsShown()?(this.annotationModel.setPage(a),this.annotationModel.modelChanged()):this.annotationModel.isTemporarilyDifferencePageAnnotationsShown()&&
(this.annotationModel.setPage(b),this.annotationModel.modelChanged()):this.annotationModel.setPage(a)};m.prototype._whenActiveOrDifferencePageChangedAndParametersAvailable=function(a){this._annotateComponent&&(a.isBlankPage()?this._annotateComponent.hide():this._annotateComponent.show())};m.prototype.toggleDifferencePageAnnotations=function(a){void 0===a&&(a=!this.annotationModel.isTemporarilyDifferencePageAnnotationsShown());a?(this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",1,!0),this.annotationModel.showTemporarilyDifferencePageAnnotations()):
this.annotationModel.hideTemporarilyAnnotations()};m.prototype.toggleCurrentPageAnnotations=function(a){void 0===a&&(a=!this.annotationModel.isTemporarilyCurrentPageAnnotationsShown());a?(this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",1,!0),this.annotationModel.showTemporarilyActivePageAnnotations()):this.annotationModel.hideTemporarilyAnnotations()};m.prototype.getUnsavedElementsName=function(){return this.f.i18n.t("Annotations")};m.prototype.isTemporarilyCurrentPageAnnotationsShown=function(){return this.annotationModel.isTemporarilyCurrentPageAnnotationsShown()};
m.prototype.isTemporarilyDifferencePageAnnotationsShown=function(){return this.annotationModel.isTemporarilyDifferencePageAnnotationsShown()};m.prototype.getState=function(){return{annotationModel:{temporarilyDisabled:{temporarilyDisabled:this.annotationModel.isTemporarilyDisabled(),temporarilyCurrentPageAnnotationsShown:this.annotationModel.isTemporarilyCurrentPageAnnotationsShown(),temporarilyDifferencePageAnnotationsShown:this.annotationModel.isTemporarilyDifferencePageAnnotationsShown(),temporarilyDisabledMessage:this.annotationModel.getTemporarilyDisabledMessage(),
temporaryAnnotationDocumentTogglingEnabled:this.annotationModel.isTemporarilyAnnotationDocumentTogglingEnabled()},annotationVisibility:1==this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE"),filter:this.annotationModel.getAnnotationFilterModel().getFilterState()}}};m.prototype.setState=function(a){this.f.whenModuleAvailable("annotation",function(){if(void 0!==a){var b=a.annotationModel;a.disableSelectTool&&(this._selectTool=null,this._unpublishTool("annotationtool"),this._indicatorTool=null,this._unpublishTool("annotationindicatortool"));
if(void 0!==b){var c=b.temporarilyDisabled;void 0!==c&&(this.annotationModel.temporarilyDisable(c.temporarilyDisabled,c.temporaryAnnotationDocumentTogglingEnabled,c.temporarilyDisabledMessage),c.temporarilyCurrentPageAnnotationsShown?this.annotationModel.showTemporarilyActivePageAnnotations():c.temporarilyDifferencePageAnnotationsShown&&this.annotationModel.showTemporarilyDifferencePageAnnotations());this.annotationModel.toggleVisibility(b.annotationVisibility);b.filter&&this.annotationModel.getAnnotationFilterModel().setFilterState(b.filter)}}},
this)};m.prototype.promptToSaveUnsavedAnnotations=function(a,b,c){return this.annotationModel.promptToSaveUnsavedAnnotations(a,b,c)};m.prototype.promptIfAnnotationOutsidePage=function(a,b,c,d){var e=this.f.getDocumentController().getActivePage(),h=!0;e.hasCad()||(h=e.isRectOnPage(a));if(h)b();else{var g=new p(this.f,"annotationOnOtherPage",this.f.getContext());g.setRemoveFromDomAfterUsage(!0);g.setOkAction(f.bind(function(){b(d);g.hide()},this));g.setCancelAction(f.bind(function(){c()},this));g.setHeader($("<span/>").addClass("popupTitle").text(this.f.i18n.t("AnnSaveTitle")));
g.setContent($("<div/>").addClass("unsavedItemsContent").text(this.f.i18n.t("AnnSaveOutsidePrompt")));g.setOkBtnText(this.f.i18n.t("YesResponse"));g.setCancelBtnText(this.f.i18n.t("NoResponse"));g.show()}};m.prototype.reload=function(){this.annotationModel.reload(!0)};m.prototype.disableAnnotations=function(a,b,c){a?this.annotationModel.setDisableReason(b,c,!0,!0):this.annotationModel.removeDisableReason(b)};m.prototype._duplicateAnnotation=function(a,b,c,d,e,g,h){var i=a.getGodfather().duplicate(b,
c,d,e,this.annotationModel);g&&(i.content="");a.inreplyto&&(i.content=f.clone(a.content));a=null;a=i.getType()==s.AnnotationType.ANNOT_PIN?this._noteDrawTool.getAnnotationColor():this._drawTool.getAnnotationColor();i.setColor(a);this.annotationModel.unselectAllAnnotations(!0,!0);this.annotationModel.addAnnotation(i,!1,h);0<i.links.length&&f.each(i.links,function(a){a.messagenumber=i.messagenumber;this.annotationModel.addAnnotation(a)},this);i.setColor(a);h||this.annotationModel.modelChanged(i)};return m});