/**
		 * Check licenses for barcode and braille
		 * @returns {$.Deferred.<Boolean, Boolean>} Two parameters where the first one if true indicates has barcode license 
		 *                                          and second one if true indicates has braille license
		 */

/**
		 * Get the ServerInfo flags (can be used for checking licenses)
		 * @return {$.Deferred.<Number>} Flags number. 0 if something went wrong.
		 */

define("web-viewer/measure/Ruler","web-viewer/utils/LineworkWrapper web-viewer/utils/LineworkPoint utils/ShapeUtils web-viewer/utils/ViewerUtils web-viewer/utils/DrawUtils web-viewer/measure/MeasureConstants underscore".split(" "),function(b,a,d,g,h,f){var e=function(a){this.f=a;this.rulerType=1;this.endPoint=this.startPoint=null};e.prototype.reset=function(){this.endPoint=this.startPoint=null};e.prototype.snapToClosestAngle=function(a){if(0===this.rulerType){var c=this.getLength(),b=g.closestAngle(this.getAngle(),
8);a?(this.startPoint.x=this.endPoint.x-c*Math.cos(b*Math.PI/180),this.startPoint.y=this.endPoint.y-c*Math.sin(b*Math.PI/180)):(this.endPoint.x=c*Math.cos(b*Math.PI/180)+this.startPoint.x,this.endPoint.y=c*Math.sin(b*Math.PI/180)+this.startPoint.y)}};e.prototype.getLength=function(){if(this.endPoint&&this.startPoint){var a=Math.abs(this.endPoint.x-this.startPoint.x),c=Math.abs(this.endPoint.y-this.startPoint.y);return Math.sqrt(a*a+c*c)}return 0};e.prototype.getAngle=function(){return 180*Math.atan2(this.endPoint.y-
this.startPoint.y,this.endPoint.x-this.startPoint.x)/Math.PI};e.prototype.getLinework=function(){return this.endPoint&&this.startPoint?0===this.rulerType?this.getRulerLinework():this.getSquareLinework():[]};e.prototype.getSquareLinework=function(){var e=[];if(this.startPoint&&this.endPoint){var c=new b;c.fillcolor="rgba(0, 0, 0, 0.30)";c.color="rgba(0, 0, 0, 1.00)";c.linewidth=1;c.type=h.LWTYPE_RECT;var j=new a;j.makeMoveTo(this.startPoint.x,this.startPoint.y);c.pointArray[0]=j;j=new a;j.makeLineTo(this.endPoint.x,
this.endPoint.y);c.pointArray[1]=j;c.rect=new d.Rect(this.startPoint,this.startPoint.sizeTo(this.endPoint));e.push(c);c=new b;c.fillcolor="rgba(0, 0, 0, 0.0)";c.color="rgba(220, 220, 220, 0.9)";c.linewidth=1;c.type=h.LWTYPE_DASHEDBOX;c.dash=[4,3];j=new a;j.makeMoveTo(this.startPoint.x,this.startPoint.y);c.pointArray[0]=j;j=new a;j.makeLineTo(this.endPoint.x,this.endPoint.y);c.pointArray[1]=j;c.rect=new d.Rect(this.startPoint,this.startPoint.sizeTo(this.endPoint));e.push(c)}return e};e.prototype.getRulerLinework=
function(){var a="black";this.f&&(a=this.f.getCurrentUser().getColor("PREFERENCES_RULER_DISPLAY_COLOR"));if(this.startPoint&&this.endPoint)return this._cachedRulerLinework&&this._cachedRulerLinework.startPoint.equals(this.startPoint)&&this._cachedRulerLinework.endPoint.equals(this.endPoint)&&this._cachedRulerLinework.color==a?this._cachedRulerLinework.linework:this.generateRulerLinework(this.startPoint,this.endPoint,a)};e.prototype.generateRulerLinework=function(e,c,j){var d=[],m=new a;m.makeMoveTo(e.x,
e.y);var n=new a;n.makeLineTo(c.x,c.y);var f=new b;f.pointArray.push(m);f.pointArray.push(n);f.color="white";f.type=h.LWTYPE_LINE;d.push(f);f=new b;f.pointArray.push(m);f.pointArray.push(n);f.color=j;f.dash=[10,10];f.type=h.LWTYPE_LINE;d.push(f);m=this.getCursor(e);n=this.getCursor(c);d.push(m);d.push(n);this._cachedRulerLinework={startPoint:e.copy(),endPoint:c.copy(),color:j,linework:d};return d};e.prototype.getCursor=function(a){var c=new b;c.type=h.LWTYPE_IMAGE;c.linewidth=1;c.imageRef=f.RulerPoint.DEFAULT;
c.staticsize=!0;c.setRect(new d.Rect(new d.Point(a.x,a.y)));c.imageOffset=new d.Size(f.RulerPoint.OFFSET.width,f.RulerPoint.OFFSET.height);return c};return e});
define("web-viewer/utils/SnapIndicator",["web-viewer/utils/LineworkWrapper","web-viewer/utils/DrawUtils","utils/ShapeUtils"],function(b,a,d){var g=new d.Size(7,7),h=function(d){b.call(this);this.type=a.LWTYPE_IMAGE;this.linewidth=0;this.imageRef="/wcr-static/web-viewer/layout/img/crosshair.png";this.staticsize=!0;this.imageOffset=g;d&&this.setCenter(d)};h.prototype=Object.create(b.prototype);h.prototype.constructor=h;h.prototype.setCenter=function(a){this.setRect(new d.Rect(new d.Point(a.x,a.y)))};
return h});
define("tpl!web-viewer/measure/RulerPopoverTemplate",function(){return function(b){var a,d;d="<table>\r\n";b.showXY&&(d+="\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(a=b.i18n("InfoX"))?"":_.escape(a))+'</strong></td>\r\n\t\t<td align="right">'+(null==(a=b.x)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"</td>\r\n\t</tr>\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(a=b.i18n("InfoY"))?"":_.escape(a))+'</strong></td>\r\n\t\t<td align="right">'+(null==(a=b.y)?"":_.escape(a))+" "+(null==(a=
b.i18n(b.unitsloc))?"":_.escape(a))+"</td>\r\n\t</tr>\r\n");d+="\r\n";b.showDA&&(d+="\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(a=b.i18n("InfoDist"))?"":_.escape(a))+'</strong></td>\r\n\t\t<td align="right">'+(null==(a=b.distance)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"</td>\r\n\t</tr>\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(a=b.i18n("InfoAngle"))?"":_.escape(a))+'</strong></td>\r\n\t\t<td align="right">'+(null==(a=b.angle)?"":_.escape(a))+"&#176;</td>\r\n\t</tr>\r\n");d+=
"\r\n";b.showWH&&(d+="\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(a=b.i18n("InfoWidth"))?"":_.escape(a))+'</strong></td>\r\n\t\t<td align="right">'+(null==(a=b.width)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"</td>\r\n\t</tr>\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(a=b.i18n("InfoHeight"))?"":_.escape(a))+'</strong></td>\r\n\t\t<td align="right">'+(null==(a=b.height)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"</td>\r\n\t</tr>\r\n");d+="\r\n\r\n</table>\r\n";
b.createAnnotation&&(d+='\r\n    <a class="addAnnotation">\r\n        <i class="icon-WCR_Annotation-Arrow12"></i>\r\n        <span>'+(null==(a=b.i18n("AnnFromReadout"))?"":_.escape(a))+"</span>\r\n    </a>\r\n");return d+""}});
define("web-viewer/measure/RulerSnapIndicatorPopoverModel","underscore web-viewer/utils/ViewerUtils web-viewer/viewport/model/ViewportPopoverModel utils/ShapeUtils Template tpl!web-viewer/measure/RulerPopoverTemplate web-viewer/core/CoreConstants".split(" "),function(b,a,d,g,h,f,e){var i=function(c,a,e,m){d.call(this,c,a);var n=$("<div/>");this.fix=3;this.f=c;this.snapIndicator=e;this.t=new h(c.i18n,f);c.i18n.loadBundle("viewer",b.bind(function(){this.t.render()},this));this.t.setContext(n);this.t.render();
this.getFrame=function(){return this.snapIndicator?this.snapIndicator.rect:new g.Rect};this.getContent=function(){return n};this.getRestrictBorder=function(){return 0};this.getClass=function(){return m};this.getContext=b.bind(function(){return this.f.getContext().find(".viewport")},this)};i.prototype=Object.create(d.prototype);i.prototype.constructor=i;i.prototype.setPoint=function(a){this.point=a;this.render()};i.prototype.render=function(){if(this.snapIndicator){var c=this.snapIndicator.rect.center(),
b=null,d=null;this.f.getUnits()===e.SizeUnits.PIXELS&&(d=this.f.getActivePage(),b=d.getParam("resolutionx"),d=d.getParam("resolutiony"));this.t.d.showXY=!0;this.t.d.unitsloc=this.f.getUnitsLocName();c=new g.Point(c.x,c.y);c=this._coordinates.getTransformedPoint(c);this.t.d.x=a.convertFromMmValue(c.x,this.f.getUnits(),this.f.getUnitsFix(),a.parseFloat(b));this.t.d.y=a.convertFromMmValue(c.y,this.f.getUnits(),this.f.getUnitsFix(),a.parseFloat(d));this.t.render()}};return i});
define("web-viewer/measure/MeasureLayerModel","underscore jquery web-viewer/viewport/model/ViewportLayerModel web-viewer/measure/Ruler utils/XMLUtils utils/ShapeUtils web-viewer/measure/MeasureConstants web-viewer/utils/SnapIndicator web-viewer/measure/RulerSnapIndicatorPopoverModel".split(" "),function(b,a,d,g,h,f,e,i,c){a=function(a,b){d.call(this,a,b);this.f=a;this.ruler=new g(a);this._drawType=e.MeasureDrawType.RECTANGLE;this._allowStartPointSnapping=!1;this.snapIndicator=null;this.snapIndicatorModel=
new c(a,"RulerSnapIndicatorPopover",this.snapIndicator)};a.prototype=Object.create(d.prototype);a.prototype.constructor=a;a.prototype.getLinework=function(){var a=b.clone(this.ruler.getLinework());this.snapIndicator&&a.push(this.snapIndicator);return a};a.prototype.setStartPoint=function(a,c){this.snapIndicator=null;this.ruler.startPoint=a;c&&this._allowStartPointSnapping&&this.ruler.snapToClosestAngle(!0);this.repaint();this.modelChanged()};a.prototype.setEndPoint=function(a,c){var b=this.ruler.endPoint?
this.ruler.endPoint.copy():null;this.ruler.endPoint=a;c&&this.ruler.snapToClosestAngle();if(!b||!b.equals(this.ruler.endPoint))this.repaint(),this.ruler.rulerType==e.MeasureType.Ruler&&this.calculate();this.modelChanged()};a.prototype.getStartPoint=function(){return this.ruler.startPoint};a.prototype.getEndPoint=function(){return this.ruler.endPoint};a.prototype.repaint=function(){this.modelChanged()};a.prototype.reset=function(){this.ruler.reset();this.modelChanged()};a.prototype.hidePopover=function(){this.removePopover(this.name)};
a.prototype.calculate=function(){this.ruler.endPoint&&this.ruler.startPoint&&this.ruler.rulerType==e.MeasureType.Ruler&&(this.ruler.getLength(),this.ruler.getAngle(),this.ruler.startPoint.sizeTo(this.ruler.endPoint))};a.prototype.setRulerType=function(a){this.ruler.rulerType=a;this.reset()};a.prototype.setSnapIndicatorPoint=function(a){var c=!1;a?!this._allowStartPointSnapping&&this.ruler.startPoint&&a.equals(this.ruler.startPoint)?this.snapIndicator&&(this.snapIndicator=null,c=!0):this.snapIndicator?
a.equals(this.snapIndicator.rect.center())||(this.snapIndicator.setCenter(a),c=!0):(this.snapIndicator=new i(a),c=!0):this.snapIndicator&&(this.snapIndicator=null,c=!0);c&&(c=a=!1,this.ruler&&this.snapIndicator&&(this.ruler.endPoint&&this.snapIndicator.rect.center().equals(this.ruler.endPoint)&&(a=!0),this.ruler.startPoint&&this.snapIndicator.rect.center().equals(this.ruler.startPoint)&&(c=!0)),(a=null!==this.snapIndicator&&!a&&!c)&&!this.getPopoverModel(this.snapIndicatorModel.getID())?(this.snapIndicatorModel.snapIndicator=
this.snapIndicator,this.addPopoverModel(this.snapIndicatorModel)):!a&&this.getPopoverModel(this.snapIndicatorModel.getID())&&this.removePopoverModel(this.snapIndicatorModel.getID()),this.snapIndicatorModel.render(),this.modelChanged())};a.prototype.clearSnapIndicator=function(){this.setSnapIndicatorPoint(null)};a.prototype.setAllowStartPointSnapping=function(a){this._allowStartPointSnapping=a};a.prototype.setDrawType=function(a){this._drawType=a};a.prototype.modelChanged=function(a){var c=null;!a&&
(this.ruler&&this.ruler.startPoint&&this.ruler.endPoint)&&(a=this.ruler.startPoint.sizeTo(this.ruler.endPoint),c={mode:this._drawType,w:a.width,h:a.height},this._drawType===e.MeasureDrawType.RECTANGLE?(c.x=this.ruler.startPoint.x,c.y=this.ruler.startPoint.y):this._drawType===e.MeasureDrawType.LINE&&(c.d=this.ruler.getLength(),c.a=this.ruler.getAngle()));this.f.emit("selection.changed",c);d.prototype.modelChanged.call(this)};return a});
define("tpl!web-viewer/measure/MeasurePopoverTemplate",function(){return function(b){var a,d="",d=d+"<ul>\r\n\t";_.each(b.channels,function(b){b&&(d+='\r\n\t\t<li><span class="colorBlock" style="background-color: #'+(null==(a=b.getHexRGB())?"":_.escape(a))+';"></span><span>'+(null==(a=b.value)?"":_.escape(a))+"</span></li>\r\n\t")});d+="\r\n</ul>\r\n";b.makeTotalCount&&(d+='\r\n<ul>\r\n\t<li><div style="text-align:right">'+(null==(a=b.totalCount)?"":_.escape(a))+"</div></li>\r\n</ul>\r\n");return d+=
'\r\n<ul>\r\n\t<li class="addAnnotation"><a><i class="icon-WCR_Annotation-Rect12"></i><span>'+(null==(a=b.i18n("AnnFromReadout"))?"":_.escape(a))+"</span></a></li>\r\n</ul>"}});
define("web-viewer/measure/MeasurePopoverModel","web-viewer/utils/ViewerUtils web-viewer/viewport/model/ViewportPopoverModel web-viewer/annotation/Annotation tpl!web-viewer/measure/MeasurePopoverTemplate Template underscore jquery".split(" "),function(b,a,d,g,h,f,e){b=function(b,c,d,l,m,n){a.call(this,b,d);this._content=e("<div/>").addClass("measureInfo");this._header=e("<div />").addClass("measureInfoHeader");this._headerTitle=e("<span />").addClass("headerTitle").html(l);this._headerExtra=e("<span />").addClass("headerExtra");
this._header.append(this._headerTitle).append(this._headerExtra);this._content.append(this._header);this._body=e("<div />");this._content.append(this._body);this.t=new h(b.i18n,g);this.t.setContext(this._body);this.makeTotalCount=n;this._channelsInfo=m;this.channels=[];this.t.bind("click",".addAnnotation",f.bind(function(){var a="<p>";f.each(this.channels,function(c,b){a+=(0<b?"<br />":"")+"<b>"+c.name+"</b>: "+c.value},this);a+="</p>";this.f.emit("module.annotation.createAnnotation",this.area.rect,
a);this.f.emit("toolManager.deactivateTool")},this));this.f.i18n.loadBundle("viewer",f.bind(function(){this.t.render()},this));this.t.d.channels=[];this.t.d.makeTotalCount=n;this.area=c;this.update();this.getFrame=function(){return this.area?this.area.rect:null};this.getContent=function(){return this._content};this.getRestrictBorder=function(){return 0};this.isInteractive=function(){return!0}};b.prototype=Object.create(a.prototype);b.prototype.constructor=b;b.prototype.getChannelsInformation=function(){return this._channelsInfo};
b.prototype.update=function(){this.f.requestModule("graphics",f.bind(function(a){var c=a.getGraphicsModel();this.channels=[];this.t.d.channels=[];a=c.getParsedChannelsInfo(this._channelsInfo);f.each(a.channels,function(a){if(!c.isInDifferenceCompareMode()||!a.isInPreviousAndMatchedWithCurrent())this.channels.push(a),this.t.d.channels.push(a)},this);this.t.d.totalCount=this.makeTotalCount?a.total:"";this.t.render()},this))};b.prototype.setChannelsInfo=function(a){this._channelsInfo=a;this.update()};
b.prototype.setArea=function(a){this.area=a};return b});
define("web-viewer/measure/AbstractMeasureTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/utils/GEOUtils web-viewer/utils/DrawUtils web-viewer/utils/ViewerUtils web-viewer/measure/MeasureLayerModel web-viewer/measure/MeasureConstants web-viewer/measure/MeasurePopoverModel utils/XMLUtils web-viewer/utils/ConversionConstants utils/Cache".split(" "),function(b,a,d,g,h,f,e,i,c,j,l,m){g=function(c,d){a.call(this,c,d);this.f=c;this.popover=null;this.defaultState="default";
this.drawingState="drawing";this.clickState="click";this.model=new e(c,d);this.touchPoint=null;this.snapDistance=this.minimum=16;this.infoFetchedFor=null;this.isPopoverShown=!1;this._infoCache=new m(4,!0);this._infoCache._loadItem=b.bind(function(a){this.f.ajax(a,{success:b.bind(function(c){(c=j.xml2obj(c))&&(c.status&&"-1"==c.status.value)&&this.f.emit("userMessage","warn",c.status.message);this._infoCache._registerItem(a,c)},this),error:b.bind(function(c,b,e){this._infoCache._registerItem(a);this.f.i18n.loadBundle("viewer",
function(){this.f.emit("error.SEVERE",this.f.i18n.t("MeasurementInfoError"),c,b,e)},this)},this)})},this);this.registerState(this.defaultState,function(a){return{enterState:function(){},mousedown:function(c){a.removePopover();a.model.reset();a.didReset();a.touchPoint=a.keepPointWithinWorldBounds(a.getWorldPoint(c),!0);var b=a.getPointToSnapTo(c,a.snapDistance);b||(b=a.keepPointWithinWorldBounds(a.getWorldPoint(c),!1));a.model.setStartPoint(b);a.model.hidePopover();a.changeState(a.drawingState);c.originalEvent.preventDefault()},
mouseup:function(){a.model.ruler.startPoint&&!a.model.ruler.endPoint?a.changeState(a.clickState):(a.changeState(a.defaultState),a.model.ruler.startPoint&&a.model.ruler.endPoint&&a.calculate())},mousemove:function(c){a.checkForSnapPoint(c)},mouseout:function(){},contextmenu:function(a){a.preventDefault();a.stopPropagation();return!1},mouseleave:function(){}}}(this));this.registerState(this.drawingState,b.defaults(function(a){return{enterState:function(){c.emit("layout.disableTextSelection");c.emit("viewport.startInteractive")},
leaveState:function(){setTimeout(function(){c.emit("layout.enableTextSelection")},500);c.emit("viewport.stopInteractive")},mousemove:function(c){var b=a.keepPointWithinWorldBounds(a.getWorldPoint(c),!0).sizeTo(a.touchPoint);(a.model.ruler.endPoint||Math.abs(b.width)>=a.minimum||Math.abs(b.height)>a.minimum)&&a.registerEndPoint(c);a.checkForSnapPoint(c)}}}(this),this.getState(this.defaultState)));this.registerState(this.clickState,b.defaults(function(a){return{enterState:function(){a.changeState(a.defaultState)}}}(this),
this.getState(this.drawingState)));this.getDefaultCursor=function(){return"rulerCursor"};this._override("initialize",function(a,c){this._super(a,c);this.changeState(this.defaultState);this.registerActiveEvents("mousedown mousemove mouseup mouseout mouseleave contextmenu".split(" "))});this._override("activate",function(a){this._super(a);a||(this.f.getModule("viewport").addLayer(this.getIID(),this.model),this.model.ruler.startPoint&&this.model.ruler.endPoint&&this.popover&&(this.model.addPopoverModel(this.popover),
this.f.emit("channels.informationAdded",this.popover.getChannelsInformation())))});this._override("deactivate",function(a){this._super(a);a||(this.model.modelChanged(!0),this.removePopover(),this.f.getModule("viewport").removeLayer(this.getIID()),c.emit("channels.informationNotVisible"))})};g.prototype=new a;g.prototype.constructor=g;g.prototype.calculate=function(){};g.prototype.endPointSet=function(){};g.prototype.didReset=function(){};g.prototype.registerEndPoint=function(a){var c=this.getPointToSnapTo(a,
this.snapDistance);c||(c=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!1));this.model.setEndPoint(c,a.shiftKey);this.endPointSet()};g.prototype.registerStartPoint=function(a){var c=this.getPointToSnapTo(a,this.snapDistance);c||(c=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!1));this.model.setStartPoint(c,a.shiftKey);this.endPointSet()};g.prototype.getPointToSnapTo=function(){return null};g.prototype.checkForSnapPoint=function(a){a=this.getPointToSnapTo(a,this.snapDistance);this.model.setSnapIndicatorPoint(a)};
g.prototype.showInfo=function(){};g.prototype.getInfo=function(a){var c=this._generateParameters(),e=b.clone(c);null!=c&&(b.each(a,function(a,b){c[b]=a}),a=this.f.getActivePage().getInfoURL(c),this._infoCache.get(a,b.bind(function(a){a&&(this.infoFetchedFor=e,this.showInfo(a))},this)))};g.prototype._generateParameters=function(){if(this.model.ruler.startPoint&&this.model.ruler.endPoint){var a=new d.Rect(this.model.ruler.startPoint.copy(),this.model.ruler.startPoint.sizeTo(this.model.ruler.endPoint));
a.normalize();var c=l.FIXED_BARCODE_DPMM,a={rectangle:a,servlet:"",params:{x1:0,y1:0,x2:0,y2:0}};this.f.emit("intercept.fragmentURL",a);a=a.params;a.res=c;return a}return null};g.prototype.canBeInterrupted=function(){return this.getCurrentStateName()!=this.drawingState};g.prototype.canBeUsedOnActivePage=function(){return!0};g.prototype.updateIfNeeded=function(a){(a||this.infoFetchedFor&&this.infoFetchedFor!=this._generateParameters())&&this.calculate();this.popover&&this.isPopoverShown&&(this.popover.update(),
this.model.modelChanged())};g.prototype.showPopover=function(a,c){c||(c=this.model.ruler.getSquareLinework()[0]);this.popover?(this.popover.setArea(c),this.popover.setChannelsInfo(a)):this.popover=this.createPopoverModel(a,c);this.model.addPopoverModel(this.popover);this.isPopoverShown=!0;this.model.modelChanged()};g.prototype.createPopoverModel=function(a,b){return new c(this.f,b,"Channels",this.f.i18n.t("ChannelsTitle"),a,this._needsTotalCount())};g.prototype.removePopover=function(){this.popover&&
this.model.removePopoverModel(this.popover.getID());this.isPopoverShown=!1};g.prototype._needsTotalCount=function(){return!1};g.prototype.getToolState=function(){return{startPoint:this.model.getStartPoint(),endPoint:this.model.getEndPoint(),isActive:this.isActive()}};g.prototype.setToolState=function(a){null!==a.startPoint&&this.model.setStartPoint(a.startPoint);null!==a.endPoint&&(this.model.setEndPoint(a.endPoint),this.endPointSet())};g.prototype.doActivation=function(){this.model.modelChanged();
a.prototype.doActivation.call(this)};return g});
define("web-viewer/measure/RulerPopoverModel","underscore web-viewer/utils/ViewerUtils web-viewer/viewport/model/ViewportPopoverModel utils/ShapeUtils Template tpl!web-viewer/measure/RulerPopoverTemplate web-viewer/core/CoreConstants".split(" "),function(b,a,d,g,h,f,e){var i=function(a,e,i,m,n){d.call(this,a,e);var p=$("<div/>").addClass("rulerMeasurement");this.ruler=i;this.end=m;this.fix=3;this.f=a;i&&(this.point=i.startPoint);this.t=new h(a.i18n,f);a.i18n.loadBundle("viewer",b.bind(function(){this.t.render()},
this));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SIZE",b.bind(this.render,this));this.t.setContext(p);this.t.bind("mousedown",".addAnnotation",function(a,c){c.preventDefault();c.stopPropagation()},this);this.t.bind("click",".addAnnotation",function(a,c){this._emit("createRulerAnnotation");c.preventDefault();c.stopPropagation()},this);this.t.render();this.getFrame=function(){if(this.ruler){if(this.end&&i.endPoint)return new g.Rect(i.endPoint.copy(),null);if(i.startPoint)return new g.Rect(i.startPoint.copy(),
null)}else if(this.point)return new g.Rect(this.point.copy(),null);return null};this.getContent=function(){return p};this.getPreferredPosition=function(){return this.ruler.startPoint&&this.ruler.endPoint?this.ruler.startPoint.x.toFixed(this.fix)==this.ruler.endPoint.x.toFixed(this.fix)?this.ruler.startPoint.y<=this.ruler.endPoint.y?!this.end?"top":"bottom":!this.end?"bottom":"top":this.ruler.startPoint.x<=this.ruler.endPoint.x?this.end?"right":"left":this.end?"left":"right":"bottom"};this.getRestrictBorder=
function(){return 0};this.getContext=b.bind(function(){return this.f.getContext().find(".viewport")},this);this.getClass=function(){return n};this.isInteractive=function(){return!0}};i.prototype=Object.create(d.prototype);i.prototype.constructor=i;i.prototype.isEmpty=function(){return this.end?!(this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_DA")||this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY")||this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_WH")):!(this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY")||
this.point)};i.prototype.render=function(){if(this.ruler){if(!this.ruler.startPoint||!this.ruler.endPoint)return}else if(!this.point)return;b.extend(this.t.d,this.getMeasureData());this.t.render()};i.prototype.getMeasureData=function(){var c={};c.unitsloc=this.f.getUnitsLocName();this.fix=this.f.getUnitsFix();var b=this.f.getUnits(),d,f=null,n=null,i=null;this.ruler?(d=new g.Rect(this.ruler.startPoint.copy(),this.ruler.startPoint.sizeTo(this.ruler.endPoint)),b===e.SizeUnits.PIXELS&&(n=this.f.getActivePage(),
f=a.parseFloat(n.getParam("resolutionx")),n=a.parseFloat(n.getParam("resolutiony")))):d=this.point?new g.Rect(this.point):new g.Rect;if(c.end=this.end){if(!this.ruler.endPoint)return;c.createAnnotation=!0;c.showDA=this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_DA");c.showXY=this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY");c.showWH=this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_WH");var h=new g.Point(d.right(),d.bottom()),h=this._coordinates.getTransformedPoint(h);c.x=a.convertFromMmValue(h.x,
b,this.fix,f);c.y=a.convertFromMmValue(h.y,b,this.fix,n);b===e.SizeUnits.PIXELS&&(i=this.ruler.getAngle()*Math.PI/180,i=Math.sqrt(Math.cos(i)*Math.cos(i)*f*f+Math.sin(i)*Math.sin(i)*n*n));c.distance=a.convertFromMmValue(this.ruler.getLength(),b,this.fix,i);c.angle=this.f.getOption("PREFERENCES_RULER_ANGLE_MODE")?-this.ruler.getAngle().toFixed(2):this.ruler.getAngle().toFixed(2);c.width=a.convertFromMmValue(d.size.width,b,this.fix,f);c.height=a.convertFromMmValue(d.size.height,b,this.fix,n)}else{if(this.ruler&&
!this.ruler.startPoint)return;c.showXY=this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY")||(this.point?!0:!1);c.showDA=!1;c.showWH=!1;d=new g.Point(d.origin.x,d.origin.y);d=this._coordinates.getTransformedPoint(d);c.x=a.convertFromMmValue(d.x,b,this.fix,f);c.y=a.convertFromMmValue(d.y,b,this.fix,n)}return c};return i});
define("tpl!web-viewer/measure/RulerToAnnotationText",function(){return function(b){var a,d;d="";b.showXY&&(d+="\r\n    <b>"+(null==(a=b.i18n("RulerAnnotationFrom"))?"":_.escape(a))+"</b><br/>\r\n        &nbsp;"+(null==(a=b.i18n("InfoX"))?"":_.escape(a))+" "+(null==(a=b.fromX)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"<br/>\r\n        &nbsp;"+(null==(a=b.i18n("InfoY"))?"":_.escape(a))+" "+(null==(a=b.fromY)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+
"<br/>\r\n    <b>"+(null==(a=b.i18n("RulerAnnotationTo"))?"":_.escape(a))+"</b><br/>\r\n        &nbsp;"+(null==(a=b.i18n("InfoX"))?"":_.escape(a))+" "+(null==(a=b.x)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"<br/>\r\n        &nbsp;"+(null==(a=b.i18n("InfoY"))?"":_.escape(a))+" "+(null==(a=b.y)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"<br/><br/>\r\n");d+="\r\n";b.showDA&&(d+="\r\n    <b>"+(null==(a=b.i18n("InfoDist"))?"":_.escape(a))+"</b> "+(null==
(a=b.distance)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"<br/>\r\n    <b>"+(null==(a=b.i18n("InfoAngle"))?"":_.escape(a))+"</b> "+(null==(a=b.angle)?"":_.escape(a))+"&#176;<br/>\r\n");d+="\r\n";b.showWH&&(d+="\r\n    <b>"+(null==(a=b.i18n("InfoWidth"))?"":_.escape(a))+"</b> "+(null==(a=b.width)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"<br/>\r\n    <b>"+(null==(a=b.i18n("InfoHeight"))?"":_.escape(a))+"</b> "+(null==(a=b.height)?"":_.escape(a))+" "+
(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"<br/>\r\n");return d+""}});
define("web-viewer/measure/RulerTool","underscore web-viewer/measure/AbstractMeasureTool web-viewer/measure/MeasureConstants web-viewer/utils/ListenerUtil web-viewer/measure/RulerPopoverModel Template tpl!web-viewer/measure/RulerToAnnotationText web-viewer/annotation/AnnotationConstants utils/ShapeUtils web-viewer/core/CoreConstants".split(" "),function(b,a,d,g,h,f,e,i,c,j){var l=function(c){a.call(this,c,j.TOOLS.MEASURE_RULER);g.mixin(this,c);this.hoverState="hover";this.draggingState="dragging";
this.drawnState="drawn";this.t=new f(c.i18n,e);this.model.setRulerType(d.MeasureType.Ruler);this.model.setAllowStartPointSnapping(!0);this.model.setDrawType(d.MeasureDrawType.LINE);this.startPopover=new h(c,"startRulerPopover",this.model.ruler,!1,"transparent");this.endPopover=new h(c,"endRulerPopover",this.model.ruler,!0,"transparent");this._registerListener("createRulerAnnotation",this._createAnnotation,this,this.endPopover);this.getState(this.defaultState).canBeInterrupted=!0;this.registerState(this.drawnState,
b.defaults({mousemove:b.bind(function(a){this._isHovering(a)&&this.changeState(this.hoverState);this.checkForSnapPoint(a)},this),mouseup:b.bind(function(){this.model.ruler.startPoint&&!this.model.ruler.endPoint?this.changeState(this.clickState):(this.changeState(this.drawnState),this.model.ruler.startPoint&&this.model.ruler.endPoint&&this.calculate())},this),mouseleave:b.bind(function(){this.changeState(this.drawnState)},this),canBeInterrupted:!0},this.getState(this.defaultState)));this.registerState(this.hoverState,
b.defaults({mousedown:b.bind(function(a){if(a=this._getDistanceToPoints(a))this._isMovingStartPoint=a.toStartPoint<a.toEndPoint,this.changeState("dragging")},this),mousemove:b.bind(function(a){this._isHovering(a)||this.changeState(this.drawnState);this.checkForSnapPoint(a)},this),canBeInterrupted:!1,canBeInterruptedForNavigation:!0},this.getState(this.drawnState)));this.registerState(this.draggingState,b.defaults({enterState:b.bind(function(){this.setCursor("cursor-none")},this),mousemove:b.bind(function(a){this.setCursor("cursor-none");
this._isMovingStartPoint?this.registerStartPoint(a):this.registerEndPoint(a);this.checkForSnapPoint(a)},this),mouseup:b.bind(function(){this.changeState(this.hoverState)},this),canBeInterrupted:!1,canBeInterruptedForNavigation:!0},this.getState(this.drawnState)));this.registerState(this.drawingState,b.defaults({enterState:function(){c.emit("layout.disableTextSelection");c.emit("viewport.startInteractive")},leaveState:function(){setTimeout(function(){c.emit("layout.enableTextSelection")},500);c.emit("viewport.stopInteractive")},
mousemove:b.bind(function(a){this.model.ruler.endPoint&&this.setCursor("cursor-none");var c=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!0).sizeTo(this.touchPoint);(this.model.ruler.endPoint||Math.abs(c.width)>=this.minimum||Math.abs(c.height)>this.minimum)&&this.registerEndPoint(a);this.checkForSnapPoint(a)},this),canBeInterrupted:!1,canBeInterruptedForNavigation:!0},this.getState(this.drawnState)));this.registerState(this.clickState,b.defaults({enterState:function(){},mousedown:b.bind(function(a){this.registerEndPoint(a);
this.changeState(this.drawnState)},this)},this.getState(this.drawingState)));this._override("activate",function(a){this._super(a);this.endPointSet()});c.getCurrentUser().on("options.changed.PREFERENCES_RULER_ANGLE_MODE",b.bind(function(){this.startPopover.render();this.endPopover.render();this.model.repaint()},this));c.getCurrentUser().on("options.changed.PREFERENCES_RULER_DISPLAY_MODE",b.bind(function(){this.startPopover.isEmpty()?this.model.removePopoverModel(this.startPopover.getID()):(void 0===
this.model.getPopoverModel(this.startPopover.getID())&&this.model.addPopoverModel(this.startPopover),this.startPopover.render());this.endPopover.isEmpty()?this.model.removePopoverModel(this.endPopover.getID()):(void 0===this.model.getPopoverModel(this.endPopover.getID())&&this.model.addPopoverModel(this.endPopover),this.endPopover.render());this.model.repaint()},this));c.getCurrentUser().on("options.changed.PREFERENCES_RULER_DISPLAY_COLOR",b.bind(function(){this.startPopover.render();this.endPopover.render();
this.model.repaint()},this))};l.prototype=Object.create(a.prototype);l.prototype.constructor=l;l.prototype.endPointSet=b.throttle(function(){this.model.ruler.startPoint&&(!this.model.getPopoverModel(this.startPopover.getID())&&!this.startPopover.isEmpty())&&this.model.addPopoverModel(this.startPopover);this.model.ruler.endPoint&&(!this.model.getPopoverModel(this.endPopover.getID())&&!this.endPopover.isEmpty())&&this.model.addPopoverModel(this.endPopover);this.startPopover.render();this.endPopover.render()},
100);l.prototype.didReset=function(){this.model.removePopoverModel(this.startPopover.getID());this.model.removePopoverModel(this.endPopover.getID())};l.prototype.removePopover=function(){this.didReset()};l.prototype.getPointToSnapTo=function(a,c){if(!this.f.getActivePage().hasCad()&&!this.f.getActivePage().hasLinkedPage())return null;var b=this._widget.requestView(a);if(b){var e=this.getScenePoint(a);(b=b.getClosestLineworkPointFromPoint(e,c))&&(b=this.sceneToWorld(b));return b}return null};l.prototype._isHovering=
function(a){if((a=this._getDistanceToPoints(a))&&(a.toStartPoint<d.RulerPoint.CLOSETODISTANCE||a.toEndPoint<d.RulerPoint.CLOSETODISTANCE))return this.setCursor("cursor-moveObject"),!0;this.setCursor(this.getDefaultCursor());return!1};l.prototype._getDistanceToPoints=function(a){var a=this.getScenePoint(a),c=this.model.ruler.startPoint,b=this.model.ruler.endPoint;if(c&&b)return c=this._widget.getWorld().getScenePointFromWorld(c),b=this._widget.getWorld().getScenePointFromWorld(b),c=a.sizeTo(c),c=Math.sqrt(Math.abs(c.width*
c.width+c.height*c.height)),a=a.sizeTo(b),a=Math.sqrt(Math.abs(a.width*a.width+a.height*a.height)),{toStartPoint:c,toEndPoint:a}};l.prototype._createAnnotation=function(){var a=this.startPopover.getMeasureData();this.t.d.fromX=a.x;this.t.d.fromY=a.y;b.extend(this.t.d,this.endPopover.getMeasureData());var a=this.t.getRenderedHtml(),e=new c.Rect(this.model.ruler.startPoint,this.model.ruler.startPoint.sizeTo(this.model.ruler.endPoint));this.f.emit("module.annotation.createAnnotation",e,a,i.AnnotationType.ANNOT_ARROW);
this.f.emit("toolManager.deactivateTool")};l.prototype.canBeInterrupted=function(a){return this.getCurrentState().canBeInterrupted||this.getCurrentState().canBeInterruptedForNavigation&&a&&(a.getIID()===j.TOOLS.PAN||a.getIID()===j.TOOLS.NAVIGATIONPAN||a.getIID()===j.TOOLS.TOUCH||a.getIID()===j.TOOLS.ZOOM)};return l});
define("web-viewer/measure/BarcodeMeasureTool",["underscore","web-viewer/measure/AbstractMeasureTool","web-viewer/measure/MeasureConstants","web-viewer/utils/ViewerUtils","web-viewer/core/CoreConstants"],function(b,a,d,g,h){var f=function(b,f){a.call(this,b,h.TOOLS.MEASURE_BARCODE);this.f=b;this.measureModule=f;this.model.setRulerType(d.MeasureType.Barcode)};f.prototype=Object.create(a.prototype);f.prototype.constructor=f;f.prototype.showInfo=function(a){var d=[];a&&(a.status.info&&(b.isArray(a.status.info.barcodegv)||
(a.status.info.barcodegv=[a.status.info.barcodegv]),this.f.i18n.loadBundle("viewer",b.bind(function(){b.each(a.status.info.barcodegv,b.bind(function(a){var e=a.xml.Barcodes.Barcode;b.isArray(e)||(e=[e]);d[a.color]="";b.each(e,b.bind(function(b,e){0<e&&(d[a.color]+=" | ");d[a.color]+=b.attributes.Type+": "+b.Decoded;b.Decoded_reverse_dir&&(d[a.color]+=" (--\>) "+b.Decoded_reverse_dir+" (<--)");void 0!==b.Magnification&&(100!==parseInt(b.Magnification,10)&&999!==parseInt(b.Magnification,10))&&(d[a.color]+=
" "+b.Magnification+"%");var f=g.parseFloat(b.BWR);999>f&&0!==f&&(d[a.color]+=" ["+f+" "+this.f.i18n.t("Unitmm")+"] ")},this))},this))},this))),this.f.emit("channels.informationAdded",d));this.showPopover(d)};f.prototype.removePopover=function(){this.popover&&this.model.removePopoverModel(this.popover.getID())};f.prototype.calculate=function(){this.getInfo({opmask:6})};f.prototype.canBeUsedOnActivePage=function(){var a=this.f.getActivePage();return a&&a.hasGraphics()};return f});
define("web-viewer/measure/BrailleMeasureTool",["underscore","web-viewer/measure/AbstractMeasureTool","web-viewer/measure/MeasureConstants","web-viewer/utils/ViewerUtils","web-viewer/core/CoreConstants"],function(b,a,d,g,h){g=function(f,e){a.call(this,f,h.TOOLS.MEASURE_BRAILLE);this.model.setRulerType(d.MeasureType.Braille);this.language=b.invert(d.BrailleLanguage)[f.getOption("PREFERENCES_BRAILLE_LANGUAGE")];this.f=f;this.measureModule=e;f.getCurrentUser().on("options.changed.PREFERENCES_BRAILLE_LANGUAGE",
b.bind(function(a,c){this.language=b.invert(d.BrailleLanguage)[c];this.removePopover();this.calculate()},this))};g.prototype=Object.create(a.prototype);g.prototype.constructor=g;g.prototype.showInfo=function(a){var e=[];a&&(a.status.info&&(a=a.status.info.braille,a instanceof Array||(a=[a]),b.each(a,function(a){var c=a.xml.Regions.Braille;c instanceof Array||(c=[c]);b.each(c,function(d,f){var h="";1<c.length&&(h=f+1+",");void 0===e[a.color]&&(e[a.color]="");d.Line instanceof Array?b.each(d.Line,function(c,
b){1<=b&&(e[a.color]+=" ");e[a.color]+="["+h+(b+1)+"] "+c}):e[a.color]=1<c.length?e[a.color]+("["+h+"1] "+d.Line+" "):e[a.color]+d.Line},this)},this)),this.f.emit("channels.informationAdded",e));this.showPopover(e)};g.prototype.calculate=function(){var a=this.language;if(void 0===a||a===d.LanguageAutomatic)a=d.LanguageLocales[this.f.getCurrentUser().getLocale()],void 0===a&&(a=d.LanguageDefault);this.getInfo({opmask:5,brlang:a})};g.prototype.canBeUsedOnActivePage=function(){var a=this.f.getActivePage();
return a&&a.hasGraphics()};return g});
define("web-viewer/measure/EyeDropperUnitSelector",["web-viewer/layout/component/DropdownMiniButton","web-viewer/core/CoreConstants","underscore"],function(b,a,d){var g=function(h){this.f=h;this._optionButton=new b(this.f,"eyeDropperUnitSettings","icon-WCR_Settings-submenu");this._optionButton.setTooltip("viewer","UnitSettings");this.f.i18n.loadBundle("viewer",function(){this._optionButton.addOption({name:"eyeDropperUnitPixels",content:this.f.i18n.t(a.EyeDropperUnitsLocNames[a.EyeDropperUnits.PIXELS]),onchange:d.bind(this._toggleEyeDropperUnit,
this,a.EyeDropperUnits.PIXELS),userCannotUncheck:!0});this._optionButton.addOption({name:"eyeDropperUnitSQMM",content:this.f.i18n.t(a.EyeDropperUnitsLocNames[a.EyeDropperUnits.SQMM]),onchange:d.bind(this._toggleEyeDropperUnit,this,a.EyeDropperUnits.SQMM),userCannotUncheck:!0});this._optionButton.addOption({name:"eyeDropperUnitSQCM",content:this.f.i18n.t(a.EyeDropperUnitsLocNames[a.EyeDropperUnits.SQCM]),onchange:d.bind(this._toggleEyeDropperUnit,this,a.EyeDropperUnits.SQCM),userCannotUncheck:!0});
this._optionButton.addOption({name:"eyeDropperUnitSQINCH",content:this.f.i18n.t(a.EyeDropperUnitsLocNames[a.EyeDropperUnits.SQINCH]),onchange:d.bind(this._toggleEyeDropperUnit,this,a.EyeDropperUnits.SQINCH),userCannotUncheck:!0});this._optionButton.addOption({name:"eyeDropperUnitPercent",content:this.f.i18n.t(a.EyeDropperUnitsLocNames[a.EyeDropperUnits.PERCENT]),onchange:d.bind(this._toggleEyeDropperUnit,this,a.EyeDropperUnits.PERCENT),userCannotUncheck:!0});this._updateOptions();this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_EYEDROPPER",
d.bind(this._updateOptions,this))},this)};g.prototype.getButtonElement=function(){return this._optionButton.element};g.prototype._toggleEyeDropperUnit=function(b,d){d&&(this.f.setOption("PREFERENCES_UNIT_EYEDROPPER",b,!0),b!==a.EyeDropperUnits.PERCENT&&this.f.setOption("PREFERENCES_UNIT_SIZE",b,!0))};g.prototype._updateOptions=function(){var b=this.f.getOption("PREFERENCES_UNIT_EYEDROPPER");this._optionButton.toggleOption("eyeDropperUnitPixels",b===a.EyeDropperUnits.PIXELS);this._optionButton.toggleOption("eyeDropperUnitSQMM",
b===a.EyeDropperUnits.SQMM);this._optionButton.toggleOption("eyeDropperUnitSQCM",b===a.EyeDropperUnits.SQCM);this._optionButton.toggleOption("eyeDropperUnitSQINCH",b===a.EyeDropperUnits.SQINCH);this._optionButton.toggleOption("eyeDropperUnitPercent",b===a.EyeDropperUnits.PERCENT)};return g});
define("web-viewer/measure/EyeDropperPopoverModel",["web-viewer/measure/MeasurePopoverModel","web-viewer/measure/EyeDropperUnitSelector","underscore","jquery"],function(b,a){var d=function(a,d,f,e,i,c){b.call(this,a,d,f,e,i,c);this._eyeDropperUnitSelector=null;this.f.getDocumentController().whenActivePageChangedAndParametersAvailable(this._updateEyeDropperUnitSelectorButton,this)};d.prototype=Object.create(b.prototype);d.prototype.constructor=d;d.prototype._updateEyeDropperUnitSelectorButton=function(){this.f.getActivePage().isDigitalFilmPage()?
null===this._eyeDropperUnitSelector?(this._eyeDropperUnitSelector=new a(this.f),this._headerExtra.append(this._eyeDropperUnitSelector.getButtonElement())):this._eyeDropperUnitSelector.getButtonElement().show():null!==this._eyeDropperUnitSelector&&this._eyeDropperUnitSelector.getButtonElement().hide()};return d});
define("web-viewer/measure/EyeDropperMeasureTool","underscore web-viewer/measure/AbstractMeasureTool web-viewer/measure/MeasureConstants web-viewer/measure/EyeDropperPopoverModel utils/ShapeUtils web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(b,a,d,g,h,f,e){var i=function(c){a.call(this,c,e.TOOLS.MEASURE_EYEDROPPER);this.model.setRulerType(d.MeasureType.EyeDropper);this.registerState(this.clickState,b.defaults({enterState:b.bind(function(){var a=this.getWorldResolution();
if(null!==a){var c=d.ClickSize.NORMAL;this.f.getActivePage().isDigitalFilmPage()&&(c=d.ClickSize.DIGITAL_FILM);var b=c/a.x,a=c/a.y;this.model.setStartPoint(new h.Point(this.model.ruler.startPoint.x-b/2,this.model.ruler.startPoint.y-a/2));this.model.setEndPoint(new h.Point(this.model.ruler.startPoint.x+b,this.model.ruler.startPoint.y+a));this.calculate();this.changeState(this.defaultState)}},this)},this.getState(this.drawingState)));this._channels=[];this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_EYEDROPPER",
b.bind(this._onEyeDropperUnitChanged,this));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SIZE",b.bind(function(){var a=this.f.getOption("PREFERENCES_UNIT_SIZE");a!==e.SizeUnits.POINTS&&this.f.setOption("PREFERENCES_UNIT_EYEDROPPER",a,!0)},this))};i.prototype=Object.create(a.prototype);i.prototype.constructor=i;i.prototype.showInfo=function(a){this._channels=[];a&&a.status.info.dotpercentage&&(b.isArray(a.status.info.dotpercentage)||(a.status.info.dotpercentage=[a.status.info.dotpercentage]),
b.each(a.status.info.dotpercentage,function(a){this._channels[a.color]=f.parseFloat(a.dotvalue)},this));this._onEyeDropperUnitChanged(!0)};i.prototype._onEyeDropperUnitChanged=function(a){if(this.popover&&this.isPopoverShown||a)if((a=this.model.ruler)&&a.startPoint&&a.endPoint){var d=a.startPoint.sizeTo(a.endPoint),a=e.EyeDropperUnits.PERCENT;this.f.getActivePage().isDigitalFilmPage()&&(a=this.f.getOption("PREFERENCES_UNIT_EYEDROPPER"));var i=d.width,d=d.height,g=0;switch(a){case e.EyeDropperUnits.SQMM:g=
i*d;break;case e.EyeDropperUnits.SQCM:g=f.parseFloat(f.convertFromMmValue(i,e.SizeUnits.CM))*f.parseFloat(f.convertFromMmValue(d,e.SizeUnits.CM));break;case e.EyeDropperUnits.SQINCH:g=f.parseFloat(f.convertFromMmValue(i,e.SizeUnits.INCH))*f.parseFloat(f.convertFromMmValue(d,e.SizeUnits.INCH));break;case e.EyeDropperUnits.PIXELS:var n=this.getWorldResolution();null!==n&&(g=i*n.x*d*n.y);break;case e.EyeDropperUnits.PERCENT:g=100}var h=[];b.each(this._channels,function(a,c){a&&(h[c]=""+a/100*g)},this);
h.makeTotalCount=!0;h.unit=this.f.i18n.t(e.EyeDropperUnitsShortLocNames[a]);h.unitFix=e.EyeDropperUnitsFixes[a];this.f.emit("channels.informationAdded",h);this.showPopover(h)}};i.prototype.calculate=function(){this.getInfo({opmask:1})};i.prototype.canBeUsedOnActivePage=function(){var a=this.f.getActivePage();return a&&a.hasGraphics()};i.prototype._needsTotalCount=function(){return!0};i.prototype.createPopoverModel=function(a,b){return new g(this.f,b,"Channels",this.f.i18n.t("ChannelsTitle"),a,this._needsTotalCount())};
return i});define("tpl!web-viewer/measure/CaliperPopoverTemplate",function(){return function(b){var a;return b=""+("<table>\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(a=b.endPointLabel)?"":_.escape(a))+": </strong></td>\r\n\t\t<td>"+(null==(a=b.endPointValue)?"":_.escape(a))+"</td>\r\n\t</tr>\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(a=b.i18n("GapSize"))?"":_.escape(a))+": </strong></td>\r\n\t\t<td>"+(null==(a=b.gap)?"":_.escape(a))+"</td>\r\n\t</tr>\r\n</table>")}});
define("web-viewer/measure/CaliperPopoverModel","web-viewer/viewport/model/ViewportPopoverModel tpl!web-viewer/measure/CaliperPopoverTemplate utils/ShapeUtils web-viewer/utils/ViewerUtils Template web-viewer/core/CoreConstants underscore".split(" "),function(b,a,d,g,h,f,e){var i=function(c,f,i){b.call(this,c,i);this.div=$("<div/>").addClass("measureInfo caliperPopover");this.t=new h(c.i18n,a);this.t.setContext(this.div);this.t.d.isMeasuringHeight=!0;this._endPoint=new d.Point;this._gapinMm=this._endPointValueInMm=
null;c.i18n.loadBundle("viewer",e.bind(function(){this.t.render()},this));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SIZE",e.bind(this.recalculateGap,this));this.frame=null;this.getFrame=function(){return this.frame?this.frame:new d.Rect(new d.Point(0,0),new d.Size(1,1))};this.getContent=function(){return this.div};this.getPreferredPosition=function(){return this.t.d.isMeasuringHeight?"bottom":"right"};this.getRestrictBorder=function(){return 0};this.isInteractive=function(){return!0};
this.getContext=function(){return this.f.getContext().find(".viewport")};this.render=e.throttle(e.bind(function(){this.t.render()},this),100);this.getClass=function(){return"transparent"}};i.prototype=Object.create(b.prototype);i.prototype.constructor=i;i.prototype.getChannelsInformation=function(){return this._channelsInfo};i.prototype.setGap=function(a){this._gapinMm=a.getVector().getLength();this.t.d.gap=this._convertToCorrectUnits(this._gapinMm);this.render()};i.prototype.recalculateGap=function(){null!==
this._gapinMm&&null!==this._endPointValueInMm&&(this.t.d.endPointValue=this._convertToCorrectUnits(this._endPointValueInMm),this.t.d.gap=this._convertToCorrectUnits(this._gapinMm),this.render())};i.prototype.setEndPoint=function(a){if(this._endPoint=a)this.t.d.endPointValue=this._convertToCorrectUnits(this.t.d.isMeasuringHeight?this._endPoint.y:this._endPoint.x)};i.prototype._convertToCorrectUnits=function(a){var b=null;this.f.getUnits()===f.SizeUnits.PIXELS&&(b=this.f.getActivePage(),b=this.t.d.isMeasuringHeight?
b.getParam("resolutiony"):b.getParam("resolutionx"));a=g.convertFromMmValue(a,this.f.getUnits(),this.f.getUnitsFix(),g.parseFloat(b));b=this.f.i18n.t(this.f.getUnitsLocName());return a+" "+b};i.prototype.setFrame=function(a){this.frame=a};i.prototype.setMeasuringHeight=function(a){this.t.d.isMeasuringHeight=a;this._endPoint&&(this.t.d.isMeasuringHeight?(this.t.d.endPointLabel="Y",a=this._endPoint.copy(),a=this._coordinates.getTransformedPoint(a),this.t.d.endPointValue=this._convertToCorrectUnits(a.y),
this._endPointValueInMm=a.y):(this.t.d.endPointLabel="X",a=this._endPoint.copy(),a=this._coordinates.getTransformedPoint(a),this.t.d.endPointValue=this._convertToCorrectUnits(a.x),this._endPointValueInMm=a.x));this.render()};return i});
define("web-viewer/measure/CaliperLayerModel","underscore web-viewer/viewport/model/ViewportLayerModel web-viewer/measure/CaliperPopoverModel web-viewer/utils/DrawUtils utils/ShapeUtils web-viewer/utils/LineworkWrapper web-viewer/utils/LineworkPoint web-viewer/utils/ListenerUtil web-viewer/measure/MeasureConstants".split(" "),function(b,a,d,g,h,f,e,i,c){var j=function(b,c,d){a.call(this,b,c);i.mixin(this,b);this._caliperModel=d;this._caliperPopover=null;this._popoverFrame=new h.Rect;this._startPoint=
null;this._registerListener("changed.currentGap",this.modelChanged,this,this._caliperModel);this._registerListener("changed.currentGap.vector",this.modelChanged,this,this._caliperModel)};j.prototype=Object.create(a.prototype);j.prototype.constructor=j;j.prototype.setStartPoint=function(a){this._startPoint=a;this.modelChanged()};j.prototype.getStartPoint=function(){return this._startPoint};j.prototype.getLinework=function(a,b,c){if(this._startPoint){var a=new f,b=new f,d=new f,i=new f,k=this._caliperModel.getCurrentGap().getVector(),
j=k.getLength(),s=k.getAngleInDegrees();if(this._caliperModel.isMeasuringHeight(k)){if(0===s||90===s)j=-j;k=new h.Rect(new h.Point(c.left(),c.top()),new h.Size(c.right()-c.left(),Math.min(this._startPoint.y,this._startPoint.y+j)-c.top()));k.normalize();d.rect=k;k=Math.max(this._startPoint.y,this._startPoint.y+j);k=new h.Rect(new h.Point(c.left(),k),new h.Size(c.right()-c.left(),c.bottom()-k));k.normalize();i.rect=k;k=new e;k.makeMoveTo(c.left(),this._startPoint.y);a.pointArray.push(k);k=new e;k.makeLineTo(c.right(),
this._startPoint.y);a.pointArray.push(k);k=new e;k.makeMoveTo(c.left(),this._startPoint.y+j);b.pointArray.push(k);k=new e;k.makeLineTo(c.right(),this._startPoint.y+j);b.pointArray.push(k);this._popoverFrame.origin.x=c.left();this._popoverFrame.origin.y=this._startPoint.y+j;this._popoverFrame.size.width=c.size.width;this._popoverFrame.size.height=1E-8}else this._caliperModel.isMeasuringWidth(k)&&(180===s&&(j=-j),k=new h.Rect(new h.Point(c.left(),c.top()),new h.Size(Math.min(this._startPoint.x,this._startPoint.x+
j)-c.left(),c.bottom()-c.top())),k.normalize(),d.rect=k,k=Math.max(this._startPoint.x,this._startPoint.x+j),k=new h.Rect(new h.Point(k,c.top()),new h.Size(c.right()-k,c.bottom()-c.top())),k.normalize(),i.rect=k,k=new e,k.makeMoveTo(this._startPoint.x,c.top()),a.pointArray.push(k),k=new e,k.makeLineTo(this._startPoint.x,c.bottom()),a.pointArray.push(k),k=new e,k.makeMoveTo(this._startPoint.x+j,c.top()),b.pointArray.push(k),k=new e,k.makeLineTo(this._startPoint.x+j,c.bottom()),b.pointArray.push(k),
this._popoverFrame.origin.x=this._startPoint.x+j,this._popoverFrame.origin.y=c.top(),this._popoverFrame.size.width=1E-8,this._popoverFrame.size.height=c.size.height);a.dash=[4,3];a.color="rgba(210,210,210,0.9)";a.type=g.LWTYPE_LINE;b.dash=[4,3];b.color="rgba(210,210,210,0.9)";b.type=g.LWTYPE_LINE;d.type=g.LWTYPE_RECT;d.fillcolor="rgba(0, 0, 0, 0.40)";d.color="rgba(0, 0, 0, 1.00)";d.linewidth=1;i.type=g.LWTYPE_RECT;i.fillcolor="rgba(0, 0, 0, 0.40)";i.color="rgba(0, 0, 0, 1.00)";i.linewidth=1;return[d,
i,a,b]}};j.prototype.getEndPoint=function(){if(this._startPoint){var a=this._caliperModel.getCurrentGap().getVector(),b=a.getLength(),c=a.getAngleInDegrees();if(this._caliperModel.isMeasuringHeight(a)){if(0===c||90===c)b=-b;return new h.Point(this._startPoint.x,this._startPoint.y+b)}if(this._caliperModel.isMeasuringWidth(a))return 180===c&&(b=-b),new h.Point(this._startPoint.x+b,this._startPoint.y)}else return null};j.prototype.setPoints=function(a,b,c,d){var e=this.getStartPoint(),f=this.getEndPoint(),
i=this._caliperModel.getCurrentGap().getVector();if(c)d=b.y-f.y,b=b.x-f.x,0!==d?a=new h.Point(e.x,e.y+d):0!==b&&(a=new h.Point(e.x+b,e.y));else{var c=f=0,f=b.x-a.x,g=b.y-a.y,b=Math.abs(f),c=Math.abs(g),j=b>c;d&&(j=this._caliperModel.isMeasuringWidth(i));j?(f=0>f?180:0,c=b):f=0>g?90:-90;i.setAngleInDegrees(f);i.setLength(c)}a.equals(e)||(this._startPoint=a);this._caliperModel.setCurrentGapVector(i);this.modelChanged()};j.prototype.showPopover=function(){this._caliperPopover||(this._caliperPopover=
new d(this.f,null,"CaliperPopover",this),this.modelChanged(),this.addPopoverModel(this._caliperPopover))};j.prototype.hidePopover=function(){this._caliperPopover&&(this.removePopoverModel(this._caliperPopover.getID()),this.removePopover(this._caliperPopover.getID()),this._caliperPopover=null)};j.prototype.modelChanged=function(d){var e=null;if(!b.isBoolean(d)||b.isBoolean(d)&&!d)this._caliperPopover&&(this._caliperPopover.setGap(this._caliperModel.getCurrentGap()),this._caliperPopover.setEndPoint(this.getEndPoint()),
this._caliperPopover.setMeasuringHeight(this._caliperModel.isMeasuringHeight(this._caliperModel.getCurrentGap().getVector())),this._caliperPopover.setFrame(this._popoverFrame)),this._startPoint&&(this._caliperModel.getCurrentGap()&&0!==this._caliperModel.getCurrentGap().getVector().getLength())&&(e=this._caliperModel.isMeasuringHeight(this._caliperModel.getCurrentGap().getVector())?{mode:c.MeasureDrawType.HEIGHT,y:this._startPoint.y,h:this._caliperModel.getCurrentGap().getVector().getLength()}:{mode:c.MeasureDrawType.WIDTH,
x:this._startPoint.x,w:this._caliperModel.getCurrentGap().getVector().getLength()});this.f.emit("selection.changed",e);a.prototype.modelChanged.call(this)};return j});
define("web-viewer/measure/CaliperTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/measure/CaliperLayerModel web-viewer/measure/MeasureConstants web-viewer/core/CoreConstants".split(" "),function(b,a,d,g,h,f){d=function(d,i){a.call(this,d,f.TOOLS.MEASURE_CALIPER);this.CLOSETODISTANCE=16;this._caliperModel=i;this._caliperLayerModel=new g(d,this.getIID(),i);this.registerState("default",{enterState:b.bind(function(){this._caliperLayerModel.hidePopover();this._caliperLayerModel.setStartPoint(null);
this._caliperModel.resetFreeformVector()},this),mousedown:b.bind(function(a){var b=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!1);this._caliperLayerModel.setStartPoint(b);this._caliperLayerModel.getEndPoint()||this._moveEndLine(a);this.changeState("dragging")},this),mouseup:function(){},mousemove:function(){},mouseout:function(){},mouseleave:function(){},contextmenu:b.bind(function(a){a.preventDefault();a.stopPropagation()},this),canBeInterrupted:!0});this.registerState("dragging",b.defaults({enterState:b.bind(function(){this._caliperLayerModel.showPopover();
this.f.emit("viewport.startInteractive")},this),leaveState:b.bind(function(){this.f.emit("viewport.stopInteractive")},this),mousedown:function(){},mouseup:b.bind(function(){var a=this._caliperModel.getCurrentGap(),b=a.getStyle();(b===h.CaliperStyle.Fixed||b===h.CaliperStyle.Preset||0<a.getVector().getLength())&&this.changeState("drawn")},this),mousemove:b.bind(function(a){var b=this._caliperModel.getCurrentGap().getStyle();b===h.CaliperStyle.Fixed||b===h.CaliperStyle.Preset?this._moveStartLine(a):
this._moveEndLine(a)},this),canBeInterrupted:!1},this.getState("default")));this.registerState("drawn",b.defaults({enterState:function(){},mousemove:b.bind(function(a){this._isHovering(a)&&this.changeState("hover")},this),canBeInterrupted:!0},this.getState("default")));this.registerState("hover",b.defaults({enterState:function(){},mousedown:b.bind(function(a){var a=this.getWorldPoint(a),b=this._caliperLayerModel.getStartPoint(),d=this._caliperLayerModel.getEndPoint();this._isCloseToLine(b,a)?this.changeState("movingStartLine"):
this._isCloseToLine(d,a)&&this.changeState("movingEndLine")},this),mousemove:b.bind(function(a){this._isHovering(a)||this.changeState("drawn")},this),mouseleave:b.bind(function(){this.changeState("drawn")},this),canBeInterrupted:!0},this.getState("default")));this.registerState("movingEndLine",b.defaults({enterState:b.bind(function(){this.f.emit("viewport.startInteractive")},this),leaveState:b.bind(function(){this.f.emit("viewport.stopInteractive")},this),mouseleave:b.bind(function(){this.changeState("drawn")},
this),mouseup:b.bind(function(){this.changeState("drawn")},this),mousemove:b.bind(function(a){this._moveEndLine(a,!0)},this),canBeInterrupted:!1},this.getState("default")));this.registerState("movingStartLine",b.defaults({enterState:b.bind(function(){this.f.emit("viewport.startInteractive")},this),leaveState:b.bind(function(){this.f.emit("viewport.stopInteractive")},this),mouseleave:b.bind(function(){this.changeState("drawn")},this),mouseup:b.bind(function(){this.changeState("drawn")},this),mousemove:b.bind(function(a){this._moveStartLine(a)},
this),canBeInterrupted:!1},this.getState("default")));this.registerActiveEvents(["mousedown","mousemove","mouseup","mouseleave","contextmenu"]);this.activeKeyEvents.push(["esc",b.bind(function(a){this.changeState("default");a.preventDefault();a.stopPropagation()},this),"keyup"]);this._override("initialize",function(a,b){this._super(a,b);this.changeState("default")});this._override("activate",function(a){this._super(a);a||this.f.getModule("viewport").addLayer(this.getIID(),this._caliperLayerModel)});
this._override("deactivate",function(a){this._super(a);a||(this._caliperLayerModel.modelChanged(!0),this.f.getModule("viewport").removeLayer(this.getIID()));(!a||b.contains(["movingStartLine","movingEndLine","dragging"],this.getCurrentStateName()))&&this.changeState("default")})};d.prototype=Object.create(a.prototype);d.prototype.constructor=d;d.prototype._moveEndLine=function(a,b){var c=this._caliperModel.getCurrentGap().getStyle(),d=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!1),f=this._caliperLayerModel.getStartPoint();
c===h.CaliperStyle.Freeform?this._caliperLayerModel.setPoints(f,d,!1,b):(c===h.CaliperStyle.Fixed||c===h.CaliperStyle.Preset)&&this._caliperLayerModel.setPoints(f,d,!0,b)};d.prototype._moveStartLine=function(a){var b=this._caliperModel.getCurrentGap().getStyle(),a=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!1);b===h.CaliperStyle.Freeform?(b=this._caliperLayerModel.getEndPoint(),this._caliperLayerModel.setPoints(a,b,!1,!0)):(b===h.CaliperStyle.Fixed||b===h.CaliperStyle.Preset)&&this._caliperLayerModel.setStartPoint(a)};
d.prototype._isHovering=function(a){var a=this.getWorldPoint(a),b=this._caliperLayerModel.getStartPoint(),c=this._caliperLayerModel.getEndPoint();if(this._isCloseToLine(b,a)||this._isCloseToLine(c,a))return a=this._widget.getWorld().getRotation(),this._caliperModel.isMeasuringHeight(this._caliperModel.getCurrentGap().getVector())?90===a%180?this.setCursor("cursor-resizeE"):this.setCursor("cursor-resizeN"):this._caliperModel.isMeasuringWidth(this._caliperModel.getCurrentGap().getVector())&&(90===a%
180?this.setCursor("cursor-resizeN"):this.setCursor("cursor-resizeE")),!0;this.setCursor(this.getDefaultCursor());return!1};d.prototype._isCloseToLine=function(a,b){var c=this._widget.getWorld().getZoom();return Math.abs(this._getDistanceToLine(a,b))<this.CLOSETODISTANCE/c};d.prototype._getDistanceToLine=function(a,b){var c=this._caliperModel.getCurrentGap().getVector();if(this._caliperModel.isMeasuringHeight(c))return a.y-b.y;if(this._caliperModel.isMeasuringWidth(c))return a.x-b.x};d.prototype.canBeInterrupted=
function(){return this.getCurrentState().canBeInterrupted};d.prototype.getCaliperModel=function(){return this._caliperModel};d.prototype.canBeUsedOnActivePage=function(){return!0};d.prototype.updateIfNeeded=function(){};d.prototype.getDefaultCursor=function(){return"rulerCursor"};d.prototype.doActivation=function(){this._caliperLayerModel.modelChanged(!1);a.prototype.doActivation.call(this)};d.prototype.getToolState=function(){var a=this._caliperModel.getCurrentGap();return{caliperStyle:a.getStyle(),
caliperGapVector:a.getVector(),startPoint:this._caliperLayerModel.getStartPoint(),isActive:this.isActive()}};d.prototype.setToolState=function(a){if(a.isActive){this.f.emit("toolManager.activateTool",this);this.f.emit("toolManager.interruptTools",!0);var d=a.caliperStyle,c=a.caliperGapVector;if(void 0!==d&&void 0!==c&&void 0!==a.startPoint){var f=b.bind(function(a,b){this._caliperModel.setCurrentGapById(a);this._caliperModel.setCurrentGapVector(b)},this);if(d===h.CaliperStyle.Freeform){var g=this._caliperModel.getFreeformGap();
f(g.getId(),c)}else g=this._caliperModel.getFixedGap(),f(g.getId(),c),d===h.CaliperStyle.Preset&&(d=this._caliperModel.getSimilarPreset(this._caliperModel.getCurrentGap()),void 0!==d&&this._caliperModel.setCurrentGapById(d.getId()));this._caliperLayerModel.setStartPoint(a.startPoint);this._caliperLayerModel.showPopover()}}};return d});
define("web-viewer/measure/CaliperGap",["utils/ShapeUtils","underscore"],function(){var b=function(a,b,g){this._id=a;this._style=b;this._vector=g};b.prototype.getId=function(){return this._id};b.prototype.getStyle=function(){return this._style};b.prototype.getVector=function(){return this._vector.copy()};b.prototype.setVector=function(a){this._vector=a};b.prototype.isSimilarTo=function(a){return this._vector.equals(a.getVector())};return b});
define("web-viewer/measure/CaliperModel",["web-viewer/core/AbstractModel","web-viewer/measure/CaliperGap","web-viewer/measure/MeasureConstants","utils/ShapeUtils","underscore"],function(b,a,d,g,h){var f=function(e,f){b.call(this,e,f);this._nextId=0;this._freeformVector=new g.Vector(0,0,-Math.PI/2);this._freeform=new a(this._getNextId(),d.CaliperStyle.Freeform,this._freeformVector);var c=new g.Vector(0,0.8);this._fixed=new a(this._getNextId(),d.CaliperStyle.Fixed,c);this._presetGaps=[];this._readPresets();
this._currentGap=null};f.prototype=Object.create(b.prototype);f.prototype.constructor=f;f.prototype.resetFreeformVector=function(){var a=this.getCurrentGap();a&&a.getStyle()===d.CaliperStyle.Freeform&&this.setCurrentGapVector(this._freeformVector)};f.prototype._getNextId=function(){var a=this._nextId;this._nextId++;return""+a};f.prototype.getFreeformGap=function(){return this._freeform};f.prototype.getFixedGap=function(){return this._fixed};f.prototype.getAllGaps=function(){var a=[this._freeform,
this._fixed],b=h.sortBy(this._presetGaps,function(a){return 1E4*Math.abs(a.getVector().getAngleInDegrees())+a.getVector().getLength()});return h.union(a,b)};f.prototype.getCurrentGap=function(){return this._currentGap};f.prototype.getGapById=function(a){return h.find(this.getAllGaps(),function(b){return b.getId()===a})};f.prototype.setCurrentGapById=function(a){var b=this.getGapById(a);b?(a=this._currentGap,this._currentGap=b,this._fireChange(!1,["currentGap"],a,this._currentGap)):this.f.debug.error("Gap with id "+
a+" not found")};f.prototype.setCurrentGapVector=function(a){var b=this._currentGap.getVector();this._currentGap.setVector(a);this._fireChange(!1,["currentGap","vector"],b,a)};f.prototype.saveCurrentGapAsPreset=function(){var b=new a(this._getNextId(),d.CaliperStyle.Preset,this._currentGap.getVector());this._presetGaps.push(b);this._persistPresets();this._fireChange(!1,["presetGaps","new"],null,b)};f.prototype._readPresets=function(){var b=this.f.getOption("CALIPER_PRESETS");b&&(b=JSON.parse(b),this._presetGaps=
h.map(b,function(b){return new a(this._getNextId(),d.CaliperStyle.Preset,new g.Vector(b.x,b.y))},this))};f.prototype._persistPresets=function(){var a=h.map(this._presetGaps,function(a){return a.getVector()}),a=JSON.stringify(a);this.f.setOption("CALIPER_PRESETS",a)};f.prototype.deleteCurrentGapFromPresets=function(){this._currentGap.getStyle()!==d.CaliperStyle.Preset&&this.f.debug.error("Cannot delete a non-preset style");this._presetGaps=h.without(this._presetGaps,this._currentGap);this._persistPresets();
this._fireChange(!1,["presetGaps","deleted"],this._currentGap,null)};f.prototype.getSimilarPreset=function(a){return h.find(this._presetGaps,function(b){return b.isSimilarTo(a)})};f.prototype.isMeasuringHeight=function(a){a=a.getAngleInDegrees();return 90===a||-90===a};f.prototype.isMeasuringWidth=function(a){a=a.getAngleInDegrees();return 0===a||180===a};return f});
define("web-viewer/measure/ScreenRulingUnitSelector",["web-viewer/layout/component/DropdownMiniButton","web-viewer/core/CoreConstants","web-viewer/measure/MeasureConstants","underscore"],function(b,a,d,g){var h=function(f){this.f=f;this._optionButton=new b(f,"screenRulingUnitSettings","icon-WCR_Settings-submenu");f.i18n.loadBundle("viewer",function(){function b(a,d,f){f&&this.setUnitAndMode(a,d)}function f(a,b){b&&this.setOrientation(a)}this._optionButton.addOption({name:"unitLpmm",content:this.f.i18n.t("UnitScreenmm"),
onchange:g.bind(b,this,a.ResolutionUnits.PPMM,d.ScreenRulingMode.LINES),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpcm",content:this.f.i18n.t("UnitScreencm"),onchange:g.bind(b,this,a.ResolutionUnits.PPCM,d.ScreenRulingMode.LINES),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpi",content:this.f.i18n.t("UnitScreenInch"),onchange:g.bind(b,this,a.ResolutionUnits.PPI,d.ScreenRulingMode.LINES),userCannotUncheck:!0});this._optionButton.addOption({name:"unitDeg",content:this.f.i18n.t("UnitDegree"),
onchange:g.bind(b,this,0,d.ScreenRulingMode.ANGLE),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpmmDeg",content:this.f.i18n.t("UnitDegreemm"),onchange:g.bind(b,this,a.ResolutionUnits.PPMM,d.ScreenRulingMode.BOTH),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpcmDeg",content:this.f.i18n.t("UnitDegreecm"),onchange:g.bind(b,this,a.ResolutionUnits.PPCM,d.ScreenRulingMode.BOTH),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpiDeg",content:this.f.i18n.t("UnitDegreeInch"),
onchange:g.bind(b,this,a.ResolutionUnits.PPI,d.ScreenRulingMode.BOTH),userCannotUncheck:!0});this._optionButton.addDivider();this._optionButton.addOption({name:"scrOrientationCW",content:this.f.i18n.t("ScreenCW"),onchange:g.bind(f,this,d.ScreenRulingOrientation.CW),userCannotUncheck:!0});this._optionButton.addOption({name:"scrOrientationCCW",content:this.f.i18n.t("ScreenCCW"),onchange:g.bind(f,this,d.ScreenRulingOrientation.CCW),userCannotUncheck:!0});this._updateUnitOptions();this._updateOrientationOptions();
this._optionButton.setTooltip("viewer","UnitSettings");this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SCREENRULING",g.bind(this._updateUnitOptions,this));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SCREEN",g.bind(this._updateUnitOptions,this));this.f.getCurrentUser().on("options.changed.PREFERENCES_SCREEN_ORIENTATION",g.bind(this._updateOrientationOptions,this))},this)};h.prototype.getButtonElement=function(){return this._optionButton.element};h.prototype.setUnitAndMode=
function(a,b){this.f.getOption("PREFERENCES_UNIT_SCREENRULING")!==a&&this.f.setOption("PREFERENCES_UNIT_SCREENRULING",a,!0);this.f.getOption("PREFERENCES_UNIT_SCREEN")!==b&&this.f.setOption("PREFERENCES_UNIT_SCREEN",b,!1)};h.prototype._updateUnitOptions=function(){var b=this.f.getOption("PREFERENCES_UNIT_SCREENRULING"),e=this.f.getOption("PREFERENCES_UNIT_SCREEN");this._optionButton.toggleOption("unitLpmm",b===a.ResolutionUnits.PPMM&&e===d.ScreenRulingMode.LINES);this._optionButton.toggleOption("unitLpcm",
b===a.ResolutionUnits.PPCM&&e===d.ScreenRulingMode.LINES);this._optionButton.toggleOption("unitLpi",b===a.ResolutionUnits.PPI&&e===d.ScreenRulingMode.LINES);this._optionButton.toggleOption("unitDeg",e===d.ScreenRulingMode.ANGLE);this._optionButton.toggleOption("unitLpmmDeg",b===a.ResolutionUnits.PPMM&&e===d.ScreenRulingMode.BOTH);this._optionButton.toggleOption("unitLpcmDeg",b===a.ResolutionUnits.PPCM&&e===d.ScreenRulingMode.BOTH);this._optionButton.toggleOption("unitLpiDeg",b===a.ResolutionUnits.PPI&&
e===d.ScreenRulingMode.BOTH)};h.prototype.setOrientation=function(a){this.f.setOption("PREFERENCES_SCREEN_ORIENTATION",a,!1)};h.prototype._updateOrientationOptions=function(){var a=this.f.getOption("PREFERENCES_SCREEN_ORIENTATION");this._optionButton.toggleOption("scrOrientationCW",a===d.ScreenRulingOrientation.CW);this._optionButton.toggleOption("scrOrientationCCW",a===d.ScreenRulingOrientation.CCW)};return h});
define("web-viewer/measure/ScreenRulingPopoverModel",["web-viewer/measure/MeasurePopoverModel","web-viewer/measure/ScreenRulingUnitSelector","underscore","jquery"],function(b,a){var d=function(a,d,f,e,i,c){b.call(this,a,d,f,e,i,c);this._screenRulingUnitSelector=null;this.f.getDocumentController().whenActivePageChangedAndParametersAvailable(this._updateScreenRulingUnitSelectorButton,this)};d.prototype=Object.create(b.prototype);d.prototype.constructor=d;d.prototype._updateScreenRulingUnitSelectorButton=
function(){this.f.getActivePage().isDigitalFilmPage()?null===this._screenRulingUnitSelector?(this._screenRulingUnitSelector=new a(this.f),this._headerExtra.append(this._screenRulingUnitSelector.getButtonElement())):this._screenRulingUnitSelector.getButtonElement().show():null!==this._screenRulingUnitSelector&&this._screenRulingUnitSelector.getButtonElement().hide()};return d});
define("web-viewer/measure/ScreenRulingMeasureTool","underscore web-viewer/measure/AbstractMeasureTool web-viewer/measure/MeasureConstants web-viewer/measure/ScreenRulingPopoverModel utils/ShapeUtils web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(b,a,d,g,h,f,e){var i=function(c){a.call(this,c,e.TOOLS.MEASURE_SCREEN_RULING);this.model.setRulerType(d.MeasureType.ScreenRuling);this._storedResults=null;this.registerState(this.clickState,b.defaults({enterState:b.bind(function(){var a=
this.getWorldResolution();if(null!==a){var b=d.ClickSize.DIGITAL_FILM/a.x,a=d.ClickSize.DIGITAL_FILM/a.y;this.model.setStartPoint(new h.Point(this.model.ruler.startPoint.x-b/2,this.model.ruler.startPoint.y-a/2));this.model.setEndPoint(new h.Point(this.model.ruler.startPoint.x+b,this.model.ruler.startPoint.y+a));this.calculate();this.changeState(this.defaultState)}},this)},this.getState(this.drawingState)));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SCREENRULING",b.bind(this.showInfo,
this,null));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SCREEN",b.bind(this.showInfo,this,null));this.f.getCurrentUser().on("options.changed.PREFERENCES_SCREEN_ORIENTATION",b.bind(this.showInfo,this,null))};i.prototype=Object.create(a.prototype);i.prototype.constructor=i;i.prototype.canBeUsedOnActivePage=function(){var a=this.f.getActivePage();return a&&a.hasGraphics()&&a.isDigitalFilmPage()};i.prototype._needsTotalCount=function(){return!1};i.prototype.calculate=function(){this.getInfo({scrmode:1})};
i.prototype.showInfo=function(a){var e=[];a?this._storedResults=a:a=this._storedResults;var g=this.f.getOption("PREFERENCES_UNIT_SCREEN"),h=this.f.getOption("PREFERENCES_SCREEN_ORIENTATION");a&&(a.status.info.screen&&(b.isArray(a.status.info.screen)||(a.status.info.screen=[a.status.info.screen]),b.each(a.status.info.screen,b.bind(function(a){var b="";if("1"===a.found){if(g===d.ScreenRulingMode.LINES||g===d.ScreenRulingMode.BOTH)b+=f.convertResolutionFromPpmmValue(f.parseFloat(a.ruling),this.f.getScreenUnits(),
this.f.getScreenUnitsFix()),b+=" "+this.f.i18n.t(this.f.getScreenUnitsLocName());g===d.ScreenRulingMode.BOTH&&(b+=" / ");if(g===d.ScreenRulingMode.ANGLE||g===d.ScreenRulingMode.BOTH){var c=f.parseFloat(a.angle);h===d.ScreenRulingOrientation.CCW&&(c=90-c);b+=c.toFixed(2)+"\u00b0"}}e[a.color]=b},this))),this.f.emit("channels.informationAdded",e));this.showPopover(e)};i.prototype.createPopoverModel=function(a,b){return new g(this.f,b,"Channels",this.f.i18n.t("ChannelsTitle"),a,this._needsTotalCount())};
return i});
define("web-viewer/layout/component/Spinner",["component/tooltip/Tooltip","web-viewer/utils/ViewerUtils","underscore","jquery","jqueryUI"],function(b,a,d,g){var h=function(a,e){this.f=a;this._min=void 0===e.min?0:e.min;this._max=void 0===e.max?100:e.max;this._step=void 0===e.step?1:e.step;this._page=void 0===e.page?10:e.page;this._onSpinnerChanged=e.onSpinnerChanged;this._inputUnit=void 0===e.inputUnit?"%":e.inputUnit;this.element=g("<div />").addClass("spinnerWrapper");this._input=g("<input />").attr("size",(""+
this._max).length).addClass("input");this._input.on("keydown",d.bind(this._valueChanged,this));this._input.on("blur",d.bind(this._valueChanged,this));this._labelUnit=g("<span>"+this._inputUnit+"</span>");this._label=g("<label />").addClass("unit").append(this._input).append(this._labelUnit);this.element.append(this._label);this._input.spinner({min:this._min,max:this._max,step:this._step,page:this._page,spin:d.bind(function(a,b){this._fireSpinnerChanged(b.value)},this)});this.setValue(this._min);void 0!==
e.tooltip&&(this._tooltip=new b(this.f.i18n,this.element,this.f.getContext(),this.f.getContext(),this.f.isMobile(),e.tooltip))};h.prototype._valueChanged=function(b){if((13==b.which||13==b.keyCode)&&"keydown"===b.type)this._input.blur();else if("keydown"!==b.type){var d=a.parseFloat(g(b.target).val());isNaN(d)&&(d=this._min);d=Math.max(Math.min(d,this._max),this._min);g(b.target).val(d);this._fireSpinnerChanged(d)}};h.prototype._fireSpinnerChanged=function(a){this._onSpinnerChanged(a)};h.prototype.setValue=
function(a){this.getValue()!==a&&this._input.spinner("value",a)};h.prototype.getValue=function(){return this._input.spinner("value")};h.prototype.isDisabled=function(){return this._input.spinner("option","disabled")};h.prototype.setDisabled=function(a){this._input.spinner("option","disabled",a)};h.prototype.setTooltip=function(a){void 0===this._tooltip?this._tooltip=new b(this.f.i18n,this.element,this.f.getContext(),this.f.getContext(),this.f.isMobile(),a):this._tooltip.setTooltipContent(a)};h.prototype.setOption=
function(a,b){var d=this["_"+a];void 0!==d&&d!==b&&(this["_"+a]=b,this._input.spinner("option",a,b))};h.prototype.setInputUnit=function(a){this._inputUnit=a;this._labelUnit.empty();this._labelUnit.append(this._inputUnit)};return h});
define("web-viewer/measure/CaliperSubtoolbarComponent","component/toolbar/ToolbarComponent component/toolbar/ButtonGroup web-viewer/layout/component/SubtoolbarButton web-viewer/layout/component/Spinner web-viewer/core/CoreConstants web-viewer/measure/MeasureConstants web-viewer/utils/ViewerUtils web-viewer/utils/ListenerUtil jquery underscore".split(" "),function(b,a,d,g,h,f,e,i,c,j){var l=function(e,f){b.call(this,"CaliperSubtoolbar",e);i.mixin(this,e);this.f=e;this._caliperModel=f;this.f.i18n.loadBundle("viewer",
function(){this._stylesLabel=c("<span />").addClass("styleLabel").text(this.f.i18n.t("GapStyle")+":");this._styles=c("<select />").addClass("styleSelect mousetrap");this._refreshGaps();this._styles.on("change",j.bind(this._styleSelectorChanged,this));this.element.append(c("<div class='caliperStyle'/>").append(this._stylesLabel).append(this._styles));this._gapLabel=c("<span />").addClass("gapLabel").text(this.f.i18n.t("GapSize")+":");this._gapSpinner=new g(this.f,{min:0,max:9999,step:0.01,page:10,
onSpinnerChanged:j.bind(this._spinnerChanged,this),inputUnit:this.f.i18n.t(this.f.getUnitsLocName())});this.element.append(c("<div class='caliperGap'/>").append(this._gapLabel).append(this._gapSpinner.element.addClass("mousetrap")));this._heightWidthButtonGroup=new a("heightWidthButtonGroup");this._heightWidthButtonGroup.element.addClass("heightWidthButtonGroup");this._heightButton=new d(this.f,"checkHeight","icon-WCR_Height",!0,j.bind(this._heightButtonClicked,this));this._heightButton.element.append(this.f.i18n.t("GapHeight"));
this._heightWidthButtonGroup.addButton(this._heightButton);this._widthButton=new d(this.f,"checkWidth","icon-WCR_Width",!0,j.bind(this._widthButtonClicked,this));this._widthButton.element.append(this.f.i18n.t("GapWidth"));this._heightWidthButtonGroup.addButton(this._widthButton);this.addButtonGroup(this._heightWidthButtonGroup);this._saveButtonGroup=new a("saveButtonGroup");this._saveGapButton=new d(this.f,"SaveGap","icon-WCR_Save",!0,j.bind(this._saveClicked,this));this._saveGapButton.setTooltip("viewer",
"SaveGapTT");this._saveButtonGroup.addButton(this._saveGapButton);this._deleteGapButton=new d(this.f,"DeleteGap","icon-WCR_Actions-Delete12",!0,j.bind(this._deleteClicked,this));this._deleteGapButton.setTooltip("viewer","DeleteGapTT");this._saveButtonGroup.addButton(this._deleteGapButton);this.addButtonGroup(this._saveButtonGroup);this._registerListener("changed.currentGap",this._gapChanged,this,this._caliperModel);this._registerListener("changed.currentGap.vector",this._gapVectorChanged,this,this._caliperModel);
this._registerListener("changed.presetGaps.new",this._refreshGaps,this,this._caliperModel);this._registerListener("changed.presetGaps.deleted",this._deletedPresetGap,this,this._caliperModel);this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SIZE",j.bind(this._unitsUpdated,this));this._caliperModel.setCurrentGapById(this._caliperModel.getFreeformGap().getId())},this)};l.prototype=Object.create(b.prototype);l.prototype.constructor=l;l.prototype._styleSelectorChanged=function(a){var b=this._caliperModel.getCurrentGap(),
c=this._caliperModel.getGapById(a.target.value);(c.getStyle()===f.CaliperStyle.Fixed&&b.getStyle()===f.CaliperStyle.Freeform||c.getStyle()===f.CaliperStyle.Freeform&&b.getStyle()===f.CaliperStyle.Fixed)&&c.setVector(b.getVector());this._caliperModel.setCurrentGapById(a.target.value)};l.prototype._spinnerChanged=function(a){var b=null;this.f.getUnits()===h.SizeUnits.PIXELS&&(b=this._getResolution(this._caliperModel.getCurrentGap().getVector()));a=e.convertToMmValue(a,this.f.getUnits(),this.f.getUnitsFix(h.SizeUnits.MM),
e.parseFloat(b));this._caliperModel.getCurrentGap().getStyle()===f.CaliperStyle.Preset&&(b=this._caliperModel.getCurrentGap(),this._caliperModel.setCurrentGapById(this._caliperModel.getFixedGap().getId()),this._caliperModel.setCurrentGapVector(b.getVector()));b=this._caliperModel.getCurrentGap().getVector();b.setLength(a);this._caliperModel.setCurrentGapVector(b)};l.prototype._heightButtonClicked=function(a){if(this._caliperModel.getCurrentGap().getStyle()===f.CaliperStyle.Preset){var b=this._caliperModel.getCurrentGap();
this._caliperModel.setCurrentGapById(this._caliperModel.getFixedGap().getId());this._caliperModel.setCurrentGapVector(b.getVector())}b=this._caliperModel.getCurrentGap().getVector();b.setAngleInDegrees(-90);this._caliperModel.setCurrentGapVector(b);a.stopPropagation()};l.prototype._widthButtonClicked=function(a){if(this._caliperModel.getCurrentGap().getStyle()===f.CaliperStyle.Preset){var b=this._caliperModel.getCurrentGap();this._caliperModel.setCurrentGapById(this._caliperModel.getFixedGap().getId());
this._caliperModel.setCurrentGapVector(b.getVector())}b=this._caliperModel.getCurrentGap().getVector();b.setAngleInDegrees(0);this._caliperModel.setCurrentGapVector(b);a.stopPropagation()};l.prototype._gapChanged=function(a,b){this._styles.find('option[value="'+b.getId()+'"]').prop("selected",!0);this._gapVectorChanged(null,b.getVector());this._updateButtons()};l.prototype._gapVectorChanged=function(a,b){this._caliperModel.isMeasuringHeight(b)?(this._heightButton.setActive(!0),this._widthButton.setActive(!1)):
this._caliperModel.isMeasuringWidth(b)&&(this._widthButton.setActive(!0),this._heightButton.setActive(!1));var c=null;this.f.getUnits()===h.SizeUnits.PIXELS&&(c=this._getResolution(b));var d=b.getLength(),d=e.convertFromMmValue(d,this.f.getUnits(),this.f.getUnitsFix(),e.parseFloat(c));this._gapSpinner.setValue(d)};l.prototype._refreshGaps=function(a,b){this._styles.empty();j.each(this._caliperModel.getAllGaps(),function(a){this._newGap(a)},this);void 0!==b&&this._caliperModel.setCurrentGapById(b.getId())};
l.prototype._unitsUpdated=function(){this._gapSpinner.setInputUnit(this.f.i18n.t(this.f.getUnitsLocName()));this._gapChanged(this._caliperModel.getCurrentGap(),this._caliperModel.getCurrentGap());this._refreshGaps()};l.prototype._newGap=function(a){a=c("<option />").html(this._toString(a)).val(a.getId());this._styles.append(a)};l.prototype._deletedPresetGap=function(a){this._styles.find('option[value="'+a.getId()+'"]').remove();this._caliperModel.setCurrentGapById(this._caliperModel.getFixedGap().getId());
this._caliperModel.setCurrentGapVector(a.getVector())};l.prototype._saveClicked=function(){var a=this._caliperModel.getSimilarPreset(this._caliperModel.getCurrentGap());a?this._caliperModel.setCurrentGapById(a.getId()):this._caliperModel.saveCurrentGapAsPreset()};l.prototype._deleteClicked=function(){this._caliperModel.deleteCurrentGapFromPresets()};l.prototype._updateButtons=function(){switch(this._caliperModel.getCurrentGap().getStyle()){case f.CaliperStyle.Freeform:this._deleteGapButton.element.addClass("hiddenElement");
this._saveGapButton.element.removeClass("hiddenElement");break;case f.CaliperStyle.Fixed:this._deleteGapButton.element.addClass("hiddenElement");this._saveGapButton.element.removeClass("hiddenElement");break;case f.CaliperStyle.Preset:this._saveGapButton.element.addClass("hiddenElement"),this._deleteGapButton.element.removeClass("hiddenElement")}};l.prototype._toString=function(a){switch(a.getStyle()){case f.CaliperStyle.Freeform:return this.f.i18n.t("GapStyleFreeform");case f.CaliperStyle.Fixed:return this.f.i18n.t("GapStyleFixed");
case f.CaliperStyle.Preset:var b=null;this.f.getUnits()===h.SizeUnits.PIXELS&&(b=this._getResolution(a.getVector()));var b=e.convertFromMmValue(a.getVector().getLength(),this.f.getUnits(),this.f.getUnitsFix(),e.parseFloat(b)),c=this.f.i18n.t(this.f.getUnitsLocName()),d="";this._caliperModel.isMeasuringHeight(a.getVector())?d=this.f.i18n.t("GapHeight"):this._caliperModel.isMeasuringWidth(a.getVector())&&(d=this.f.i18n.t("GapWidth"));return b+" "+c+" ("+d+")"}};l.prototype._getResolution=function(a){var b=
this.f.getActivePage(),c=null;this._caliperModel.isMeasuringHeight(a)?c=b.getParam("resolutiony"):this._caliperModel.isMeasuringWidth(a)&&(c=b.getParam("resolutionx"));return c};return l});
define("web-viewer/measure/MeasureToolbarComponent","component/toolbar/ToolbarComponent component/toolbar/ButtonGroup web-viewer/layout/component/ViewerToolbarButton web-viewer/layout/component/SubtoolbarButton component/button/Button web-viewer/layout/component/ColorPicker web-viewer/layout/LayoutConstants web-viewer/measure/MeasureConstants web-viewer/measure/CaliperSubtoolbarComponent utils/OrderedObject jquery".split(" "),function(b,a,d,g,h,f,e,i,c,j,l){var m=function(c,d,f,g,h,i,j){b.call(this,
e.ToolbarComponent.MEASURE,c);this.f=c;this.rulerTool=d;this.eyedropperTool=f;this.barcodeTool=g;this.brailleTool=h;this.caliperTool=i;this.screenRulingTool=j;this.screenRulingButton=this.caliperButton=this.brailleButton=this.barcodeButton=this.eyeDropperButton=this.rulerButton=null;this.measureGroup=new a("MeasureGroup");this.measureGroup.setTitle(c.i18n,"viewer","MeasurementToolsTitle");this.addButtonGroup(this.measureGroup);this.f.getDocumentController().whenActivePageChangedAndParametersAvailable(_.bind(function(){this.updateTools()},
this))};m.prototype=Object.create(b.prototype);m.prototype.constructor=m;m.toolbarName=e.ToolbarComponent.MEASURE;m.prototype.initializeRulerButton=function(c){if(!this.rulerButton){this.rulerButton=new d(this.f,"RulerButton","icon icon-WCR_Measure-Ruler",!0);this.rulerButton.listenToTool(c,!0);this.rulerButton.setTooltip("viewer","RulerTT");c=new b("RulerSubtoolbar",this.f);this.rulerButton.addSubtoolbarComponent(c);var e=new a("RulerSubGroup");c.addButtonGroup(e);var h=new g(this.f,"DAButton","icon-WCR_Measure-Ruler-DA-cont",
!0,_.partial(function(a){a.setOption("PREFERENCES_RULER_DISPLAY_MODE_DA",a.getOption("PREFERENCES_RULER_DISPLAY_MODE_DA")?0:1);a.setOption("PREFERENCES_RULER_DISPLAY_MODE",1<=a.getOption("PREFERENCES_RULER_DISPLAY_MODE")?0:1)},this.f));h.setIcon("icon-WCR_Measure-Ruler-DA-cont",["icon-WCR_Measure-Ruler-DA-sub icon-red"]);h.setTooltip("viewer","RulerDATT");e.addButton(h);var i=new g(this.f,"XYButton","icon-WCR_Measure-Ruler-XY-cont",!0,_.partial(function(a){a.setOption("PREFERENCES_RULER_DISPLAY_MODE_XY",
a.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY")?0:1);a.setOption("PREFERENCES_RULER_DISPLAY_MODE",2<=a.getOption("PREFERENCES_RULER_DISPLAY_MODE")?1:2)},this.f));i.setIcon("icon-WCR_Measure-Ruler-XY-cont",["icon-WCR_Measure-Ruler-XY-sub icon-red"]);i.setTooltip("viewer","RulerXYTT");e.addButton(i);var j=new g(this.f,"WHButton","icon-WCR_Measure-Ruler-WH-cont",!0,_.partial(function(a){a.setOption("PREFERENCES_RULER_DISPLAY_MODE_WH",a.getOption("PREFERENCES_RULER_DISPLAY_MODE_WH")?0:1);a.setOption("PREFERENCES_RULER_DISPLAY_MODE",
3<=a.getOption("PREFERENCES_RULER_DISPLAY_MODE")?2:3)},this.f));j.setIcon("icon-WCR_Measure-Ruler-WH-cont",["icon-WCR_Measure-Ruler-WH-sub icon-red"]);j.setTooltip("viewer","RulerWHTT");e.addButton(j);var l=_.partial(function(a){h.setActive(1===a.getOption("PREFERENCES_RULER_DISPLAY_MODE_DA"));i.setActive(1===a.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY"));j.setActive(1===a.getOption("PREFERENCES_RULER_DISPLAY_MODE_WH"))},this.f);this.f.getCurrentUser().on("options.changed.PREFERENCES_RULER_DISPLAY_MODE",
function(){l()});l();var m=new f(_.partial(function(a,b){a.getCurrentUser().setColor("PREFERENCES_RULER_DISPLAY_COLOR",b)},this.f));this.f.getCurrentUser().on("options.changed.PREFERENCES_RULER_DISPLAY_COLOR",_.partial(function(a){m.setColor(a.getCurrentUser().getColor("PREFERENCES_RULER_DISPLAY_COLOR"))},this.f));m.setColor(this.f.getCurrentUser().getColor("PREFERENCES_RULER_DISPLAY_COLOR"));e=new g(this.f,"ColorSelector",m.element,!0);e.setTooltip("viewer","RulerDisplayColorChange");var t=new g(this.f,
"ColorReset","icon-WCR_Revert",!0,_.partial(function(a){a.resetOption("PREFERENCES_RULER_DISPLAY_COLOR")},this.f));t.setTooltip("viewer","RulerDisplayColorReset");var q=new g(this.f,"angleButton",this.f.getOption("PREFERENCES_RULER_ANGLE_MODE")?"measureCCW":"measureCW",!0,_.partial(function(a){a.setOption("PREFERENCES_RULER_ANGLE_MODE",a.getOption("PREFERENCES_RULER_ANGLE_MODE")?0:1);a.getOption("PREFERENCES_RULER_ANGLE_MODE")?(this.setTooltip("viewer","RulerAngleToCW"),this.setIcon("icon-WCR_Measure-Ruler-CCW-cont",
["icon-WCR_Measure-Ruler-CCW-sub icon-red"])):(this.setTooltip("viewer","RulerAngleToCCW"),this.setIcon("icon-WCR_Measure-Ruler-CW-cont",["icon-WCR_Measure-Ruler-CW-sub icon-red"]))},this.f));this.f.getOption("PREFERENCES_RULER_ANGLE_MODE")?(q.setTooltip("viewer","RulerAngleToCW"),q.setIcon("icon-WCR_Measure-Ruler-CCW-cont",["icon-WCR_Measure-Ruler-CCW-sub icon-red"])):(q.setTooltip("viewer","RulerAngleToCCW"),q.setIcon("icon-WCR_Measure-Ruler-CW-cont",["icon-WCR_Measure-Ruler-CW-sub icon-red"]));
var r=new a("RulerSubGroupOptions");c.addButtonGroup(r);r.addButton(q);r.addButton(e);r.addButton(t)}};m.prototype.initializeEyeDropperButton=function(a){this.eyeDropperButton||(this.eyeDropperButton=new d(this.f,"EyeDropperButton","icon icon-WCR_Measure-Colorpicker",!1),this.eyeDropperButton.listenToTool(a,!0),this.eyeDropperButton.setTooltip("viewer","ToolPercentageTT"))};m.prototype.initializeBarCodeButton=function(a){this.barcodeButton||(this.barcodeButton=new d(this.f,"BarcodeButton","icon icon-WCR_Measure-Barcode",
!1),this.barcodeButton.listenToTool(a,!0),this.barcodeButton.setTooltip("viewer","ToolBarcodeTT"))};m.prototype.initializeBrailleButton=function(a){if(!this.brailleButton){this.brailleButton=new d(this.f,"BrailleButton","icon icon-WCR_Measure-Braille",!1);this.brailleButton.listenToTool(a,!0);this.brailleButton.setTooltip("viewer","ToolBrailleTT");var c=new j;_.each(i.BrailleLanguage,function(a,b){b!==i.LanguageAutomatic&&c.addItem(this.f.i18n.t(i.LanguageTranslationPrefix+b),a)},this);c.setOrder(_.sortBy(c.getKeys()));
c.addItemAtIndex(this.f.i18n.t(i.LanguageTranslationPrefix+i.LanguageAutomatic),i.BrailleLanguage[i.LanguageAutomatic],0);a=new b("BrailleSubToolbar",this.f);this.brailleButton.addSubtoolbarComponent(a);var e=l("<div/>").addClass("brailleLanguages"),f=l("<span/>").addClass("currentlang").append(c.getKeyByValue(this.f.getOption("PREFERENCES_BRAILLE_LANGUAGE"))),g=l("<ul/>").addClass("languagelist").hide(),m=new h(this.f.i18n,this.f.getContext(),this.f.isMobile(),"language",f,!1,function(){g.toggle()});
_.each(c.getKeys(),function(a){var b=new h(this.f.i18n,this.f.getContext(),this.f.isMobile(),"brailleLang"+c.getItemByKey(a),a,!1,_.partial(function(b){b.setOption("PREFERENCES_BRAILLE_LANGUAGE",c.getItemByKey(a));g.hide()},this.f));g.append(l("<li/>").append(b.element))},this);m.element.append(l("<b/>").addClass("caret"));e.append(m.element);e.append(g);a.element.append(e);this.f.getCurrentUser().on("options.changed.PREFERENCES_BRAILLE_LANGUAGE",function(a,b){f.html(c.getKeyByValue(b))})}};m.prototype.initializeCaliperButton=
function(a){this.caliperButton||(this.caliperButton=new d(this.f,"CaliperButton","icon-WCR_Measure-Caliper2-cont",!1),this.caliperButton.listenToTool(a,!0),this.caliperButton.setIcon("icon-WCR_Measure-Caliper2-cont",["icon-WCR_Measure-Caliper2-sub icon-red"]),this.caliperButton.setTooltip("viewer","CaliperTT"),this.caliperButton.addSubtoolbarComponent(new c(this.f,a.getCaliperModel())))};m.prototype.initializeScreenRulingButton=function(a){this.screenRulingButton||(this.screenRulingButton=new d(this.f,
"ScreenRulingButton","icon icon-WCR_Measure-Screen",!1),this.screenRulingButton.listenToTool(a,!0),this.screenRulingButton.setTooltip("viewer","ToolScreenTT"))};m.prototype.updateTools=function(){this.f.emit("toolManager.activeTool",_.bind(function(a){a&&(a.canBeUsedOnActivePage&&!a.canBeUsedOnActivePage())&&this.f.emit("toolManager.deactivateTool",a)},this));this.measureGroup.clearButtons();this.rulerTool&&this.rulerTool.canBeUsedOnActivePage()&&(this.initializeRulerButton(this.rulerTool),this.measureGroup.addButton(this.rulerButton));
this.eyedropperTool&&this.eyedropperTool.canBeUsedOnActivePage()&&(this.initializeEyeDropperButton(this.eyedropperTool),this.measureGroup.addButton(this.eyeDropperButton));this.screenRulingTool&&this.screenRulingTool.canBeUsedOnActivePage()&&(this.initializeScreenRulingButton(this.screenRulingTool),this.measureGroup.addButton(this.screenRulingButton));this.barcodeTool&&this.barcodeTool.canBeUsedOnActivePage()&&(this.initializeBarCodeButton(this.barcodeTool),this.measureGroup.addButton(this.barcodeButton));
this.brailleTool&&this.brailleTool.canBeUsedOnActivePage()&&(this.initializeBrailleButton(this.brailleTool),this.measureGroup.addButton(this.brailleButton));this.caliperTool&&this.caliperTool.canBeUsedOnActivePage()&&(this.initializeCaliperButton(this.caliperTool),this.measureGroup.addButton(this.caliperButton));this._emit("changed.content")};return m});
define("web-viewer/measure/MeasureModule","underscore web-viewer/core/AbstractModule web-viewer/measure/RulerTool web-viewer/measure/BarcodeMeasureTool web-viewer/measure/BrailleMeasureTool web-viewer/measure/EyeDropperMeasureTool web-viewer/measure/CaliperTool web-viewer/measure/CaliperModel web-viewer/measure/ScreenRulingMeasureTool web-viewer/measure/MeasureToolbarComponent web-viewer/measure/MeasureConstants web-viewer/utils/ListenerUtil utils/XMLUtils jquery".split(" "),function(b,a,d,g,h,f,
e,i,c,j,l,m,n,p){var o=function(k,l){a.call(this,k,l,"measure");m.mixin(this,k);p.when(this._checkBarCodeAndBrailleLicenses()).done(b.bind(function(a,l){this.tools=[];this.rulerTool=new d(k,"ruler");this._publishTool(this.rulerTool);this.tools.push(this.rulerTool);a&&(this.barcodeTool=new g(k,this),this._publishTool(this.barcodeTool),this.tools.push(this.barcodeTool));l&&(this.brailleTool=new h(k,this),this._publishTool(this.brailleTool),this.tools.push(this.brailleTool));this.eyedropperTool=new f(k,
"eyedropper");this._publishTool(this.eyedropperTool);this.tools.push(this.eyedropperTool);this.screenRulingTool=new c(k,"screenruling");this._publishTool(this.screenRulingTool);this.tools.push(this.screenRulingTool);this.caliperModel=new i(k,[this.getPrivateChannelName(),"caliper","model"]);this.caliperTool=new e(k,this.caliperModel);this._publishTool(this.caliperTool);this.tools.push(this.caliperTool);this._publishToolbarComponent(j.toolbarName,b.bind(function(){return this._measureToolbarComponent=
new j(k,this.rulerTool,this.eyedropperTool,this.barcodeTool,this.brailleTool,this.caliperTool,this.screenRulingTool)},this));this._registerListener("module.graphics.model.changed.**",b.debounce(b.partial(this.updateMeasureTools,!1),10),this);this._registerListener("module.compare.referenceOffset.changed",b.partial(this.updateMeasureTools,!0),this)},this))};o.prototype=Object.create(a.prototype);o.prototype.constructor=o;o.prototype.updateMeasureTools=function(a){b.each(this.tools,function(b){b.isActive()&&
b.updateIfNeeded(a)})};o.prototype.getState=function(){var a={rulerState:this.rulerTool.getToolState(),eyedropperState:this.eyedropperTool.getToolState(),caliperState:this.caliperTool.getToolState(),sizeUnitState:this.f.getOption("PREFERENCES_UNIT_SIZE")};this.barcodeTool&&(a.barcodeState=this.barcodeTool.getToolState());this.brailleTool&&(a.brailleState=this.brailleTool.getToolState());return a};o.prototype.setState=function(a){void 0!==a.rulerState&&(a.rulerState.isActive&&this.f.emit("toolManager.activateTool",
this.rulerTool),this.rulerTool.setToolState(a.rulerState),this.f.emit("toolManager.interruptTools",!0));void 0!==a.barcodeState&&this.barcodeTool&&this.barcodeTool.setToolState(a.barcodeState);void 0!==a.brailleState&&this.brailleTool&&this.brailleTool.setToolState(a.brailleState);void 0!==a.eyedropperState&&this.eyedropperTool.setToolState(a.eyedropperState);void 0!==a.caliperState&&this.caliperTool.setToolState(a.caliperState);void 0!==a.sizeUnitState&&this.f.setOption("PREFERENCES_UNIT_SIZE",a.sizeUnitState)};
o.prototype._checkBarCodeAndBrailleLicenses=function(){var a=p.Deferred();p.when(this._getServerInfoFlags()).done(function(b){a.resolve((b&l.ServerInfoFlags.barCode)===l.ServerInfoFlags.barCode||(b&l.ServerInfoFlags.barCodeGV)===l.ServerInfoFlags.barCodeGV,(b&l.ServerInfoFlags.braille)===l.ServerInfoFlags.braille)});return a.promise()};o.prototype._getServerInfoFlags=function(){var a=p.Deferred();void 0!==this._serverFlags?a.resolve(this._serverFlags):this.f.ajax(this.f.getDataAdapter().ViewServer("getserverinfo.jsp"),
{success:b.bind(function(b){if(b&&(b=n.xml2obj(b))&&(b.status&&"0"==b.status.value)&&b.status.server){this._serverFlags=parseInt(b.status.server.flags,10);a.resolve(this._serverFlags);return}this.f.emit("error.WARNING","Problem while fetching server flags");a.resolve(0)},this),error:b.bind(function(b,c,d){this.f.emit("error.WARNING","Problem while fetching server flags",c,d);a.resolve(0)},this)});return a.promise()};return o});